------------------
-- ļ:	cfgDBMgr.lua
--   Ȩ:	
-- :	
--   :	2017-6-17 11:24
--   :	1.0
--   :	
-- Ӧ  :  
-------------------

local tbOpenCfgDB = {
	
}

--cfgDBMgr
cfgDBMgr = class("cfgDBMgr")
cfgDBMgr.__index = cfgDBMgr

function cfgDBMgr:create()
	local instance = cfgDBMgr.new()
	self.instance = instance
	instance.sqlite3 = require("sqlite3")
---	instance.Db = instance.sqlite3.open(g_dbfilePath.."game.db")
	
		--1ݿָ루sqlite3*ǴݿʱõǸ
		--2
		--3볤
	--local result = sqlite3_key( instance.Db, "pwd", 3 );
	--cclog("====sqlite3_key====result==============")
	local db = instance.Db
	return instance
end


function cfgDBMgr:openDb(strName)
	local dbName = "game.db"
	if tbOpenCfgDB.dbName then
		return tbOpenCfgDB.dbName
	end 
	local dbStr = "dbfile/"..strName..".db"
	local strFullFileName = cc.FileUtils:getInstance():fullPathForFilename(dbStr) 
	
	cclog(cc.Application:getInstance():getTargetPlatform() ,"=====strFullFileName===11===",OS_ANDROID)
	if  cc.Application:getInstance():getTargetPlatform()  == OS_ANDROID then
		local writepath= cc.FileUtils:getInstance():getWritablePath()
		local pathR = writepath.."src/dbfile/"..dbName
		strFullFileName = pathR
		
		cclog(strFullFileName,"=====strFullFileName======")
		
		local  isHDbR = cc.FileUtils:getInstance():isFileExist(strFullFileName)

		print(isHdb,isHDbR,"====LoadAssetDB====111==========="..strFullFileName)
	end
	
	tbOpenCfgDB.dbName  = self.instance.sqlite3.open(strFullFileName)
	cclog(string.format("====cfgDBMgr:openDb======= %s %s %s",strName, strFullFileName, tostring(tbOpenCfgDB.dbName)))
	
	return tbOpenCfgDB.dbName
end



function cfgDBMgr:openBatDb()
	cclog( tbOpenCfgDB.BatDb,"===openBatDb=====")
	if tbOpenCfgDB.BatDb then
		return tbOpenCfgDB.BatDb
	end 
	--local dbStr = "dbfile/BatDb.db"
	--local strFullFileName = cc.FileUtils:getInstance():fullPathForFilename(dbStr) 
	local writepath= cc.FileUtils:getInstance():getWritablePath()
	tbOpenCfgDB.BatDb = self.instance.sqlite3.open(writepath.."BatDb.db")
	cclog(string.format("====cfgDBMgr:openDb======= %s  %s",writepath, tostring(tbOpenCfgDB.BatDb)))
	return tbOpenCfgDB.BatDb
end

function cfgDBMgr:exec(szSQL)
	self.Db:exec(szSQL)
end

function cfgDBMgr:closeDB()
	self.Db:close()
end

function cfgDBMgr:showTest()
	local db = self.Db
	--local db = sqlite3.open_memory()
	db:exec[[
	  CREATE TABLE test (id INTEGER PRIMARY KEY, content);
	]]
	db:exec[[
		INSERT INTO test VALUES (NULL, 'Hello World');
	  INSERT INTO test VALUES (NULL, 'Hello Lua');
	  INSERT INTO test VALUES (NULL, 'Hello Sqlite3')
	]]
	for row in db:nrows("SELECT * FROM test") do
		print(row.id, row.content)
	end
	
	--cclog(db:last_insert_rowid())
end

function cfgDBMgr:createLogDb()
	local db = self.Db
	db:exec[[
	  CREATE TABLE IF NOT EXISTS logDB(id INTEGER PRIMARY KEY, uin INTEGER, areaid INTEGER,  time TEXT, value TEXT);
	]]
end

function cfgDBMgr:logToDB(szText)
	local szSQL = nil
    local szText = string.gsub(szText,"'","\"")
	local dateText = os.date("%c")
    local tbServer = g_DataMgr:getSeverInfoCsv(self.nCfgID)
	if(g_MsgMgr and g_MsgMgr.nUin and tbServer.AreaID)then
		szSQL = "INSERT INTO logDB VALUES (NULL,"..g_MsgMgr.nUin..","..tbServer.AreaID..",'"..dateText.."','"..szText.."');"
	else
		szSQL = "INSERT INTO logDB VALUES (NULL, -1, -1,'"..dateText.."','"..szText.."');"
	end
	
	--cclog(szSQL)
	self.Db:exec(szSQL)
end

function cfgDBMgr:getDB()
	return self.Db
end

function cfgDBMgr:closeDB()
	self.Db:close()
end

function dblog(szText)
	g_DbMgr:logToDB(szText)
	
end

g_cfgDBMgr = cfgDBMgr:create()