------------------
-- ļ:	gameMusic.lua

-------------------
local gameMusic = class("gameMusic")
local tbMusicPath =
{
}


local tbMusicMsg =
{
	curMusicName = nil,
	bCanPlayMusic = true,
	bCanPlayEffect = true,
}

function gameMusic:getTbPreloadMusic()
	return tbPreloadMusic
end

function gameMusic:getCurMusicName()
	return tbMusicMsg.curMusicName
end
function gameMusic:setCurMusicName(curMusicName)
	tbMusicMsg.curMusicName = curMusicName
end


function gameMusic:playMusic(cfgID,bloop,bReload)
	local CurMusicName = self:getCurMusicName()
	local bCanPlayMusic = self:getBCanPlayMusic()
	cclog(bCanPlayMusic,"====000====playMusic===============",CurMusicName,musicName,bloop,id,bReload)
	if bCanPlayMusic == true then
		local bloop = bloop or true
		local cfgMsg =  g_cfgMsg:getCfgMsg("music_D",cfgID) 
		if not cfgMsg then
			cclog("gameMusic:playEffect nil",cfgID)
			return
		end
		local name = cfgMsg.value
		local name  = "music/"..name
	
		if CurMusicName ~= name or bReload then
			cclog(cfgMsg,"====000====playMusic===============",name,CurMusicName)
			self:stopMusic()
			if g_Cfg.Platform == kTargetAndroid  then --wind
				
				self.MusicId = cc.AudioEngine:play2d(name, bloop, 0.3)
			else
				cc.SimpleAudioEngine:getInstance():playMusic(name, bloop)
			end 
			self:setCurMusicName(name)
		end 
	else

		self:stopMusic()
	end
end

function gameMusic:playEffect(cfgID,name,bloop)
	local bCanPlayEffect = self:getBCanPlayEffect()
--	cclog(bCanPlayEffect,"====000===playEffect==========",cfgID,name,bloop)
	if bCanPlayEffect == true then
		local cfgID = cfgID or 1
		local bloop =false
		local nType = cfgMsg.nType
		if not name then
			local cfgMsg =  g_cfgMsg:getCfgMsg("music_D",cfgID)
			if not cfgMsg then
				cclog("gameMusic:playEffect nil",cfgID)
				return
			end
			name = cfgMsg.value
		end 
		local namePath  = "music/effc/"..name
		--cclog(cfgID,"====000===playEffect==========",namePath)
		
		if g_Cfg.Platform == kTargetAndroid  then --wind
			cc.AudioEngine:play2d(namePath, bloop, 0.3)
		else
			cc.SimpleAudioEngine:getInstance():playEffect(namePath, bloop)
		end 
	end
end
function gameMusic:setBCanPlayMusic(stauts)
	tbMusicMsg.bCanPlayMusic = stauts
	local name = "bCanPlayMusic"
	cc.UserDefault:getInstance():setBoolForKey(name, stauts)
	if not stauts then
		self:stopMusic()
	end 
	
end

function gameMusic:stopMusic()
	
	if g_Cfg.Platform == kTargetAndroid  then --wind
		if self.MusicId then
			cc.AudioEngine:stop(self.MusicId)
			self.MusicId = nil
		end
	else
		cc.SimpleAudioEngine:getInstance():stopMusic()
	end 
		

end

function gameMusic:getBCanPlayMusic()
	local name = "bCanPlayMusic"
	tbMusicMsg.bCanPlayMusic = cc.UserDefault:getInstance():getBoolForKey(name, false)
	return  tbMusicMsg.bCanPlayMusic
end

function gameMusic:setBCanPlayEffect(stauts)
	tbMusicMsg.bCanPlayEffect = stauts
	local name = "bCanPlayEffect"
	cc.UserDefault:getInstance():setBoolForKey(name, stauts)

end
function gameMusic:getBCanPlayEffect()
	local name = "bCanPlayEffect"
	tbMusicMsg.bCanPlayEffect = cc.UserDefault:getInstance():getBoolForKey(name, true)
	return  tbMusicMsg.bCanPlayEffect
end



function gameMusic:ctor()
end

g_gameMusic =  gameMusic:create()