------------------
-- 文件名:	batTbMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local batTbMsg = class("batTbMsg")


---==============================================
local batMyMsg = {}
batMyMsg.Petmsg = {}
batMyMsg.Rolemsg = {}
batMyMsg.enemymsg = {}
batMyMsg.enemyBaseMsg = {}
batMyMsg.enemyBossBaseMsg = {}
function batTbMsg:getFbPetMsg(index) 
	if not index then
		return batMyMsg.Petmsg
	end 
	return batMyMsg.Petmsg[index]
end 
function batTbMsg:setFbPetMsg(info) 
	 batMyMsg.Petmsg[info.index] = info
end
function batTbMsg:delFbPetMsg(index) 
	 batMyMsg.Petmsg[index] = nil
end

function batTbMsg:getFbRoleMsg() 
	return batMyMsg.Rolemsg
end 
function batTbMsg:setFbRoleMsg(info) 
	 batMyMsg.Rolemsg = info
end

function batTbMsg:getBatInfo(index)  --100表示role 其他表示打pet
	if  index == 100  then
		return self:getFbRoleMsg() 
	elseif  index > 0 and index <= 7   then
		return self:getFbPetMsg(index) 
	elseif  index == 500  then	
		return self:getFbEnemyMsg(index) 
	elseif  index >= 1000  then
		return self:getFbEnemyMsg(index) 
	end 
end
function batTbMsg:setBatInfo(info)  --100表示role 其他表示打pet
	
	if  info.index == 100  then
		return self:setFbRoleMsg(info) 
	elseif  info.index  > 0 and info.index  <= 7   then
		return self:setFbPetMsg(info) 
	elseif  info.index  >= 1000  and info.index  == 500  then
		return self:setFbEnemyMsg(info) 
	end 
end

--==================
function batTbMsg:getFbEnemyMsg(enemyId) 
	if enemyId then
		return batMyMsg.enemymsg[enemyId]
	end 
	return batMyMsg.enemymsg
end 
function batTbMsg:setFbEnemyMsg(info) 
	 batMyMsg.enemymsg[info.index] = info
end
function batTbMsg:cleanFbEnemyMsg() 
	for i,info in pairs(batMyMsg.enemymsg)do
		info.status = -1
		if info.item then
			info.item:setVisible(false)
		end 
	end 
end

EnemyBaseMsgKey = {}
EnemyBaseMsgKey.Dps = 1 
EnemyBaseMsgKey.Def = 2 
EnemyBaseMsgKey.MaxHp = 3 
EnemyBaseMsgKey.BJ = 4 
EnemyBaseMsgKey.JZ = 5 
EnemyBaseMsgKey.sb = 6 
EnemyBaseMsgKey.attckNum = 7 
EnemyBaseMsgKey.speed = 8 
EnemyBaseMsgKey.attValue = 9  ---属性攻击
EnemyBaseMsgKey.skillRation = 10  ---技能概率
EnemyBaseMsgKey.lev = 11  ---等级

EnemyBaseMsgKey.Behurt = 12  ---被攻击伤害
EnemyBaseMsgKey.BehurtBJ = 13  ---被暴击伤害
EnemyBaseMsgKey.BehurtSkill = 14---被技能伤害
EnemyBaseMsgKey.BehurtSkillBJ = 15  ---被技能暴击伤害

EnemyBaseMsgKey.dorpRes = 16  ---金币

EnemyBaseMsgKey.BOSSNameID = 100  ---BOSSNameID
EnemyBaseMsgKey.BOSSZhiye = 101  ---BOSS职业
EnemyBaseMsgKey.BOSSSkill = 102  ---BOSS技能
function batTbMsg:getFbEnemyBaseMsg(key) 
	return batMyMsg.enemyBaseMsg[key]
end 
function batTbMsg:setFbEnemyBaseMsg(key,info) 
	 batMyMsg.enemyBaseMsg[key] = info
end

function batTbMsg:getFbEnemyBossBaseMsg(key) 
	return batMyMsg.enemyBossBaseMsg[key]
end 
function batTbMsg:setFbEnemyBossBaseMsg(key,info) 
	 batMyMsg.enemyBossBaseMsg[key] = info
end

---==============================================
local fbBatMsg = {}
fbBatMsgKey = {}
fbBatMsgKey.killEnemyNum = 1 ---击杀数量
fbBatMsgKey.resMath = 2 ---资源计算
fbBatMsgKey.dpsMath = 3 ---dps计算
fbBatMsgKey.BaokuResMath = 4 ---宝库计算
function batTbMsg:getFbBatMsg(ID) 
	return fbBatMsg[ID]
end 
function batTbMsg:setFbBatMsg(ID,value) 
	fbBatMsg[ID] = value
end 

---===============================
function batTbMsg:getFbRoleDuoshanValue(ID) 
	local duoshan 
	local info = self:getBatInfo(ID)
	duoshan = info.sb
	--计算buf上面的
	return duoshan
end 
function batTbMsg:getFbRoleBaojiValue(ID) 
	local value 
	local info = self:getBatInfo(ID)
	value = info.bj
	--计算buf上面的
	return value
end 
function batTbMsg:getFbRoleJingzhunValue(ID) 
	local value 
	local info = self:getBatInfo(ID)
	value = info.jz
	--计算buf上面的
	return value
end 
function batTbMsg:getFbRoleAttckNumValue(ID) 
	local value 
	local info = self:getBatInfo(ID)
	value = info.attckNum
	--计算buf上面的
	return value
end 

function batTbMsg:getFbRoleDpsWlValue(ID) 
	local value 
	local info = self:getBatInfo(ID)
	value = info.dpsWl
	--计算buf上面的
	return value
end 
function batTbMsg:getFbRoleDpsMfValue(ID) 
	local value 
	local info = self:getBatInfo(ID)
	value = info.dpsMf
	--计算buf上面的
	return value
end 
function batTbMsg:getFbRoleDefWLValue(ID) 
	local value 
	local info = self:getBatInfo(ID)
	value = info.defWL
	--计算buf上面的
	return value
end 
function batTbMsg:getFbRoleDefMfValue(ID) 
	local value 
	local info = self:getBatInfo(ID)
	value = info.defMf
	--计算buf上面的
	return value
end 

function batTbMsg:getFbRoleSpeedValue(ID) 
	local value 
	local info = self:getBatInfo(ID)
	value = info.speed
	--计算buf上面的
	return value
end 


function batTbMsg:ctor()

end

g_batTbMsg =  batTbMsg:create()