------------------
-- 文件名:	batContorlPK.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local batContorlPK = class("batContorlPK")
local TimeSchedu = 0.05
local TimeScheduCount = 0

batStatusTypes = {}
batStatusTypes.Bj = 1
batStatusTypes.sb = 2

gameStatus = {}
gameStatus.stop = -1
gameStatus.batIng = 1


ROLESTATUSS = {}
ROLESTATUSS.death = 3

---======其他操作 ===============================
--特效
function batContorlPK:EffctContorl(index,status)
	--界面操作
	
end
--状态飘字 躲闪暴击等
function batContorlPK:statusContorl(index,status)
	--界面操作
	if status == batStatusTypes.Bj then
		g_batWndContorlPK:createStausPiaozi(index,"暴击",22)
	elseif status == batStatusTypes.sb then
		g_batWndContorlPK:createStausPiaozi(index,"躲闪",5)
	else
		g_batWndContorlPK:createStausPiaozi(index,status)
	end 
end

---回魔
function batContorlPK:addMpContorl(roleID,addValue,noPiaozi)
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	if info.status  == ROLESTATUSS.death or info.status < 0 then
		return
	end 
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	if not  MaxBigInt(info.maxMp, info.mp)then
		return
	end
	info.mp =  addBigInt(info.mp, addValue)
	if not  MaxBigInt(info.maxMp, info.mp)then
		
		info.mp = info.maxMp
	end 
	
	g_batTbMsgPK:setBatInfo(info) 
	B_FbBatPk:setFbMsgPanleRoleMp()
	--界面操作
	if not noPiaozi then
		g_batWndContorlPK:createHurtPiaozi(roleID,addValue,nil,4)
	end 
end
---回血
function batContorlPK:zhiliaoContorl(roleID,hurt,isfuho,noPiaozi)
	if not MaxBigInt(hurt, "0") then
		return
	end 
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	if isfuho  then
		info.status = 0
	end 
	if info.status  == ROLESTATUSS.death or info.status < 0 then
		return
	end 
	info.hp =  addBigInt(info.hp, hurt)
	if not  MaxBigInt(info.maxHp, info.hp)then
		info.hp = info.maxHp
	end 
	g_batTbMsgPK:setBatInfo(info) 
	--界面操作
	if not noPiaozi then
		local hurtCN,hurt =  getBigIntByStr(hurt)
		g_batWndContorlPK:createHurtPiaozi(roleID,hurtCN,nil,3)
	end 
end
---掉血
function batContorlPK:hurtContorl(roleID,hurt,isBaoji,isMp)
	if not MaxBigInt(hurt, "0") then
		return
	end 
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	----cclog(info,"====hurtContorl======",roleID)
	if not MaxBigInt(info.hp, "0") then
		self:deadContorl(roleID)
		return
	end 
	hurt =  floorBigInt(hurt) 
	info.hp =  subBigInt(info.hp, hurt)
	---info.hp - hurt
	g_batTbMsgPK:setBatInfo(info) 

	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	if not MaxBigInt(info.hp, "0") then
		self:deadContorl(roleID)
		
	end 
	--界面操作
	local nType = 1
	if isBaoji then
		nType = 2
	end 
	local hurtCN,hurt =  getBigIntByStr(hurt)
	g_batWndContorlPK:createHurtPiaozi(roleID,hurtCN,nil,nType)
	
end
---死亡
function batContorlPK:deadContorl(roleID)
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	info.status = ROLESTATUSS.death 
	g_batTbMsgPK:setBatInfo(info) 
	--界面操作
	g_batWndContorlPK:deatItem(roleID)
	if roleID == 100 or roleID == 1100 then
		local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
		B_FbBatPk:showMpStatusText(roleID,1)
	elseif roleID < 100 then
		g_batRoleSkillContorlPK:showSkillFactory(openSkillMsg.death,100,roleID)
		g_batPetSkillContorlPK:showSkillFactory(openSkillMsg.death,nil,roleID)
	else
		g_batRoleSkillContorlPK:showSkillFactory(openSkillMsg.death,1100,roleID)
		g_batPetSkillContorlPK:showSkillFactory(openSkillMsg.death,nil,roleID)
	end 
	---g_action:ts_hszz_antion("你获得了胜利",22,nil,nil,nil,nil,callBack)
	g_batRoleSkillContorlPK:isZhongZhuSkillGui(roleID)	
end
---复活
function batContorlPK:FuhuoContorl(roleID,hp)
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	info.status = 0 
	if hp then
	  info.hp = hp 
	end 
	g_batTbMsgPK:setBatInfo(info) 
	--界面操作
	g_batWndContorlPK:deatItemFh(roleID)
	g_action:ts_hszz_antion("复活")
end
---说话
function batContorlPK:talkContorl()
	--界面操作
end
---掉钱
function batContorlPK:dropresContorl()
	--界面操作
end

---======战斗操作 ===============================

--普通攻击操作 --造成伤害
function batContorlPK:ptAttckContorl(attckId,toAttckId,isSkill,dps,isMp)
	--技能或者普通攻击
	local info =  g_batTbMsgPK:getBatInfo(attckId) 
	local toinfo =  g_batTbMsgPK:getBatInfo(toAttckId) 
	if not toinfo then
		return
	end 
	local hurt
	--是否躲闪
	local jingzhun = g_batTbMsgPK:getFbRoleJingzhunValue(attckId) 
	local duoshan = g_batTbMsgPK:getFbRoleDuoshanValue(toAttckId) 
	local isDuoshan = g_batMathPK:mathDuoshan(jingzhun,duoshan,toAttckId) 
	--cclog(attckId,toAttckId,"===22=ptAttckContorl==isDuoshan====",jingzhun,duoshan)
	if  isDuoshan then
		
		self:statusContorl(toAttckId,batStatusTypes.sb)
		return
	end  
	--是否暴击
	local baoji1 = g_batTbMsgPK:getFbRoleBaojiValue(attckId) 
	local toBaoji = g_batTbMsgPK:getFbRoleBaojiValue(toAttckId) 
	local isBaoji = g_batMathPK:mathBaoji(baoji1,toBaoji,toAttckId)
	local hurt 
	if isSkill then
		hurt =  g_batMathPK:mathHurtMF(info,toinfo,dps) 
	else
		hurt =  g_batMathPK:mathHurtWl(info,toinfo,dps) 
	end 
	if isBaoji then
		self:statusContorl(attckId,batStatusTypes.Bj)
		hurt = g_batMathPK:mathHurtBaoji(info,hurt)
	end 
	----cclog("=======ptAttckContorl========",attckId,toAttckId,isSkill,dps,hurt)
	--伤害操作

	self:hurtContorl(toAttckId,hurt,isBaoji,isMp)
	--是否有吸血
	if info.xiHp and info.xiHp > 0 then
		--治疗操作
		local xiHp = info.xiHp
		---local hurt1 = byBigInt(hurt,xiHp)  
		--cclog(hurt1,hurt,"===hurtContorl=====",info.xiHp)
		self:zhiliaoContorl(attckId,xiHp)
		g_batWndContorlPK:showAnimaZhilieo(attckId)
	end 
end

--获取目标1 --我方 ---友军 
function batContorlPK:getAttckObjFriend(attckNum,index)
	---是否已有目标 
	local nType = self:getNtype(index)
	nType = nType %2  + 1
	local count = 0
	local tbattckObj = {}
	local tbObj = g_batMathPK:mathFbBatRoleObj(attckNum,nType)
	for i,Index in pairs(tbObj)do
		tbattckObj[Index] = Index
	end 	
	return tbattckObj
end


--获取目标1 --随机仇恨
function batContorlPK:getAttckObjRan(attckNum,index)
	---是否已有目标 
	local nType = self:getNtype(index)
	local count = 0
	local tbattckObj = {}
	local tbObj =  g_batMathPK:mathFbBatRoleObj(attckNum,nType)
	for i,Index in pairs(tbObj)do
		tbattckObj[#tbattckObj+1] = Index
	end 	
	return tbattckObj
end

--获取目标1 --仇恨最高
function batContorlPK:getAttckObjRan2(attckNum,index)
	---是否已有目标 
	local nType = self:getNtype(index)
	local count = 0
	local tbattckObj = {}
	local tbObj =  g_batMathPK:mathFbBatRoleObj2(attckNum,nType)
	for i,Index in pairs(tbObj)do
		tbattckObj[#tbattckObj+1] = Index
	end 	
	return tbattckObj
end


--是否结束
function batContorlPK:isEnd()
	local tbInfo = g_batTbMsgPK:getBatInfo() 
	local result1 ,result2
	for i,info in pairs(tbInfo)do
		if info.status >= 0 and info.status ~= ROLESTATUSS.death  then
			if i  < 1000  then	
				result1 = true
			else
				result2 = true
			end 
		end 
	end 

	if not result2 then
		return 1
	end 
	if not result1  then
		return 0
	end 

end
---======开始战斗 ===============================
function batContorlPK:getNtype(index)
	if index < 1000 then
		return 1
	else
		return 2
	end 
end 
---
---回合行动器
function batContorlPK:roleItemTimeSchedu(index)
	--是否存活可行动
	--是否存活
	local info = g_batTbMsgPK:getBatInfo(index) 
	--cclog(index,"==roleItemTimeSchedu=====")
	if not info  then
		--cclog("=====roleItemTimeSchedu== not info ====")
		return
	end 
	if info.status and info.status < 0  then
		--cclog("===info.status and info.status < 0  ==")
		return
	end 
	info.count = info.count + 1
	
	if  not info.status  then
		info.status = 0
	end
	---晕眩和冰冻
	local tbBufMsg = {70,71}
	local stausYX = g_batRoleSkillContorlPK:getBufByID(index,tbBufMsg)
	local toBatIndex = {}
	--cclog(index,"=====roleItemTimeSchedu====",info.status,stausYX)
	if  info.status ~= ROLESTATUSS.death  and not stausYX then
		g_batTbMsgPK:setBatInfo(info) 
		
		---攻击
		g_batRoleSkillContorlPK:showSkillFactory(openSkillMsg.attackFront,100)
		g_batPetSkillContorlPK:showSkillFactory(openSkillMsg.attackFront,index)
		--info.count = 0
	
		---是否释放技能
		local isSkill  
		isSkill =  g_batRoleSkillContorlPK:showSkillFactory(openSkillMsg.openSkill,index)
		isSkill =  g_batPetSkillContorlPK:showSkillFactory(openSkillMsg.openSkill,index)
		 
		local tbBufMsg = {79}
		local nTime = g_batRoleSkillContorlPK:getBufByID(index,tbBufMsg)
		-----cclog(isSkill,nTime,"===222===callback=====",index)
		if not isSkill and not nTime then
			
			local toBID 
			local attckObj =  self:getAttckObjRan2(info.attckNum,index)
			--for i,toAttckId in pairs(attckObj)do
				--self:ptAttckContorl(index,toAttckId)
				--toBatIndex[#toBatIndex+1] = toAttckId
			--end 
			--cclog(attckObj,"==attckObj====callback===22==",info.attckNum,index)
			local function callback()
				--cclog("======callback=====")
				for i,toAttckId in pairs(attckObj)do
					self:ptAttckContorl(index,toAttckId)
					g_batWndContorlPK:setItemHpPet(toAttckId,1)
					g_batRoleSkillContorlPK:isZhongZhuSkillRX(index,toAttckId)	
					g_batRoleSkillContorlPK:isZhongZhuSkillRX(toAttckId,index)	
				end 
			end 
			
			---播放攻击动画
			g_batWndContorlPK:showActor(index,attckObj[1],callback)
			-----cclog(attckObj,"=roleItemTimeSchedu===")
		else
			g_batWndContorlPK:setItemMaoPao(roleID,1)
			self:startAllTimeSchedu()
			
		end 
	else	
		g_batWndContorlPK:setItemMaoPao(roleID,1)
		self:startAllTimeSchedu()
		
	end 
	--状态计数
	g_batRoleSkillContorlPK:roleBufTime(index,1)
	
end


---战斗计时器
function batContorlPK:GameItemTimeSchedu()
	--战斗是否结束
	
	local status = self:isEnd()
	if status then
		--cclog("=====GameItemTimeSchedu==11===",status)  
		local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
		local function callBack()
			B_FbBatPk:close()
		end 

		if status == 1  then  --下一波
			self.gameStatus = gameStatus.stop
			g_gameMusic:playEffect(24)
			g_action:ts_hszz_antion("你获得了胜利",22,nil,nil,nil,nil,callBack)
			g_svSendMsgControl:request_daoyuInfo(3,g_playerMsg.dyID,1)
		elseif status == 0  then --失败
			self.gameStatus = gameStatus.stop
			g_action:ts_hszz_antion("战斗失败",1,nil,nil,nil,nil,callBack)
			g_gameMusic:playEffect(23)		
			g_svSendMsgControl:request_daoyuInfo(3,g_playerMsg.dyID,0)
		end 
		return
	end  
end

function batContorlPK:miaoFrameContorl()
	local info = g_batTbMsgPK:getBatInfo(100) 
	local addHpOne = info.addHpOne or 0
	local addMpOne = info.addMpOne or 0
	
	if  info.status == ROLESTATUSS.death then
		return
	end 
	if addHpOne ~= "0"  or addHpOne ~= 0 then
		self:zhiliaoContorl(100,addHpOne,true)
	end 
	
	if addMpOne ~= "0"  or addMpOne ~= 0 then
		self:addMpContorl(100,addMpOne,true)
	end 
end 

---排序速度
function batContorlPK:curActionRole()
	local tbInfo = g_batTbMsgPK:getBatRoleMsg() 
	local curID,curSpeed
	for id,info in pairs(tbInfo)do
		
		if info.count < self.turn and info.status ~= ROLESTATUSS.death and info.status >= 0  then		
			----cclog(curSpeed,id,curID,"======curActionRole=========",info.speed,info.status,info.count)
			if not curSpeed  then
				curID = info.index
				curSpeed = info.speed
			elseif  curSpeed < info.speed  then 
				curID = info.index
				curSpeed = info.speed
			end 
		end 
	end 
	----cclog(curID,"======curActionRole=========")
	return curID
end

---战斗开始，回合启动
function batContorlPK:startAllTimeSchedu()
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	local  n23 =  B_FbBatPk.rootLayout:getChild("n23")  
	
	local function timesCallback()
		--cclog(self.gameStatus,gameStatus.stop,"==startAllTimeSchedu======")
		if self.gameStatus == gameStatus.stop then
			return
		end 
		
		---寻找这次行动的角色
		local curID =  self:curActionRole()
		--cclog(curID,"===elf.gameStatus==startAllTimeSchedu======")
		if not curID then
			self.turn = self.turn + 1
			curID =  self:curActionRole()
			self:setTuanNum()
		end 
		self:roleItemTimeSchedu(curID)
		self:GameItemTimeSchedu()
	end
	local n23 = n23:displayObject()
	g_scheduleTime:scheduleByTimes(n23, 0.2,1,timesCallback)
	--cclog("=====startAllTimeSchedu======")
end 

local boNum = 0


function batContorlPK:setTuanNum()
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
		
	local textReeturn = B_FbBatPk.rootLayout:getChild("textReeturn")
	textReeturn:setText("战斗回合："..self.turn)
	--所有状态重置
	local tbInfo = g_batTbMsgPK:getBatRoleMsg() 
	local curID,curSpeed
	for id,info in pairs(tbInfo)do
		if  info.status ~= ROLESTATUSS.death and info.status >= 0  then
			g_batWndContorlPK:setItemMaoPao(info.index,0)
		end 
	end 
end

---=====================================

function batContorlPK:reloadPetMsg(index,reload)
	local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	
	local petID = batPatMsg[index%10] or 0
	--cclog(index,type(index),"===batPatMsg=====",batPatMsg)
	if petID <= 0 then
		local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
		g_batTbMsgPK:delBatRoleMsg(index) 
		B_FbBatPk:setFbMsgPanleCW(index)
		return
	end 
	
	local info = g_batTbMsg:getFbPetMsg(index) 
	if  not info then
		info = {}
		local tbMsg = g_petMsg:getpetTbMsg(petID)
		deepcopy(info, tbMsg) 
	end 

	local petAttInfo = g_petMsg:getpetTbMsg(petID)
	local zhizi = g_petMsg:getPetZZ(petID)  
	local value = g_mathConTrol:mathPetBaseAtt(petAttInfo.Level,3,zhizi,petID) 
	value = floorBigInt(value) 
	info.maxHp = value
	 -----cclog(value,index,"=====value====",petAttInfo.Level,3,zhizi,petID)
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	if not info.hp or reload  then	
		--info.id = index
		info.hp  = value
		info.index = index
		info.bj = g_mathConTrol:mathPetAttCe(petAttInfo,petAttCeMsg.baoji)
		info.jz = g_mathConTrol:mathPetAttCe(petAttInfo,petAttCeMsg.jinzun)
		info.sb = g_mathConTrol:mathPetAttCe(petAttInfo,petAttCeMsg.duoshan)
		info.attckNum = g_mathConTrol:mathPetAttCe(petAttInfo,petAttCeMsg.attckNum)
		if self.chongSkill[2] > 1 and info.attckNum > self.chongSkill[2]  then
			info.attckNum = math.floor(self.chongSkill[2])
		end 
		info.dpsWl  = g_mathConTrol:mathPetBaseAtt(petAttInfo.Level,1,zhizi,petID,true) 
		info.dpsMf  = info.dpsWl
		info.defWL  = g_mathConTrol:mathPetBaseAtt(petAttInfo.Level,2,zhizi,petID,true) 
		info.defMf  = info.defWL
		--local speed = g_batMathPK:mathSpeed(,1 )
		info.speed  = g_mathConTrol:mathPetBaseAtt(petAttInfo.Level,4,zhizi,petID)
		info.speed = tonumber(info.speed)
		info.chouhen = g_mathConTrol:mathPetBaseAtt(petAttInfo.Level,5,zhizi,petID,true) 
		--info.attHurt  = {}--math.floor(petAttInfo.Level/2)
		---info.attHurtDef[]  =              math.floor(petAttInfo.Level/2)
		
		local cfgID = info.cfgID
		local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID) 
		local lyvalue = g_playerMsg:mathZhongzhuValueAtt(cfgMsg.zhongzhu,6)
		info.baojiHurt  = 150 + lyvalue
		
		for indexD=1,4 do
			info.attHurt  =  {}
			info.attHurtDef  =  {}
			
			info.attHurt[indexD] = g_petMsg:mathPetAttHurt(indexD)
			info.attHurtDef[indexD]  =  g_petMsg:mathPetAttHurt(indexD)
		end 
		info.count = 0
		info.status = 0
		info.bufMsg = {}
		----cclog(info,"=====reloadPlayerPetMsg=====",index)
		local item = g_batWndContorlPK:getItem(index)
		local c1 =  item:getController("c1") --控制器
		c1:setSelectedIndex(0)	
	else
		--B_FbBatPk:setFbMsgPanlePetHp(index)
	end 
	g_batTbMsgPK:setBatRoleMsg(info) 
	----cclog("=====setBatRoleMsg=======",info,index)
	B_FbBatPk:setFbMsgPanleCW(index)	
	
end 

--有外部有数值改变时  查看监听的操作
function batContorlPK:reloadMyRoleMsg(reload)
	local info = g_batTbMsgPK:getBatRoleMsg(100) or {}
	local mp = g_roleMsg:getRoleAttValue(16)
	local hp = g_roleMsg:getRoleAttValue(15)
	hp = floorBigInt(hp) 
	info.maxMp = mp
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	info.maxHp = hp
	if not info.hp or reload  then
		--info.id = 100
		info.index  = 100
		info.cfgID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
		info.mp  = mp
		info.hp  = hp
		info.bj = g_roleMsg:getRoleAttValue(RoleAttMsg.baoji,true)
		info.jz = g_roleMsg:getRoleAttValue(RoleAttMsg.jingzun,true)
		info.sb = g_roleMsg:getRoleAttValue(RoleAttMsg.shanbi,true)
		---local tbplayerMsg =  g_cfgMsg:getCfgMsg("role_D",info.cfgID)
		info.attckNum = g_roleMsg:getRoleAttValue(RoleAttMsg.attckNum,true) --tbplayerMsg.attckNum 
		if self.chongSkill[2] > 1 and info.attckNum > self.chongSkill[2]  then
			info.attckNum = math.floor(self.chongSkill[2])
		end 
		-----cclog("====getRoleAttValue=======",info.jz,info.sb )
		info.dpsWl  = g_roleMsg:getRoleAttValue(RoleAttMsg.wlDps,nil,true)
		
		info.dpsMf  = g_roleMsg:getRoleAttValue(RoleAttMsg.mfDps,nil,true)
		----cclog("====getRoleAttValue====111===",info.dpsMf,info.dpsWl )
		info.defWL  = g_roleMsg:getRoleAttValue(RoleAttMsg.wlDef,true)
		info.defMf  = g_roleMsg:getRoleAttValue(RoleAttMsg.mfDef,true)
		info.chouhen  = g_roleMsg:getRoleAttValue(RoleAttMsg.chouhen,true)
		info.kangyun  = g_roleMsg:getRoleAttValue(RoleAttMsg.kangyun)
		---local speed = g_batMathPK:mathSpeed()
		info.speed  = g_roleMsg:getRoleAttValue(RoleAttMsg.speed,1)
		info.speed = tonumber(info.speed) 
		--cclog(info.speed,"====222===info.speed==D==")
		for i=1,4 do
			info.attHurt  =  {}
			info.attHurtDef  =  {}
			local id = RoleAttMsg.hyHurt + 1-i
			local id2 = RoleAttMsg.hyKang + 1-i
			info.attHurt[i] = g_roleMsg:getRoleAttValue(id)
			info.attHurtDef[i]  =   g_roleMsg:getRoleAttValue(id2)
		end 
		
		info.fantan  = g_roleMsg:getRoleAttValue(RoleAttMsg.fantan,1)
		info.chuanjia  = g_roleMsg:getRoleAttValue(RoleAttMsg.chuanjia,1)
		info.fashang  = g_roleMsg:getRoleAttValue(RoleAttMsg.fashang,1)
		info.baojiHurt  = g_roleMsg:getRoleAttValue(RoleAttMsg.baojiHurt,1)
		info.xiHp  = g_roleMsg:getRoleAttValue(RoleAttMsg.xiHp,1)
		info.xiMp  = g_roleMsg:getRoleAttValue(RoleAttMsg.xiMp,1)
		info.addHpOne  = g_roleMsg:getRoleAttValue(RoleAttMsg.addHpOne,1,true)
		info.addMpOne  = g_roleMsg:getRoleAttValue(RoleAttMsg.addMpOne,1,true)
		info.jngl  = g_roleMsg:getRoleAttValue(RoleAttMsg.jngl,1)
		
		info.kangyun  = g_roleMsg:getRoleAttValue(RoleAttMsg.kangyun,1)
		info.chouhen  = g_roleMsg:getRoleAttValue(RoleAttMsg.chouhen,1)
		
		info.status = 0
		info.count = 0
		info.bufMsg = {}
		g_batTbMsgPK:setBatRoleMsg(info) 
		B_FbBatPk:setFbMsgPanleMyRole()
		g_batWndContorlPK:cleanItemBuf(100)
	else
		g_batTbMsgPK:setBatRoleMsg(info) 
		B_FbBatPk:setFbMsgPanleMyRole()
	end 
	
end 

--重置其他数据
function batContorlPK:initGameOthersMsg()
	g_batTbMsgPK:cleanFbEnemyMsg() 
	for i,ID in pairs(fbBatMsgKey)do
		g_batTbMsgPK:setFbBatMsg(ID,nil) 
	end 
end


--有外部有数值改变时  查看监听的操作
function batContorlPK:reloadPlayerRoleMsg(toUserID,reload)
	local id = 1100
	local info = g_batTbMsgPK:getBatRoleMsg(id) or {} 
	local mp = g_playerMsg:getRoleAttValue(16)
	local hp = g_playerMsg:getRoleAttValue(15)
	hp = floorBigInt(hp) 
	info.maxMp = mp
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	info.maxHp = hp
	--cclog("====getRoleAttValue====111===",mp,hp )
	if (not info.hp and  toUserID ~= info.userID) or reload then
		--info.id = 100
		info.userID = toUserID
		info.index  = id
		info.cfgID = g_playerMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
		info.mp  = mp
		info.hp  = hp
		info.bj = g_playerMsg:getRoleAttValue(RoleAttMsg.baoji,true)
		info.jz = g_playerMsg:getRoleAttValue(RoleAttMsg.jingzun,true)
		info.sb = g_playerMsg:getRoleAttValue(RoleAttMsg.shanbi,true)
	
		local tbplayerMsg =  g_cfgMsg:getCfgMsg("role_D",info.cfgID)
		info.attckNum = g_playerMsg:getRoleAttValue(RoleAttMsg.attckNum,true) --tbplayerMsg.attckNum  ---
		
		info.dpsWl  = g_playerMsg:getRoleAttValue(RoleAttMsg.wlDps,nil,true)
		
		info.dpsMf  = g_playerMsg:getRoleAttValue(RoleAttMsg.mfDps,nil,true)
		----cclog("====getRoleAttValue====111===",info.dpsMf,info.dpsWl )
		info.defWL  = g_playerMsg:getRoleAttValue(RoleAttMsg.wlDef,true)
		info.defMf  = g_playerMsg:getRoleAttValue(RoleAttMsg.mfDef,true)
		info.chouhen  = g_playerMsg:getRoleAttValue(RoleAttMsg.chouhen,true)
		info.kangyun  = g_playerMsg:getRoleAttValue(RoleAttMsg.kangyun)
		--local speed = --g_batMathPK:mathSpeed()
		info.speed  = g_playerMsg:getRoleAttValue(RoleAttMsg.speed,1)
		info.speed = tonumber(info.speed)
		--cclog(info.speed ,"=======info.speed====")
		for i=1,4 do
			info.attHurt  =  {}
			info.attHurtDef  =  {}
			local id = RoleAttMsg.hyHurt + 1-i
			local id2 = RoleAttMsg.hyKang + 1-i
			info.attHurt[i] = g_playerMsg:getRoleAttValue(id)
			info.attHurtDef[i]  =   g_playerMsg:getRoleAttValue(id2)
		end 
		
		info.fantan  = g_playerMsg:getRoleAttValue(RoleAttMsg.fantan,1)
		info.chuanjia  = g_playerMsg:getRoleAttValue(RoleAttMsg.chuanjia,1)
		info.fashang  = g_playerMsg:getRoleAttValue(RoleAttMsg.fashang,1)
		info.baojiHurt  = g_playerMsg:getRoleAttValue(RoleAttMsg.baojiHurt,1)
		info.xiHp  = g_playerMsg:getRoleAttValue(RoleAttMsg.xiHp,1)
		info.xiMp  = g_playerMsg:getRoleAttValue(RoleAttMsg.xiMp,1)
		info.addHpOne  = g_playerMsg:getRoleAttValue(RoleAttMsg.addHpOne,1,true)
		info.addMpOne  = g_playerMsg:getRoleAttValue(RoleAttMsg.addMpOne,1,true)
		info.jngl  = g_playerMsg:getRoleAttValue(RoleAttMsg.jngl,1)
		
		info.kangyun  = g_playerMsg:getRoleAttValue(RoleAttMsg.kangyun,1)
		info.chouhen  = g_playerMsg:getRoleAttValue(RoleAttMsg.chouhen,1)
		
		info.status = 0
		info.count = 0
		info.bufMsg = {}
		g_batTbMsgPK:setBatRoleMsg(info) 
		--cclog(info,"===reloadPlayerRoleMsg=====")
		B_FbBatPk:setFbMsgPanleMyRole(2)
		g_batWndContorlPK:cleanItemBuf(id)
	else
		g_batTbMsgPK:setBatRoleMsg(info) 
		B_FbBatPk:setFbMsgPanleMyRole(2)
	end 
end 

function batContorlPK:reloadPlayerPetMsg(index,id,reload)
	local batPatMsg = g_playerMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	local petID = batPatMsg[index] or 0
	----cclog(petID,index,"=====reloadPlayerPetMsg=====",id)
	local index = id
	if petID <= 0 then
		local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
		g_batTbMsgPK:delBatRoleMsg(index) 
		B_FbBatPk:setFbMsgPanleCW(index)
		return
	end 
	local info = g_batTbMsgPK:getBatRoleMsg(index) or g_playerMsg:getpetTbMsg(petID)
	local petAttInfo = g_playerMsg:getpetTbMsg(petID)
	local zhizi = g_playerMsg:getPetZZ(petID)  
	if not zhizi then
		return
	end 
	local value = g_playerMsg:mathPetBaseAtt(petAttInfo.Level,3,zhizi,petID) 
	value = floorBigInt(value) 
	info.maxHp = value
	 -----cclog(value,index,"=====value====",petAttInfo.Level,3,zhizi,petID)
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	if not info.hp or reload  then	
		--info.id = index
		info.hp  = value
		info.index = index
		info.bj = g_playerMsg:mathPetAttCe(petAttInfo,petAttCeMsg.baoji)
		info.jz = g_playerMsg:mathPetAttCe(petAttInfo,petAttCeMsg.jinzun)
		info.sb = g_playerMsg:mathPetAttCe(petAttInfo,petAttCeMsg.duoshan)
		info.attckNum = g_playerMsg:mathPetAttCe(petAttInfo,petAttCeMsg.attckNum)
		
		info.dpsWl  = g_playerMsg:mathPetBaseAtt(petAttInfo.Level,1,zhizi,petID,true) 
		info.dpsMf  = info.dpsWl
		info.defWL  = g_playerMsg:mathPetBaseAtt(petAttInfo.Level,2,zhizi,petID,true) 
		info.defMf  = info.defWL
		--local speed = g_batMathPK:mathSpeed(,1 )
		info.speed  =  g_playerMsg:mathPetBaseAtt(petAttInfo.Level,4,zhizi,petID)
		info.speed = tonumber(info.speed)
		info.chouhen = g_playerMsg:mathPetBaseAtt(petAttInfo.Level,5,zhizi,petID,true) 
		--info.attHurt  = {}--math.floor(petAttInfo.Level/2)
		---info.attHurtDef[]  =              math.floor(petAttInfo.Level/2)
		for indexD=1,4 do
			info.attHurt  =  {}
			info.attHurtDef  =  {}
			
			info.attHurt[indexD] = g_playerMsg:mathPetAttHurt(indexD)
			info.attHurtDef[indexD]  =  g_playerMsg:mathPetAttHurt(indexD)
		end 
		info.count = 0
		info.status = 0
		info.bufMsg = {}
		
		--cclog(info,"=====reloadPlayerPetMsg=====",index)
		local item = g_batWndContorlPK:getItem(index)
		local c1 =  item:getController("c1") --控制器
		c1:setSelectedIndex(0)	
	else
		--B_FbBatPk:setFbMsgPanlePetHp(index)
	end 
	g_batTbMsgPK:setBatRoleMsg(info) 
	B_FbBatPk:setFbMsgPanleCW(index)	
end 

function batContorlPK:initPlayerMsg()
	--初始化对方角色
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	self:reloadPlayerRoleMsg(g_playerMsg.toUserID,true)
	---初始化对方宠物
	local batPatMsg = g_playerMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	for i=1,7 do
		local petID = batPatMsg[i] or 0
		local index = 1000 + i
		
		self:reloadPlayerPetMsg(i,index,true)
		local nType = g_batRoleSkillContorlPK:isZhongZhuSkillChong(index)	
		if nType ~= 3 then
			self.chongSkill[2] = 0
		end 
	end 
	local id = 1100
	local nType = g_batRoleSkillContorlPK:isZhongZhuSkillChong(id)	
	if nType ~= 3 then
		self.chongSkill[2] = 0
	end 
	
end

function batContorlPK:initGameMsg()
	self.chongSkill =  {1,1}
	g_batRoleSkillContorlPK.GuiSkill =  {}
	--初始化对方 
	self:initPlayerMsg()
	--初始化自己角色
	self:reloadMyRoleMsg(true)
	--初始化自己宠物

	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	
	for i=1,7 do
		local petID = batPatMsg[i] or 0
		local index = 10 + i
		self:reloadPetMsg(index,true)
		local nType = g_batRoleSkillContorlPK:isZhongZhuSkillChong(index)	
		if nType >= 1 then
			self.chongSkill[1] = 0
		end 
	end 
	local nType = g_batRoleSkillContorlPK:isZhongZhuSkillChong(100)	
	if nType  >= 1 then
		self.chongSkill[1] = 0
	end 
	if self.chongSkill[1]  >= 1 then
		local info =  g_batTbMsgPK:getBatInfo(1100)
		if info and info.attckNum  >= self.chongSkill[1] then
			info.attckNum = math.floor( self.chongSkill[1])
		end 
		g_batTbMsgPK:setBatRoleMsg(info) 
		local batPatMsg = g_playerMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
		for i=1,7 do
			local petID = batPatMsg[i] or 0
			local index = 1000 + i
			local info =  g_batTbMsgPK:getBatInfo(index)
			if info then
				if info and info.attckNum  >= self.chongSkill[1] then
					info.attckNum = math.floor( self.chongSkill[1])
				end 
				g_batTbMsgPK:setBatRoleMsg(info) 
			end 
		end 
	end 
	
	
	self.gameStatus = gameStatus.batIng
	self.turn  = 1
	self:startAllTimeSchedu()
	
	g_batWndContorlPK:initTopPanel()
	self:setTuanNum()
	TimeScheduCount = 0
	self.TimeScheduSpeed = nil

	---local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	--local skillPanle =  B_FbBatPk.rootLayout:getChild("skillPanle") 
	--skillPanle:removeChildren()
	g_batContorl.gameStatus = gameStatus.stop
end 

function batContorlPK:ctor()
	
end

g_batContorlPK =  batContorlPK:create()