------------------
-- 文件名:	batRoleSkillContorlPK.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local batRoleSkillContorlPK = class("batRoleSkillContorlPK")

--播放界面特效
--播放界面效果Item

---=================================================

--给目标施放效果 nTime -1 是永久  >0是计数
function batRoleSkillContorlPK:toBojBuf(toRoleID,bufID,value,nTime,roleID)
	---cclog(id, "====toBojBuf======1==",toRoleID)
	local info =  g_batTbMsgPK:getBatInfo(toRoleID) 
	local id = bufID*10000 + roleID
	
	local status 
	if not info.bufMsg[id] then
		status = 1
	end
	local cfgMsg =  g_cfgMsg:getCfgMsg("att_D",bufID)
	if id >= 70 and  id <= 89 and info.kangyun and info.kangyun > 0 then
		local nRandom = math.random(1,10000)
		if nRandom <= info.kangyun*100 then
			
			local str = cfgMsg.name.."抵抗"
			g_batWndContorlPK:createStausPiaozi(toRoleID,"抵抗",22)
			return
		end 
	end 
	info.bufMsg[id] = { value = tonumber(value) ,  nTime = tonumber(nTime), toRole = roleID,maxTime = tonumber(nTime) }
	g_batTbMsgPK:setBatInfo(info) 
	if status then
		--刷新界面
		g_batWndContorlPK:setItemBuf(toRoleID)
	end 
	 
end 
---	可叠加
--给目标施放效果  nTime -1 是永久  >0是计数
function batRoleSkillContorlPK:addToBojBuf(toRoleID,bufID,value,nTime,roleID)
	local info =  g_batTbMsgPK:getBatInfo(toRoleID) 
	local id = bufID*1000 + roleID
	cclog(info.bufMsg,id, "====toBojBuf======1==",toRoleID)
	local status 
	if not info.bufMsg[id] then
		status = 1
	end
	if not info.bufMsg[id] then
		info.bufMsg[id] = { value = tonumber(value) ,  nTime = tonumber(nTime), toRole = roleID,maxTime = tonumber(nTime) }
	else
		info.bufMsg[id].nTime = nTime
		info.bufMsg[id].value = info.bufMsg[id].value + value
	end 
	
	g_batTbMsgPK:setBatInfo(info) 
	if status then
		--刷新界面
		g_batWndContorlPK:setItemBuf(toRoleID)
	end 
end 

--重置计数
function batRoleSkillContorlPK:reloadRoleBufTime(roleID)
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	local status 
	for ID,tbMsg in pairs(info.bufMsg)do
		if tbMsg.nTime > 0  then
			info.bufMsg[ID].nTime = info.bufMsg[ID].maxTime
			status = true
		end 
	end 
	if status then
		--cclog("==status====roleBufTime====")
		g_batTbMsgPK:setBatInfo(info) 
		--刷新界面
		g_batWndContorlPK:setItemBuf(roleID)
	end 
end 

--效果计数
function batRoleSkillContorlPK:roleBufTime(roleID,addTime)
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	local status 
	if not addTime then
		addTime = 1
	end 
	for ID,tbMsg in pairs(info.bufMsg)do
		--cclog(tbMsg.nTime,"======roleBufTime====",roleID)
		if tbMsg.nTime then
			if tbMsg.nTime <= 0 then
				info.bufMsg[ID] = nil
				status = true
			elseif tbMsg.nTime > 0  then
				info.bufMsg[ID].nTime = info.bufMsg[ID].nTime - addTime
			end 
		end 
		
	end 
	if status then
		g_batTbMsgPK:setBatInfo(info) 
		--刷新界面
		g_batWndContorlPK:setItemBuf(roleID)
	end 
end 

--效果清除
---- bufID = 0 表示 所有负面效果， bufID<0 表示全部,  bufID > 0 表示某个
function batRoleSkillContorlPK:cleanRoleBuf(roleID,ID)
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	if ID == 0  then
		for ID,tbMsg in pairs(info.bufMsg)do
			local bufID = math.floor(ID/1000)
			if  tbMsg.nTime > 0 and bufID < 90 then
				info.bufMsg[ID] = nil
				status = true
			end 
		end 
	elseif  ID < 0  then
		for ID,tbMsg in pairs(info.bufMsg)do
			if  tbMsg.nTime < 0 then
				info.bufMsg[ID] = nil
				status = true
			end 
		end 
	elseif  ID > 0  then
		info.bufMsg[ID] = nil
		status = true
	end 
	if status then
		g_batTbMsgPK:setBatInfo(info) 
		--刷新界面
		g_batWndContorlPK:setItemBuf(roleID)
	end 	
	--特效
end 

--效果触发
function batRoleSkillContorlPK:openBufContorl(roleID,bufID)
	--是否有该效果
	local info =  g_batTbMsgPK:getBatInfo(roleID)
	local id = bufID *1000
	local maxID = bufID *1000 +  999
	for ID,tbMsg in pairs(info.bufMsg)do
		if  tbMsg.nTime ~= 0 and  ID  > id and  ID < maxID then
			---触发
			handler(self, self["bufOpen_BufID"..UseType])(roleID,tbMsg)  --buf触发
		end 
	end 
end

--是否有某某效果
function batRoleSkillContorlPK:getBufByID(roleID,tbBufMsg)
	local info =  g_batTbMsgPK:getBatInfo(roleID)
	for ID,tbMsg in pairs(info.bufMsg)do
		local bufID = math.floor(ID/1000)
		for i,id in pairs(tbBufMsg)do
			if bufID ==  id and  tbMsg.nTime ~= 0 then
				return tbMsg.nTime
			end 
		end 
	end 
	return 
end 
---=================================================
--给目标施放伤害
function batRoleSkillContorlPK:skillHurtRole(roleID,toRoleID,hurt)
	local info =  g_batTbMsgPK:getBatInfo(toRoleID) 
	if info.status == ROLESTATUSS.death or  not MaxBigInt(info.hp, "0")  then
		return
	end 
	 g_batContorlPK:ptAttckContorl(roleID,toRoleID,true,hurt,true)
end 
--给目标施放治疗
function batRoleSkillContorlPK:skillZiliaoRole(attckId,toAttckId,hurt)
	--技能或者普通攻击
	local info =  g_batTbMsgPK:getBatInfo(attckId) 
	local toinfo =  g_batTbMsgPK:getBatInfo(toAttckId) 
	--是否暴击
	local baoji1 = g_batTbMsgPK:getFbRoleBaojiValue(attckId) 
	local toBaoji = g_batTbMsgPK:getFbRoleBaojiValue(toAttckId) 
	local isBaoji = g_batMathPK:mathBaoji(baoji1,toBaoji,toAttckId)
	local attHurt = g_batMathPK:mathHurtAtt(info,toinfo) or "0"
	if attHurt ~= "0" then
		hurt = addBigInt(attHurt, hurt)
	end 
	if isBaoji then
		 g_batContorlPK:statusContorl(attckId,batStatusTypes.Bj)
		hurt = g_batMathPK:mathHurtBaoji(info,hurt)
	end 
	--治疗操作
	 g_batContorlPK:zhiliaoContorl(toAttckId,hurt)
	
end 
--复活目标
function batRoleSkillContorlPK:fuhuoRole(toAttckId,hurt)
	 g_batContorlPK:FuhuoContorl(toAttckId,hurt)
end 

--被动- 获取 自身血量每减少10%，xxx提高x%  获取减少多少
function batRoleSkillContorlPK:mathHpRolePro(attckId)
	local info =  g_batTbMsgPK:getBatInfo(attckId) 
	local hpOne = info.hp * 0.1
	local num = 0
	for i=1,10 do
		local value = hpOne*i
		if  not MaxBigInt(info.hp, value)  then
			local index = 10 - i
			return index
		end 
	end 
	
	return 0
end

---=================================================
--获取技能数值
function batRoleSkillContorlPK:mathSkillValue(skillID,lev)
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",skillID)
	local info =   g_batTbMsgPK:getBatInfo(100) 
	local  jngl = (info.jngl or  0 )
	
	local tbAttMsg = g_roleSkillMsg:getSkillValue(skillID,lev) 
	---cclog(tbAttMsg,"===mathSkillValue===222====",skillID,lev)
	if tbMsg.isRandom == 1 then
		tbAttMsg[1] = tbAttMsg[1] + jngl
	end 
	--cclog(tbAttMsg,"===mathSkillValue=======",skillID,lev)
	return tbAttMsg
end 

---=================================================
openSkillMsg = {}
openSkillMsg.attackFront = 1
openSkillMsg.attackBehi = 2
openSkillMsg.beAttack = 3
openSkillMsg.baoji = 4
openSkillMsg.duoshan = 5
openSkillMsg.death = 6
openSkillMsg.openSkill = 7
function batRoleSkillContorlPK:showSkillFactory(nType,attckId,toAttckId)
	
	local status = handler(self, self["showSkill"..nType])(attckId,toAttckId)  
	return status
end 
---攻击前触发
function batRoleSkillContorlPK:showSkill1(attckId)
	for skillID=95000122 ,95000126 do
		self:skillFactory(skillID,attckId)
	end 
	return
end

---攻击后触发
function batRoleSkillContorlPK:showSkill2(attckId)
end
---被攻击后触发
function batRoleSkillContorlPK:showSkill3(attckId)
end
---暴击触发
function batRoleSkillContorlPK:showSkill4(attckId)
end
---闪避触发
function batRoleSkillContorlPK:showSkill5(attckId)
end
---死亡触发
function batRoleSkillContorlPK:showSkill6(attckId,toAttckId)
	if toAttckId < 100  then
		self:skillFactory(95000117,attckId,toAttckId)
	end 
end
---主动技能触发
function batRoleSkillContorlPK:showSkill7(attckId)
	local isOpen 
	for skillID=95000101 ,95000111 do
		local status = self:skillFactory(skillID,attckId)
		if status == true then
			isOpen = true
		end 
	end 
	return isOpen
end

---判断是否有该技能
function batRoleSkillContorlPK:isHSkill(attckId,skillID)
	if attckId == 1100 then
		local lev = self:isHSkill2(attckId,skillID)
		return lev
	end 
	local BOSSID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	for indexD=1,tbGameConst.SkillMaxNum do
		local ID = tbMsg["skill"..indexD]
		if  ID == skillID then
			local lev = g_roleSkillMsg:getroleSkillTbMsgLev(indexD) or 0
			if lev > 0  then
				local addVa = g_tianfuConTrol:getTianfuOpenValue(50) 
				return lev + addVa
			end 
		end 
	end
	return 
end
---判断是否有该技能
function batRoleSkillContorlPK:isHSkill2(attckId,skillID)
	local BOSSID = g_playerMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	for indexD=1,tbGameConst.SkillMaxNum do
		local ID = tbMsg["skill"..indexD]
		if  ID == skillID then
			local lev = g_playerMsg:getroleSkillTbMsgLev(indexD) or 0
			if lev > 0  then
				local addVa = g_playerMsg:getTianfuOpenValue(50) 
				return lev + addVa
			end 
		end 
	end
	return 
end

------技能工厂 ---isOpen  必施放
function batRoleSkillContorlPK:skillFactory(skillID,attckId,toAttckId,isOpen)
	---判断是否有该技能
	cclog("===skillFactory====",skillID,attckId)
	if  attckId == 100  or  attckId == 1100  then
	else
		return
	end 
	local lev = self:isHSkill(attckId,skillID)
	if not lev then	
		cclog("=not lev"..skillID)
		return
		
	end 
	
	--是否死亡或者晕眩或者禁魔
	local info =  g_batTbMsgPK:getBatInfo(attckId) 
	if info.status == ROLESTATUSS.death  then
		cclog("==死亡中... ")
		return 
	end 
	local tbBufMsg = {70,71,78}
	local nTime = self:getBufByID(attckId,tbBufMsg)
	
	if  nTime then
		--显示禁魔火或者buf标记
		cclog(nTime,"====显示禁魔火或者buf标记==")
		return true
	end 

	--是否需要魔法
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",skillID)
	--获取数值
	local tbValue = self:mathSkillValue(skillID,lev)
	if tbMsg.isRandom >= 1 and not isOpen then
		local ration = tbValue[1]
		local statue = self:mathRandomOpen(ration)
		if not statue then
			--cclog("=======not statue======")
			return
		end 
	end 
	--判断魔法
	if tbMsg.costMp > 0  then
		---是否在冷却
		if not info.coolTimeSkill then
			info.coolTimeSkill = {}
		end 
		if not info.coolTimeSkill[skillID] then
			info.coolTimeSkill[skillID] =  -3
		end 
		local startIme =  g_batContorlPK.turn - info.coolTimeSkill[skillID]
		local baseCool = 3
		local addVa = g_tianfuConTrol:getTianfuOpenValue(53) 
		local roleLev
		if attckId == 1100  then
			 addVa = g_playerMsg:getTianfuOpenValue(53) 
			 roleLev = g_playerMsg:getRoleAttValue(RoleAttMsg.level,true)
		end 
		baseCool = baseCool- addVa
		cclog(startIme,baseCool,addVa,"======冷却中=====", g_batContorlPK.turn,info.coolTimeSkill[skillID] )
		if baseCool  < 1 then
			baseCool = 1
		end 
		if startIme < baseCool and not isOpen then
			cclog(startIme,"==冷却中==")
			return
		end 
		info.coolTimeSkill[skillID] =  g_batContorlPK.turn

		local costMp  = g_roleSkillMsg:getCostMp(skillID,lev,roleLev) 
		g_batWndContorlPK:setWndMp(attckId)
		local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
		if tonumber(info.mp) < costMp and not isOpen then
			B_FbBatPk:showMpStatusText(1)
			g_batTbMsgPK:setBatInfo(info) 
			cclog("======info.mp) < costMp===")
			return
		end 
		info.mp  = info.mp  - costMp
		g_batTbMsgPK:setBatInfo(info) 
		B_FbBatPk:setFbMsgPanleRoleMp()
	end 

	--获取目标- 单体或者几个全体
	local tbToAttckId = self:mathSkillToObj(skillID,attckId,toAttckId)
	local stasu 

	local info =  g_batTbMsgPK:getBatInfo(attckId) 
	local cfgID  = tbMsg.anima1 or 0
	local wndAnima = 0
	if cfgID  >  0  then
		local tbMsg2 =  g_cfgMsg:getCfgMsg("animaEffct_D",cfgID)
		if  tbMsg2.startType == 0  then
			wndAnima = 1
		else
			wndAnima =  -1 
		end 
	end 
	--cclog(wndAnima,"==tbToAttckId==",tbToAttckId,skillID)	
	for i,toAttckId in pairs(tbToAttckId)do
		  
		if wndAnima == 1 then
			g_batWndContorlPK:showSkillEffctItemPool(attckId,toAttckId,skillID)
		end 
		handler(self, self["skillIDContorl"..skillID])(attckId,toAttckId,tbValue,isOpen) 
		
		g_batRoleSkillContorlPK:isZhongZhuSkillRX(attckId,toAttckId)	
		g_batRoleSkillContorlPK:isZhongZhuSkillRX(toAttckId,attckId)	
	end 
	--播放效果
	if wndAnima == -1 then
		g_batWndContorlPK:showSkillEffctItemPool(attckId,attckId,skillID)
	end 
	return true
end
----获取目标- 单体或者几个全体
function batRoleSkillContorlPK:mathSkillToObj(skillID,attckId,toAttckId)
	
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",skillID)
	local nType = tbMsg.attckObjType -- 目标类型1是敌人  2是自己  3是队友   4指定
	local attckNum = tbMsg.attckNum  --- 目标个数-1是全体
	local tbToAttckId = {}
	if nType == 1  then
		tbToAttckId =  g_batContorlPK:getAttckObjRan(attckNum,attckId)
	elseif nType == 2  then
		tbToAttckId = {attckId}
	elseif nType == 3  then
		
	elseif nType == 4  then	
		tbToAttckId = {toAttckId}
	end 
	--cclog(nType,attckNum,"=========mathSkillToObj=====",tbToAttckId)
	return tbToAttckId
end 
--概率-是否触发
function batRoleSkillContorlPK:mathRandomOpen(ration)
	local rand = math.random(1,10000)
	cclog(rand,"=====mathRandomOpen=====",ration)
	if rand <= ration*100 then
		return true
	end 
	return 
end
--计算魔法值x%的伤害
function batRoleSkillContorlPK:mathMFHurt(ration,attckId)
	local attckId = attckId or 100
	local info =  g_batTbMsgPK:getBatInfo(attckId) 
	local mf = info.dpsMf
	local strLDEnd , strLDEndCN = byBigInt(mf, ration)
	return strLDEnd
end

---技能 95000101  x%概率缴械目标y秒（缴械期间受到伤害提高+z点）
function batRoleSkillContorlPK:skillIDContorl95000101(attckId,toAttckId,tbValue)
	
	local nTime = tbValue[2] or 2
	local value = tbValue[3] or 0
	self:toBojBuf(toAttckId,79,value,nTime,attckId)
	
end

---技能 95000102  x%概率禁魔敌方全体y秒（缴械期间受到伤害+z点）
function batRoleSkillContorlPK:skillIDContorl95000102(attckId,toAttckId,tbValue)
	local nTime = tbValue[2] or 2
	local value = tbValue[3] or 0
	self:toBojBuf(toAttckId,78,value,nTime,attckId)	
end

---技能 95000103  x%概率触发敌方全体寒冰术，造成魔法攻击y%+z，并冻结3秒
function batRoleSkillContorlPK:skillIDContorl95000103(attckId,toAttckId,tbValue)
	
	local ration = tbValue[2]/100
	local hurt  = self:mathMFHurt(ration)
	hurt = addBigInt(hurt,tbValue[3])
	self:toBojBuf(toAttckId,71,0,3,attckId)	
	self:skillHurtRole(attckId,toAttckId,hurt)
end

---技能 95000104  x%概率触发敌方全体减防，造成魔法攻击y%+z，
function batRoleSkillContorlPK:skillIDContorl95000104(attckId,toAttckId,tbValue)
	
	local ration = tbValue[2]/100
	local hurt  = self:mathMFHurt(ration)
	hurt = addBigInt(hurt,tbValue[3])
	
	self:toBojBuf(toAttckId,75,30,3,attckId)	
	self:skillHurtRole(attckId,toAttckId,hurt)
end

---技能 95000105  x%概率触发攻击提高y%，期间暴击提高z，持续5秒
function batRoleSkillContorlPK:skillIDContorl95000105(attckId,toAttckId,tbValue)
	
	local value1 = tbValue[2] or 2
	local value2 = tbValue[3] or 2
	self:toBojBuf(toAttckId,91,value1,5,attckId)	
	self:toBojBuf(toAttckId,94,value2,5,attckId)	
end

---技能 95000106  x%概率触发对单个目标造成大额魔法攻击y%+z的伤害
function batRoleSkillContorlPK:skillIDContorl95000106(attckId,toAttckId,tbValue)
	
	local ration = tbValue[2]/100
	local hurt  = self:mathMFHurt(ration)
	hurt = addBigInt(hurt,tbValue[3])
	self:skillHurtRole(attckId,toAttckId,hurt)
end

---技能 95000107  x%概率触发对5个目标造成魔法攻击y%+z伤害
function batRoleSkillContorlPK:skillIDContorl95000107(attckId,toAttckId,tbValue)
	
	local ration = tbValue[2]/100
	local hurt  = self:mathMFHurt(ration)
	hurt = addBigInt(hurt,tbValue[3])
	self:skillHurtRole(attckId,toAttckId,hurt)
end

---技能 95000108  x%概率触发对10个目标造成魔法攻击y%+z伤害
function batRoleSkillContorlPK:skillIDContorl95000108(attckId,toAttckId,tbValue)
	
	local ration = tbValue[2]/100
	local hurt  = self:mathMFHurt(ration)
	hurt = addBigInt(hurt,tbValue[3])
	self:skillHurtRole(attckId,toAttckId,hurt)
end

---技能 95000109  x%概率触发自身无敌y秒，期间物理攻击提高z%
function batRoleSkillContorlPK:skillIDContorl95000109(attckId,toAttckId,tbValue)
	
	local nTime = tbValue[2] or 2
	local value2 = tbValue[3] or 2
	self:toBojBuf(attckId,95,0,nTime,attckId)	
	self:toBojBuf(attckId,91,value2,nTime,attckId)	
end

---技能 95000110  x%概率触发控制2个目标5秒，期间目标攻击提高（物理攻击y%）
function batRoleSkillContorlPK:skillIDContorl95000110(attckId,toAttckId,tbValue)
	
	local nTime = tbValue[2] or 2
	local value2 = tbValue[3] or 2
	self:toBojBuf(toAttckId,77,value2,nTime,attckId)	
end
---技能 950001111  x%概率触发对目标造成魔法攻击y%+z伤害,如果目标血量大于50%,30%概率再放一次技能
function batRoleSkillContorlPK:skillIDContorl95000111(attckId,toAttckId,tbValue,isOpen)
	
	local ration = tbValue[2]/100
	local hurt  = self:mathMFHurt(ration)
	hurt = addBigInt(hurt,tbValue[3])
	self:skillHurtRole(attckId,toAttckId,hurt)

	local info =  g_batTbMsgPK:getBatInfo(toAttckId)
	local pro = math.floor( info.hp *100/info.maxHp )
	if pro > 50 then
		local nRandom = math.random(1,100)
		if nRandom <= 30 then
			local item = g_batWndContorlPK:getItem(toAttckId)
			local function scheduleByOne()
				self:skillFactory(95000111,attckId,nil,true)
			end 
			---local TextHp = item:getChild("TextHp")
			---TextHp
			local _viewObj = item:displayObject()
			g_scheduleTime:scheduleByTimes(_viewObj, 0.2,1,scheduleByOne)
		end 
	end 
	


end

---技能 95000117  宠物复活恢复x血量
function batRoleSkillContorlPK:skillIDContorl95000117(attckId,toAttckId,tbValue)
	local addHp = tbValue[1] or 0
	self:fuhuoRole(toAttckId,addHp)
end


---技能 95000122  自身血量每减少10%，攻击提高x%
function batRoleSkillContorlPK:skillIDContorl95000122(attckId,toAttckId,tbValue)
	local num = self:mathHpRolePro(attckId)
	if num == 0 then
		return
	end 
	local ration = tbValue[1] or 0
	self:toBojBuf(attckId,91,ration,nTime,attckId)	
end
---技能 95000123  自身血量每减少10%，全防御提高x%
function batRoleSkillContorlPK:skillIDContorl95000123(attckId,toAttckId,tbValue)
	local num = self:mathHpRolePro(attckId)
	if num == 0 then
		return
	end 
	local ration = tbValue[1] or 0
	self:toBojBuf(attckId,96,ration,nTime,attckId)	
end

---技能 95000124  自身血量每减少10%，躲闪提高x%
function batRoleSkillContorlPK:skillIDContorl95000124(attckId,toAttckId,tbValue)
	local num = self:mathHpRolePro(attckId)
	if num == 0 then
		return
	end 
	local ration = tbValue[1] or 0
	self:toBojBuf(attckId,97,ration,nTime,attckId)	
end

---技能 95000125  目标血量每减少10%，速度提高x%
function batRoleSkillContorlPK:skillIDContorl95000125(attckId,toAttckId,tbValue)
	local num = self:mathHpRolePro(attckId)
	if num == 0 then
		return
	end 
	local ration = tbValue[1] or 0
	self:toBojBuf(attckId,90,ration,nTime,attckId)	
end

---技能 95000126 目标血量每减少10%，暴击概率提高x%
function batRoleSkillContorlPK:skillIDContorl95000126(attckId,toAttckId,tbValue)
	local num = self:mathHpRolePro(attckId)
	if num == 0 then
		return
	end 
	local ration = tbValue[1] or 0
	self:toBojBuf(attckId,94,ration,nTime,attckId)	
end


---========================================
--是否已开启
function batRoleSkillContorlPK:openZhongZhuSkill(toRoleID)
	local zslevel
	if toRoleID  > 800  then
		zslevel = g_playerMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	else
		zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	end 

	if zslevel < 6  then
		return	0
	end 
	return 1	
end 

function batRoleSkillContorlPK:getZhongZhuSkillValue(toRoleID,cIndex)
	local value
	if toRoleID  > 800  then
		value = g_playerMsg:mathZhongzhuValue2(cIndex) 
	else
		value = g_lyInfoMsg:mathZhongzhuValue2(cIndex) 
	end 

	return value	
end 

---种族技能
function batRoleSkillContorlPK:isZhongZhuSkillYS(toRoleID)	
	local status = self:openZhongZhuSkill(toRoleID)
	if status == 0 then
		return 0
	end 
	local info =  g_batTbMsgPK:getBatInfo(toRoleID)
	local cfgID = info.cfgID
	local nZZ = 0
	if toRoleID == 100 or toRoleID == 1100 then
		cclog(toRoleID,"=========zhongzhu=====000====",cfgID)
		local tbMsg =  g_cfgMsg:getCfgMsg("role_D",cfgID)
		nZZ = tbMsg.nTypeIndex
	else
		cclog(toRoleID,"=========zhongzhu====1111=====",cfgID)
		local tbMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID)
		nZZ = tbMsg.zhongzhu
	end 	
	if nZZ == 1 then
		local value  = self:getZhongZhuSkillValue(toRoleID,1)
		value = value*100
		return value
	end 
	return 0
end

function batRoleSkillContorlPK:isZhongZhuSkillRX(RoleID,toRoleID)	
	local status = self:openZhongZhuSkill(RoleID)
	if status == 0 then
		return 0
	end
	local info =  g_batTbMsgPK:getBatInfo(RoleID)
	local cfgID = info.cfgID
	local nZZ = 0
	if RoleID == 100 or RoleID == 1100 then
		local tbMsg =  g_cfgMsg:getCfgMsg("role_D",cfgID)
		nZZ = tbMsg.nTypeIndex
	else
		local tbMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID)
		nZZ = tbMsg.zhongzhu
	end 	
	if nZZ == 2 then
		local nRandom = math.random(1,100)
		local value  = self:getZhongZhuSkillValue(toRoleID,2)
		if nRandom <= value then
			self:toBojBuf(toRoleID,71,0,1,RoleID)	
			return 1
		end 
		
	end 
	return 0
end

function batRoleSkillContorlPK:isZhongZhuSkillChong(RoleID)	
	local status = self:openZhongZhuSkill(RoleID)
	if status == 0 then
		return 0
	end
	local info =  g_batTbMsgPK:getBatInfo(RoleID)
	if not info then
		return 0
	end 
	local cfgID = info.cfgID
	local nZZ = 0
	if RoleID == 100 or RoleID == 1100 then
		--cclog(cfgID,"======isZhongZhuSkillChong======111===",RoleID)
		local tbMsg =  g_cfgMsg:getCfgMsg("role_D",cfgID)
		nZZ = tbMsg.nTypeIndex
	else
		--cclog("======isZhongZhuSkillChong====222=====",cfgID)
		local tbMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID)
		nZZ = tbMsg.zhongzhu
	end 	
	if nZZ == 3 then
		local value  = self:getZhongZhuSkillValue(RoleID,3)
		return value
	end 
	return 0
end


function batRoleSkillContorlPK:isZhongZhuSkillFlong(RoleID)	
	local status = self:openZhongZhuSkill(RoleID)
	if status == 0 then
		return 0
	end
	local info =  g_batTbMsgPK:getBatInfo(RoleID)
	local cfgID = info.cfgID
	local nZZ = 0
	if RoleID == 100 or RoleID == 1100 then
		local tbMsg =  g_cfgMsg:getCfgMsg("role_D",cfgID)
		nZZ = tbMsg.nTypeIndex
	else
		local tbMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID)
		nZZ = tbMsg.zhongzhu
	end 	
	if nZZ == 4 then
		local value  = self:getZhongZhuSkillValue(RoleID,4)
		local nRandom = math.random(1,100)
		if nRandom <= value then
			return 1
		end 
	end 
	return 0
end

function batRoleSkillContorlPK:isZhongZhuSkillGui(RoleID)	
	local status = self:openZhongZhuSkill(RoleID)
	if status == 0 then
		return 0
	end
	local info =  g_batTbMsgPK:getBatInfo(RoleID)
	local cfgID = info.cfgID
	local nZZ = 0
	if RoleID == 100 or RoleID == 1100 then
		local tbMsg =  g_cfgMsg:getCfgMsg("role_D",cfgID)
		nZZ = tbMsg.nTypeIndex
	else
		local tbMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID)
		nZZ = tbMsg.zhongzhu
	end 	
	if nZZ == 5 then
		---是否复活过 
		if self.GuiSkill[RoleID]  then
			return
		end 
	
		local nRandom = math.random(1,100)
		local value  = self:getZhongZhuSkillValue(RoleID,5)
		if nRandom <= value then
			self.GuiSkill[RoleID] = 1
			g_batContorlPK:FuhuoContorl(RoleID,info.maxHp)
			return 1
		end 
	end 
	return 0
end

function batRoleSkillContorlPK:ctor()
	self.GuiSkill = {}
end

g_batRoleSkillContorlPK =  batRoleSkillContorlPK:create()