 --------------------------------------------------------------------------------------
-- 文件名:	roleAttConTrol.lua
-- 版  权:	(C)  *****互动科技有限公司
-- 创建人:	
-- 日  期:	2019-9-21 23:24
-- 版  本:	1.0
-- 描  述:	挂机的操作
-- 应  用:  
---------------------------------------------------------------------------------------
roleAttConTrol = class("roleAttConTrol")
roleAttConTrol.__index = roleAttConTrol

local attlisenerItems = {}
--注册
function roleAttConTrol:registerAttLisener(attID,wndID,item)	
	if not attlisenerItems[attID] then
		attlisenerItems[attID] = {}
	end 
	if not attlisenerItems[attID][wndID] then
		attlisenerItems[attID][wndID] = {}
	end 
	local count = #attlisenerItems[attID][wndID]
	attlisenerItems[attID][wndID][count+1] = item
	self:setAttItemByChangeNumber(attID,item)
end 

--取消注册
function roleAttConTrol:delRegisterAttLisener(curWndID)
	for attID,tbMsg in pairs(attlisenerItems)do
		for wndId ,tbMsg2 in pairs(attlisenerItems)do
			if curWndID == wndId then
				attlisenerItems[attID][wndID] = nil
			end 
		end 
	end 
end 
function roleAttConTrol:setAttItemByChangeNumber(attID,item,value,strLDEndCN)
	local valueEnd,strLCN
	if not value then
		valueEnd,strLCN = g_roleMsg:getRoleAttValue(attID,nil,true)
		cclog(valueEnd,strLCN,"=======setAttItemByChangeNumber===",attID)
	else
		valueEnd = value
		strLCN = strLDEndCN
	end 
	
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D",attID)
	cclog(valueEnd,strLCN,"=======setAttItemByChangeNumber===",attID)
	if attMsgD.isDanwen == 1 then
		item:setVar("number",tostring(strLCN)) 
		item:flushVars()
	elseif attMsgD.isDanwen == 0 then
		if attID == 17 then
			local valueEnd1 = g_batMath:mathSpeed(valueEnd,nType) 
			item:setVar("number1",tostring(valueEnd1)) 
		end 
		item:setVar("number",tostring(valueEnd)) 
		item:flushVars()
	end 
end 

--有数值改变时  查看监听的控件
function roleAttConTrol:attItemByChangeNumber(attID)
	if not attlisenerItems[attID] then
		
		return
	end 
	--主属性时，还会改变其他
	local othorAtt = {[1] = {11,12},[2] = {19,20},[3] = {13,14},[4] = {15,12,14}, [5] = {47,48},[6] = {33,17},}
	if   attID <= 7  then
		for i,id in ipairs(othorAtt[attID])do
			self:attItemByChangeNumber(id)
		end
	end 

	local valueEnd,strLDEndCN = g_roleMsg:getRoleAttValue(attID)
	for wnd,wndItemMsg in pairs(attlisenerItems[attID])do
		local wndD = g_WndMgr:getWnd(wnd)
		if wndD then	
			for i,item in pairs(wndItemMsg)do
				--self:setAttItemByChangeNumber(attID,item,valueEnd,strLDEndCN)
			end 
		end 	
	end 
	
end 

---============================Func==================================
local attlisenerFuncs = {}
--注册
function roleAttConTrol:registerAttLisenerFunc(attID,wndID,Func)	
	if not attlisenerFuncs[attID] then
		attlisenerFuncs[attID] = {}
	end 
	if not attlisenerFuncs[attID][wndID] then
		attlisenerFuncs[attID][wndID] = {}
	end 
	local count = #attlisenerFuncs[attID][wndID]
	attlisenerFuncs[attID][wndID][count+1] = Func
end 

--有数值改变时  查看监听的Func
function roleAttConTrol:attFuncmByChangeNumber(attID)	
	if not attlisenerFuncs[attID] then
		return
	end 
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D",attID)
	local value = g_roleMsg:getRoleAttValue(attID)
	for wnd,func in pairs(attlisenerFuncs)do
		local wnd = g_WndMgr:getWnd(wnd)
		if wnd then	
			if func then
				func(attID)
			end 
		end 	
	end 
end 


-------=================================================
function roleAttConTrol:getRoleNeedExp()
	local level = g_roleMsg:getRoleAttValue(RoleAttMsg.level,true)
	local needExp = (level + 100) *level 
	return needExp
end 

function roleAttConTrol:getRoleMaxJinHua()
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	local MaxJinHua =  tbGameConst.baseMaxJinjie + (zslevel) * tbGameConst.addJinjie
	return MaxJinHua
end 

function roleAttConTrol:getMaxLev(jinhua)
	local jinhua = jinhua or g_roleMsg:getRoleAttValue(RoleAttMsg.jinhua,true) or 0
	
	local maxLev = (jinhua+1)*tbGameConst.addMaxLev
	--cclog(maxLev,jinhua,"====getMaxLev======",tbGameConst.addMaxLev)
	return maxLev
end 

function roleAttConTrol:mathZuansNeedLev()
	local MaxJinHua =  self:getRoleMaxJinHua()
	local maxLev = (MaxJinHua+1)*tbGameConst.addMaxLev
	--cclog(maxLev,"=====mathZuansNeedLev====",MaxJinHua,tbGameConst.addMaxLev)
	return maxLev
end 

function roleAttConTrol:getZizhi()
	local jinhua = g_roleMsg:getRoleAttValue(RoleAttMsg.jinhua,true)
	
	local BOSSID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local bianyi = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSIDBianyi) or 0
	local tbMsg = g_cfgMsg:getCfgMsg("role_D",BOSSID)
	local addzz =   g_roleMsg:getRoleAttValue(RoleAttMsg.zizhi)  or 0
	local baseZz = tbMsg.nSort
	if bianyi then
		baseZz = tbMsg.nSortMax
	end 
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	local Zizhi = baseZz + jinhua* tbGameConst.addzizhi + addzz
	
	return Zizhi
end 
function roleAttConTrol:getBossName()
	local BOSSID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	local jinhua = g_roleMsg:getRoleAttValue(RoleAttMsg.jinhua,true)

	if tbMsg.openType <= -1 then
		g_svSendMsgControl:request_geBatMsg(6)
	end 

	local iconname = tbMsg.icon
	local baseName = tbMsg.name
	
	local name,yanse
	if jinhua > 0  then
		local tbJHMsg =  g_cfgMsg:getCfgMsg("roleJinJieLev_D",jinhua)
		local jjName = tbJHMsg.name
		yanse = tbJHMsg.nType
		name = jjName.."·"..baseName 
		--cclog(yanse,name,"====222=getBossName========",jinhua)
	else
		name = baseName
		yanse = 1
	end 
	if yanse > 7  then
		yanse = 7
	end 
	local colorID = G_tb_TextColor[yanse]
	--cclog(name,colorID,iconname,"=====11====baseName=====",jinhua)
	return name,colorID,iconname,yanse
end 

function roleAttConTrol:getFubenName()
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}	
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}	
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1

	local curMapLev = fubenCurLev[mapType] or 1
	local curMap = fubenCurLev[mapType] or 1
	
	local tbMsg =  g_cfgMsg:getCfgMsg("map_D",mapType)
	--cclog(curMap,curMapLev,mapType,"====getFubenName========",fubenMaxLev,fubenCurLev)
	local strName = string.format("%s[%d]层",tbMsg.name,curMapLev)
	return strName,tbMsg.name
end 


-- ctor() 是类的构造函数，在调用 roleAttConTrol.new() 创建 roleAttConTrol 对象实例时会自动执行  
function roleAttConTrol:ctor()	
	
end
function roleAttConTrol:init()
	
end
g_roleAttConTrol =  roleAttConTrol:create()