------------------
-- 文件名:	baseMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	制作数据
-- 应  用:  
-------------------
local baseMsg = class("baseMsg")

local tbInteger = {}
local other = {}
local tbbaseMsg = {}


function baseMsg:setTbInteger(tbValue)
	tbInteger = tbValue
end
function baseMsg:getTbIntegerTb(id)
	return tbInteger[id]
end


function baseMsg:setTbIntegerByID(id,tbValue)
	
	tbInteger[id] = tbValue
end

function baseMsg:getTbInteger(id)
	 
	if tbInteger[id] then
		return tbInteger[id].value
	end 
	
	return  
end
---===============================================================
local otherStrDBMsg = {}

function baseMsg:setOtherStr(tbValue)
	otherStrDBMsg = tbValue
end
function baseMsg:setOtherStrByID(id,value)
	otherStrDBMsg[id] = {id = id, value =value }
	
end
function baseMsg:getOtherStr(id)
	if otherStrDBMsg[id] then
		--cclog(otherStrDBMsg[id] ,"===getOtherStr======",id)
		if not otherStrDBMsg[id] then
			return
		end 
		return otherStrDBMsg[id].value
	end 
	return 
end


function baseMsg:saveToOtherStr(id,value)
--	cclog(otherStrDBMsgID.baokuValue3,"=saveToOtherStr===",id,value)
	if id <= otherStrDBMsgID.baokuValue3   then
	
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		if B_FbBat then
			B_FbBat:initWndMsg()
		end 	
	end 
	
end 
---=============================================

function baseMsg:setOther(tbValue)
	other = tbValue
end
function baseMsg:setOtherByID(id,value)
	other[id] = {id = id, value =value }
end
function baseMsg:getOther(id)
	if other[id] then
		if not other[id] then
			return
		end 
		return other[id].value
	end 
	return 
end

function baseMsg:saveToOther(id,value)
	if id == otherDBMsgID.xinshouLib  then
		local ComponentCzhixinshou = g_panleMgr:getPannelwd("ComponentCzhixinshou")
		if ComponentCzhixinshou then
			ComponentCzhixinshou:setBtn()
		end 	
	end 
	
end 

function baseMsg:setOtherValue(id,value,add)
	if not id then
		return 
	end 
	if other[id] then
		if not other[id].value  then
			other[id].value = 0
		end 
		if add then
			other[id].value = other[id].value + value
		else
			other[id].value = value
		end
		if not value then
			other[id] = nil
		end 
	else
		other[id] = {id = id ,value = value}
	end 
	--cclog(other[id],"==setOtherValue===11==",id,value)
	if value then
		self:saveToOther(id,other[id].value )
	end 
	
	return 
end

function baseMsg:setResOfID(id,value)
	tbbaseMsg[id] = value
	return  tbbaseMsg[id] 
end
function baseMsg:getResOfID(id)
	cclog(tbbaseMsg,"=======getResOfID==",id)
	return  tbbaseMsg[id] 
	
end


function baseMsg:getResOfVipJifen()
	local resValue = tonumber(self:getResOfID(g_resCfgId.jifen)) or 0
	return  resValue
end

function baseMsg:getResOfVipLev(shengwangD)
	local shengwang = shengwangD or self:getResOfVipJifen() or 0
	
	local cfgMsg2 =  g_cfgMsg:getCfgMsg("VIPLev_D") 
	local lev = 0
	local curExp = 0
	local maxExp = 0
	for i,v in ipairs(cfgMsg2)do
		local need = v.getMathExp
		maxExp = v.getMathExp
		if shengwang >= need  then
			lev = i
			--curExp =  jifen - need
		else
			break
		end 
	end 
	cclog("======ev,shengwang,maxExp====",lev,shengwang,maxExp,shengwangD)
	return  lev,shengwang,maxExp
end

function baseMsg:getRes()
	return tbbaseMsg[g_resCfgId.coin]
end
function baseMsg:setRes(value)
	tbbaseMsg[g_resCfgId.coin] = value
end
function baseMsg:setllianExp(value)
	tbbaseMsg[g_resCfgId.nLilianExp] = value
end
function baseMsg:getllianExp()
	return tbbaseMsg[g_resCfgId.nLilianExp]
end


function baseMsg:getLev()
	local maxMap = g_mapMsg:getOpenMaxMapKey()
	return maxMap
end

function baseMsg:initOther()
	for id,v in pairs(other)do
		self:saveToOther(id,other[id].value )
	end 
end

function baseMsg:ctor()
	tbbaseMsg[g_resCfgId.coin]  = 0
	tbbaseMsg[g_resCfgId.diamond]  = 0
	----tbbaseMsg[g_resCfgId.energy]  = 0
	tbbaseMsg[g_resCfgId.nExp]  = 0
end

g_baseMsg =  baseMsg:create()