------------------
-- 文件名:	dalitInfoMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	制作数据
-- 应  用:  
-------------------
local dalitInfoMsg = class("dalitInfoMsg")

local dalitInfoTbMsg = { 
	-- dalitInfoInfo
}

function dalitInfoMsg:getdalitInfoTbMsg(dalitInfoID)
	if dalitInfoID  then
		local tbsmg = dalitInfoTbMsg[dalitInfoID] 
		return tbsmg
	end 
	return dalitInfoTbMsg
end

function dalitInfoMsg:setdalitInfoTbMsg(info)  
	dalitInfoTbMsg[info.id] = info
end
function dalitInfoMsg:setdalitInfoTbMsgAll(info)   
	if not info then
		return
	end 
	dalitInfoTbMsg = info
end

---======================================================
---计算每日任务等级
function dalitInfoMsg:mathDalitLev(daliyExp)   
	local daliyExp = daliyExp or g_baseMsg:getOther(otherDBMsgID.daliyExp) or 0
	local cfgMsg =  g_cfgMsg:getCfgMsg("lilianLev_D") 
	local expOne,lastExp = 0,0
	local lev = 0
	
	local tbAtt = {}
	local addVip =  g_viplevMsg:getVipValue(13) or 0
		cclog(daliyExp,"=====expOne==222===",addVip)
	
	for i,v in ipairs(cfgMsg)do
		if  daliyExp >= v.getSumExp then
			lev = i
			expOne = v.getSumExp
			if not  tbAtt[v.attID] then
				tbAtt[v.attID] = 0
			end 
			local  value = math.floor(v.value + addVip)
			cclog(v.value,"===mathDalitLev========",addVip)
			tbAtt[v.attID] = tbAtt[v.attID] + value
			lastExp = daliyExp - expOne
		else
			lastExp = daliyExp - expOne
			expOne = v.getSumExp - expOne
			--cclog(expOne,v.getSumExp,daliyExp,lastExp,"=====expOne=====")
			break
		end 
	end 
	
	for i,v in ipairs(tbAtt)do
		local addVa = g_tianfuConTrol:getTianfuOpenValue(29) 
		tbAtt[i] = tbAtt[i] *(1+addVa/100)
		cclog(tbAtt,addVa,"===getTianfuOpenValue=====",i)
	end 
	
	return lev ,expOne,lastExp , tbAtt
	 
end

---计算每日任务最大等级
function dalitInfoMsg:mathDalitMaxLev() 
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	
	local result = 100 + tbGameConst.dalitMaxLev*zslevel
	if result > g_MAXDalitlev  then
		result = g_MAXDalitlev
	end 
	return result
end 



----========================================================================================

local chengjiuInfoTbMsg = { 
	-- dalitInfoInfo
}

function dalitInfoMsg:getchengjiuTbMsg(InfoID)
	if InfoID  then
		local tbsmg = chengjiuInfoTbMsg[InfoID] 
		return tbsmg
	end 
	return chengjiuInfoTbMsg
end

function dalitInfoMsg:setchengjiuTbMsg(info)  
	chengjiuInfoTbMsg[info.id] = info
end
function dalitInfoMsg:setchengjiuTbMsgAll(info)   
	if not info then
		return
	end 
	chengjiuInfoTbMsg = info
end


function dalitInfoMsg:ctor()

end

g_dalitInfoMsg =  dalitInfoMsg:create()