------------------
-- 文件名:	daoyuMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	酒馆数据
-- 应  用:  
-------------------
local daoyuMsg = class("daoyuMsg")



local tbDaoyuMsg ={
	---[1] = mailInfo
}

function daoyuMsg:getTbDaoyuMsg(id)
	if id then
		return  tbDaoyuMsg[id]
	end 
	return tbDaoyuMsg
end
function daoyuMsg:setTbDaoyuMsg(info)
	tbDaoyuMsg[info.id] = info
end

function daoyuMsg:setTbDaoyuMsgAll(info)
	tbDaoyuMsg = info
end

---===========================================

local tbOldDaoyuMsg ={
	---[1] = mailInfo
}
function daoyuMsg:getTbOldDaoyuMsg(id)
	if id then
		return  tbOldDaoyuMsg[id]
	end 
	return tbOldDaoyuMsg
end
function daoyuMsg:setTbOldDaoyuMsg(info)
	tbOldDaoyuMsg[info.id] = info
end

function daoyuMsg:setTbOldDaoyuMsgAll(info)	
	cclog(info,"====setTbOldDaoyuMsgAll====")
	self.sortTbOldDaoyuMsg = {}
	tbOldDaoyuMsg = info
end

function daoyuMsg:getSortTbOldDaoyuMsg()
	cclog(self.sortTbOldDaoyuMsg,"====getSortTbOldDaoyuMsg==2==")
	return self.sortTbOldDaoyuMsg
end

function daoyuMsg:mathSortTbOldDaoyuMsg()
	cclog(tbOldDaoyuMsg,"=====mathSortTbOldDaoyuMsg=====")
	for i,v in pairs(tbOldDaoyuMsg)do
		self.sortTbOldDaoyuMsg[#self.sortTbOldDaoyuMsg + 1] = v 
	end 
	
	local function comps(a,b)
		if a.nTime == b.nTime then
			return a.id > b.id
		else
			return a.nTime > b.nTime
		end 
	end
	table.sort(self.sortTbOldDaoyuMsg,comps)
	return self.sortTbOldDaoyuMsg
end

----

function daoyuMsg:daoyuDrop(dyID,nTime)

	local info = g_daoyuMsg:getTbDaoyuMsg(dyID) or {}
	local dyType = 	 math.floor( dyID/100000)
	local cfgID = info.cfgID
	if nTime  > 3600*24  then
		nTime = 3600*24
	end 
	if nTime < 0 then	
		nTime = 0
	end 
	
	local str
	cclog(dyType,info,"====daoyuDrop=======",dyID,cfgID,nTime)
	if dyType == 1 then 
		str = self:daoyuBatDropPey(cfgID,nTime)
	elseif dyType == 2 then
		str = self:daoyuBatDropEqu(cfgID,nTime)
	elseif dyType == 3 then
		str = self:daoyuBatDropTiao(nTime)
	elseif dyType == 4 then
		str = self:daoyuBatDropDaijin(nTime)
	end 
	
	return str
end 


function daoyuMsg:daoyuBatDropTiao(nTime)
	local nTimesp = math.floor( nTime/1200) --最多48
	local  DaoyuReward =  g_taskConTrol:getTaskFinishNum(g_TaskStatisticsType.Daily_DaoyuReward,3) or 0
	if DaoyuReward >= 20  then ---tbGameConst.daoyumaxNumTT  
		return "跳过卷0"
	end 
	local lestNUm = (tbGameConst.daoyumaxNumTT - DaoyuReward )
	if nTimesp > lestNUm then
		nTimesp = lestNUm
	end 
	local str = "跳过卷"..nTimesp
	return str
end 

function daoyuMsg:daoyuBatDropDaijin(nTime)
	local nTimesp = math.floor( nTime/1200) --最多48
	local  DaoyuReward =  g_taskConTrol:getTaskFinishNum(g_TaskStatisticsType.Daily_DaoyuReward,4) or 0
	if DaoyuReward >= 20 then --tbGameConst.daoyumaxNumDj  
		return "代金卷0"
	end 
	local lestNUm = (tbGameConst.daoyumaxNumDj - DaoyuReward )
	if nTimesp > lestNUm then
		nTimesp = lestNUm
	end 

	local str = "代金卷"..nTimesp
	return str
end 

function daoyuMsg:daoyuBatDropPey(cfgID,nTime)
	local cfgMsg =  g_cfgMsg:getCfgMsg("daoyu_D",cfgID)
	local nTimes = math.floor( nTime/100) --最多288 
	local nTimesp = math.floor( nTime/900) --最多48
	local nTimecw = math.floor( nTime/1800) --最多24
	local num = nTimes*(30 + cfgMsg.ration) 
	local tbMSg = {}
	local str = "材料"..num
	
	if nTimesp > 50	  then
		nTimesp = 50
	end 
	
	str = str.."|红色碎片"..nTimesp
	if nTimecw > 10	  then
		nTimecw = 10
	end 
	str = str.."|宠物"..nTimecw
	
	return str
	
end 

function daoyuMsg:daoyuBatDropEqu(cfgID,nTime)

	local cfgMsg =  g_cfgMsg:getCfgMsg("daoyu_D",cfgID)
	local nTimes = math.floor( nTime/100) --最多288 
	local nTimesp = math.floor( nTime/900) --最多48
	local nTimecw = math.floor( nTime/1800) --最多24
	local num = nTimes*(30 + cfgMsg.ration) 
	local tbMSg = {}
	num = num 

	if nTimesp > 50	  then
		nTimesp = 50
	end 
	local str = "材料"..num
	str = str.."|红色碎片"..nTimesp
	if nTimecw > 10	  then
		nTimecw = 10
	end 
	str = str.."|装备"..nTimecw
	return str
	
end 


function daoyuMsg:MathqiangduoNUm()	
	local num = tbGameConst.maxDQNum or 10
	return num
end 

function daoyuMsg:ctor()
	self.sortTbOldDaoyuMsg = {}
end

g_daoyuMsg =  daoyuMsg:create()