------------------
-- 文件名:	lyInfoMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	制作数据
-- 应  用:  
-------------------
local lyInfoMsg = class("lyInfoMsg")

local lyInfoTbMsg = {}
function lyInfoMsg:getTbMsg(ID)
	if ID  then
		local tbsmg = lyInfoTbMsg[ID] 
		return tbsmg
	end 
	return lyInfoTbMsg
end

function lyInfoMsg:setTbMsg(info)  
	lyInfoTbMsg[info.id] = info
end

function lyInfoMsg:setTbMsgAll(info)   
	if not info then
		return
	end 
	lyInfoTbMsg = info
end


--============================================================
function lyInfoMsg:mathExpAndlev(ID)  
	local info =  lyInfoTbMsg[ID] or {}
	local nExp = info.nExp or 0
	cclog(info,"======mathExpAndlev===")
	if nExp <= 0 then
		return 0,0,1030
	end 
	local cfgMsg =  g_cfgMsg:getCfgMsg("lingyuLev_D") 
	local lev = 0
	local maxExp = 117120
	for i,v in ipairs(cfgMsg)do
		if nExp >= v.getExp then
			nExp = nExp - v.getExp
			lev = i
		else
			maxExp = v.getExp
			break
		end 
	end 
	if lev > 48 then
		lev = 48
	end 
	cclog(lev,nExp,maxExp,"==222====mathExpAndlev===")
	return lev,nExp,maxExp
end 

function lyInfoMsg:mathAttValue(cfgID,lev,yanse) 
	local cfgMsg =  g_cfgMsg:getCfgMsg("lingyu_D",cfgID) 
	if yanse < 1 then
		yanse = 1
	end 
	local Value = cfgMsg.baseValue + (cfgMsg.addValue + (cfgMsg.addValue2*(yanse-1)) ) * lev 
	return Value
end 

function lyInfoMsg:mathZhongzhuValue2(cIndex) 
	local qhValye = self:mathQiheValue(cIndex) 
	local yanse  = self:mathZhongzhuYanse(qhValye) 
	local value = self:mathZhongzhuValue(cIndex,yanse) 
	return value
end 

function lyInfoMsg:mathZhongzhuValue(cfgID,yanse) 
	local cfgMsg =  g_cfgMsg:getCfgMsg("lingyuLev_D",cfgID) 
	local Value = cfgMsg.baseValue + cfgMsg.addValue * yanse
	return Value
end 

function lyInfoMsg:mathZhongzhuYanse(qhValye) 
	local tbMsg = {20,40,60,80,100,120}
	local yanse = 0
	for i,v in ipairs(tbMsg)do
		if qhValye < v then
			
		else
			yanse = i
		end 
	end 
	
	return yanse
end 

function lyInfoMsg:mathQiheValue(cIndex) 
	local value = 0
	for index=1,8 do
		local ID = cIndex*100 + index
		local info =  lyInfoTbMsg[ID] or {}
		local yanse = info.yanse or 0
		if yanse > 0   then	
			local cfgMsg =  g_cfgMsg:getCfgMsg("lingyuLev_D",yanse) 
			value = value + cfgMsg.addValue
			--cclog(value,cfgMsg.addValue,"====qhValye========DD========",yanse)
		end 
	end 
	return value
end 

function lyInfoMsg:mathCLValue(index) 
	---获得经验
	if not self.LyTunshiCL then
		local tbMsg = g_cfgMsg:getCfgMsg("zz_game_D",45)
		
		self.LyTunshiCL  = cc.g_inalienContentByCfgMsg(tbMsg.value,1,"_") 
		
		local tbMsg = g_cfgMsg:getCfgMsg("zz_game_D",46)
		self.LyTunshiCLRation  = cc.g_inalienContentByCfgMsg(tbMsg.value,1,"_") 
	end 
	local goodsID = self.LyTunshiCL[index]
	local num = self.LyTunshiCLRation[index]
	num = 5000*num
	return goodsID,num
end 

----计算属性
function lyInfoMsg:mathZhongzhuValueAtt(zzhuType,attCfgID)
	local value = 0
	for index=1,8 do
		local ID = (zzhuType-1)*100 + index
		
		local info =  lyInfoTbMsg[ID] or {}
		local yanse = info.yanse or 0
		local  cfgID = info.cfgID 
		--cclog(ID,yanse,cfgID,"=======mathZhongzhuValueAtt========",zzhuType,attCfgID)
		if yanse > 0   then	
			
			if attCfgID == cfgID then
				local lev = self:mathExpAndlev(ID)  
				local  addValue = self:mathAttValue(cfgID,lev,yanse) 
				value = value + addValue
				---cclog(ID,value,addValue,lev,yanse,"=======mathZhongzhuValueAtt===222=====",zzhuType,attCfgID)
			end 
		end 
	end 
	return value
end 



function lyInfoMsg:ctor()

end

g_lyInfoMsg =  lyInfoMsg:create()