------------------
-- 文件名:	roleMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	制作数据
-- 应  用:  
-------------------
local roleMsg = class("roleMsg")

local roleBaseInfoTbMsg = {}
local tbSkillID = {}
local tbZbID = {}
function roleMsg:getRoleBaseInfoTbMsg(id)
	if id  then
		local tbsmg = roleBaseInfoTbMsg[id] or {}
		return tbsmg.value
	end 
	return roleBaseInfoTbMsg
end
function roleMsg:setRoleBaseInfoTbMsg(info)  
	if not info then
		return
	end
	roleBaseInfoTbMsg = info
end
function roleMsg:setRoleBaseInfoTbMsgOne(info)  
	roleBaseInfoTbMsg[info.id] = info
end
---================================================  {id = 1,value1 = 95001001,value2 = 1} ====getTbSkillID===222= 1
function roleMsg:getTbSkillID(id)
	cclog(tbSkillID,"====getTbSkillID====",id)
	if id  then
		local tbsmg = tbSkillID[id] or {}
		local SkillID = tbsmg.value1 or 0
		local SkillLev = tbsmg.value2 or 0
		cclog(tbsmg,"====getTbSkillID===222=",id,SkillID,SkillLev)
		
		return SkillID,SkillLev
	else
		return tbSkillID
	end 
	
end
function roleMsg:setTbSkillIDAll(info) 
	if not info then
		return
	end
	tbSkillID = info
end
function roleMsg:setTbSkillIDAllOne(info)  
	tbSkillID[info.id] = info
end

--===========================
function roleMsg:getTbZbID(index)
	if index  then
		local value = tbZbID[index] or  0
		return  value
	end 
	return tbZbID
end

function roleMsg:setTbZbIDOne(index,value)  
	tbZbID[index] = value
end
function roleMsg:setTbZbIDAll(info)  
	if not info then
		return
	end
	tbZbID = info
end

local roleTbMsg = {}
function roleMsg:getRoleTbMsg(id)
	if id  then
		local tbsmg = roleTbMsg[id] or 0
		return tbsmg
	end 
	return roleTbMsg
end

function roleMsg:setRoleTbMsgOne(info)  ---value 是string类型
   
	roleTbMsg[info.id] = info.value
end

function roleMsg:addRoleTbMsgOne(id,strValue)  ---string类型
	if not roleTbMsg[id] then
		roleTbMsg[id] = "0"
	end 
	roleTbMsg[id] = addBigInt(roleTbMsg[id], strValue)
end

local roleChangeAttTbMsg = {}
local oldAttMsg = {}
function roleMsg:cleanChangeAttTbMsg()  ---value 是string类型
	roleChangeAttTbMsg = {}
	oldAttMsg = {}
	for i,v in pairs(roleTbMsg)do
		oldAttMsg[i] = v
	end 
end

function roleMsg:ChangeAttTbMsg()  ---value 是string类型
	for key,v in pairs(roleTbMsg)do
		if v ~= oldAttMsg[key] then 
			local attID = self:getAttKey(key)
			roleChangeAttTbMsg[attID] = 1
		end 
	end 
	for attID,v in pairs(roleChangeAttTbMsg)do
		g_roleAttConTrol:attItemByChangeNumber(attID)	
	end 
end
----========================================================================
RoleAttMsg = {}
RoleAttMsg.liliang = 1
RoleAttMsg.minjie = 2
RoleAttMsg.zhihui = 3
RoleAttMsg.tizhi = 4
RoleAttMsg.xinyun = 5
RoleAttMsg.xuemai = 6

RoleAttMsg.wlDps  = 11
RoleAttMsg.wlDef = 12
RoleAttMsg.mfDps = 13
RoleAttMsg.mfDef = 14
RoleAttMsg.hp = 15
RoleAttMsg.mp = 16
RoleAttMsg.speed = 17
RoleAttMsg.jingzun = 18
RoleAttMsg.baoji = 19
RoleAttMsg.shanbi = 20

RoleAttMsg.baojiHurt = 21
RoleAttMsg.attckNum = 22

RoleAttMsg.fantan  = 30
RoleAttMsg.chuanjia = 31
RoleAttMsg.fashang = 32
RoleAttMsg.tongshuai = 33
RoleAttMsg.hyHurt = 34
RoleAttMsg.bsHurt = 35
RoleAttMsg.ldHurt = 36
RoleAttMsg.jdHurt = 37
RoleAttMsg.hyKang = 38
RoleAttMsg.bsKang = 39
RoleAttMsg.ldKang = 40
RoleAttMsg.jdKang = 41

RoleAttMsg.kangyun = 42
RoleAttMsg.chouhen = 43
RoleAttMsg.xiHp = 44
RoleAttMsg.xiMp = 45

RoleAttMsg.jngl = 46
RoleAttMsg.addCoin = 47
RoleAttMsg.addExp = 48

RoleAttMsg.zizhi = 63

RoleAttMsg.addHpOne = 69
RoleAttMsg.addMpOne = 70

RoleAttMsg.level = 200
RoleAttMsg.jinhua = 201
RoleAttMsg.zhuansheng = 202
RoleAttMsg.exp = 203

--[[
	
	public const int Base = Speed * 1000 + 1;
	public const int Add = Speed * 1000 + 2;   数值   一般装备系统类  
	public const int Pct = Speed * 1000 + 3;  百分比  一般装备系统类  
	
	
	一个值可以由3个值进行控制其最终结果 
	final = (base + add) * (100 + pct) / 100 ;
]]
	

function roleMsg:getAttKey(key)
	if key < 1000 then
		return key
	end 
	key = math.floor(key/100)
	return key
end

function roleMsg:getAttBaseKey(attID)
	return attID*1000 + 1
end
function roleMsg:getAttADDKey(attID)
	return attID*1000 + 2
end
function roleMsg:getAttPctKey(attID)
	return attID*1000 + 3
end

function roleMsg:getAttValue(key)
	return  roleTbMsg[key] 
end


function roleMsg:cleanRoleAttValue(attID)
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D",attID)
	local key 
	if attMsgD.attType == 1 then
		key = self:getAttBaseKey(attID)
		
	elseif attMsgD.attType == 2 then
		key = self:getAttADDKey(attID)
	elseif attMsgD.attType == 3 then
		key = self:getAttPctKey(attID)
	else
		key = attID
	end 
	roleTbMsg[key] = nil
end  

function roleMsg:addRoleAttValue(attID,value)
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D",attID)
	local key 
	if not attMsgD then
		return
	end 
	if attMsgD.attType == 1 then
		key = self:getAttBaseKey(attID)
		
	elseif attMsgD.attType == 2 then
		key = self:getAttADDKey(attID)
	elseif attMsgD.attType == 3 then
		
		key = self:getAttPctKey(attID)
	else
		key = attID
	end 
	self:addRoleTbMsgOne(key,value)
end

function roleMsg:getRoleAttValue(AttID,isNumber,isFloor,logd)
	AttID = self:getAttKey(AttID)
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D",AttID)
	if attMsgD.isMath ~= 1 then
		local value = self:getRoleTbMsg(AttID)
		
		if isNumber then
			value = tonumber(value)
		end 
		
		return value,value
	end 

	local value = self:getRoleTbMsg(AttID) or "0"
	
	local baseKey = self:getAttBaseKey(AttID)
	local addKey  = self:getAttADDKey(AttID)
	local pctKey  = self:getAttPctKey(AttID)
	
	local base = self:getAttValue(baseKey) or "0"
	local add  = self:getAttValue(addKey) or "0"
	local pct  = self:getAttValue(pctKey) or "0" 
	pct = 1+tostring(tonumber(pct)/100)
	
	local  final0 = addBigInt(value, base)
	local  final1 = addBigInt(final0, add)

	local final,strLDEndCN =  byBigInt(final1, pct,isFloor) ;
	if logd then
		cclog(AttID,baseKey,"=======11111===",value, base)
		cclog(addKey,"=====22==",value, add)
		cclog(pctKey,"======33==",value, pct)
		cclog(AttID,final,strLDEndCN,final1,final0,value,"========getRoleAttValue=============",base,pct,add)
	end 
	--
	if isNumber then
		final = tonumber(final)
	end 
	if AttID == 48  then
		local curMapLev,maxMapLev = g_batMath:getMapLev(1) 
		--final = math.floor( final/maxMapLev)
		---cclog(final,"=======getAddCLXY===11===",maxMapLev,AttID)
	elseif AttID == RoleAttMsg.baojiHurt then
	 
		final = 150 + final
	end 

	return final,strLDEndCN
end


----------------------------计算Role属性----------------------------------------------------

function roleMsg:mathBaseAttMsg()
	--local tbMsg =  g_cfgMsg:getCfgMsg("att_D")
	local BOSSID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbRoleMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	for key=1,6 do		
		local value = g_mathConTrol:mathMainAtt(key)
		self:addRoleAttValue(key,value)
		cclog("===mathBaseAttMsg====DDD====00=====",key,value)
	end 
	local value = tbRoleMsg.attckNum
	self:addRoleAttValue(22,value)
	local value = tbRoleMsg.speed
	self:addRoleAttValue(17,value)
	
	local tbMsg =  g_cfgMsg:getCfgMsg("att_D")
	for key,v in ipairs(tbMsg)do
		if v.isMath == 1 and v.baseValue > 0 then
			self:addRoleAttValue(key,v.baseValue)
		end 
	end 
	
	self:addRoleAttValue(16,10)
	self:addRoleAttValue(18,70)
	
	local level = g_roleMsg:getRoleAttValue(RoleAttMsg.level,true)
	--  --计算回血和回魔
	self:addRoleAttValue(RoleAttMsg.addHpOne,level)
	--回魔在下面技能那
	--仇恨
	local zizhi = roleAttConTrol:getZizhi()
	cclog("==mathBaseAttMsg====22=DD==111==",zizhi,RoleAttMsg.addHpOne,level)
	if zizhi <= 0 then
		zizhi = 0
	end 
	local chouhen = (40 + zizhi ) *level
	cclog("==mathBaseAttMsg===33==DD=",chouhen,level)
	self:addRoleAttValue(RoleAttMsg.chouhen,chouhen)
end 

function roleMsg:mathRoleEquAttMsgOne(Info)
	--主属性
	local name,yanse,tbEquMsg = g_getNameConTrol:getAllMsg(Info.cfgID)
	for i=1,2 do 
		local attLev = Info.mainAttLev[i]
		local attID = tbEquMsg["attID"..i]
		local ration = g_mathConTrol:mathEquMaintAttRation(attLev,Info.cfgID,i,Info.yanse)
		local value = g_mathConTrol:mathEquMaintAtt(Info.zbLev,Info.cfgID,attID,ration)
		self:addRoleAttValue(attID,value)
	end
	--副属性
	if  Info.QHAttLev then
		for i=1,7 do
			local attID = Info.QHAttID[i] or 0
			--cclog(attID,"=====attID=====")
			if  attID > 0 then
				local QHAttLev = Info.QHAttLev[i] or 0
				local ration = g_mathConTrol:mathEquCecAttRaton(QHAttLev,Info.cfgID)
				local value = g_mathConTrol:mathEquCecAtt(Info.zbLev,Info.cfgID,attID,ration)
				--cclog("======addRoleAttValue=====",attID,value)
				self:addRoleAttValue(attID,value)
			end 
		end 
	end 
	---符文
	if  Info.runeMsg then
		for i=1,6 do
			local FWID = Info.runeMsg[i] or 0
			--cclog(FWID,"=====FWID=========",Info.runeMsg,i)
			if FWID > 0   then
				local name,yanse,tbMsg,baseName = g_getNameConTrol:getAllMsg(FWID)
				local attID = tbMsg.attID
				local value =  g_mathConTrol:mathFWValue(FWID)
				--cclog(value,attID,"===222==FWID=========",FWID)
				self:addRoleAttValue(attID,value)
			end 
		end 
	end
	
end


function roleMsg:mathRoleEquAttMsg()
	self.tbTaozMsg = {}
	self.tbTaozMsgSkill = {}
	self.tbTaozMsgOpen = {}
	for index=1,9 do
		local zbID = self:getTbZbID(index) or 0
		if zbID > 0 then
			local zbInfo = g_zbMsg:getEuqTbMsg(zbID)
			if zbInfo  then
				self:mathRoleEquAttMsgOne(zbInfo)
				local nType = g_getTypeByCfgID(zbInfo.cfgID)
				if nType == g_cfgType.equT then
					local  tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D",zbInfo.cfgID)
					if not self.tbTaozMsg[tbMsg.nTaozhuangType] then
						self.tbTaozMsg[tbMsg.nTaozhuangType] = 0
					end 
					self.tbTaozMsg[tbMsg.nTaozhuangType] = self.tbTaozMsg[tbMsg.nTaozhuangType] + 1
				
					self.tbTaozMsgSkill[tbMsg.nTaozhuangType] = tbMsg.taoSkill
				end 
			else
				self:setTbZbIDOne(index,0)  
			end 	
		end
	end 
	--套装
	for nType,num in pairs(self.tbTaozMsg)do
		local taoSkill = self.tbTaozMsgSkill[nType] 
		local  tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiSkill_D",taoSkill)
		for i=1,3 do
			local open_num = tbMsg["open_num"..i] or 0
			if open_num > 0 and num >= open_num then
				self.tbTaozMsgOpen[nType] = i
				local value = tbMsg["value"..i]
				self:addRoleAttValue(tbMsg.attID,value)
				
				local value1 = self:getRoleAttValue(5,isNumber,isFloor,true)
				
				local attMsgD =  g_cfgMsg:getCfgMsg("att_D",attID)
				if attMsgD.isCwu and attMsgD.isCwu >= 1 then
					g_petMsg:addTbPetAddAttMsg(attMsgD.isCwu,value)
				end 
			end 	
		end 
		
	end 
end 

function roleMsg:mathRoleSkillAttMsgOne(indexD,skillID)
	local lev = g_roleSkillMsg:getroleSkillTbMsgLev(indexD) 

	if lev <= 0  then
		return
	end 
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",skillID)
	if  tbMsg.costMp > 0  then
		local val =  tbMsg.costMpAdd*0.1*lev
		self:addRoleAttValue(RoleAttMsg.addMpOne,val)
	end 
	if tbMsg.attID <= 0  then
		return
	end 
	local maxLev = g_roleSkillMsg:getTFMaxlev() 
	if lev > maxLev then
		lev = maxLev
	end 
	local  tbAttMsg = g_roleSkillMsg:getSkillValue(skillID,lev) 
	self:addRoleAttValue(tbMsg.attID,tbAttMsg[1])
    local attMsgD =  g_cfgMsg:getCfgMsg("att_D",tbMsg.attID)
	cclog(lev,attMsgD.isCwu,"======mathRoleSkillAttMsgOne==2222=====",tbAttMsg,skillID,lev,tbMsg.attID)
	
	if attMsgD.isCwu and attMsgD.isCwu >= 1 then
		g_petMsg:addTbPetAddAttMsg(attMsgD.isCwu,tbAttMsg[1])
	end 
	
end 
function roleMsg:mathRoleSkillAttMsg()
	local BOSSID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	for i=1,tbGameConst.SkillMaxNum do
		local skillID = tbMsg["skill"..i]
		
		self:mathRoleSkillAttMsgOne(i,skillID)
	end 
end

function roleMsg:mathRoleTianfuAttMsg()
	local tianfuTbMsg = g_tianfuMsg:getTianfuTbMsg()
	for i,info in pairs(tianfuTbMsg)do
		local lev = info.lev or 0
		if  lev > 0 then
			local tbMsg =  g_cfgMsg:getCfgMsg("tianfu_D",info.cfgID)
			if tbMsg.attID > 0  then
				if lev > tbMsg.maxLev then
					lev = tbMsg.maxLev
				end 
				local value = g_tianfuMsg:getValuetianfu(info.cfgID,lev)   
				self:addRoleAttValue(tbMsg.attID,value)
				local attMsgD =  g_cfgMsg:getCfgMsg("att_D",tbMsg.attID)
				if attMsgD.isCwu and attMsgD.isCwu >= 1 then
					g_petMsg:addTbPetAddAttMsg(attMsgD.isCwu,value)
				end 
			end 
		end 
	end 
end 

function roleMsg:mathRoleMainAttChangeMsg()
	
	local value1 = self:getRoleAttValue(1) -- 1点力量 = 2点物理攻击 + 1点物理防御
	local addVa = g_tianfuConTrol:getTianfuOpenValue(30) 
	local value = byBigInt(value1,2+addVa)
	self:addRoleAttValue(11,value)
	local value = byBigInt(value1,1)
	self:addRoleAttValue(12,value)
	--cclog(value1,"======mathRoleMainAttChangeMsg====22===",value)
	--======================================
	local value1 = self:getRoleAttValue(2) --1点敏捷 = 0.1%躲闪 + 0.1%暴击
	
	local value = byBigInt(value1,0.1)
	self:addRoleAttValue(19,value)
	self:addRoleAttValue(20,value)
	self:addRoleAttValue(18,value)
	
	local value1 = self:getRoleAttValue(3) --1点智慧 = 2点魔法攻击 + 1点法力
	local addVa = g_tianfuConTrol:getTianfuOpenValue(33)	
	local value = byBigInt(value1,2)
	self:addRoleAttValue(13,value)
	
	local value = byBigInt(value1,2 + addVa)
	local value = value1
	self:addRoleAttValue(16,value)
	
	local value1 = self:getRoleAttValue(4) --1点体质 = 4点血量 + 2点物理/魔法防御
	local addVa = g_tianfuConTrol:getTianfuOpenValue(26) 
	local value = byBigInt(value1,4+addVa)
	self:addRoleAttValue(15,value)

	local addVa = g_tianfuConTrol:getTianfuOpenValue(27) 
	local value = byBigInt(value1,2+addVa)
	self:addRoleAttValue(14,value)
	self:addRoleAttValue(12,value)
	
	local value1 = self:getRoleAttValue(5) --1点幸运 = 0.1额外材料获取 + 0.1额外金币获取
	local value = byBigInt(value1,0.1)
	self:addRoleAttValue(48,value)
	self:addRoleAttValue(47,value)
	
	local value1 = self:getRoleAttValue(6) --1点血脉 = 0.1统帅 + 0.1点攻速
	local value = byBigInt(value1,0.1)
	self:addRoleAttValue(33,value)

	self:addRoleAttValue(17,value)
	

	---上传
	local value1 =  g_roleMsg:getRoleAttValue(48,true)
	cclog(value1,"=====48===getRoleAttValue====")
	if not MaxBigInt(value1, "0") then
		value1  = 0
	end
	cc.UserDefault:getInstance():setIntegerForKey("XY",value1)
	g_svSendMsgControl:request_msgString(1000,nil,otherDBMsgID.addCLXY,value1)
	local value1 = g_roleMsg:getRoleAttValue(47,true)
	if not MaxBigInt(value1, "0") then
		value1  = 0
	end 
	cc.UserDefault:getInstance():setIntegerForKey("Co",value1)
	g_svSendMsgControl:request_msgString(1000,nil,otherDBMsgID.addCoinXY,value1)
	
	local value1 = g_roleMsg:getRoleAttValue(33,true)
	if not MaxBigInt(value1, "0") then
		value1  = 0
	end 
	--value1 = math.floor( value1/curMapLev)
	---local value1 = g_roleMsg:getRoleAttValue(RoleAttMsg.baojiHurt,true)

	
	g_svSendMsgControl:request_msgString(1000,nil,otherDBMsgID.tongshuai,value1)
end 


function roleMsg:cleanRoleBaseAttMsg()
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D")
	for attID,v in pairs(attMsgD)do
		if v.isDD == 2 then
			self:cleanRoleAttValue(attID)
		end 
	end 
end 

function roleMsg:reloadDalitLevAddAtt()
	local lev ,expOne,lastExp , tbAtt = g_dalitInfoMsg:mathDalitLev()  
	---cclog(DalitExp,lev,"=====reloadDalitLevAddAtt===11========")
	for attID,value in ipairs(tbAtt)do
		
		self:addRoleAttValue(attID,value)
		--cclog(lev,value,"=====reloadDalitLevAddAtt===222======",addVip)
	end 
	--cclog(lev,"=====reloadDalitLevAddAtt===11========")
end

function roleMsg:sendBaseAttMsg()
	local  value1 = g_roleMsg:getRoleAttValue(RoleAttMsg.baoji)
	local  value2 =  g_roleMsg:getRoleAttValue(RoleAttMsg.mfDps,nil,true)
	local  value3 =  g_roleMsg:getRoleAttValue(RoleAttMsg.wlDps,nil,true)
	local  value4 = g_roleMsg:getRoleAttValue(RoleAttMsg.baojiHurt)
	local string1 = {tostring(value1),tostring(value2),tostring(value3),tostring(value4)}
	
	local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	for i=1,7 do
		local petID = batPatMsg[i] or 0
		if petID > 0 then
			local info = g_batContorl:reloadPetMsg(i,true,true)
			string1[#string1+1] = tostring(i)
			string1[#string1+1] = tostring(info.dpsWl)
		end 
	end 
	
	g_svSendMsgControl:request_msgString(1000,nil,666,value1,string1)	
end 
function roleMsg:reloadRoleBaseAttMsg()
	self:cleanRoleBaseAttMsg()
	--重置宠物光环
	g_petMsg:cleanTbPetAddAttMsg()
	
	self:mathBaseAttMsg() --基础属性

	---计算装备  增加属性
	self:mathRoleEquAttMsg()
	---角色技能  增加属性
	self:mathRoleSkillAttMsg()
	---角色天赋  增加属性
	self:mathRoleTianfuAttMsg()
	---每日任务增加属性
	self:reloadDalitLevAddAtt()

	---计算主属性变换
	self:mathRoleMainAttChangeMsg()
	
end

function roleMsg:ctor()

end

g_roleMsg =  roleMsg:create()