------------------
-- 文件名:	roleSkillMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	制作数据
-- 应  用:  
-------------------
local roleSkillMsg = class("roleSkillMsg")

local roleSkillTbMsg = { 
	-- roleSkillInfo
}

function roleSkillMsg:getroleSkillTbMsg(ID)
	if ID  then
		local tbsmg = roleSkillTbMsg[ID] 
		return tbsmg
	end 
	return roleSkillTbMsg
end
	
	
function roleSkillMsg:getroleSkillTbMsgLev(indexD)
	local info = self:getroleSkillTbMsg(indexD) or {}
	local lev = info.lev or 0
	local addVa = g_tianfuConTrol:getTianfuOpenValue(28) 
	lev = lev + addVa
	return lev
end

function roleSkillMsg:setroleSkillTbMsg(info)  
	roleSkillTbMsg[info.id] = info
end
function roleSkillMsg:setroleSkillTbMsgAll(info)   
	if not info then
		return
	end 
	roleSkillTbMsg = info
end

---========================================

function roleSkillMsg:getGWLevUpNeedCoin() 
	local curRoleSkilGWlLev = g_baseMsg:getOther(otherDBMsgID.curRoleSkilGWlLev) or  1
	
	local addVa = g_tianfuConTrol:getTianfuOpenValue(25) 
	local value1 , strLDEndCN = byBigInt(curRoleSkilGWlLev, curRoleSkilGWlLev,true)
	--local value2 , strLDEndCN = byBigInt(value1, "0.5")
	local value3 , strLDEndCN = byBigInt(value1, "100",true)
	local value , strLDEndCN = addBigInt(value1, value3,true)
	local addVa = 1-addVa/100
	local needCoin , strLDEndCN = byBigInt(value, addVa,true)
	---cclog(needCoin,strLDEndCN,"====getGWLevUpNeedCoin========",value, addVa)
	return needCoin,strLDEndCN
end
function roleSkillMsg:getTFMaxlev() 
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	local value = tbGameConst.baseSkillMaxLev + zslevel*tbGameConst.skillMaxLev
	
	return value
end

function roleSkillMsg:getCostMp(cfgID,lev,roleLev) 
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",cfgID)
	local level = roleLev or g_roleMsg:getRoleAttValue(RoleAttMsg.level,true)
	level = math.ceil(level/10 )
	local costMp = tbMsg.costMp*level + tbMsg.costMpAdd*(lev-1)
	---cclog(costMp,"====getCostMp========",cfgID,lev) 
	return costMp
end
	
function roleSkillMsg:getCostXueshi(cfgID,lev,index) 
	if lev <= 0  then
		lev = 1
	end 
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",cfgID)
	local Ration = tbMsg.xsReration
	local costMp = 50*index + 50*(lev-1)*(lev-1)*index
	local addVa = g_tianfuConTrol:getTianfuOpenValue(19) 
	cclog(costMp,index,addVa,lev,"==getCostXueshi====",addVa)
	costMp = math.ceil(costMp *(1-addVa/100)*Ration)

	cclog(costMp,index,addVa,lev,"==getCostXueshi==222==",addVa,Ration)
	return costMp
end
--计算每秒获得学识
function roleSkillMsg:getXSDps() 
	local speed = tbGameConst.ganwuSpeed
	local curRoleSkilGWlLev = g_baseMsg:getOther(otherDBMsgID.curRoleSkilGWlLev) or  1
	
	local addVa = g_tianfuConTrol:getTianfuOpenValue(17) 
	
	local addVip = g_viplevMsg:getVipValue(18)
	local oneValue = curRoleSkilGWlLev*3 + addVa 
	--cclog(oneValue,"=====getXSDps===",addVip)
	oneValue =math.floor( oneValue *(1+ addVip/100))
	local addVaTime = g_tianfuConTrol:getTianfuOpenValue(24) 
	speed = speed - addVaTime
	
	if speed < 1 then
		speed = 1
	end 
	return oneValue,speed
end 
--最大学识离线时间
function roleSkillMsg:getMaxXSTimeOff() 
	local nTime = tbGameConst.MaxXSTimeOff
	local addVa = g_tianfuConTrol:getTianfuOpenValue(7) 
	nTime = nTime + addVa*60
	return nTime
end 
--计算离线时间
function roleSkillMsg:getXSTimeOff() 
	local MaxXSTimeOff  = g_roleSkillMsg:getMaxXSTimeOff() 
	local lastGetXSTime = g_baseMsg:getOther(otherDBMsgID.lastGetXSTime) or 0
	if lastGetXSTime == 0 then
		lastGetXSTime = os.time()
	end 
	local nTime = g_getCursvTime() - lastGetXSTime
	if nTime > MaxXSTimeOff then
		nTime = MaxXSTimeOff
	end 
	local nTimeStr = cc.getStrTimeByS(nTime)
	return nTimeStr,nTime
end 

--计算累计学识
function roleSkillMsg:getTimeOffXSValue(nTime,oneValue,speed) 
	local nTimes = math.floor(nTime/speed)

	local value = nTimes*oneValue
	return value
end 

function roleSkillMsg:getSkillValue(cfgID,lev,isStr) 
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",cfgID)
	local tbAttMsg = {}
	for i=1,3 do
		local addLev = tbMsg["addLev"..i]
		local value 
		if addLev and addLev > 0 then
			value = tbMsg["value"..i] + math.floor(lev/addLev)* tbMsg["addValue"..i]
		else
			value = tbMsg["value"..i] + lev * tbMsg["addValue"..i]
		end 
		if tbMsg["max1"..i] and tbMsg["max1"..i] > 0 and  value > tbMsg["max1"..i] then 
			value = tbMsg["max1"..i]
		end 
		tbAttMsg[i] =  value
		cclog(cfgID,tbAttMsg[i],value,addLev,"========getSkillValue==========",tbMsg["addValue"..i],i)
	end 
	
	if isStr then
		if cfgID >= 95001001 then
			local cIndex = cfgID%10
			tbAttMsg[2] = g_lyInfoMsg:mathZhongzhuValue2(cIndex) 
			local tb_Str = {"x","n"}
			dec = cc.g_inalienContentByTbNumber(tbMsg.dec,tb_Str,tbAttMsg) 
		else
			local tb_Str = {"x","y","z"}
			dec = cc.g_inalienContentByTbNumber(tbMsg.dec,tb_Str,tbAttMsg) 
		end 
		 
		return  dec
	end 
	return tbAttMsg
end

function roleSkillMsg:ctor()

end

g_roleSkillMsg =  roleSkillMsg:create()