------------------
-- 文件名:	viplevMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	酒馆数据
-- 应  用:  
-------------------
local viplevMsg = class("viplevMsg")

--计算vip等级
function viplevMsg:mathRoleVIPlev(jifen)
	local  jifen = jifen or  g_baseMsg:getResOfVipJifen() or 0
	local cfgMsg =  g_cfgMsg:getCfgMsg("VIPLev_D")
	local lev = 0
	local needExp = 0
	local curExp,offx = 0,0
	for i,v in ipairs(cfgMsg)do
		local allExp = v.getMathExp
		
		if jifen < allExp  then
			lev = i
			needExp = v.getExp
			offx = allExp - jifen
			curExp = needExp - offx
			break
		else
			lev = i
			if lev >= tbGameConst.maxVip then
				lev = tbGameConst.maxVip
				break
			end 
			needExp = v.getExp
			offx = allExp - jifen
			if offx < 0 then
				offx = 0
			end 
			curExp = needExp - offx
				
		end 
	end 
	if lev > tbGameConst.maxVip  then
		lev =  tbGameConst.maxVip
	end 
	cclog(lev,tbGameConst.maxVip,"======mathRoleVIPlev========",jifen)
	return lev
end

function viplevMsg:getVipValue(nType)
	if  self.vipTbValue[nType] then
		return self.vipTbValue[nType]
	end 
	local count = 0
	local lev = g_viplevMsg:mathRoleVIPlev()
	for index = 1,lev do
		local cfgMsg =  g_cfgMsg:getCfgMsg("VIPLev_D",index)
		if cfgMsg.nTypeID == nType then
			count = count + cfgMsg.value1
			cclog(count,cfgMsg.value1,"======getVipValue====11====",nType)
		end 
	end 
	self.vipTbValue[nType] = count
	cclog(lev,nType,"====getVipValue=====",count)
	return count
end

function viplevMsg:reloadVipValue()
	self.vipTbValue = {}
end

function viplevMsg:ctor()
	self.vipTbValue = {}
end

g_viplevMsg =  viplevMsg:create()