------------------
-- 文件名:	svResponseMsgControl.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	服务器  response
-- 应  用:  
-------------------

local svResponseMsgControl = class("svResponseMsgControl")

local function BackToRelogin()
	cclog("---BackToRelogin--")
	require("app.checkUpdate.checkupdatewnd"):create():openWnd()
end

------------------------------------
local function showDailog(dec, openFunc)
	local tbQDMsg = {}
	tbQDMsg.dec = dec
	tbQDMsg.text1 = "确定"
	tbQDMsg.qdFunc = openFunc
	g_quedingItem:openWnd(tbQDMsg)
end


--error
local function response_error(response)
	cclog("========stack===服务器出错 ==response_error===",response)
	local errorTiShi = response.errorTiShi
	local status = response.status
	local szerror = response.szerror

	if errorTiShi  then
		if errorTiShi == 10000 then -- not player
			if not zb2_loadingScene.rootLayout then
				BackToRelogin(10000)
			end
			return
		end
		
		if  errorTiShi == -1  then
			cclog(errorTiShi,"====ts_hszz_antion===333===")
			g_action:ts_hszz_antion(response.szerror,1)
			return
		end
		cclog(errorTiShi,"====ts_hszz_antion====11===")
		if  errorTiShi == -2 then
			--cclog(errorTiShi,"====ts_hszz_antion===22====")
			g_quedingItem2:openWnd(response.szerror)
			return
		end
		
		if  errorTiShi == -100   then	
			g_Cfg.Debug = true
			local ters = "服务器出错，请联系管理员"
			if gCurszerror ~= szerror  then
				cclog("======ters==111=====1124===",szerror)
				g_suploadlog1()
				gCurszerror = szerror
			end 
		
			--g_action:ts_hszz_antion(ters,1)
			----onChangeState(event,szerror)
			---g_erro_panle:openWnd(szerror,"服务器出错")
			g_Cfg.Debug = false
			return
		elseif   errorTiShi == -101  and  g_Cfg.Platform == kTargetWindows  then
			--g_action:ts_hszz_antion(response.szerror,1)
			return
		end
		if g_serverText[errorTiShi] then
			local text = g_serverText[errorTiShi]
			--local errorTiShiNumber = response.errorTiShiNumber
			g_action:ts_hszz_antion(text,1)
			return
		end
		
	else
		--g_action:ts_hszz_antion(response.szerror,nil,-2)
	end 
	local szerror  = response.szerror or  ""
---	g_tbMsgGmNode:addTbJiTanLevelMsg("服务器szerror："..szerror)
	---g_delayNode:closeWnd()
	if  status == -1 then
		g_action:ts_hszz_antion(response.szerror,1,2)
		return
	end
end


local function response_time(response)
	cclog("===========服务器 =时间===response_time====",response)
	local status = response.status
	local nType = response.nType
	if status == 1 then
		local nTime = response.nValue
		local playerStatus = response.playerStatus
		
		local gVersion = response.gVersion
		
		if playerStatus and playerStatus == -1  then -- 冻结
			local szerror = response.szerror   or ""
			showDailog(szerror, BackToRelogin )
			g_reloadData = nil
			return
		end
		if gVersion  then
			curGVersion = gVersion
		end 
		g_setCursvTime(nTime)
		g_baseConTrol:scheduGameTime()
		g_svResponseMsgControl:openResponseTagFunc(1,playerStatus)

	elseif status == -1 then
	elseif status == -30 then
	
		local function callBack()
			--cc.Application:getInstance():openURL(appURL)
			---BackToRelogin()
			---cc.Director:getInstance():endToLua()
			cclog("=======response_time==22222==",nTIme)
			BackToRelogin()
			--require "cocos.init"
			--require "public.init"
			--require("app.checkUpdate.checkupdatewnd"):create():openWnd()
		end
		showDailog("有新版本，请重启游戏", callBack)
	end
	
	if nType and nType == -110  then --pand 
		local nTime = response.nValue
		local curTime = g_getCursvTime()
		local nTIme = curTime - nTime 
		cclog("=======response_time=======DD===",nTIme)
		----g_action:ts_hszz_antion(curTime.."======恢复游戏=========="..nTIme,nil,-1)
		showDailog("有新版本，请重启游戏", callBack)
		g_batContorl.gameStatus = gameStatus.stop
		BackToRelogin()
	end 
end

--资源变动
--setResInfo
local function setResInfo(resInfo,noTishi)
	local id = resInfo.id
	local number = resInfo.number or  0
	local addNumber = resInfo.addNumber
	if not id  then	
		cclog("==setResInfo=== not id=",id,resInfo)
		return
	end 
	g_baseConTrol:setBaseMsg(id,number)
	if  addNumber and  MaxBigInt(addNumber, "0")  and addNumber ~= "0"  then
		if   not noTishi and id ~= g_resCfgId.jifen then
			local resName,colorID= g_getNameConTrol:getAllMsg(id)
			g_action:ts_hszz_antion("获得"..addNumber..resName,G_tb_TextColor[colorID],nil,true)
			
			if id == g_resCfgId.coin  then
				g_countMsg:addTbCount(TBCountKEY.CoinNum,addNumber)
			end 
			
		end 
	end 
end 

--掉落
--setResInfo
local function setGoodsInfo(goodsInfo,noTishi)
	local id = goodsInfo.id
	local number = goodsInfo.number or  0
	local addNumber = goodsInfo.addNumber
	if not id  then	
		cclog("==setResInfo=== not id=",id,goodsInfo)
		return
	end 
	--g_baoxiangMsg:settbGoodsMsg(id,number)
	g_bagMsg:setGoodsTbMsg(goodsInfo)
	cclog("==setGoodsInfo====",id,number,addNumber)
	if  addNumber  then
		local curValue = number - addNumber
		if addNumber > 0 and not noTishi then
			
			local name,colorID= g_getNameConTrol:getAllMsg(id)
			g_action:ts_hszz_antion(name.."x"..addNumber,G_tb_TextColor[colorID],nil,true)
			cclog("==setGoodsInfo==11==",id,number,cfgMsg.value8)
			g_gameMusic:playEffect(13)
		end 
	end 
	
	local B_Bag = g_WndMgr:getWnd("B_Bag")
	if B_Bag then
		B_Bag:setListItemGoods(nil,cfgID)
		local panle = B_Bag:touchGoodsItem(nil,cfgID,true)
		if panle then
			g_gNodeConTrol:setGoodsDecItem(panle,cfgID)
		end 	
	end
end 
--掉落
--setResInfo
local function setRuneInfo(runeInfo,noTishi)
	local id = runeInfo.id
	local number = runeInfo.number or  0
	local addNumber = runeInfo.addNumber
	if not id  then	
		cclog("==setResInfo=== not id=",id,runeInfo)
		return
	end 
	--g_baoxiangMsg:settbGoodsMsg(id,number)
	g_bagMsg:setRuneTbMsg(runeInfo)
	cclog("==setGoodsInfo====",id,number,addNumber)
	if  addNumber  then
		local curValue = number - addNumber
		if addNumber > 0 and not noTishi then
			local name,colorID= g_getNameConTrol:getAllMsg(id)
			g_action:ts_hszz_antion("符文："..name.."x"..addNumber,G_tb_TextColor[colorID],nil,true)
			g_gameMusic:playEffect(13)
		end 
	end 
	local C_EquContorl = g_WndMgr:getWnd("C_EquContorl")
	if C_EquContorl then
		C_EquContorl:touchGoodsItem(nil,id,true)
		C_EquContorl:setListItemRune(nil,id)
	end 
	
	local B_Bag = g_WndMgr:getWnd("B_Bag")
	if B_Bag then
		B_Bag:setListItemRune(nil,id)
		local panle = B_Bag:touchGoodsItem(nil,id,true)
		if panle then
			g_gNodeConTrol:setRuneDecItem(panle,id)
		end 	
	end
end 
local function setPetSkillInfo(Info,noTishi)
	local id = Info.id
	local number = Info.number or  0
	local addNumber = Info.addNumber
	if not id  then	
		cclog("==setResInfo=== not id=",id,Info)
		return
	end 
	g_bagMsg:setpetSkillTbMsg(Info)
	
	cclog("==setGoodsInfo====",id,number,addNumber)
	if  addNumber  then
		local curValue = number - addNumber
		if addNumber > 0 and not noTishi then
			local name,colorID= g_getNameConTrol:getAllMsg(id)
			g_action:ts_hszz_antion("获得："..name.."x"..addNumber,G_tb_TextColor[colorID],nil,true)
			g_gameMusic:playEffect(13)
		end 
	end 
end 


function svResponseMsgControl:responseOpenWnd(...)
	--cclog(self.responseOpenWndfunc,"======responseOpenWnd========")
	if self.responseOpenWndfunc then
		self.responseOpenWndfunc(...)
		self:setresponseOpenWnd()
	end 
end 

function svResponseMsgControl:setresponseOpenWnd(func)
	self.responseOpenWndfunc = func
end 

function svResponseMsgControl:openResponseTagFunc(Tag,...)
	cclog(self.responseTagFunc[Tag],"======responseOpenWnd========",Tag)
	local func = self.responseTagFunc[Tag]
	if func  then
		func(...)
		self:setResponseTagFunc(Tag)	
	end 
end 

function svResponseMsgControl:getResponseTagFunc(Tag)
	return self.responseTagFunc[Tag]
end 

function svResponseMsgControl:setResponseTagFunc(Tag,func)
	self.responseTagFunc[Tag] = func
end

--回调监听
function svResponseMsgControl:getRegisterSvSpon(svName,response)
	if not self.registerSvSpon[svName]  then
		cclog("=====getRegisterSvSpon====",svName)
		return 
	end 
	local tble = self.registerSvSpon[svName]
	for id,func in pairs(tble)do
		local tbMsg = g_WndMgr:getTbWndMsg(id)
		cclog(tbMsg,"=i====getRegisterSvSpon====",svName,id,response)
		if  tbMsg then 
			local wnd = g_WndMgr:getWnd(id)
			if wnd then
				func(response)
			end 
		else
			func(response)
		end 
	end 
end

--注册回调监听
function svResponseMsgControl:setRegisterSvSpon(svName,registerID,func)
	if not self.registerSvSpon[svName]  then
		self.registerSvSpon[svName]  = {}
	end 
	self.registerSvSpon[svName][registerID] = func
end


local function ProcessNtyKickOff(iType)
	if iType then --0重新登陆 1强制离线 2 异常踢人 3  999即将关服 1000停服 
		if 1 == iType then
			showDailog("账号在其他地方登录", BackToRelogin )
		elseif 2 == iType then
			showDailog("账号数据受损", BackToRelogin )
		elseif 3 == iType then
			local function callBack()
				cc.Application:getInstance():openURL(updatewnd:getAppURL())
				---appURLTapTap
				---BackToRelogin()
			end
			showDailog("商店更新最新版本", callBack)
		elseif iType == 1000 then	
			showDailog("服务器正在维护中..即将开启",nil)
		elseif iType == 10000  then	
			cclog("---player Nil -----Director:endToLua--")
			cc.Director:getInstance():endToLua()
		end 
	end
end


local function nty_kickoff(response)
	cclog(response,'====服务器fwq=====nty_kickoff===========')	
	if response.errortype == 999 or not g_GameDataMgr.loginSucc then	 -- 即将关服
        g_action:ts_hszz_antion(response.desc, nil,-2)
	elseif response.errortype == 1 then
		g_action:ts_hszz_antion("111", nil,-2)
		BackToRelogin(response.errortype)
		
	else  -- 关服
		BackToRelogin(response.errortype)
	end	
end

local function response_getApiCallBack(response)
	if response.status < 0 then
		--g_action:ts_hszz_antion(response.szerror, nil,-2)
		local tbQDMsg = {}
		tbQDMsg.dec = string.format("%s 支付发货异常，是否重试:%s->%s", tostring(os.date("%Y-%m-%d-%H-%M-%S",os.time())), tostring(response.szerror), tostring(response.productID))
		tbQDMsg.text1 = "确定"
		tbQDMsg.text2 = "取消"
		tbQDMsg.qdFunc = function() g_ReTryAppStoreReceipt() end
		g_quedingItem:openWnd(tbQDMsg) 
		
		local connectItem = g_WndMgr:getWnd("connectItem")
		if connectItem then
			connectItem:close()
		end 
	end
end



local function response_getInitMsg(response)
	cclog("===========服务器 ==response_getInitMsg====",response)
	local status = response.status
	if status == 1 then
		local nTime = response.nTime
		local tbResValue = response.tbResValue
		local thOtherMsg = response.thOtherMsg
		local tbInteger = response.tbInteger
		g_setCursvTime(nTime)
		
		for i,info in pairs(tbResValue)do
			setResInfo(info,true)
		end 
		if response.tbInteger then  
			g_baseMsg:setTbInteger(response.tbInteger)
		end 
		if response.thOtherMsg then  
			g_baseMsg:setOther(response.thOtherMsg)
		end 
		if response.thOtherStrMsg then  
			g_baseMsg:setOtherStr(response.thOtherStrMsg)
		end 
		g_svResponseMsgControl:openResponseTagFunc(2,playerStatus)

	elseif status == 10 then
		g_playerMsg:saveGetUserIDMsg1(response)
	end
end

local function response_dropResMsg(response)
	cclog("===response_dropResMsg=======",response)
	local status = response.status
	local  tbResValue = response.tbResValue or {}
	local  noTishi = response.noTishi
	for i,resInfo in pairs(tbResValue)do
		 setResInfo(resInfo,noTishi)
	end 

end 


--成就任务
local function response_setName(response)
	local status = response.status
	cclog("=====response_setName====",response)
	if status == 1 then	
		local name = response.name
		g_GameDataMgr.nickname = name
		--g_action:ts_hszz_antion("名字修改成功\n"..name,2,-3)
		--g_batMsg_MJ:initMineMsg1()
		
	end
	g_svResponseMsgControl:openResponseTagFunc(3)
end


---新手引导
local function response_newGuide(response)
	local status = response.status
	cclog("===response_newGuide=======",response)
	if status and status == 1  then
		local nType = response.nType
		local newGuideInfo = response.newGuideInfo
		if newGuideInfo then
			g_newGuideMsg:setTbGuide(newGuideInfo)
		end 
		g_svResponseMsgControl:openResponseTagFunc(24)
	end 
end

--成就任务
local function response_taskInfo(response)
	cclog("===response_taskInfo=======",response)
	g_taskConTrol:taskInfo(response)
	
end
local function response_msgString(response)
	cclog("===response_msgString=======",response)
	local status = response.status
	local value = response.value
	if status == 100 then	
		local otherInfo = response.otherInfo
		if otherInfo then
			g_baseMsg:setOtherValue(otherInfo.id, otherInfo.value)
		else
			if response.value then
				g_baseMsg:setOtherValue(response.value)
			end 
		end 
	elseif status == 101 then
		local tbInteger = response.tbInteger
		g_baseMsg:setTbIntegerByID(tbInteger.id,tbInteger)
	elseif status == 103 then
		local otherStrInfo = response.otherStrInfo
		g_baseMsg:setOtherStrByID(otherStrInfo.id,otherStrInfo.value)
		g_baseMsg:saveToOtherStr(otherStrInfo.id,otherStrInfo.value)
	elseif status == 14 then	 --开启终身卡
		local b_shopSence = g_WndMgr:getWnd("b_shopSence")
		if  b_shopSence then	
			b_shopSence:initlist4()
		end 
		
	elseif status == 4 then	 --领取终身卡
		local b_shopSence = g_WndMgr:getWnd("b_shopSence")
		if  b_shopSence then	
			b_shopSence:initlist4()
		end 
	
	elseif status == 203 then	 
		local ComponentCZhi_VIP = g_panleMgr:getPannelwd("ComponentCZhi_VIP")
		if ComponentCZhi_VIP  then
			ComponentCZhi_VIP:setListItem(nil,value)
			ComponentCZhi_VIP:showAnima(value)
		end
		g_action:ts_hszz_antion("领取成功")
	elseif status == 207 then	 
		local tbMsg = {}
		tbMsg[1] = {90000001,90000002,90000003}
		tbMsg[2] = {90000004,90000005,90000006}
		tbMsg[3] = {90000007,90000008,90000009}
		local b_GoodsBuyPanle = g_WndMgr:getWnd("b_GoodsBuyPanle")
		
		if b_GoodsBuyPanle then
			b_GoodsBuyPanle:setCurHeroBuy(tbMsg[value])
			b_GoodsBuyPanle:svOpenWnd()
		end 
	elseif status == 701 then	 
		local b_yuekaPanle = g_WndMgr:getWnd("b_yuekaPanle")
		if b_yuekaPanle then
			b_yuekaPanle:setYuekaItem()
		end 
		
	elseif status == 702 then	 
		local b_yuekaPanle = g_WndMgr:getWnd("b_yuekaPanle")
		if b_yuekaPanle then
			b_yuekaPanle:setYuekaItem()
		end 
	elseif status == 703 then	 
		
		local b_yuekaPanle = g_WndMgr:getWnd("b_yuekaPanle")
		if b_yuekaPanle then
			b_yuekaPanle:setDataChongzhi()
		end 
	elseif status == 704 then	 
		local b_swyuekaPanle = g_WndMgr:getWnd("b_swyuekaPanle")
		if b_swyuekaPanle then
			b_swyuekaPanle:setYuekaItem()
		end 	
	
	end
end

--任务
local function response_taskReward(response)
	cclog("===response_taskReward=======",response)
	if response.status ==  -1  then
		g_action:ts_hszz_antion(response.szerror)
		return
	end 
	g_taskConTrol:taskReward(response)
end

local function response_cmdMsg(response)
	cclog("===response_cmdMsg=======",response)
	local  cmd = response.cmd
	local  status = response.status
	local  value2 = response.value2
	local  value1 = response.value1
	if cmd == "getName" then
		
	elseif  cmd == "7DayLogin" then
		
	elseif  cmd == "VipRewar" then
		
	elseif  cmd == "newPlayer" then	
		local  cztbInfo = response.cztbInfo
		local  dltbInfo = response.dltbInfo
		g_GMcPanle2:setDltbInfo(dltbInfo)	
		g_GMcPanle2:setCztbInfo(cztbInfo)	
		if  g_GMcPanle2.rootLayout  then
			g_GMcPanle2:initDLList()
			g_GMcPanle2:initCzList()
			g_GMcPanle2:touch(0)	
		end  
	end 
	g_svResponseMsgControl:openResponseTagFunc(7,value2)
end 
local function response_videoAD(response)
	cclog("===response_videoAD=======",response)
	local status = response.status
	local resultType = response.resultType or 0
	if status == 1 then	
	elseif resultType == 10 then	
		
	elseif resultType >= 101  and resultType <= 104 then
	elseif resultType == g_tbAdsReward.adsHDNum  then 
	
	end
	g_svResponseMsgControl:openResponseTagFunc(6,value2)
end 

--邮件
local function response_mial(response)
	local status = response.status
	local tbMailInfo = response.tbMailInfo or {}
	for i,mailInfo in pairs(tbMailInfo)do
		g_mailMsg:setTbMailMsg(mailInfo)
	end 
	cclog("===response_mial=======",response)
	if status and status > 0  then
		if status == 2 then -- 读/领取状态修改
			local mailID = response.count
			if mailID then
				g_mailMsg:setTbMailMsgOfStatus(mailID,1)
				--g_action:ts_hszz_antion("读取邮件",nil,-1)
				
			end
		else
			if status == 3 then  --loginAll
				g_mailMsg:setloginMail(0)
			end 
			if response.count and response.count  > 0  then
				g_action:ts_hszz_antion("有未读邮件",nil,-1)
				g_gNodeConTrol:showNewNumberNode(GMaoPaoNumTag.mail,response.count)
				
			end
			local  b_mail = g_WndMgr:getWnd("b_mail")
			cclog(b_mail,"=====b_mail=======")
			if b_mail then
				b_mail:reloadWnd()
			end
		end
		local tbMailInfo = response.tbMailInfo
		if tbMailInfo then
			for i,info in pairs(tbMailInfo)do
				g_mailMsg:setTbMailMsg(info)
			end
		end
		g_svResponseMsgControl:openResponseTagFunc(8)
	else
		local szerror = response.szerror
		g_action:ts_hszz_antion(szerror,nil,-1)
	end 
end
local function response_getResMsg(response)
	cclog("===response_getResMsg====",response)
	local status = response.status
	local tbResInfo = response.tbResInfo or {}
	local nType = response.nType or {}
	if  nType == 0 then --show
		for resInfo,v in pairs(tbResInfo)do
			setResInfo(resInfo)
		end 
	end 
end 

local function response_getRoleMsg(response)
	cclog("===response_getRoleMsg====",response)
	local status = response.status
	local RoleAttInfo = response.RoleAttInfo 
	local BaseInfo = response.BaseInfo 
	local nType = response.nType or {}
	if  nType == 0 then --show
		g_roleMsg:cleanChangeAttTbMsg()
		for i,info in pairs(RoleAttInfo)do
			g_roleMsg:setRoleTbMsgOne(info)
		end 
		g_roleMsg:ChangeAttTbMsg()
		g_roleMsg:setRoleBaseInfoTbMsg(BaseInfo)
		
		local tbSkillID = response.tbSkillID 
		local tbZbID = response.tbZbID 
		g_roleMsg:setTbZbIDAll(tbZbID)  
		g_roleMsg:setTbSkillIDAll(tbSkillID)  
	elseif	nType == 1 then --升级
		g_action:ts_hszz_antion("角色等级+"..status)
		g_mathConTrol:reloadRoleAtt()
		local LvUpPanle = g_panleMgr:getPannelwd("LvUpPanle")
		if LvUpPanle then
			LvUpPanle:openWnd()
		end 
		local B_Role = g_WndMgr:getWnd("B_Role")
		if B_Role then
			B_Role:showAnnima(1)
		end 
		g_gameMusic:playEffect(73)
	elseif	nType == -1 then -- 有属性改变
		g_roleMsg:cleanChangeAttTbMsg() 
		for i,info in pairs(RoleAttInfo)do
			g_roleMsg:setRoleTbMsgOne(info)
		end 
		g_roleMsg:ChangeAttTbMsg()
		g_mathConTrol:reloadRoleAtt()
	elseif	nType == 2 then --进阶
		g_action:ts_hszz_antion("角色进化")
		local B_Role = g_WndMgr:getWnd("B_Role")
		if B_Role then
			B_Role:setJHBar()
			B_Role:showAnnima(2)
		end 
		local jinhuaPanle = g_panleMgr:getPannelwd("jinhuaPanle")
		if jinhuaPanle then
			jinhuaPanle:openWnd()
		end 
		g_gameMusic:playEffect(73)
	elseif	nType == 3 then --转生
		g_action:ts_hszz_antion("角色转生")
		g_mathConTrol:reloadRoleAtt()
		local B_Role = g_WndMgr:getWnd("B_Role")
		if B_Role then
			B_Role:setZSBar()
			B_Role:showAnnima(3)
		end 
		local zhuanshengPanle = g_panleMgr:getPannelwd("zhuanshengPanle")
		if zhuanshengPanle then
			zhuanshengPanle:openWnd()
		end 
		g_gameMusic:playEffect(73)
	elseif	nType == 4 then --更换角色
		
		local B_Role = g_WndMgr:getWnd("B_Role")
		if B_Role then
			B_Role:setBossPanle()
		end 
		local zhuanshengPanle = g_panleMgr:getPannelwd("zhuanshengPanle")
		if zhuanshengPanle then
			zhuanshengPanle:openWnd()
		end 
		g_mathConTrol:reloadRoleAtt()
		g_gameMusic:playEffect(73)
	elseif	nType == 100 then --BaseInfo 改变
		for i,info in pairs(BaseInfo)do
			g_roleMsg:setRoleBaseInfoTbMsgOne(info)
		end 
		g_mathConTrol:reloadRoleAtt()
	elseif	nType == 1000 then 
		g_playerMsg:saveGetUserIDMsg2(response)
	end 
end 

local function response_getBagMsg(response)
	cclog("===response_getBagMsg====",response)
	local status = response.status
	local tbGoodsInfo = response.tbGoodsInfo 
	local euqInfos = response.euqInfos 
	local tbRuneInfo = response.tbRuneInfo 
	local nType = response.nType or {}
	if  nType == 0 then
		g_bagMsg:setBagEuqTbMsgAll(euqInfos)
	elseif  nType == 1 then	
		g_bagMsg:setGoodsTbMsgAll(tbGoodsInfo)
	elseif  nType == 2 then	
		g_bagMsg:setRuneTbMsgAll(tbRuneInfo)
	elseif  nType == 3 then	
		local tbPetSkillInfo = response.tbPetSkillInfo 
		g_bagMsg:setpetSkillMsgAll(tbPetSkillInfo)
	elseif  nType == 4 then	 --合成符文

	elseif  nType == 11 then	--购买背包
		g_action:ts_hszz_antion("背包+5")
		local B_Bag = g_WndMgr:getWnd("B_Bag")
		if B_Bag then
			B_Bag:setBagNum()
		end 
		g_gameMusic:playEffect(25)
	end 
end 



local function response_getEquMsg(response)
	cclog("===response_getEquMsg====",response)
	local status = response.status
	local tbEquInfo = response.tbEquInfo 
	local nType = response.nType or {}
	if  nType == 0 then --show
		g_zbMsg:setEuqTbMsgAll(tbEquInfo)   
	elseif  nType == 1000 then --show	
		g_playerMsg:saveGetUserIDMsg4(response)
	elseif  nType == 1 then --dropEqu
		for i,info in pairs(tbEquInfo)do
			info.isNew = 1
			g_zbMsg:setEuqTbMsg(info)  
			g_bagMsg:setBagEuqTbMsg(info.id)	
			--if  not response.szerror then
			local equMsg = {}
			equMsg[1] = info.mainAttLev[1]
			equMsg[2] = info.mainAttLev[2]
			equMsg.colorID = G_tb_TextColor[info.yanse]
			local name = g_getNameConTrol:getAllMsg(info.cfgID)
			g_action:ts_hszz_antionEqu(name,equMsg,nil,true)
			---end 
		end 	
		g_countMsg:addTbCount(TBCountKEY.euqNum,1)
		g_gameMusic:playEffect(13)	
		--刷新界面	
	elseif  nType == 3 then --qianghua
		local zbID
		for i,info in pairs(tbEquInfo)do
			if  not info.inRole or info.inRole == 0 then
				g_bagMsg:setBagEuqTbMsg(info.id)
			end 
			g_zbMsg:setEuqTbMsg(info)  
			
			zbID = info.id
		end 
		local C_EquContorl = g_WndMgr:getWnd("C_EquContorl")
		if C_EquContorl then
			C_EquContorl:setQHPanle(status, response.value)
			C_EquContorl:reloadZbDecPanle()
			C_EquContorl:setGoodsNum()	
		end 
		local B_Bag = g_WndMgr:getWnd("B_Bag")
		if B_Bag then
			B_Bag:showEquDecPanle(nil,true)
			B_Bag:setListItemEqu(nil,B_Bag.curTouchEuqID)
		end 
		
		--是否穿戴在角色身上
		g_mathConTrol:reloadRoleByZb(zbID)
	elseif  nType == 4 then 
		local zbID
		for i,info in pairs(tbEquInfo)do
			g_zbMsg:setEuqTbMsg(info)  
			zbID = info.id
		end 

		local C_EquContorl = g_WndMgr:getWnd("C_EquContorl")
		if C_EquContorl then
			C_EquContorl:setLevUpPanle(status, response.value)
			C_EquContorl:reloadZbDecPanle()
			C_EquContorl:setGoodsNum()	
		end 
		local B_Bag = g_WndMgr:getWnd("B_Bag")
		if B_Bag then
			B_Bag:showEquDecPanle(nil,true)
			B_Bag:setListItemEqu(nil,B_Bag.curTouchEuqID)
		end 
		g_action:ts_hszz_antion("装备等级+1")
		--是否穿戴在角色身上
		g_mathConTrol:reloadRoleByZb(zbID)
		g_gameMusic:playEffect(73)
	elseif  nType == 5 then --锁定
		for i,info in pairs(tbEquInfo)do
			g_zbMsg:setEuqTbMsg(info)  
			g_bagMsg:setBagEuqTbMsg(info.id)
			if info.isClock == 1 then
				g_action:ts_hszz_antion("锁定装备")
			else
				g_action:ts_hszz_antion("解锁")
			end
		end 
		g_gameMusic:playEffect(18)
		local C_EquContorl = g_WndMgr:getWnd("C_EquContorl")
		if C_EquContorl then
			C_EquContorl:reloadZbDecPanle()	
		end 
		local B_Bag = g_WndMgr:getWnd("B_Bag")
		if B_Bag then
			B_Bag:showEquDecPanle(nil,true)
			B_Bag:setListItemEqu(nil,B_Bag.curTouchEuqID)
		end 
	elseif  nType == 6 then --穿戴
		local zbID 
		for i,info in pairs(tbEquInfo)do
			g_zbMsg:setEuqTbMsg(info)  
			zbID = info.id
			g_roleMsg:setTbZbIDOne(status,info.id)  
			g_bagMsg:delBagEuqTbMsg(info.id)
		end 
		local C_EquContorl = g_WndMgr:getWnd("C_EquContorl")
		if C_EquContorl then
			C_EquContorl:reloadZbDecPanle()	
		end 
		local B_Bag = g_WndMgr:getWnd("B_Bag")
		if B_Bag then
			B_Bag:showEquDecPanle(nil,true)
			B_Bag:reloadListEuq(true)
			B_Bag:setBagNum()
		end 
		local B_Role = g_WndMgr:getWnd("B_Role")
		if B_Role then
			B_Role:setZBPanle(status)
		end 
		g_action:ts_hszz_antion("穿戴装备")
		g_mathConTrol:reloadRoleAtt()
		g_gameMusic:playEffect(74)
	elseif  nType == 7 then --卸下
		local zbID 
		for i,info in pairs(tbEquInfo)do
			g_zbMsg:setEuqTbMsg(info)  
			g_bagMsg:setBagEuqTbMsg(info.id)
			zbID = info.id	
		end 
		g_roleMsg:setTbZbIDOne(status,0)  

		if not  response.szerror  then
			g_action:ts_hszz_antion("卸下装备")
			g_gameMusic:playEffect(74)
			local C_EquContorl = g_WndMgr:getWnd("C_EquContorl")
			if C_EquContorl then
				C_EquContorl:reloadZbDecPanle()	
			end 
			local B_Bag = g_WndMgr:getWnd("B_Bag")
			if B_Bag then
				B_Bag:showEquDecPanle(nil,true)
				B_Bag:reloadListEuq(true)
				B_Bag:setBagNum()
			end 
			local B_Role = g_WndMgr:getWnd("B_Role")
			if B_Role then
				B_Role:setZBPanle(status)
			end 
			g_mathConTrol:reloadRoleAtt()
		end 
		
		
	elseif  nType == 8 or  nType == 9   then --分解
		for i,zbID in pairs(response.tbEquMsg)do
			g_zbMsg:setEuqTbMsgByID(zbID)  
			g_bagMsg:delBagEuqTbMsg(zbID)
		end 

		local C_EquContorl = g_WndMgr:getWnd("C_EquContorl")
		if C_EquContorl then
			C_EquContorl:close()	
		end 
		local B_Bag = g_WndMgr:getWnd("B_Bag")
		if B_Bag then
			
			B_Bag:showEquDecPanle(nil,true)
			B_Bag:reloadListEuq(true)
			B_Bag:setBagNum()
		end 
		g_gameMusic:playEffect(38)
		g_action:ts_hszz_antion("装备分解")
	elseif  nType == 10  then --凹槽+1
		local zbID 
		for i,info in pairs(tbEquInfo)do
			g_zbMsg:setEuqTbMsg(info)  
			zbID = info.id	
		end 
		local C_EquContorl = g_WndMgr:getWnd("C_EquContorl")
		if C_EquContorl then
			C_EquContorl:setXQPanle()
			C_EquContorl:reloadZbDecPanle()
		end 
		local B_Bag = g_WndMgr:getWnd("B_Bag")
		if B_Bag then
			B_Bag:showEquDecPanle(nil,true)
			B_Bag:setListItemEqu(nil,B_Bag.curTouchEuqID)
		end 
		g_action:ts_hszz_antion("装备凹槽+1")
		g_gameMusic:playEffect(39)
	elseif  nType == 200 or nType == 201 then --镶嵌
		local isInRole , cfgID ,zbID
		for i,info in pairs(tbEquInfo)do
			g_zbMsg:setEuqTbMsg(info)  
			g_bagMsg:setBagEuqTbMsg(info.id)
			isInRole = info.inRole
			cfgID = info.cfgID
			zbID = info.id
		end 
		local C_EquContorl = g_WndMgr:getWnd("C_EquContorl")
		if C_EquContorl then
			C_EquContorl:setXQPanle()
			C_EquContorl:reloadZbDecPanle()
		end 
		local B_Bag = g_WndMgr:getWnd("B_Bag")
		if B_Bag then
			B_Bag:showEquDecPanle(nil,true)
			B_Bag:setListItemEqu(nil,B_Bag.curTouchEuqID)
		end 
		if nType == 200 then
			g_action:ts_hszz_antion("符文镶嵌成功")
		else
			g_action:ts_hszz_antion("拆卸符文")
		end 
		g_gameMusic:playEffect(18)
		--是否穿戴在角色身上
		local B_Role = g_WndMgr:getWnd("B_Role")
		if isInRole  then
			g_mathConTrol:reloadRoleByZb(zbID)
		end 
		if  B_Role then
			local name,yanse,zbMsg = g_getNameConTrol:getAllMsg(cfgID)
			B_Role:setZBPanle(zbMsg.nType)
		end 
		
	end 
	
end 


local function response_getGoodsMsg(response)
	cclog("===response_getGoodsMsg====",response)
	local status = response.status
	local nType = response.nType
	local tbGoodsInfo = response.tbGoodsInfo 
	local tbRuneInfo = response.tbRuneInfo 
	local nType = response.nType or {}
	if  status == 1 then --use
		local name,colorID= g_getNameConTrol:getAllMsg(nType)
		local str = "使用道具:"..name
		g_action:ts_hszz_antion(str,G_tb_TextColor[colorID],nil,true)
		local B_Bag = g_WndMgr:getWnd("B_Bag")
		if B_Bag then
			B_Bag:setListItemGoods(nil,nType)
			local panle = B_Bag:touchGoodsItem(nil,nType,true)
			if panle then
				local num = g_gNodeConTrol:setGoodsDecItem(panle,nType)
				if num == 0 then
					g_panleMgr:closeWndPanle()
					B_Bag:touchBtn(B_Bag.touchTag,true)
				end 
			end 
		end 
		g_gameMusic:playEffect(73)
	elseif  status == 100 then --dropGoods
		local goodsID
		for i,info in pairs(tbGoodsInfo)do
			goodsID = info.id
			setGoodsInfo(info,response.noTis)
		end 
		local B_Bag = g_WndMgr:getWnd("B_Bag")
		if B_Bag then
			B_Bag:setListItemGoods(nil,goodsID)
			local panle = B_Bag:touchGoodsItem(nil,goodsID,true)
			if panle then
				local num = g_gNodeConTrol:setGoodsDecItem(panle,goodsID)
				if num == 0 then
					g_panleMgr:closeWndPanle()
					B_Bag:touchBtn(B_Bag.touchTag,true)
				end 
			end 
		end 
		g_gameMusic:playEffect(73)
	elseif  status == 102 then --dropFW 
		for i,info in pairs(tbRuneInfo)do
			setRuneInfo(info,response.noTis)
		end 
		
	elseif  status == 103 then --drop 
		local tbPetSkillInfo = response.tbPetSkillInfo 
		for i,info in pairs(tbPetSkillInfo)do
			setPetSkillInfo(info,response.noTis)
		end 	
	elseif  status == 1004 then --drop 
		g_action:ts_hszz_antion("符文合成")
	end 
end

local function response_getPetMsg(response)
	cclog("===response_getPetMsg====",response)
	local status = response.status
	local tbPetInfo = response.tbPetInfo 
	local nType = response.nType or {}
	local B_Pet = g_WndMgr:getWnd("B_Pet")
	if  nType == 0 then 
		g_petMsg:setpetTbMsgAll(tbPetInfo)   
	elseif  nType == 1000 then 	
		g_playerMsg:saveGetUserIDMsg3(response)
	elseif  nType == 100 then 
		g_petMsg.sortType = nil
		for i,info in pairs(tbPetInfo)do
			g_petMsg:setpetTbMsg(info)  
			local name = g_getNameConTrol:getAllMsg(info.cfgID)
			g_action:ts_hszz_antion("宠物："..name,G_tb_TextColor[info.yanse],nil,true)
			g_countMsg:addTbCount(TBCountKEY.petNum,1)
		end 
	elseif nType == 1  then --出战
		local info  = g_petMsg:getpetTbMsg(response.value)  
		info.batIndex = status
		
		if B_Pet then
			B_Pet:reloadBatPatItemOne(status)
			B_Pet:setListItem(nil,response.value)
			local c5 =  B_Pet.rootLayout:getController("c5") --控制器
			c5:setSelectedIndex(1)
		end
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		if B_FbBat then
			g_batContorl:reloadPetMsg(status,true)
			B_FbBat:setFbMsgPanleCW(status)
		end 
		g_action:ts_hszz_antion("宠物出战")
	elseif nType == 2  then --撤下
		local info =  g_petMsg:getpetTbMsg(response.value)  
		info.batIndex = nil
		g_batTbMsg:delFbPetMsg(status)
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		if B_Pet then
			B_Pet:reloadBatPatItemOne(status)
			B_Pet:setListItem(nil,response.value)
			local c5 =  B_Pet.rootLayout:getController("c5") --控制器
			c5:setSelectedIndex(1)
		
		end
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		if B_FbBat then	
			local B_FbBat = g_WndMgr:getWnd("B_FbBat")
			cclog("====delFbPetMsg======",response.value)
			B_FbBat:setFbMsgPanleCW(status)
			
		end 
		
		
		g_action:ts_hszz_antion("撤下宠物")
		g_gameMusic:playEffect(73)
		
	elseif nType == 3  then --开启战位
		if B_Pet then
			B_Pet:reloadBatPatItemOne(status)
			B_Pet:showAnima(status)
		end
		g_action:ts_hszz_antion("位置开启")
	elseif nType == 4  then --提炼
		for i,info in pairs(tbPetInfo)do
			g_petMsg:setpetTbMsg(info)  
		end 
		if B_Pet then
			B_Pet:setPetDecPanl()
		end
		local ComponentTL = g_panleMgr:getPannelwd("ComponentTL")
		if ComponentTL then
			ComponentTL:setTextPanle()
		end 
		g_action:ts_hszz_antion("提炼完成")
		g_countMsg:addTbCount(TBCountKEY.cwTl,1)
		g_gameMusic:playEffect(13)
	elseif nType == 5  then --锁定
		for i,info in pairs(tbPetInfo)do
			g_petMsg:setpetTbMsg(info)  
			if info.isClock == 1 then
				g_action:ts_hszz_antion("锁定宠物")
			else
				g_action:ts_hszz_antion("宠物解锁",1)
			end 
		end 
		if B_Pet then
			B_Pet:setPetDecPanl()
			B_Pet:setListItem(nil,status)
		end
		g_gameMusic:playEffect(18)
	elseif nType == 6  then	 --升级
		local petID 
		for i,info in pairs(tbPetInfo)do
			g_petMsg:setpetTbMsg(info)  
			petID = info.id	
		end 
		if B_Pet then
			B_Pet:setPetDecPanl()
			B_Pet:setListItem(nil,status)
		end
		local ComponentLevUp = g_panleMgr:getPannelwd("ComponentLevUp")
		if ComponentLevUp then
			ComponentLevUp:setPanle()
		end 
		g_mathConTrol:reloadPetOne(petID)
		g_action:ts_hszz_antion("等级提升")
			g_gameMusic:playEffect(13)
	elseif nType == 7  then	--升星
		local petID 
		for i,info in pairs(tbPetInfo)do
			g_petMsg:setpetTbMsg(info)  
			petID = info.id	
		end 
		
		if B_Pet then
			B_Pet:setPetDecPanl()
			B_Pet:setListItem(nil,status)
		end
		---g_action:ts_hszz_antion("使用猛兽之心")
		g_action:ts_hszz_antion("获得星级经验+"..response.value)
		if response.szerror then
			g_mathConTrol:reloadPetOne(petID)
		end 
		local ComponentLevUpStar = g_panleMgr:getPannelwd("ComponentLevUpStar")
		if ComponentLevUpStar then
			ComponentLevUpStar:openWnd(petID)
			ComponentLevUpStar:buyListItemEff(response.value2)
		end
		g_gameMusic:playEffect(73)
	elseif nType == 8  then	--打书
		local petID 
		for i,info in pairs(tbPetInfo)do
			g_petMsg:setpetTbMsg(info)  
			petID = info.id	
		end 
		if B_Pet then
			B_Pet:setPetDecPanl()
		end
		local petSkillPanle = g_panleMgr:getPannelwd("petSkillPanle")
		if petSkillPanle then
			petSkillPanle:openWnd()
			petSkillPanle:showAnima2(response.value)
		end 
		g_mathConTrol:reloadPetOne(petID)
		g_countMsg:addTbCount(TBCountKEY.CwDS,1)
		g_gameMusic:playEffect(73)
		g_action:ts_hszz_antion("宠物学会了新技能")
	elseif nType == 9  then	 --遗忘
		local petID 
		for i,info in pairs(tbPetInfo)do
			g_petMsg:setpetTbMsg(info) 
			petID = info.id	
		end 
		if B_Pet then
			B_Pet:setPetDecPanl()
		end
		local petSkillPanle = g_panleMgr:getPannelwd("petSkillPanle")
		if petSkillPanle then
			petSkillPanle:openWnd()
			petSkillPanle:showAnima1(response.value)
		end 
		g_mathConTrol:reloadPetOne(petID)
		g_action:ts_hszz_antion("宠物遗忘了一个技能")
		g_gameMusic:playEffect(13)
	elseif nType == 10  then --技能升级
		g_action:ts_hszz_antion("等级+1")
		local petSkillPanle = g_panleMgr:getPannelwd("petSkillPanle")
		if petSkillPanle then
			--petSkillPanle:setSkillIndexItemAll()
		end 
		if B_Pet then
			B_Pet:setPetDecPanl()
		end
		g_gameMusic:playEffect(73)
	elseif nType == 11  then	 --技能书    吞噬
		g_action:ts_hszz_antion("熟练度+ "..status)
		if response.tujianInfo then
			g_TujianMsg:setTbTujianMsg(response.tujianInfo)
		end 
		g_gameMusic:playEffect(13)
		
		local petSkillPanle = g_panleMgr:getPannelwd("petSkillPanle")
		if petSkillPanle then
			petSkillPanle:openWnd(petSkillPanle.petID)
			petSkillPanle:touchGoodsItem(nil,petSkillPanle.showCfgID)
			petSkillPanle:showAnima0()
		end 
	elseif nType == 12  then
		local petID 
		for i,dpetID in pairs(response.tbDelMsg)do
			g_petMsg:delpetTbMsg(dpetID)  
		end 
		g_petMsg:getSortPetMsg(nil,true) 
		if B_Pet then
			B_Pet:setPetDecPanl()
			B_Pet:reloadPatList()
		end
		g_action:ts_hszz_antion("宠物放生")
		g_gameMusic:playEffect(13)
	elseif nType == 13 then	
		if B_Pet then
			B_Pet:setPetNumText()
		end
		g_action:ts_hszz_antion("宠物栏+"..tbGameConst.petBagBuyaddNum)
		g_gameMusic:playEffect(25)
	end 
end



local function response_getTianfuMsg(response)
	cclog("===response_getTianfuMsg====",response)
	local status = response.status
	local tianfuInfo = response.tianfuInfo 
	local nType = response.nType or {}
	if  nType == 0 then 
		g_tianfuMsg:setTianfuTbMsgAll(tianfuInfo)   
	elseif  nType == 1000 then  --升级
		g_playerMsg:saveGetUserIDMsg5(response)
	elseif  nType == 1 then  --升级
		--g_action:ts_hszz_antion("天赋升级")
		local tuanfuPanle = g_WndMgr:getWnd("tuanfuPanle")
		if tuanfuPanle then
			local curTianfuID = g_baseMsg:getOther(otherDBMsgID.curTianfuID) or  0
			tuanfuPanle:showDecPanle()
			tuanfuPanle:setFreeTFNum()
			tuanfuPanle:setListItemOne(nil,curTianfuID)
			tuanfuPanle:scheduleForever()
			g_tianfuConTrol:reloadTbTfValue(curTianfuID)
		end 
		
	elseif  nType == 2 then  --重置点数
	
		g_action:ts_hszz_antion("天赋点数重置")
		g_tianfuMsg:reloadTianfuTbMsgAll()   
		local tuanfuPanle = g_WndMgr:getWnd("tuanfuPanle")
		if tuanfuPanle then
			tuanfuPanle:showDecPanle()
			tuanfuPanle:setFreeTFNum()
			tuanfuPanle:reloadListShow()
		end 
		g_tianfuConTrol:reloadTbTfValue()
		--刷新重置其他相关数据
		g_mathConTrol:changAttReloadMsgAll()
	elseif  nType == 3 then  --完成 
		g_action:ts_hszz_antion("天赋加点")
		local cfgID
		for i,info in pairs(tianfuInfo)do
			g_tianfuMsg:setTianfuTbMsg(info)  
			local tuanfuPanle = g_WndMgr:getWnd("tuanfuPanle")
			if tuanfuPanle then
				tuanfuPanle:showDecPanle()
				tuanfuPanle:reloadListShow()
				tuanfuPanle:scheduleForever()
				tuanfuPanle:showListItemEff(info.id)
				tuanfuPanle:setFreeTFNum()	
					
			end 
			cfgID = info.cfgID
			g_tianfuConTrol:reloadTbTfValue(cfgID)
		end 
		local cfgMsg =  g_cfgMsg:getCfgMsg("tianfu_D",cfgID)
		g_mathConTrol:changAttReloadMsg(cfgMsg.attID)
		g_gameMusic:playEffect(73)
	elseif  nType == 4 then  --刷新	
		g_tianfuMsg:setTianfuTbMsgAll(tianfuInfo)   
		local tuanfuPanle = g_WndMgr:getWnd("tuanfuPanle")
		if tuanfuPanle then
			tuanfuPanle:openWnd()
		end
		g_action:ts_hszz_antion("改命完毕")
	end 
	
end 

local function response_getRoleSkillMsg(response)
	cclog("===response_getRoleSkillMsg====",response)
	local status = response.status
	local roleSkillInfo = response.roleSkillInfo 
	local nType = response.nType or {}
	if  nType == 0 then 
		g_roleSkillMsg:setroleSkillTbMsgAll(roleSkillInfo) 
	elseif  nType == 1000 then
		g_playerMsg:saveGetUserIDMsg6(response)
	elseif  nType == 1 then  --升级感悟
		g_action:ts_hszz_antion("等级+1")
		local SkillPanle = g_WndMgr:getWnd("SkillPanle")
		if SkillPanle then
			SkillPanle:initTextPanle(true)
		end 
	elseif  nType == 2 then  --升级技能
		local skillIndex 
		for i,info in pairs(roleSkillInfo)do
			g_roleSkillMsg:setroleSkillTbMsg(info)  
			local SkillPanle = g_WndMgr:getWnd("SkillPanle")
			if SkillPanle then
				SkillPanle:setListItem(nil,info.id)			
			end 
			skillIndex = info.id
		end 
		g_action:ts_hszz_antion("等级+1")
		--重置战斗技能数据
		local BOSSID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
		local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
		local skillID = tbMsg["skill"..skillIndex]
		local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",skillID)
		g_mathConTrol:changAttReloadMsg(tbMsg.attID)
		local SkillPanle = g_WndMgr:getWnd("SkillPanle")
		if SkillPanle then
			SkillPanle:setListItem(nil,skillIndex)
		end 
		g_gameMusic:playEffect(73)
	elseif  nType == 3 then --收取学识
		local SkillPanle = g_WndMgr:getWnd("SkillPanle")
		if SkillPanle then
			
			SkillPanle:setBar2()
		end 
		g_gameMusic:playEffect(13)
	end
end
local function response_geTujianMsg(response)
	cclog("===response_geTujianMsg====",response)
	local status = response.status
	local tujianInfo = response.tujianInfo 
	local nType = response.nType or {}
	if  nType == 0 then 
		 g_TujianMsg:setTbTujianMsgAll(tujianInfo)
		 local tujianPanle = g_WndMgr:getWnd("tujianPanle")
		 if tujianPanle then
			tujianPanle:openWnd()
		 end 
	elseif  nType == 1000 then
		g_playerMsg:saveGetUserIDMsg7(response)
		
	elseif nType == 1 then 
		
	end 
	g_svResponseMsgControl:openResponseTagFunc(1000)
end 

local function response_geBatMsg(response)
	cclog("===response_geBatMsg====",response)
	local status = response.status
	
	local nType = response.nType or {}
	if nType == 100  then --- 宝库领取
		---刷新宝库
		local ComponentFubenPanle = g_WndMgr:getWnd("ComponentFubenPanle")
		if ComponentFubenPanle then
			ComponentFubenPanle:showDecPanle()
		end 
		
		
	elseif nType == 101  then --- 宝库升级
		g_action:ts_hszz_antion("宝库等级+1")
		---刷新宝库
		local Component1Baoku = g_panleMgr:getPannelwd("Component1Baoku")
		if Component1Baoku then
			Component1Baoku:setPanle()
		end 
		g_gameMusic:playEffect(73)	
	elseif nType == 1  then --- 战斗宝库
		---刷新宝库
		
	elseif nType == 2  then --- 战斗宝库离线
		local tbQDMsg = {}
		local function openFunc()
			local Allvalue = g_batTbMsg:getFbBatMsg(fbBatMsgKey.BaokuResMath) or 0
			local value = response.strValue or 0
			Allvalue = addBigInt(Allvalue, value)
			g_batTbMsg:setFbBatMsg(fbBatMsgKey.BaokuResMath,Allvalue) 
			local B_FbBat = g_WndMgr:getWnd("B_FbBat")
			if B_FbBat then
				B_FbBat:textBaoKu()
			end  
		end 
		tbQDMsg.dec = string.format("离线期间防御玩家来袭，宝库获得金币%s", tostring(response.strValue))
		tbQDMsg.text1 = "确定"
		tbQDMsg.qdFunc = openFunc
		g_quedingItem:openWnd(tbQDMsg) 
	elseif nType == 3  then --- 选择副本
		--进入副本战斗
		g_batWndContorl:gotoFuben(response.value)
		local cfgMsg =  g_cfgMsg:getCfgMsg("map_D",response.value)
		g_action:ts_hszz_antion("进入"..cfgMsg.name)
	elseif nType == 4  then
		g_batContorl:initGameMsg()
	elseif nType == 5  then	
		
	end 
end 


local function response_geDaliyMsg(response)
	cclog("===response_geDaliyMsg====",response)
	local status = response.status
	local nType = response.nType 
	local daliyInfo = response.daliyInfo
	if nType == 0 then
		g_dalitInfoMsg:setdalitInfoTbMsgAll(daliyInfo)   
		local ComponentLilian = g_panleMgr:getPannelwd("ComponentLilian")
		if ComponentLilian then
			ComponentLilian:setList()
		end 
		
		
	elseif  nType == 1 then --领取
		local index 
		for i,info in pairs(daliyInfo)do
			g_dalitInfoMsg:setdalitInfoTbMsg(info)  
			index = info.id
		end 
		local ComponentLilian = g_panleMgr:getPannelwd("ComponentLilian")
		if ComponentLilian then
			ComponentLilian:reloadListItem(index)
		end 
	elseif  nType == 2 then --计数
		local index 
		for i,info in pairs(daliyInfo)do
			g_dalitInfoMsg:setdalitInfoTbMsg(info)  
			if info.count >= info.maxCount then
				----g_action:ts_hszz_antion("有每日任务完成,可领取奖励")
				g_gNodeConTrol:setMaoPaoMsg(G_MaoPaoMsgType.Daliy,1)
			end 
			index = info.id
		end 
		--local ComponentLilian = g_panleMgr:getPannelwd("ComponentLilian")
		--if ComponentLilian and index  then
			--ComponentLilian:reloadListItem(index)
		--end 
	elseif  nType == 10 then 
		local index 
		for i,info in pairs(daliyInfo)do
			g_dalitInfoMsg:setdalitInfoTbMsg(info)  
			index = info.id
		end 
		local ComponentLilian = g_panleMgr:getPannelwd("ComponentLilian")
		if ComponentLilian then
			ComponentLilian:reloadListItem(index)
		end 
		g_action:ts_hszz_antion("任务更换完成")
	end 
end 

local function response_getChengjiuMsg(response)
	cclog("===response_getChengjiuMsg====",response)
	local status = response.status
	local nType = response.nType 
	local chengjiuInfo = response.chengjiuInfo
	if nType == 0 then
		g_dalitInfoMsg:setchengjiuTbMsgAll(chengjiuInfo) 
	elseif  nType == 1000 then
		g_playerMsg:saveGetUserIDMsg6(response)
	elseif nType == 1 then --领取	
		local ComponentCJpanle = g_panleMgr:getPannelwd("ComponentCJpanle")
		if ComponentCJpanle then
			ComponentCJpanle:openWnd()
			g_action:ts_hszz_antion("领取奖励")
		end 
	elseif nType == 2 then --计数
		local index 
		for i,info in pairs(chengjiuInfo)do
			g_dalitInfoMsg:setchengjiuTbMsg(info)  
		end 
		
	end
end

local function response_getShopMsg(response)
	cclog("===response_getShopMsg====",response)
	local status = response.status
	local nType = response.nType 
	local shopInfo = response.shopInfo
	if nType == 0 then
		g_ShopMsg:setShopTbMsgAll(shopInfo)   
		local ComponentShop = g_panleMgr:getPannelwd("ComponentShop")
		if ComponentShop then
			ComponentShop:openWnd()
		end 
	elseif nType == 1 then --购买
		local index 
		for i,info in pairs(shopInfo)do
			g_ShopMsg:setShopTbMsg(info)
			index = i			
		end 
		local ComponentShop = g_panleMgr:getPannelwd("ComponentShop")
		if ComponentShop then
			ComponentShop:setListItem(nil,index)
		end 
		g_action:ts_hszz_antion("购买物品")
	elseif nType == 2 then --重置
		g_ShopMsg:setShopTbMsgAll(shopInfo)   
		
		local ComponentShop = g_panleMgr:getPannelwd("ComponentShop")
		if ComponentShop then
			ComponentShop:openWnd()
			g_action:ts_hszz_antion("重置物品")
		end 
	end
end 
local function response_getqianDaoMsg(response)
	cclog("===response_getqianDaoMsg====",response)
	local status = response.status
	local nType = response.nType 
	local qdaoInfo = response.qdaoInfo
	if nType == 0 then
		g_qianDaoInfoMsg:setqianDaoInfoTbMsgAll(qdaoInfo) 
		local Component7Day = g_panleMgr:getPannelwd("Component7Day")
		if Component7Day then
			Component7Day:openWnd()	
		end 
		--判断冒泡
		g_qianDaoInfoMsg:isMaopao()   
	elseif nType == 1 then
		local index 
		for i,info in pairs(qdaoInfo)do
			g_qianDaoInfoMsg:setqianDaoInfoTbMsg(info)
			index = i			
		end 
		local Component7Day = g_panleMgr:getPannelwd("Component7Day")
		if Component7Day then
			Component7Day:setListItem(nil,index)	
			g_action:ts_hszz_antion("签到成功")
		end 
	end 
end 


local function response_getBaozangMsg(response)
	cclog("===response_getBaozangMsg====",response)
	local status = response.status
	local nType = response.nType 
	local baozInfo = response.baozInfo
	local congzhuInfo = response.congzhuInfo
	if nType == 0 then
		g_baozangInfoMsg:setBzInfoTbMsgAll(baozInfo)   
	elseif nType == 1 then
		for i,info in pairs(baozInfo)do
			g_baozangInfoMsg:setBzInfoTbMsg(info)  
		end 
		local ComponentBaozang = g_panleMgr:getPannelwd("ComponentBaozang")
		if ComponentBaozang then
			ComponentBaozang:openWnd()
		end 
		g_action:ts_hszz_antion("双倍宝藏")
	elseif nType == 2 then
		for i,info in pairs(baozInfo)do
			g_baozangInfoMsg:setBzInfoTbMsg(info)  
		end 
		g_action:ts_hszz_antion("探索完毕")
		local ComponentBaozang = g_panleMgr:getPannelwd("ComponentBaozang")
		if ComponentBaozang then
			ComponentBaozang:openWnd(true)
		end 
		
	elseif nType == 100 then
		g_congzhuInfoMsg:setBzInfoTbMsgAll(congzhuInfo)   
		local Componentchongzhu = g_panleMgr:getPannelwd("Componentchongzhu")
		if Componentchongzhu then
			Componentchongzhu:openWnd(true)
		end 
	elseif nType == 101 then
		
		local Componentchongzhu = g_panleMgr:getPannelwd("Componentchongzhu")
		if Componentchongzhu then
			Componentchongzhu:showAnima(nil,response.value)
		end

	elseif nType == 102 then
		g_congzhuInfoMsg:setBzInfoTbMsgAll(congzhuInfo)  
		g_action:ts_hszz_antion("刷新完毕")
		local Componentchongzhu = g_panleMgr:getPannelwd("Componentchongzhu")
		if Componentchongzhu then
			Componentchongzhu:setList()
		end
	end 
end 



local function response_rankInfo(response)
	cclog("===response_rankInfo====",response)
	local status = response.status
	local nType = response.nType 
	local tbRank = response.tbRank or {}
	local tbUserMsg = response.tbUserMsg or {}
	if nType == 0 then
	elseif  nType == 1  then
		for i,info in pairs(tbRank)do
			g_rankMsg:setRankMsg(info)
		end 
		for i,info in pairs(tbUserMsg)do
			g_rankMsg:setTbUserMsg(info)
		end 
		local rankPanle = g_WndMgr:getWnd("rankPanle")
		if rankPanle then
			rankPanle:setList()
		end 	
	elseif  nType == 2  then
	elseif  nType == 3  then
		local myRank = response.myRank
		for i,info in pairs(tbUserMsg)do
			g_rankMsg:setTbUserMsg(info)
		end 
		local rankPanle = g_WndMgr:getWnd("rankPanle")
		if rankPanle then
			rankPanle:setMyItem()
		end 
	elseif  nType == 100  then
		local tbEquInfo = response.tbEquInfo 
		for i,info in pairs(tbEquInfo)do
			g_zbMsg:setEuqTbMsg(info) 
		end 
		local Componenttoushi = g_panleMgr:getPannelwd("Componenttoushi")
		if Componenttoushi then
			Componenttoushi:reloadWnd(1)
		end
	elseif  nType == 101  then
		local tbPetInfo = response.tbPetInfo 
		for i,info in pairs(tbPetInfo)do
			g_petMsg:setpetTbMsg(info)  
		end 
		local Componenttoushi = g_panleMgr:getPannelwd("Componenttoushi")
		if Componenttoushi then
			Componenttoushi:reloadWnd(2)
		end
		
		
	end 
end 

local function response_daoyuInfo(response)
	cclog("===response_daoyuInfo====",response)
	local status = response.status
	local nType = response.nType 
	local daoyuInfo = response.daoyuInfo or {}

	if nType == 0 then ---
		g_daoyuMsg:setTbDaoyuMsgAll(daoyuInfo)
		local B_Daoyu = g_WndMgr:getWnd("B_Daoyu")
		if B_Daoyu then
			B_Daoyu:reloadWnd()
		end 
		
	elseif nType == 1 then -- --领取
		local id 
		for i,info in pairs(daoyuInfo)do
			g_daoyuMsg:setTbDaoyuMsg(info)
			id = info.id
		end 
		local B_Daoyu = g_WndMgr:getWnd("B_Daoyu")
		if B_Daoyu then
			B_Daoyu:setDaoyuItemOne(id)
			B_Daoyu:showMyRes()
		end 
		
	elseif nType == 2 then -- --抢夺
		local  dyID = status
		local info = g_daoyuMsg:getTbDaoyuMsg(dyID)
		local userID = info.userID or 0
		
		if userID > 0 then
			g_playerMsg:sendGetUserIDMsg(userID,dyID)
		end 
		
	elseif nType == 3 then -- 抢夺胜利
		local B_Daoyu = g_WndMgr:getWnd("B_Daoyu")
		for i,info in pairs(daoyuInfo)do
			g_daoyuMsg:setTbDaoyuMsg(info)
			if B_Daoyu then
				B_Daoyu:setDaoyuItemOne(info.id)
				B_Daoyu:settxextBagNum()
				B_Daoyu:touchIndex(B_Daoyu.cutTouchIndex)
			end
		end 
		if 1 == response.value then
			g_action:ts_hszz_antion("成功抢夺,成为岛主")
			if B_Daoyu then
				B_Daoyu:showAnima()
			end
			
		end 
		if response.value1 and response.value1 > 0  then
			g_action:ts_hszz_antion("额外抢夺对方已采集资源20%")
		end 
	elseif nType == 4 then ---战斗记录
		g_daoyuMsg:setTbOldDaoyuMsgAll(response.daoyuOldInfo)
		local B_Daoyu = g_WndMgr:getWnd("B_Daoyu")
		if B_Daoyu then
			B_Daoyu:showMyMsg(true)
		end
	elseif nType == 5 then ---战斗记录	
		local id 
		for i,info in pairs(daoyuInfo)do
			g_daoyuMsg:setTbDaoyuMsg(info)
			if B_Daoyu then
				B_Daoyu:setDaoyuItemOne(info.id)
				B_Daoyu:settxextBagNum()
				B_Daoyu:touchIndex(B_Daoyu.cutTouchIndex)
			end
		end 
		for i,info in pairs(response.daoyuOldInfo)do
			g_daoyuMsg:setTbOldDaoyuMsg(info)
			id = info.id
		end 
		local B_Daoyu = g_WndMgr:getWnd("B_Daoyu")
		if B_Daoyu then
			B_Daoyu:showMyMsg(true)
		end
		if response.value then
			if  response.value == 2 then
				g_action:ts_hszz_antion("你的岛屿有玩家依附")
			else
				g_action:ts_hszz_antion("你的岛屿被玩家抢夺")
			end 
		end 
	
	elseif nType == 6 then ---	
		local B_Daoyu = g_WndMgr:getWnd("B_Daoyu")
		for i,info in pairs(daoyuInfo)do
			g_daoyuMsg:setTbDaoyuMsg(info)
			if B_Daoyu then
				B_Daoyu:setDaoyuItemOne(info.id)
				B_Daoyu:settxextBagNum()
				B_Daoyu:touchIndex(B_Daoyu.cutTouchIndex)
			end
		end 
		g_action:ts_hszz_antion("成功依附岛主")
		if B_Daoyu then
			B_Daoyu:showAnima()
		end

	elseif nType == 100 then ---刷新
		local B_Daoyu = g_WndMgr:getWnd("B_Daoyu")
		if B_Daoyu then
			B_Daoyu:showMyRes()
		end
	end
end 

local function response_lyuInfo(response)
	cclog("===response_lyuInfo====",response)
	local status = response.status
	local nType = response.nType 
	local lyuInfo = response.lyuInfo or {}
	local B_mShuoChang = g_WndMgr:getWnd("B_mShuoChang")
	if nType == 0 then ---
		g_lyInfoMsg:setTbMsgAll(lyuInfo)  
		
		if B_mShuoChang then
			B_mShuoChang:reload()
		end 
	elseif nType == 1 then ---jihuo
		for i,info in pairs(lyuInfo)do
			g_lyInfoMsg:setTbMsg(info)
			if B_mShuoChang then
				local index = info.id%100
				B_mShuoChang:setItem(index)
				B_mShuoChang:touchItem(index)
				B_mShuoChang:setQiHeBar()
			end
		end 
	elseif nType == 2 then ---tunshi
		for i,info in pairs(lyuInfo)do
			g_lyInfoMsg:setTbMsg(info)
			if B_mShuoChang then
				local index = info.id%100
				B_mShuoChang:setItem(index)
				B_mShuoChang:touchItem(index)
				B_mShuoChang:setQiHeBar()
			end
		end 
	elseif nType == 3 then ---gengh
		for i,info in pairs(lyuInfo)do
			g_lyInfoMsg:setTbMsg(info)
			if B_mShuoChang then
				local index = info.id%100
				B_mShuoChang:setItem(index)
				B_mShuoChang:touchItem(index)
				B_mShuoChang:setQiHeBar()
			end
		end 
	elseif nType == 1000 then ---gengh	
		g_playerMsg:setlyTbMsgAll(lyuInfo)   
	end
end


-------response_getEquMsg--------------------------------------------------------------------
function client_sendWsSocketData(strProtoName, tbData)
	
	WebSocket:client_Response(strProtoName, tbData)
	
end 
---------------------------------------------------------------------------

function svResponseMsgControl:initResponse()   ---通用
	registerWsSocketMsg("response_error", response_error)--错误提示
	registerWsSocketMsg("response_time", response_time)--加载时间
	registerWsSocketMsg("nty_kickoff", nty_kickoff) ---踢人
	registerWsSocketMsg("response_getInitMsg", response_getInitMsg)--登入数据发送
	registerWsSocketMsg("response_setName", response_setName)---命名
	registerWsSocketMsg("response_msgString", response_msgString)--
	registerWsSocketMsg("response_taskInfo", response_taskInfo)---任务
	registerWsSocketMsg("response_videoAD", response_videoAD)---广告
	registerWsSocketMsg("response_dropResMsg", response_dropResMsg)---广告
	registerWsSocketMsg("response_cmdMsg", response_cmdMsg)
	registerWsSocketMsg("response_newGuide", response_newGuide)
	registerWsSocketMsg("response_taskReward", response_taskReward)
	registerWsSocketMsg("response_mial", response_mial)
	registerWsSocketMsg("response_newGuide", response_newGuide)
	registerWsSocketMsg("response_getResMsg", response_getResMsg)
	
end
function svResponseMsgControl:initResponse2()  
	registerWsSocketMsg("response_getRoleMsg", response_getRoleMsg)
	registerWsSocketMsg("response_getBagMsg", response_getBagMsg)
	registerWsSocketMsg("response_getEquMsg", response_getEquMsg)
	registerWsSocketMsg("response_getGoodsMsg", response_getGoodsMsg)
	registerWsSocketMsg("response_getPetMsg", response_getPetMsg)
	registerWsSocketMsg("response_getTianfuMsg", response_getTianfuMsg)
	registerWsSocketMsg("response_getRoleSkillMsg", response_getRoleSkillMsg)
	registerWsSocketMsg("response_geTujianMsg", response_geTujianMsg)
	registerWsSocketMsg("response_geBatMsg", response_geBatMsg)
	registerWsSocketMsg("response_geDaliyMsg", response_geDaliyMsg)
	registerWsSocketMsg("response_getChengjiuMsg", response_getChengjiuMsg)
	registerWsSocketMsg("response_getShopMsg", response_getShopMsg)
	registerWsSocketMsg("response_getqianDaoMsg", response_getqianDaoMsg)
	registerWsSocketMsg("response_getBaozangMsg", response_getBaozangMsg)
	registerWsSocketMsg("response_rankInfo", response_rankInfo)
	registerWsSocketMsg("response_daoyuInfo", response_daoyuInfo)
	registerWsSocketMsg("response_lyuInfo", response_lyuInfo)
end


function svResponseMsgControl:ctor()
	g_tbAddItemResponse = {}
	self:initResponse()
	self:initResponse2()
	self.registerSvSpon = {}
	self.responseTagFunc = {}
end

g_svResponseMsgControl =  svResponseMsgControl:create()
