------------------
-- 文件名:	svSendMsgControl.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2015-6-2 11:24
-- 版  本:	1.0
-- 描  述:	服务器  request
-- 应  用:  
-------------------

local svSendMsgControl = class("svSendMsgControl")

local nTbMsgPlayerID 
local svSendIndex = 1


--服务器时间
function svSendMsgControl:request_time(callback,nType,nValue,nValue2)
	local tbMsg = {nType = nType ,nValue = nValue , nValue2 = nValue2}
	g_svResponseMsgControl:setResponseTagFunc(1,callback)
	sendWsSocketData("request_time", tbMsg)
end

--登入数据发送
function svSendMsgControl:request_getInitMsg(nType,userID,callback)
	local tbMsg = {nType = nType,userID = userID}
	g_svResponseMsgControl:setResponseTagFunc(2,callback)
	sendWsSocketData("request_getInitMsg", tbMsg)
end

function svSendMsgControl:request_newGuide(id,nType,value,callback)
	local tbMsg = { id = id , nType = nType , value = value }
	cclog("=====request_newGuide===",tbMsg )
	if nType == 1 then
		local newGuideInfo = {id = id,status = value}
		g_newGuideMsg:setTbGuideByID(id,newGuideInfo)
	end 
	g_svResponseMsgControl:setResponseTagFunc(24,callback)
	sendWsSocketData("request_newGuide", tbMsg)
end

--命名
function svSendMsgControl:request_setName(nType,name,callback)
	local tbMsg = {nType = nType ,name = name}
	g_svResponseMsgControl:setResponseTagFunc(3,callback)
	sendWsSocketData("request_setName", tbMsg)
end



--成就
function svSendMsgControl:request_taskInfo(itype,renwuID,taskid, callback)
	local tbMsg = {itype = itype , taskid = taskid , renwuID = renwuID}
	g_svResponseMsgControl:setResponseTagFunc(4,callback)
	sendWsSocketData("request_taskInfo", tbMsg)
end

--其他
function svSendMsgControl:request_msgString(nType,dec,value1,value2,sting1,callback,sting2)
	local tbMsg = {nType=nType,dec= dec,value1 = value1,value2 = value2 , sting1 = sting1,sting2 = sting2}
	cclog(tbMsg,"=====request_msgString===" ,sting1)
	g_svResponseMsgControl:setResponseTagFunc(5,callback)
	sendWsSocketData("request_msgString", tbMsg)
end


--ads 广告
function svSendMsgControl:request_videoAD(nType,status,resultType,callback, value )
	local tbMsg = {nType = nType, status = status,resultType = resultType , value = value}
	g_svResponseMsgControl:setResponseTagFunc(6,callback)
	sendWsSocketData("request_videoAD", tbMsg)
end


function svSendMsgControl:request_cmdMsg(cmd,value1,value2,value3,callback,sting1)
	local tbMsg = {cmd = cmd,value1= value1,value2 = value2,value3 = value3 ,sting1 = sting1}
	g_svResponseMsgControl:setResponseTagFunc(7,callback)
	sendWsSocketData("request_cmdMsg", tbMsg)
end



function svSendMsgControl:request_mail(nType,mailID,callback)
	local tbMsg = {nType = nType,mailID = mailID}
	g_svResponseMsgControl:setResponseTagFunc(8,callback)
	sendWsSocketData("request_mail", tbMsg)
end


--
function svSendMsgControl:request_getResMsg(nType,id,callback)
	cclog("==request_getResMsg==",nType,id)
	local tbMsg = {nType = nType ,id = id}
	g_svResponseMsgControl:setResponseTagFunc(9,callback)
	sendWsSocketData("request_getResMsg", tbMsg)
end

--
function svSendMsgControl:request_getRoleMsg(nType,id,value,callback)
	cclog("==request_getRoleMsg==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value = value}
	g_svResponseMsgControl:setResponseTagFunc(10,callback)
	sendWsSocketData("request_getRoleMsg", tbMsg)
end

function svSendMsgControl:request_getEquMsg(nType,id,value,tbClientMsg,callback)
	cclog("==request_getEquMsg==",nType,id,value,tbClientMsg)
	local tbMsg = {nType = nType ,id = id,value = value,tbClientMsg = tbClientMsg}
	g_svResponseMsgControl:setResponseTagFunc(11,callback)
	sendWsSocketData("request_getEquMsg", tbMsg)
end
function svSendMsgControl:request_getBagMsg(nType,id,value,callback)
	cclog("==request_getBagMsg==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value = value}
	g_svResponseMsgControl:setResponseTagFunc(12,callback)
	sendWsSocketData("request_getBagMsg", tbMsg)
end

function svSendMsgControl:request_getPetMsg(nType,id,value,tbClientMsg)
	cclog("==request_getPetMsg==",nType,id,value,tbClientMsg)
	local tbMsg = {nType = nType ,id = id,value = value,tbClientMsg = tbClientMsg}
	sendWsSocketData("request_getPetMsg", tbMsg)
end

function svSendMsgControl:request_getTianfuMsg(nType,id,value,callback)
	cclog("==request_getTianfuMsg==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value = value}
	sendWsSocketData("request_getTianfuMsg", tbMsg)
end

function svSendMsgControl:request_getRoleSkillMsg(nType,id,value,callback)
	cclog("==request_getRoleSkillMsg==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value = value}
	sendWsSocketData("request_getRoleSkillMsg", tbMsg)
end


function svSendMsgControl:request_geTujianMsg(nType,id,value,callback)
	cclog("==request_geTujianMsg==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value = value}
	sendWsSocketData("request_geTujianMsg", tbMsg)
	g_svResponseMsgControl:setResponseTagFunc(1000,callback)

end


function svSendMsgControl:request_geBatMsg(nType,id,value,valueStr,valueStr4)
	cclog("==request_geBatMsg==",nType,id,value,valueStr)
	local tbMsg = {nType = nType ,id = id,value = value,valueStr = valueStr, valueStr4 = valueStr4}
	sendWsSocketData("request_geBatMsg", tbMsg)
end

function svSendMsgControl:request_geDaliyMsg(nType,id,value,callback)
	cclog("==request_geDaliyMsg==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value = value}
	sendWsSocketData("request_geDaliyMsg", tbMsg)
end


function svSendMsgControl:request_getChengjiuMsg(nType,id,value,callback)
	cclog("==request_getChengjiuMsg==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value = value}
	sendWsSocketData("request_getChengjiuMsg", tbMsg)
end

function svSendMsgControl:request_getShopMsg(nType,id,value,callback)
	cclog("==request_getShopMsg==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value = value}
	sendWsSocketData("request_getShopMsg", tbMsg)
end
function svSendMsgControl:request_getqianDaoMsg(nType,id,value,callback)
	cclog("==request_getqianDaoMsg==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value = value}
	sendWsSocketData("request_getqianDaoMsg", tbMsg)
end

function svSendMsgControl:request_getBaozangMsg(nType,id,value,callback)
	cclog("==request_getBaozangMsg==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value = value}
	sendWsSocketData("request_getBaozangMsg", tbMsg)
end


function svSendMsgControl:request_rankInfo(nType,id,value1,value2,value3)
	cclog("==request_rankInfo==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value1 = value1,value2 = value2 ,value3 = value3}
	sendWsSocketData("request_rankInfo", tbMsg)
end

function svSendMsgControl:request_daoyuInfo(nType,id,value1,value2,value3)
	cclog("==request_daoyuInfo==",nType,id,value)
	local tbMsg = {nType = nType ,id = id,value1 = value1,value2 = value2 ,value3 = value3}
	sendWsSocketData("request_daoyuInfo", tbMsg)
end


function svSendMsgControl:request_lyuInfo(nType,id,value1)
	local tbMsg = {nType = nType ,id = id,value1 = value1}
	sendWsSocketData("request_lyuInfo", tbMsg)
end

function svSendMsgControl:ctor()
	
end

g_svSendMsgControl =  svSendMsgControl:create()