
local B_Bag = class("B_Bag")

function B_Bag:initCheckBtn()
	local c4 =  self.rootLayout:getController("c4") --控制器
	local bagEquType = cc.UserDefault:getInstance():getIntegerForKey("bagEquType",1)
	c4:setSelectedIndex(bagEquType-1)
	for i=1,3 do
		local  checkBtn =  self.rootLayout:getChild("checkBtn"..i) 
		if bagEquType == i then
			self.curChecBtn = checkBtn
		end 
		local function funcEndCallBack(btn,tag) 
			cc.UserDefault:getInstance():setIntegerForKey("bagEquType",tag)
			c4:setSelectedIndex(tag-1)
			
			self.curChecBtn = btn
			self:reloadListEuq(true)
			
		end
		g_SetBtn(self.rootLayout,"checkBtn"..i,i, funcEndCallBack)
	end 
end 

function B_Bag:initCheckBtnGoods()
	local c7 =  self.rootLayout:getController("c7") --控制器
	local bagGoodsType = cc.UserDefault:getInstance():getIntegerForKey("bagGoodsType",1)
	c7:setSelectedIndex(bagGoodsType-1)
	for i=1,2 do
		local  checkBtn =  self.rootLayout:getChild("checkBtnGoods"..i) 
		if bagGoodsType == i then
			self.curChecBtnGoods = checkBtn
		end 
		local function funcEndCallBack(btn,tag) 
			cc.UserDefault:getInstance():setIntegerForKey("bagGoodsType",tag)
			c7:setSelectedIndex(tag-1)
			self.curChecBtnGoods = btn
		
			self:reloadList(true)
		end
		g_SetBtn(self.rootLayout,"checkBtnGoods"..i,i, funcEndCallBack)
	end 
end 

function B_Bag:initWnd()
	self.selectMsg = {}
	self:initCheckBtn()
	self:initCheckBtnGoods()
	local function funcEndCallBack(btn,tag) 
		cclog("======B_Bag==funcEndCallBack====",tag,self.curHzbID)
		
		if tag <100  then
			--c1:setSelectedIndex(1)
			self:touchBtn(0)
		else
			self:touchBtn(tag)
		end 
		
		self:touchEquItem(nil,self.curHzbID)
	end 
	for i=0,9 do
		g_SetBtn(self.rootLayout, "btnEuq"..i,i, funcEndCallBack)	
	end 
	g_SetBtn(self.rootLayout, "btn0",0, funcEndCallBack)
	g_SetBtn(self.rootLayout, "btn100",100, funcEndCallBack)	
	g_SetBtn(self.rootLayout, "btn101",101, funcEndCallBack)
	g_SetBtn(self.rootLayout, "btn102",102, funcEndCallBack)

	local  checkBtnAll =  self.rootLayout:getChild("checkBtnAll") 
	local function funcEndCallBack(btn,tag) 
		cclog("=======funcEndCallBack======",tag)
		if tag == 103  then
			
			self:showCheckBtn()
		elseif tag == 104  then
			
			local count =  getTbCount(self.selectMsg)
			if count > 0 then
				local tbClientMsg = {}
				local staus 
				for i,ID in pairs(self.selectMsg)do
					tbClientMsg[#tbClientMsg+1] = ID
					local info = g_zbMsg:getEuqTbMsg(ID)
					if info then
						local runeMsg = info.runeMsg or {}
						for i,v in pairs(runeMsg)do
							if  v > 0 then
								staus = true
								break
							end 
						end

					end 
					
				end 
				if  staus then
					local tbQDMsg = {}
					tbQDMsg.dec =  "装备中镶嵌有符文，是否继续分解"
					tbQDMsg.text1 = "确定"
					tbQDMsg.text2 = "取消"
					local function callBack()
						g_svSendMsgControl:request_getEquMsg(9,nil,nil,tbClientMsg)
					end 
					tbQDMsg.qdFunc =  callBack
					g_quedingItem:openWnd(tbQDMsg) 
				end 
				
				g_svSendMsgControl:request_getEquMsg(9,nil,nil,tbClientMsg)
			end 

		elseif tag == 105  then
			local selectSta = tonumber(checkBtnAll:getText())
			selectSta = (selectSta+1)%2
			checkBtnAll:setText(selectSta)
			
			self:selectAll()
		end 
		self:showCheckBtn()
	end 
	g_SetBtn(self.rootLayout, "btnFjie",103, funcEndCallBack)	
	g_SetBtn(self.rootLayout, "btnQD",104, funcEndCallBack)
	g_SetBtn(self.rootLayout, "touchSelect",105, funcEndCallBack)
	
	
	
	local function funcEndCallBack(btn,tag) 
		local bagBuyBum = g_baseMsg:getOther(otherDBMsgID.bagBuyBum) or  0
		local cost =  tbGameConst.BagBuyZs + bagBuyBum*tbGameConst.BagBuyZs
		
		local tbQDMsg = {}
		tbQDMsg.dec =  "是否花费"..cost.."钻石扩展背包,容量+5"
		tbQDMsg.text1 = "确定"
		tbQDMsg.text2 = "取消"
		local function callBack()
			g_svSendMsgControl:request_getBagMsg(11)
		end 
		tbQDMsg.qdFunc =  callBack
		g_quedingItem:openWnd(tbQDMsg) 
		g_svSendMsgControl:request_getBagMsg(6)
	end
	g_SetBtn(self.rootLayout, "btnAdd",1, funcEndCallBack)	
end 

function B_Bag:setBagNum()
	local maxBagNum = g_bagMsg:getMaxBagNum()
	local num = g_bagMsg:getcurBagEquNum()
	local  txextBagNum =  self.rootLayout:getChild("txextBagNum") 
	txextBagNum:setText("背包："..num.."/"..maxBagNum)

end 

function B_Bag:selectAll()
	local  checkBtnAll =  self.rootLayout:getChild("checkBtnAll") 
	local selectSta = checkBtnAll:getText()
	if selectSta == "1" then
		for i,ID in pairs(self.EuqBgTbMsg)do
			local info = g_zbMsg:getEuqTbMsg(ID)
			if (not info.isClock or info.isClock == 0 ) and (not info.inRole or  info.inRole  == 0 ) then
				self.selectMsg[ID] = ID
			end 
		end 
	else
		self.selectMsg = {}
	end 
end 

function B_Bag:showCheckBtnOne(curChild)
	local ID = curChild:getCustomData()
	local info = g_zbMsg:getEuqTbMsg(ID)
	local c3 =  curChild:getController("c3") --控制器
	local c6 =  self.rootLayout:getController("c6") --控制器
	local index = c6:getSelectedIndex()
	if info then
		local inRole = info.inRole
		cclog(index,"====222==showCheckBtn=")
		if index == 1 then
			if  (inRole and inRole > 0) or (info.isClock and  info.isClock > 0) then
				c3:setSelectedIndex(0)
			else
				c3:setSelectedIndex(1)
				local  checkBtn1 = curChild:getChild("checkBtn1") 
					
				if not  self.selectMsg[ID] or self.selectMsg[ID] <= 0  then
					checkBtn1:setText(0)
				else
					checkBtn1:setText(1)
				end 
			end 
		else
			c3:setSelectedIndex(0)
		end 
	else	
		c3:setSelectedIndex(0)
	end 
end

function B_Bag:showCheckBtn()
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	local  bagListEuq =  euqPanle:getChild("bagListEuq") 
	local chidren = bagListEuq:getChildren()

	cclog(index,"======showCheckBtn=")
	for i =1, #chidren do
		local curChild = chidren[i] 
		self:showCheckBtnOne(curChild)	
	end
end 

function B_Bag:closeWnd()
	self.EquPanle = nil
	g_WndMgr.mainBtn:setVisible(true)
end 
function B_Bag:closeWnd_goodsDecItem()
	cclog("=====closeWnd_goodsDecItem=======",self.curTouchGoodsID)
	--[[if self.curTouchGoodsID then
		local  bagList =  self.rootLayout:getChild("bagList") 
		local panle = getChildById(bagList, self.curTouchGoodsID)
		if panle then
			local c1 =  panle:getController("c1") --控制器
			c1:setSelectedIndex(0)
		end 
	end ]]
end 

function B_Bag:touchGoodsItem(obj,cfgID,isReload)
	if isReload and  cfgID ~= self.curTouchGoodsID  then
		return
	end 
	cclog("====touchGoodsItem=========",self.touchTag)
	if self.touchTag < 100  then
		return
	end 
	local  bagList =  self.rootLayout:getChild("bagList") 
	if self.curTouchGoodsID then
		local panle = getChildById(bagList, self.curTouchGoodsID)
		if panle then
			local c1 =  panle:getController("c1") --控制器
			c1:setSelectedIndex(0)
		end 
	end 
	if (not cfgID or self.curTouchGoodsID == cfgID ) and not isReload then
		 g_panleMgr:closeWndPanle()
		 self.curTouchGoodsID = nil
	
		return
	end 
	if not obj then
		obj = getChildById(bagList, cfgID)
	end 
	if not obj then
		cclog("== not obj=",self.touchTag)
		return
	end 
	local c1 =  obj:getController("c1") --控制器
	c1:setSelectedIndex(1)
	self.curTouchGoodsID = cfgID
	local pos
	local  item = obj:displayObject()
	local toPos = getWorildPos(item)
	if  toPos.y <= 820 then
		pos = {91,246}
	else
		pos = {91,881}
	end 
	local panle = g_panleMgr:showWndPanle("goodsDecItem",cfgID,nil,nil,pos)
	---cclog(panle,"===222===")
	return  panle
end 
function B_Bag:setListItemGoods(obj,cfgID)
	if not obj then
		local  bagList =  self.rootLayout:getChild("bagList") 
		obj = getChildById(bagList,cfgID)
	end 
	if not obj then
		return
	end 
	local  textNum =  obj:getChild("textNum") 
	local  title =  obj:getChild("title") 
	
	local tbMsg =  g_cfgMsg:getCfgMsg("goods_D",cfgID)
	if not tbMsg or  not  cfgID then
		g_bagMsg:delGoodsTbMsg(cfgID)
		return
	end 
	local  value = g_bagMsg:getGoodsTbMsg(cfgID) or 0
	textNum:setText("数量："..value)
	obj:setText("【"..tbMsg.name.."】")
	
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)

	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(title,colorID,true)
	
	local function funcEndCallBack(btn,tag) 
		local panle = self:touchGoodsItem(obj,cfgID)
		if not panle then
			return
		end 
		---
	end 
	g_SetBtnOne(nil,nil,cfgID, funcEndCallBack,obj)
	
	local c1 =  obj:getController("c1") --控制器
	if  cfgID ==  self.curTouchGoodsID then	
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
	--if value <= 0 then
	--	self:touchBtn(self.touchTag,true)
	---end 
end

function B_Bag:setListItemRune(obj,cfgID)
	if self.touchTag ~= 101  then
		return
	end 
	if not obj then
		local  bagList =  self.rootLayout:getChild("bagList") 
		obj = getChildById(bagList,cfgID)
	end 
	if not obj then
		return
	end 
	local  textNum =  obj:getChild("textNum") 
	local tbMsg =  g_cfgMsg:getCfgMsg("rune_D",cfgID)
	local  value = g_bagMsg:getRuneTbMsg(cfgID)
	textNum:setText("数量："..value)

	local  title =  obj:getChild("title") 
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)
	title:setText(name.."Lv."..tbMsg.lev)
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(title,colorID,true)
	
	local function funcEndCallBack(btn,tag) 
		 local panle = self:touchGoodsItem(obj,cfgID)
		 if not panle then
			return
		 end 
		 --g_gNodeConTrol:setRuneDecItem(panle,cfgID)
	end 
	g_SetBtnOne(nil,nil,cfgID, funcEndCallBack,obj)
	
	local c1 =  obj:getController("c1") --控制器
	if  cfgID ==  self.curTouchGoodsID then	
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
end

function B_Bag:setListItemPet(obj,cfgID)
	if not obj then
		local  bagList =  self.rootLayout:getChild("bagList") 
		obj = getChildById(bagList,cfgID)
	end 
	if not obj then
		return
	end 
	local  textNum =  obj:getChild("textNum") 
	local value = g_bagMsg:getpetSkillTbMsg(cfgID)
	
	textNum:setText("数量："..value)

	local  title =  obj:getChild("title") 
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)
	
	title:setText(name)
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(title,colorID,true)
	
	local function funcEndCallBack(btn,tag) 
		 local panle = self:touchGoodsItem(obj,cfgID)
		 if not panle then
			return
		 end 
		--
	end 
	g_SetBtnOne(nil,nil,cfgID, funcEndCallBack,obj)
	
	local c1 =  obj:getController("c1") --控制器
	if  cfgID ==  self.curTouchGoodsID then	
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
end

function B_Bag:sortListTb1()
	local bagEquType = cc.UserDefault:getInstance():getIntegerForKey("bagEquType",1)
	local function comps(a,b)
		local info1 = g_zbMsg:getEuqTbMsg(a)
		local info2 = g_zbMsg:getEuqTbMsg(b)
		local inRole1 = info1.inRole or 0
		local inRole2 = info2.inRole or 0
		if inRole1 > inRole2 then
			return true
		elseif  inRole1 < inRole2 then
			return false
		end 
		if bagEquType == 2 then
			local yanse1 = info1.yanse
			local yanse2 = info2.yanse
			if yanse1 == yanse2 then
				local pinfen1 = info1.pinfen or  g_mathConTrol:mathEquPoint(info1.id)
				local pinfen2 = info2.pinfen or  g_mathConTrol:mathEquPoint(info2.id)
				if pinfen1 == pinfen2 then
					local runeNum1 = info1.runeNum
					local runeNum2 = info2.runeNum
					if runeNum1 == runeNum2 then
						local cfgID1 = info1.cfgID
						local cfgID2 = info2.cfgID
						if cfgID1 == cfgID2 then
							return info1.id > info2.id 
						else
							return cfgID1 > cfgID2
						end 
					else
						return runeNum1 > runeNum2
					end 
				else
					return pinfen1 > pinfen2
				end 
				
			else
				return yanse1 > yanse2
			end 
		elseif  bagEquType == 3 then
			local runeNum1 = info1.runeNum
			local runeNum2 = info2.runeNum
			if runeNum1 == runeNum2 then
				local yanse1 = info1.yanse
				local yanse2 = info2.yanse
				if yanse1 == yanse2 then
					local pinfen1 = info1.pinfen or  g_mathConTrol:mathEquPoint(info1.id)
					local pinfen2 = info2.pinfen or  g_mathConTrol:mathEquPoint(info2.id)
					if pinfen1 == pinfen2 then
						local cfgID1 = info1.cfgID
						local cfgID2 = info2.cfgID
						if cfgID1 == cfgID2 then
							return info1.id > info2.id 
						else
							return cfgID1 > cfgID2
						end 
					else
						return pinfen1 > pinfen2
					end 
				else
					return yanse1 > yanse2
				end 
				
			else
				return runeNum1 > runeNum2
			end 
		elseif  bagEquType == 1 then
			local pinfen1 = info1.pinfen or  g_mathConTrol:mathEquPoint(info1.id)
			local pinfen2 = info2.pinfen or  g_mathConTrol:mathEquPoint(info2.id)
			if pinfen1 == pinfen2 then
				local yanse1 = info1.yanse
				local yanse2 = info2.yanse
				if yanse1 == yanse2 then
					local zbLev1 = info1.zbLev
					local zbLev2 = info2.zbLev
					if zbLev1 == zbLev2 then
						local cfgID1 = info1.cfgID
						local cfgID2 = info2.cfgID
						if cfgID1 == cfgID2 then
							return info1.id > info2.id 
						else
							return cfgID1 > cfgID2
						end 
					else
						return zbLev1 > zbLev2
					end 
				else
					return yanse1 > yanse2
				end 
			else
				return pinfen1 > pinfen2
			end 
		end 
		return a.numberKey < b.numberKey
	end
	table.sort(self.EuqBgTbMsg, comps)
end 
function B_Bag:sortListTb2()
	local function comps(a,b)
		return a > b 
	end 
	table.sort(self.BgTbMsg, comps)
end 	

function B_Bag:sortListTbGoods()
	local function comps(a,b)
		local tbMsgA = g_cfgMsg:getCfgMsg("goods_D",a)
		local tbMsgB = g_cfgMsg:getCfgMsg("goods_D",b)
		if tbMsgA.value5 == tbMsgB.value5 then
			return a > b 
		else
			return tbMsgA.value5 > tbMsgB.value5 
		end 
	end 
	table.sort(self.BgTbMsg, comps)
end 	


function B_Bag:reloadList(reload)
	self.BgTbMsg = {}
	if self.curTouchGoodsType and self.curTouchGoodsType == self.touchTag and not reload then
		return
	end 
	self.curTouchGoodsType = self.touchTag
	if self.touchTag == 100 then
		local TbMsg = g_bagMsg:getGoodsTbMsg()
		for cfgID,v in pairs(TbMsg)do
			--cclog(v,"==reloadList=====")
			if v.number > 0  then
				self.BgTbMsg[#self.BgTbMsg+1] = cfgID
			end 
		end 
		local bagGoodsType = cc.UserDefault:getInstance():getIntegerForKey("bagGoodsType",1)
		if bagGoodsType == 1 then
			self:sortListTb2()
		else
			self:sortListTbGoods()
		end 
		
	elseif self.touchTag == 101 then
		local TbMsg = g_bagMsg:getRuneTbMsg()
		for cfgID,v in pairs(TbMsg)do
			if v.number > 0  then
				self.BgTbMsg[#self.BgTbMsg+1] = cfgID
			end 
		end
		self:sortListTb2()
	elseif self.touchTag == 102 then
	
		local TbMsg = g_bagMsg:getpetSkillTbMsg()
		for cfgID,v in pairs(TbMsg)do
			--cclog(cfgID,"=====cfgID=====")
			if cfgID >= 87000101 and  cfgID <= 87010000 and  v.number > 0 then
				self.BgTbMsg[#self.BgTbMsg+1] = cfgID
			end 
		end
		self:sortListTb2()
	end 

	local  bagList =  self.rootLayout:getChild("bagList") 
	bagList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local cfgID = self.BgTbMsg[indexD]
			obj:setCustomData(cfgID)
			if self.touchTag == 100 then
				self:setListItemGoods(obj,cfgID)	
			elseif self.touchTag == 101 then	
				self:setListItemRune(obj,cfgID)	
			elseif self.touchTag == 102 then	
				self:setListItemPet(obj,cfgID)		
			end
			
		end)
	bagList:setVirtual()--回调
	bagList:setNumItems(#self.BgTbMsg);
	
end 

function B_Bag:showEquDecPanle(zbID,reload)
	if reload then
		zbID = self.curTouchEuqID
	end 
	--local panle = g_panleMgr:showWndPanle("equDecItem",zbID)
	
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	local  equDecItem =  euqPanle:getChild("equDecItem") 
	if not  zbID  then
		return
	end 
	local info = g_zbMsg:getEuqTbMsg(zbID)
	if  info then
		g_gNodeConTrol:setEquDecItem(equDecItem,info)
		equDecItem:setVisible(true)
	else
		equDecItem:setVisible(false)
	end 
	
	self.EquPanle = equDecItem
end 

function B_Bag:getEquListItem(zbID)
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	if self.curHzbID == zbID then
		panle =  euqPanle:getChild("myEquItem") 
	else
		local  bagListEuq =  euqPanle:getChild("bagListEuq") 
		panle = getChildById(bagListEuq, self.curTouchEuqID)
	end 
	return  panle
end 

function B_Bag:touchEquItem(obj,zbID)
	if self.curTouchEuqID then
		local  euqPanle =  self.rootLayout:getChild("euqPanle") 
		local panle = self:getEquListItem(self.curTouchEuqID)
		
		if panle then
			local c1 =  panle:getController("c1") --控制器
			c1:setSelectedIndex(0)
		end 
	end 
	if not obj then
		local  euqPanle =  self.rootLayout:getChild("euqPanle") 
		obj = self:getEquListItem(zbID)

	end 
	if not obj then
		return
	end 
	local c1 =  obj:getController("c1") --控制器
	c1:setSelectedIndex(1)
	self.curTouchEuqID = zbID
	self:showEquDecPanle(zbID)
end 

function B_Bag:setListItemEqu(obj,zbID)
	if not obj then
		obj = self:getEquListItem(zbID)
	end 
	if not obj then
		
		return
	end 
	
	local  textEquName =  obj:getChild("textEquName") 
	local  textEquT =  obj:getChild("textEquT") 
	local  textEquKLev =  obj:getChild("textEquKLev") 
	
	
	local info = g_zbMsg:getEuqTbMsg(zbID)
	local c1 =  obj:getController("c1") --控制器
	local c2 =  obj:getController("c2") --控制器
	local c4 =  obj:getController("c4") --控制器
	
	if not info or not  info.cfgID or  info.cfgID <= 0 then
		c2:setSelectedIndex(1)
		c1:setSelectedIndex(0)
		c4:setSelectedIndex(0)

		return
	end 
	self:showCheckBtnOne(obj)	
	c2:setSelectedIndex(0)
	local name,yanse,tbEquMsg = g_getNameConTrol:getAllMsg(info.cfgID)
	textEquName:setText(name)
	local colorID = G_tb_TextColor[info.yanse]
	
	cc.g_setTextColor(textEquName,colorID,true)
	textEquKLev:setText("Lv."..info.zbLev)
	
	local  textEquT =  obj:getChild("textEquT") 
	if tbEquMsg.nameT2 then
		textEquT:setText(tbEquMsg.nameT2)
	else	
		textEquT:setText("")
	end 

	for i=1,2 do
		local  euqAtt =  obj:getChild("euqAtt"..i) 
		local lev = info.mainAttLev[i] or 0
		if lev <= 0 then
			euqAtt:setVisible(false)
		else
			euqAtt:setVisible(true)
			euqAtt:setIcon(g_iconConTrol:getABCDIcon(lev))
		end 
	end 
	local  conClock =  obj:getChild("conClock") 
	if info.isClock and info.isClock == 1 then
		conClock:setVisible(true)
	else
		conClock:setVisible(false)
	end 
	local textEquPinfen =  obj:getChild("textEquPinfen") 
	if not info.pinfen then
		info.pinfen = g_mathConTrol:mathEquPoint(info.id)
		g_zbMsg:setEuqTbMsg(info)  
	end 

	textEquPinfen:setText("评分："..info.pinfen)
	if not info.runeMsg then
		info.runeMsg = {}
	end 
	
	for i=1,7 do
		local  stItem =  obj:getChild("stItem"..i) 
		
		if stItem  then
			if  i > info.runeNum  then
				stItem:setVisible(false)
			else
				stItem:setVisible(true)
				local FWID = info.runeMsg[i] or 0
				
				if FWID > 0 then
					local name,yanse,tbMsg,baseName = g_getNameConTrol:getAllMsg(FWID)
					stItem:setIcon(g_iconConTrol:getFWYanseIcon(yanse))
				else
					stItem:setIcon(g_iconConTrol:getFWYanseIcon(0))
				end 
			end 
		end 
	end 
	
	local c2 =  obj:getController("c2") --控制器
	if not zbID or zbID <= 0 then
		c2:setSelectedIndex(1)
		c1:setSelectedIndex(0)
		return
	end 
	c2:setSelectedIndex(0)
	local function funcEndCallBack(btn,tag) 
		self:touchEquItem(obj,zbID)
	end 
	g_SetBtnOne(nil,nil,cfgID, funcEndCallBack,obj)
	
	
	cclog(zbID,"==setListItemEqu===11=",self.curTouchEuqID,info.inRole)

	if info.inRole and info.inRole > 0  then
		c4:setSelectedIndex(1)
	else
		c4:setSelectedIndex(0)
	end 
	if  zbID ==  self.curTouchEuqID then	
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
 
	local  checkBtn1 = obj:getChild("checkBtn1") 
	local function funcEndCallBack(btn,tag) 
		local index = tonumber(btn:getText())
		index = (index+1)%2
		btn:setText(index)
		if  index == 1 then
			self.selectMsg[zbID] = zbID
		else
			self.selectMsg[zbID] = nil
		end 
	end 
	g_SetBtnOne(nil,nil,1,funcEndCallBack,checkBtn1)	
	if not  self.selectMsg[zbID] or self.selectMsg[zbID] <= 0  then
		checkBtn1:setText(0)
	else
		checkBtn1:setText(1)
	end 


	local  textLevQH =  obj:getChild("textLevQH") 
	if  info.QHLev and info.QHLev > 0 then
		textLevQH:setText("A"..info.QHLev)
	else
		textLevQH:setText("")
	end 
	
end


function B_Bag:setListItemEquTaoItem(obj,nType,num)
	local cfgID = 61100001 + (nType - 1)*100
	local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D",cfgID)
	local name = tbMsg.nameT2..num
	local index = math.floor(num/3)
	local c1 =  obj:getController("c1") --控制器
	c1:setSelectedIndex(index)
	obj:setText(name)
end

function B_Bag:reloadListEuqTaoList(reload)
	local  equTaoList =  self.rootLayout:getChild("equTaoList") 
	local tbMsg = {}
	for nType,v in pairs(g_roleMsg.tbTaozMsg)do
		
		tbMsg[#tbMsg + 1] =  {nType,v}
	end 

	equTaoList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local nType = tbMsg[indexD][1]
			local num = tbMsg[indexD][2]
			obj:setCustomData(nType)
			self:setListItemEquTaoItem(obj,nType,num)
		end)
	equTaoList:setVirtual()--回调
	equTaoList:setNumItems(#tbMsg);
end 

function B_Bag:reloadListEuq(reload)
	local c3 =  self.rootLayout:getController("c3") --控制器
	self.EuqBgTbMsg = {}
	local euqTbMsg = g_bagMsg:getBagEuqTbMsg()
	
	local nTypeIndex = c3:getSelectedIndex() 
	if self.curTouchEuqType and self.curTouchEuqType  == nTypeIndex and not reload then
		return
	end 
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	local c2 =  euqPanle:getController("c2") --控制器
	if  nTypeIndex == 0 then
		for index =1, 9 do
			local HaEquID = g_roleMsg:getTbZbID(index)  or 0
			if HaEquID > 0 then
				self.EuqBgTbMsg[#self.EuqBgTbMsg+1] = HaEquID
			end 
		end 
		c2:setSelectedIndex(1)
	else
		c2:setSelectedIndex(0)
	end 
	for ID,v in pairs(euqTbMsg)do
		local info = g_zbMsg:getEuqTbMsg(ID)
		if info then
			local name,yanse,cfgEquMsg =  g_getNameConTrol:getAllMsg(info.cfgID) 
			local nType = cfgEquMsg.nType
			if nTypeIndex == 0 or  nType == nTypeIndex then
				self.EuqBgTbMsg[#self.EuqBgTbMsg+1] = ID
			end 
		end 
		
	end 
	self:sortListTb1()

	local  bagListEuq =  euqPanle:getChild("bagListEuq") 
	bagListEuq:itemRenderer(function(index, obj)
			local indexD = index + 1
			local zbID = self.EuqBgTbMsg[indexD]
			obj:setCustomData(zbID)
			self:setListItemEqu(obj,zbID)
		end)
	bagListEuq:setVirtual()--回调
	bagListEuq:setNumItems(#self.EuqBgTbMsg);
	
	local  title =  euqPanle:getChild("title") 
	local nameB = g_tb_zhuangbeiType_cn[nTypeIndex]
	
	if nTypeIndex > 0 then
		title:setText(nameB.."背包("..#self.EuqBgTbMsg..")")
		self.curHzbID = g_roleMsg:getTbZbID(nTypeIndex) 
		self:setMyEquItem()
	else
		title:setText("背包("..#self.EuqBgTbMsg..")")
		for i=1,9 do
			self.curHzbID = g_roleMsg:getTbZbID(i) 
			if self.curHzbID > 0  then
				break 
			end 
		end 
		self:setMyEquItem()
	end 
	self.curTouchEuqType = nTypeIndex
	self:reloadListEuqTaoList()
end 


function B_Bag:setMyEquItem()
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	local panle =  euqPanle:getChild("myEquItem") 
	
	if not self.curHzbID or self.curHzbID == 0 then
		panle:setVisible(false)
		return
	else
		panle:setVisible(true)
	end 
	self:setListItemEqu(panle,self.curHzbID)
	return panle
end 
function B_Bag:touchBtn(tag,reload)
	local c2 =  self.rootLayout:getController("c2") --控制器
	cclog("====touchBtn===",tag)
	self.touchTag = tag
	if tag == 0 then --装备
		c2:setSelectedIndex(0)
		self:reloadListEuq()
	elseif tag == 100 then --道具
		self:reloadList(reload)
		c2:setSelectedIndex(1)
	elseif tag == 101 then --符文
		self:reloadList(reload)
		c2:setSelectedIndex(2)
	elseif tag == 102 then --宠物技能
		self:reloadList(reload)
		c2:setSelectedIndex(3)		
	end 
end

function B_Bag:showEquMaopao()
	for i=1,9 do
		local  btnEuq =  self.rootLayout:getChild("btnEuq"..i) 
		local euqTbMsg = g_bagMsg:getBagEuqTbMsg()
		for zbID,v in pairs(euqTbMsg)do
			local info = g_zbMsg:getEuqTbMsg(zbID)
			if info then
				local name,yanse,cfgEquMsg =  g_getNameConTrol:getAllMsg(info.cfgID) 
				local nType = cfgEquMsg.nType
				if nType == i then
					local c2 =  btnEuq:getController("c2") --控制器
					c2:setSelectedIndex(1)
					break
				end 
			end 
		end 
	end
end 

function B_Bag:openWnd(index1,euqType,c5D)
	local index  = index1 or 0
	
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	local  equDecItem =  euqPanle:getChild("equDecItem") 
	equDecItem:setVisible(false)
	
	local c3 =  self.rootLayout:getController("c3") --控制器
	
	cclog(euqType,index,"=====openWnd===B_Bag====",index1,euqType,c5D)
	if euqType  then
		self:touchBtn(0)
		c3:setSelectedIndex(euqType-1)
	else
		self:touchBtn(index)
	end 
	
	local c5 =  self.rootLayout:getController("c5") --控制器
	if c5D then
		c5:setSelectedIndex(c5D)
		g_WndMgr.mainBtn:setVisible(false)
	end 
	self:setBagNum()
	self:showEquMaopao()
end 

	
return B_Bag
