
local B_Pet = class("B_Pet")


function B_Pet:initCheckBtn()
	local c4 =  self.rootLayout:getController("c4") --控制器
	local sortType = cc.UserDefault:getInstance():getIntegerForKey("sortType",1)
	c4:setSelectedIndex(sortType-1)
	for i=1,3 do
		local  checkBtn =  self.rootLayout:getChild("checkBtn"..i) 
		if sortType == i then
			self.curChecBtn = checkBtn
		end 
		local function funcEndCallBack(btn,tag) 
			c4:setSelectedIndex(tag-1)
			self.curChecBtn = btn
			self:reloadPatList(tag)
			cc.UserDefault:getInstance():setIntegerForKey("bagEquType",tag)
			
		end
		g_SetBtn(self.rootLayout,"checkBtn"..i,i, funcEndCallBack)
		if i == 1 then
			self.curChecBtn = checkBtn
		end 
	end 	
end 

function B_Pet:initWnd()
	local c1 =  self.rootLayout:getController("c1") --控制器
	local c3 =  self.rootLayout:getController("c3") --控制器
	local c5 =  self.rootLayout:getController("c5") --控制器

	local c2 =  self.rootLayout:getController("c2") --控制器
	
	local  checkBtnAll =  self.rootLayout:getChild("checkBtnAll") 
	local function funcEndCallBack(btn,tag) 
		cclog("======initWnd======",tag)
		if tag == 1 then
			
			local panle = g_panleMgr:showWndPanle("ComponentTL",self.cutTouchID)
			c2:setSelectedIndex(1)
		elseif tag == 2 then
			---local panle = g_panleMgr:showWndPanle("ComponentQB",self.cutTouchID)
			--
			local panle = g_panleMgr:showWndPanle("ComponentLevUpStar")
			c2:setSelectedIndex(1)
		elseif tag == 3 then --锁定
			g_svSendMsgControl:request_getPetMsg(5,self.cutTouchID)
		elseif tag == 4 then	
			local curMapLev = g_batMath:getMapLev(1) 
			if curMapLev < 60 then
				g_action:ts_hszz_antion("黑石塔60层后开启")
				--return
			end 
			local panle = g_panleMgr:showWndPanle("petSkillPanle",self.cutTouchID)
		elseif tag == 5 then	
			local panle = g_panleMgr:showWndPanle("ComponentLevUp",self.cutTouchID)	
			c2:setSelectedIndex(1)
		elseif tag == 6 then --出战
			local index =  c5:getSelectedIndex()
			index = index + 1
			g_svSendMsgControl:request_getPetMsg(index,self.cutTouchID)
		elseif tag == 8 or tag == 7 then
			local index = c1:getSelectedIndex()
			index = (index+1)%2
			c1:setSelectedIndex(index)
			c3:setSelectedIndex(index)
			if tag == 7 then
				local count =  getTbCount(self.selectPetMsg)
				if count > 0 then
					local tbClientMsg = {}
					for i,petID in pairs(self.selectPetMsg)do
						tbClientMsg[#tbClientMsg+1] = petID
					end 
					if #tbClientMsg > 0 then
						g_svSendMsgControl:request_getPetMsg(12,self.tunshiPet,nil,tbClientMsg)
					end 
				end 
				self.tunshiPet = nil
			else
				if not self.tunshiPet then
					self.tunshiPet = self.cutTouchID
				end 
				if index == 0  then
					self.tunshiPet = nil
				end 
			end 
			self:showCheckBtn()
			c2:setSelectedIndex(0)
		elseif tag == 9 then 
			local selectSta = tonumber(checkBtnAll:getText())
			selectSta = (selectSta+1)%2
			checkBtnAll:setText(selectSta)
			self:selectAll()
		elseif tag == 10 then
			local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
			if zslevel < 8  then
				g_action:ts_hszz_antion("8转后开启")	
				return	
			end 
			g_WndMgr:showWnd("B_mShuoChang")
		end 
	end 
	g_SetBtnOne(self.rootLayout, "btnTL",1, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnStarUp",2, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnClock",3, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnSkill",4, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnLeUp",5, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnBat",6, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnQD",7, funcEndCallBack)
	g_SetBtnOne(self.rootLayout, "btnFS",8, funcEndCallBack)
	g_SetBtnOne(self.rootLayout, "checkBtnAll",9, funcEndCallBack)
	g_SetBtnOne(self.rootLayout, "btnLy",10, funcEndCallBack)
	
	
	local function funcEndCallBack(btn,tag) 
		local petMaxBuy = g_baseMsg:getOther(otherDBMsgID.petMaxBuy) or  0
		local cost =  tbGameConst.petBagBuyZs + petMaxBuy*tbGameConst.petBagBuyZs
		
		local tbQDMsg = {}
		tbQDMsg.dec =  "是否花费"..cost.."钻石扩展宠物栏,容量+"..tbGameConst.petBagBuyaddNum
		tbQDMsg.text1 = "确定"
		tbQDMsg.text2 = "取消"
		local function callBack()
			g_svSendMsgControl:request_getPetMsg(13)
		end 
		tbQDMsg.qdFunc =  callBack
		g_quedingItem:openWnd(tbQDMsg) 	
	end
	g_SetBtnOne(self.rootLayout, "addPatNum",1, funcEndCallBack)
end 

function B_Pet:selectAll()
	local  checkBtnAll =  self.rootLayout:getChild("checkBtnAll") 
	local selectSta = checkBtnAll:getText()
	if selectSta == "1" then
		for i,petID in pairs(self.petTbMsg)do
			local info = g_petMsg:getpetTbMsg(petID)
			if (not info.isClock or info.isClock == 0 ) and (not info.batIndex or  info.batIndex  == 0 )  and  self.tunshiPet ~= petID  then
				self.selectPetMsg[petID] = petID
			end 
		end 
	else
		self.selectPetMsg = {}
	end 
	self:showCheckBtn()
end 
function B_Pet:showCheckBtn()
	local  petList =  self.rootLayout:getChild("petList") 
	local chidren = petList:getChildren()
	local c1 =  self.rootLayout:getController("c1") --控制器
	local index = c1:getSelectedIndex()

	for i =1, #chidren do
		local curChild = chidren[i] 
		local petID = curChild:getCustomData()
		local info = g_petMsg:getpetTbMsg(petID)
		local isBat = info.batIndex
		local c2 =  curChild:getController("c2") --控制器
		if index == 1 then
			if  (isBat and isBat > 0) or (info.isClock and  info.isClock > 0) then
				c2:setSelectedIndex(0)
			else
				c2:setSelectedIndex(1)
				local  checkBtn1 = curChild:getChild("checkBtn1") 
				
				if not  self.selectPetMsg[petID] or self.selectPetMsg[petID] <= 0  then
					checkBtn1:setText(0)
				else
					checkBtn1:setText(1)
				end 
			end 
		else
			c2:setSelectedIndex(0)
		end 
	end
	
end 

function B_Pet:setPetNumText()
	local  petNumText =  self.rootLayout:getChild("petNumText") 
	local maxNum = g_mathConTrol:mathMaxPetNum()
	petNumText:setText("拥有："..#self.petTbMsg.."/"..maxNum)
end 

function B_Pet:mathCostPetBatIndexZS(index)
	local baseZs = 100
	local value = baseZs + 200*index
	return value
end
	

function B_Pet:showAnima(index)
	local  patItem =  self.rootLayout:getChild("patItem"..index) 
	local Panel_ = patItem:displayObject()
	local pos = cc.p(36,40)
	local ArmatureEndA = g_gArmature:showArmatureByNums("FateSellAnimation",nil,Panel_,nil,nil,pos,1.5,endCallBcak)
	g_gameMusic:playEffect(73)
end 
function B_Pet:reloadBatPatItemOne(index)
	cclog(index,"==reloadBatPatItemOne===2==")
	local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	local  patItem =  self.rootLayout:getChild("patItem"..index) 
	local petID = batPatMsg[index] or 0
	local  textLev = patItem:getChild("textLev") 
	local openLev = g_petMsg:isOpenBatIndex(index)  or -1  
	local c1 =  patItem:getController("c1") --控制器
	cclog(openLev,"====openLev========",index)
	if  openLev == -1 then
		c1:setSelectedIndex(1)
		local function callBack() 
			local costzs = self:mathCostPetBatIndexZS(index)
			--判断
			local status = g_baseConTrol:resEnough(g_resCfgId.diamond,costzs)
			if not status  then
				return 
			end 
			g_svSendMsgControl:request_getPetMsg(3,index)
		
		end 
		local function funcEndCallBack(btn,tag) 
			local costzs = self:mathCostPetBatIndexZS(index)
			local tbQDMsg = {}
			tbQDMsg.dec =  "是否花费"..costzs.."钻石开启一个战位"
			tbQDMsg.text1 = "确定"
			tbQDMsg.text2 = "取消"
			tbQDMsg.qdFunc =  callBack
			g_quedingItem:openWnd(tbQDMsg) 
			-- self:showAnima(index)
		end 
		g_SetBtnOne(nil, nil,8, funcEndCallBack,patItem)
		return
	else
		c1:setSelectedIndex(0)
		local function funcEndCallBack(btn,tag) 
			if petID > 0 then
				self:touchPetItem(nil,petID)
			end 
		end 
		g_SetBtnOne(nil, nil,8, funcEndCallBack,patItem)
	end 
	local  title = patItem:getChild("title") 
	--cclog("==reloadBatPatItemOne========",batPatMsg)
	local  starText =  patItem:getChild("starText")
	if petID > 0 then
		local info = g_petMsg:getpetTbMsg(petID)
		local cfgID = info.cfgID
		local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID) 
		title:setText(cfgMsg.name)
		local colorID = G_tb_TextColor[info.yanse]
		--cc.g_setTextColor(title,colorID,true)
		cc.g_setTextColor(textLev,colorID,true)
		
		local  title = patItem:getChild("title") 
		local  iconBg = patItem:getChild("iconBg") 
		patItem:setIcon(g_iconConTrol:getPetYanseIcon(info.yanse))
		iconBg:setIcon(g_iconConTrol:getPetYanseBgIcon(info.yanse))
		
		textLev:setText(info.Level.."级")
		
		
		starText:setText(G_tb_starText[(info.starLev or 0)])
	else
		title:setText("")
		textLev:setText("")
		starText:setText("")
	end 
end 

function B_Pet:reloadBatPatItemAll()
	for index=1, 7 do
		 self:reloadBatPatItemOne(index)
	end 
end 

function B_Pet:setListItem(obj,petID,notouch)
	local info = g_petMsg:getpetTbMsg(petID)
	if not obj then
		local  petList =  self.rootLayout:getChild("petList") 
		obj = getChildById(petList,petID)
	end 
	if not obj then
		return
	end 
	local  title =  obj:getChild("title") 
	local  icon =  obj:getChild("icon") 
	icon:setIcon(g_iconConTrol:getPetYanseIcon(info.yanse))
	local cfgID = info.cfgID
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID) 
	title:setText(cfgMsg.name)
	
	local  barExp =  obj:getChild("barExp")
	local maxExp = g_mathConTrol:mathPetMaxExp((info.starLev or 0) +1)
	barExp:setValue(info.nExp or 0)
	barExp:setMax(maxExp)
	
	local  textZZD =  obj:getChild("textZZD")
	textZZD:setText("【"..G_tb_ZZTypeD[cfgMsg.zhongzhu].."】")
	cc.g_setTextColor(textZZD,G_tb_ZZTextColor[cfgMsg.zhongzhu],true)
	
	local  iconBg = obj:getChild("iconBg") 
	obj:setIcon(g_iconConTrol:getPetYanseIcon(info.yanse))
	iconBg:setIcon(g_iconConTrol:getPetYanseBgIcon(info.yanse))
	local  textZZ =  obj:getChild("textZZ") 
	local  textLev =  obj:getChild("textLev") 
	local  skillText =  obj:getChild("skillText") 
	
	local colorID = G_tb_TextColor[info.yanse]

	cc.g_setTextColor(textZZ,colorID,true)
	cc.g_setTextColor(textLev,colorID,true)
	cc.g_setTextColor(skillText,colorID,true)
	textZZ:setText("资质："..g_petMsg:getPetZZ(info.id))
	textLev:setText("等级："..info.Level)
	
	
	
	local  starText =  obj:getChild("starText")
	starText:setText(G_tb_starText[(info.starLev or 0)])
	
	
	local count  = 0
	for i=1,info.skillNum do
		if  info.skillMsg[i] and  info.skillMsg[i].id > 0 then
			count = count+1
		end 
	end 
	
	skillText:setText("技能：("..count.."/"..info.skillNum..")")

	local function funcEndCallBack(btn,tag) 
		self:touchPetItem(obj,petID)
	end 
	if not notouch then
		g_SetBtnOne(obj,"touchItem",1,funcEndCallBack)	
	end 
	
	local c1 =  obj:getController("c1") --控制器
	if petID == self.cutTouchID  then
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
	
	local iconClock =  obj:getChild("iconClock")
	
	if info.isClock and  info.isClock > 0 then
		iconClock:setVisible(true)
	else
		iconClock:setVisible(false)
	end 

	local index = c1:getSelectedIndex()
	local  isBatIndexText =  obj:getChild("isBatIndexText") 
	local isBat = info.batIndex
	if isBat and isBat > 0 then
		isBatIndexText:setVisible(true)
	else
		isBatIndexText:setVisible(false)
	end 
	local c1 =  self.rootLayout:getController("c1") --控制器
	local index = c1:getSelectedIndex()
	local c2 =  obj:getController("c2") --控制器
	if index ==  1 then
		if (isBat and isBat > 0) or (info.isClock and  info.isClock > 0)  then
			c2:setSelectedIndex(0)
		else
			c2:setSelectedIndex(1)
			local  checkBtn1 = obj:getChild("checkBtn1") 
			if not  self.selectPetMsg[petID] or self.selectPetMsg[petID] <= 0  then
				checkBtn1:setText(0)
			else
				checkBtn1:setText(1)
			end 
			
		end 
	else
		c2:setSelectedIndex(0)
	end 
	local function funcEndCallBack(btn,tag) 
		cclog("======funcEndCallBack======")
		local index = tonumber(btn:getText())
		index = (index+1)%2
		btn:setText(index)
		if  index == 1 then
			self.selectPetMsg[petID] = petID
		else
			self.selectPetMsg[petID] = nil
		end 
	end 
	g_SetBtnOne(obj,"checkBtn1",1,funcEndCallBack)
end
	
function B_Pet:setPetDecPanl()
	local info = g_petMsg:getpetTbMsg(self.cutTouchID)
	local  petName =  self.rootLayout:getChild("petName") 
	local  textLev =  self.rootLayout:getChild("textLev")
	local  textZZ =  self.rootLayout:getChild("textZZ")
	if not info then
		self:touchPetItem()
		return
	end 
	local cfgID = info.cfgID
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)

	petName:setText(name)
	local colorID = G_tb_TextColor[info.yanse]
	cc.g_setTextColor(petName,colorID,true)
	cc.g_setTextColor(textLev,colorID,true)
	cc.g_setTextColor(textZZ,colorID,true)
	local zhizi = g_petMsg:getPetZZ(info.id)
	textZZ:setText("资质："..zhizi)
	textLev:setText("等级："..info.Level)
	local  barExp =  self.rootLayout:getChild("barExp")
	local maxExp = g_mathConTrol:mathPetMaxExp((info.starLev or 0) +1)
	barExp:setValue(info.nExp or 0)
	barExp:setMax(maxExp)

	local  textZZD =  self.rootLayout:getChild("textZZD")
	textZZD:setText("【"..G_tb_ZZType[tbMsg.zhongzhu].."】")
	cc.g_setTextColor(textZZD,G_tb_ZZTextColor[tbMsg.zhongzhu],true)
	
	local  starText =  self.rootLayout:getChild("starText")
	starText:setText(G_tb_starText[(info.starLev or 0)])
	
	for i=1,4 do
		local TextAtt =  self.rootLayout:getChild("TextAtt"..i)
		local TexttsAtt =  self.rootLayout:getChild("TexttsAtt"..i)
		local value,strLDEndCN,addValue = g_mathConTrol:mathPetBaseAtt(info.Level,i,zhizi,info.id) 
		local value = subBigInt(value, addValue)
		TextAtt:setVar("value",tostring(value)) 
		TextAtt:flushVars()
		TexttsAtt:setText("+"..addValue)
	
		local TextAttCe =  self.rootLayout:getChild("TextAttCe"..i)
		local value = g_mathConTrol:mathPetAttCe(info,i) 
		TextAttCe:setVar("value",tostring(value)) 
		TextAttCe:flushVars()
	end 
	
	
	local count = 0
	for i=1,6 do
		local TextSkill =  self.rootLayout:getChild("TextSkill"..i)
		local skillMsg = info.skillMsg[i] or {}
		local skillID = skillMsg.value1 or 0
		
		local skillIDLev = g_bagMsg:getpetSkillTbMsgLev(skillID)  
		if i > info.skillNum then
			TextSkill:setVisible(false)
		elseif skillID <= 0 then
			cc.g_setTextColor(TextSkill,1,true)
			TextSkill:setText("无")
		else
			local cfgSkillMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillID) 
			TextSkill:setVisible(true)
			local colorID = G_tb_TextColor[cfgSkillMsg.lev]
			cc.g_setTextColor(TextSkill,colorID,true)
			TextSkill:setText(cfgSkillMsg.name.." Lv"..skillIDLev)
			count = count + 1
		end 
	end
	local skillNum =  self.rootLayout:getChild("skillNum")
	skillNum:setVar("value1",tostring(count)) 
	skillNum:setVar("value2",tostring(info.skillNum)) 
	skillNum:flushVars()
	local TextChouhen =  self.rootLayout:getChild("TextChouhen")
	local chouhen = g_mathConTrol:mathPetBaseAtt(info.Level,5,zhizi,info.id) 
	TextChouhen:setText("仇恨值:"..chouhen)
	
	local btnBat =  self.rootLayout:getChild("btnBat")
	local c5 =  self.rootLayout:getController("c5") --控制器
	if info.batIndex and  info.batIndex > 0 then
		c5:setSelectedIndex(1)
	else
		c5:setSelectedIndex(0)
	end 	
	
	local iconClock =  self.rootLayout:getChild("iconClock")
	local  btnClock =  self.rootLayout:getChild("btnClock") 
	if info.isClock and  info.isClock > 0 then
		iconClock:setVisible(true)
		btnClock:setText("解锁")
		btnClock:setGrayed(true)
	else
		iconClock:setVisible(false)
		btnClock:setText("锁定")
		btnClock:setGrayed(false)
	end 

end 	

function B_Pet:touchPetItem(obj,petID)
	if self.cutTouchID then
		local  petList =  self.rootLayout:getChild("petList") 
		local item  = getChildById(petList,self.cutTouchID)
		if item then
			local c1 =  item:getController("c1") --控制器
			c1:setSelectedIndex(0)
		end 
	end
	local c6 =  self.rootLayout:getController("c6") --控制器
	if not petID then
		c6:setSelectedIndex(1)
		return
	else
		c6:setSelectedIndex(0)
	end 
	self.cutTouchID = petID
	if not obj then
		local  petList =  self.rootLayout:getChild("petList") 
		obj = getChildById(petList,petID)
	end 
	local c1 =  obj:getController("c1") --控制器
	c1:setSelectedIndex(1)
	self:setPetDecPanl()
	if g_panleMgr.panleID then
		g_panleMgr:showWndPanle(g_panleMgr.panleID,self.cutTouchID,"B_Pet")
	end 
	
end 

function B_Pet:reloadPatList(sortType)
	local sortType = sortType or cc.UserDefault:getInstance():getIntegerForKey("sortType",petSortType.yans)
	self.petTbMsg =  g_petMsg:getSortPetMsg(sortType) 
	local  petList =  self.rootLayout:getChild("petList") 
	self.first = nil
	petList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local petID = self.petTbMsg[indexD]
			if not self.first then
				self.first = petID
			end 
			obj:setCustomData(petID)
			self:setListItem(obj,petID)
		end)
	petList:setVirtual()--回调
	petList:setNumItems(#self.petTbMsg);
end 

function B_Pet:openWnd()
	self.selectPetMsg = {}
	self:initCheckBtn()
	self:reloadBatPatItemAll()
	self:reloadPatList()
	self:setPetNumText()
	self:touchPetItem(nil,self.first)
	g_newGuide:isGuideContorlWnd("B_Pet")
end 

	
return B_Pet
