
local loadScene = class("loadScene")
g_visibleSize = cc.Director:getInstance():getVisibleSize()
g_winSize = cc.Director:getInstance():getWinSize()
instLoadScene = nil

local C2DXPlatTypeQQ = 24
local C2DXPlatTypeWeChat = 22
g_newGameSce = 0

if g_Cfg.Platform == kTargetWindows  then --wind
	g_newGameSce = 2.0
end

function loadScene:initLoadMusic()
	--AudioEngine.setEffectsVolume(0.7)
   -- AudioEngine.setMusicVolume(0.4)
	if g_Cfg.Platform == kTargetAndroid  then --wind
	--	AudioEngine:setMusicVolume(0.5)
	else
		cc.SimpleAudioEngine:getInstance():setMusicVolume(0.5)
	end 
end



function loadScene:touchBtn(index)
	self:VisitorLogin()
end

function loadScene:initADDPackage()
	fgui.UIPackage:addPackage("z_UiRes");
	fgui.UIPackage:addPackage("z_BarRes");
	fgui.UIPackage:addPackage("z_BGres");
	fgui.UIPackage:addPackage("z_Btn");
	fgui.UIPackage:addPackage("d_node");
	fgui.UIPackage:addPackage("z_9Panle");
	fgui.UIPackage:addPackage("Y_font");
	fgui.UIPackage:addPackage("C_EquContorl");
	fgui.UIPackage:addPackage("z_Goods");
	fgui.UIPackage:addPackage("skillEff/Res_skill_effect");
	
end 

function loadScene:intoGameADDPackage()

	fgui.UIPackage:addPackage("z_Pilst");
	fgui.UIPackage:addPackage("z_Number");
	fgui.UIPackage:addPackage("z_effct");

end 

function loadScene:addPackage()
	
	local function urlEncode(s)
		s = string.gsub(s, "([^%w%.%-%_ ])", function(c) return string.format("%%%02X", string.byte(c)) end)
		return string.gsub(s, " ", "+")
	end

	local encode_url = urlEncode('/v3/r/mpay/get_balance_m')   

	cclog("ipa_android==="..encode_url)

end

function loadScene:initFWQ()

	--if g_Cfg.Platform == kTargetWindows  then --wind
		
		fwqNode:sv_setNode(self.rootLayout)
		fwqNode:sv_InitWnd()
		
	--end 	
end 
function loadScene:openWnd(rootObj)

	local Platform = cc.Application:getInstance():getTargetPlatform()
	g_Cfg.Platform = Platform
		
	self:addPackage()
	
	g_GameDataMgr.rootObj = rootObj
	CheckValidLog(cc.FileUtils:getInstance():getWritablePath().."LogFiles/")	
	
	self:initADDPackage()
	self:initLoadMusic()
	instLoadScene = self
	g_LoadFile("app/init")
	g_LoadFile("public/init")
	
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		API_LoginCallBack_android(g_androidLoginFunc)
		API_TaptapLogin_callback(g_LoginTapTapCallback)
		API_AntiAddCallBack_android(g_androidAntiAddFunc)
	end
	
	local _view = fgui.UIPackage:createObject("A_loading", "loadingSence")
	g_loadScene = self
    rootObj:addChild(_view)
	_view:setSize(g_visibleSize.width,g_visibleSize.height);
    self.rootLayout = _view
	
	g_sendSvTbMsg()
	self:initFWQ()
	
		
	local c8 = self.rootLayout:getController("c8") --控制器
	local buttonQQ = self.rootLayout:getChild("buttonQQ")
	local  buttonQQD = buttonQQ:displayObject()
	local checkBtnXY = self.rootLayout:getChild("checkBtnXY")
	local c1 = self.rootLayout:getController("c1") --控制器
	
	
    local function funcEndCallBack(btn,tag)
		local GsvID = fwqNode:getCurSVID()
				
		local xieyi =  cc.UserDefault:getInstance():getIntegerForKey("xieyi",0)
		if xieyi == 0 then
			--c8:setSelectedIndex(1)
			---g_action:ts_hszz_antion("需要先同意协议")
			cc.UserDefault:getInstance():setIntegerForKey("xieyi",1)
			--return
		end 
		if not GsvID  then
			return
		end 
         if tag == 1 then
			if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
				local  openid = API_GetDeviceID()
				LogType = g_logType.YK
				openid = openid.."boss"
				cclog(self.touchAndrodi,"===1==self.touchAndrodi=======")
				if  PackageName.Taptap == G_PackageName then 
					---
					API_taptapLogin()
				else
					g_androidISShowAntiFunc(openid,g_logType.YK)
					---g_loadScene:VisitorLogin()
				end 
			else
				self:touchBtn(3)
			end 
            
        elseif tag == 2 then
       
        elseif tag == 3 then
			if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
				LogType = g_logType.QQ
				API_initLogin_android(1)
			else
				self:BtnQQLogin()
			end 
		elseif tag == 4 then	
			
        end
		g_action:ts_hszz_antion("登录游戏中,请稍后",nil,-2,nil,nil,rootTips)
    end

    g_SetBtnOne(_view, "buttonyk",1, funcEndCallBack)
	g_SetBtnOne(_view, "buttonQQ",3, funcEndCallBack)
		
	local n25 = self.rootLayout:getChild("n25")
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		if  PackageName.Taptap == G_PackageName then
			n25:setText("TapTap登录")
			
		end 
	end 
	local function funcEndCallBack(btn,tag)
		if tag == 1 then		
			cc.Application:getInstance():openURL("http://112.74.170.146:8093/"); 
		elseif tag == 2 then
			cc.Application:getInstance():openURL("http://112.74.170.146:8094/");  
		elseif tag == 3 then
			c8:setSelectedIndex(0)
			checkBtnXY:setText(1)
			cc.UserDefault:getInstance():setIntegerForKey("xieyi",1)
			
		elseif tag == 4 then
			c8:setSelectedIndex(0)
			checkBtnXY:setText(0)
			cc.UserDefault:getInstance():setIntegerForKey("xieyi",0)
		end 
	end 
	local xyPanle = self.rootLayout:getChild("xyPanle")
	g_SetBtnOne(xyPanle, "title2",1, funcEndCallBack)
	g_SetBtnOne(xyPanle, "title3",2, funcEndCallBack)
	g_SetBtnOne(xyPanle, "btnTY",3, funcEndCallBack)
	g_SetBtnOne(xyPanle, "btnNot",4, funcEndCallBack)
	
	local btnTeam = self.rootLayout:getChild("btnTeam")
	btnTeam:setVisible(false)

	
	local iptype = getSvrIpTest() or "NULL"
	local text_version = _view:getChild("text_version")
	text_version:setText(iptype..get_FullVersion())
	
	self.Tips = self.rootLayout:getChild("Tips")
	self.Tips:setText(g_xieyi_text)

	--g_gameMusic:playEffect(5)
	
	g_sendSvQQqun()
	g_sendSvVersion()
	
	self:registerLoginGameServer()
	---g_gameMusic:playMusic(bgMusicID,true)

	local function scheduleByOne()
		btnTeam:setVisible(true)
		self:setBtnVisible()
	end 
	local buttonyk = self.rootLayout:getChild("buttonyk")
	local  buttonyk = buttonyk:displayObject()
	g_scheduleTime:scheduleByTimes(buttonyk, 1,1,scheduleByOne)

	local procent_bar = self.rootLayout:getChild("procent_bar")
	procent_bar:setValue(0)
	procent_bar:tweenValue(100,1)

	local statusWX =  API_CheckWechatInstall(C2DXPlatTypeWeChat)
	local statusQQ = API_CheckWechatInstall(C2DXPlatTypeQQ)
	local buttonWX = self.rootLayout:getChild("buttonWX")
	local buttonQQ = self.rootLayout:getChild("buttonQQ")
	local n24 = self.rootLayout:getChild("n24")
	local n23 = self.rootLayout:getChild("n23")
	
	buttonQQ:setVisible(false)
	n24:setVisible(false)
	
	buttonWX:setVisible(false)
	n23:setVisible(false)

	local  buttonWX = self.rootLayout:displayObject()
	local count = 1
	self:intoGameADDPackage()
	self.Tips1 = self.rootLayout:getChild("Tips1")
	self.Tips1:setText("正在加载游戏，请稍后")
	local c7 = self.rootLayout:getController("c7") --控制器
	c7:setSelectedIndex(0)	
	local c5 = self.rootLayout:getController("c5") --控制器
	c5:setSelectedIndex(0)
	
	local function scheduleByOne()
		g_WndMgr:createWndAll(count)
		count = count+ 1
		if count == 20  then
			self.Tips1:setText("")	
		end 
		if count == 8  then
			c7:setSelectedIndex(0)	
		end 
		
	end 
	g_scheduleTime:scheduleByTimes(buttonWX, 0.05,20,scheduleByOne)
	
	local xieyi = cc.UserDefault:getInstance():getIntegerForKey("xieyi",0)
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID and xieyi == 1 then
		
	end
	  

end

function loadScene:testadddd()
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D")
	
	local skillMsg = {}
	for key,v in pairs(tbMsg)do
		cclog(key,"======TujianMsg======")
		for cfgID=90000001,90000040 do
			local tbMsg2 =  g_cfgMsg:getCfgMsg("role_D",cfgID)
			for i=1,5 do
				local skillID = tbMsg2["skill"..i] 
				if skillID == key then
					if not skillMsg[key] then
						skillMsg[key] = ""
					end 
					skillMsg[key] = skillMsg[key].." 【"..tbMsg2.name.."】"
				end 
			end 
		end 
	end 
	cclog("=======skillMsg========",skillMsg)
end 



function loadScene:setBtnVisible()
	local statusWX =  API_CheckWechatInstall(C2DXPlatTypeWeChat)
	local statusQQ = API_CheckWechatInstall(C2DXPlatTypeQQ)
	local buttonWX = self.rootLayout:getChild("buttonWX")
	local buttonQQ = self.rootLayout:getChild("buttonQQ")
	local n24 = self.rootLayout:getChild("n24")
	local n23 = self.rootLayout:getChild("n23")

	local c1 = self.rootLayout:getController("c1") --控制器
	if g_Cfg.Platform ~= kTargetWindows  then 
		if not statusQQ then
			buttonQQ:setVisible(false)
			n24:setVisible(false)
		else
			buttonQQ:setVisible(true)
			n24:setVisible(true)
		end 
		
		if not statusWX then
			buttonWX:setVisible(false)
			n23:setVisible(false)
		else
			buttonWX:setVisible(true)
			n23:setVisible(true)
		end 
	else
		buttonWX:setVisible(true)
		n23:setVisible(true)
		buttonQQ:setVisible(true)
		n24:setVisible(true)
	end
	
	local c6 = self.rootLayout:getController("c6") --控制器
	c6:setSelectedIndex(1)
		
	GshenheTyep = G_tableMsgList["gameTyep1.0.2"]  ---2 审核版本
	---local stsus1 = cc.UserDefault:getInstance():getIntegerForKey("userid"..g_LoginType.loginTypeWeiXinAuth,0)
	--local stsus2 = cc.UserDefault:getInstance():getIntegerForKey("userid"..g_LoginType.loginTypeWeiXinToken,0)
	
	local stsus1 = cc.UserDefault:getInstance():getIntegerForKey("userid",0)
	local verifyIDCard = cc.UserDefault:getInstance():getIntegerForKey("verifyIDCard", 0)
	local n59 = self.rootLayout:getChild("n59")
	local c4 = self.rootLayout:getController("c4") --控制器

	if   2 == GshenheTyep and g_Cfg.Platform ~= cc.PLATFORM_OS_ANDROID   then
		c1:setSelectedIndex(3)
	elseif   g_Cfg.Platform == cc.PLATFORM_OS_ANDROID then
		c1:setSelectedIndex(0)
		if  PackageName.Taptap == G_PackageName then 
			c1:setSelectedIndex(0)
		else
			c1:setSelectedIndex(0)
		end 
		c4:setSelectedIndex(0)
	else
		c1:setSelectedIndex(0)
		if verifyIDCard == 0   then
			cc.UserDefault:getInstance():setIntegerForKey("verifyIDCard", 6)
		elseif verifyIDCard == 6   then 
			if 	 g_Cfg.Platform ~= cc.PLATFORM_OS_ANDROID and  g_Cfg.Platform ~= kTargetWindows  then
			--	c4:setSelectedIndex(1)
			--	g_verifyIDCard:setPanle(n59)
			end 
		end 
	end 
	local c8 = self.rootLayout:getController("c8") --控制器
	local xieyi = cc.UserDefault:getInstance():getIntegerForKey("xieyi",1)
	local checkBtnXY = self.rootLayout:getChild("checkBtnXY")
	if xieyi == 0 then
		c8:setSelectedIndex(1)
		checkBtnXY:setText(0)
	else
		c8:setSelectedIndex(0)
		checkBtnXY:setText(1)
	end 
	
	local function funcEndCallBack(btn,tag)
		c8:setSelectedIndex(1)
		
	end 
	g_SetBtnOne(self.rootLayout, "n104",1, funcEndCallBack)

end

--初始化界面前前发送消息
function loadScene:LoginGameSendmsg()
	local  function callBack1()
		self:loadGameData()
	end 
	
	g_svSendMsgControl:request_getInitMsg()
	g_svSendMsgControl:request_getRoleMsg()
	
	g_svSendMsgControl:request_getBagMsg(1)
	g_svSendMsgControl:request_getBagMsg(2)
	g_svSendMsgControl:request_getBagMsg(3)
	g_svSendMsgControl:request_getBagMsg(0)
	g_svSendMsgControl:request_getPetMsg()
	g_svSendMsgControl:request_getEquMsg()
	g_svSendMsgControl:request_getTianfuMsg()
	g_svSendMsgControl:request_getChengjiuMsg(0)
	g_svSendMsgControl:request_getRoleSkillMsg()
	g_svSendMsgControl:request_taskInfo()
	g_svSendMsgControl:request_getqianDaoMsg(0)
	g_svSendMsgControl:request_getBaozangMsg(0)
	g_svSendMsgControl:request_newGuide()
	g_svSendMsgControl:request_lyuInfo(0)	
	g_svSendMsgControl:request_geTujianMsg(0)
	g_svSendMsgControl:request_time(callBack1,101)
end


function loadScene:registerLoginGameServer()
    cclog("registerLoginGameServer")
	local function logingamecallback(response)
		cclog("=====logingamecallback======",response)
		if response.ok == true then	
			g_GameDataMgr.type = response.type
			g_GameDataMgr.sex = response.sex
			g_GameDataMgr.nickname = response.nickname
			g_GameDataMgr.headimgurl = response.headimgurl
			g_GameDataMgr.userid = response.userid
			g_GameDataMgr.bindwechat = response.bindwechat
			g_GameDataMgr.gm = response.gm
			g_GameDataMgr.newplayer = response.newplayer
			g_GameDataMgr.create_time = response.create_time
			g_GameDataMgr.loginSucc = true
			
			cc.UserDefault:getInstance():setIntegerForKey("userid"..g_GameDataMgr.type, g_GameDataMgr.userid)
			cc.UserDefault:getInstance():setIntegerForKey("userid", g_GameDataMgr.userid)
			--cc.UserDefault:getInstance():setIntegerForKey("userid", g_GameDataMgr.userid)
			cc.UserDefault:getInstance():setBoolForKey("gm", g_GameDataMgr.gm)
			
			local roleId = g_GameDataMgr.userid
			local roleName = g_GameDataMgr.nickname
		
			local playerID ,realmName  = fwqNode:getCurSVID()
			local VipLev_Lev_FB = g_getTimeDate(g_GameDataMgr.create_time)
			local roleLevel = 1
			--g_OPPOConTorl(G_OPPOConTorlEnum.UpdateRole,roleId,roleName,roleLevel,playerID,realmName,VipLev_Lev_FB)
			--local  setName = cc.UserDefault:getInstance():getIntegerForKey("setName", 0)
			--if setName == 0  then
				--g_setNameItem:openWnd(handler(self, self.LoginGameSendmsg))
				--cc.UserDefault:getInstance():setIntegerForKey("setName", 1)
				--return 
			--end 
			self:LoginGameSendmsg()

		else
			--local rootTips = display.getRunningScene()
			--local  layerRoot = cc.Director:getInstance():getRunningScene()
			
			g_GameDataMgr.loginSucc = false
			local str = string.format("登陆失败，%s[%d]", tostring(response.desc), response.type )
			cclog("=====erro====",str)
			g_action:ts_hszz_antion(response.desc,nil,-2,nil,nil,rootTips)
			WebSocket:Close()
			--if response.userid == -1  then
			cc.UserDefault:getInstance():setStringForKey("refresh_token", "")
			cc.UserDefault:getInstance():setStringForKey("QQrefresh_token", "")
			--end 
		end
	end
	registerWsSocketMsg("res_login", logingamecallback)
end

function WechatLogin(iErrorType, access_token, openid)
    cclog(string.format("WechatLogin %d %s", iErrorType, openid))
    local rootTips = display.getRunningScene()
    if iErrorType == 0 then--微信
        instLoadScene:WeChatLogin(access_token, openid)
        cc.UserDefault:getInstance():setIntegerForKey("logintype", iErrorType)
    elseif iErrorType == 1 then--QQ
        instLoadScene:QQLogin(access_token,openid)
        cc.UserDefault:getInstance():setIntegerForKey("logintype", iErrorType)
    elseif iErrorType == 2 then
		g_action:ts_hszz_antion("微信登录取消",nil,-2,nil,nil,rootTips)
    elseif iErrorType == 3 then
        g_action:ts_hszz_antion("QQ登录取消",nil,-2,nil,nil,rootTips)
    elseif iErrorType == 4 then
        g_action:ts_hszz_antion("微信登录发生错误",nil,-2,nil,nil,rootTips)
		cc.UserDefault:getInstance():setStringForKey("refresh_token", "")
    elseif iErrorType == 5 then
        g_action:ts_hszz_antion("QQ登录发生错误",nil,-2,nil,nil,rootTips)
		cc.UserDefault:getInstance():setStringForKey("QQrefresh_token", "")
    else
        g_action:ts_hszz_antion("登录其他错误"..iErrorType,nil,-2,nil,nil, rootTips)
		cc.UserDefault:getInstance():setStringForKey("QQrefresh_token", "")
		cc.UserDefault:getInstance():setStringForKey("refresh_token", "")
    end
	--cclog("=====WechatLogin==end====")
    return true
end

local iLoginClickTime = nil
local function CheckLoginClick()
    cclog("=CheckLoginClick====",iLoginClickTime)
	if not iLoginClickTime then
		iLoginClickTime = os.time()
		return 
	else
		local iCurTime  = os.time()
		local iLeft = 5 - (iCurTime - iLoginClickTime)
            
		if iLeft > 0 then
			g_action:ts_hszz_antion(string.format("点击太快了 %d秒后再试", iLeft), nil,-2,nil,nil,rootTips)
			return true
		end
		
		iLoginClickTime = iCurTime
		return 
	end
end

function  GetDeviceID()
	local  DeviceID
	if g_Cfg.Platform == OS_ANDROID then
		DeviceID = API_GetDeviceID()  -- callJavaGetAppVer()   "1638594012"
	else
		DeviceID = API_GetDeviceID()
	end
	 return  DeviceID
end 

function loadScene:VisitorLogin(openidTap)
	---cclog(g_Cfg.Platform,"===VisitorLogin====="..kTargetWindows)
	local nType = g_LoginType.loginTypeVisitor
	local  userid 
	if g_Cfg.Platform == kTargetWindows  then --wind ---登录其他玩家账号
		local  GMLogInID = cc.UserDefault:getInstance():getIntegerForKey("GMLogInID", 0)
		local openid,devOpenid
		if GMLogInID > 0 then
			userid = GMLogInID
			nType = g_LoginType.loginTypeGM
			cc.UserDefault:getInstance():setIntegerForKey("GMLogInID", 0)
			devOpenid  = API_GetDeviceID()
			openid  = API_GetDeviceID()
		else
			devOpenid  = "20-0D-B0-38-B9-70523" --API_GetDeviceID()
			local openidIndex = cc.UserDefault:getInstance():getIntegerForKey("openidIndex",1 )
			openid = devOpenid.."44"--..openidIndex
		end
	
		local  devicetoken = API_GetDeviceID()
		
		devicetoken =   "20-0D-B0-38-B9-70523"           
		nType = g_LoginType.loginTypeGM -- g_LoginType.loginTypeGM  --g_LoginType.loginTypeVisitor
		userid = 2006829		--2001115
 ---5575 --- 1001730---- 装备丢失  1014  1001598  4502   1001342

		openid =  userid--
		local GsvID = fwqNode:getCurSVID()
		sendWsSocketData("req_login", {type=nType, devicetoken = devicetoken, openid =  openid ,userid = userid ,accesstoken = "youke", svID= GsvID})
	else
		--cclog("======VisitorLogin=222=222===2==")
		if CheckLoginClick() then
			return
		end
		local sex = 1
		local openidDD = openidTap or API_GetDeviceID()
		if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
			sex = 100
			openidDD =  openidDD.."TapTap"
			if  G_PackageName == PackageName.kuaibao then
				openidDD =  API_GetDeviceID().."kuaibao"
			end 
		end
		local GsvID = fwqNode:getCurSVID()
		nType = g_LoginType.loginTypeVisitor
		openid =  userid--
		sendWsSocketData("req_login", {type=nType, devicetoken = openidDD, openid = openidDD, accesstoken = "youke", sex = sex,svID= GsvID})
	end
end

function loadScene:QQLogin(access_token,openid,nickName,sex)
	cclog("===QQLogin==11==="..openid)
	local nType  = g_LoginType.loginTypeQQAuth
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		nType  = g_LoginType.loginTypeQQAndroid
		openid =  openid..nType
	end 
	local GsvID = fwqNode:getCurSVID()
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		sex = 100

	end
	sendWsSocketData("req_login", {type= nType, devicetoken = API_GetDeviceID(), openid = openid, accesstoken = access_token, nickname = nickName,sex = sex,svID= GsvID})

end

function loadScene:QQQuickLogin(refresh_token)
	local openid = API_GetDeviceID()
	local GsvID = fwqNode:getCurSVID()
	cclog(refresh_token.."===QQQuickLogin====="..openid)
	local GsvID = fwqNode:getCurSVID()
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		sex = 100

	end
	sendWsSocketData("req_login", {type=g_LoginType.loginTypeQQToken, devicetoken = API_GetDeviceID(), openid = openid, accesstoken = refresh_token,svID= GsvID,sex = sex})
end

function loadScene:BtnQQLogin()
	cclog(kTargetWindows,"===BtnQQLogin==111==0000=  /"..g_Cfg.Platform)
	if CheckLoginClick() then
		return
	end
	
	if  g_Cfg.Platform ==  kTargetAndroid  then
		local  GMLogInID = cc.UserDefault:getInstance():getIntegerForKey("GMLogInID", 0)
		local openid,devOpenid
		if GMLogInID > 0 then
			userid = GMLogInID
			nType = g_LoginType.loginTypeGM
			cc.UserDefault:getInstance():setIntegerForKey("GMLogInID", 0)
			devOpenid  = API_GetDeviceID()
			openid  = API_GetDeviceID()
		else
			devOpenid  = "20-0D-B0-38-B9-701" --API_GetDeviceID()
			local openidIndex = cc.UserDefault:getInstance():getIntegerForKey("androidOpenid",1) 
			openid = devOpenid..openidIndex--..openidIndex
		end
		local  devicetoken = API_GetDeviceID()
		devicetoken = "20-0D-B0-38-B9-70"              
		nType = g_LoginType.loginTypeVisitor-- g_LoginType.loginTypeGM  --g_LoginType.loginTypeVisitor
		local GsvID = fwqNode:getCurSVID()
		sendWsSocketData("req_login", {type=nType, devicetoken = devicetoken, openid =  openid ,userid = userid ,accesstoken = "youke",svID= GsvID})
	
	elseif g_Cfg.Platform == kTargetWindows  then
		self:VisitorLogin()
	else
		local refresh_token = cc.UserDefault:getInstance():getStringForKey("QQrefresh_token", "")
		if refresh_token == "" then
            API_qqLogin()
		else
            self:QQQuickLogin(refresh_token)
		end	
	end
end

function loadScene:WeChatLogin(access_token, openid)
	cclog("===WeChatLogin====="..openid)
	local GsvID = fwqNode:getCurSVID()
	sendWsSocketData("req_login", {type=g_LoginType.loginTypeWeiXinAuth, devicetoken = API_GetDeviceID(), openid = openid, accesstoken = access_token,svID= GsvID})
end

function loadScene:WeChatQuickLogin(refresh_token)
	local openid = API_GetDeviceID()
	local GsvID = fwqNode:getCurSVID()
	cclog(refresh_token.."===WeChatQuickLogin====="..openid)
	sendWsSocketData("req_login", {type=g_LoginType.loginTypeWeiXinToken, devicetoken = openid, openid = openid, accesstoken = refresh_token,svID= GsvID})
end

function loadScene:BtnWeChatLogin()
	cclog(kTargetWindows,"===BtnWeChatLogin==111==22="..g_Cfg.Platform)
	if CheckLoginClick() then
		return
	end
	
	if g_Cfg.Platform ~= kTargetWindows  then
		local refresh_token = cc.UserDefault:getInstance():getStringForKey("refresh_token", "")
		cclog(refresh_token.." --refresh_token-==")
		if refresh_token == "" then
			API_WechatLogin()
		else
			self:WeChatQuickLogin(refresh_token)
		end
	else
		self:VisitorLogin()
	end
end

--[[
TransitionRotoZoom 旋转进入
TransitionJumpZoom 跳动进入
TransitionPageTurn 翻页效果进入
TransitionRadialCCW 钟摆效果
TransitionMoveInL ／ TransitionMoveInR ／ TransitionMoveInT ／ TransitionMoveInB 左侧／右侧／顶部／底部进入
TransitionSlideInL／TransitionSlideInR／TransitionSlideInT／TransitionSlideInB 分别从左侧／右侧／顶部／底部滑入
TransitionShrinkGrow 交替进入
TransitionFlipX／TransitionFlipY x轴翻入（左右）／ y轴翻入（上下）
TransitionFlipAngular 左上右下轴翻入
TransitionZoomFlipX／TransitionZoomFlipY x轴翻入放大缩小效果（左右）／ y轴翻入放大缩小效果（上下）
TransitionFadeTR ／TransitionFadeBL／TransitionFadeUp／TransitionFadeDown 小方格右上角显示进入／ 小方格左下角显示进入／ 横条向上显示进入／ 横条向下显示进入
TransitionSplitCols ／ TransitionSplitRows 竖条切换进入／ 横条切换进入
TransitionZoomFlipAngular 左上右下轴翻入放大缩小效果
TransitionFade 渐隐进入
TransitionCrossFade 渐变进入
TransitionTurnOffTiles 小方格消失进入
TransitionRadialCCW／TransitionRadialCW 扇面展开收起
]]

---登录成功，
function loadScene:loadGameData()	
	
	self:EnterMainSence()
end 

function loadScene:EnterMainSence()
		
	local function openFunc()
		os.exit()
	end 
		--加载英雄资源
	
	--加载怪物资源

	----local scene = cc.Scene:createWithPhysics()
	--scene:getPhysicsWorld():setGravity(cc.p(0,0))
	--scene:getPhysicsWorld():setDebugDrawMask(cc.PhysicsWorld.DEBUGDRAW_ALL)
	
	---local _groot = fgui.GRoot:create(scene);
	---scene:setUserObject(_groot)
	--g_GameDataMgr.rootObj = _groot
	self.rootLayout:removeFromParent()
	local TyepLog = G_tableMsgList["cclog"] 
	cclog(TyepLog,"=====TyepLog====111=",g_Cfg.Debug)
	if TyepLog  then
		if TyepLog == 0  then
			g_Cfg.Debug = true
		elseif TyepLog  == g_GameDataMgr.userid  then
			g_Cfg.Debug = true
		elseif TyepLog == -1  then
			g_Cfg.Debug = false
		end 
	end 
	cclog(TyepLog,"=====TyepLog=====",g_Cfg.Debug)

	--计算属性
	g_roleMsg:reloadRoleBaseAttMsg()
	--
	
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local leaveGameTime = g_baseMsg:getOther(otherDBMsgID.leaveGameTime) or  0
	cclog(leaveGameTime,"====leaveGameTime========")
	if leaveGameTime == 0 then
		--发送一次
		g_svSendMsgControl:request_geBatMsg(1,1,0)
	else
		g_batWndContorl:getOff(mapType)
	end 
	--g_WndMgr:openWnd("ComponentFubenPanle")
	g_WndMgr:openWnd("B_FbBat",mapType)
	--g_WndMgr:touchMainBtn(nil,touchMainBtn_FbBat)
	
	g_svSendMsgControl:request_time(nil,100)
	---local scene1 = cc.TransitionFadeDown:create(1, scene)
	--display.runScene(scene1)
	---fgui.UIPackage:removePackage("a_loading")
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		---API_playBannerAd_android()
	
	end
	---cclog("loadScene:openWnd".. getBigInt(byBigInt("100", "0.1")))
	--Player:getPlayerID(userid)	
	--SV_batConTrol:getTbBatInfo(Player,1)	
	g_gameMusic:playMusic(2,true)
	

	
end


return loadScene
