
local SkillPanle = class("SkillPanle")

function SkillPanle:initWnd()

	local function funcEndCallBack(btn,tag) 
		g_svSendMsgControl:request_getRoleSkillMsg(3)
		
	end 
	g_SetBtnOne(self.rootLayout, "btnGetXS",1, funcEndCallBack)	
	--g_SetBtnOne(self.rootLayout, "btn3",3, funcEndCallBack)	
end 

function SkillPanle:showAnima(indexD)
	local skillList = self.rootLayout:getChild("skillList")
	local patItem = getChildById(skillList, indexD)
	local textName = patItem:getChild("textName")
	
	local Panel_ = textName:displayObject()
	local pos = cc.p(36,-20)
	local ArmatureEndA = g_gArmature:showArmatureByNums("FateSellAnimation",nil,Panel_,nil,nil,pos,1.5,endCallBcak)
	g_gameMusic:playEffect(73)
end 

function SkillPanle:setListItem(obj,indexD)
	if not obj then
		local skillList = self.rootLayout:getChild("skillList")
		obj = getChildById(skillList, indexD)
	end 
	local textName = obj:getChild("textName")
	local lev = g_roleSkillMsg:getroleSkillTbMsgLev(indexD)
	local BOSSID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	local skillID = tbMsg["skill"..indexD]
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",skillID)
	cclog("=====setListItem=======",skillID,BOSSID,indexD)
	textName:setText(tbMsg.name)
	--local textnType = obj:getChild("textnType")
	--textnType:setText(tbMsg.nType)
	
	local textLev = obj:getChild("textLev")

	local maxLev = g_roleSkillMsg:getTFMaxlev() 
	if lev > maxLev then
		lev = maxLev
	end 
	textLev:setText("Lv."..lev)
	
	local textDec = obj:getChild("textDec")
	local  str = g_roleSkillMsg:getSkillValue(skillID,lev,true) 
	textDec:setText(str)
	
	local textCostmp = obj:getChild("textCostmp")
	if tbMsg.costMp > 0 then
		textCostmp:setText("消耗魔法："..g_roleSkillMsg:getCostMp(skillID,lev) ) 
		textCostmp:setVisible(true)
	else
		textCostmp:setVisible(false)
	end 
	local textXueshiNeed = obj:getChild("textXueshiNeed")
	local costMp = g_roleSkillMsg:getCostXueshi(skillID,lev,indexD) 
	local str = getBigIntByStr2(costMp)
	
	textXueshiNeed:setText("学识："..str)
	
	local function funcEndCallBack(btn,tag) 
		cclog("====funcEndCallBack=====",tag,costMp)
		--判断学识
		
		local status = g_baseConTrol:resEnough(g_resCfgId.xueshi,costMp)
		if not status  then
			return 
		end 
		--判断等级
		if indexD > 1 then
			local levLast = g_roleSkillMsg:getroleSkillTbMsgLev(indexD-1) or 0
			local openLev =  20
	
			if levLast < openLev then
				g_action:ts_hszz_antion("需要第".."层技能达到"..openLev.."级")
				return
			end 
			if levLast < lev then
				g_action:ts_hszz_antion("无法超过上一层的技能等级,\n请先升级上一层技能")	
				return	
			end 
			if indexD == 6  then
				local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
				if zslevel < 6  then
					g_action:ts_hszz_antion("6转后开启")	
					return	
				end 
			end 
		end 
		g_svSendMsgControl:request_getRoleSkillMsg(2,indexD)
		self:showAnima(indexD)
	end 
	g_SetBtnOne(obj, "btnLevUp",1, funcEndCallBack)	
end 

function SkillPanle:setListPanle()
	local skillList = self.rootLayout:getChild("skillList")
	skillList:itemRenderer(function(index, obj)
			local indexD = index + 1
			obj:setCustomData(indexD)
			self:setListItem(obj,indexD)
		end)
	skillList:setVirtual()--回调
	skillList:setNumItems(tbGameConst.SkillMaxNum);
end

function SkillPanle:setXueshiText()
	local textXueshi = self.rootLayout:getChild("textXueshi")
	local resValue = g_baseMsg:getResOfID(g_resCfgId.xueshi) or 0
	cclog("=====setXueshiText=========",resValue,g_resCfgId.xueshi)
	local str = getBigIntByStr2(resValue)
	textXueshi:setText(str)

end


function SkillPanle:initTextPanle(isInit)
	local roleLevText = self.rootLayout:getChild("roleLevText")
	local gwLev = self.rootLayout:getChild("gwLev")
	
	local maxLev = g_roleSkillMsg:getTFMaxlev() 
	roleLevText:setText("等级上限："..maxLev.."级")
	local curRoleSkilGWlLev = g_baseMsg:getOther(otherDBMsgID.curRoleSkilGWlLev) or  1
	gwLev:setText("Lv."..curRoleSkilGWlLev)
	
	local res50 = self.rootLayout:getChild("res50")
	local  needCoin,strLDEndCN = g_roleSkillMsg:getGWLevUpNeedCoin() 
	local str = getBigIntByStr2(needCoin)
	---cclog(str,needCoin,"===getBigIntByStr========",strLDEndCN)
	res50:setText(str)
	local function funcEndCallBack(btn,tag) 
		--判断金币
		local status = g_baseConTrol:resEnough(g_resCfgId.coin,needCoin)
		if not status  then
			return 
		end 
		g_svSendMsgControl:request_getRoleSkillMsg(1)
		
	end 
	g_SetBtnOne(self.rootLayout, "btn50",1, funcEndCallBack)	
	
	self:setBar2(isInit)
	local  oneValue,speed = g_roleSkillMsg:getXSDps() 
	local testTexts = self.rootLayout:getChild("testTexts")
	testTexts:setText(speed.."秒")
end 

function SkillPanle:setBar2(isInit)
	local  rootLayout = self.rootLayout:displayObject()
	local oneValue,speed = g_roleSkillMsg:getXSDps() 
	
	local bar1 = self.rootLayout:getChild("bar1")
	local bar2 = self.rootLayout:getChild("bar2")
	local textOffTime = self.rootLayout:getChild("textOffTime")
	
	bar1:setValue(0)
	bar1:tweenValue(100,speed)
	
	
	local nTimeStr,nTime =  g_roleSkillMsg:getXSTimeOff() 
	textOffTime:setText("离线时间："..nTimeStr)
	
	local MaxXSTimeOff  = g_roleSkillMsg:getMaxXSTimeOff() 
	local  offXSValue = g_roleSkillMsg:getTimeOffXSValue(nTime,oneValue,speed) 
	if offXSValue < 0 then
		offXSValue = 0
	end 
	local  offXSValueMax =  g_roleSkillMsg:getTimeOffXSValue(MaxXSTimeOff,oneValue,speed) 
	--cclog(MaxXSTimeOff,offXSValue,"===MaxXSTimeOff=========",offXSValueMax)
	local pro = math.floor(offXSValue*1000/offXSValueMax)/10
	bar2:setValue(pro)
	bar2:setMax(100)
	
	local t0 = self.rootLayout:getTransition("t0")
	local n336 = self.rootLayout:getChild("n336")
	n336:setText("学识：+"..oneValue)

	local function scheduleByOne()
		
		t0:play()
		bar1:setValue(0)
		bar1:tweenValue(100,speed)
		offXSValue = offXSValue + oneValue
		local pro = math.floor(offXSValue*1000/offXSValueMax)/10
		bar2:setValue(pro)
		nTime = nTime + speed
		local nTimeStr = cc.getStrTimeByS(nTime)
		textOffTime:setText("离线时间："..nTimeStr)
	end 
	--if  isInit then
		g_scheduleTime:scheduleForever(rootLayout,speed,scheduleByOne)
	--end 
	
end 

function SkillPanle:openWnd()
	self:initTextPanle(true)
	
	self:setListPanle()
	
	local textXueshi = self.rootLayout:getChild("textXueshi")
	g_baseConTrol:setItemCallback(g_resCfgId.xueshi,"SkillPanle",1,textXueshi)
	self:setXueshiText()
end 

	
return SkillPanle
