local battleDropFailItem = class("battleDropFailItem")

function battleDropFailItem:setFubenName(mapCfgID)
	local Label = self.rootLayout:getChild("Label")
	local text_name = self.rootLayout:getChild("text_name")
	
	if mapCfgID > 100000 then
		local cfgMsg =  g_cfgMsg:getCfgMsg("fuben_D",mapCfgID)
		local name = cfgMsg.name
		local index = cfgMsg.ceng
		local cost = cfgMsg.power
		local nType = cfgMsg.type
		if nType == 4 then
			cost = g_battleControlFactory:getFBEquTl()
		end 
		text_name:setText(name.."【第"..index.."层】")
		Label:setText(cost)
	elseif mapCfgID < 0 then	 ---JJC
		text_name:setText("竞技场")
		Label:setText(0)
	else
		local cfgMsg =  g_cfgMsg:getCfgMsg("map_D",mapCfgID)
		local name = cfgMsg.name
		local index = cfgMsg.value2
		text_name:setText(name.."【"..G_tb_fubenType[index].."】")

		local cost = cfgMsg.value17
		Label:setText(cost)
	end	
end

function battleDropFailItem:initWnd()
	cclog('battleDropFailItem:initWnd')
	local function funcEndCallBack(btn,tag) 
		local mapId = self.mapCfgID
		if mapId > 100000  then
			g_battleControlFactory:batBtnContorl_fuben(mapId)
		elseif mapId < 0   then
		else
			g_battleControlFactory:batBtnContorl(mapId)
		end

	end 
	g_SetBtnOne(self.rootLayout, "Button_next",1, funcEndCallBack)
	
	
	local function funcEndCallBack(btn,tag) 
		g_jnds_battleContorlNew:startBattleContorl(g_battleControlFactory.batType,g_battleControlFactory.batIDTag)
	end
	g_SetBtnOne(self.rootLayout, "Button_reBat",1, funcEndCallBack)
	
end 

function battleDropFailItem:closeWnd()
	cclog('battleDropFailItem:closeWnd')
end

function battleDropFailItem:openWnd(mapCfgID)
	cclog('battleDropFailItem:openWnd',mapCfgID)
	self.mapCfgID = mapCfgID
	self:setFubenName(mapCfgID)
	
	local dong = self.rootLayout:getTransition("show")
	dong:play();


end

return battleDropFailItem