local battleDropWinItem = class("battleDropWinItem")


function battleDropWinItem:setTime()
	local text_time = self.rootLayout:getChild("text_time")
	local batTime = g_jnds_battleMsg:getBatTime()
	local nTimeStr = cc.getStrTimeByS3(batTime,1) 
	text_time:setText("用时："..nTimeStr)
end

function battleDropWinItem:setListViewItem(info, obj)
	local cfgID = info.id
	local addNumber = info.addNumber
	
end
function battleDropWinItem:setDropList(dropItem)
	local listView_item = self.rootLayout:getChild("listView_item")
	listView_item:itemRenderer(function(index, obj)
		index = index + 1
		local info = dropItem[index]
		self:setListViewItem(info, obj)	
	end)
	
	listView_item:setVirtual()--回调
	local count =  #dropItem or 0
    listView_item:setNumItems(count);
end

function battleDropWinItem:setHeroAddExp(addHeroExp)	
	local listView_hero = self.rootLayout:getChild("listView_hero")
	local items = listView_hero:getChildren()
	cclog("===setHeroAddExp======",addHeroExp)
	for i,obj in pairs(items)do
		local heroID = self.tbHeros[i]
		self:setHeroListViewItem(heroID,obj,addHeroExp)
		local text_add = obj:getChild("text_add")
		text_add:setVisible(true)
		text_add:setText("+"..addHeroExp)
		local dongH = obj:getTransition("show")
		dongH:play()
	end 
end

function battleDropWinItem:setHeroListViewItem(heroID,obj,addHeroExp)
	local heroItem = obj:getChild("heroItem")
	local text_add = obj:getChild("text_add")
	
	local pbHero = g_HeroMgr:getHeroById(heroID)
	g_HeroMgr:setHeroItemInfo(pbHero, nil, heroItem, 0,addHeroExp)
	text_add:setVisible(false)
end
function battleDropWinItem:setHeroList()
	local listView_hero = self.rootLayout:getChild("listView_hero")
	local seleHero = g_heroPickControl:getbatHeroMsg(index)
	self.tbHeros = {}
	local tempHero = g_HeroMgr:getHeroList()
	for i, heroID in pairs(seleHero) do
		if heroID > 0 then
			table.insert(self.tbHeros, heroID)
		end 
	end
	listView_hero:removeChildren()
	for index,v in ipairs(self.tbHeros)do
		local  listItem = listView_hero:addItemFromPool()
		local heroID = self.tbHeros[index]
		self:setHeroListViewItem(heroID, listItem)	
	end 
end

function battleDropWinItem:setFubenName(mapCfgID)
	local text_name = self.rootLayout:getChild("text_name")
	local Label = self.rootLayout:getChild("Label")
	if mapCfgID > 100000 then
		local cfgMsg =  g_cfgMsg:getCfgMsg("fuben_D",mapCfgID)
		local name = cfgMsg.name
		local index = cfgMsg.ceng
		local cost = cfgMsg.power
		
		text_name:setText(name.."【第"..index.."层】")
		local curValue = g_resData:getResMsg(energy) or  0
		Label:setText(cost.."/"..curValue)
		
	else
		local cfgMsg =  g_cfgMsg:getCfgMsg("map_D",mapCfgID)
		local name = cfgMsg.name
		local index = cfgMsg.value2
		local cost = cfgMsg.value10
		
		text_name:setText(name.."【"..G_tb_fubenType[index].."】")
		Label:setText(cost)
	end 
end



function battleDropWinItem:setNextTL()
	if self.mapCfgID > 100000 then
		local cfgMsg =  g_cfgMsg:getCfgMsg("fuben_D",self.mapCfgID)
		local Label = self.rootLayout:getChild("Label")
		local nextTl  = cfgMsg.power
		local nType = cfgMsg.type
		if nType == 4 then
			nextTl = g_battleControlFactory:getFBEquTl()
		end 
		Label:setText(nextTl)
	else	
		--local cfgMsg =  g_cfgMsg:getCfgMsg("map_D",self.mapCfgID)
		--local id = cfgMsg.map_id
		--local nextID = id + 1
		--local whereText = "map_id = "..nextID
		--local tbCfgData =  g_cfgDBControl:selectDbMsgFactory("map_D",whereText)	
		--tbCfgData = tbCfgData[1]
		--local key = tbCfgData.key
		
		--local cfgMsg =  g_cfgMsg:getCfgMsg("map_D",key)
		--local nextTl  = cfgMsg.value17
		--local Label = self.rootLayout:getChild("Label")
		---Label:setText(nextTl)
	end

end

function battleDropWinItem:initWnd()
	cclog('battleDropWinItem:initWnd')
	local function funcEndCallBack(btn,tag) 
		if tag == 1 then
			if self.mapCfgID > 100000  then
				--判断体力
				local status = g_battleControlFactory:getFubenNeedTiLi(self.mapCfgID)
				if not  status then
					return 
				end
				if self.isSaoDang then
					local  num =  g_taskConTrol:getTaskFinishNum(g_TaskStatisticsType.Daily_saodangFreeNum) or 0
					local number =  saodangFreeNum -  num
					cclog(number,"=====saodangFreeNum====",num)
					if number <= 0  then
						--判断月卡
						local  statusOpen =  g_otherConTrol:isYueKaOpen30()
						if statusOpen then
						else
							g_action:ts_hszz_antion("每天只有3次免费扫荡 ")
							return
						end
					end 		
					
					g_battleControlFactory:test_BatContorl(1,self.mapCfgID,1)
					g_taskConTrol:addTaskFinishNum(g_TaskStatisticsType.Daily_saodangFreeNum,1)
			
				else
					g_battleControlFactory:batBtnContorl_fuben(self.mapCfgID)
				end
				
			
				
			else
				local mapId = g_battleControlFactory:getNextFubenID(self.mapCfgID)
				g_battleControlFactory:batBtnContorl(mapId)
			end
		end 
	end 
	
	local Button_next = self.rootLayout:getChild("Button_next")
	g_SetBtnOne(nil,nil,1, funcEndCallBack,Button_next)
	
	
	local function funcEndCallBack(btn,tag) 
		--是否开启
		local  statusOpen = g_otherConTrol:isYueKaOpen15()
		if statusOpen then
			g_jnds_battleContorlNew:startBattleContorl(g_battleControlFactory.batType,g_battleControlFactory.batIDTag)
		else
			g_action:ts_hszz_antion("还未开启半月卡")
		end
		
	end
	g_SetBtnOne(self.rootLayout, "Button_reBat",1, funcEndCallBack)

end 

function battleDropWinItem:closeWnd()
	cclog('battleDropWinItem:closeWnd')
	
end

function battleDropWinItem:openWnd(mapCfgID,isSaoDang)
	cclog('battleDropWinItem:openWnd:',mapCfgID,isSaoDang)
	self:setFubenName(mapCfgID)
	g_WinmapCfgID = mapCfgID
	self.mapCfgID = mapCfgID
	self.isSaoDang = isSaoDang
	local listView_item = self.rootLayout:getChild("listView_item")
	listView_item:setVisible(false)
	local Button_next = self.rootLayout:getChild("Button_next")
	
	local function callback(dropItem,addHeroExp)
		if  not self.rootLayout then
			return 
		end
		local listView_item = self.rootLayout:getChild("listView_item")
		listView_item:setVisible(true)
		self:setDropList(dropItem)
		
		local function callbackExp()
			self:setHeroAddExp(addHeroExp)	
		end
		if  mapCfgID < 100000 then
			local cfgMsg =  g_cfgMsg:getCfgMsg("map_D",mapCfgID)
			local itemIndex = cfgMsg.map_id + 1
			local mapWnd = g_WndMgr:getWnd("mapWnd")
			if mapWnd   then
				mapWnd:setFuBenBtn(itemIndex)
			end
			local mapDetWnd = g_WndMgr:getWnd("mapDetWnd")
			if mapDetWnd   then
				mapDetWnd:setListDif()
			end
			
			local dongH = self.rootLayout:getTransition("show")
			
			dongH:play(callbackExp);
		else
			local t1 = self.rootLayout:getTransition("t1")
			if isSaoDang then
				Button_next:setText("继续扫荡")
			else
				Button_next:setText("继续战斗")
			end
			---
			t1:play(callbackExp);
		end	
	end
	local tbatHeroMsg = g_heroPickControl:getbatHeroMsg() or  {}
	local hero = tbatHeroMsg
	
	self:setHeroList()
	self:setNextTL()
	
	
	if isSaoDang then
		g_svSendMsgControl:request_mapInfo(11,mapCfgID,hero,callback)
	else
		g_svSendMsgControl:request_mapInfo(1,mapCfgID,hero,callback)
	end 
	self:setTime()
	
end

return battleDropWinItem