
local GMcPanle2 = class("GMcPanle2")


local tbWndMsg = {  "D_GM" ,"D_GM", "item_gm(2", "app.views.panle.GMcPanle2"}

function GMcPanle2:closeWnd()
	cclog('setNameItem:closeWnd')
	if not self.rootLayout then
		return
	end 
	self.rootLayout:removeFromParent()
	self.rootLayout = nil
end

function GMcPanle2:initWnd()
	local  szPacakgePath = tbWndMsg[1]
	local  szPacakge = tbWndMsg[2]
	local szWndName = tbWndMsg[3]
	fgui.UIPackage:addPackage(szPacakgePath)
	local _view = fgui.UIPackage:createObject(szPacakge, szWndName)
	self.rootLayout = _view	
	g_GameDataMgr.rootObj:addChild(_view);
	_view:setPosition(0, 0)
	local function funcEndCallBack(btn,tag) 
		 self:closeWnd()
	end 
	g_SetBtnOne(self.rootLayout, "clockBtn",1, funcEndCallBack)	
end

local dltbInfo = {}
local cztbInfo = {}
function GMcPanle2:setDltbInfo(info)	
	dltbInfo = info
end
function GMcPanle2:getDltbInfo(id)	
	if  id then
		return dltbInfo[id]
	end 
	 return  dltbInfo
end

function GMcPanle2:setCztbInfo(info)	
	cztbInfo = info
end
function GMcPanle2:getCztbInfo(id)	
	if  id then
		return cztbInfo[id]
	end 
	 return  cztbInfo
end

function GMcPanle2:setDLListItem(obj,indexD)	
	local info = self:getDltbInfo(indexD)	
	local text1 = obj:getChild("text1")
	local text2 = obj:getChild("text2")
	local text3 = obj:getChild("text3")
	local text4 = obj:getChild("text4")
	--cclog("=setDLListItem====",info)
	local nickName = info.nickName
	local id = info.id
	text1:setText(nickName.."("..id..")")
	
	local ntime = info.ntime
	local str = g_getTimeDate2D(ntime)
	text3:setText(str)
	local ntime2 = info.ntime2
	local str = g_getTime2(ntime2)
	text4:setText(str)
	
	local jifen = info.jifen
	local maxMapID = info.maxMapID
	local  status =  g_bTimeDate(ntime)
	if status then
		text2:setText(maxMapID.."/"..jifen.."新")
	else		
		text2:setText(maxMapID.."/"..jifen)
	end 
end

function GMcPanle2:initAlltext1()	
	local allText1 = self.rootLayout:getChild("allText1")
	local allText2 = self.rootLayout:getChild("allText2")
	local tbMsg = self:getDltbInfo()	
	
	local count = 0
	for i,v in ipairs(tbMsg)do
		local  status =  g_bTimeDate(v.ntime)
		if status then
			count = count+1	
		end 
	end 
	allText1:setText(count)

	local  count = #tbMsg-count
	allText2:setText(count)
end
function GMcPanle2:initDLList()
	local tbMsg = self:getDltbInfo()	
	local ntime=  g_getDaytime(os.time())  
	local function comps(a,b)
		local ntime1 = tonumber(a.ntime)
		local ntime2 = tonumber(b.ntime)
		if ntime1 > ntime and ntime2 >  ntime then
			if a.jifen ==  b.jifen then
				if  a.maxMapID ==  b.maxMapID then	
					return a.ntime >  b.ntime
				else
					return a.maxMapID >  b.maxMapID
				end 
			else
				return a.jifen >  b.jifen
			end 
		elseif ntime1 > ntime then
			return true
		elseif ntime1 < ntime  and ntime2 < ntime  then
			if a.jifen ==  b.jifen then
				if  a.maxMapID ==  b.maxMapID then	
					return a.ntime >  b.ntime
				else
					return a.maxMapID >  b.maxMapID
				end 
			else
				return a.jifen >  b.jifen
			end 
			return false
		end 
	end
	table.sort(tbMsg, comps)
	local dlList = self.rootLayout:getChild("dlList")
	dlList:itemRenderer(function(index, obj)
		local indexD = index + 1
		obj:setCustomData(indexD)
		self:setDLListItem(obj,indexD)	
	end)
	--cclog("=initDLList====",tbMsg)
	dlList:setVirtual()--回调
	dlList:setNumItems(#tbMsg);
	 self:initAlltext1()	
end

----=========================================================

function GMcPanle2:setCZListItem(obj,indexD)	
	local info = self:getCztbInfo(indexD)	
	local text1 = obj:getChild("text1")
	local text2 = obj:getChild("text2")
	local text3 = obj:getChild("text3")
	local text4 = obj:getChild("text4")
	local nickName = info.nickName
	local id = info.id
	text1:setText(nickName.."("..id..")")
	local maxMapID = info.maxMapID
	local ntime = info.ntime
	local str = g_getTime2(ntime)
	text4:setText(str)
	text3:setText(maxMapID.."/"..info.jifen)

	local czID = info.czID
	local cfgMsg =  g_cfgMsg:getCfgMsg("chongzhi_D",czID) 
	text2:setText(cfgMsg.name)
end

function GMcPanle2:initAlltext2()	
	local allText1 = self.rootLayout:getChild("allText1")
	local allText2 = self.rootLayout:getChild("allText2")
	local tbMsg = self:getCztbInfo()	
	local count = 0
	for i,v in ipairs(tbMsg)do
		local czID = v.czID
		local cfgMsg =  g_cfgMsg:getCfgMsg("chongzhi_D",czID) 
		local cost = cfgMsg.cost
		count = count+ cost
	end 
	allText1:setText(count)
end
function GMcPanle2:initCzList()
	local tbMsg = self:getCztbInfo()	
	local czList = self.rootLayout:getChild("czList")
	czList:itemRenderer(function(index, obj)
		local indexD = index + 1
		obj:setCustomData(indexD)
		self:setCZListItem(obj,indexD)	
	end)
	czList:setVirtual()--回调
	czList:setNumItems(#tbMsg);
	self:initAlltext2()	
end

function GMcPanle2:touch(tag)	
	local c1 =self.rootLayout:getController("c1") --控制器	
	if  tag == 0  then
		self:initAlltext1()	
	else
		self:initAlltext2()	
	end
	c1:setSelectedIndex(tag)
end
function GMcPanle2:initBtn()	
	local c1 =self.rootLayout:getController("c1") --控制器	
	local function funcEndCallBack(btn,tag) 
		self:touch(tag)	
	end 
	g_SetBtnOne(self.rootLayout, "xzBt",0, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "czBtn",1, funcEndCallBack)	
end 

function GMcPanle2:openWnd()
	self:initWnd()
	self:initBtn()	
	g_svSendMsgControl:request_cmdMsg("newPlayer",szPayId,szKey)
	
end 
function GMcPanle2:ctor()
end

g_GMcPanle2 =  GMcPanle2:create()