
local b_talk = class("b_talk")

local tbWndMsg = {  "a_mainSence" ,"a_mainSence", "b_talk", "app.views.panle.b_talk"}

function b_talk:closeWnd()
	g_erroStr = nil
	self.rootLayout:removeFromParent()
	self.rootLayout = nil
	cclog('b_talk:closeWnd',self.rootLayout)
end

function b_talk:initWnd()
	if self.rootLayout then
		self:closeWnd()
	end 
	local  szPacakgePath = tbWndMsg[1]
	local  szPacakge = tbWndMsg[2]
	local szWndName = tbWndMsg[3]
	fgui.UIPackage:addPackage(szPacakgePath)
	local _view = fgui.UIPackage:createObject(szPacakge, szWndName)
	self.rootLayout = _view	
	g_GameDataMgr.rootObj:addChild(_view)
	_view:setPosition(0, 0)
	local _view =_view:displayObject()
	_view:setLocalZOrder(G_tishiLocalZOrder+4)
end

function b_talk:setWd(cfgID,callback)
	local cfgTalkMsg =  g_cfgMsg:getCfgMsg("talk_D",cfgID) 
	local contorl1 = cfgTalkMsg.contorl1
	local contorl2 = cfgTalkMsg.contorl2 or 0
	local c1 =self.rootLayout:getController("c1") --控制器	
	local c2 =self.rootLayout:getController("c2") --控制器	
	cclog("====setWd===b_talk===",cfgID,contorl1,contorl2,cfgTalkMsg)
	
	c1:setSelectedIndex(contorl2)
	c2:setSelectedIndex(contorl1)
	
	local headIcon = self.rootLayout:getChild("headIcon")
	local name = self.rootLayout:getChild("name")
	
	local ion = cfgTalkMsg.ion
	if ion == "1" or  ion == "2"  then
		local index = tonumber(ion)
		local heroCfgID = g_baseBatMsg:getbaseBatMsgHero(index) or 0
		local curCfgID
		if heroCfgID > 0  then
			curCfgID = heroCfgID
		else
			local index = (index%2)+1
			local heroCfgID = g_baseBatMsg:getbaseBatMsgHero(index) or 0
			if heroCfgID > 0  then
				curCfgID = heroCfgID
			else
				curCfgID = 90000001
			end 
		end 
		local cfgMsg =  g_cfgMsg:getCfgMsg("role_D",curCfgID) 
		local iconPath = g_iconConTrol:getHeroIcon(cfgMsg.heroHead)
		headIcon:setIcon(iconPath)
		name:setText(cfgMsg.name)
		
	elseif   ion == "100" then
		local anima,namEtex
		if not self.isTalk then
			local mapID = cfgTalkMsg.mapID
			local tbMsgMap =  g_cfgMsg:getCfgMsg("map_D",mapID)
			local bossID = tbMsgMap.bossID
			local tbMap =  g_cfgMsg:getCfgMsg("enemy_D",bossID)
			anima = tbMap.anima
			namEtex = tbMap.name
		else
			tbMap =  g_cfgMsg:getCfgMsg("enemyBOSS_D",self.isTalk )
			 namEtex = tbMap.name2
			 anima = tbMap.anima
		end 
		name:setText(namEtex)
		local iconPath = g_iconConTrol:getEnemyIcon(anima)
		headIcon:setIcon(iconPath)
	else
		local iconPath = g_iconConTrol:getHeroIcon(ion)
		headIcon:setIcon(iconPath)
		name:setText(cfgMsg.name)
	end 
	
	local Dec = self.rootLayout:getChild("Dec")
	showTextActionFGUI(Dec,cfgTalkMsg.dec)

	local function funcEndCallBack(btn,tag)
		--下一个对话
		if cfgID   > 100000  then
			g_mainRWMsg:setMainRWMsgTalkIndex(cfgID)
			g_svSendMsgControl:request_mainRW(3,cfgID)
		end 
	
		local  nextID = cfgTalkMsg.nextID
		cclog(cfgID,"========funcEndCallBack==========",nextID,cfgTalkMsg)
		if nextID > 0 then
	
			 self:setWd(nextID,callback)
		else
			---如果没有
			---关闭
			----g_mainRWMsg:isFinishRW(cfgID)
			local curWndID =  g_WndMgr:getTopWndID()	
			if curWndID ==  "MainScene" or cfgID ==  100510  then
				if cfgID   > 100000  then
					g_mainRWMsg:isFinishRW(cfgID)
				end 
			end 
			
			self:closeWnd()
			if callback then
				callback(cfgID)
			end 
		end 
	end 
	
	local function funcEndCallBackBtn(btn,tag)
		local str = cfgTalkMsg["btnDec"..tag]
		---g_quedingItem2:openWnd(str) 
		g_svSendMsgControl:request_mainRW(3,cfgID)
		---g_mainRWMsg:isFinishRW(cfgID)
		local curWndID =  g_WndMgr:getTopWndID()	
		if curWndID ==  "MainScene" or cfgID ==  100510  then
			g_mainRWMsg:isFinishRW(cfgID)
		end 
		self:closeWnd()
		if callback then
			callback()
		end
	end 
	if contorl2 == 1  then
		for i=1,2 do
			local starBtn = self.rootLayout:getChild("starBtn"..i)
			local title = starBtn:getChild("title")
			title:setText(cfgTalkMsg["btn"..i])
			g_SetBtnOne(nil,nil,i, funcEndCallBackBtn,starBtn)
		end 
		g_SetBtnOne(self.rootLayout,"touchBg",1, funcEndCallBackBtn)
	else
		g_SetBtnOne(self.rootLayout,"touchBg",i, funcEndCallBack)
	end 

	local cfgMsg =  g_cfgMsg:getCfgMsg("mainRenwu_D",cfgTalkMsg.renwuID)
	local touchBg = self.rootLayout:getChild("touchBg")
	---local iconpath = g_iconConTrol:getBigIcon(cfgMsg.iconBg)
	local c3 =self.rootLayout:getController("c3") --控制器	
	--if   ion == "100" or cfgTalkMsg.BgIcon == 1 then  
	c3:setSelectedIndex(1)
	--else
		--touchBg:setIcon(iconpath)
	--end
	
end 

function b_talk:openWnd(cfgID,callback,isTalk)
	local cfgTalkMsg =  g_cfgMsg:getCfgMsg("talk_D",cfgID) 
	if not cfgTalkMsg then
		return
	end 
	self.isTalk = isTalk
	self:initWnd()

	cclog("==openWnd=b_talk==",cfgID,callback)
	self:setWd(cfgID,callback)

end

function b_talk:ctor()
end

g_b_talk =  b_talk:create()