
local ComponentBaozang = class("ComponentBaozang")

function ComponentBaozang:initWnd()
	local function callBack()
		g_svSendMsgControl:request_getBaozangMsg(1,self.curIndex)
	end 

	local function funcEndCallBack(btn,tag) 
		if tag == 1 then
			--看广告
			
			 local DoubleNum = g_taskConTrol:getTaskFinishNum(g_TaskStatisticsType.Daily_baozangDoubleNum) or 0
			
			local info = g_baozangInfoMsg:getBzInfoTbMsg(self.curIndex)
			if not info then
				return
			end 
			
			--if DoubleNum >= tbGameConst.bzShuangNum then
			--	g_action:ts_hszz_antion("每日双倍上限"..tbGameConst.bzShuangNum.."次")
				--return
			---end 
			if info.status == 1 then
				g_action:ts_hszz_antion("已经是双倍")
				return 
			end 
			setADSFunc(g_tbAdsReward.bzDouble,callBack)
			g_API_playAds(g_tbAdsReward.bzDouble)
		elseif tag == 2 then
			g_svSendMsgControl:request_getBaozangMsg(2,self.curIndex)
			self:showAnima()
		end 
	end 
	local decPanle =  self.rootLayout:getChild("decPanle") 
	g_SetBtnOne(decPanle, "btnShuang",1, funcEndCallBack)	
	g_SetBtnOne(decPanle, "btnget",2, funcEndCallBack)	

end 

function ComponentBaozang:showAnima()

	local Panel_ = self.rootLayout:displayObject()
	local pos = cc.p(127,840 - 193)
	local ArmatureEndA = g_gArmature:showArmatureByNums("FateSellAnimation",nil,Panel_,nil,nil,pos,1.5,endCallBcak)
	g_gameMusic:playEffect(73)
end 

function ComponentBaozang:setScheduleByOne()
	local decPanle =  self.rootLayout:getChild("decPanle") 
	local textTime =  decPanle:getChild("textTime") 
	local bar1 =  decPanle:getChild("bar1") 

	local info = g_baozangInfoMsg:getBzInfoTbMsg(self.curIndex)
	local tbbzMsg =  g_cfgMsg:getCfgMsg("baozangName_D",info.nameCfgID)
	
	local startTime = info.startTime or 0

	local coolTime_Str,nTime  = getCoolTimeStr1(startTime ,tbbzMsg.nTime)
	textTime:setText("探索中..."..coolTime_Str)
	
	bar1:setMax(tbbzMsg.nTime)
	bar1:setValue(tbbzMsg.nTime - nTime)
	local c1 =  decPanle:getController("c1") --控制器
	local textTimeD = textTime:displayObject()
	local function callBack()
		local coolTime_Str,nTime  = getCoolTimeStr1(info.startTime or 0 ,tbbzMsg.nTime)
		textTime:setText("探索中..."..coolTime_Str)
		bar1:setValue(tbbzMsg.nTime - nTime)
		if nTime <= 0  then
			c1:setSelectedIndex(1)
			g_scheduleTime:stopScheduleForever(textTimeD)
		end 
	end 
	g_scheduleTime:scheduleForever(textTimeD,1,callBack)
end



function ComponentBaozang:setDecPanle()	
	
	local info = g_baozangInfoMsg:getBzInfoTbMsg(self.curIndex)
	local c1 =  self.rootLayout:getController("c1") --控制器
	
	if not info then
		c1:setSelectedIndex(1)
		return
	end 
	local baozID = info.nameCfgID
	local tbbzMsg =  g_cfgMsg:getCfgMsg("baozangName_D",baozID)
	
	c1:setSelectedIndex(0)
	local decPanle =  self.rootLayout:getChild("decPanle") 
	local textName =  decPanle:getChild("textName") 
	
	textName:setText(self.curIndex.."."..tbbzMsg.name)
	
	local goodsID = info.goodsID 
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(goodsID)
	local textGoods =  decPanle:getChild("textGoods") 
	local nType = g_getTypeByCfgID(goodsID)
	local str = ""
	if nType == g_cfgType.equT then
		str = "(装备)"
	elseif nType == g_cfgType.pet then
		str = "(宠物)"
	elseif nType == g_cfgType.equ then
		str = "(套装)"
	end 
	textGoods:setText(name..str.."x"..info.number)
	if info.yanse then
		local colorID = G_tb_TextColor[info.yanse]
		cc.g_setTextColor(textGoods,colorID,true)
	else
		local colorID = G_tb_TextColor[yanse]
		cc.g_setTextColor(textGoods,colorID,true)
	end 
	local startTime = info.startTime 
	if not startTime and index == 1 then
		startTime = 0
	else
		startTime = os.time()
	end  
	local nTime =  g_getCursvTime() -  startTime 
	
	local c1 =  decPanle:getController("c1") --控制器
	cclog(nTime,"=====tbbzMsg.nTime===",tbbzMsg.nTime)
	if nTime >= tbbzMsg.nTime then
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
		self:setScheduleByOne()
	end 
	
	local c2 =  decPanle:getController("c2") --控制器
	
	local Daily_baozangDoubleNum = g_taskConTrol:getTaskFinishNum(g_TaskStatisticsType.Daily_baozangDoubleNum) or 0
	
	local tbMsg =  g_cfgMsg:getCfgMsg("baozangReward_D",self.curIndex)
	local number = info.number
	local status = info.status or 0
	
	local c3 =  decPanle:getController("c3") --控制器
	
	if Daily_baozangDoubleNum >= tbGameConst.bzShuangNum  then
		c2:setSelectedIndex(1)
	elseif  status == 1  then
		c2:setSelectedIndex(0)
		c3:setSelectedIndex(0)
	else
		c2:setSelectedIndex(0)
		c3:setSelectedIndex(1)
	end 

	textGoods:setText(name.."x"..number)
end

function ComponentBaozang:setListItem(obj,index)	
	local info = g_baozangInfoMsg:getBzInfoTbMsg(index)
	local title =  obj:getChild("title") 
	local tbbaozID = info.nameCfgID
	local tbMsg =  g_cfgMsg:getCfgMsg("baozangName_D",tbbaozID)
	title:setText(index.."."..tbMsg.name)
	
	local goodsID = info.goodsID 
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(goodsID)
	local textGoods =  obj:getChild("textGoods") 
	local nType = g_getTypeByCfgID(goodsID)
	local str = ""
	if nType == g_cfgType.equT then
		str = "(装备)"
	elseif nType == g_cfgType.pet then
		str = "(宠物)"
	elseif nType == g_cfgType.equ then
		str = "(套装)"
	end 
	textGoods:setText(name..str.."x"..info.number)
	if info.yanse then
		local colorID = G_tb_TextColor[info.yanse]
		cc.g_setTextColor(textGoods,colorID,true)
	else
		local colorID = G_tb_TextColor[yanse]
		cc.g_setTextColor(textGoods,colorID,true)
	end 
	
	local c1 =  obj:getController("c1") --控制器

	if index < self.curIndex then
		c1:setSelectedIndex(1)
		cc.g_setTextColor(textGoods,1,true)
	elseif  index ==  self.curIndex then
		c1:setSelectedIndex(0)
	elseif  index >  self.curIndex then	
		c1:setSelectedIndex(2)
	end 
end 
--计算当前
function ComponentBaozang:mathCurIndex()
	local tbMsg = g_baozangInfoMsg:getBzInfoTbMsg()
	
	for i,info in ipairs(tbMsg)do
		if not info.status or info.status ~= -1 then
			self.curIndex  = i 
			return 
		end 
	end 
	self.curIndex = #tbMsg + 1
end 

function ComponentBaozang:setList()
	local bzList = self.rootLayout:getChild("bzList") 
	local tbbaozID = g_baseMsg:getTbInteger(tbIntegerKEy.baozID) or {}	
	local tbMsg = g_baozangInfoMsg:getBzInfoTbMsg()
	bzList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local cfgID = indexD
			obj:setCustomData(cfgID)
			self:setListItem(obj,cfgID)	
		end)
	bzList:setVirtual()--回调
	bzList:setNumItems(#tbMsg);
end 
function ComponentBaozang:openWnd(anima)	
	cclog("==11=openWnd=========")
	self:mathCurIndex()
	self:initWnd()
	self:setList()
	self:setDecPanle()	
	if anima then
		local t0 = self.rootLayout:getTransition("t0")
		t0:play()
		---
	end 
	
end 

	
return ComponentBaozang
