
local ComponentFb = class("ComponentFb")

function ComponentFb:initWnd()

	local function funcEndCallBack(btn,tag) 
		cclog("======initWnd======",tag)
		if tag == 1 then
			
		elseif tag == 2 then

		end 
	end 
	g_SetBtnOne(self.rootLayout, "btnMain3",2, funcEndCallBack)	
end 

function ComponentFb:setListItem(obj,cfgID)	
	local title = obj:getChild("title")
	local textReWard = obj:getChild("textReWard")
	local cfgMsg =  g_cfgMsg:getCfgMsg("map_D",cfgID)
	local mapLev = g_batMath:getMapLev(cfgID) 
	title:setText(cfgMsg.name.."("..mapLev.."层)")
	
	local c1 =  obj:getController("c1") --控制器
	local level = g_roleMsg:getRoleAttValue(RoleAttMsg.level,true)
	if level < cfgMsg.openLev  then
		textReWard:setText("角色等级："..cfgMsg.openLev.."级后开启")
		cc.g_setTextColor(title,1,true)
		c1:setSelectedIndex(1)
	else
		textReWard:setText("")
		c1:setSelectedIndex(0)
	end 
	local colorID = G_tb_TextColor[cfgMsg.yanse]
	cc.g_setTextColor(title,colorID,true)
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	if mapType == cfgID then
		c1:setSelectedIndex(2)
	end 
	local function funcEndCallBack(btn,tag) 
		if level < cfgMsg.openLev  then	
			g_action:ts_hszz_antion("副本未开启")
			return
		end 
		--进入副本
		g_svSendMsgControl:request_geBatMsg(3,cfgID)
		self:close()
	end 
	g_SetBtnOne(obj, "btnMain3",2, funcEndCallBack)	
end 

function ComponentFb:setList()
	local cfgMsg =  g_cfgMsg:getCfgMsg("map_D")
	self.tbMsg = {}
	for i,v in pairs(cfgMsg)do
		if v.openD ~= -1 then
			self.tbMsg[#self.tbMsg+1] = v
		end 
	end 

	local fbList = self.rootLayout:getChild("fbList")
	fbList:itemRenderer(function(index, obj)
		local indexD = index + 1
		local cfgID = self.tbMsg[indexD].key
		obj:setCustomData(cfgID)
		self:setListItem(obj,cfgID)	
	end)
	fbList:setVirtual()--回调
    fbList:setNumItems(#self.tbMsg);
end 

function ComponentFb:closeWnd()
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local c2 =  B_FbBat.rootLayout:getController("c2") --控制器
	c2:setSelectedIndex(0)
end 

function ComponentFb:openWnd()
	self:initWnd()
	self:setList()
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local c2 =  B_FbBat.rootLayout:getController("c2") --控制器
	c2:setSelectedIndex(1)
end 

	
return ComponentFb
