
local ComponentLevUp = class("ComponentLevUp")

function ComponentLevUp:initWnd()

end 

function ComponentLevUp:mathLevUpNeedNum(Lev)
	local value = 100 + (Lev-1)*50
	return value
end 

function ComponentLevUp:setPanleAtt()
	local info = g_petMsg:getpetTbMsg(self.petID)
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",info.cfgID) 
	local zhizi = g_petMsg:getPetZZ(info.id)
	for i=1,4 do
		local  TextAtt =  self.rootLayout:getChild("TextAtt"..i) 
		local  TextAttCe =  self.rootLayout:getChild("TextAttCe"..i) 
		local value1 = g_mathConTrol:mathPetBaseAtt(info.Level,i,zhizi,info.id) 
		local value2 = g_mathConTrol:mathPetBaseAtt(info.Level+1,i,zhizi,info.id) 
		
		TextAtt:setVar("value",tostring(value2 - value1 )) 
		TextAtt:flushVars()
		if TextAttCe then	
			TextAttCe:setVar("value",tostring(cfgMsg["addAttCe"..i])) 
			TextAttCe:flushVars()
		end 
		
	end 

end 

function ComponentLevUp:setPanle()

	local info = g_petMsg:getpetTbMsg(self.petID)
	local  TextZC =  self.rootLayout:getChild("TextZC") 
	local  petName =  self.rootLayout:getChild("petName") 
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(info.cfgID)
	petName:setText(name)
	local colorID = G_tb_TextColor[info.yanse]
	cc.g_setTextColor(petName,colorID,true)
	
	local  textZZ =  self.rootLayout:getChild("textZZ") 
	textZZ:setText("资质："..g_petMsg:getPetZZ(info.id))
	
	local  textNeedCl =  self.rootLayout:getChild("textNeedCl") 
	TextZC:setText(info.Level.."级")
	local num = self:mathLevUpNeedNum(info.Level)
	textNeedCl:setText("妖兽果x"..num)

	local function funcEndCallBack(btn,tag) 
		cclog("=======funcEndCallBack===")
		local numGoods = g_bagMsg:getGoodsTbMsg(12003009)
		if numGoods <  num then
			g_action:ts_hszz_antion("妖兽果不足")
			return
		end 
		local level = g_roleMsg:getRoleAttValue(RoleAttMsg.level,true)
		if info.Level >= level  then
			g_action:ts_hszz_antion("无法超过角色等级")
			return
		end 
		g_svSendMsgControl:request_getPetMsg(6,self.petID)
	end 
	cclog("=====btnLeUp==funcEndCallBack===",num)
	g_SetBtnOne(self.rootLayout,"btnLeUp",nil,funcEndCallBack)
end 


function ComponentLevUp:closeWnd()
	local B_Pet = g_WndMgr:getWnd("B_Pet")
	local c2 =  B_Pet.rootLayout:getController("c2") --控制器
	c2:setSelectedIndex(0)
end 
function ComponentLevUp:openWnd(petID)
	if petID then
		self.petID = petID
	end 
	self:initWnd()
	
	self:setPanle()
	self:setPanleAtt()
end 

	
return ComponentLevUp
