
local ComponentLevUpStar = class("ComponentLevUpStar")

function ComponentLevUpStar:initWnd()
	local function funcEndCallBack(btn,tag) 
		--判断物品是否有
		local goodsID = 12003020 + self.touchIndex
		local  value = g_bagMsg:getGoodsTbMsg(goodsID) or 0
		if value <= 0 then
			g_action:ts_hszz_antion("物品不足",22)
			return 
		end 
		local B_Pet = g_WndMgr:getWnd("B_Pet")
		local info = g_petMsg:getpetTbMsg(B_Pet.cutTouchID)
		
		if info.starLev and  info.starLev >= tbGameConst.maxPetStarLev then
			g_action:ts_hszz_antion("宠物已满星",22)
			return
		end 
		--self:buyListItemEff(1)
		g_svSendMsgControl:request_getPetMsg(7,B_Pet.cutTouchID,goodsID)
	end 
	g_SetBtnOne(self.rootLayout,"btnLeUp",1, funcEndCallBack)	
	
	
	local B_Pet = g_WndMgr:getWnd("B_Pet")
	local info = g_petMsg:getpetTbMsg(B_Pet.cutTouchID)	
	local  petName =  self.rootLayout:getChild("petName") 

	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(info.cfgID)
	petName:setText(name)
	local colorID = G_tb_TextColor[info.yanse]
	cc.g_setTextColor(petName,colorID,true)
end 


function ComponentLevUpStar:buyListItemEff(goodsID)
	local index = goodsID%10
	local  list =  self.rootLayout:getChild("list")  
	local objD = getChildById(list, index)
	if objD then
		local parent = objD:displayObject()
		local pos = cc.p(120,55)
		local ArmatureEndA = g_gArmature:showArmatureByNums("texiao28","texiao28",parent,nil,nil,pos)
		ArmatureEndA:setScale(3.3,1.6)
	end 
end


function ComponentLevUpStar:setTouchItem(index)
	local  list =  self.rootLayout:getChild("list")  
	if self.touchIndex then
		local panle = getChildById(list, self.touchIndex)
		if panle then
			local c1 =panle:getController("c1") --控制器
			c1:setSelectedIndex(0)
		end 
	end 
	
	local panle = getChildById(list, index)
	if panle then
		local c1 =panle:getController("c1") --控制器
		c1:setSelectedIndex(1)
	end 
	self.touchIndex = index
	local goodsID = 12003020 + index
	local  textDec =  self.rootLayout:getChild("textDec")  
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(goodsID)
	textDec:setText(tbMsg.dec)
end 

function ComponentLevUpStar:setGoodsItemOne(item,index)
	local goodsID = 12003020 + index
	local title = item:getChild("title") 
	local textNum = item:getChild("textNum") 
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(goodsID)
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(title,colorID,true)
	title:setText(name)
	local  value = g_bagMsg:getGoodsTbMsg(goodsID) or 0
	textNum:setText("数量："..value)
	
	local function funcEndCallBack(btn,tag) 
		self:setTouchItem(index)
	end 
	g_SetBtnOne(nil,nil,1, funcEndCallBack,item)	
end 

function ComponentLevUpStar:setGoodsItem()
	local  list =  self.rootLayout:getChild("list")  
	for index=1,7 do
		local  item =  list:getChild("item"..index) 
		item:setCustomData(index)
		self:setGoodsItemOne(item,index)		
	end 
end 

function ComponentLevUpStar:closeWnd()
	local B_Pet = g_WndMgr:getWnd("B_Pet")
	local c2 =  B_Pet.rootLayout:getController("c2") --控制器
	c2:setSelectedIndex(0)
end 
function ComponentLevUpStar:openWnd(petID)
	if petID then
		self.petID = petID
	end 
	self:initWnd()
	self:setTouchItem(1)
	self:setGoodsItem()
end 

	
return ComponentLevUpStar
