
local ComponentSet = class("ComponentSet")

function ComponentSet:initWnd()

	local function funcEndCallBack(btn,tag) 
		cclog("======initWnd======",tag)
		if tag == 1 then
			
		elseif tag == 2 then

		end 
	end 

	local  musicbar1 =  self.rootLayout:getChild("musicbar1") 	
	local function barChage()
		local value = math.floor(musicbar1:getValue())
		cclog(value,"====barChage===111=")
		
		if  g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
			callJavaMusicVolume(value)
		else
			cc.SimpleAudioEngine:getInstance():setMusicVolume(value/100)
		end 
	end 
	musicbar1:addEventListener(cc.UIEventType.Changed,barChage)
	
	local c1 =  self.rootLayout:getController("c1") --控制器
	local bCanPlayMusic = g_gameMusic:getBCanPlayMusic()
	if  bCanPlayMusic == true then
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
	local c3 =  self.rootLayout:getController("c3") --控制器
	local c4 =  self.rootLayout:getController("c4") --控制器
	local c7 =  self.rootLayout:getController("c7") --控制器
	local function funcEndCallBack(btn,tag) 
		if tag == 0 then	
			g_gameMusic:setBCanPlayMusic(false)
			g_gameMusic:setBCanPlayEffect(false)
			c1:setSelectedIndex(0)
		elseif tag == 1 then
			g_gameMusic:setBCanPlayMusic(true)
			g_gameMusic:setBCanPlayEffect(true)
			c1:setSelectedIndex(1)
		elseif tag == 3 then
			local nidex = c3:getSelectedIndex()
			nidex = (nidex+1)%2
			c3:setSelectedIndex(nidex)
			cc.UserDefault:getInstance():setIntegerForKey("dropCoin", nidex)
			local tbMsg = {[0] = "开启","关闭"}
			g_action:ts_hszz_antion(tbMsg[nidex],nil,-2)
		elseif tag == 4 then	
			local tbMsg = {[0] = "加速开启","加速关闭"}
			local nidex = c4:getSelectedIndex()
			nidex = (nidex+1)%2
			c4:setSelectedIndex(nidex)
			cc.UserDefault:getInstance():setIntegerForKey("BOSSSpeed", nidex)
			g_action:ts_hszz_antion(tbMsg[nidex],nil,-2)
		elseif tag == 5 then
			local tbMsg = {[0] = "开启","关闭"}
			local nidex = c7:getSelectedIndex()
			nidex = (nidex+1)%2
			c7:setSelectedIndex(nidex)
			cc.UserDefault:getInstance():setIntegerForKey("batEffct", nidex)
			g_action:ts_hszz_antion(tbMsg[nidex],nil,-2)
		elseif tag == 6 then	
			API_taptapLogOut()
			g_action:ts_hszz_antion("登出成功，请重启游戏")
		elseif tag == 7 then	
			g_WndMgr:touchMainBtn2(nil,3)
		end 
	end
	g_SetBtnOne(self.rootLayout, "checkBtnMusicClose",0, funcEndCallBack,euqItem)
	g_SetBtnOne(self.rootLayout, "checkBtnMusicOpen",1, funcEndCallBack,euqItem)
	
	g_SetBtnOne(self.rootLayout, "checkBtnClose1",3, funcEndCallBack,euqItem)
	g_SetBtnOne(self.rootLayout, "checkBtnClose2",4, funcEndCallBack,euqItem)
	g_SetBtnOne(self.rootLayout, "checkBtnClose3",5, funcEndCallBack,euqItem)
	g_SetBtn(self.rootLayout, "n202",6, funcEndCallBack,euqItem)
	g_SetBtn(self.rootLayout, "n210",7, funcEndCallBack,euqItem)
	local dropCoin = cc.UserDefault:getInstance():getIntegerForKey("dropCoin", 1)
	
	c3:setSelectedIndex(dropCoin)
	local BOSSSpeed =  cc.UserDefault:getInstance():getIntegerForKey("BOSSSpeed", 1)
	
	c4:setSelectedIndex(BOSSSpeed)
	
	
	local  n202 =  self.rootLayout:getChild("n202") 	
	if  PackageName.Taptap == G_PackageName then 
		n202:setVisible(true)
	end 
end 


function ComponentSet:setCheckBtnEqu()	
	local function funcEndCallBack(btn,tag) 
		local equFj = g_baseMsg:getTbInteger(tbIntegerKEy.equFj) or {}	
		local statsu = equFj[tag] or 0
		
		statsu = (statsu+1)%2
		btn:setText(statsu)
		--cclog(type(statsu),"====setCheckBtnEqu======",statsu)
		g_svSendMsgControl:request_msgString(206,nil,tag,statsu)
	end
	
	for i=1,6 do
		local  checkBtn =  self.rootLayout:getChild("checkBtn"..i) 	
		local equFj = g_baseMsg:getTbInteger(tbIntegerKEy.equFj) or {}	
		local statsu = equFj[i] or 0
		checkBtn:setText(statsu)
		g_SetBtnOne(nil, nil,i, funcEndCallBack,checkBtn)
	end 
	
	
end 
function ComponentSet:setCheckBtnCw()	
	local function funcEndCallBack(btn,tag) 
		local cwFj = g_baseMsg:getTbInteger(tbIntegerKEy.cwFj) or {}	
		local statsu = cwFj[tag] or 0
		statsu = (statsu+1)%2

		btn:setText(statsu)
		g_svSendMsgControl:request_msgString(207,nil,tag,statsu)
	end
	
	for i=1,7 do
		local  checkBtn =  self.rootLayout:getChild("checkPetBtn"..i) 	
		local cwFj = g_baseMsg:getTbInteger(tbIntegerKEy.cwFj) or {}	
		local statsu = cwFj[i] or 0
		checkBtn:setText(statsu)
		g_SetBtnOne(nil, nil,i, funcEndCallBack,checkBtn)
	end 

end 

function ComponentSet:closeWnd()

end 

function ComponentSet:openWnd(status)
	self:initWnd()
	local addVip = g_viplevMsg:getVipValue(14)
	local c5 =  self.rootLayout:getController("c5") --控制器
	c5:setSelectedIndex(1)
	self:setCheckBtnEqu()	
	self:setCheckBtnCw()	
	
	local  n202 =  self.rootLayout:getChild("n202") 	
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		if  G_PackageName == PackageName.Taptap then
			n202:setVisible(true)
		end 
	end
	cclog(status,"=openWnd===========")
	local c8 =  self.rootLayout:getController("c8") --控制器
	if status then
		
		c8:setSelectedIndex(1)
	else
		c8:setSelectedIndex(0)
	end 
	
	
end 

	
return ComponentSet
