---resolution 1136x640 -search-path G:\work\zbds3;G:\work\zbds3\src;G:\work\zbds3\res
--require("LuaDebuggee").StartDebug("127.0.0.1", 9826)
--调试用的
--require('LuaDebuggee').StartDebug('127.0.0.1', 9826)
--加载文件
function g_LoadFile(filename)
	package.loaded[filename] = nil
	local instance = require(filename)
	print(string.format("LoadFile:%s->%s", tostring(instance), filename))
	return instance
end

kTargetWindows = 0
kTargetAndroid = 3
kTargetIpad = cc.PLATFORM_OS_IPAD
kTargetIphone = cc.PLATFORM_OS_IPHONE
 OS_ANDROID = 3
 OS_WINDOWS = 0
g_visibleSize = cc.Director:getInstance():getVisibleSize()
g_SafeAreaSize = cc.Director:getInstance():getSafeAreaRect()
GtestLog = 1

G_PackageName = "D"
PackageName = {}
PackageName.oppo = "com.czx.ycdxc.nearme.gamecenter"
PackageName.Taptap = "com.boss.www"
PackageName.kuaibao = "com.kuaibaoBoss.www"
PackageName.Test = "com.Test.www"
local function addSearchPath()
	local fileUtils = cc.FileUtils:getInstance()
	fileUtils:setPopupNotify(false)
	fileUtils:addSearchPath("src/")
	fileUtils:addSearchPath("res/")
	
	if cc.Application:getInstance():getTargetPlatform()  == OS_WINDOWS    then--window下要处理很多事情
		print("==========kTargetWindows============")
		return
	end
	print(cc.Application:getInstance():getTargetPlatform() , OS_WINDOWS, "=======22===kTargetWindows============")
	local pathToSave = fileUtils:getWritablePath()
	local function dumpSearchPaths()	
		local searchPaths = fileUtils:getSearchPaths()
		print("dumpSearchPaths:"..#searchPaths)
		for i=1, #searchPaths do
			print(searchPaths[i])
		end
	end
	
	if  cc.Application:getInstance():getTargetPlatform()  == OS_ANDROID then
		local writepath= cc.FileUtils:getInstance():getWritablePath()
		
		--fileUtils:addSearchPath(pathR.."src/")
		--fileUtils:addSearchPath(pathR.."res/")
		---local searchPaths = fileUtils:getSearchPaths()

		local searchPaths = fileUtils:getSearchPaths()
		local resPrefix1 = pathToSave.."res/"
		table.insert(searchPaths, 1, resPrefix1)
		local resPrefix2 = pathToSave.."src/"
		table.insert(searchPaths, 1, resPrefix2)
		table.insert(searchPaths, 1, pathToSave)

		local pathR = writepath
		local resPrefix1 = pathR.."res/"
		table.insert(searchPaths, 1, resPrefix1)
		local resPrefix2 = pathR.."src/"
		table.insert(searchPaths, 1, resPrefix2)
		table.insert(searchPaths, 1, pathR)
		
		fileUtils:setSearchPaths(searchPaths)
		
	elseif  cc.Application:getInstance():getTargetPlatform()  == OS_WINDOWS then
	else
		local searchPaths = fileUtils:getSearchPaths()
		local resPrefix1 = pathToSave.."/res/"
		table.insert(searchPaths, 1, resPrefix1)
		local resPrefix2 = pathToSave.."/src/"
		table.insert(searchPaths, 1, resPrefix2)
		table.insert(searchPaths, 1, pathToSave)
		fileUtils:setSearchPaths(searchPaths)
	end 
	--dumpSearchPaths()
	
	dumpSearchPaths()
	
end  



function removeCacheFiles()
	print('removeCacheFiles')
	cc.UserDefault:getInstance():setStringForKey("res-version",  "0")

	--删除 res和lua目录
	local pathToSave = cc.FileUtils:getInstance():getWritablePath()
	os.rmdir(pathToSave.."src/")
	os.rmdir(pathToSave.."res/")
	
	os.remove(pathToSave.."filelist.json")
end

local function checkAppVersion()
	local szAppVer = get_szAppVersion()
	local szCurAppVer = cc.UserDefault:getInstance():getStringForKey("app-version",  "")
	print(string.format("checkAppVersion: %s->%s", szAppVer, szCurAppVer))
	if szCurAppVer == "" then
		cc.UserDefault:getInstance():setStringForKey("app-version",  szAppVer)
	else
		if szAppVer ~= szCurAppVer then
			removeCacheFiles()
			cc.UserDefault:getInstance():setStringForKey("app-version",  szAppVer)
		end
	end
end

local function loadingMyApp()	
	addSearchPath()
	require "config"
	checkAppVersion()
	
	require "cocos.init"
	require "public.init"
	require("app.checkUpdate.checkupdatewnd"):create():openWnd()
end

function g_GetDeviceID()
	if g_Cfg.Platform == OS_WINDOWS then
		return cc.Device:getDeviceUID()	
	else
		local deviceUID = API_GetDeviceID()
		if deviceUID == "" then
			deviceUID = cc.Device:getDeviceUID()
		end
	
		return deviceUID
	end
end


function API_playAds_android_callback(func)
	local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = { "callbacklua", func }
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"callbackLua",args,sigs)
	 if not ok then
        print("============= call callback error")
    else
        print("------------- call callback success")
    end
end


 function callJavaGetAppVer()
	local argsJson = nil
	local sigs = "()I"
	local luaj = require "cocos.cocos2d.luaj"
	local className = "org/cocos2dx/lua/AppActivity"
	local ok,ret = luaj.callStaticMethod(className, "getAppVersionCode", {argsJson}, sigs)
	if not ok then
		print(ok,"==== luaj callJavaGetAppVer error ==== : ", ret)
		
		return "1.7.6"
	else
		print("==== The JNI return is:", ret)
		return ret
	end
	---return "1.7.6"
end



local szAppVersion = nil
function  get_szAppVersion()
	if not szAppVersion then
		if g_Cfg.Platform == OS_WINDOWS then
			szAppVersion = "1200"
		elseif g_Cfg.Platform == OS_ANDROID then
			szAppVersion = tostring( callJavaGetAppVer()+100 )
		else
			szAppVersion = API_getAppVer()
		end
	end
	print( szAppVersion,"=========get_szAppVersion=========")
	return szAppVersion
end
function  GetDeviceID()
	local  DeviceID
	if g_Cfg.Platform == OS_ANDROID then
		DeviceID ="1638594012" -- callJavaGetAppVer()
	else
		DeviceID = API_GetDeviceID()
	end
	 return 
end 

function  get_szCurVersion()
	return cc.UserDefault:getInstance():getStringForKey("res-version",  "0")
end

function  get_FullVersion()
	return string.format("%s.%s", get_szAppVersion(), get_szCurVersion())
end

local function ReportBuglyLog(msg, header)
	if g_Cfg.Platform ~= OS_WINDOWS then
		local header = g_GetDeviceID()
		if g_WeChatData then
			buglySetUserId(g_WeChatData.userid or 0)
			buglyAddUserValue("ID", tostring(g_WeChatData.userid) )
		end
	
		buglyAddUserValue("AppVersion", get_szAppVersion())
		buglyAddUserValue("ResVersion", get_szCurVersion() )
		buglyAddUserValue("Devicetoken", g_GetDeviceID())
				
		buglyReportLuaException(header, msg)
	end	
end


function g_suploadlog1(Errostr)
	
	local pathToSave = cc.FileUtils:getInstance():getWritablePath()
	local gameID =  ""
	local userid =  cc.UserDefault:getInstance():getIntegerForKey("userid", 0)
	if userid == 0 then
		userid = API_GetDeviceID()
	end 
	local toFilePath
	local logName = cc.UserDefault:getInstance():getStringForKey("curLogFile", "")
	local filePath = pathToSave.."LogFiles/"..logName
	local curVersion =  cc.UserDefault:getInstance():getStringForKey("current-version-code",  get_szAppVersion())
	local LogFileName = cc.UserDefault:getInstance():getIntegerForKey("LogFileName", 1)
	if logName ~= g_astSupLog then
		LogFileName = LogFileName + 1
		g_astSupLog  = logName
		cc.UserDefault:getInstance():setIntegerForKey("LogFileName", LogFileName)
		cc.UserDefault:getInstance():setStringForKey("suploadLogFileName", logName)
	end 
	local logName = userid.."_"..LogFileName.."_"..curVersion
	toFilePath = filePath
	local svrIp = g_GameDataMgr.SvrIp -- 
	local  rootSvrIp = string.format("http://%s/", svrIp)
	local  rootSvrIp =  g_GameDataMgr.rootSvrIp 
		
	network.uploadFile(
		function(evt)
			if evt.name == "completed" then
				local request = evt.request
				release_print("REQUEST getResponseStatusCode() = %d", request:getResponseStatusCode())
				--release_print("REQUEST getResponseHeadersString() =\n%s", request:getResponseHeadersString())
				--release_print("REQUEST getResponseDataLength() = %d", request:getResponseDataLength())
				--release_print("REQUEST getResponseString() =\n%s", request:getResponseString())			
			elseif evt.name == "progress" then
				--print(evt.total.." "..evt.dltotal)
				--evt.request:delete()
			end
		end,
		
	
		rootSvrIp.."uploadfile",	
		{
			fileFieldName="filepath",
			filePath = toFilePath,
			contentType = "multipart/form-data",
			fileBuffName = logName..".log",
			extra={
				{"op", "upload"},
				{"act", "upload"},
			}
		}
	)
	
	--if parent then
		--g_action:ts_hszz_antion("提交日志成功 ",22,2,nil,nil,parent)
	--end 
end

g_erroStr = nil
function onChangeState(event,title)

	print( cc.Application:getInstance():getTargetPlatform(),"===333===警告：游戏后台错=====",kTargetWindows)
	if cc.Application:getInstance():getTargetPlatform() == kTargetWindows then
		if     event._usedata ~= g_erroStr then
			g_erroStr = event._usedata
			--g_suploadlog1()
			if G_tableMsgList  and G_tableMsgList.Debug then
				--g_suploadlog1()
				--g_erro_panle:openWnd(g_erroStr,title)
			end 
			g_A_Error:openWnd(g_erroStr)
		
		end	
	elseif 	 cc.Application:getInstance():getTargetPlatform() ~= kTargetWindows  then
		if  event._usedata ~= g_erroStr then
			g_erroStr = event._usedata
			if GtestLog == 1 then
				g_suploadlog1()
			end 
			--g_A_Error:openWnd(g_erroStr)
		end 
	else
		print(cc.Application:getInstance():getTargetPlatform() , kTargetWindows,"==DDD==11==")
	end
end

--https://www.cnblogs.com/jadeboy/p/3978661.html
function __G__TRACKBACK__(msg)	
   -- local msg = debug.traceback(msg, 10)
	local msg = msg..debug.traceback()
	print("=====22===事件监听===游戏有报错=========")
	print(msg)
	print("====22====事件监听===游戏有报错=========")
	local event = cc.EventCustom:new("__G__TRACKBACK__")
	event._usedata = msg
	onChangeState(event)
	cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
    return msg
end

--[[ 尝试调一个function 这个function可以带可变参数
如果被调用的函数有异常 返回false，退出此方法继续执行其他代码并打印出异常信息；]]
local function trycall(func, ...)
    local args = { ... };
    return xpcall(function() func(unpack(args)) end, __G__TRACKBACK__);
end

trycall(loadingMyApp, "lua main trycall")
