---//////////////////////////
--https://open.weixin.qq.com/cgi-bin/showdocument?action=dir_list&t=resource/res_list&verify=1&id=open1419317853&token=&lang=zh_CN

g_LoadFile("app.checkUpdate.xmlSimple")
g_LoadFile("app.checkUpdate.xmlTest")

local function LoadAssetDB()	
	local dbName = "game.db"
	local dbfile = "dbfile/"..dbName
	local writepath= cc.FileUtils:getInstance():getWritablePath()
	local path = writepath.."src/dbfile/"
	local pathR = writepath.."encrypt/src/dbfile/"
	local isHdb = cc.FileUtils:getInstance():isDirectoryExist(pathR)
	local pathDBR = pathR..dbName
	local  isHDbR = cc.FileUtils:getInstance():isFileExist(pathDBR)

	print(isHdb,isHDbR,"===============LoadAssetDB==============="..path)
	if not isHdb then
		cc.FileUtils:getInstance():createDirectory(path)
	end
	local szAppVersion  = get_szAppVersion()
	if not  isHDbR then	
		local pathDB = path..dbName
		local fullPath = cc.FileUtils:getInstance():fullPathForFilename(dbfile)	
		print(string.format("LoadAssetDB copy from:%s to %s", fullPath, pathDB))
		cc.FileUtils:getInstance():copyFile(fullPath, pathDB)
		cc.FileUtils:getInstance():removeFileCache(dbfile)
	else	
		---读取db版本 
		local pathDB = path..dbName
		print(string.format("LoadAssetDB copy from:%s to %s", pathDBR, pathDB))
		cc.FileUtils:getInstance():copyFile(pathDBR, pathDB)
		--cc.FileUtils:getInstance():removeFileCache(dbfile)

	end
end

tbCheckVersionUpdate = {
	CreateFileError = 0,--创建文件是不
	NetError = 1,  	 	--网络异常
	GetVersion = 2,  	--获取版本
	Progress = 3, 		--进度，返回进度值
	CheckFileMd5 = 4,   --文件Md5校验
	Donwload = 5,   	--，返回当前的版本号
	DonwloadSucc = 6,   --成功，返回当前的版本号
	UpdateOver = 7,     
	UpdateFullPackageError = 8,     --结束
	VersionError = 9,  --版本文件失败
	AppVersionLow = 10,  --版本文件过低
}

GtestServer = "123.207.98.23:8097"
publicSvrIp = "112.74.170.146:8097"   --public

if fwqNode and  fwqNode.SVMySv1   then
	local tbMsg = fwqNode:getTbFWQRUl( fwqNode.SVMySv1)
	if tbMsg and   tbMsg[3]  then
		publicSvrIp = tbMsg[3]
	end 
end 
	--GtestServer = "123.207.98.23:8093"
	--publicSvrIp = "112.74.170.146:8093"   --public
--end 
---cclog("=================")

local testSvrIp =  publicSvrIp --local  

if  PackageName.Test == G_PackageName or g_Cfg.Platform  == kTargetWindows  then
	g_GameDataMgr.SvrIp  = "112.74.170.146:8096"   --public
end 

g_GameDataMgr.SvrIp = g_GameDataMgr.SvrIp or testSvrIp
if os.isFileExist("testsvr.txt")  then
	g_GameDataMgr.SvrIp = GtestServer
end
local szAppVer = get_szAppVersion()
cclog(szAppVer,"===g_GameDataMgr.SvrIp ======")

---iptables -A INPUT -p tcp --dport 3690 -j ACCEPT
---cclog(testSvrIp,"====testSvrIp======", g_Cfg.curGameType  )
function setSvrIp()
	if svrIpStr == "local" then
		g_GameDataMgr.SvrIp = testSvrIp
	else
		g_GameDataMgr.SvrIp = testSvrIp
	end 
	
	g_GameDataMgr.rootSvrIp = string.format("http://%s/", g_GameDataMgr.SvrIp)
	cc.UserDefault:getInstance():setStringForKey("g_SvrIp", g_GameDataMgr.svrip)
end 
cclog(g_GameDataMgr.SvrIp ,"===g_GameDataMgr.SvrIp ==333==")
function getSvrIpTest()
	if g_GameDataMgr.SvrIp == publicSvrIp then
		return "pub_"
	elseif g_GameDataMgr.SvrIp == GtestServer then
		return "local_"
	end 
end 
g_GameDataMgr.rootSvrIp = string.format("http://%s/", g_GameDataMgr.SvrIp)
g_GameDataMgr.rootSvrIp2 = string.format("http://%s", g_GameDataMgr.SvrIp)
local rootURL =  g_GameDataMgr.rootSvrIp.."UpdatePackage/"
cclog(curVersion,rootURL, "=====11======222===AssetsManagerDownload===11===",pathToSave)
DetailInfo = {}
function g_decodeXML(xmlbody)
	local xml = require("app.checkUpdate.xmlSimple").newParser()
	local xmlTab = xml:ParseXmlText(xmlbody)
	
	 local tbMsg = xmlTab.Version.UpdatePackages or {}
	 
	for k,v in pairs(tbMsg) do
		local tbMsg = {}
		local tbUpdatePackages ,version,zipMd5
		 if type(v) == "function" then
			tbUpdatePackages = xmlTab.Version.UpdatePackages
			 cclog(k,"HttpGet====222===",tbUpdatePackages)
		 else
			tbUpdatePackages = v
		 end 
		version = tbUpdatePackages["@version"]
		zipMd5 = tbUpdatePackages["@zipMd5"]
		if not DetailInfo[zipMd5] then
			cclog("HttpGet====4444==",tbUpdatePackages,Package)
			if not tbUpdatePackages.Package  then
				return 
			end 
			for i,n in pairs(tbUpdatePackages.Package)do
				if type(n) == "function" then
					local filename = tbUpdatePackages.Package["@filename"]
					tbMsg[i] = filename
					cclog(i,"HttpGet==3=", tbUpdatePackages.Package)
				else
					local filename = n["@filename"]
					tbMsg[i] = filename
				end 
			end 
			DetailInfo[zipMd5]  = tbMsg
		end 

	end	
	return  DetailInfo
end 


local function _rmdir(path)
	local iter, dir_obj = lfs.dir(path)
	print("====_rmdir==1111======",path)
	while true do
		local dir = iter(dir_obj)
		if dir == nil then
			break
		end
		if dir ~= "." and dir ~= ".." then
			local curDir = path..dir
			--cclog(curDir)
			local mode = lfs.attributes(curDir, "mode")
			if mode == "directory" then
				_rmdir(curDir.."/")
			elseif mode == "file" then
				os.remove(curDir)
				print("删除文件:",curDir)	
			end
		end
	end        
end


---是否删除更新文件夹
function AssetsManagerDelFileAll()
	if g_Cfg.Platform  ~= kTargetAndroid then
		return
	end 
	local szAppVersion  = get_szAppVersion()
	local delAssetsDirectory = cc.UserDefault:getInstance():getIntegerForKey("delAssetsDirectory",0 )
	print(szAppVersion,"=====szAppVersionDB========",delAssetsDirectory)
	---if szAppVersion >  delAssetsDirectory then
		--删 拷贝
	local writepath= cc.FileUtils:getInstance():getWritablePath()
	local path = writepath
	local stusts = cc.FileUtils:getInstance():isDirectoryExist(path)
	print(stusts,"=====szAppVersionDB===22=====",path)
	if  stusts then
		local curDir = path
		 _rmdir(curDir)
		cc.UserDefault:getInstance():setIntegerForKey("delAssetsDirectory",szAppVersion )
	end
---	end 
end 		

if g_Cfg.Platform  == kTargetWindows  then
	 rootURL =  g_GameDataMgr.rootSvrIp.."AndroidUpdatePackageTest/"
end 
if g_Cfg.Platform  == kTargetAndroid then
	rootURL =  g_GameDataMgr.rootSvrIp.."AndroidUpdatePackageTapTap/"
	if  PackageName.Test == G_PackageName or g_Cfg.Platform  == kTargetWindows  then
		 rootURL =  g_GameDataMgr.rootSvrIp.."AndroidUpdatePackageTest/"
	end 
	function g_sendDetailInfo()
		local http = string.format('%sversionDetailInfo.xml',rootURL)
		--G_DetailInfo
		  HttpGet(http, function(content)
				
			  g_decodeXML(content)  
		end)
	end
	g_sendDetailInfo()
end

function AssetsManagerDelFile(tbCurVersion)
	local tbMsg = DetailInfo[tbCurVersion]
	for i,filename in pairs(tbMsg)do
		--解析路径
		local tbLogName = string.strSplit(filename, '//')
		local curDir1 ,curDir2
		for i,v in ipairs(tbLogName)do
			--if v ~= "encrypt" then
				if  not curDir  then
					curDir = v
				else
					curDir = curDir.."/"..v
				end 
			--end 
		end 
		if curDir then
			local writepath= cc.FileUtils:getInstance():getWritablePath()
			local path = writepath..curDir
			print(path,"==1==AssetsManagerDelFile======") 
			os.remove(path)
			cclog("删除文件:",path)	
	
		end 
	end 
end 			

--[[
回调函数
fucCallBack(iFlag, data)  iFlag为tbCheckVersionUpdate类型
]]
function AssetsManagerDownload(fucCallBack)
     -- 目录  
	local pathToSave = cc.FileUtils:getInstance():getWritablePath()
	--os.mkdir(pathToSave)
	local curVersion =  get_szCurVersion()-- 字符串
	local assetsManager = nil

   
    local function onProgress( percent )  
        -- 显示进度  
        --local progress = string.format("downloading %s %d%%", assetsManager:getPackageUrl(), percent)  
        local progress = string.format("==downloading %d%%", percent)  
        print(progress)  
		if fucCallBack then
			 print("=====fucCallBack==11===="..percent)  
			fucCallBack(tbCheckVersionUpdate.Progress, percent)
		end
    end  
      
	local tbVersion = {}
	local icurVersionIndex = 0
	local iTryCount = 0
	local iMaxVersionIndex = 0
	local tbVersionList = nil
	local function downloadPackage()
		icurVersionIndex = icurVersionIndex + 1
		
		if icurVersionIndex <= iMaxVersionIndex then
			local tbCurVersion = tbVersion[icurVersionIndex]
			print(string.format("开始解压version=%s, zip = %s.zip", tbCurVersion.version, tbCurVersion.zip))
			g_Cfg.CurDownloadVer = tbCurVersion.version
			if fucCallBack then
				fucCallBack(tbCheckVersionUpdate.Donwload, tbCurVersion.version)
			end
			--删除文件
			if g_Cfg.Platform  == kTargetAndroid  then
				AssetsManagerDelFile(tbCurVersion.zip)
			end 	
			assetsManager:startDownloadPackage(rootURL..tbCurVersion.zip)  
			cc.UserDefault:getInstance():setStringForKey("res-version", tbCurVersion.version)-- 字符串  
		else
			print("解压所有的文件完成！！",fucCallBack)
			if fucCallBack then
				fucCallBack(tbCheckVersionUpdate.UpdateOver, tbVersion[#tbVersion])
				
			end
		end
	end
	
	local function downloadFullPackage()
		icurVersionIndex = iMaxVersionIndex
		local szFullPackageZip = tbVersionList["0.0.0"]
		g_Cfg.CurDownloadVer = "0.0.0"
		if szFullPackageZip then
			print("downloadFullPackage ", szFullPackageZip) 
			assetsManager:startDownloadPackage(rootURL..szFullPackageZip) 
		else
			if fucCallBack then
				fucCallBack(tbCheckVersionUpdate.UpdateFullPackageError)
			end
		end
	end
	
    -- 成功方法回调  
    local function onSuccess()  
        print("downloading ok") 
		if icurVersionIndex > 0 and icurVersionIndex <= iMaxVersionIndex then
			local tbCurVersion = tbVersion[icurVersionIndex]
			cc.UserDefault:getInstance():setStringForKey("res-version", tbCurVersion.version)-- 字符串  
			
			if fucCallBack then
				fucCallBack(tbCheckVersionUpdate.DonwloadSucc, tbCurVersion.version)
			end
		end
		
		downloadPackage()
    end  
    
	-- 错误回调  
    local function onError(errorCode)  
		print("errorCode "..errorCode)  
        -- 没有新版本  AppVer
        if errorCode == tbCheckVersionUpdate.GetVersion then  
			local strData = assetsManager:getVersion()
			
			local  cjson = require("cjson")
			tbVersionList = cjson.decode(strData)	
			local tbKey = cc.g_inalienContentByCfgMsg(tbVersionList.AppVer,0 ,".")
			local iCurAppVersion =  tonumber(table.concat(tbKey)) 
			g_Cfg.curGameType =  tonumber(tbVersionList.GameType) or g_Cfg.online
			g_Cfg.Debug  = (g_Cfg.curGameType ~= g_Cfg.online)
			cclog("版本信息 ",tbVersionList)
			if not g_Cfg.Debug then
				local szDevceID = g_GetDeviceID()
				if tbVersionList[szDevceID] then
					----g_Cfg.Debug = true
				end
			end
			
			if not g_Cfg.Debug then
				if os.isFileExist("showlog.txt")  then
					--g_Cfg.Debug = true
				end
			end
			
			tbKey = cc.g_inalienContentByCfgMsg(get_szAppVersion(), 0 ,".")
			local iAppVersion =  tonumber(table.concat(tbKey))
            print("App版本信息 ", iCurAppVersion, iAppVersion,tbVersionList.GameType)
			if iCurAppVersion > iAppVersion then
				if fucCallBack then
					fucCallBack(tbCheckVersionUpdate.AppVersionLow)  ---提示去更新
				end  
			elseif iCurAppVersion == iAppVersion then
				local iCurVersion = tonumber(curVersion)
				print(curVersion, " cur version to number ", iCurVersion)
				for key, value in pairs(tbVersionList.ResVer) do
					local versionNum = tonumber(key)
					print(string.format("tbVersionList:【%s %s %d %d】", key, value, versionNum, iCurVersion))
					if versionNum > iCurVersion then
						table.insert(tbVersion, {version = key, zip = value, numberKey = versionNum})
					end
				end
					
				local function comps(a,b)
					return a.numberKey < b.numberKey
				end
				table.sort(tbVersion, comps)
				
				for key, value in pairs(tbVersion) do
					print(string.format("ready to down:【%s %s %d】", value.version, value.zip, value.numberKey))
				end
				
				iMaxVersionIndex = #tbVersion --最后一个是全包的
				downloadPackage()
            else
				AssetsManagerDelFileAll()
                if fucCallBack then  -- 直接启动 --删除文件
                    fucCallBack(tbCheckVersionUpdate.UpdateOver)
                end
			end
        elseif errorCode == tbCheckVersionUpdate.NetError then  
            -- 网络错误  
            print("network error")  
			if fucCallBack then
				fucCallBack(tbCheckVersionUpdate.NetError)
			end
		elseif errorCode == tbCheckVersionUpdate.CheckFileMd5 then   
            print("文件MD5校验失败")  
			if fucCallBack then
				fucCallBack(tbCheckVersionUpdate.CheckFileMd5)
			end
			
			downloadFullPackage()
        end  
    end  
  

	 -- 获得资源管理器  
    local function getAssetsManager()	
        if nil == assetsManager then  
			local szGM = ""
			if cc.UserDefault:getInstance():getBoolForKey("gm", false) or  cc.UserDefault:getInstance():getBoolForKey("user_predownload", false) then
				szGM = "gm_"
			end
			local urlVersion = rootURL..szGM.."versionlist.json"
	
            -- 创建一个资源管理器，，第二个参数是版本文件，第三个参数是保存路径 
            assetsManager = cc.AssetsManager:new("",  urlVersion,  pathToSave)  
            -- 保留所有权，该方法会增加Ref对象的引用计数  
            assetsManager:retain()  
            -- 设置一系列委托  
            assetsManager:setDelegate(onError, cc.ASSETSMANAGER_PROTOCOL_ERROR )  
            assetsManager:setDelegate(onProgress, cc.ASSETSMANAGER_PROTOCOL_PROGRESS)  
            assetsManager:setDelegate(onSuccess, cc.ASSETSMANAGER_PROTOCOL_SUCCESS )  
            assetsManager:setConnectionTimeout(1)-- 设置连接超时 
        end  
	
        return assetsManager  
    end  
	
    
	assetsManager = getAssetsManager()
	assetsManager:checkUpdate()
	return assetsManager
end

 

function string.strSplit(input, delimiter)
    input = tostring(input)
    delimiter = tostring(delimiter)
	--print('string.strSplit', input, delimiter)
    if (delimiter == '') then 
		return false 
	end
	
    local pos,arr = 0, {}
    for st,sp in function() return string.find(input, delimiter, pos, true) end do
        table.insert(arr, string.sub(input, pos, st - 1))
        pos = sp + 1
    end
	
    table.insert(arr, string.sub(input, pos))
    return arr
end

function CheckValidLog(path)
	if  cc.Application:getInstance():getTargetPlatform()  == OS_ANDROID then
		LoadAssetDB()
	end
	
	local strCurLogFile = cc.Director:getInstance():getConsole():getCurLogFileName()
	local strLogFile =  cc.UserDefault:getInstance():getStringForKey("curLogFile", "")
	local strLastLogFile =  cc.UserDefault:getInstance():getStringForKey("lastLogFile", "")
	
	cclog(strCurLogFile,strLogFile,"=======lastLogFile======",strLastLogFile, OS_ANDROID, cc.Application:getInstance():getTargetPlatform() )
	if strCurLogFile == strLogFile then
		strLogFile = strLastLogFile
	end
	
	cc.UserDefault:getInstance():setStringForKey("lastLogFile", strLogFile)
	cc.UserDefault:getInstance():setStringForKey("curLogFile", strCurLogFile)
    cclog(string.format("curLogfile:%s lastLogfile:%s", strCurLogFile, strLogFile))

    --cclog(os.isDirectoryExist(path),"--------DD-------CheckValidLog-----------------:", path)
    if os.isDirectoryExist(path) then
		local tbValidData = os.date("*t", os.time())
		local iValidTime = tbValidData.year*10000 + tbValidData.month*100 + tbValidData.day
		cclog("-------11--------CheckValidLog:", iValidTime)
        local function _rmdir(path)
            local iter, dir_obj = lfs.dir(path)
            while true do
                local dir = iter(dir_obj)
                if dir == nil then
                    break
                end
               
			    --cclog(dir)
                if dir ~= "." and dir ~= ".." then
                    local curDir = path..dir
                    --cclog(curDir)
                    local mode = lfs.attributes(curDir, "mode")
                    if mode == "directory" then
                        _rmdir(curDir.."/")
                    elseif mode == "file" then
						local tbLogName = string.strSplit(dir, '_')
						--for i =1, #tbLogName do
						--	cclog(tbLogName[i])
						--end
						local iCurTime = tonumber(tbLogName[2])
						cclog(string.format("%d check file %s %d", iValidTime, curDir, iCurTime))
						cclog("=====strCurLogFile=====",strCurLogFile , dir,strLogFile)
						if strCurLogFile ~= dir then
							if (dir ~= strLogFile) then
								os.remove(curDir)
								cclog("删除日志文件:",curDir, dir)	
							end
						end
                    end
                end
            end        
        end	
		_rmdir(path)	
	else
		--cc.FileUtils:getInstance():createDirectory(path)
    end

end

