-- 描  述:	游戏初始化

--创建Cupdatewnd类
local updatewnd = class("updatewnd")
local cjson = require("cjson")

--local  cjson = require "json" --require("cjson")
g_LoadFile("app.common.network")
function HttpGet(url, func)
    print("HttpGet============="..url)
	local request = network.createHTTPRequest(function(event)  
			local request = event.request  
			if event.name ~= "completed" then 
			  --  print("request:getErrorCode(), request:getErrorMessage() ", request:getErrorCode(), request:getErrorMessage())  
				return   
			end  
			local code = request:getResponseStatusCode()  
			if code ~= 200 then -- 鎴愬姛  
				print("code ", code)  
				func(strResponse, false) 	
				return   
			end  
			local strResponse = request:getResponseString()
			print('HttpGet->', strResponse) 
			if func then
				func(strResponse, true) 	
			end
		end,
	url, "GET")  
	
	request:setTimeout(30)
	request:start()
end


function updatewnd:CheckLocalRes(bClear)
	local pathToSave = cc.FileUtils:getInstance():getWritablePath()
	local bCheck = true
	local strData = cc.FileUtils:getInstance():getStringFromFile(pathToSave.."filelist.json")
	cclog("CheckLocalRes Begin:", strData)
	if strData ~= "" then
		local tbFileInfo = cjson.decode(strData)	
		for iFileMd5, filename in pairs(tbFileInfo) do
			local iCurFileMd5 = API_GetFileMd5(pathToSave ..filename)
			cclog(string.format("%s md5:%s->%s", filename, iFileMd5, iCurFileMd5))
			if iCurFileMd5 ~= iFileMd5 then
				cclog(string.format("diff %s md5:%s->%s", filename, iFileMd5, iCurFileMd5))
				bCheck = false
				break
			end
		end
	else
		cclog("CheckLocalRes File not exist")
	end
	print('removeCacheFiles',bCheck)
	if not bCheck then
		print('removeCacheFiles222',bCheck)
		removeCacheFiles()
	end
	
	cclog(string.format("CheckLocalRes:%s", tostring(bCheck)) )
	return bCheck
end



g_Boss_URL = "http://itunes.apple.com/cn/app/id6443587989"   
 appURL = g_Boss_URL
appURLTapTap = "https://www.taptap.com/app/243580"  

function g_androidPackageFunc(ret,isInto)
	local func = loadstring(ret)
	local tbmsg = func()
	G_PackageName = tbmsg.Package
	if  G_PackageName == PackageName.oppo then
		cclog("====11111==g_androidPackageFunc=====",Package)
	end 
	
end

function updatewnd:getAppURL()	
	local appURL
	if g_Cfg.Platform == kTargetAndroid  then
		appURL = appURLTapTap
	else
		appURL = appURL
	end 

	return appURL
end 
function updatewnd:getPackage_android()	
	API_Package_android_callback(g_androidPackageFunc)
	API_getPackage_android()
end 


function updatewnd:initFairgui(scene)
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		g_LoadFile("app.common.jnds_GCCFunc_android")
		self:getPackage_android()	
	end 
	
	
	g_LoadFile("app.common.g_scheduleTime")

	fgui.UIPackage:addPackage("A_loading");
	fgui.UIPackage:addPackage("z_BGres")
	
	--fgui.UIPackage:addPackage("z_res");
	--fgui.UIPackage:addPackage("role1");
	---cc.SpriteFrameCache:getInstance():addSpriteFrames("role1")
	g_LoadFile("app.common.jnds_GCCFunc")
	g_sendSvTbMsg()
	math.randomseed(tostring(os.time()):reverse():sub(1, 6))
	local  rootObj = fgui.GRoot:create(scene);
	scene:setUserObject(rootObj)
	local _view = fgui.UIPackage:createObject("A_loading", "loadingSence")
	
    rootObj:addChild(_view)
	self.rootObj = rootObj
	self.rootLayout = _view

	self.Tips = self.rootLayout:getChild("Tips")
	self.Tips:setText("")
	
	self.updata = self.rootLayout:getChild("updata")
	self.updata:setVisible(true)

	self.updata:addClickListener(function() 
				cc.Application:getInstance():openURL(updatewnd:getAppURL()); 
			end)
	
	local queding = self.rootLayout:getChild("queding")
	local Button = queding:getChild("Button")
	Button:addClickListener(function() 
				cc.Director:getInstance():endToLua()
			end)
	
	local updataOld = self.rootLayout:getChild("updataOld")
	updataOld:addClickListener(function() 
				self:LoginScene()
			end)
			
	
	self.ProgressBar = self.rootLayout:getChild("procent_bar")
	self.text_version = self.rootLayout:getChild("text_version")
	
	
	local _viewObj = _view:displayObject()
	self.iType = -1
	self.iLastType = -1
	local function scheduleByOne()
		if self.iLastType ~= self.iType then
			self.iLastType = self.iType
			self:UpdateErrorDesc()
		elseif  tbCheckVersionUpdate and  self.iType == tbCheckVersionUpdate.Progress then
			self:UpdateErrorDesc()
		end
	end 
	
	g_scheduleTime:scheduleByTimes(_viewObj, 0.1,100000,scheduleByOne)
	local btnTeam = self.rootLayout:getChild("btnTeam")
	btnTeam:setVisible(false)
	local buttonyk = self.rootLayout:getChild("buttonyk")
	cclog("======initFairgui======")
	
	require("app.checkUpdate.fwqNode")
	local function callback()
		g_LoadFile("app.checkUpdate.checkupdate")
		cclog(g_GameDataMgr.SvrIp,"====111==initFairgui=11=====")
		self:CheckVersion()
	end 
	fwqNode:sendSv(callback)
	
	local c7 = self.rootLayout:getController("c7") --控制器
	if g_Cfg.Platform  ~= kTargetAndroid then
		c7:setSelectedIndex(1)	
	end 
	
	local c5 = self.rootLayout:getController("c5") --控制器
	c5:setSelectedIndex(0)
	

end

function updatewnd:releaseAssetsMgr()
	if self.assetsManager then
		self.assetsManager:release()
		self.assetsManager = nil
	end
end

function updatewnd:LoginScene()
	self:releaseAssetsMgr()
	
	
	local _viewObj = self.rootLayout:displayObject()
	g_scheduleTime:stopScheduleByTimes(_viewObj)
	self.rootLayout:removeFromParent()
	
	require("app.views.LoginScene"):create():openWnd(self.rootObj)
end

--[[
function updatewnd:touchTryBtn()
	local iType = self.iType
	self.iType = -1
	self.iLastType = -1
	if iType == tbCheckVersionUpdate.AppVersionLow then	
		cc.Application:getInstance():openURL(updatewnd:getAppURL())
	else
		self:UpdateRes()
	end
end]]

function updatewnd:UpdateloadSucc ()
		local c3 = self.rootLayout:getController("c3") --控制器
		c3:setSelectedIndex(1)
end 

function updatewnd:UpdateErrorDesc(Progress)
	local iType = tbCheckVersionUpdate.UpdateOver
	print('UpdateErrorDesc', iType)
	if iType == tbCheckVersionUpdate.CreateFileError then	
		self.Tips:setText("创建文件失败，请重试...")
		--self.btnTry:setVisible(true)
	elseif iType == tbCheckVersionUpdate.NetError then	
		self.Tips:setText("网络异常，请重试...")
          --self.btnTry:setVisible(true)
	elseif iType == tbCheckVersionUpdate.Progress then	
		local c5 = self.rootLayout:getController("c5") --控制器
		if g_Cfg.CurDownloadVer then
			c5:setSelectedIndex(0)	
		    self.Tips:setText(string.format("【%s】文件解压中...请不要关闭手机", tostring(g_Cfg.CurDownloadVer) ))
			self.DonwloadSucc = true
		else
			
			self.Tips:setText("版本检测中...")
		end
		self.ProgressBar:setValue(self.szTips)
	elseif iType == tbCheckVersionUpdate.CheckFileMd5 then	
		self.Tips:setText("文件校验失败...")
		--self.btnTry:setVisible(true)
	elseif iType == tbCheckVersionUpdate.UpdateFullPackageError then	
		self.Tips:setText("文件检测发生异常，请重试...")
		--self.btnTry:setVisible(true)
	elseif iType == tbCheckVersionUpdate.UpdateOver then	
		
		if not self:CheckLocalRes() then
			self.Tips:setText("文件完整性校验失败，请重试...")
		else
			self.Tips:setText("文件检测完成...")
			if  self.DonwloadSucc then
				--self:UpdateloadSucc ()
				--return 
			end 
			self:LoginScene()
			
		end
	elseif iType == tbCheckVersionUpdate.DonwloadSucc then	
		self.text_version:setText(get_FullVersion() )
		
	elseif iType == tbCheckVersionUpdate.VersionError then	
		--self.text_version:setText("获取版本文件失败，请重试..." )
		--self.btnTry:setVisible(true)
	elseif iType == tbCheckVersionUpdate.AppVersionLow then	
		--self.btnTry:setVisible(true)
		local c2 = self.rootLayout:getController("c2") --控制器
		
		GshenheTyep = G_tableMsgList["gameTyepGX"]
		if GshenheTyep == 2  then
			c2:setSelectedIndex(2)
		else	
			c2:setSelectedIndex(1)
		end 
		self.updata:setVisible(true)
		if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
			self.Tips:setText("请到TapTap更新最新版本1")
		else
			self.Tips:setText("请到苹果商店更新最新版本1")
		end
	end
end

function updatewnd:CheckVersion()
	self:CheckLocalRes()
	self:UpdateRes()
end

function updatewnd:UpdateRes()
	--self.btnTry:setVisible(false)
	get_szCurVersion()
	self:releaseAssetsMgr()
	get_szCurVersion()
	self.assetsManager = AssetsManagerDownload(function(iType, szTips)
		self.iType = iType
		self.szTips = szTips or 0
		print(self.szTips,"==11===UpdateRes===11==",iType, szTips)  
		if self.ProgressBar   then
			if type(szTips) == "number" then
				self.ProgressBar:setValue(szTips)
			end 
		end 
		 
	end)
end


--打开窗口
function updatewnd:openWnd()
	local scene = display.newScene()
	display.runScene(scene)
	--g_sendSvTbMsg()
	--local scene = cc.Scene:createWithPhysics()
	--scene:getPhysicsWorld():setGravity(cc.p(0,0))
	---scene:getPhysicsWorld():setDebugDrawMask(cc.PhysicsWorld.DEBUGDRAW_ALL)
	self:initFairgui(scene)
end
return updatewnd
