local mod = 10000
local modum = 4
function showBigInt(a)
	print(getBigInt(a))
end

tbCnMsg = 
{
	"","万","亿","兆","京","垓","aa","bb","cc","dd","ee","ff","gg","hh","ii","jj","kk","ll","mm","nn","..."
}

local mod2 = 1000
local modum2 = 3
tbCnMsg2 = 
{
	"","k","m","g","n","aa","bb","cc","dd","ee","ff","gg","hh","ii","jj","kk","ll","mm","nn","..."
}


--isPoint --是否需要小数
function getBigInt2(a,noMathPoin)
	local s = {}
	local strLD = {}
	local proValue = 0 --每组的小数点
	local proIsNot --前面是否都是0   0.06 0.06 0
	local lastPoint ---最后的小数点
	local PointIndex
	for i=#a, 1, -1 do
		
		if a[i] ~= 0 or  proIsNot then
			if not proIsNot then
				table.insert(s, a[i])
			else
				table.insert(s, string.format("%03d", a[i]))
			end 
			if i >=  #a-1  then
				if not proIsNot then
					table.insert(strLD,a[i] )
				else
					table.insert(strLD,string.format("%03d", a[i]) )
				end 
			end 
			proIsNot = true
		end 
		
	end
	local strLDEnd = table.concat(strLD, "")
	if not strLDEnd or strLDEnd == "" or  tonumber(strLDEnd) == nil then
		--cclog(strLD,"====getBigInt======",debug.traceback())
		return 0
	end 
	----cclog(#a,"=====strLDEnd==11===",mod)
	local strLDEnd1,strLDEndCN
	if #a > 1 then
		strLDEnd = math.floor(tonumber(strLDEnd*100)/mod2)/100
		strLDEndCN  = strLDEnd..tbCnMsg2[#a]
	else
		---strLDEnd1 = a[#a]
		strLDEndCN  = strLDEnd
	end 
	return table.concat(s, ""),strLDEndCN
end


--isPoint --是否需要小数
function getBigInt(a,isPoint,noMathPoin,maxNums)
	local s = {}
	local strLD = {}
	local proValue = 0 --每组的小数点
	local proIsNot --前面是否都是0   0.06 0.06 0
	local lastPoint ---最后的小数点
	local PointIndex
	--cclog("==getBigInt=======",a,isPoint,noMathPoin,maxNums)
	for i=#a, 1, -1 do
		
		if a[i] ~= 0 or  proIsNot then
			if not proIsNot then
				table.insert(s, a[i])
			else
				table.insert(s, string.format("%04d", a[i]))
			end 
			if i >=  #a-1  then
				if not proIsNot then
					table.insert(strLD,a[i] )
				else
					table.insert(strLD,string.format("%04d", a[i]) )
				end 
			end 
			proIsNot = true
		end 
	end
	
	local strLDEnd = table.concat(strLD, "")
	if not strLDEnd or strLDEnd == "" or  tonumber(strLDEnd) == nil then
		----cclog(strLD,"====getBigInt======",debug.traceback())
		return 0
	end 
	local maxNums = maxNums or 2
	local strLDEnd1,strLDEndCN
	if #a > maxNums then
		strLDEnd = math.floor(tonumber(strLDEnd*100)/mod)/100
		strLDEndCN  = strLDEnd..tbCnMsg[#a]
	else
		---strLDEnd1 = a[#a]
		strLDEndCN  = strLDEnd
	end 
	--cclog("=====getBigInt===55555==",s)
	return table.concat(s, ""),strLDEndCN
end

function getBigIntByStr2(a)
	a = tostring(a)
	
	if #a < modum2 then
		return a ,a
	end 
	a = createBigInt(a,modum2)
	local s,strLDEndCN = getBigInt2(a)
	return strLDEndCN,s
end


function getBigIntByStr(a,isPoint,nType2,maxNums)
	a = tostring(a)
	if #a < modum then
		return a ,a
	end 
	a = createBigInt(a)

	local s,strLDEndCN = getBigInt(a,isPoint,nType2,maxNums)
	-----cclog("====getBigIntByStr==",s,strLDEndCN )
	return strLDEndCN,s
end

function createBigInt(s,modumD)
	local modumD = modumD or modum
	if type(s) ~= "string" then
		s = tostring(s)
	end 

	if s["xyBigInt"] == true then 
		return s 
	end
	
	
	local index,poinNum
	for i=1,#s do
		local str = string.sub(s, i, i )
		if str == "." then
			--cclog("===.....====",#s ,i)
			index = i
			poinNum = #s - i
			break
		end 
	end 
	--cclog(index,"====createBigInt==00==",s)
	if index  then
		local indexEnd = index+2
		if indexEnd < #s then
			poinNum = 2
		elseif indexEnd > #s then
			indexEnd = #s
			poinNum = 1
		end 
		local str1 = string.sub(s, 1, index-1 )
		local str2 = string.sub(s, index+1, indexEnd )
		--cclog(s,str1,"==createBigInt===11==",str2,index,indexEnd)
		s = str1..str2
	end 
	
	local n, t, a = math.floor(#s/modumD), 1, {}
	a["xyBigInt"] = true
	a["poinNum"] = poinNum

	if #s%modumD ~= 0 then 
		a[n + 1], t = tonumber(string.sub(s, 1, #s%modumD), 10), #s%modumD + 1 
	end
	for i = n, 1, -1 do 
	a[i], t= tonumber(string.sub(s, t, t + modumD-1), 10), t + modumD 
	end

	return a,s
end


function getABCTTabms(aNum, bNum)
	local a,as = createBigInt(aNum)
	local b,bs = createBigInt(bNum)
	local c = createBigInt("0")
	local t = 0
	--cclog(b,bs,"==getABCTTabms=00==",a,as,aNum, bNum)
	if a.poinNum or b.poinNum  then
		local poinNumA = a.poinNum or 0
		local poinNumB = b.poinNum or 0
		--cclog(poinNumA,poinNumB,"===poinNumA====")
		if poinNumA >  poinNumB then	
			local Num = poinNumA - poinNumB
			local s = getBigInt(a)
			for i=1,Num do
				bs = bs.."0"
			end 
			b =  createBigInt(bs)
			--cclog(b,bs,"==getABCTTabms==11=",a.poinNum)
			c.poinNum = a.poinNum
			b.poinNum = a.poinNum
		elseif poinNumA <  poinNumB then
			local Num = poinNumB - poinNumA
			
			local s = getBigInt(a)
			for i=1,Num do
				as = as.."0"
			end 
			a =  createBigInt(as)
			--cclog(a,as,"==getABCTTabms==11=",b.poinNum)
			c.poinNum = poinNumB
			a.poinNum = b.poinNum
		else
			c.poinNum = poinNumB
		end 
	end 	
	return a, b, c, t
end 


function addBigInt(a, b,isPoint)
	a = tostring(a)
	b = tostring(b)
	if #a < 9 and #b < 9 then 	
		a = tonumber(a)
		b = tonumber(b)
		return a+b
	end 
	
	if  MaxBigInt(a, "0") and not MaxBigInt(b, "0")  or (not MaxBigInt(a, "0") and  MaxBigInt(b, "0") ) then
		local strLDEnd , strLDEndCN = subBigInt(a, b)
		return strLDEnd , strLDEndCN
	end  
	local a, b, c, t =  getABCTTabms(a, b) --createBigInt(a), createBigInt(b), createBigInt("0"), 0
	
	for i = 1, math.max(#a,#b) do
		t = t + (a[i] or 0) + (b[i] or 0)
		c[i], t = t%mod, math.floor(t/mod)
	end
	
	while t ~= 0 do c[#c + 1], t = t%mod, math.floor(t/mod) end
	local strLDEnd , strLDEndCN = getBigInt(c,isPoint)

	if c.poinNum and c.poinNum  > 0 then--变成小数
		local poinNum = c.poinNum 
		strLDEnd , strLDEndCN = setPoint(strLDEnd,poinNum,isPoint)
	end 
	
	return strLDEnd , strLDEndCN
end

function setPoint(s,poinNum,isPoint)
	if not poinNum or poinNum  ==  0 then--变成小数
		return s
	end 
	local s = tostring(s)
	local index = #s - poinNum
	local str1 = string.sub(s, 1, index )
	--cclog(s,str1,"====setPoint======",s,poinNum,isPoint)
	local tbstr1 = createBigInt(str1)
	local strLDEnd , strLDEndCN = getBigInt(tbstr1)
	if not isPoint then
		return strLDEnd , strLDEndCN
	end 
	local endPoint = index + 2
	if poinNum >= 2 then
		endPoint = index + 2
	else
		endPoint = index + 2
	end 
	local str2 = string.sub(s, index+1,  endPoint)
	--cclog(s,str1,"==setPoint=====",str2,index,indexEnd)
	s = str1.."."..str2
	
	return s, strLDEndCN
end

function subBigInt(a, b,isPoint,isInt)
	a = tostring(a)
	b = tostring(b)
	if #a < 9 and #b < 9 then
		a = tonumber(a)
		b = tonumber(b)
		local c = 	a-b
		if isInt then
			c = math.ceil(c)
		end 
		return  c
	end 
	---cclog( MaxBigInt(a, b),"===DD==subBigInt=======", a, b)
	if not MaxBigInt(a, b) then
		local result , strLDEndCN = subBigInt(b, a)
		--cclog(result,"=====subBigInt=======", strLDEndCN)
		result = "-"..result
		return result  , strLDEndCN
	end 
	local a, b, c, t = getABCTTabms(a, b)

	for i = 1, #a do
		c[i] = a[i] - t - (b[i] or 0)
		if c[i] < 0 then 
			t, c[i] = 1, c[i] + mod  
		else 
			t = 0 
		end
		
	end
	--cclog("=====subBigInt===DDD==",a, b, c, t)
	local strLDEnd , strLDEndCN = getBigInt(c,isPoint)
	
	if c.poinNum and c.poinNum  > 0 then--变成小数
		local poinNum = c.poinNum 
		strLDEnd , strLDEndCN = setPoint(strLDEnd,poinNum,isPoint)
	end 
	
	
	return strLDEnd , strLDEndCN
end

function MaxBigInt(aNum, bNum)  --判断a是否大于B
	local a = tostring(aNum)
	local b = tostring(bNum)
	
	if #a <= 9 and #b <= 9  then
		if tonumber(aNum) >= tonumber(bNum) then
			return true
		else
			return false
		end 
	end 
	local Ner
	local nType1 = string.sub(a, 1, 1)
	local nType2 = string.sub(b, 1, 1)
	if  nType1 == "-"  and nType2 ~= "-" then
		return false
	elseif  nType1 ~= "-"  and nType2 == "-" then
		return true
	elseif  nType1 == "-"  and nType2 == "-" then	
		local nlen = tonumber( string.len(a))
		a = string.sub(a, 2, nlen)
		
		local nlen = tonumber( string.len(b))
		b = string.sub(a, 2, nlen)
		Ner = true
	end 

	local a, b  = createBigInt(a), createBigInt(b)
	local stastus  = true
	if (#a == #b and a[#a] == b[#a]) then
		for i=#a ,1,-1 do
			if a[i] < b[i] then
				stastus = false
				break
			elseif a[i] > b[i] then
				stastus = true
				break
			end 
		end 
	end 
	
	if #a < #b or (#a == #b and a[#a] < b[#a]) then
		stastus = false
	end 
	if Ner then
		return not stastus
	end 
	return stastus
end 

function byBigInt(a, b,isFloor)  --乘
	a = tostring(a)
	b = tostring(b)
	
	if #a < modum and #b < modum or  (#a + #b ) <= 9 then
		a = tonumber(a)
		b = tonumber(b)
		local value1 = a*b
		if isFloor  then
			local value = math.floor(value1)
			return value,value
		else
			return value1,value1
		end 
	end 
	local isPoint = true
	if isFloor  then
		isPoint = nil
	end 
	
	local a, b, c, t = getABCTTabms(a, b)
	
	--cclog("===222====byBigInt===111==",a, b, c, t)
	for i = 1, #a do
		for j = 1, #b do
			t = t + (c[i + j - 1] or 0) + a[i] * b[j]
			
			--cclog(t,c,"===222====byBigInt=====",a[i] , b[j])
			c[i + j - 1], t = t%mod, math.floor(t / mod)
		end
		--cclog(t,"=======byBigIn=====")
		if t ~= 0 then 
			c[i + #b], t = t + (c[i + #b] or 0), 0 
			--cclog(c,t,"=====223333==byBigIn=====")
		end
	end

	local strLDEnd , strLDEndCN = getBigInt(c,isPoint,true)
	--cclog("======byBigInt==0===",a,b,c, strLDEnd , strLDEndCN,c.poinNum)
	
	if c.poinNum and c.poinNum  > 0 then--变成小数
	
		local poinNum = c.poinNum *2
		--cclog(c.poinNum ,c,"===c.poinNum ======")
		strLDEnd , strLDEndCN = setPoint(strLDEnd,poinNum,isPoint)
	end 

	--cclog(strLDEnd , strLDEndCN,"===222====byBigInt=====",c,isPoint,a,b)
	return strLDEnd , strLDEndCN
end

---   百分比    不能太多小数  -----  b是max 4 1  100 9
function porBigInt(a, b,isPro)  --百分比
	a = tostring(a)
	b = tostring(b)
	if  not a or not b or b == 0 or b == "0" then
		return 0
	end 
	if #a < 9 and #b < 9 then
		a = tonumber(a)
		b = tonumber(b)
		if isFloor  then
			return math.floor(a*100/b)
		else
			return math.floor(a*1000/b)/10
		end 
	end 
	if isPro then
		local status = MaxBigInt(a, b)
		if  status then
			return 100 
		end
	end 
	
	local status = MaxBigInt(a, "0")
	if  not status then
		return 0 
	end
	
	if  #b <= 9 and #a <= 9 then 
	  return  math.floor(a*1000/b)/10
	end
	
	if  (#b - #a) >= 3 then 
		return 0
	else
		local count =   #b- #a
		
		local nType1 = string.sub(a, 1, 4)
		local nType2 = string.sub(b, 1, 4+count)
		local pro = math.floor(nType1*1000/nType2)/10
		--cclog(nType2,nType1,"======porBigInt========",pro)
		return  pro
	end 

	return curPro
end 


---取整
function floorBigInt(aNum,modumD) 
	local modumD = modumD or modum
	a = tostring(aNum)
	if  #a <= 9 then	
		a = math.floor(aNum)
		return  a
	end
	local nlen = string.len(a)
	local poinIndex
	for i= 0,modumD do
		local  index = nlen-i
		local str = string.sub(a, index, index)
		if str == "." then
			poinIndex = index-1
			break
		end 
	end 
	a =  string.sub(a, 1, poinIndex)
	return a
end 
--[[
showBigInt(addBigInt("987654321", "123456789"))
showBigInt(subBigInt("987654321", "123456789"))
showBigInt(byBigInt("987654321", "123456789"))
showBigInt(byBigInt("123456780000003123", "2"))
]]