------------------
-- 文件名:	cfgDBControl.lua
-- 版  权:	
-- 创建人:	陆奎安
-- 日  期:	2013-2-22 9:37
-- 版  本:	1.0
-- 描  述:	
-- 应  用:  本例子是用类对象的方式实现
-------------------

cfgDBControl = class("cfgDBControl")
cfgDBControl.__index = cfgDBControl


function cfgDBControl:getDB()
	if not self.cfgDB then
		self.cfgDB = g_cfgDBMgr:openDb("game")
	end 
	cclog(dbId,"=====getDB===========",db)
	return self.cfgDB
end
function cfgDBControl:getBatDB()
	if not self.cfgBatDB then
		self.cfgBatDB = g_cfgDBMgr:openBatDb()
	end 
	cclog(self.cfgBatDB,"==111===getDB=====111======",db)
	return self.cfgBatDB
end


tb_playerDBName = {
	[35] = "bat_data", -- 1数据 金币 资源等
}
local defaultCacheNum = 100
local prikey1 = "prikey1"
local prikey2 = "prikey2"
local tb_playerDBNameText = {
	[35] = "CREATE TABLE IF NOT EXISTS ".. tb_playerDBName[35] .." ( ".. prikey1 .." int(64) NOT NULL,"..
		[[
		   buff blob ,
		]].."PRIMARY KEY (".. prikey1 .."));",	
}


function cfgDBControl:createDefalutGameTables()
    -- create player tables
	local db =  self:getBatDB()
		cclog(db,"=11=createDefalutGameTables===")
	for tag, dbname in pairs(tb_playerDBName) do	
        local result = db:exec(tb_playerDBNameText[tag])    --   self:query(tb_playerDBNameText[tag])
        if not result then
            return
        end
	end
end


--===============================通用db======================================
function cfgDBControl:query(sql)
	local db =  self:getBatDB()
	local res, err, errcode, sqlstate = db:query(sql)
	if not res then	
		cclog(sql,"-not query =")
		return res, err, errcode, sqlstate
	end
	return res, err, errcode, sqlstate 
end 

local function getSqlWhere(key1, key2)
	cclog("===getSqlWhere====",key1, key2)
	 if not key1 then
			return ""
    end
    local where = " where ".. prikey1 .." = '"..key1.."'"
    if key2 then
        where = where.." and "..prikey2 .." = '"..key2.."'"
    end

    return where
end

---

--删除信息 --
function cfgDBControl:delDbMsgFactory(dbId,tableName,playerID)
	local playerID = g_GameDataMgr.userid  
	local db = self:getBatDB()
	local dbStr = "DELETE  FROM "..tableName..getSqlWhere(playerID)
    db:exec(dbStr)
end
---修改db
function cfgDBControl:updateDbMsgFactory(tableName,tableData,playerID)
	local playerID = g_GameDataMgr.userid  
	local db = self:getBatDB()
	 local delimiter = ""
	 local sql = "update "..tableName.." set "
    for k,v in pairs(tableData) do
		if k~= prikey1  then
			sql = sql..delimiter.." "..k.."="..v
			if delimiter == "" then
				delimiter = ","
			end
		end 
    end
	sql = sql..getSqlWhere(playerID)
	cclog(playerID,"===updateDbMsgFactory====",sql)
	db:exec(sql)
end

---插入db
function cfgDBControl:insertDbMsgFactory(tableName,tableData,playerID)
	local playerID = g_GameDataMgr.userid  
	local db = self:getBatDB()
	local fieldnames = {}
	local fieldvalues = {}
	local statusKey1 
	 local index = 0
	 cclog("===insertDbMsgFactory=11===",tableData)
	
    for key, value in pairs(tableData) do
		index = index + 1
		fieldnames[index] = key
		fieldvalues[index] = value
		if key == prikey1 then
			statusKey1 = true
		end 	
	end
	if not statusKey1 then
		index = index + 1
		fieldnames[index] = prikey1
		fieldvalues[index] = playerID
	end

	local fieldsname_str = " ("
    local delimiter = ""
    for index = 1, #fieldnames do
        fieldsname_str = fieldsname_str.." "..delimiter..fieldnames[index]
        if delimiter == "" then
            delimiter = ","
        end
    end
    fieldsname_str = fieldsname_str..")"	
	
	 -- 组合values
    local fieldsvalue_str = " ("
    delimiter = ""
    for index = 1, #fieldvalues do
        fieldsvalue_str = fieldsvalue_str.." "..delimiter..'"'..fieldvalues[index]..'"'
        if delimiter == "" then
            delimiter = ","
        end
    end
    fieldsvalue_str = fieldsvalue_str.." )"..";"
	
	 local sql = "insert into "..tableName
	sql = sql .. fieldsname_str .. " values " .. fieldsvalue_str
	
	local result = db:exec(sql)
	cclog(result,"===insertDbMsgFactory===="..sql)
end

---查询db
function cfgDBControl:selectDbMsgFactory(tableName,playerID)
	local playerID = g_GameDataMgr.userid  
	local db = self:getBatDB()
	if not db then
		cclog("cfgDBControl:selectDbMsgFactory error "..tableName)
		return
	end
	
	local dbText = "SELECT * FROM "..tableName..getSqlWhere(playerID)
	
	local res,res2,res3,res4 =  db:nrows(dbText)
	local tbMsgD
	for row in  db:nrows(dbText)  do
		if not tbMsgD  then
			tbMsgD = {}
		end 
		tbMsgD[#tbMsgD+1] = row
	end 
	cclog(tbMsgD,"====nrows=====11======",dbText,playerID)

	return tbMsgD
end



function cfgDBControl:ctor()
	self.cfgMsg  =  {}
		--cclog("==createDefalutGameTables===")
	--self:createDefalutGameTables()
end

g_cfgDBControl =  cfgDBControl:create()

---g_cfgDBControl:createDefalutGameTables()