------------------
-- 文件名:	cfgMsg.lua
-- 版  权:	
-- 创建人:	陆奎安
-- 日  期:	2013-2-22 9:37
-- 版  本:	1.0
-- 描  述:	
-- 应  用:  配置表数据，存在内存，不放db
-------------------

cfgMsg = class("cfgMsg")
cfgMsg.__index = cfgMsg

function cfgMsg:getCfgMsg(cfgName,key1,key2)
	--cclog("===getCfgMsg=====",cfgName,key1,key2)
	if not cfgName then
		return 
	end 
	
	
	if not key1 and not  key2 then
		return  self.cfgMsg[cfgName]
	elseif not  key2 then
		local tbMsg1 = self.cfgMsg[cfgName]
		key1 = tonumber(key1)
		local tbMsg =tbMsg1[key1]
		
		return tbMsg
	else
		local tbMsg1 = self.cfgMsg[cfgName]	
		local tbMsg2 =tbMsg1[key1]
		if  not tbMsg2  then
			return 
		end 
		local tbMsg =tbMsg2[key2]
		return  tbMsg
	end 
end 

function cfgMsg:loadAllDb()
	local db = g_cfgDBControl:getDB()
	if not db then
		cclog("========not db==== ")
		return
	end
	cclog("==loadAllDb=")
	local dbText = "select name from sqlite_master where type='table' order by name;"
	for row in db:nrows(dbText) do
		local dbText2 = "select * from "..row.name
		
		local tbMsg = {}
		local key2,key1 
		cclog("==loadAllDb222=",row.name)
		for row2 in db:nrows(dbText2) do
			local key = row2["key"]
			local key1= row2["key1"]
			local key2= row2["key2"]
			
			if key1 and key2   then
				if not tbMsg[key1] then
					tbMsg[key1] = {}
				end 
				tbMsg[key1][key2] = row2
			elseif  key  then
				tbMsg[key] = row2
			end 
		end 
		self.cfgMsg[row.name] = tbMsg
	end
end


--===============================通用db======================================

function cfgMsg:ctor()
	self.cfgMsg  =  {}
end

g_cfgMsg =  cfgMsg:create()
