------------------
-- ļ:	g_scheduleTime.lua
--   Ȩ:	(C)
-- :	½
--   :	2017-6-17 9:37
--   :	1.0
--   :	ʱ
-- Ӧ  :  ķʽʵ
-------------------
local scheduleTime = class("scheduleTime")
--ʱ
--1 ʱ󶨽ڵ㣻 2 ʱ;3 4 ص
--أ
function scheduleTime:scheduleByTimes(node,ntime,number,callback,isFgui)
	local createNode = false
	if not node then
		createNode = true
		node = ccui.Layout:create()
		g_WndMgr:getrootLayout():addChild(node)
	else
		
	end 
	if isFgui then
		node = node:displayObject()	
	end 
	local ntime = ntime or 1
	local number = number or 1
	if number <= 0 then
		return
	end 
	local count = 0
	local delayTime =  cc.DelayTime:create(ntime)
	local function scheduleCallBack()
		callback()
		count = count + 1
		if node and count >= number and createNode == true then
			node:stopActionByTag(100)
			node:removeFromParent(true)
		end 
	end
	
	local action2 = cc.CallFunc:create(scheduleCallBack)
	local actionSequence = cc.Sequence:create(delayTime,action2)
	
	local action1 = cc.Repeat:create(actionSequence, number)
	action1:setTag(100)

	node:stopActionByTag(100)
	node:runAction(action1)
end
--ֹͣʱ
--1 ʱ󶨽ڵ
--أ
function scheduleTime:stopScheduleByTimes(node)
	if not node then
		return
	end
	node:stopActionByTag(100)
end


--ʱ䶨ʱ
--1 ʱ󶨽ڵ㣻 2 ʱ;3 ʱ䣻4 ص
--أ
function scheduleTime:scheduleByOverallTime(node,ntime,overallTime,callback)
	if not node then
		return
	end
	local ntime = ntime or 1/50
	local overallTime = overallTime or 1
	local delayTime =  cc.DelayTime:create(ntime)
	local action2 = nil
	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local actionSequence = cc.Sequence:create(delayTime,action2)
	
	local action1 = cc.Repeat:create(actionSequence, overallTime/ntime)
	action1:setTag(101)
	node:stopActionByTag(101)
	node:runAction(action1)
end

--ֹͣʱ
--1 ʱ󶨽ڵ
--أ
function scheduleTime:stopScheduleByTime(node)
	if not node then
		return
	end
	node=node:displayObject()
	node:stopActionByTag(101)
end


--ѭʱ
--1 ʱ󶨽ڵ㣻 2 ʱ3 ص
--أ
function scheduleTime:scheduleForever(node,ntime,callback,reload)
	if not node then
		cclog("==========actionForever:isDone()========not node========")
		return
	end
	local actionForever =  node:getActionByTag(102)
	if  not reload then
		--cclog("==========actionForever:isDone()=========return============")
		--return
	end 
	local ntime = ntime or 1
	local delayTime =  cc.DelayTime:create(ntime)
	local function endCallBack()
		callback(node)
	end
	action2 = cc.CallFunc:create(endCallBack)
	local actionSequence = cc.Sequence:create(delayTime,action2)
	local action = cc.RepeatForever:create(actionSequence)
	action:setTag(102)
	node:stopActionByTag(102)
	node:runAction(action)
end
--ֹͣѭʱ
--1 ʱ󶨽ڵ
--أ
function scheduleTime:stopScheduleForever(node)
	if not node then
		return
	end
	node:stopActionByTag(102)
end
function scheduleTime:isScheduleForever(node)
	if not node then
		return
	end
	local actionForever =  node:getActionByTag(102)
	return actionForever

end

function scheduleTime:ctor()
end
g_scheduleTime =  scheduleTime:create()