local Ios_PayKey = "Ios_PayKey"

bContentScaleFactorXoY = 0
g_visibleSize = cc.Director:getInstance():getVisibleSize()
g_winSize = cc.Director:getInstance():getWinSize()

kTargetIpad = cc.PLATFORM_OS_IPAD
kTargetIphone = cc.PLATFORM_OS_IPHONE

if g_Cfg.Platform == kTargetIpad or g_Cfg.Platform ==kTargetIphone then
    API_clearProduct()
    for key, value in pairs(g_PayType) do
        API_addProduct(value)
    end
   -- API_requestProducts()
end

cclog(g_PayType, "========initProduct========",kTargetIpad,kTargetIphone, g_Cfg.Platform )
local szCurKey = nil
local szPayId = nil
--[[
typedef enum {
IOSIAP_PAYMENT_PURCHASING,// just notify, UI do nothing
IOSIAP_PAYMENT_PURCHAED,// need unlock App Functionality
IOSIAP_PAYMENT_FAILED,// remove waiting on UI, tall user payment was failed
IOSIAP_PAYMENT_RESTORED,// need unlock App Functionality, consumble payment No need to care about this.
IOSIAP_PAYMENT_REMOVED,// remove waiting on UI
} IOSiAPPaymentEvent;
]]

function closeConnectItem()
	local connectItem = g_WndMgr:getWnd("connectItem")
	if connectItem then
		connectItem:close()
	end 
end

cclog(g_PayType, "========initProduct========",kTargetIpad,kTargetIphone, g_Cfg.Platform )
local szCurKey = nil
local szPayId = nil
function g_AppstoreCallBack(errorCode, szPayID)
    cclog("g_AppstoreCallBack", errorCode, szPayID)
    if errorCode == 0 then
        WebSocket:showTips("支付中")
    elseif errorCode == 1 then
        WebSocket:showTips("支付成功")
    elseif errorCode == 2 then
        WebSocket:showTips("支付失败")
		closeConnectItem()
    elseif errorCode == 3 then
        WebSocket:showTips("支付恢复")
    elseif errorCode == 4 then
        ---WebSocket:showTips("支付结束")
    else
        WebSocket:showTips("支付异常，请重试")
		closeConnectItem()
    end
end

--支付
function g_AppstoreIap(szPay, key)	
	if not szPay or not key then
		local tbQDMsg = {}
		tbQDMsg.dec = string.format("支付异常，请联系管理员(%s=%s)", tostring(szPay), tostring(key))
		tbQDMsg.text1 = "确定"
		tbQDMsg.text2 = "取消"
		g_quedingItem:openWnd(tbQDMsg) 
		return
	end

	szPayId = szPay
	szCurKey = key
	local tbMsg =  g_cfgMsg:getCfgMsg("chongzhi_D",key)
	local	cost = tbMsg.cost
		
	if g_Cfg.Platform  ==  cc.PLATFORM_OS_ANDROID then
		
	end
    cclog("g_AppstoreIap", szPay, szCurKey, g_PayType[szPay])
    if g_PayType[szPay] and key then
        API_iosIap(g_PayType[szPay])
		g_WndMgr:showWnd("connectItem")
    end
end

--代金卷
function g_DaojzIap(cfgID)	
	--判断代金卷
	local tbCfg = g_cfgMsg:getCfgMsg("chongzhi_D", cfgID)
	local cost = tbCfg.cost
	local number = g_bagMsg:getGoodsTbMsg(12003117) or 0
	
	if number <  cost then	
		if g_Cfg.Platform  == kTargetAndroid  then
			--g_action:ts_hszz_antion("需要代金卷"..cost.."张",22)
			local tbQDMsg = {}
			tbQDMsg.dec =  "要代金卷不足,加入QQ群有更多群活动得代金卷"
			tbQDMsg.text1 = "确定"
			tbQDMsg.text2 = "取消"
			local function callBack()
				g_AddQQqun()
			end 
			tbQDMsg.qdFunc =  callBack
			g_quedingItem:openWnd(tbQDMsg) 
			return
		else
			local tbQDMsg = {}
			tbQDMsg.dec =  "要代金卷不足,是否前往购买"
			tbQDMsg.text1 = "确定"
			tbQDMsg.text2 = "取消"
			local function callBack()
				g_newGuide:getGuideContorl(50,5000)
			end 
			tbQDMsg.qdFunc =  callBack
			g_quedingItem:openWnd(tbQDMsg) 
		end
		return
	end
	g_svSendMsgControl:request_msgString(2000,nil,cfgID)
	g_viplevMsg:reloadVipValue()
end 
local function onResponseGet(event)  
	closeConnectItem()
	
    local request = event.request  
    if event.name ~= "completed" then -- 鐣剁偤completed琛ㄧず姝ｅ父绲愭潫姝や簨浠? 
      --  print("request:getErrorCode(), request:getErrorMessage() ", request:getErrorCode(), request:getErrorMessage())  
        return   
    end  
	
    local code = request:getResponseStatusCode()  
    if code ~= 200 then -- 鎴愬姛  
        print("code ", code)  
        return   
    end  
	
    local strResponse = string.trim(request:getResponseString())  
    print(strResponse)  
	cc.UserDefault:getInstance():setStringForKey(Ios_PayKey, "")
end  

local szReceiptString = nil
function g_ReTryAppStoreReceipt()
	g_AppStoreReceipt(szReceiptString)
end

function g_AppStoreReceipt(receiptString)
	if not szPayId or not szCurKey or not receiptString then
		local tbQDMsg = {}
		tbQDMsg.dec = string.format("支付异常，请联系管理员(szPayId:%s szCurKey:%s)", tostring(szPayId), tostring(szCurKey))
		tbQDMsg.text1 = "确定"
		tbQDMsg.text2 = "取消"
		g_quedingItem:openWnd(tbQDMsg) 
		return
	end
	
	szReceiptString = receiptString
	--cclog("g_AppStoreReceipt")
--local url = "https://sandbox.itunes.apple.com/verifyReceipt"  
--local url = "https://buy.itunes.apple.com/verifyReceipt"  
	local url = g_GameDataMgr.rootSvrIp..string.format("iapconfirm?uid=%d&szPayId=%s&szCurKey=%s", g_GameDataMgr.userid, szPayId, szCurKey) 

	cc.UserDefault:getInstance():setStringForKey(Ios_PayKey, szPayId)
	--200 - 鏈嶅嫏鍣ㄦ垚鍔熻繑鍥炵恫闋?
	--404 - 璜嬫眰鐨勭恫闋佷笉瀛樺湪
	--503 - 鏈嶅嫏鍣ㄦ毇鏅備笉鍙敤
	local request = network.createHTTPRequest(function(event)  
		onResponseGet(event)  
	end, url, "POST")  
	request:setTimeout(30)  --榛樿獚瓒呮檪鏅傞枔鐐?0s锛岄€欒！瑾跨敤setTimeout瑷疆30s瓒呮檪
	-- 瑾跨敤addPOSTValue鍚慒orm涓坊鍔犻嵉鍊煎皪渚嬪锛歬ey:value  
	local dataInfo = {}
	dataInfo["receipt-data"] = receiptString
	local json = require("json")
	local str = (json.encode(dataInfo))
	request:setPOSTData(str)
	request:start()
end

--离线消息推送
function g_AppstoreOffMsgCallBack(textStr,offTime)
	--API_ClearAllLocalPush()
	local tbAlertType = {}
	tbAlertType.kCFCalendarUnitEra                = 2 --纪元
	tbAlertType.kCFCalendarUnitYear               = 4 --年
	tbAlertType.kCFCalendarUnitMonth              = 8 --月
	tbAlertType.kCFCalendarUnitDay                = 16 --日
	tbAlertType.kCFCalendarUnitHour               = 32 --时
	tbAlertType.kCFCalendarUnitMinute             = 64 --分
	tbAlertType.kCFCalendarUnitSecond             = 128 --秒
	tbAlertType.kCFCalendarUnitWeekday            =  256 --周
	cclog(offTime,"====离线消息推送===",textStr)
	if offTime and  offTime >= 20 then
		API_AddLocalPush(textStr,0, offTime)
	end
	
end 

-- 后台暂停游戏 
-- 
function g_AppPauseCallBack()
	g_appPause = true
	cclog("==g_AppPauseCallBack===")
	local curTime =  g_getCursvTime()
	g_PauseTime = curTime
	
	g_baseConTrol.aseTime = 0
	g_svSendMsgControl:request_time(callBack,100)
	g_svSendMsgControl:request_msgString(200,nil,g_baseConTrol.onlineTime)

end

-- 后台暂停后 恢复游戏 回调  恢复音乐什么的
--
function g_AppResumeCallBack()
	g_batWndContorl:getOff(mapType)
	g_baseConTrol.aseTime = 0
	---g_action:ts_hszz_antion("======恢复游戏==========",nil,-1)
	--判断版本
	g_svSendMsgControl:request_time(callBack,-30,curGVersion)

end
-- 
function UpdateRes()
	
	
end


--NSString *adId = [[[ASIdentifierManager sharedManager] advertisingIdentifier] UUIDString];
g_IDFA = ""
function g_getIDFACallBack(szBuf)
	local tbmsg = assert(loadstring(szBuf))()
		--cclog(tbmsg.productID,"=======11===g_getIDFACallBack=====")
	local  productID = tbmsg.productID
	g_IDFA = productID
	API_getIDFV()
end 

--分享callback
-- 1-2 成功 
function g_ShareResult(iType, desc)
    cclog(iType.." g_ShareResult "..desc)
	if desc == "cacel" then
	else -- 成功 
		
	end 
	
end


--检测appstore—version
---返回值
-- true  是最新的
-- false  
function g_isCurAppVersionBNew()
	return 	true
end


--iType
YUMI_REARD = 1
INMOBI_REARD = 2
INMOBI_INTER = 3
INMOBI_FULLVIDEO = 4

local adsFunc = {}
local adsTime = {}
adsValue = {}
--iResultType
local NoReady = 0 --没有准备好
local Error = 1--出错
local Ready  = 2 --准备好了
local Open = 3 --打开视频
local Playing = 4 --播放视频中
local Closed = 5 --关闭视频
local Rewarded = 6 --获取奖励吧
function g_AdsCallBack(iType, iResultType)
	cclog(Rewarded,Playing,YUMI_REARD,Error,"====g_AdsCallBack====",iType, iResultType)
	closeConnectItem()
	if iResultType == NoReady then--视屏播放未准备好
		if iType == YUMI_REARD then--玉米激励视屏
			
		elseif iType == INMOBI_REARD then--inmobi的激励视屏
			
		elseif iType == INMOBI_FULLVIDEO then--inmobi的激励视屏	
			
		end
		g_action:ts_hszz_antion("暂时没有视频源，请稍后再来1",nil,-1)
	elseif iResultType == Rewarded then--获取奖励
		
		local function callback()
			getADSFunc(g_adsRewardedType)
		end 
		if iType == YUMI_REARD then--玉米激励视屏
			g_svSendMsgControl:request_videoAD(1,Rewarded,g_adsRewardedType,callback,adsValue[g_adsRewardedType] )
		elseif iType == INMOBI_REARD then--inmobi的激励视屏
			g_svSendMsgControl:request_videoAD(2,Rewarded,g_adsRewardedType,callback,adsValue[g_adsRewardedType] )
		elseif iType == INMOBI_FULLVIDEO then--inmobi的激励视屏	
			g_svSendMsgControl:request_videoAD(3,Rewarded,g_adsRewardedType,callback,adsValue[g_adsRewardedType] )
		end
		
		---adsTime[adsRewardedType] = os.time()
	elseif iResultType == Playing then--视屏播放
		if iType == YUMI_REARD then--玉米激励视屏播放
			g_svSendMsgControl:request_videoAD(1,Playing)
		elseif iType == INMOBI_REARD then--inmobi的激励视屏播放
			g_svSendMsgControl:request_videoAD(2,Playing)
		elseif iType == INMOBI_FULLVIDEO then--inmobi的视屏	
			g_svSendMsgControl:request_videoAD(3,Playing)
		end
	elseif iResultType == Closed then--视屏播放关闭
		
	elseif iResultType == Error then--视屏播放出错
		
		g_action:ts_hszz_antion("暂时没有视频源，请稍后再来",nil,-1)
	else	
	end
end


function  setADSFunc(adsRewardedType,func)
	adsFunc[adsRewardedType] = func
end
function  getADSFunc(adsRewardedType)
	local func =  adsFunc[adsRewardedType]
	if func then
		--local getWnd1 = g_WndMgr:getWnd("MainScene")
		--local objD=getWnd1.rootLayout:displayObject()
		--local function adsFunc2()
		--
		--end 
		---g_scheduleTime:scheduleByTimes(objD,1,1,adsFunc2)
		func()
	end 
end

function  getadsTime(adsRewardedType)	
	local adtim = adsTime[adsRewardedType]  or 0
	local nTime =  os.time()
	nTime = nTime - adtim
	return  nTime
end

--冷却时间
function  g_API_playAds(adsRewardedType,value,noGoods)
	if adsRewardedType then
		g_adsRewardedType = adsRewardedType
		
	end 
	local adtim = adsTime[g_adsRewardedType]  or 0
	local nTime =  os.time()
	nTime = nTime - adtim
	
	adsValue[g_adsRewardedType] = value
	
	
    adsTime[g_adsRewardedType]   =  os.time()
	local REARD =  YUMI_REARD
	g_svSendMsgControl:request_videoAD(1,Playing)
	
	local function test()
		local count =1
		local function scheduleByOne()
			count = count -1 
			
			
			if count == 0  then
				g_action:ts_hszz_antion("完毕",nil,-2)
				 g_AdsCallBack(REARD, Rewarded)
			end 
		end 
		g_scheduleTime:scheduleByTimes(_viewObj, 1,count,scheduleByOne)
	end 
	g_svSendMsgControl:request_videoAD(1,Playing)
	
	local num =  g_bagMsg:getGoodsTbMsg(12003002)
	g_countMsg:addTbCount(TBCountKEY.ads,1)
	local number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_AdsBuy,3) or 0
	cclog("===========")
	if (num  > 0 or number > 0 ) and not noGoods   then
		local function callback()
			getADSFunc(g_adsRewardedType)
		end 
		g_svSendMsgControl:request_videoAD(1,Rewarded,g_adsRewardedType,callback,adsValue[g_adsRewardedType])
		return
	end 

	if  1   then
		test()
	elseif 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		---g_WndMgr:showWnd("connectItem", nil,3)
		API_playAds_android_callback(g_AdsCallBack_android)
		API_playAds_android()
		adsTime[g_adsRewardedType]  = os.time()

	else
		---cclof(DDD)
		local vip = 0---1g_baseConTrol:getVipContorl(7)
		if   num > 0 and not noGoods  then
			
			local function callback()
				getADSFunc(g_adsRewardedType)
			end 
			g_svSendMsgControl:request_videoAD(1,Rewarded,g_adsRewardedType,callback,adsValue[g_adsRewardedType])
		else
			API_playAds(REARD)
			--test()
		end 

		adsTime[g_adsRewardedType]  = os.time()
		
	end
end 
--[[
function  API_playAds(REARD)
	g_action:ts_hszz_antion("播放:"..REARD,nil,-1)
	local getWnd1 = g_WndMgr:getWnd("MainScene")
	local item = g_WndMgr.rootLayout
	local count = 1
	local function scheduleByOne3()
		
		if count == 8 then
			g_action:ts_hszz_antion("视频完毕",22)
			g_AdsCallBack(REARD,Rewarded)
		else	
			g_action:ts_hszz_antion("视频"..count,22)
		end
		count = count + 1
	end 
	g_AdsCallBack(REARD,Playing)
	g_scheduleTime:scheduleByTimes(item,1,8,scheduleByOne3)
end ]]
--播放玉米视频 API_playAds(YUMI_REARD)
--播放inmobi视频 API_playAds(INMOBI_REARD)



--分享
function g_setShare(MyUrl)
	local MyUrl = g_zqxj2_URL ---or g_ZBDS2_URL
	
    local SSDKPlatformSubTypeQZone = 6 --QQ空间
	local SSDKPlatformSubTypeWechatSession = 22 --微信好友
	local SSDKPlatformSubTypeWechatTimeline = 23 --微信朋友圈
	local SSDKPlatformSubTypeQQFriend = 24 --QQ好友
	local nShareCount = g_ShareTag or 8
	
	local tbMsg = {1,2,4,6}
	local nRandom = math.random(1,#tbMsg)
	local id = 1
	local url = g_fxUrl or  g_GameDataMgr.rootSvrIp.."icon1.jpg"
	local strContent = "超级火爆，休闲对战，"
	local strTitle = "最强细菌2"
	local strClickUrl = tostring(MyUrl)
	cclog(MyUrl,"=====**************==11111=2====", g_GameDataMgr.rootSvrIp, url, strTitle, strClickUrl, SSDKPlatformSubTypeQQFriend)
	if  nShareCount == 0 then
		API_showShareView(strContent, url, strTitle, strClickUrl, SSDKPlatformSubTypeQQFriend)

	elseif nShareCount == 1 then
		API_showShareView(strContent, url, strTitle, strClickUrl, SSDKPlatformSubTypeQZone)

	elseif nShareCount == 2 then
		API_shareContent(strContent, url, strTitle, strClickUrl, SSDKPlatformSubTypeQQFriend)
	
	elseif nShareCount == 3 then
		API_shareContent(strContent, url, strTitle, strClickUrl, SSD,KPlatformSubTypeQZone)
	
	elseif nShareCount == 4 then
		--strClickUrl = g_MyUrl
		--strTitle = "点击关注官方公众号"
		local strContent = "最强细菌2，今年超好玩的休闲对战，约战！"
		API_showShareView(strContent, url, strTitle, strClickUrl, SSDKPlatformSubTypeWechatSession)
	
	elseif nShareCount == 5 then
		--strClickUrl = g_MyUrl
		local strContent = "最强细菌2，今年超好玩的休闲对战，约战！"
		API_showShareView(strContent, url, strTitle, strClickUrl, SSDKPlatformSubTypeWechatTimeline)
	
	elseif nShareCount == 6 then
		--strClickUrl = g_MyUrl
		local strContent = "最强细菌2，今年超好玩的休闲对战，约战！"
		API_shareContent(strContent, url, strTitle, strClickUrl, SSDKPlatformSubTypeWechatSession)
		
	elseif nShareCount == 7 then
		--strClickUrl = g_MyUrl
		local strContent = "最强细菌2，今年超好玩的休闲对战，约战！"
		API_shareContent(strContent, url, strTitle, strClickUrl, SSDKPlatformSubTypeWechatTimeline)
		
	elseif nShareCount == 8 then
		local url1 = url
		local url2 = g_GameDataMgr.rootSvrIp.."icon5.jpg"  
		local url3 = [[https://m.baidu.com/sf?pd=image_content&word=图片&tn=nohead&atn=mediacy&imgpn=0&imgspn=0&top=%7B%22sfhs%22%3A1%2C%20%22sfbg%22%3A%201%7D&sa=vs_ala_img&fr=alawise&cardserver=2&tt=1&di=220&pi=0&imgos=2203774813%2C3758473366&cs=2249893882%2C1165836821&adpicid=0&bdtype=0&objurl=http%3A%2F%2Fimg03.tooopen.com%2Fuploadfile%2Fdowns%2Fimages%2F20110714%2Fsy_20110714135215645030.jpg&imgis=0%2C0&lid=11198836649699485146]]
		cclog(url1, url2,"=====LogFileName=====",url3)
		---strClickUrl = g_MyUrl
		strTitle = "最强细菌2,爆款游戏"
		API_showShareMenu(strContent, url, strTitle, strClickUrl, url1,url2,url3)
	elseif g_ShareCount == 9 then

	else
	
	end
	
end

function moblinkHandler(content) 
	local  cjson = require("cjson")

	local tbsmg = cjson.decode(content)
	cclog(tbsmg,"====moblinkHandler====",tbsmg.playerID,tbsmg.svID)
	local playerID = tbsmg.playerID
	local playerSvrIp = tbsmg.svID
	
	cc.UserDefault:getInstance():setStringForKey("playerFXSvrID", playerSvrIp)
	cc.UserDefault:getInstance():setStringForKey("playerID", playerID)
end


function g_getMobID(ShareTag) 
	local gameID = g_GameDataMgr.userid  
	if not gameID then
		gameID =  cc.UserDefault:getInstance():getIntegerForKey("userid", 0)
		if gameID == 0 then
			gameID = API_GetDeviceID()
		end 
	end 
	g_ShareTag = ShareTag
	API_getMobID("playerID", gameID,"svID",SvrID)

end
function getMobIdHandler(itype, mobid)
    cclog(mobid,"======getMobIdHandler======",itype,g_FxTag)

	local mobid = tostring(mobid)
	
	if g_FxTag  then
		g_createQN2(mobid,g_FxTag) 
	else
		g_createQN(mobid) 
	end 
end

function g_setFxTag(nTag,parent) 
	g_FxTag = nTag
	g_fxParent = parent
end 

--二维码
function g_createQN(mobid) 
		local parent =  g_fxParent or  g_WndMgr:getCurWnd().rootLayout  --g_WndMgr:getrootLayout()
	local fxJpNode = parent:getChildByName("fxJpNode")
	
	if not fxJpNode then
		fxJpNode = cc.CSLoader:createNode("itemBB/fxJpNodezzBB.csb")
		
		parent:addChild(fxJpNode)
		fxJpNode:setLocalZOrder(G_maxLocalZOrder+20)
		fxJpNode:setPosition(0,0)
		fxJpNode:setName("fxJpNode")
	end 
	fxJpNode:setVisible(true)
	
	
	local ewmNode = parent:getChildByName("ewmNode")
	if ewmNode then
		ewmNode:removeFromParent()
	end
	cclog("====g_createQN=========",mobid)
	local function callBack(succeed, outputFile)
		if succeed then
			cclog("===截屏成功=======",mobid)
			print("截屏成功")
			g_fxUrl = outputFile
			g_setShare(mobid)
			fxJpNode:removeFromParent(true)
			--ewmNode:removeFromParent(true)
		else
			print("截屏失败")
		end
	end 
	
	ewmNode = cc.QrNode:createQrNode(mobid, 230)
	parent:addChild(ewmNode)
	ewmNode:setLocalZOrder(G_maxLocalZOrder+11000)
	
	ewmNode:setPosition(625, 1200)
	
	local function callbackcountTimer()
		
	end 
	
	
	ewmNode:saveQrToFile("erewima.png", function()
			---g_scheduleTime:scheduleByTimes(parent,1,0.3,callbackcountTimer)
			g_Screen(ewmNode, callBack)
		end)

end 



--二维码
function g_createQN2(mobid,nTag) 
	local tbMsg = {
		[1] = {320,335,510}
	}
	if not tbMsg[nTag] then
		cclog("==tbMsg[nTag]======",mobid,nTag)
		return 
	end 
	local parent =  g_fxParent or  g_WndMgr:getCurWnd().rootLayout  --g_WndMgr:getrootLayout()
	
	local ewmNode = parent:getChildByName("ewmNode")
	cclog("=g_createQN2=====",ewmNode,nTag)
	if ewmNode then
		return
	end

	ewmNode = cc.QrNode:createQrNode(mobid, tbMsg[nTag][1])
	parent:addChild(ewmNode)
	ewmNode:setName("ewmNode")
	ewmNode:setPosition(tbMsg[nTag][2], tbMsg[nTag][3])
	cclog(tbMsg,"=g_createQN2====22=",ewmNode,nTag)
	g_setFxTag() 
	
end 

--好友绑定 好友充值  好友修改信息
function g_friendBind(playerSvrID,playerID)
	local MyUserID = g_GameDataMgr.userid  
	if not MyUserID then
		MyUserID =  cc.UserDefault:getInstance():getIntegerForKey("userid", 0)
	end 
	cclog("=======g_friendBind===22=====",playerSvrID,playerID)
	local name = ""
	if  g_GameDataMgr.type  == 1 and not g_GameDataMgr.bindwechat then	
		name = "游客"..MyUserID
	else	
		name = g_GameDataMgr.nickname
	end
	local playerSvrID = playerSvrID or g_tbMsgGame:getFriendParentIP()
	local playerID = playerID or g_tbMsgGame:getFriendParentUserID()
	playerID = tonumber(playerID)
	MyUserID = tonumber(MyUserID)
	if playerID == MyUserID and playerSvrID == SvrID then
		cclog("=not=g_friendBind===")
		return
	end 
	if not playerID or playerID <= 900 then
		cclog("=not=playerID===")
		return
	end 
	local friendUserID = MyUserID
	local friendServerIP = SvrID
	local friendName = name
	local friendIcon =  g_playerData:getHeroIcon()
	local friendIconBg = g_playerData:getHeroIconBG()
	local friendLev =  g_tbMsgGame:getLevel()
	local friendLoginTime = g_getCursvTime()
	local tbSvMsg = getTbFWQMsg(playerSvrID)
	local playerSvrIp = tbSvMsg[3]
	local urlText = "http://%s/sendmsg?user=1&&userid=%d&&friendUserID=%d&&friendServerID=%s&&friendName=%s&&friendIcon=%d&&friendIconBg=%d&&friendLev=%d&&friendLoginTime=%d"
	urlText = string.format(urlText,playerSvrIp, playerID,friendUserID,friendServerIP,friendName,friendIcon,friendIconBg,friendLev,friendLoginTime)
	HttpGet(urlText)

	cclog(urlText,"=======g_friendBind========",playerSvrIp,playerID)
end

local G_AndroidQQunNum  

function g_getQQqun()
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		return G_AndroidQQunNum
		
	else
		return G_QQunNum
	end 
end 
function g_AddQQqun()
	if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
		local qun = math.random(1,#G_AndroidQQunNum)
		local tbMsg = G_AndroidQQunNum[qun]
		API_ADDQQ_android(tbMsg[2])
	else
		local qun = math.random(1,#G_QQunNum)
		local tbMsg = G_QQunNum[qun]
		API_getAddQQQun(tbMsg[1],tbMsg[2])
	end 
end


function sz_T2S(_t)  
	if not _t then
		return "table is nil"
	end
	
    local szRet = "{"  
    function doT2S(_i, _v)  
        if "number" == type(_i) then  
            szRet = szRet .. "[" .. _i .. "] = "  
            if "number" == type(_v) then  
                szRet = szRet .. _v .. ","  
            elseif "string" == type(_v) then  
                street = szRet .. '"' .. _v .. '"' .. ","  
            elseif "table" == type(_v) then  
                szRet = szRet .. sz_T2S(_v) .. ","  
			elseif "boolean" == type(_v) then  
                szRet = szRet .. tostring(_v) .. ","  
            else  
                szRet = szRet .. "nil,"  
            end  
        elseif "string" == type(_i) then  
            szRet = szRet .. '["' .. _i .. '"] = '  
            if "number" == type(_v) then  
                szRet = szRet .. _v .. ","  
            elseif "string" == type(_v) then  
                szRet = szRet .. '"' .. _v .. '"' .. ","  
            elseif "table" == type(_v) then  
                szRet = szRet .. sz_T2S(_v) .. ","  
			elseif "boolean" == type(_v) then  
                szRet = szRet .. tostring(_v) .. ","  
            else  
                szRet = szRet .. "nil,"  
            end  
        end  
    end  
    table.foreach(_t, doT2S)  
    szRet = szRet .. "}"  
    return szRet  
end  

function g_sendSvQQqun()
	local http = string.format('http://%s/serverQQqun.lua',g_GameDataMgr.SvrIp)
    G_QQunNum = G_QQun
    HttpGet(http, function(content)
        local func = loadstring(content )
        local tbServerList = func()
        print(sz_T2S(tbServerList))
        G_QQunNum = {}
        local tbServerListMsg = tbServerList
        for index,v in pairs(tbServerList)do
            local number = v[1]
            local str = v[2]
            local tbMsg  =  {number,str}
            G_QQunNum[#G_QQunNum + 1] = tbMsg
        end
        if #G_QQunNum == 0 or G_QQunNum == {} then
            G_QQunNum = G_QQun
        end
		cclog(G_QQunNum,"======G_QQunNum=====")
    end)
	g_sendSvQQqunAndroid()
end


function g_sendSvQQqunAndroid()
	local http = string.format('http://%s/serverAndroidQQqun.lua',g_GameDataMgr.SvrIp)
    G_AndroidQQunNum = G_QQun
    HttpGet(http, function(content)
        local func = loadstring(content )
        local tbServerList = func()
        print(sz_T2S(tbServerList))
        G_AndroidQQunNum = {}
        local tbServerListMsg = tbServerList
        for index,v in pairs(tbServerList)do
            local number = v[1]
            local str = v[2]
            local tbMsg  =  {number,str}
            G_AndroidQQunNum[#G_AndroidQQunNum + 1] = tbMsg
        end
        if #G_AndroidQQunNum == 0 or G_AndroidQQunNum == {} then
            G_AndroidQQunNum = G_QQun
        end
		cclog(G_AndroidQQunNum,"======G_QQunNum=====")
    end)
end

function g_sendSvVersion()
	local http = string.format('http://%s/serverVersionList.lua',g_GameDataMgr.SvrIp)
    G_VersionList = {} 
    HttpGet(http, function(content)
        local func = loadstring(content )
        local tbServerList = func()
        print(sz_T2S(tbServerList))
        --G_VersionList = {} 
        G_VersionList= tbServerList or {}
        
		cclog(G_VersionList,"======G_QQunNum=====",http)
    end)
end


function g_sendSvTbMsg()
	local http = string.format('http://%s/tableMsgList.lua',g_GameDataMgr.SvrIp)
    G_tableMsgList = {} 
    HttpGet(http, function(content)
        local func = loadstring(content )
        local tableMsgList = func()
        print(sz_T2S(tableMsgList))
        --G_tableMsgList = {} 
        G_tableMsgList= tableMsgList or {}
        
		cclog(G_tableMsgList,"======G_QQunNum=====",http)
    end)
end

---刷新日志 --日志太大
function g_reloadLog()
	local strLogFile =  cc.UserDefault:getInstance():getStringForKey("curLogFile", "")
	local path  = cc.FileUtils:getInstance():getWritablePath().."LogFiles/"
    cclog("---------------CheckValidLog-----------------:", path)
    if os.isDirectoryExist(path) then
		local tbValidData = os.date("*t", g_getCursvTime())
		local iValidTime = tbValidData.year*10000 + tbValidData.month*100 + tbValidData.day
		cclog("---------------CheckValidLog:", iValidTime)
        local function _rmdir(path)
            local iter, dir_obj = lfs.dir(path)
            while true do
                local dir = iter(dir_obj)
                if dir == nil then
                    break
                end
               
			    --cclog(dir)
                if dir ~= "." and dir ~= ".." then
                    local curDir = path..dir
                    --cclog(curDir)
                    local mode = lfs.attributes(curDir, "mode")
                    if mode == "directory" then
                        _rmdir(curDir.."/")
                    elseif mode == "file" then
						local tbLogName = string.strSplit(dir, '_')
						--for i =1, #tbLogName do
						--	cclog(tbLogName[i])
						--end
						local iCurTime = tonumber(tbLogName[2])
						cclog(string.format("%d check file %s %d", iValidTime, curDir, iCurTime))
						cclog("=====strCurLogFile=====",strCurLogFile , dir,strLogFile)
						os.remove(curDir)
						cclog("删除日志文件:",curDir, dir)	
                    end
                end
            end        
        end

        _rmdir(path)
	end
end 