function API_Pay_android_callback(func)
	local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = {"setPayCallBackFunc", func }
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"setPayCallBackFunc",args,sigs)
	 if not ok then
        print("============= API_Pay_android_callback callback error")
    else
        print("------------- API_Pay_android_callback call callback success")
    end
end

--[[
   public static void loginCallBack(UserLoginRet ret){
        Log.e(activity.TAG, "登陆11==111==" + ret.toString());
        String tbms = " local tbMsg = {   ";
        String tbms1 = tbms + "['AccessToken']=  '"  + ret.getAccessToken() + "',";
        String tbms2 = tbms1 +"['openId'] = '"  + ret.open_id + "',";
        String tbms3 = tbms2 + "['flag'] = '" + ret.flag + "',";
        String tbms4 = tbms3 + "['msg'] = '" + ret.msg + "',";
        String tbms5 = tbms4 + "['platform'] = " + ret.platform + " ,";

        String tbms6 = tbms5 + "['pf'] = " + ret.pf + " ,";
        String tbms7 = tbms6 + "['token'] = " + ret.token + " ,";
        String tbms8 = tbms7 + "['pfkey'] = " + ret.pf_key + " ,";
        String tbms9 = tbms8 + "['nickname'] = " + ret.nick_name + " ,";
        String tbms10 = tbms9 + "['paytoken'] = " +  ret.getPayToken() + " ,";

        String tbmsEnd = tbms10 + "}  return tbMsg ";
        Cocos2dxLuaJavaBridge.callLuaFunctionWithString(luaLoginCallback, tbmsEnd);
        Log.e(activity.TAG, "登陆11===End="   +  tbms5 );
    }
]]

	
--https://wiki.open.qq.com/index.php?title=%E7%B1%B3%E5%A4%A7%E5%B8%88%E6%9C%8D%E5%8A%A1%E7%AB%AF%E8%AF%B4%E6%98%8E
local RET_SUCC = 0
local PAYSTATE_PAYSUCC = 0
local PAYSTATE_PAYCANCEL = 1
local PAYSTATE_PAYUNKOWN = -1
local PAYSTATE_PAYERROR = 2
local Login_TokenInvalid = 3100
local Pay_User_Cancle = 4001
local Pay_Param_Error = 4002
function g_setPayCallBackFunc_android(ret)
	cclog("=====g_setPayCallBackFunc_android=====",ret)
	local func = loadstring(ret)
	local tbmsg = func()
	local  ysdkExtInfo = tbmsg.ysdkExtInfo
	local  realSaveNum = tbmsg.realSaveNum
	local  payState = tbmsg.payState
	local  flag = tbmsg.flag
	 
	if  flag == RET_SUCC   then
		--cclog("=====g_setPayCallBackFunc_android===== ", payState == PAYSTATE_PAYSUCC)
		if payState == PAYSTATE_PAYSUCC then
			--https://blog.csdn.net/zzhongcy/article/details/102500089
			--https://segmentfault.com/a/1190000013238325?utm_source=tag-newest
			--https://wiki.open.qq.com/wiki/YSDK%E6%94%AF%E4%BB%98%E6%8E%A5%E5%8F%A3%E7%AD%BE%E5%90%8D%E8%AF%B4%E6%98%8E
			
			--local step1 = urlEncode('/v3/r/mpay/get_balance_m')
			
			--[[openkey：手Q登陆时传手Q登陆回调里获取的paytoken值，微信登陆时传微信登陆回调里获取的传access_token值。
			local openkey = ""
			local app_id = "1111135079" 
			if tbmsg.platform == 1 then
				openkey = g_userLoginData.paytoken
				app_id = "1111135079" 
			elseif tbmsg.platform == 2 then --weixin
				openkey = g_userLoginData.AccessToken
				app_id = "wxd6e0f5413a5c7888" 
			else
			end
			local step2 = string.format("appid=%s&format=json&openid=%s&openkey=%s&pf=%s&pfkey=%s&ts=%d&zoneid=1", app_id,
			g_userLoginData.openId, openkey, g_userLoginData.pf, g_userLoginData.pfkey, os.time())
			--local step2_encode = urlEncode(step2)
			--local step2_result = string.format("%s&%s", step1, step2_encode)
			]]
			g_AppAndroidReceipt(tbmsg)
		elseif payState == PAYSTATE_PAYCANCEL then
			WebSocket:showTips("取消支付")
		elseif payState == PAYSTATE_PAYUNKOWN then
			WebSocket:showTips("支付异常，请重试")
		elseif payState == PAYSTATE_PAYERROR then
			WebSocket:showTips("支付出错了，请重试")
		else
		end
	else
		cclog("=====g_setPayCallBackFunc_android=====1")
		if payState == Login_TokenInvalid then
			WebSocket:showTips("授权过期，请重新登陆")
		elseif payState == Pay_User_Cancle then
			WebSocket:showTips("您取消支付")
		elseif payState == Pay_Param_Error then
			WebSocket:showTips("支付发生异常，请重试")
		else
		end
	end 
end

--https://wiki.open.qq.com/wiki/%E7%B1%B3%E5%A4%A7%E5%B8%88%E4%BB%8B%E7%BB%8D_%E2%80%94%E2%80%94_%E9%81%93%E5%85%B7%E7%9B%B4%E8%B4%AD%E6%A8%A1%E5%BC%8F%E4%BB%8B%E7%BB%8D
--http://www.360doc.com/content/14/0117/13/9200790_345940368.shtml
--zoneid：       账户分区ID。应用如果没有分区：传zoneid=1
function g_AndroidPay(zoneId, saveValue, isCanChange, resName, ysdkExt)
	local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = {zoneId, saveValue, isCanChange, resName, ysdkExt}
    --local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"recharge",args)
	 if not ok then
        print("============= g_AndroidPay callback error")
    else
        print("------------- g_AndroidPay call callback success")
    end
end

local NoReady = 0 --没有准备好
local Error = 1--出错
local Ready  = 2 --准备好了
local Open = 3 --打开视频
local Playing = 4 --播放视频中
local Closed = 5 --关闭视频
local Rewarded = 6 --获取奖励吧

function g_AdsCallBack_android(iResultType)
	closeConnectItem()
	iResultType = tonumber(iResultType)
	cclog(Rewarded,Playing,YUMI_REARD,Error,"====g_AdsCallBack==22==",iType, iResultType)
	if iResultType == NoReady then--视屏播放未准备好
		
		g_action:ts_hszz_antion("暂时没有视频源，请稍后再来1",nil,-1)
	elseif iResultType == Rewarded then--获取奖励
		cclog("==g_AdsCallBack_android====")
		--g_svSendMsgControl:request_videoAD(1,Rewarded,g_adsRewardedType)
		g_svSendMsgControl:request_videoAD(1,Rewarded,g_adsRewardedType,callback,adsValue[g_adsRewardedType] )
		getADSFunc(g_adsRewardedType)
		---adsTime[adsRewardedType] = os.time()
	elseif iResultType == Playing then--视屏播放
		g_svSendMsgControl:request_videoAD(1,Playing)
	elseif iResultType == Closed then--视屏播放关闭
		
	elseif iResultType == Error then--视屏播放出错
		
		g_action:ts_hszz_antion("暂时没有视频源，请稍后再来",nil,-1)
	else	
	end
end

function API_playAds_android_callback(func)
	 local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = { "callbacklua", func }
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"callbackLua",args,sigs)
	 if not ok then
        print("============= call callback error")
    else
        print("------------- call callback success")
    end
end
function g_reloginFunc_android()
	require("app.checkUpdate.checkupdatewnd"):create():openWnd()
end 
function API_relogin_android_callback(func)
	 local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = { "setReloginCallBack", func }
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"setReloginCallBack",args,sigs)
	 if not ok then
        print("============= call callback error")
    else
        print("------------- call callback success")
    end
end

function API_playAds_android()
	 local argsJson = nil
	 
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "showAd", {argsJson}, sigs)
	 if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end



function API_Package_android_callback(func)
	 local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = { "setPackageCallBack", func }
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"setPackageCallBack",args,sigs)
	 if not ok then
        print("============= call callback error")
    else
        print("------------- call callback success")
    end
end
function API_getPackage_android()
	 local argsJson = nil
	 
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "getPackageIds", {argsJson}, sigs)
	 if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end

function API_ADDQQ_android(key)
	local argsJson = key
	cclog("=======API_ADDQQ_android==11===="..key)
  ---  local sigs = "(Ljava/lang/String)V"
	local sigs = "(Ljava/lang/String;I)V"
	 local args = {key,0 }
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "joinQQGroup", args, sigs)
	 if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end

function API_playBannerAd_android()
	  print("====API_playBannerAd_android== : ", ret)
	 local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "showBannerAd", {argsJson}, sigs)
	 if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end

function API_initAds_android()
	 print("===API_initAds_android=== : ")
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "initAd", {argsJson}, sigs)
	 if not ok then
       print("==== luaj error ==== : ", ret)
        return false
   else
        print("==== The JNI return is:", ret)
        return ret
    end
end

function API_initAll_android()
	print("===API_initAds_android=== : ")
	if g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID and not GinitAll  then
		local argsJson = nil
		local sigs = "()V"
		local luaj = require "cocos.cocos2d.luaj"
		local className = "org/cocos2dx/lua/AppActivity"
		local ok,ret = luaj.callStaticMethod(className, "initAll", {argsJson}, sigs)
		GinitAll = true
		 if not ok then
		   print("==== luaj error ==== : ", ret)
			return false
	   else
			print("==== The JNI return is:", ret)
			return ret
		end
	end
end


LogType = 0
g_logType = {}
g_logType.QQ = 1
g_logType.YK = 2
function g_androidAntiAddFunc()
	 cclog(G_taptapOpenid,"====g_androidAntiAddFunc=11111==",g_gameMsg)
	
	if LogType  == g_logType.QQ then
		g_androidLoginFunc(g_gameMsg,1)
	elseif LogType  == g_logType.YK then
		g_loadScene:VisitorLogin(G_taptapOpenid)
	else
		g_action:ts_hszz_antion("==登录Erro====="..LogType)
	end 
 end 


 function g_androidISShowAntiFunc(openId,DlogType)
	if 	 g_Cfg.Platform  ~= cc.PLATFORM_OS_ANDROID then
		return
	end 
	if DlogType then
		LogType = DlogType
	end 
	
	API_AntiAdd_android(openId)
 end





 function g_androidLoginFunc(ret,isInto)
	 cclog(g_loadScene,"=====API_LoginCallBack_android===11==",ret)
	 local func = loadstring(ret)
	 local tbmsg = func()
	 local openId = tbmsg.UserId.."AndroidQQ"
	 local AccessToken = tbmsg.getToken
	 local sex = tbmsg.sex
	 local nickName = tbmsg.nickName
	 g_userLoginData = tbmsg
	 if not  g_loadScene  then
		return 
	 end 
	cclog(AccessToken,isInto,"===g_androidLoginFunc=====",openId)
	if  openId   then
		if 	 g_Cfg.Platform  == cc.PLATFORM_OS_ANDROID then
			sex = 100
		end
		--是否弹出防沉迷身份验证
		 if  isInto and isInto == 1 then
			g_loadScene:QQLogin(AccessToken,openId,nickName,sex)
		 else
			g_gameMsg = ret
			g_androidISShowAntiFunc(openId)
		 end 
		--- 
	end 
	 
	--[[
	 if  flag == "0" and openId   then
		 cclog(platform, type(platform),"====11=")
		if platform ==  7  then
			g_loadScene:VisitorLogin(2,AccessToken, openId,7 )
		elseif platform == 1  then
			
		elseif platform == 2  then
			g_loadScene:WeChatLogin(AccessToken,openId,2)
		end 
	 end ]]
end


--taptap 身份验证
function API_AntiAdd_android(openId)
	local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = {openId,0}
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"AntiAdd",args,sigs)
	 if not ok then
        print("============= call callback error")
    else
        print("------------- call callback success")
    end
end
function API_AntiAddCallBack_android(func)
	local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = {"setLoginCallBack", func }
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"setAntiAddCallBack",args,sigs)
	 if not ok then
        print("============= call callback error")
    else
        print("------------- call callback success")
    end
end



function API_LoginCallBack_android(func)
	local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = {"setLoginCallBack", func }
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"setLoginCallBack",args,sigs)
	 if not ok then
        print("============= call callback error")
    else
        print("------------- call callback success")
    end
end

function API_initLogin_android(tag)
	local argsJson = tag
    local sigs = "(I)V"
	
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "initLogin", {argsJson}, sigs)
	 if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end
function API_getUserMsg_android()
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "getUserMsg", {argsJson}, sigs)
	 if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end

	 
function antiCallBack_android(ret)
	cclog(g_loadScene,"=====API_LoginCallBack_android===11==",ret)
	 local func = loadstring(ret)
	 local tbmsg = func()
	g_android_fanchenmiItem:openWnd(tbmsg)
end 

-- 防沉迷计回调
function API_antiCallBack_android(func)
	local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = {"setAntiCallBackFunc", func }
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"setAntiCallBackFunc",args,sigs)
	 if not ok then
        print("============= call callback error")
    else
        print("------------- call callback success")
    end
end


-- 防沉迷计时
function API_setAntiAddictGameStart_android()
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "setAntiAddictGameStart", {argsJson}, sigs)
	 if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end
-- 防沉停止
function API_setAntiAddictGameEnd_android()
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "setAntiAddictGameEnd", {argsJson}, sigs)
	 if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end



 function callJavaMusicVolume(Volume)
	cclog(type(Volume),"======callJavaMusicVolume=======",Volume)
	local argsJson = nil
	
	local luaj = require "cocos.cocos2d.luaj"
	local className = "org/cocos2dx/lua/AppActivity"
	local sigs ="(Ljava/lang/String;I)V"
	local args = { "setReloginCallBack", Volume }
	local ok,ret = luaj.callStaticMethod(className, "setMediaVolume", args, sigs)
	if not ok then
		print(ok,"==== luaj callJavaGetAppVer error ==== : ", ret)
		
		return "1.7.6"
	else
		print("==== The JNI return is:", ret)
		return ret
	end
	---return "1.7.6"
end

function callJavaEffVolume(Volume)
	cclog(type(Volume),"===callJavaEffVolume=======",Volume)
	local argsJson = nil
	local sigs ="(Ljava/lang/String;I)V"
	local args = { "setReloginCallBack", Volume }
	local luaj = require "cocos.cocos2d.luaj"
	local className = "org/cocos2dx/lua/AppActivity"
	
	local ok,ret = luaj.callStaticMethod(className, "setAlermVolume", args, sigs)
	if not ok then
		print(ok,"==== luaj callJavaGetAppVer error ==== : ", ret)
		
		return "1.7.6"
	else
		print("==== The JNI return is:", ret)
		return ret
	end
	---return "1.7.6"
end


----------taptap---------------------------


 function g_LoginTapTapCallback(ret,isInto)
	 cclog(g_loadScene,"=====API_LoginCallBack_android===11==",ret)
	 local func = loadstring(ret)
	 local tbmsg = func()
	 local userID = tbmsg.userID
	 local unionid = tbmsg.unionid
	 local openid = tbmsg.openid
	
	 local nickName = tbmsg.nickName
	 g_userLoginData = tbmsg
	 if not  g_loadScene  then
		return 
	 end 
	 print(userID.."-----------=g_LoginTapTapCallback="..unionid)
	 cclog(userID,"===g_androidLoginFunc=====",unionid)
	 if  openid   then
		---g_loadScene:VisitorLogin(openid)
	 end 
	G_taptapOpenid = openid
end

function API_TaptapLogin_callback(func)
	local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = { "setluaTokenCallback_Taptap", func }
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"setluaTokenCallback_Taptap",args,sigs)
	 if not ok then
        print("============= call callback error")
    else
        print("------------- call callback success")
    end
end
--获取玩家信息token
function API_taptapLogin()
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	local ok,ret = luaj.callStaticMethod(className, "taptapLogin", {argsJson}, sigs)
	if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end

--获取 退出登录
function API_taptapLogOut()
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	local ok,ret = luaj.callStaticMethod(className, "taptaplogOut", {argsJson}, sigs)
	if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end
-----------OPPOSDK-----------oPPOSDK----------oPPOSDK------------------------------
G_OPPOConTorlEnum = {}
G_OPPOConTorlEnum.doPay = 1
G_OPPOConTorlEnum.UpdateRole = 2
G_OPPOConTorlEnum.AntiAddict = 3
G_OPPOConTorlEnum.Loign = 4
G_OPPOConTorlEnum.getNewestVersion = 5

function g_OPPOConTorl(nType,...)
	print("======11111=======g_OPPOConTorl")
	cclog("===g_OPPOConTorl=====",nType)
	if  PackageName.oppo ~= G_PackageName then
		cclog(G_PackageName,"===g_OPPOConTorl===fase==",PackageName.oppo)
		return
	end 
	cclog("===g_OPPOConTorl=====",nType,...)
	if nType == G_OPPOConTorlEnum.doPay  then
		API_doPayOppo_android_OPPO(...)
	elseif nType == G_OPPOConTorlEnum.UpdateRole  then
		API_UpdateRole_android_OPPO(...)
	elseif nType == G_OPPOConTorlEnum.AntiAddict  then
		API_setAntiAddictGameStart_android_OPPO(...)
	elseif nType == G_OPPOConTorlEnum.Loign  then
		API_sdkDoLoignOppo_android_OPPO(...)
	elseif nType == G_OPPOConTorlEnum.getNewestVersion  then
		API_getNewestVersion_android_OPPO(...)
	end 
end

function API_luaTokenOPPO_android_callback(func)
	 local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
    local args = { "setluaTokenCallback_OPPO", func }
    local sigs ="(Ljava/lang/String;I)V"
    local ok = luaj.callStaticMethod(className,"setluaTokenCallback_OPPO",args,sigs)
	 if not ok then
        print("============= call callback error")
    else
        print("------------- call callback success")
    end
end

--充值
function API_doPayOppo_android_OPPO(payName, payDecs,shopstr, Cost, serverURL)
	local argsJson = nil
    local sigs = "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;ILjava/lang/String;)V"
	local args = {payName, payDecs,shopstr, Cost, serverURL}
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "doPayOppo", args,sigs)
	 if not ok then
        print("====doPayOppo==== : ", ret)
        return false
    else
        print("====doPayOppo is:", ret)
        return ret
    end
end
--上传玩家信息
---inal String roleId,final String roleName,final int roleLevel,final String plaerID,final String realmName,final String VipLev_Lev_FB)
function API_UpdateRole_android_OPPO(roleId,roleName,roleLevel,playerID,realmName,VipLev_Lev_FB)
	local argsJson = nil
    local sigs = "(Ljava/lang/String;Ljava/lang/String;ILjava/lang/String;Ljava/lang/String;Ljava/lang/String;)V"
	local args = {roleId,roleName,roleLevel,playerID,realmName,VipLev_Lev_FB}
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "ReportUserGameInfoParamOppo", args, sigs)
	 if not ok then
        print("===ReportUserGameInfoParamOppo==11== : ", ret)
        return false
    else
        print("===ReportUserGameInfoParamOppo:", ret)
        return ret
    end
end
--获取玩家信息token
function API_doGetTokenAndSsoid_android_OPPO()
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	local ok,ret = luaj.callStaticMethod(className, "doGetTokenAndSsoid", {argsJson}, sigs)
	if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end
--防沉迷
function API_setAntiAddictGameStart_android_OPPO()
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "doGetVerifiedInfoOppo", {argsJson}, sigs)
	 if not ok then
        print("==== luaj error ==== : ", ret)
        return false
    else
        print("==== The JNI return is:", ret)
        return ret
    end
end
--OPPO  登录
function API_sdkDoLoignOppo_android_OPPO()
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "sdkDoLoignOppo", {argsJson}, sigs)
	 if not ok then
        print("==== sdkDoLoignOppo==== : ", ret)
        return false
    else
        print("===sdkDoLoignOppo:", ret)
        return ret
    end
end

--检查 OPPO 软件商店是否有更新 Oppo
function API_getNewestVersion_android_OPPO()
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, "getNewestVersionCodeOppo", {argsJson}, sigs)
	 if not ok then
        print("==== getNewestVersionCodeOppo==== : ", ret)
        return false
    else
        print("===getNewestVersionCodeOppo:", ret)
        return ret
    end
end

--无参数调用
function API_android_Func(StrFunc)
	local argsJson = nil
    local sigs = "()V"
    local luaj = require "cocos.cocos2d.luaj"
    local className = "org/cocos2dx/lua/AppActivity"
	 local ok,ret = luaj.callStaticMethod(className, StrFunc, {argsJson}, sigs)
	 if not ok then
        print("==== API_android_Func==== : ", StrFunc)
        return false
    else
        print("===API_android_Func:", StrFunc)
        return ret
    end
end 

