------------------
-- 文件名:	mathConTrol.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local mathConTrol = class("mathConTrol")


---=========数值操作===通关计算算出来的数值============================
function mathConTrol:mathMainAttAdd(attID) --计算角色主属性 每级增加
	local BOSSID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	local baseValue = tbMsg["mainAtt"..attID] 
	local zizhi = roleAttConTrol:getZizhi()
	local value = math.floor( baseValue*zizhi/20)
	return value
end 
function mathConTrol:mathMainAtt(attID) --计算角色主属性
	local BOSSID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	--cclog(tbMsg,"====mathMainAtt====111===",BOSSID,attID)
	local baseValue = tbMsg["mainAtt"..attID] 
	local zizhi = roleAttConTrol:getZizhi()
	local level = g_roleMsg:getRoleAttValue(RoleAttMsg.level,true)
	
	local value = baseValue + math.floor(baseValue*zizhi*(level-1)/20)
	--cclog(value,"======mathMainAtt==222===",baseValue,zizhi,level)
	return value
end
function mathConTrol:mathResultJH() --计算进化成功率
	local jinhua = g_roleMsg:getRoleAttValue(RoleAttMsg.jinhua,true)
	local result = 110 - jinhua
	
	if result <= 10  then
		return 10
	end 
	return result
end 

function mathConTrol:mathLevUpNeedCoin(attID,Tag) --计算升级需要金币  
	local Tag = Tag or 1
	local zizhi = roleAttConTrol:getZizhi()
	local level = g_roleMsg:getRoleAttValue(RoleAttMsg.level,true)
	
	--和转生有关系
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0

	local value2 =  level + 100 + 10*(zslevel)*level
	local needCoin , strLDEndCN = byBigInt(level, value2,true)
	local needCoin , strLDEndCN = byBigInt(needCoin, Tag,true)

	local addVa = g_tianfuConTrol:getTianfuOpenValue(18) 
	addVa = 1-(addVa / 100 )
	cclog(needCoin,"=======mathLevUpNeedCoin======",zslevel,level,value2,addVa)
	if addVa ~= 1 then
		 needCoin = byBigInt(needCoin, addVa,true)
	end 
	
	strLDEndCN , needCoin = getBigIntByStr2(needCoin)
	cclog(needCoin,"=======mathLevUpNeedCoin====000==",strLDEndCN)
	return strLDEndCN , needCoin
end

function mathConTrol:mathJHNeedClNum() --计算进化材料
	local jinhua = g_roleMsg:getRoleAttValue(RoleAttMsg.jinhua,true)
	local result = 100 + 100*jinhua
	
	return result
end 

function mathConTrol:mathZhuansNeedClNum() --计算转生材料
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	local result = 100 + 100*zslevel
	
	return result
end 

-------=============================装备============================================================================================================================================================================================

function mathConTrol:mathEquMaintAttRation(attLev,cfgID,index,yanseD) --计算装备主属性的Ration
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)
	local Ration1 = tbMsg["addRationMin"..index]
	local Ration2 = tbMsg["addRationMax"..index]
	local add = (Ration2-Ration1)/7
	local ration = Ration1 + (attLev-1)*add + yanseD*2
	return ration
end 

function mathConTrol:mathEquMaintAtt(level,zbCfgID,attID,ration) --计算装备属性值
	
	local cfgMsg =  g_cfgMsg:getCfgMsg("att_D",attID)
	--cclog("========mathEquMaintAtt======",level,zbCfgID,attID,ration)
	local value = math.ceil( cfgMsg.value1*level*ration)
	return value
end 

function mathConTrol:mathEquCecAttRaton(attLev,cfgID) --计算装备fu属性的Ration
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)
	local Ration1 = tbMsg["addRationMin1"]
	local Ration2 = tbMsg["addRationMax1"]
	local add = (Ration2-Ration1)/7
	local ration = Ration1 + (attLev-1)*add
	--cclog(ration,add,"==mathEquCecAttRaton======",Ration1,Ration2,attLev)
	return ration
end 

function mathConTrol:mathEquCecAtt(level,zbCfgID,attID,ration) --计算装备副属性值
	local cfgMsg =  g_cfgMsg:getCfgMsg("att_D",attID)
	local value
	cclog(value,"=22====mathEquCecAtt=======",attID ,cfgMsg)
	local addVip = g_viplevMsg:getVipValue(26) or 0
	if cfgMsg.nType == 1 then
		value = math.floor( (cfgMsg.zbbaseValue + cfgMsg.valueAdd2*level*ration)*(1+addVip/ 100))/10
	else
		value = math.floor(( cfgMsg.zbbaseValue + cfgMsg.valueAdd2*level*ration/4*10)*(1+addVip/ 100))/10
	end 
	
	
	--cclog(value,"=====mathEquCecAtt=======")
	if cfgMsg.maxValue > 0 and value > cfgMsg.maxValue then
		value = cfgMsg.maxValue 
	end 

	return value
end 

function mathConTrol:mathEquPoint(EquID) --计算装备评分
	local zbInfo = g_zbMsg:getEuqTbMsg(EquID)
	local zbLev = zbInfo.zbLev
	local yanse = zbInfo.yanse
	local mainAttLev = zbInfo.mainAttLev
	local runeNum = zbInfo.runeNum
	local ration1 = self:mathEquMaintAttRation(zbInfo.mainAttLev[1],zbInfo.cfgID,1,yanse)
	local ration2 = self:mathEquMaintAttRation(zbInfo.mainAttLev[2],zbInfo.cfgID,2,yanse)
	local QHLev = zbInfo.QHLev or 0
	--cclog("====mathEquPoint=====")
	local point = (1 + yanse*5 + runeNum*3 + QHLev) + (ration1 + ration2)*10
	
	return point
end 


function mathConTrol:mathEquQHcailiaoNum(EquID) --计算装备强化材料
	local zbInfo = g_zbMsg:getEuqTbMsg(EquID)
	local zbLev = zbInfo.zbLev
	local QHLev = zbInfo.QHLev or 0
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}
	local maxMapLev = fubenMaxLev[1] or 1

	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	
	local num = 100 + 100 * ( 1 + 0.2*QHLev) + 200 * zslevel
	--cclog(num,"=========mathEquQHcailiaoNum=======",QHLev,zslevel)
	return num
end 

function mathConTrol:mathEquLevUpcailiaoNum(EquID) --计算装备升级材料
	local zbInfo = g_zbMsg:getEuqTbMsg(EquID)
	local zbLev = zbInfo.zbLev

	local num = 100 + 60*zbLev 

	return num
end 


---==============================================
function mathConTrol:mathSkillLevUpNeedXS(Lev,index) --计算技能升级需要学识
	local num = 100*Lev*index
	return num
end 
function mathConTrol:mathSkillLWNeedXS(index) --计算技能领悟需要技能书
	local num = 10*index
	return num
end 

---==============================================

function mathConTrol:mathMaxPetNum() --
	local petMaxBuy = g_baseMsg:getOther(otherDBMsgID.petMaxBuy) or  0
	local addVa = g_tianfuConTrol:getTianfuOpenValue(6) 
	local addVip = g_viplevMsg:getVipValue(1)
	local num = tbGameConst.basePetNum + petMaxBuy*tbGameConst.petBagBuyaddNum +addVa + addVip
	return num
end 
function mathConTrol:mathPetMaxExp(lev) --需要经验
	local cfgMsg =  g_cfgMsg:getCfgMsg("petStarLevExp_D",lev) 
	local  needExp = cfgMsg.getExp
	return needExp
end 


--计算金币宝箱 lev 宝箱等级
function mathConTrol:mathResBox(lev) --
	local res = g_batMath:mathFbBatEnemyRes(1)
	cclog(res,"====mathResBox===",lev)
	res = res*1000*lev
	return res
end 


--计算商店金币
function mathConTrol:mathShopCoin(ration) --
	local mapLev = g_batMath:getMapLev() 
	local res  = self:mathResBox(3)
	if mapLev > 600 then
		local res , strLDEndCN = byBigInt(res, ration,true)
		return  res 
	end 
	local add = 1
	if mapLev <= 100 then
		add = 0.2
	elseif mapLev <= 200 then
		add = 0.4
	elseif mapLev <= 400 then
		add = 0.6	
	elseif mapLev <= 600 then
		add = 0.8		
	end 
	cclog(res,"==DD==mathResBox===",ration)
	local res = res*ration*add
	return res
end 
---==============================================

function mathConTrol:getAttValue(tbValue,curAttID)
	local proID = curAttID*1000+3
	local addValue = "0"
	local pct = "0"
	for attID,v in pairs(tbValue)do
		if curAttID == attID then
			addValue = addBigInt(addValue, v)
		elseif  proID == attID then
			pct = addBigInt(pct, v)
		end 
	end 
	return  addValue ,pct
end 
petAttIndexMsg = {}
petAttIndexMsg.dps = 1
petAttIndexMsg.def = 2
petAttIndexMsg.hp = 3
petAttIndexMsg.speed = 4
petAttIndexMsg.chouhen = 5
petAttCeMsg = {}
petAttCeMsg.baoji = 1
petAttCeMsg.jinzun = 2
petAttCeMsg.duoshan = 3
petAttCeMsg.attckNum = 4


function mathConTrol:mathPetBaseAtt(lev,index,zizhi,PetID,isFloor) ---计算基础属性
	local attIDRation = {18,30,25,20,80}
	local info = g_petMsg:getpetTbMsg(PetID)
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",info.cfgID) 
	local baseValue = cfgMsg["baseValue"..index]
	local baseValue = math.floor( baseValue + lev*zizhi/attIDRation[index]*baseValue)
	--技能属性
	local tbattID = {11,12,15,17,43}

	---获取技能  增加
	local tbValue  = g_petMsg:mathSkillAddAttMsg(PetID)
	---全体增加  增加
	--cclog(tbValue,"===mathPetAttCe========123=====")
	local tbValue = g_petMsg:mathTbPetAddAttMsg(tbValue)
	--cclog(tbValue,"===mathPetAttCe======123=======")
	local curID = tbattID[index]
	
	local addValue ,pct  =  self:getAttValue(tbValue,curID)
	
	--lyu
	local tbLyattID = {4,8,1,3,9}
	local lyvalue = g_lyInfoMsg:mathZhongzhuValueAtt(cfgMsg.zhongzhu,tbLyattID[index])
	pct = pct + lyvalue
	
	cclog("=======mathPetAttCe=====DD===",lyvalue,index)
	
	pct = tostring(1 + tonumber(pct)/100)
	local  final1 = addBigInt(baseValue, addValue)
	
	local final,strLDEndCN =  byBigInt(final1, pct,true) ;
	
	--统帅
	local addValue =  g_roleMsg:getRoleAttValue(33,true) 
	local tbRation = {0.5,0.2,1.5,0.3,0}
	--cclog("======getRoleAttValue====",addValue,tbRation[index],index)
	local addValue =  byBigInt(addValue, tbRation[index],true) 
	
	final = addBigInt(final, addValue)
	final = tonumber(final)

	return final,strLDEndCN,addValue
end 

function mathConTrol:mathPetAttCe(info,index,Level) ---计算基础属性2
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",info.cfgID) 
	local tbAttValue =  info.attValue or {}
	local attValue = tbAttValue[index] or 0
	local addLevValue = 0
	local value
	if index == 4 then
		value = g_petMsg:getTbPetAddAttMsg(54) or  0
		
		local lyvalue = g_lyInfoMsg:mathZhongzhuValueAtt(cfgMsg.zhongzhu,10)
		value =  attValue + value + lyvalue
	else
		local addValue =  g_roleMsg:getRoleAttValue(33,true) 
		local lev = Level or info.Level
		addLevValue = cfgMsg["addAttCe"..index] * lev
		value = cfgMsg["TextAttCe"..index]  + addLevValue
		
		local tbLyattID = {5,100,7}
		local lyvalue = g_lyInfoMsg:mathZhongzhuValueAtt(cfgMsg.zhongzhu,tbLyattID[index])
		-------cclog("=======mathPetAttCe===124=====",lyvalue,index)
		value = (value + addValue*0.25)*(1+ lyvalue/100)
		
	end 
	
	local addVip = g_viplevMsg:getVipValue(24)
	value = math.floor(value * (1+addVip/100))
	
	local tbattID = {19,18,20,22}

	---获取技能  增加
	local tbValue  = g_petMsg:mathSkillAddAttMsg(info.id)

	local curID = tbattID[index]
	---全体增加  增加
	
	local tbValue = g_petMsg:mathTbPetAddAttMsg(tbValue)
	
	local addValue ,pct  =  self:getAttValue(tbValue,curID)
	pct = tostring(1 + tonumber(pct)/100)
	local  final1 = addBigInt(value, addValue)
	
	local final,strLDEndCN =  byBigInt(final1, pct) ;
	
	if isNumber then
		final = tonumber(final)
	end 
	
	return final,strLDEndCN
end 



---==============================================
function mathConTrol:mathPetSkillNeedLev(lev) ---计算需求等级
	local value =  (lev-1)*10
	
	return value
end 

function mathConTrol:mathPetSkillValue(lev,skillID) ---计算数值
	local tbMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillID)
	tbValue = {}
	for i=1,3 do
		if tbMsg["baseValue"..i] > 0 then
			tbValue[i] = tbMsg["baseValue"..i] +  tbMsg["addVa"..i]*lev
		end 
	end 
	
	return tbValue
end
function mathConTrol:mathPetSkillNeedSLD(lev) ---计算需求熟练度x
	if lev < 1 then
		lev = 1
	end 
	local cfgMsg =  g_cfgMsg:getCfgMsg("petStarLevExp_D",lev) 
	
	return cfgMsg.getExp2
end 
---=============================================================================
function mathConTrol:mathBatMaxRes(nType,lev) ---计算宝库最大量
	local nType =  1
	local baokulev = g_baseMsg:getTbInteger(tbIntegerKEy.baokulev) or {}	
	local lev = lev or baokulev[nType] or 1
	lev = lev*lev*10
	local tbMsg = { 10000,30000,60000}
	local maxValue = byBigInt(tbMsg[nType],lev,true) 
	self.bkMaxValue = maxValue
	cclog("===mathBatMaxRes=",lev,maxValue,baokulev,tbMsg[nType])
	return maxValue
end

function mathConTrol:mathBatMaxNeedCoin(nType,lev) ---计算宝库升级zs
	local nType =  1
	local baokulev = g_baseMsg:getTbInteger(tbIntegerKEy.baokulev) or {}	
	local lev = lev or baokulev[nType] or 1
	local value = 1000 *lev*lev
	if  lev > 339 then
		value = 25000 *lev*lev 
	elseif  lev > 300 then
		value = 20000 *lev*lev 
	elseif  lev > 280 then
		 value = 10000 *lev*lev 
	elseif  lev > 250 then
		value = 5000 *lev*lev 
	elseif  lev > 230 then	
		value = 3000 *lev*lev 
		
	end 
	return value
end

---=============================================================================
function mathConTrol:changAttReloadMsg(attID)
	--刷新重置其他相关数据
	if attID <= 0  then
		return
	end 
	local cfgMsg =  g_cfgMsg:getCfgMsg("att_D",attID)
	if not cfgMsg then
		return
	end 
	if cfgMsg.isCwu == 1 then
		g_petMsg:cleanTbPetAddAttMsg()
		g_roleMsg:mathRoleTianfuAttMsg()
		--刷新宠物属性
		local B_Pet = g_WndMgr:getWnd("B_Pet")
		if B_Pet then
			B_Pet:setPetDecPanl()
		end 
		g_batContorl:reloadPet()
	else
		g_roleMsg:reloadRoleBaseAttMsg()
		--刷新角色属性
		g_roleAttConTrol:attItemByChangeNumber(cfgMsg.attID)
		g_batContorl:reloadMyRoleMsg(true)
	end 
end 

--重置所有，比如重生重置天赋
function mathConTrol:changAttReloadMsgAll()
	--刷新重置其他相关数据
	g_roleMsg:reloadRoleBaseAttMsg()
	
	--刷新宠物属性
	local B_Pet = g_WndMgr:getWnd("B_Pet")
	if B_Pet then
		B_Pet:setPetDecPanl()
	end 

	local B_Role = g_WndMgr:getWnd("B_Role")
	if  B_Role then
		B_Role:reloadWnd()
	end 
	g_batContorl:reloadPet()
	g_batContorl:reloadMyRoleMsg(true)
	
end 

--刷新某个宠物
function mathConTrol:reloadPetOne(petID)
	--是否出战
	local info = g_petMsg:getpetTbMsg(petID)
	if  info.batIndex and info.batIndex  > 0 then
		 g_batContorl:reloadPetMsg(info.batIndex,true)
	end 
end

function mathConTrol:reloadRoleAtt()
	g_roleMsg:reloadRoleBaseAttMsg()
	g_batContorl:reloadMyRoleMsg(true)
	local B_Role = g_WndMgr:getWnd("B_Role")
	if  B_Role then
		B_Role:reloadWnd()
	end 
end 
--装备更新刷新
function mathConTrol:reloadRoleByZb(zbID)
	local info = g_zbMsg:getEuqTbMsg(zbID)  
	if  info and info.inRole  and info.inRole  > 0 then
		self:reloadRoleAtt()
	end 
end

----
function mathConTrol:mathFWValue(fwID) ---获取符文属性
	local tbMsg = g_cfgMsg:getCfgMsg("rune_D", fwID)
	local value = tbMsg.value
	local addVa = g_tianfuConTrol:getTianfuOpenValue(49) 
	local addVip = g_viplevMsg:getVipValue(25) or 0
	local value = math.floor(value *(1+ addVip/ 100 + addVa/100))
	cclog(addVip,fwID,value,"===mathFWValue=======")
	local addVa = value - tbMsg.value 
	return value,addVa
end 

function mathConTrol:mathFWValueDec(fwID) ---获取符文属性
	local tbMsg = g_cfgMsg:getCfgMsg("rune_D", fwID)
	local addVa = g_tianfuConTrol:getTianfuOpenValue(49) or 0
	local addVip = g_viplevMsg:getVipValue(25) or 0
	addVa = addVa + addVip
	cclog(addVa,fwID,addVip,"====mathFWValueDec=========")
	local dec = tbMsg.dec.."(+"..addVa.."%)"
	return dec
end 


function mathConTrol:ctor()

end

g_mathConTrol =  mathConTrol:create()