------------------
-- 文件名:	baseConTrol.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local baseConTrol = class("baseConTrol")

---获取成就数量
function baseConTrol:getChengjiuNum(id)
	local number  = 0
	if id == 1 then
		number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_bat,1) or 0
	elseif id ==2  then
		number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_adsRoleNum,1) or 0
	elseif id ==3  then
		number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_bat,2) or 0
	elseif id == 4  then	
		number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_getZZReward,1) or 0
	elseif id == 5  then		
		number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_QQNum,1) or 0
	elseif id == 6 then			
		number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_fenxNum,1) or 0
	elseif id == 7  or  id == 8 or  id == 9 then
		number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_LoginDate,1) or 0
		
	elseif id == 10  or  id == 11 or  id == 12 then	
		local  index,name = g_baseMsg:mathPlayerRank()
		if index >= id - 7  then
			number = 1
		end 
	
	elseif  id == 13  or  id == 14 or  id == 15  or  id == 16  then
		number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_bat,1) or 0
		local  number2 = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_bat,2) or 0
		number = number + number2
	elseif  id == 17  or  id == 18 or  id == 19 or  id == 20 then
		number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_adsNums,1) or 0
	
	elseif id == 21  or  id == 22 or  id == 23 then	
		local  index,name = g_baseMsg:mathPlayerRank()
		if index >= id - 9  then
			number = 1
			
		end 
	end 
	cclog(number,"====getChengjiuNum=======",id)
	return  number 
end


function baseConTrol:scheduGameTimeOne()
	 g_addCursvTime(1)
	self.onlineTime = self.onlineTime +1
	
	cc.UserDefault:getInstance():setIntegerForKey("onlineTime", self.onlineTime)
end

function baseConTrol:scheduGameTime()
	local wnd = g_WndMgr:getWnd("B_FbBat")
	if not  wnd then
		return 
	end 
	local onlineTime = cc.UserDefault:getInstance():getIntegerForKey("onlineTime", 0)
	self.onlineTime  = onlineTime
	
	local   rootLayout = wnd.rootLayout
	local  itemObj = rootLayout:displayObject()
	self.aseTime = 0
	self.aseTimeAll = 0
	local function CallBack() 
		self:scheduGameTimeOne()
		self.aseTime = self.aseTime + 1
		self.aseTime = self.aseTime % 10
		if  self.aseTime == 0 then
			local curTime = g_getCursvTime() 
			g_svSendMsgControl:request_time(callBack,-30,curGVersion,curTime)
			local value1 = cc.UserDefault:getInstance():getIntegerForKey("Co",0)
			g_batMath.addCoinXY = value1
		end	
		if self.aseTimeAll  == 2 then
			g_svSendMsgControl:request_mail(10)
		end 
		local curMapLev = g_batMath:getMapLev() 
		local number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_newPlayer,7) or 0
		if curMapLev > 2 and number == 0 then
			if self.aseTimeAll  == 30 or self.aseTimeAll % 300 == 0 then
				g_svSendMsgControl:request_msgString(2001)
			end 
		end 
		
		if self.aseTimeAll % 60 == 30 then
			g_roleMsg:reloadRoleBaseAttMsg()
			local value1 = cc.UserDefault:getInstance():getIntegerForKey("Co",0)
			g_batMath.addCoinXY = value1
		end 
		
		
		self.aseTimeAll = self.aseTimeAll+ 1
	end 
	g_scheduleTime:scheduleForever(itemObj,1,CallBack)
end

--注册回调
function baseConTrol:setBaseCallback(nType,func)
	self.BaseCallback[nType] = func
end

--注册回调控件
function baseConTrol:setItemCallback(nType,wnd,tag,item)
	if not self.resItem[nType]  then
		self.resItem[nType] = {}
	end 
	if not self.resItem[nType][wnd]  then
		self.resItem[nType][wnd] = {}
	end 
	self.resItem[nType][wnd][tag] = item
	
	local res = g_baseMsg:getResOfID(nType) or 0
	if nType == g_resCfgId.coin then
		---res =  g_numberData:numberToUnit(res)
	end 
	
	
	if nType == g_resCfgId.coin or nType == g_resCfgId.xueshi  or nType == g_resCfgId.diamond then
		local strLDEndCN = getBigIntByStr2(res) 
		cclog( nType,strLDEndCN,"==setItemCallback==111=",res)
		item:setText(strLDEndCN)
	else
		item:setText(res)
	end 
	
end

function baseConTrol:setBaseMsg(nType,value,add)
	local res = g_baseMsg:getResOfID(nType)
	local strLDEndCN
	if add == 1 then
		res,strLDEndCN = addBigInt(res, value)
	elseif add == -1 then
		res,strLDEndCN = subBigInt(res, value)
	else
		res = value
	end 
	
	 g_baseMsg:setResOfID(nType,res)
	
	if self.BaseCallback[nType]  then
		local func = self.BaseCallback[nType]
		func()
	end 
	--cclog(self.resItem, res,"===setBaseMsg====",nType,value,strLDEndCN)
	if  self.resItem[nType] then
		local tbMsg = self.resItem[nType]
		
		for wnd,v in pairs(tbMsg)do
			local wnd = g_WndMgr:getWnd(wnd)
			if wnd then	
				for i,item in pairs(v)do
					if nType == g_resCfgId.coin or nType == g_resCfgId.xueshi  or nType == g_resCfgId.diamond then
						if not strLDEndCN then
							strLDEndCN = getBigIntByStr2(res) 
							
						end 
						item:setText(strLDEndCN)
						
					else
						item:setText(res)
					end 
					
				end 
			end 
		end 
	end 
end


---判断资源是否足够
function baseConTrol:resEnough(nType,value,notSend)
	local resValue = g_baseMsg:getResOfID(nType) or 0
	cclog(resValue,"====DD=resEnough",value)
	local result = MaxBigInt(  tostring(resValue),tostring(value))
	cclog(result,"=====resEnough",resValue,value)
	if  result ~= true then
		if not notSend then
			local tbMsg = g_cfgMsg:getCfgMsg("goods_D",nType)
			local name =  tbMsg.name
			name = name.."不足"
			g_action:ts_hszz_antion(name)	
			cclog("=====resEnough===1===",value,resValue,nType)
		end 
		return 
	end 
	return true 
end 

---判断材料是否足够
function baseConTrol:GoodsEnough(goodsID,value,notSend)
	local numGoods = g_bagMsg:getGoodsTbMsg(goodsID) or 0
	if  numGoods < value   then
		if not notSend then
			
			local tbMsg = g_cfgMsg:getCfgMsg("goods_D",goodsID)
			cclog(tbMsg,"==22==GoodsEnough======",goodsID)
			local name =  tbMsg.name
			name = name.."不足"
			g_action:ts_hszz_antion(name)	
		end 
		return 
	end 
	return true 
end 

--获取背包格子数
function baseConTrol:getBagMaxNum()
	local tbMsg = g_cfgMsg:getCfgMsg("zz_game_D",17)
	local addValue =  tonumber(tbMsg.value)
	local tbMsg = g_cfgMsg:getCfgMsg("zz_game_D",18)
	local maxValue =  tonumber(tbMsg.value)
	
	local tbMsg = g_cfgMsg:getCfgMsg("zz_game_D",19)
	local baseValue =  tonumber(tbMsg.value)
	
	local number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_buyBagNum,1) or 0
	local  addNum = addValue*number
	local vipValue = baseConTrol:getVipContorl(1)
	
	local value = baseValue + addNum + vipValue
	
	local TbBagEquMsg = g_equMsg:getTbBagEquMsg()
	local curValue = getTbCount(TbBagEquMsg)
	return value,curValue
end

---获取vipx是否开启
function baseConTrol:getVipContorl(vipX)
	local lev,curExp,maxExp = g_baseMsg:getResOfVipLev()
	if lev  < vipX  then
		return 0
	end 
	local cfgMsg2 =  g_cfgMsg:getCfgMsg("VIPLev_D",vipX) 
	return cfgMsg2.value
end 

--计算秒杀钻石
function baseConTrol:mathNeedZsByTime(nTime,maxRation)
	if nTime <= 0  then
		return 0
	end 
	local tbMsg = g_cfgMsg:getCfgMsg("zz_game_D",26)
	local ration1 = tbMsg.value
	local tbMsg = g_cfgMsg:getCfgMsg("zz_game_D",27)
	local ration2 = tbMsg.value
		
	local tbMsg = g_cfgMsg:getCfgMsg("zz_game_D",28)
	local maxValue = tonumber(tbMsg.value)
	
	local value1 = nTime/60
	local value2 = math.pow(value1,ration1)
	local value3 = value2 + ration2
	value3 = value3*2
	value3 = g_roundNumber(value3)
	local maxRation = maxRation or 1
	if value3 > maxValue then
		value3 = maxValue
	end
	return value3
end

----是否开启vip技能
function baseConTrol:isOpenVipLev(lev)
	local Dlev,shengwang,maxExp = g_baseMsg:getResOfVipLev()  
	local value = value or 0
	if Dlev >= lev  then
		local cfgMsg =  g_cfgMsg:getCfgMsg("VIPLev_D",lev) 
		local value1 = cfgMsg.value1
		local value2 = cfgMsg.value2
		return value1, value2
	end 
	return  0,0
end 

function baseConTrol:getMaxBuyTili()
	local value1, value2  = g_baseConTrol:isOpenVipLev(3)
	local value3, value4  = g_baseConTrol:isOpenVipLev(7)
	local base = 3
	value = base + value1 + value4
	return  value
end 

function baseConTrol:getYuekaStatu()
	local status = 0
	local yuekaNum = g_baseMsg:getOther(otherDBMsgID.yuekaNum) or  0
	local yuekaGetTimes = g_baseMsg:getOther(otherDBMsgID.yuekaGetTimes) or  0
	if   yuekaNum <= 0  then
		return 0
	end 
	---是否已领取
	local isGet =  g_bTimeDate(yuekaGetTimes)
	if isGet then
		status = 2
	else
		status = 1
	end 
	return status ,yuekaNum
end


function baseConTrol:geTongxzStatu()
	local status = 0
	local yuekaNum = g_baseMsg:getOther(otherDBMsgID.yuekaTXZNum) or  0
	local yuekaGetTimes = g_baseMsg:getOther(otherDBMsgID.yuekaTXZGetTimes) or  0
	if   yuekaNum <= 0  then
		return 0
	end 
	---是否已领取
	local isGet =  g_bTimeDate(yuekaGetTimes)
	if isGet then
		status = 2
	else
		status = 1
	end 
	return status ,yuekaNum
end

function baseConTrol:ctor()
   self.BaseCallback = {}
   self.resItem = {}
end

g_baseConTrol =  baseConTrol:create()