------------------
-- 文件名:	batContorl.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local batContorl = class("batContorl")
local TimeSchedu = 0.05
local TimeScheduCount = 0

batStatusTypes = {}
batStatusTypes.Bj = 1
batStatusTypes.sb = 2

gameStatus = {}
gameStatus.stop = -1
gameStatus.batIng = 1


ROLESTATUSS = {}
ROLESTATUSS.death = 3

---======其他操作 ===============================
--特效
function batContorl:EffctContorl(index,status)
	--界面操作
	
end
--状态飘字 躲闪暴击等
function batContorl:statusContorl(index,status)
	--界面操作
	if status == batStatusTypes.Bj then
		g_batWndContorl:createStausPiaozi(index,"暴击",22)
	elseif status == batStatusTypes.sb then
		g_batWndContorl:createStausPiaozi(index,"躲闪",5)
	else
		g_batWndContorl:createStausPiaozi(index,status)
	end 
end

---回魔
function batContorl:addMpContorl(roleID,addValue,noPiaozi)
	local info =  g_batTbMsg:getBatInfo(roleID) 
	if info.status  == ROLESTATUSS.death or info.status < 0 then
		return
	end 
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	if not  MaxBigInt(info.maxMp, info.mp)then
		return
	end
	info.mp =  addBigInt(info.mp, addValue)
	if not  MaxBigInt(info.maxMp, info.mp)then
		
		info.mp = info.maxMp
	end 
	
	g_batTbMsg:setBatInfo(info) 
	B_FbBat:setFbMsgPanleRoleMp()
	--界面操作
	if not noPiaozi then
		g_batWndContorl:createHurtPiaozi(roleID,addValue,nil,4)
	end 
end
---回血
function batContorl:zhiliaoContorl(roleID,hurt,isfuho,noPiaozi)
	if not MaxBigInt(hurt, "0") then
		return
	end 
	local info =  g_batTbMsg:getBatInfo(roleID) 
	if isfuho  then
		info.status = 0
	end 
	if info.status  == ROLESTATUSS.death or info.status < 0 then
		return
	end 
	info.hp =  addBigInt(info.hp, hurt)
	if not  MaxBigInt(info.maxHp, info.hp)then
		info.hp = info.maxHp
	end 
	g_batTbMsg:setBatInfo(info) 
	--界面操作
	if not noPiaozi then
		local hurtCN,hurt =  getBigIntByStr(hurt)
		g_batWndContorl:createHurtPiaozi(roleID,hurtCN,nil,3)
	end 
end
---掉血
function batContorl:hurtContorl(roleID,hurt,isBaoji,isMp)
	if not MaxBigInt(hurt, "0") then
		return
	end 
	local info =  g_batTbMsg:getBatInfo(roleID) 
	if not MaxBigInt(info.hp, "0") then
		self:deadContorl(roleID)
		return
	end 
	hurt =  floorBigInt(hurt) 
	info.hp =  subBigInt(info.hp, hurt)
	---info.hp - hurt
	g_batTbMsg:setBatInfo(info) 

	local info =  g_batTbMsg:getBatInfo(roleID) 
	if not MaxBigInt(info.hp, "0") then
		self:deadContorl(roleID)
		
	end 
	--界面操作
	local nType = 1
	if isBaoji then
		nType = 2
	end 
	local hurtCN,hurt =  getBigIntByStr(hurt)
	g_batWndContorl:createHurtPiaozi(roleID,hurtCN,nil,nType)
	if roleID >= 1000 then
		g_batMath:addDpsCount(hurt) 
	end 
end
---死亡
function batContorl:deadContorl(roleID)
	local info =  g_batTbMsg:getBatInfo(roleID) 
	info.status = ROLESTATUSS.death 
	g_batTbMsg:setBatInfo(info) 
	--界面操作
	g_batWndContorl:deatItem(roleID)
	if roleID == 100 then
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		B_FbBat:showMpStatusText()
	elseif roleID < 100 then
		g_batRoleSkillContorl:showSkillFactory(openSkillMsg.death,100,roleID)
		g_batPetSkillContorl:showSkillFactory(openSkillMsg.death,nil,roleID)
	else
		g_countMsg:addTbCount(TBCountKEY.killNum,1)
	end 
	
end
---复活
function batContorl:FuhuoContorl(roleID,hp)
	local info =  g_batTbMsg:getBatInfo(roleID) 
	info.status = 0 
	if hp then
	  info.hp = hp 
	end 
	g_batTbMsg:setBatInfo(info) 
	--界面操作
end
---说话
function batContorl:talkContorl()
	--界面操作
end
---掉钱
function batContorl:dropresContorl()
	--界面操作
end

---======战斗操作 ===============================

--普通攻击操作 --造成伤害
function batContorl:ptAttckContorl(attckId,toAttckId,isSkill,dps,isMp)
	--技能或者普通攻击
	local info =  g_batTbMsg:getBatInfo(attckId) 
	local toinfo =  g_batTbMsg:getBatInfo(toAttckId) 
	
	
	if toAttckId == 500  then
		if not self.tbAtaNum[attckId] then
			self.tbAtaNum[attckId] = 0
		end 
		self.tbAtaNum[attckId] = self.tbAtaNum[attckId] + 1
	end 
	if not toinfo then
		--cclog("=== not toinfo",toAttckId)
		return
	end 
	local hurt
	--是否躲闪
	local jingzhun = g_batTbMsg:getFbRoleJingzhunValue(attckId) 
	local duoshan = g_batTbMsg:getFbRoleDuoshanValue(toAttckId) 
	local isDuoshan = g_batMath:mathDuoshan(jingzhun,duoshan,toAttckId) 
	if  isDuoshan then
		self:statusContorl(toAttckId,batStatusTypes.sb)
		return
	end  
	--是否暴击
	local baoji1 = g_batTbMsg:getFbRoleBaojiValue(attckId) 
	local toBaoji = g_batTbMsg:getFbRoleBaojiValue(toAttckId) 
	local isBaoji = g_batMath:mathBaoji(baoji1,toBaoji)
	local hurt 
	if isSkill then
		hurt =  g_batMath:mathHurtMF(info,toinfo,dps) 
	else
		hurt =  g_batMath:mathHurtWl(info,toinfo,dps) 
	end 
	
	if isBaoji then
		self:statusContorl(attckId,batStatusTypes.Bj)
		hurt = g_batMath:mathHurtBaoji(info,hurt)
	end 
	---cclog("=========hurtContorl======",attckId,toAttckId,isSkill,dps,hurt)
	--伤害操作

	self:hurtContorl(toAttckId,hurt,isBaoji,isMp)
	--是否有吸血
	if info.xiHp and info.xiHp > 0 then
		--治疗操作
		--local hurt1 = addBigInt(hurt,)  
		---local hurtzl = byBigInt(hurt1,"0.01",true)  
		self:zhiliaoContorl(attckId,info.xiHp)
	end 
	if info.xiMp and info.xiMp > 0 then
		-----操作

		self:addMpContorl(100,info.xiMp,true)
	end 
end

--获取目标2 --敌人的目标
function batContorl:getAttckObj2(enemyID,attckNum)
	---是否已有目标 
	local info = g_batTbMsg:getBatInfo(enemyID) 
	local attckObj = {}
	local count = 0
	--if not info.attckObj then
		--info.attckObj = {}
	--end 
	--for i,index  in pairs(info.attckObj )do  --100表示role 其他表示打pet
		--local infoTo = g_batTbMsg:getBatInfo(index) 
		  ---目标是否存活或者可攻击
		--if infoTo then
			--if infoTo.status >= 0 and  info.status ~= ROLESTATUSS.death then  --无敌
			---	count = count+ 1
			--else
			--	info.attckObj[i] = nil
			--end 
		--end 
	--end 	
	local stauts 
	local attckNum = attckNum or info.attckNum
	--cclog(attckNum,"=====getAttckObj2=====")
	--if  count < attckNum then
		local tbObj =  g_batMath:mathFbBatEnemyObj(attckNum)
		for i,Index in pairs(tbObj)do
			if type(Index) == "table" then
				attckObj[Index] = Index[1]
			else
				attckObj[Index] = Index
			end 
			
		end 
	--end 
	--if stauts then
		--g_batTbMsg:setFbEnemyMsg(info) 
	--end 
	return attckObj
end
--获取目标1 --我方--固定目标
function batContorl:getAttckObj1(roleID)
	---是否已有目标 
	local info = g_batTbMsg:getBatInfo(roleID) 
	
	local count = 0
	if not info.attckObj then
		info.attckObj = {}
	end 
	for i,index  in pairs( info.attckObj )do  --100表示role 其他表示打pet
		local infoTo = g_batTbMsg:getBatInfo(index) 
		  ---目标是否存活或者可攻击
		if infoTo.status >= 0 and info.status ~= ROLESTATUSS.death then  --无敌
			count = count+ 1
		else
			info.attckObj[i] = nil
		end 
	end 	
	local stauts 
	if  count < info.attckNum then
		local num = info.attckNum - count
		local tbObj =  g_batMath:mathFbBatRoleObj(num)
		for i,Index in pairs(tbObj)do
			info.attckObj[Index] = Index
		end 
		stauts = true
	end 
	if stauts then
		g_batTbMsg:setBatInfo(info) 
	end 
	return info.attckObj

end

--获取目标1 --我方 ---友军 
function batContorl:getAttckObjFriend(attckNum)
	---是否已有目标 
	local count = 0
	local tbattckObj = {}
	local tbObj =  g_batMath:mathFbBatEnemyObj(attckNum)
	for i,Index in pairs(tbObj)do
		tbattckObj[Index] = Index
	end 	
	return tbattckObj
end


--获取目标1 --我方 --随机
function batContorl:getAttckObjRan(attckNum)
	---是否已有目标 
	local count = 0
	local tbattckObj = {}
	local tbObj =  g_batMath:mathFbBatRoleObj(attckNum)
	for i,Index in pairs(tbObj)do
		tbattckObj[Index] = Index
	end 	
	return tbattckObj
end

--敌人移动
function batContorl:enemyMove(info)
	local item = info.item
	--info.status  = 1
	if  info.status  == 1 then
	--	return info
	end 
	if not item then
		item = g_batWndContorl:createEnemyBaseItem(info.id)
	end 
	local pos = item:getPosition()
	local moveX = info.moveX
	local moveY = info.moveY
	local moveOff = info.moveOff
	local statusX,statusY
	if  pos.y < moveY and pos.y < 745 then
		pos.y = pos.y + 1.5
	else
		statusY = 1
	end 
	if moveOff > 0 and  pos.x < moveX and pos.x < 710 then
		pos.x = pos.x + 0.3
	elseif moveOff < 0 and  pos.x > moveX and pos.x > 0 then
		pos.x = pos.x - 0.3
	else
		statusX = 1
	end
	
	if statusY and statusY  then
		info.status  = 1
	end 
	info.item:setPosition(pos.x,pos.y)
	g_batTbMsg:setFbEnemyMsg(info)
	return info
end
--是否结束
function batContorl:isEnd()
	local info = g_batTbMsg:getBatInfo(100) 
	local result1 ,result2
	if  info then
		if info.status and info.status >= 0 and info.status ~= ROLESTATUSS.death  then
			result1 = true
		end 
	end 
	
	local tbEnemtInfo = g_batTbMsg:getFbEnemyMsg() 
	for i,info in pairs(tbEnemtInfo)do
		if info.status and info.status >= 0 and info.status ~= ROLESTATUSS.death  then
			result2 = true
			break
		end 
	end 
	if not result2 then
		return 1
	end 
	if result1  then
		return
	end 
	
	local tbInfo = g_batTbMsg:getFbPetMsg() 
	for i,info in pairs(tbInfo)do
		if info.status and info.status >= 0 and info.status ~= ROLESTATUSS.death  then
			result1 = true
			break
		end 
	end
	if result1  then
		return
	end 
	return 0
end
---======开始战斗 ===============================

---enemy计时器
function batContorl:enemyItemTimeSchedu(enemyID,speedCount)
	--是否存活
	local info = g_batTbMsg:getBatInfo(enemyID) 
	
	if  info.status and info.status < 0  then
		return
	end 
	if  not info.status  then
		info.status = 0
	end 
	---晕眩和冰冻 
	local tbBufMsg = {70,71,79}
	local stausYX = g_batRoleSkillContorl:getBufByID(enemyID,tbBufMsg)
	if  info.status ~= ROLESTATUSS.death and not stausYX  then
		if enemyID ~= 500   then
			---判断是否到指定位置
			local item = info.item
			if not item then
				item = g_batWndContorl:createEnemyBaseItem(enemyID)
			end 
			local pos = item:getPosition()
			if  info.status == 0 then	
				info = self:enemyMove(info)
				if  not info.talkStatu or info.talkStatu < 1  then
					local stauts = g_batWndContorl:setEnemyTalk(enemyID,EnemyTalkStatus_BatIng)
					info.talkStatu = 1
					g_batTbMsg:setFbEnemyMsg(info) 
				else
					info.talkStatu = (info.talkStatu + 1)%30	
					g_batTbMsg:setFbEnemyMsg(info) 
				end 
				
			end 
		end
		if info.status == 1 then --可攻击  -到达，寻找目标
			---读条计数
			info.count = info.count + speedCount
			g_batTbMsg:setFbEnemyMsg(info) 
			if info.count >= info.speed  then
				local attckObj =  self:getAttckObj2(enemyID)
				---攻击
				info.count = 0
				g_batTbMsg:setFbEnemyMsg(info) 
									
				g_batWndContorl:setEnemyTalk(enemyID,EnemyTalkStatus_BatIng)
				local isSkill =  g_batBOSSSkillContorl:showSkillFactory(openSkillMsg.openSkill,enemyID)
				---cclog(isSkill,"========enemyItemTimeSchedu=======",attckObj)
				if isSkill then
					g_batWndContorl:enemySkillAttckAnima(enemyID)
				else
					for i,toAttckId in pairs(attckObj)do
						self:ptAttckContorl(enemyID,toAttckId,isSkill)
					end 
					g_batWndContorl:enemyAttckAnima(enemyID)
				end 
				
			end 
			
		end 	
	end 

	--状态计数
end
---
---我方计时器
function batContorl:roleItemTimeSchedu(index,speedCount)
	--是否存活可行动
	--是否存活
	local info = g_batTbMsg:getBatInfo(index) 
	--cclog("=====roleItemTimeSchedu=",info.status,index)
	if not info and index < 100  then
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		self:reloadPetMsg(index,true)
		return
	end 
	
	if info.status and info.status < 0  then
		cclog("== info.status=",info.status,index)
		return
	end 
	if  not info.status  then
		info.status = 0
	end
	---晕眩和冰冻
	local tbBufMsg = {70,71}
	local stausYX = g_batRoleSkillContorl:getBufByID(index,tbBufMsg)
	local toBatIndex = {}
	if  info.status ~= ROLESTATUSS.death  and not stausYX then
		---读条计数
		info.count = info.count + speedCount 
		--cclog(info.speed,"====2222=startAllTimeSchedu=====",info.count)
		g_batTbMsg:setBatInfo(info) 
		
		if info.count >= info.speed  then
			---攻击
			g_batRoleSkillContorl:showSkillFactory(openSkillMsg.attackFront,100)
			g_batPetSkillContorl:showSkillFactory(openSkillMsg.attackFront,index)
			info.count = 0
			g_batTbMsg:setBatInfo(info) 
			---是否释放技能
			local isSkill  
			if index <= 700  then
				isSkill =  g_batRoleSkillContorl:showSkillFactory(openSkillMsg.openSkill,index)
				isSkill =  g_batPetSkillContorl:showSkillFactory(openSkillMsg.openSkill,index)
			end 
			local tbBufMsg = {79}
			local nTime = g_batRoleSkillContorl:getBufByID(index,tbBufMsg)
			if not isSkill and not nTime then
				local attckObj =  self:getAttckObjRan(info.attckNum)
				---cclog(attckObj,"====2222=startAllTimeSchedu=====",info.attckNum)
				for i,toAttckId in pairs(attckObj)do
					local function callback()
						self:ptAttckContorl(index,toAttckId)
					end 
					toBatIndex[#toBatIndex+1] = toAttckId
					g_batWndContorl:showAttckEffctItemPool(index,toAttckId,callback)
				end 
			end 
		end 
	end 
	--状态计数
	--计算加速
	if  not  self.TimeScheduSpeed and self.isBossBat  then
		local BOSSSpeed =  cc.UserDefault:getInstance():getIntegerForKey("BOSSSpeed", 1)
		
		local  curMapLev1,maxMapLev1 = g_batMath:getMapLev(1) 
		local  curMapLev,maxMapLev = g_batMath:getMapLev() 
		
		if  BOSSSpeed == 0 and curMapLev > 100  then
			 TimeScheduCount = 0.2
			 local B_FbBat = g_WndMgr:getWnd("B_FbBat")
			 local  textTuanD =  B_FbBat.rootLayout:getChild("textTuanD") 
			 textTuanD:setVisible(true)
			 g_action:ts_hszz_antion("加速开启")
			 self.speeAdd = true
		else
			local B_FbBat = g_WndMgr:getWnd("B_FbBat")
			local  textTuanD =  B_FbBat.rootLayout:getChild("textTuanD") 
			textTuanD:setVisible(false)
			TimeScheduCount = 0
			self.speeAdd  = nil
		end 
		self.TimeScheduSpeed = true
	else
		local info =  g_batTbMsg:getBatInfo(500) 
		if ( not self.isBossBat  or not info  or   info.status == ROLESTATUSS.death ) and TimeScheduCount ~= 0 then
			local B_FbBat = g_WndMgr:getWnd("B_FbBat")
			local  textTuanD =  B_FbBat.rootLayout:getChild("textTuanD") 
			textTuanD:setVisible(false)
			TimeScheduCount = 0
			self.speeAdd  = nil
		end 
	end 
	
end


---战斗计时器
function batContorl:GameItemTimeSchedu()
	--战斗是否结束
	local status = self:isEnd()
	if status then
		---cclog("=====GameItemTimeSchedu=====",status)  
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		if status == 1  then  --下一波
			if self.isBossBat then  --进入下一关
				self.gameStatus = gameStatus.stop
				g_batWndContorl:dropCoin(500,20)
				g_action:ts_hszz_antion("团灭副本玩家,进入下一层",1)
				
				local curMapLev = g_batMath:getMapLev() 
				g_gameMusic:playEffect(24)
				if curMapLev <= 2 then
					g_newGuide:isGuideContorlWnd("B_FbBat")
				end 
				g_batTbMsg:setFbBatMsg(fbBatMsgKey.killEnemyNum,0)
				B_FbBat:setFbMsgPanleBar()
				local info =  g_batTbMsg:getBatInfo(100) 
				local dpsWl = info.dpsWl
				local dpsMf = info.dpsMf
				local baojiHurt = info.baojiHurt
				local Value = addBigInt(dpsWl,dpsMf)
				
				local dpsMf = byBigInt(dpsMf,2)
				local string1 = {tostring(dpsMf),tostring(Value),tostring(baojiHurt)}
				local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
				for i=1,7 do
					local petID = batPatMsg[i] or 0
					if petID > 0 then
						local info = g_batTbMsg:getBatInfo(i) 
						string1[#string1+1] = tostring(i)
						string1[#string1+1] = tostring(info.dpsWl)
					end 
				end 
			
				g_svSendMsgControl:request_msgString(1001,nil,666,value1,string1)
				local curMapLev = g_batMath:getMapLev() 
				g_svSendMsgControl:request_geBatMsg(4,curMapLev)
			else
				--是否要自动挑战boss
				local AutoBossbat = cc.UserDefault:getInstance():getIntegerForKey("AutoBossbat", 1)
				local curMapLev = g_batMath:getMapLev() 
				if curMapLev >= 2 and AutoBossbat == 1 then
					local value = g_batTbMsg:getFbBatMsg(fbBatMsgKey.killEnemyNum)  or 0
					local maxNum = g_batMath:mathFbBatKillMaxNum() 
					if  value >= maxNum  then
						g_batContorl:startBossbat()
					else
						self:createEnemyAll()
					end 
				else
					--cclog("====createEnemyAll=====")
					self:createEnemyAll()
				end 
			end 
		elseif status == 0  then --失败
			local curMapLev = g_batMath:getMapLev() 
			local AutoBossbat = cc.UserDefault:getInstance():getIntegerForKey("AutoBossbat", 1)
			local B_FbBat = g_WndMgr:getWnd("B_FbBat")
			local curWndID = g_WndMgr:getTopWndID()
			g_batTbMsg:setFbBatMsg(fbBatMsgKey.killEnemyNum,0)
			B_FbBat:setFbMsgPanleBar()	
			self:reloadMyRoleMsg(true,true)
			self:reloadSetPetMsg()
			if curMapLev >= 2 and AutoBossbat == 1 and curWndID ~= "B_FbBat"  then
				g_batContorl:initGameMsg()
				return
			end 
			self.gameStatus = gameStatus.stop
			g_action:ts_hszz_antion("你被玩家击杀...",1)
			g_batWndContorl:dropCoinLostAll()
			g_gameMusic:playEffect(23)	
				
		end 
		return
	end  
end

function batContorl:miaoFrameContorl()
	local info = g_batTbMsg:getBatInfo(100) 
	local addHpOne = info.addHpOne or 0
	local addMpOne = info.addMpOne or 0
	
	if  info.status == ROLESTATUSS.death then
		return
	end 
	if addHpOne ~= "0"  or addHpOne ~= 0 then
		self:zhiliaoContorl(100,addHpOne,true)
	end 
	
	if addMpOne ~= "0"  or addMpOne ~= 0 then
		self:addMpContorl(100,addMpOne,true)
	end 
	
end 
---战斗开始，所有计时器启动
function batContorl:startAllTimeSchedu()
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local  mainTitleShcedu =  B_FbBat.rootLayout:getChild("mainTitleShcedu")  
	self.gameStatus = gameStatus.batIng
	local countMiao = 0
	local countMiaoCount = 0
	local countMiaoCountTag = 0
	local function timesCallback()
		if self.gameStatus == gameStatus.stop then
			return
		end 
		
		local speedCount = TimeScheduCount + TimeSchedu
		--cclog(speedCount,"=====startAllTimeSchedu=====")
		self:GameItemTimeSchedu()
		self:roleItemTimeSchedu(100,speedCount)
		g_batRoleSkillContorl:roleBufTime(100,speedCount)
		local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
		local stasu 
		for index,petID in pairs(batPatMsg)do
			if petID > 0 then
				local petAttInfo = g_petMsg:getpetTbMsg(petID)
				--cclog(petAttInfo,petID,"=====startAllTimeSchedu=========")
				if  petAttInfo  then
					self:roleItemTimeSchedu(index,speedCount)
					g_batRoleSkillContorl:roleBufTime(index,speedCount)	
				else
					batPatMsg[index] =  0
					stasu = true
				end 
						
			end 
		end 
		if stasu then
			local tbMsg = g_baseMsg:getTbIntegerTb(tbIntegerKEy.BatPetMsg) or {}
			tbMsg.value = batPatMsg
			g_baseMsg:setTbIntegerByID(tbIntegerKEy.BatPetMsg,tbMsg)
		end 
		---cclog(batPatMsg,"=====startAllTimeSchedu===222======")
		
		local batEnemyMsg = g_batTbMsg:getFbEnemyMsg() or {}	
		for enemyID,info in pairs(batEnemyMsg)do
			if not info.status or   info.status >= 0 then
				self:enemyItemTimeSchedu(enemyID,speedCount)
				g_batRoleSkillContorl:roleBufTime(enemyID,speedCount)
			end 
		end
		countMiao = countMiao + speedCount
		if countMiao > 1 then
			countMiao = 0  ---每秒处理
			self:miaoFrameContorl()
			countMiaoCount = countMiaoCount+1
		end 
		--cclog("=======countMiaoCountTag=====",countMiaoCountTag,countMiaoCount)		
		if countMiaoCount % 15 == 5 and countMiaoCountTag ~=  countMiaoCount then
			--g_mathConTrol:reloadRoleAtt()
			---countMiaoCountTag = countMiaoCount
		end 
	end 
	if self.mainTimerID then
		g_Timer:destroyTimerByID(self.mainTimerID)
	end 
	self.mainTimerID = g_Timer:createLoopTimer(TimeSchedu, nil,timesCallback )
	
end 

local boNum = 0
---创建怪物
function batContorl:createEnemyAll(isInit,isBoss)
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}	
	local curMapLev = fubenMaxLev[1] or 1
	
	local numer =  g_batMath:getEnemyNum() ---tbGameConst.batEnemyNum[mapType]
	if isBoss and curMapLev > 20 then
		numer = numer * 2
	end 

	for i =1,numer do
		local  enemyId = 1000 + i
		self:initEnemyMsg(enemyId)
		--cclog(enemyId,"=====initEnemyMsg====")
	end 
	boNum = boNum + 1
	if not isInit then
		g_batMath:mathHurtDps() 
	end 
	g_batMath:reloadStartCount() 
	
	self:setTuanNum()
end

function batContorl:setTuanNum()
	if not  self.tuanNum then
		self.tuanNum = math.random(100,600)
	end 
	
	self.tuanNum = self.tuanNum + 1
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	B_FbBat:setTextTuan(self.tuanNum )
end

---=====================================

function batContorl:initEnemyBossBaseMsg()
	
	local valueDps = g_batMath:mathFbBatEnemyDps(true)
	local value = g_batMath:mathFbBatEnemyDef(true)
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.Dps,valueDps) 
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.Def,value) 
	
	local value = g_batMath:mathFbBatEnemyHp(true)
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.MaxHp,value) 
	
	local value = g_batMath:mathFbBatEnemyBJ(true)
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.BJ,value) 
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.sb,value) 

	local value = g_batMath:mathFbBatEnemyJZ(true)
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.JZ,value) 
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.attckNum,2) 
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.speed,0.5) 
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.skillRation,10) 
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.attValue,{}) 
	local value,lev = g_batMath:mathFbBatEnemyRes()
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.lev,lev) 
	g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.dorpRes,value) 
	
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local curMapLev = cc.UserDefault:getInstance():getIntegerForKey("curMapLev"..mapType, 1)
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}	
	local BOSSNameID = cc.UserDefault:getInstance():getIntegerForKey("BOSSNameID"..mapType, 0)
	local MapLev = fubenCurLev[mapType] or 1
	local  BOSSZhiye,BOSSSkill
	---cclog(curMapLev,MapLev,BOSSNameID,"==2222===curMapLev====")
	if  curMapLev ~= MapLev or BOSSNameID == 0 then
		BOSSNameID =  math.random(1001,1073)
		g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.BOSSNameID,BOSSNameID) 
		BOSSZhiye =  math.random(1,26)
		g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.BOSSZhiye,BOSSZhiye) 
		local tbMap =  g_cfgMsg:getCfgMsg("enemy_D",BOSSZhiye)
		BOSSSkill =   tbMap.zdSkill
		g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.BOSSSkill,BOSSSkill) 
		cc.UserDefault:getInstance():setIntegerForKey("BOSSNameID"..mapType, BOSSNameID)
		cc.UserDefault:getInstance():setIntegerForKey("BOSSZhiye"..mapType, BOSSZhiye)
		cc.UserDefault:getInstance():setIntegerForKey("BOSSSkill"..mapType, BOSSSkill)
		cc.UserDefault:getInstance():setIntegerForKey("curMapLev"..mapType,MapLev)
		cclog(BOSSZhiye,BOSSSkill,"=====BOSSZhiye=======111======")
	else
		BOSSNameID = cc.UserDefault:getInstance():getIntegerForKey("BOSSNameID"..mapType, 0)
		BOSSZhiye = cc.UserDefault:getInstance():getIntegerForKey("BOSSZhiye"..mapType, 0)
		g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.BOSSNameID,BOSSNameID)
		g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.BOSSZhiye,BOSSZhiye)
		
		local tbMap =  g_cfgMsg:getCfgMsg("enemy_D",BOSSZhiye)
		BOSSSkill =   tbMap.zdSkill
		
		cclog(BOSSZhiye,BOSSSkill,"=====BOSSZhiye=============")
		g_batTbMsg:setFbEnemyBossBaseMsg(EnemyBaseMsgKey.BOSSSkill,BOSSSkill)
	end 
	

	return BOSSNameID
end 


function batContorl:initEnemyBaseMsg()
	local valueDps = g_batMath:mathFbBatEnemyDps()
	local value = g_batMath:mathFbBatEnemyDef()
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.Dps,valueDps) 
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.Def,value) 
	
	local value = g_batMath:mathFbBatEnemyHp()
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.MaxHp,value) 
	
	local value = g_batMath:mathFbBatEnemyBJ()
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.BJ,value) 
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.sb,value) 

	local value = g_batMath:mathFbBatEnemyJZ()
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.JZ,value) 
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.attckNum,2) 
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.speed,3) 
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.skillRation,10) 
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.attValue,{}) 
	local value,lev = g_batMath:mathFbBatEnemyRes()
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.lev,lev) 
	g_batTbMsg:setFbEnemyBaseMsg(EnemyBaseMsgKey.dorpRes,value) 
end 


function batContorl:initEnemyBossMsg()
	local enemyId = 500 
	local info = g_batTbMsg:getBatInfo(enemyId)  or {}
	local value = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.MaxHp) or g_batMath:mathFbBatEnemyHp()
	local maxAttNum = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.attckNum) or 1
	value = floorBigInt(value) 
	info.maxHp = value
	info.hp  = value
	--info.id  = enemyId
	info.index  = enemyId
	info.status  = 1
	info.bj = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.BJ) 
	info.jz = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.JZ) 
	info.sb = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.sb) 
	info.attckNum = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.attckNum) or math.random(1,maxAttNum)
	
	info.dpsWl  = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.Dps) 
	info.dpsMf  = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.Dps) 
	info.defWL  = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.Def) 
	info.defMf  = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.Def) 
	info.speed  = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.speed) 
	info.attHurt  = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.attValue)  
	info.attHurtDef  = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.attValue)  
	info.count = 0
	info.attckHurt = {}
	info.attckBjHurt = {}
	info.bufMsg = {}
	g_batTbMsg:setFbEnemyMsg(info)
	---g_batWndContorl:createEnemyBaseItem(enemyId)
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	B_FbBat:setFbMsgPanleEnemy100()
	g_batWndContorl:cleanItemBuf(enemyId)
	g_batWndContorl:setWndHp(enemyId)
end 

function batContorl:initEnemyMsg(enemyId)
	
	local info = g_batTbMsg:getBatInfo(enemyId)  or {}
	local value = g_batMath:mathFbBatEnemyHp()
	local maxAttNum = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.attckNum) or 1
	value = floorBigInt(value) 
	info.maxHp = value
	info.hp  = value
	--info.id  = enemyId
	info.index  = enemyId
	info.status  = 0
	info.bj = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.BJ) 
	info.jz = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.JZ) 
	info.sb = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.sb) 
	info.attckNum = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.attckNum) or math.random(1,maxAttNum)
	
	info.dpsWl  = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.Dps) 
	info.dpsMf  = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.Dps) 
	info.defWL  = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.Def) 
	info.defMf  = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.Def) 
	info.speed  = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.speed) 
	info.attHurt  = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.attValue)  
	info.attHurtDef  = g_batTbMsg:getFbEnemyBaseMsg(EnemyBaseMsgKey.attValue)  
	info.count = 0
	info.talkStatu = 0
	info.attckHurt = {}
	info.attckBjHurt = {}
	info.bufMsg = {}
	local mapLev = g_batMath:getMapLev() 
	if mapLev > 31 then
		mapLev = 31
	end 
	local EnemyName = math.random(1,mapLev) 
	
	info.EnemyName = EnemyName
	
	g_batTbMsg:setFbEnemyMsg(info)
	g_batWndContorl:createEnemyBaseItem(enemyId)
	g_batWndContorl:cleanItemBuf(enemyId)
	g_batWndContorl:setWndHp(enemyId)
end 
function batContorl:reloadPetMsg(index,reload,noReloadWnd)
	local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	local petID = batPatMsg[index] or 0
	--cclog(index,type(index),"===batPatMsg=====",batPatMsg)
	if petID <= 0 then
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		g_batTbMsg:delFbPetMsg(index) 
		--cclog("====delFbPetMsg======",index)
		B_FbBat:setFbMsgPanleCW(index)
		return
	end 
	local info = g_batTbMsg:getFbPetMsg(index) or   g_petMsg:getpetTbMsg(petID)
	local petAttInfo = g_petMsg:getpetTbMsg(petID)
	if not petAttInfo  then
		 g_batTbMsg:delFbPetMsg(index) 
		return
	end 
	local zhizi = g_petMsg:getPetZZ(petID)  
	local value = g_mathConTrol:mathPetBaseAtt(petAttInfo.Level,3,zhizi,petID) 
	value = floorBigInt(value) 
	info.maxHp = value
	 ---cclog(value,index,"=====value====",petAttInfo.Level,3,zhizi,petID)
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	if not info.hp or reload  then	
		--info.id = index
		info.hp  = value
		info.index = index
		info.bj = g_mathConTrol:mathPetAttCe(petAttInfo,petAttCeMsg.baoji)
		info.jz = g_mathConTrol:mathPetAttCe(petAttInfo,petAttCeMsg.jinzun)
		info.sb = g_mathConTrol:mathPetAttCe(petAttInfo,petAttCeMsg.duoshan)
		info.attckNum = g_mathConTrol:mathPetAttCe(petAttInfo,petAttCeMsg.attckNum)
		
		info.dpsWl  = g_mathConTrol:mathPetBaseAtt(petAttInfo.Level,1,zhizi,petID,true) 
		info.dpsMf  = info.dpsWl
		info.defWL  = g_mathConTrol:mathPetBaseAtt(petAttInfo.Level,2,zhizi,petID,true) 
		info.defMf  = info.defWL
		
		local speed = g_batMath:mathSpeed(g_mathConTrol:mathPetBaseAtt(petAttInfo.Level,4,zhizi,petID),1 )
		info.speed  = speed
		info.chouhen = g_mathConTrol:mathPetBaseAtt(petAttInfo.Level,5,zhizi,petID,true) 
		local cfgID = info.cfgID
		local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID) 
		local lyvalue = g_lyInfoMsg:mathZhongzhuValueAtt(cfgMsg.zhongzhu,6)
		info.baojiHurt  = 150 + lyvalue
		--info.attHurt  = {}--math.floor(petAttInfo.Level/2)
		---info.attHurtDef[]  =              math.floor(petAttInfo.Level/2)
		for indexD=1,4 do
			info.attHurt  =  {}
			info.attHurtDef  =  {}
			
			info.attHurt[indexD] = g_petMsg:mathPetAttHurt(indexD)
			info.attHurtDef[indexD]  =  g_petMsg:mathPetAttHurt(indexD)
		end 
		info.count = 0
		info.status = 0
		info.bufMsg = {}
		
		if not  noReloadWnd then
			B_FbBat:setFbMsgPanleCW(index)	
			local item = g_batWndContorl:getItem(index)
			local c1 =  item:getController("c1") --控制器
			c1:setSelectedIndex(0)	
		end 
		
	else
		B_FbBat:setFbMsgPanlePetHp(index)
	end 
	g_batTbMsg:setFbPetMsg(info) 
	return info
end 

--有外部有数值改变时  查看监听的操作
function batContorl:reloadMyRoleMsg(reload,noRelodItem)
	local info = g_batTbMsg:getFbRoleMsg() 
	local mp = g_roleMsg:getRoleAttValue(16)
	local hp = g_roleMsg:getRoleAttValue(15)
	hp = floorBigInt(hp) 
	info.maxMp = mp
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	info.maxHp = hp
	if not info.hp or reload  then
		--info.id = 100
		info.index  = 100
		info.cfgID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
		info.mp  = mp
		info.hp  = hp
		info.bj = g_roleMsg:getRoleAttValue(RoleAttMsg.baoji,true)
		info.jz = g_roleMsg:getRoleAttValue(RoleAttMsg.jingzun,true)
		info.sb = g_roleMsg:getRoleAttValue(RoleAttMsg.shanbi,true)
		info.attckNum = g_roleMsg:getRoleAttValue(RoleAttMsg.attckNum,true)
		---cclog("====getRoleAttValue=======",info.jz,info.sb )
		info.dpsWl  = g_roleMsg:getRoleAttValue(RoleAttMsg.wlDps,nil,true)
		info.dpsMf  = g_roleMsg:getRoleAttValue(RoleAttMsg.mfDps,nil,true)
		info.defWL  = g_roleMsg:getRoleAttValue(RoleAttMsg.wlDef,true)
		info.defMf  = g_roleMsg:getRoleAttValue(RoleAttMsg.mfDef,true)
		info.chouhen  = g_roleMsg:getRoleAttValue(RoleAttMsg.chouhen,true)
		info.kangyun  = g_roleMsg:getRoleAttValue(RoleAttMsg.kangyun)
		
		local speed = g_batMath:mathSpeed(g_roleMsg:getRoleAttValue(RoleAttMsg.speed,1))
		info.speed  = speed
		--cclog(speed,"=======info.speed====")
		for i=1,4 do
			info.attHurt  =  {}
			info.attHurtDef  =  {}
			local id = RoleAttMsg.hyHurt + 1-i
			local id2 = RoleAttMsg.hyKang + 1-i
			info.attHurt[i] = g_roleMsg:getRoleAttValue(id)
			info.attHurtDef[i]  =   g_roleMsg:getRoleAttValue(id2)
		end 
		
		info.fantan  = g_roleMsg:getRoleAttValue(RoleAttMsg.fantan,1)
		info.chuanjia  = g_roleMsg:getRoleAttValue(RoleAttMsg.chuanjia,1)
		info.fashang  = g_roleMsg:getRoleAttValue(RoleAttMsg.fashang,1)
		info.baojiHurt  =  g_roleMsg:getRoleAttValue(RoleAttMsg.baojiHurt,1)
		info.xiHp  = g_roleMsg:getRoleAttValue(RoleAttMsg.xiHp,1)
		info.xiMp  = g_roleMsg:getRoleAttValue(RoleAttMsg.xiMp,1)
		
		info.addHpOne  = g_roleMsg:getRoleAttValue(RoleAttMsg.addHpOne,1,true)
		cclog("==mathBaseAttMsg====22=DD====",zizhi,addHpOne)
		info.addMpOne  = g_roleMsg:getRoleAttValue(RoleAttMsg.addMpOne,1,true)
		info.jngl  = g_roleMsg:getRoleAttValue(RoleAttMsg.jngl,1)
		
		info.kangyun  = g_roleMsg:getRoleAttValue(RoleAttMsg.kangyun,1)
		info.chouhen  = g_roleMsg:getRoleAttValue(RoleAttMsg.chouhen,1)
		
		
		info.status = 0
		info.count = 0
		info.bufMsg = {}
		if not  noRelodItem then
			g_batTbMsg:setFbRoleMsg(info) 
			B_FbBat:setFbMsgPanleMyRole()
			g_batWndContorl:cleanItemBuf(100)
		end 
	else
		g_batTbMsg:setFbRoleMsg(info) 
		B_FbBat:setFbMsgPanleMyRole()
	end 
	
end 
--注册
function batContorl:registerGameMsg()
	if  self.registerFuc then
		return
	end 
	self.registerFuc = 1
	g_roleAttConTrol:registerAttLisenerFunc(15,"B_FbBat",handler(self, self.reloadMyRoleMsg))	
	g_roleAttConTrol:registerAttLisenerFunc(16,"B_FbBat",handler(self, self.reloadMyRoleMsg))
end 
--重置其他数据
function batContorl:initGameOthersMsg()
	g_batTbMsg:cleanFbEnemyMsg() 
	for i,ID in pairs(fbBatMsgKey)do
		g_batTbMsg:setFbBatMsg(ID,nil) 
	end 
end

function batContorl:reloadPet()
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	for i=1,7 do
		local petID = batPatMsg[i] or 0
		if petID > 0 then
			self:reloadPetMsg(i,true)
		end 
		B_FbBat:setFbMsgPanleCW(i)
	end 
end 

---进入boss战
function batContorl:startBossbat()
	--重置数据
	g_batTbMsg:cleanFbEnemyMsg()
	self.isBossBat = true	
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	for i=1,7 do
		local petID = batPatMsg[i] or 0
		if petID > 0 then
			self:reloadPetMsg(i,true)
		end 
		B_FbBat:setFbMsgPanleCW(i)
	end 
	---cclog("======startBossbat========")
	local BossNameID = self:initEnemyBossBaseMsg()
	self:initEnemyBossMsg()
	self:initEnemyBaseMsg()
	self:registerGameMsg()
	self:reloadMyRoleMsg(true)
	self:createEnemyAll(true,true)
	
	for i,v in pairs(self.tbAtaNum)do
		self.tbAtaNum[i] = 0
	end 
	self:startAllTimeSchedu()
	
	g_batWndContorl:initTopPanel()
	---进入BOSS
	local cfgMsg =  g_cfgMsg:getCfgMsg("enemyName_D",BossNameID) 
	local curWndID = g_WndMgr:getTopWndID()
	if curWndID == B_FbBat  then
		g_action:ts_hszz_antion(cfgMsg.name.."带队来袭",1)
	end 
	
	B_FbBat:startBatPanle(1)
	self.TimeScheduSpeed = nil

	local  textTuanD =  B_FbBat.rootLayout:getChild("textTuanD") 
	textTuanD:setVisible(false)
	g_batTbMsg:setFbBatMsg(fbBatMsgKey.killEnemyNum,0)
	B_FbBat:setFbMsgPanleBar()
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local skillPanle =  B_FbBat.rootLayout:getChild("skillPanle") 
	skillPanle:removeChildren()
end

function batContorl:reloadSetPetMsg()
	local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	for i=1,7 do
		local petID = batPatMsg[i] or 0
		if petID > 0 then
			self:reloadPetMsg(i,true,true)
		end 
	end 
end 
function batContorl:initGameMsg()
	TimeScheduCount = 0
	g_batTbMsg:cleanFbEnemyMsg() 
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	for i=1,7 do
		local petID = batPatMsg[i] or 0
		if petID > 0 then
			self:reloadPetMsg(i,true)
		end 
		B_FbBat:setFbMsgPanleCW(i)
	end 
	self.isBossBat = nil
	self:initEnemyBaseMsg()
	self:registerGameMsg()
	self:reloadMyRoleMsg(true)
	self:createEnemyAll(true)
	
	self:startAllTimeSchedu()
	
	g_batWndContorl:initTopPanel()
	B_FbBat:startBatPanle(0)

	self.TimeScheduSpeed = nil
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local  textTuanD =  B_FbBat.rootLayout:getChild("textTuanD") 
	textTuanD:setVisible(false)
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local skillPanle =  B_FbBat.rootLayout:getChild("skillPanle") 
	skillPanle:removeChildren()
end 

function batContorl:ctor()
	self.tbAtaNum = {}
end

g_batContorl =  batContorl:create()