------------------
-- 文件名:	gNodeConTrol.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local gNodeConTrol = class("gNodeConTrol")

function gNodeConTrol:setGoodsDecItem(decItem,cfgID,num,noBtn)
	local textNum = decItem:getChild("textNum") 
	local num = num or g_bagMsg:getGoodsTbMsg(cfgID) or 0
	textNum:setText("数量："..num)
	local textGoodsName = decItem:getChild("textGoodsName") 
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(textGoodsName,colorID,true)
	textGoodsName:setText(name)
	local textDec = decItem:getChild("textDec") 
	textDec:setText(tbMsg.dec)
	cc.g_setTextColor(textDec,colorID,true)
	local TextGoodsType = decItem:getChild("TextGoodsType")
	TextGoodsType:setText("道具")	
	local TextNeedlev = decItem:getChild("TextNeedlev")
	TextNeedlev:setVisible(false)
	local btn = decItem:getChild("btn")
	if tbMsg.showBtn == 1 and not noBtn then
		btn:setVisible(true)
		btn:setText("使用")
		
		local function funcEndCallBack()
			g_svSendMsgControl:request_getBagMsg(10,cfgID)
		end 
		g_SetBtnOne(nil,nil,1, funcEndCallBack,btn)
	else
		btn:setVisible(false)
	end
	local c1 =  decItem:getController("c1") --控制器
	if tbMsg.yanse > 0 then
		c1:setSelectedIndex(1)
		
		local function funcEndCallBack()
			g_svSendMsgControl:request_getBagMsg(12,cfgID)
		end 
		g_SetBtnOne(decItem,"btn5",1, funcEndCallBack)
		
	else
		c1:setSelectedIndex(0)
	end 
	
	return num
end 

function gNodeConTrol:setRuneDecItem(decItem,cfgID,num)
	local textNum = decItem:getChild("textNum") 
	local num = num or g_bagMsg:getRuneTbMsg(cfgID)
	textNum:setText("数量："..num)
	local textGoodsName = decItem:getChild("textGoodsName") 
	local name,yanse,tbEquMsg = g_getNameConTrol:getAllMsg(cfgID)
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(textGoodsName,colorID,true)
	textGoodsName:setText(name.."Lv."..tbEquMsg.lev)
	local textDec = decItem:getChild("textDec")
	local value,addVa =  g_mathConTrol:mathFWValue(cfgID)
	textDec:setText(tbEquMsg.dec.."(天赋+"..addVa..")")
	local TextGoodsType = decItem:getChild("TextGoodsType")
	TextGoodsType:setText("符文")	
	cc.g_setTextColor(textDec,colorID,true)
	local btn = decItem:getChild("btn")
	
	local tbMsg =  g_cfgMsg:getCfgMsg("rune_D",cfgID)
	if tbMsg.nextKey <= 0  then
		btn:setVisible(false)
	else
		btn:setVisible(true)
		btn:setText("合成")
		local function funcEndCallBack()
			--合成 5 合一
			local num = num or g_bagMsg:getRuneTbMsg(cfgID)
			if num < 5 then
				g_action:ts_hszz_antion("合成需要5个")
				return
			end 
			g_svSendMsgControl:request_getBagMsg(4,cfgID)
		end 
		g_SetBtnOne(nil,nil,1, funcEndCallBack,btn)
	end 

	local TextNeedlev = decItem:getChild("TextNeedlev")
	TextNeedlev:setVisible(false)
end 

function gNodeConTrol:setPetSkillDecItem(decItem,cfgID,num)
	local textNum = decItem:getChild("textNum") 
	local num = num or g_bagMsg:getpetSkillTbMsg(cfgID)
	textNum:setText("数量："..num)
	local textGoodsName = decItem:getChild("textGoodsName") 
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(textGoodsName,colorID,true)
	local lev = g_bagMsg:getpetSkillTbMsgLev(cfgID) or 1
	textGoodsName:setText(name)
	local textDec = decItem:getChild("textDec")
	
	local tb_Str = {"x","y","z"}
	local tb_number = g_mathConTrol:mathPetSkillValue(lev,cfgID)
	local dec = cc.g_inalienContentByTbNumber(tbMsg.dec,tb_Str,tb_number)
	
	textDec:setText(dec)	
	cc.g_setTextColor(textDec,colorID,true)
	local TextGoodsType = decItem:getChild("TextGoodsType")
	TextGoodsType:setText("技能")	
	
	local btn = decItem:getChild("btn")
	btn:setVisible(true)
	btn:setText("吞噬")
	local TextNeedlev = decItem:getChild("TextNeedlev")
	TextNeedlev:setVisible(true)
	local needLev = g_mathConTrol:mathPetSkillNeedLev(lev)
	if needLev > 0 then
		TextNeedlev:setText("需求等级："..needLev)
	else
		TextNeedlev:setText("")
	end 

	local function funcEndCallBack()
		g_svSendMsgControl:request_getPetMsg(11,cfgID)
	end 
	g_SetBtnOne(nil,nil,1, funcEndCallBack,btn)
	
end 

function gNodeConTrol:setEquDecItem(EquDecItem,Info,noSetbtn)
	local textEqu = EquDecItem:getChild("textEqu") 
	local name,yanse,tbEquMsg = g_getNameConTrol:getAllMsg(Info.cfgID)
	local colorID = G_tb_TextColor[Info.yanse]
	cc.g_setTextColor(textEqu,colorID,true)
	textEqu:setText(name)
	local textLev = EquDecItem:getChild("textLev") 
	textLev:setText("Lv."..Info.zbLev)
	
	local textEquDec = EquDecItem:getChild("textEquDec") 
	textEquDec:setText(tbEquMsg.dec)
	
	local textType = EquDecItem:getChild("textType") 
	textType:setText(g_tb_zhuangbeiType_cn[tbEquMsg.nType])
	
	local textPinfen = EquDecItem:getChild("textPinfen") 
	local pinfen = g_mathConTrol:mathEquPoint(Info.id)
	textPinfen:setText("评分："..pinfen)
	---================主属性============
	local textAttRation = EquDecItem:getChild("textAttRation") 

	for i=1,2 do 
		local textMainLev = EquDecItem:getChild("textMainLev"..i) 
		local textMainAtt = EquDecItem:getChild("textMainAtt"..i) 
		local attLev = Info.mainAttLev[i]
		local ration = g_mathConTrol:mathEquMaintAttRation(attLev,Info.cfgID,i,Info.yanse)
		textAttRation:setVar("value"..i,tostring(ration)) 	
		local attID = tbEquMsg["attID"..i]
		local value = g_mathConTrol:mathEquMaintAtt(Info.zbLev,Info.cfgID,attID,ration)
		local AttName = g_getNameConTrol:getAttName(attID)
		textMainAtt:setText(AttName..":"..value)
		textMainLev:setIcon(g_iconConTrol:getABCDIcon(attLev))
		
	end 
	textAttRation:flushVars()
	
	---=========副属性===================
	local aqLev = 0
	if not Info.QHAttLev then
		Info.QHAttLev = {}
	end 
	for i=1,7 do
		local textQHAtt = EquDecItem:getChild("textQHAtt"..i) 
		local attID = Info.QHAttID[i] or 0
		if  attID <= 0 then
			textQHAtt:setVisible(false)
		else	
			textQHAtt:setVisible(true)
			local QHAttLev = Info.QHAttLev[i] or 0
			aqLev = aqLev + QHAttLev
			
			local ration = g_mathConTrol:mathEquCecAttRaton(QHAttLev,Info.cfgID)
			local value = g_mathConTrol:mathEquCecAtt(Info.zbLev,Info.cfgID,attID,ration)
			local name,dec = g_getNameConTrol:getAttName(attID,value)
			textQHAtt:setText(dec)
			local colorID = G_tb_TextColor[QHAttLev]
			
			cc.g_setTextColor(textQHAtt,colorID,true)
		end 
	end 
	local textLevQH = EquDecItem:getChild("textLevQH") 
	if aqLev and aqLev > 0 then
		textLevQH:setText("A"..aqLev)
	else
		textLevQH:setText("")
	end 
	
	
	---=========符文===================
	local fuwenText = EquDecItem:getChild("fuwenText") 
	local count = 0
	if not Info.runeMsg then
		Info.runeMsg = {}
	end 
	for i=1,6 do
		local itemFW = EquDecItem:getChild("itemFW"..i) 
		local title = itemFW:getChild("title") 
		local FWID = Info.runeMsg[i] or 0
		if i > Info.runeNum then
			itemFW:setVisible(false)
		else	
			itemFW:setVisible(true)
			if FWID <= 0   then
				title:setText("")
				itemFW:setIcon(g_iconConTrol:getFWYanseIcon(0))
			else
				count = count+ 1
				local name,yanse,tbMsg,baseName = g_getNameConTrol:getAllMsg(FWID)
				--cclog("=====tbMsg======",FWID,tbMsg)
				local name,dec = g_getNameConTrol:getAttName(tbMsg.attID,tbMsg.value)
				local str = g_mathConTrol:mathFWValueDec(FWID)
				title:setText(str)
				
				local colorID = G_tb_TextColor[yanse]
				cc.g_setTextColor(title,colorID,true)
				itemFW:setIcon(g_iconConTrol:getFWYanseIcon(yanse))
			end 
		end 
		
	end 
	fuwenText:setVar("value1",tostring(count)) 	
	fuwenText:setVar("value2",tostring(Info.runeNum)) 
	fuwenText:flushVars()
	
	---=============================================

	local iconClock = EquDecItem:getChild("iconClock") 
	local btnTake = EquDecItem:getChild("btnTake") 
	local btnClock = EquDecItem:getChild("btnClock") 
	if Info.isClock and Info.isClock == 1 then
		iconClock:setVisible(true)
		btnClock:setText("解锁")
		btnClock:setGrayed(true)
	else
		iconClock:setVisible(false)	
		btnClock:setText("锁定")
		btnClock:setGrayed(false)
	end 
	local c3 =  EquDecItem:getController("c3") --控制器
	local c1 =  EquDecItem:getController("c1") --控制器
	if Info.inRole and Info.inRole > 0  then
		c1:setSelectedIndex(1)
		c3:setSelectedIndex(1)
	elseif Info.isNew and Info.isNew > 0  then
		c1:setSelectedIndex(2)
		c3:setSelectedIndex(0)
		Info.isNew = 0
		g_zbMsg:setEuqTbMsg(Info)  
	else
		c1:setSelectedIndex(0)
		c3:setSelectedIndex(0)
	end 

	local function funcEndCallBack(btn,tag) 
		cclog("======funcEndCallBack======",tag)
		
		if tag == 1  then --分解
			--是否锁定
			if Info.isClock and Info.isClock == 1 then
				g_action:ts_hszz_antion("装备锁定")
				return
			end 
			--是否有铭文
			local runeMsg = Info.runeMsg or {}
			local staus 
			for i,v in pairs(runeMsg)do
				if  v > 0 then
					staus = true
					break
				end 
			end

			if staus  then
				local tbQDMsg = {}
				tbQDMsg.dec =  "装备中镶嵌有符文，是否继续分解"
				tbQDMsg.text1 = "确定"
				tbQDMsg.text2 = "取消"
				local function callBack()
					g_svSendMsgControl:request_getEquMsg(8,Info.id)
				end 
				tbQDMsg.qdFunc =  callBack
				g_quedingItem:openWnd(tbQDMsg) 
			else
				g_svSendMsgControl:request_getEquMsg(8,Info.id)
			end 
		elseif  tag == 2  then --锁定
			g_svSendMsgControl:request_getEquMsg(5,Info.id)
		elseif  tag == 3  then
			g_WndMgr:showWnd("C_EquContorl",1,Info.id)
			
		elseif  tag == 4  then
			g_WndMgr:showWnd("C_EquContorl",0,Info.id)
		elseif  tag == 5  then
			g_WndMgr:showWnd("C_EquContorl",2,Info.id)
		
		elseif  tag == 6  then --穿戴
			local tag = 6
			if   Info.inRole and Info.inRole > 0 then
				tag = 7
			end 
			g_svSendMsgControl:request_getEquMsg(tag,Info.id)
	
		end
	end 
	g_SetBtnOne(EquDecItem,"btnFJ",1, funcEndCallBack)
	g_SetBtnOne(EquDecItem,"btnClock",2, funcEndCallBack)
	g_SetBtnOne(EquDecItem,"btnQH",3, funcEndCallBack)
	g_SetBtnOne(EquDecItem,"btnXQ",4, funcEndCallBack)
	g_SetBtnOne(EquDecItem,"btnLevUp",5, funcEndCallBack)
	g_SetBtnOne(EquDecItem,"btnTake",6, funcEndCallBack)
	
	local c2 =  EquDecItem:getController("c2") --控制器

	if tbEquMsg.nameT2 then
		c2:setSelectedIndex(1)
		local num = g_roleMsg.tbTaozMsg[tbEquMsg.nTaozhuangType] or 0
		for i=1,3 do
			local SkillID = tbEquMsg.taoSkill 
			local cfgMsg =  g_cfgMsg:getCfgMsg("zhuangbeiSkill_D",SkillID)
			local open_num = cfgMsg["open_num"..i] or 0
			--local tbOpenMsg  = cc.g_inalienContentByCfgMsg(open_num, 1, "_")
			local textTDec = EquDecItem:getChild("textTDec"..i) 
			if  open_num > 0 then
				local tb_Str = {"x"}
				local tb_number = {cfgMsg["value"..i]}
				local dec = cc.g_inalienContentByTbNumber(cfgMsg.decText1,tb_Str,tb_number)  
				local nameStr = "("..open_num.."件套):"..dec
				textTDec:setText(nameStr)
				if Info.inRole and Info.inRole > 0 then --计算套装
					if open_num > 0 and num >= open_num then
						cc.g_setTextColor(textTDec,21,true)
					else
						cc.g_setTextColor(textTDec,1,true)
					end 
				end 
			else
				textTDec:setText("")
			end 
			
		end 
	else
		c2:setSelectedIndex(0)
	end 

end 
------------===================================================================


function gNodeConTrol:setListItemCw(obj,petID,touchFuc)
	local info = g_petMsg:getpetTbMsg(petID)
	if not obj or not info then
		return
	end 
	local  title =  obj:getChild("title") 
	local  icon =  obj:getChild("icon") 
	icon:setIcon(g_iconConTrol:getPetYanseIcon(info.yanse))
	local cfgID = info.cfgID
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID) 
	title:setText(cfgMsg.name)
	
	local  barExp =  obj:getChild("barExp")
	local maxExp = g_mathConTrol:mathPetMaxExp((info.starLev or 0) +1)
	barExp:setValue(info.nExp or 0)
	barExp:setMax(maxExp)
	
	local  iconBg = obj:getChild("iconBg") 
	obj:setIcon(g_iconConTrol:getPetYanseIcon(info.yanse))
	iconBg:setIcon(g_iconConTrol:getPetYanseBgIcon(info.yanse))
	local  textZZ =  obj:getChild("textZZ") 
	local  textLev =  obj:getChild("textLev") 
	local  skillText =  obj:getChild("skillText") 
	
	local colorID = G_tb_TextColor[info.yanse]

	cc.g_setTextColor(textZZ,colorID,true)
	cc.g_setTextColor(textLev,colorID,true)
	cc.g_setTextColor(skillText,colorID,true)
	textZZ:setText("资质："..g_petMsg:getPetZZ(info.id))
	textLev:setText("等级："..info.Level)

	local  starText =  obj:getChild("starText")
	starText:setText(G_tb_starText[(info.starLev or 0)])

	local count  = 0
	for i=1,info.skillNum do
		if  info.skillMsg[i] and  info.skillMsg[i].id > 0 then
			count = count+1
		end 
	end 
	
	skillText:setText("技能：("..count.."/"..info.skillNum..")")

	local function funcEndCallBack(btn,tag) 
		touchFuc()
	end 
	if touchFuc then
		g_SetBtnOne(obj,"touchItem",1,funcEndCallBack)	
	end 
	
	local c1 =  obj:getController("c1") --控制器
	if petID == self.cutTouchID  then
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
	
	local iconClock =  obj:getChild("iconClock")
	
	if info.isClock and  info.isClock > 0 then
		iconClock:setVisible(true)
	else
		iconClock:setVisible(false)
	end 

	local index = c1:getSelectedIndex()
	local  isBatIndexText =  obj:getChild("isBatIndexText") 
	local isBat = info.batIndex
	if isBat and isBat > 0 then
		isBatIndexText:setVisible(true)
	else
		isBatIndexText:setVisible(false)
	end 
	

end
	
function gNodeConTrol:setListItemEqu(obj,zbID)
	if not obj then
		return
	end 
	local  textEquName =  obj:getChild("textEquName") 
	local  textEquT =  obj:getChild("textEquT") 
	local  textEquKLev =  obj:getChild("textEquKLev") 
	
	local info = g_zbMsg:getEuqTbMsg(zbID)
	local c1 =  obj:getController("c1") --控制器
	local c2 =  obj:getController("c2") --控制器
	

	if not info then
		c2:setSelectedIndex(1)
		c1:setSelectedIndex(0)
		return
	end 
	c2:setSelectedIndex(0)
	local name,yanse,tbEquMsg = g_getNameConTrol:getAllMsg(info.cfgID)
	textEquName:setText(name)
	local colorID = G_tb_TextColor[info.yanse]
	
	cc.g_setTextColor(textEquName,colorID,true)
	textEquKLev:setText("Lv."..info.zbLev)
	
	local  textEquT =  obj:getChild("textEquT") 
	if tbEquMsg.nameT2 then
		textEquT:setText(tbEquMsg.nameT2)
	else	
		textEquT:setText("")
	end 

	for i=1,2 do
		local  euqAtt =  obj:getChild("euqAtt"..i) 
		local lev = info.mainAttLev[i] or 0
		if lev <= 0 then
			euqAtt:setVisible(false)
		else
			euqAtt:setVisible(true)
			euqAtt:setIcon(g_iconConTrol:getABCDIcon(lev))
		end 
	end 
	local  conClock =  obj:getChild("conClock") 
	if info.isClock and info.isClock == 1 then
		conClock:setVisible(true)
	else
		conClock:setVisible(false)
	end 
	local textEquPinfen =  obj:getChild("textEquPinfen") 
	if not info.pinfen then
		info.pinfen = g_mathConTrol:mathEquPoint(info.id)
		g_zbMsg:setEuqTbMsg(info)  
	end 

	textEquPinfen:setText("评分："..info.pinfen)
	if not info.runeMsg then
		info.runeMsg = {}
	end 
	
	for i=1,7 do
		local  stItem =  obj:getChild("stItem"..i) 
		
		if stItem  then
			if  i > info.runeNum  then
				stItem:setVisible(false)
			else
				stItem:setVisible(true)
				local FWID = info.runeMsg[i] or 0
				
				if FWID > 0 then
					local name,yanse,tbMsg,baseName = g_getNameConTrol:getAllMsg(FWID)
					stItem:setIcon(g_iconConTrol:getFWYanseIcon(yanse))
				else
					stItem:setIcon(g_iconConTrol:getFWYanseIcon(0))
				end 
			end 
		end 
	end 
	
	local c2 =  obj:getController("c2") --控制器
	if not zbID or zbID <= 0 then
		c2:setSelectedIndex(1)
		c1:setSelectedIndex(0)
		return
	end 
	c2:setSelectedIndex(0)
	local function funcEndCallBack(btn,tag) 
		self:touchEquItem(obj,zbID)
	end 
	g_SetBtnOne(nil,nil,cfgID, funcEndCallBack,obj)
	
	
	cclog(zbID,"==setListItemEqu===11=",self.curTouchEuqID,info.inRole)
	if  zbID ==  self.curTouchEuqID then	
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
 

	local  textLevQH =  obj:getChild("textLevQH") 
	if  info.QHLev and info.QHLev > 0 then
		textLevQH:setText("A"..info.QHLev)
	else
		textLevQH:setText("")
	end 
	
end

----------------------提示冒泡操作--------------------------------------------------
local MaoPaoMsg = {}
G_MaoPaoMsgType = {}
G_MaoPaoMsgType.Daliy = 112 --每日任务
G_MaoPaoMsgType.loginReward = 131 --每日签到
G_MaoPaoMsgType.baozang = 133 --宝藏

GMaoPaoNumTag = {}
GMaoPaoNumTag.mail =1
GMaoPaoNumTag.mainRw=2

--注册回调控件
function gNodeConTrol:setItemCallback(nType,wnd,tag,item)
	cclog("===setItemCallback======",nType,wnd,tag,item)
	if not self.maopaoItem[nType]  then
		self.maopaoItem[nType] = {}
	end 
	if not self.maopaoItem[nType][wnd]  then
		self.maopaoItem[nType][wnd] = {}
	end 
	if not  MaoPaoMsg[nType]   then
		MaoPaoMsg[nType] = {}
	end 
	self.maopaoItem[nType][wnd][tag] = item
	local num = MaoPaoMsg[nType].num or 0
	if MaoPaoMsg[nType] and MaoPaoMsg[nType].num and MaoPaoMsg[nType].num > 0  then
		local title = item:getChild("title") 
		item:setVisible(true)
		if title then
			if num > 99  then
				num = "..."
			end 
			item:setText(num)
			local t0 = item:getTransition("numAct")
			local function callback()
			end 
			t0:play(-1, 0, callback)
		end 
	else
		item:setVisible(false)
	end 
	
	cclog("===setItemCallback=2222==",self.maopaoItem,nType,wnd,tag,MaoPaoMsg[nType],nType)
end

function gNodeConTrol:showNewNumberNode(nType,num)
	
	if not  MaoPaoMsg[nType]   then
		MaoPaoMsg[nType] = {}
	end 
	MaoPaoMsg[nType].num =  num
	if not  self.maopaoItem[nType]   then
		return
	end 
	for wndID,tbMsg in pairs(self.maopaoItem[nType])do
		local curWnd = g_WndMgr:getWnd(wndID)
		if  curWnd then
			for i,item in pairs(tbMsg)do
				if num and num > 0  then	
					item:setVisible(true)
					local title = item:getChild("title") 
					if title then
						if num > 99  then
							num = "..."
						end 
						item:setText(num)
						local t0 = item:getTransition("numAct")
						local function callback()
						end 
						t0:play(-1, 0, callback)
					end 
				else
					item:setVisible(false)
				end 
			end 
		end 
	end 
end

function gNodeConTrol:setMaoPaoMsg(nType,num)
	if not MaoPaoMsg[nType] then
		return
	end 
	if num == MaoPaoMsg[nType].num then
		return
	end 
	MaoPaoMsg[nType].num = num
	local func = MaoPaoMsg[nType].func
	if func then
		func()
	end 
end
function gNodeConTrol:setMaoPaoMsgFunc(nType,Func)
	if not MaoPaoMsg[nType] then
		MaoPaoMsg[nType] = {}
	end
	MaoPaoMsg[nType].num = 0
	MaoPaoMsg[nType].func = Func
end

function gNodeConTrol:getMaoPaoMsgFunc(nType)
	if not MaoPaoMsg[nType] then
		return 0
	end
	return MaoPaoMsg[nType].num or 0
end
----=========================================================

function gNodeConTrol:setGoodsItem(goodsID, item,num)
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(goodsID)
	item:setText(name)
	local title = item:getChild("title") 
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(title,colorID,true)
	
	if num then
		local textNum = item:getChild("textNum") 
		textNum:setText("数量："..tbMsg.addNumber)
	end 
end 

function gNodeConTrol:setGoodsListViewItem1(tbMsg, item,grayed)

	if tbMsg.name then
		item:setText(tbMsg.name)
	else
		cclog("=========setGoodsListViewItem1=======",tbMsg)
		local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(tbMsg.id)
		item:setText(name)
		local title = item:getChild("title") 
		local colorID = G_tb_TextColor[yanse]
		cc.g_setTextColor(title,colorID,true)
	end 
	
	if tbMsg.addNumber then
		local textNum = item:getChild("textNum") 
		textNum:setText("数量："..tbMsg.addNumber)
	end 
	if grayed then
		item:setGrayed(true)
	end 
end

function gNodeConTrol:setDropIDList(DropID,listView,grayed)
	local cfgMsg =  g_cfgMsg:getCfgMsg("drop_index_D",DropID)
	local tbDropMsg = {}
	for i,v in pairs(cfgMsg)do
		tbDropMsg[#tbDropMsg + 1] =  {id = v.value4,addNumber = v.value7, name = v.name}
	end 
	
	listView:itemRenderer(function(index, obj)
			local indexD = index + 1
			
			local tbMsg = tbDropMsg[indexD]
			self:setGoodsListViewItem1(tbMsg, obj,grayed)
		end)
	
	listView:setVirtual()
	listView:setNumItems(#tbDropMsg);
	
end
function gNodeConTrol:ctor()
	self.maopaoItem = {}

end

g_gNodeConTrol =  gNodeConTrol:create()