------------------
-- 文件名:	getNameConTrol.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local getNameConTrol = class("getNameConTrol")

function getNameConTrol:getAttName(attID,value)
	local tbMsg = g_cfgMsg:getCfgMsg("att_D",attID)
	local dec = tbMsg.AttDec
	if value then
		if tbMsg.nType == 1 then
			dec = "+"..value.."%"..tbMsg.name
		else
			dec = "+"..value..tbMsg.name
		end 
	end 
	
	return tbMsg.name,dec
end
function getNameConTrol:getAllMsg(cfgID)
	local name,icon ,number,dec,yanse, tbMsg,iconDI
	local nType = g_getTypeByCfgID(cfgID)
	if nType == g_cfgType.goods then
		
		tbMsg = g_cfgMsg:getCfgMsg("goods_D",cfgID)
		name = "【"..tbMsg.name.."】"
		baseName = tbMsg.name
		yanse = tbMsg.value5
	elseif nType == g_cfgType.res then
		tbMsg = g_cfgMsg:getCfgMsg("goods_D",cfgID)
		name = tbMsg.name
		yanse = tbMsg.value5
	elseif  nType == g_cfgType.equ then 	
		 tbMsg =  g_cfgMsg:getCfgMsg("zhuangbei_D",cfgID)
		name = "【"..tbMsg.name.."】"
		baseName = tbMsg.name
	elseif nType == g_cfgType.equT then
		
		 tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D",cfgID)
		name = "【"..tbMsg.name.."】"
		baseName = tbMsg.name
	elseif  nType == g_cfgType.petSkill then 	
		tbMsg =  g_cfgMsg:getCfgMsg("petSkill_D",cfgID)
		name = "【"..tbMsg.name.."】"
		baseName = tbMsg.name
		yanse = tbMsg.lev
	elseif  nType == g_cfgType.pet then 	
		tbMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID)
		name = "【"..tbMsg.name.."】"
		baseName = tbMsg.name
		yanse = tbMsg.lev
	elseif  nType == g_cfgType.mingwen then 	
		tbMsg = g_cfgMsg:getCfgMsg("rune_D", cfgID)
		
		name = "【"..tbMsg.name.."】"
		baseName = tbMsg.name
		yanse = tbMsg.lev
	end 
	--cclog("====getAllMsg==",name,cfgID,yanse,tbMsg)
	return name,yanse,tbMsg,baseName
end


--resicon  goodsID
function getNameConTrol:getGoodsName(resTypeID)
	local tbMsg = g_cfgMsg:getCfgMsg("goods_D",resTypeID)
	local  name = tbMsg.value1	
	return  name 
end

--装备
function getNameConTrol:getZBName(zbObj,info)
	if not zbObj and not info  then
		return 
	end 
	local zbinfo = info or zbObj:getEquipInfo()
	local cfgID = zbinfo.cfgID
	local skillID = zbinfo.tSkill  or 59200001
	--cclog(cfgID,skillID,"===getZBName===",zbinfo)
	
    local tbCfgmsg1 = g_cfgMsg:getCfgMsg("skill_suit_D",skillID)
	local skillName = tbCfgmsg1.value1
	

	local tbCfgmsg = g_cfgMsg:getCfgMsg("equipment_D",cfgID)
	local zbName = tbCfgmsg.value1
	local  yanse = zbinfo.yanse
	local  colorID = G_tb_TextColor[yanse]
	local  name = skillName.."◆"..zbName
	return  name ,colorID
end

--resicon  baoshi
function getNameConTrol:getBaoshiName(cfgID)

	local tbCfgmsg = g_cfgMsg:getCfgMsg("stone_D",cfgID)
	local  name = tbCfgmsg.value1	
	return  name 
end

function getNameConTrol:ctor()
end

g_getNameConTrol =  getNameConTrol:create()