------------------
-- 文件名:	itemConTrol.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local newGuide = class("newGuide")

g_Guide = {}
g_Guide.Loading = 1

local tbIndex = {
	--[id] = index, -- id = 做到第几步
}
---该界面是否触发新手引导
function newGuide:isGuideContorlWnd(wndUIName,DGuideID)
	local  DGuideID = DGuideID or g_baseMsg:getOther(otherDBMsgID.GuideID) or  0
	cclog(DGuideID,"======isGuideContorlWnd====000====")
	if DGuideID == 1 then
		return
	end 
	local curWndID = g_WndMgr:getTopWndID()
	cclog(curWndID,wndUIName,"======isGuideContorlWnd========")
	if curWndID ~= wndUIName then
		return
	end 
	local tbMsg = self.isGuideWnd[wndUIName] or {}
	cclog(tbMsg, "=====isGuideContorlWnd=333====",wndUIName)
	for i,tbV in pairs(tbMsg)do
		local nType =  tbV[1]
		local key =  tbV[2]
		local status = self:getGuideContorl(nType,key)
		if status then
			return status
		end 
	end 
	return
end

---触发新手引导 条件
function newGuide:isGuideContorl(nType,key)
	local tbMsg = self.OpenTb[key]
	if tbMsg and  tbMsg[1]  then
		local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",key)
		local nType = tbCfgMsg.nType
		local status = g_newGuideMsg:getTbGuide(nType)
		cclog(status,"===isGuideContorl=11===",nType)
		if status == 1 then
			return 
		end 
		local proKey = tbMsg[1]
		local lev = tbMsg[2]
		local mapKey = tbMsg[3]
		local mainLev =  g_batMath:getMapLev() 
		cclog(mainLev,lev,"===isGuideContorl=00===")
		if  lev and mainLev <  lev then
			return 
		end
		if proKey  then
			local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",proKey)
			local nType = tbCfgMsg.nType
			local status = g_newGuideMsg:getTbGuide(nType) or 0
			cclog(status,"===isGuideContorl=33==",nType)
			if status == 0 then
				 return
			else
				 
			end 
		end 
		
		return true
	end 
	
	return true
end 



function newGuide:getGuideContorl(nType,key)
	local status = g_newGuideMsg:getTbGuide(nType)
	cclog(status,"======getGuideContorl=========",nType,key)
	if status == 1 then
		return 
	end 

	if not key then
		key  = self:getGuideStepOfType(nType) 
	end 
	---判断触发条件
	local status = self:isGuideContorl(nType,key)
	cclog(status,"======getGuideContorl===222======",nType,key)
	if not status then
		return 
	end 
	
	self:getGuideConTorlByKey(key)
	return true
end

---执行到第几步
function newGuide:getGuideStepOfType(guide) 
	if  tbIndex[guide]  then	
		local index = #tbIndex[guide]
		local key = tbIndex[guide][index]
		return key
	end
	local key = guide*100+1
	return key
end 

---第几步是否可执行
function newGuide:getGuideIndexOfType(key) 
	local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",key)
	local guide = tbCfgMsg.nType
	local index = key%100
	return true 
end 

--新手引导配置表接口--某时刻有特别的处理操作
function newGuide:getGuideNextKey(key)
	local result
	local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",key)
	local nextKey =  tbCfgMsg.nextKey
	local save =  tbCfgMsg.save
	local nType =  tbCfgMsg.nType
	if  not nextKey then
		nextKey =  key + 1
	end
	cclog(key,save,"======getGuideNextKey=========",tbCfgMsg,nextKey)
	if save and save == 1 then
		g_svSendMsgControl:request_newGuide(nType,1)
		g_newGuideMsg:setTbGuideOfstatus(nType,1)
	end 
	
	if  tbCfgMsg.dropID > 0  then
		g_svSendMsgControl:request_newGuide(key,100)
	end 
	return nextKey
end


---特别处理，是否暂停或继续往下
function newGuide:getGuideConTorlOne(key)
	--if key == 1501   then
		
	--elseif key == 1101 or key == 1201  or key == 1301  or key == 1401     then

	--end 
	
end

--通用新手引导配置表接口
function newGuide:getGuideConTorlByKey(key)
	local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",key)
	cclog(tbCfgMsg,"=======getGuideConTorlByKey===111====",key)
	if not  tbCfgMsg then
		g_newGuideWnd:closeWnd()
		return 
	end 
	local status = self:getGuideIndexOfType(key) 
	cclog(status,"=======getGuideConTorlByKey==22=====",key)
	if true ~= status then
		return 
	end 
	local function callback()
		local nextKey = self:getGuideNextKey(key) ---特别处理，是否暂停或继续往下
		cclog(nextKey,"=====继续往下====",key)
		if nextKey and nextKey > 0 then
			self:getGuideConTorlByKey(nextKey)
		else
			g_newGuideWnd:closeWnd()
		end
	end
	self:getGuideConTorlOne(key)
	local tbMsg = {}
	tbMsg.func = callback
	tbMsg.GuideID = key
	
	cclog(tbMsg,"=====wndType == 5=======",tbCfgMsg.wndType)
	if tbCfgMsg.wndType == 5 then
		
		local toWnd = tbCfgMsg.icon
		local WndName =	 g_WndMgr:getTbWndByUI(toWnd)
		cclog(WndName,"======111======",toWnd)
		if WndName and WndName ~= ""  then
			g_WndMgr:openWnd(WndName)
		end 
		callback()
	elseif  tbCfgMsg.wndType == 1 then	
		g_A_story:openWnd(key)
	else	
		g_newGuideWnd:openWnd(tbMsg)
	end 

end 


function newGuide:ctor()
	self.isGuideWnd = {}
	self.OpenTb  = {}
	local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D")
	for i,v in pairs(tbCfgMsg)do
		local openWnd = v.openWnd
		local open = v.open
		local key = v.key 
		local nType = v.nType
		if openWnd and openWnd ~= "" then
				if not  self.isGuideWnd[openWnd] then
					self.isGuideWnd[openWnd] = {}
				end 
				local count = #self.isGuideWnd[openWnd]
				self.isGuideWnd[openWnd][count + 1]  = {nType, key}
		end 
		if open and open ~= "" then
			if not  self.OpenTb[key] then
					self.OpenTb[key] = {}
			end 
			local tbMsg  = cc.g_inalienContentByCfgMsg(open, 1, "_")
			self.OpenTb[key]   = tbMsg
		end
	end 
	cclog(self.isGuideWnd,"====newGuide=1====",self.OpenTb)
end

g_newGuide =  newGuide:create()