------------------
-- 文件名:	taskConTrol.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	yupingli
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local taskConTrol = class("taskConTrol")

--注册回调控件
function taskConTrol:setItemCallback(skID,wnd,tag,item)
	if not self.taskItem[skID]  then
		self.taskItem[skID] = {}
	end 
	if not self.taskItem[skID][wnd]  then
		self.taskItem[skID][wnd] = {}
	end 
	self.taskItem[skID][wnd][tag] = item
	cclog(self.taskItem,"====setItemCallback=",skID,tag,item)
	
end
function taskConTrol:callbackItem(skID,value)
	if  self.taskItem[skID] then
		local tbMsg = self.taskItem[skID]
		for wnd,v in pairs(tbMsg)do
			local wnd = g_WndMgr:getWnd(wnd)
			if wnd then
				for i,item in pairs(v)do
					item:setText(value)
				end 
			end 
		end 
	end 
end

function taskConTrol:setCallBackFunc(nType,level,wnd,func)
	local  taskid = g_taskConTrol:GetAchivementId(nType, level)
	if not self.callBackFunc[taskid] then
		self.callBackFunc[taskid] = {}
	end 
	self.callBackFunc[taskid][wnd]  = func
	
end 

function taskConTrol:callBackFuncD(taskid)
	if self.callBackFunc[taskid]  then
		local tbmsg = self.callBackFunc[taskid] 
		for wnd,func in pairs(tbmsg)do
			local wndObj = g_WndMgr:getWnd(wnd)
			if wndObj then
				func()
			end 
		end 
	end 
end 

function taskConTrol:reloadWnd(id)
	
end 
function taskConTrol:taskInfo(response)
	local  itype = response.itype
	local  str = response.str
	if str then
		local  b_senceBat = g_WndMgr:getWnd("b_senceBat")
		if  b_senceBat and  b_senceBat.setBatMSg and  b_senceBat.setBatMSg[1] == 0 then
			return
		end 
		g_action:ts_hszz_antion(str,2,2,true)
	end 
	if itype and itype == 100 then
		local  taskInfo  = response.taskStatisticsInfo
		local tbMsg = taskInfo.taskStatisticsInfo
		for id,info in pairs(tbMsg)do
			--cclog(info,"====taskInfo=======DDD==",self.taskStatisticsInfo)
			if not self.taskStatisticsInfo then
				return
			end 
			self.taskStatisticsInfo[id] = info
			local value = info.num
			self:callbackItem(id,value)
			self:callBackFuncD(id)
			self:reloadWnd(id)
		end 
		return 
	end 
	self.tbTaskInfo = response.taskBlob
	self.taskStatisticsInfo = response.taskStatisticsInfo.taskStatisticsInfo
	
	self:refreshUI(g_TaskType.Daily)
	--cclog("=====11111====taskInfo===")
end



function taskConTrol:getAchivementFinishNum(nType,level)
	local level = level or 1
	local  taskid = g_taskConTrol:GetAchivementId(nType, level)
	local  numebr =  self:getTaskStatisticsInfo(taskid)
	---cclog(numebr,taskid,"======GetAchivementId===2223==",nType, level)
	
	return  numebr
end

function taskConTrol:addAchivementFinishNum(nType,level,value,isSet)
	local level = level or 1
	local  taskid = g_taskConTrol:GetAchivementId(nType, level)
	local  numebr =  self:addTaskFinishNum(taskid,value)
	if isSet then
		self:setTaskFinishNum(taskid,value)
	end 
	
	return  numebr
end

function taskConTrol:getTaskFinishNum(id,lev)
	local lev = lev or 0
	if not id then	
		return
	end 
	if  id >= g_TaskStatisticsType.Daily_mathlev then
		id = id*100 + lev
	end 
	
	local tbData = self.taskStatisticsInfo[id]
	if not tbData then
		return 
	else
		return tbData.num
	end
end
function taskConTrol:addTaskFinishNum(id,addValue)
	local tbData = self.taskStatisticsInfo[id]
	if not tbData then
		self.taskStatisticsInfo[id] = {}
		self.taskStatisticsInfo[id].num= 0
	end
	self.taskStatisticsInfo[id].num = self.taskStatisticsInfo[id].num + addValue
	return  self.taskStatisticsInfo[id].num
end

function taskConTrol:setTaskFinishNum(id,addValue)
	local tbData = self.taskStatisticsInfo[id]
	if not tbData then
		self.taskStatisticsInfo[id] = {}
		self.taskStatisticsInfo[id].num= 0
	end
	self.taskStatisticsInfo[id].num = addValue
	return  self.taskStatisticsInfo[id].num
end

function taskConTrol:getTaskStatisticsInfo(id)
	if not id  then
		return self.taskStatisticsInfo
	end 
	if not self.taskStatisticsInfo[id] then
		return 0
	end
	return self.taskStatisticsInfo[id].num
end

function taskConTrol:taskReward(response)

	local iType = response.itype
	local taskid = response.taskid
	cclog("====taskReward========", iType , g_TaskType.FirstReward )
	if iType == g_TaskType.Daily then
		if not self.tbTaskInfo.dailyTaskInfo[taskid] then
			self.tbTaskInfo.dailyTaskInfo[taskid] = {taskid = taskid, reward = true}
		else
			self.tbTaskInfo.dailyTaskInfo[taskid].reward = true
		end
		local  b_renwu = g_WndMgr:getWnd("b_renwu")
		 if  b_renwu then
			local key = taskid - 6
			--b_renwu:setDailyListtem(nil,nil,key)
			b_renwu:setRwRewardBar()
		 end 
	elseif iType == g_TaskType.Achivement then
		if not self.tbTaskInfo.achivementTaskInfo[taskid] then
			self.tbTaskInfo.achivementTaskInfo[taskid] = {taskid = taskid, reward = true}
		else
			self.tbTaskInfo.achivementTaskInfo[taskid].reward = true
		end
		self.tbTaskInfo.achivementTaskInfo[taskid].reward = true
		 local  b_renwu = g_WndMgr:getWnd("b_renwu")
		 if  b_renwu then
			--local key = taskid - 1003
			b_renwu:initAchivement()
		 end 
		
	elseif iType == g_TaskType.Level then
		if not self.tbTaskInfo.levelTaskInfo[taskid] then
			self.tbTaskInfo.levelTaskInfo[taskid] = {taskid = taskid, reward = true}
		else
			self.tbTaskInfo.levelTaskInfo[taskid].reward = true
		end
	elseif	 iType == g_TaskType.FirstReward then
		local  firstReward = g_WndMgr:getWnd("b_firstReward")
		cclog(firstReward,"===b_firstReward=====")
		 if  firstReward then
			--local key = taskid - 1003
			local key = tonumber(response.szerror)
			firstReward:setListItem(nil,nil,key,1)
		 end 
	else
		
		return
	end

end

function taskConTrol:GetAchivementId(itype, lv,value)
	local AchivementId
	local value= value or lv  or  0
	AchivementId = itype*1000000 + value
	
	return AchivementId
end

function taskConTrol:getTaskInfoReward(iType, taskid)
	
	if not self.tbTaskInfo then
		return  
	end
	local tbmsg = self:getTaskInfo(iType, taskid) or {}
	
	return tbmsg.reward
end

function taskConTrol:getTaskInfo(iType, taskid)
	
	if not self.tbTaskInfo then
		return {}
	end
	if iType == g_TaskType.Daily then
		return self.tbTaskInfo.dailyTaskInfo[taskid]
	elseif iType == g_TaskType.Achivement then
		return self.tbTaskInfo.achivementTaskInfo[taskid]
	elseif iType == g_TaskType.Level then
		return self.tbTaskInfo.levelTaskInfo[taskid]
	end
end


function taskConTrol:refreshUI(iType)
	local wnd  = g_WndMgr:getWnd("taskWnd")
	cclog(wnd,"=====refreshUI=======",iType)
	if wnd then
		--wnd:refreshUI(iType)
	end 
end

function taskConTrol:checkTaskInfo()

	local tbMsg = {}
	sendWsSocketData("request_taskInfo", tbMsg)
	return false
end
function taskConTrol:ctor()
   self.taskItem = {}
   self.callBackFunc = {}
end

g_taskConTrol =  taskConTrol:create()