 --------------------------------------------------------------------------------------
-- 文件名:	tianfuConTrol.lua
-- 版  权:	(C)  *****互动科技有限公司
-- 创建人:	
-- 日  期:	2019-9-21 23:24
-- 版  本:	1.0
-- 描  述:	挂机的操作
-- 应  用:  
---------------------------------------------------------------------------------------
tianfuConTrol = class("tianfuConTrol")
tianfuConTrol.__index = tianfuConTrol

--判断某个天赋是否开启 -获取数值
function tianfuConTrol:getTianfuOpenValue(tfID)
	if  self.tbTfValue[tfID] then
		return self.tbTfValue[tfID]
	end 

	local info = g_tianfuMsg:getTianfuTbMsg() or {}
	local value = 0
	for id,v in pairs(info)do
		local cfgID = v.cfgID
		if cfgID ==  tfID and (v.lev or 0)  > 0 then
			local tfValue =  g_tianfuMsg:getValuetianfu(cfgID,v.lev)  
			value = value + tfValue
			cclog(tfID,"=======getValuetianfu===000===",value , tfValue)
		end 
	end 
	self.tbTfValue[tfID] = value
	cclog("========getTianfuOpenValue======",tfID,value)
	return value
end 

function tianfuConTrol:reloadTbTfValue(ID)
	self.tbTfValue[ID] = nil
end 

function tianfuConTrol:reloadTbTfValue()
	self.tbTfValue = {}
end 

-- ctor() 是类的构造函数，在调用 tianfuConTrol.new() 创建 tianfuConTrol 对象实例时会自动执行  
function tianfuConTrol:ctor()	
	self.tbTfValue = {}
end
function tianfuConTrol:init()
	
end
g_tianfuConTrol =  tianfuConTrol:create()