------------------
-- 文件名:	petMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	制作数据
-- 应  用:  
-------------------
local petMsg = class("petMsg")

local petTbMsg = {}
function petMsg:getpetTbMsg(petID)
	if petID  then
		local tbsmg = petTbMsg[petID] 
		return tbsmg
	end 
	return petTbMsg
end

function petMsg:setpetTbMsg(info)  
	petTbMsg[info.id] = info
end
function petMsg:delpetTbMsg(petID)  
	petTbMsg[petID] = nil
end
function petMsg:setpetTbMsgAll(info)   
	if not info then
		return
	end 
	petTbMsg = info
end


function petMsg:isOpenBatIndex(index)  
	local BatPetMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {0,-1,-1,-1,-1,-1,-1,-1}

	return  BatPetMsg[index]
	
end

function petMsg:getPetZZ(petID)  
	local info = self:getpetTbMsg(petID)
	local zzValue = info.zhizi
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",info.cfgID) 
	local nSortmax = cfgMsg.nSortmax
	if zzValue > nSortmax then
		zzValue = nSortmax
	end 
	local addzz = self:getTbPetAddAttMsg(62) or  0
	local  starLev = info.starLev or 0
	
	local lyvalue = g_lyInfoMsg:mathZhongzhuValueAtt(cfgMsg.zhongzhu,2)
	
	zzValue = zzValue*0.9 + addzz + starLev*0.3 + info.yanse*2.5 + lyvalue
	cclog(zzValue,addzz,starLev,"====getPetZZ=22====",info.zhizi,lyvalue,info.cfgID)
	return zzValue
end 
--==========================================
petSortType = {}
petSortType.Lev = 1
petSortType.zz = 2
petSortType.yans = 3

function petMsg:getSortPetMsg(nType,reload) 
	local nType = nType or cc.UserDefault:getInstance():getIntegerForKey("sortType",1)
	if nType ~=  self.sortType or reload then

		cc.UserDefault:getInstance():setIntegerForKey("sortType",nType)
		self.sortType = nType
		self:mathSortPetMsg(nType) 
	end 
	
	return self.sortPetMsg
end

function petMsg:mathSortPetMsg(nType) 
	self.sortPetMsg = {}
	local tbMsg = self:getpetTbMsg()
	for patID,v in pairs(tbMsg)do
		self.sortPetMsg[#self.sortPetMsg+1] = patID
	end 
	
	if self.sortType == petSortType.Lev then
		self:sortPetMsg1() 
	elseif self.sortType == petSortType.zz then
		self:sortPetMsg2() 
	elseif self.sortType == petSortType.yans then
		self:sortPetMsg3() 	
	end 
end

function petMsg:sortPetMsgYanse(info1,info2) 
	local yanse1 = info1.yanse
	local yanse2 = info2.yanse
	if yanse1 == yanse2 then
		return
	else
		return yanse1 > yanse2
	end 
end 
function petMsg:sortPetMsgLev(info1,info2) 
	local Level1 = info1.Level
	local Level2 = info2.Level
	if Level1 == Level2 then
		return
	else
		return Level1 > Level2
	end 
end 
function petMsg:sortPetMsgZZ(info1,info2) 
	local zhizi1 = g_petMsg:getPetZZ(info1.id)
	local zhizi2 = g_petMsg:getPetZZ(info2.id)
	if zhizi1 == zhizi2 then
		return
	else
		return zhizi1 > zhizi2
	end 
end 
function petMsg:sortPetMsgisBat(info1,info2) 
	local batIndex1 = info1.batIndex or 0
	local batIndex2 = info2.batIndex or 0
	if batIndex1 == batIndex2 then
		return
	else
		return batIndex1 > batIndex2
	end 
end 
function petMsg:sortPetMsg1() --Lev
	local function comps(a,b)
		local info1 = self:getpetTbMsg(a)
		local info2 = self:getpetTbMsg(b)
		local status = self:sortPetMsgisBat(info1,info2) 
		if  status ~= nil then
			return status
		end
		local status = self:sortPetMsgLev(info1,info2) 
		if  status ~= nil  then
			return status
		end
		local status = self:sortPetMsgYanse(info1,info2) 
		if  status ~= nil  then
			return status
		end
		local status = self:sortPetMsgZZ(info1,info2) 
		cclog("======sortPetMsgZZ======",status)
		if  status ~= nil  then
			return status
		end
		return info1.id > info2.id 
	end 
	table.sort(self.sortPetMsg, comps)
end 
function petMsg:sortPetMsg2() --zz
	local function comps(a,b)
		local info1 = self:getpetTbMsg(a)
		local info2 = self:getpetTbMsg(b)
		local status = self:sortPetMsgisBat(info1,info2) 
		if  status ~= nil  then
			return status
		end
		local status = self:sortPetMsgZZ(info1,info2) 
		if  status ~= nil  then
			return status
		end
		local status = self:sortPetMsgYanse(info1,info2) 
		if  status ~= nil  then
			return status
		end
		local status = self:sortPetMsgLev(info1,info2) 
		if  status ~= nil  then
			return status
		end
		return info1.id > info2.id 
	end 
	table.sort(self.sortPetMsg, comps)
end 

function petMsg:sortPetMsg3() --yanse
	local function comps(a,b)
		local info1 = self:getpetTbMsg(a)
		local info2 = self:getpetTbMsg(b)
		local status = self:sortPetMsgisBat(info1,info2) 
		if  status ~= nil  then
			return status
		end
		local status = self:sortPetMsgYanse(info1,info2) 
		if  status ~= nil  then
			return status
		end
		local status = self:sortPetMsgLev(info1,info2) 
		if  status ~= nil  then
			return status
		end
		local status = self:sortPetMsgZZ(info1,info2) 
		if  status ~= nil  then
			return status
		end
		return info1.id > info2.id 
	end 
	table.sort(self.sortPetMsg, comps)
end 

---=====================================================
local tbPetAddAttMsg = {}
 --全体增加
function petMsg:getTbPetAddAttMsg(attID)
	if not attID then
		return tbPetAddAttMsg
	end 
	return tbPetAddAttMsg[attID]
end 
function petMsg:addTbPetAddAttMsg(attID,value)
	if not tbPetAddAttMsg[attID] then
		tbPetAddAttMsg[attID] = 0
	end 	
	tbPetAddAttMsg[attID]  = tbPetAddAttMsg[attID] + value
end 
function petMsg:cleanTbPetAddAttMsg()
	 tbPetAddAttMsg = {}
end 
--全体增加
function petMsg:mathTbPetAddAttMsg(tbValue)
	cclog(tbValue,"=======mathTbPetAddAttMsg===DD==",tbPetAddAttMsg)
	for attID,v in pairs(tbPetAddAttMsg)do
		if not tbValue[attID] then
			tbValue[attID] = 0
		end 
		tbValue[attID] = tbValue[attID] + v
	end 
	cclog(tbValue,"=======mathTbPetAddAttMsg=====")
	return tbValue
end 


 --技能单个属性增加 
function petMsg:mathSkillAddAttMsg(PetID,tbValue)
	local info = g_petMsg:getpetTbMsg(PetID)
	--技能增加
	if not info.skillMsg then
		info.skillMsg = {}
	end 
	local tbSkillValue = tbValue or {}
	for i=1,6 do
		local skillMsg = info.skillMsg[i] or {}
		local skillID = skillMsg.value1 or 0
		if skillID > 0  then
			if  skillID < 87000101  then
				skillID = 87000101
				info.skillMsg[i].value1 = 87000101
				g_petMsg:setpetTbMsg(info)
			end 
			local tbMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillID)
			local attID = tbMsg.attID1
			local attID2 = tbMsg.attID2
			if  attID > 0   then
				local skillIDLev =  g_bagMsg:getpetSkillTbMsgLev(skillID)  
				local tb_number = g_mathConTrol:mathPetSkillValue(skillIDLev,skillID)
				if not tbSkillValue[attID]  then
					tbSkillValue[attID]  = 0
				end 
				tbSkillValue[attID] = addBigInt(tbSkillValue[attID], tb_number[1])
				if attID2 > 0 then
					if not tbSkillValue[attID2]  then
						tbSkillValue[attID2]  = 0
					end 
					tbSkillValue[attID2] = addBigInt(tbSkillValue[attID2], tb_number[2])
				end 
			end 
		end 
	end 
	return tbSkillValue
end

function petMsg:mathPetAttHurt(index) ---计算宠物属性伤害
	local tbAttID = {64,65,66,67}
	local value = self:getTbPetAddAttMsg(tbAttID[index])
	return value
end 



function petMsg:ctor()

end

g_petMsg =  petMsg:create()