------------------
-- 文件名:	playerMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	制作数据
-- 应  用:  
-------------------
local playerMsg = class("playerMsg")

local roleBaseInfoTbMsg = {}
local tbSkillID = {}
local tbZbID = {}
function playerMsg:getRoleBaseInfoTbMsg(id)
	if id  then
		local tbsmg = roleBaseInfoTbMsg[id] or {}
		return tbsmg.value
	end 
	return roleBaseInfoTbMsg
end
function playerMsg:setRoleBaseInfoTbMsg(info)  

	roleBaseInfoTbMsg = info
end
function playerMsg:setRoleBaseInfoTbMsgOne(info)  

	roleBaseInfoTbMsg[info.id] = info
end



---================================================  {id = 1,value1 = 95001001,value2 = 1} ====getTbSkillID===222= 1
function playerMsg:getTbSkillID(id)

	if id then
		local tbsmg = tbSkillID[id] or {}
		local SkillID = tbsmg.value1 or 0
		local SkillLev = tbsmg.value2 or 0
		
		return SkillID,SkillLev
	else
		return tbSkillID
	end 
	
end
function playerMsg:setTbSkillIDAll(info) 
	if not info then
		return
	end
	tbSkillID  = info
end
function playerMsg:setTbSkillIDAllOne(info)  
	
	tbSkillID[info.id] = info
end

--===========================
function playerMsg:getTbZbID(index)
	if index  then
		local value = tbZbID[index] or  0
		return  value
	end 
	return tbZbID
end

function playerMsg:setTbZbIDOne(index,value)  
	
	tbZbID[index]  = value
end
function playerMsg:setTbZbIDAll(info)  
	if not info then
		return
	end
	tbZbID = info
end

local roleTbMsg = {}
function playerMsg:getRoleTbMsg(id)
	if id  then
		local tbsmg = roleTbMsg[id] or 0
		return tbsmg
	end 
	return roleTbMsg
end

function playerMsg:setRoleTbMsgOne(info)  ---value 是string类型

	roleTbMsg[info.id] = info.value
end

function playerMsg:addRoleTbMsgOne(id,strValue)  ---string类型

	if not roleTbMsg[id] then
		roleTbMsg[id] = "0"
	end 
	roleTbMsg[id] = addBigInt(roleTbMsg[id], strValue)
end

----========================================================================

--[[
	
	public const int Base = Speed * 1000 + 1;
	public const int Add = Speed * 1000 + 2;   数值   一般装备系统类  
	public const int Pct = Speed * 1000 + 3;  百分比  一般装备系统类  
	
	
	一个值可以由3个值进行控制其最终结果 
	final = (base + add) * (100 + pct) / 100 ;
]]

function playerMsg:getAttKey(key)
	if key < 1000 then
		return key
	end 
	key = math.floor(key/100)
	return key
end

function playerMsg:getAttBaseKey(attID)
	return attID*1000 + 1
end
function playerMsg:getAttADDKey(attID)
	return attID*1000 + 2
end
function playerMsg:getAttPctKey(attID)
	return attID*1000 + 3
end

function playerMsg:getAttValue(key)

	return  roleTbMsg[key] 
end


function playerMsg:cleanRoleAttValue(attID)
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D",attID)
	local key 
	if attMsgD.attType == 1 then
		key = self:getAttBaseKey(attID)
		
	elseif attMsgD.attType == 2 then
		key = self:getAttADDKey(attID)
	elseif attMsgD.attType == 3 then
		key = self:getAttPctKey(attID)
	else
		key = attID
	end 
	
	roleTbMsg[key] = nil
end  

function playerMsg:addRoleAttValue(attID,value)
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D",attID)
	local key 
	if not attMsgD then
		return
	end 
	if attMsgD.attType == 1 then
		key = self:getAttBaseKey(attID)
		
	elseif attMsgD.attType == 2 then
		key = self:getAttADDKey(attID)
	elseif attMsgD.attType == 3 then
		
		key = self:getAttPctKey(attID)
	else
		key = attID
	end 
	self:addRoleTbMsgOne(key,value)
end

function playerMsg:getRoleAttValue(AttID,isNumber,isFloor,logd)
	AttID = self:getAttKey(AttID)
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D",AttID)
	if attMsgD.isMath ~= 1 then
		local value = self:getRoleTbMsg(AttID)
		
		if isNumber then
			value = tonumber(value)
		end 
		
		return value,value
	end 

	local value = self:getRoleTbMsg(AttID) or "0"
	
	local baseKey = self:getAttBaseKey(AttID)
	local addKey  = self:getAttADDKey(AttID)
	local pctKey  = self:getAttPctKey(AttID)
	
	local base = self:getAttValue(baseKey) or "0"
	local add  = self:getAttValue(addKey) or "0"
	local pct  = self:getAttValue(pctKey) or "0" 
	pct = 1+tostring(tonumber(pct)/100)
	--cclog(AttID,baseKey,"=======11111===",value, base)
	--cclog(addKey,"=====22==",value, add)
	--cclog(pctKey,"======33==",value, pct)
	local  final0 = addBigInt(value, base)
	local  final1 = addBigInt(final0, add)

	local final,strLDEndCN =  byBigInt(final1, pct,isFloor) ;

	if isNumber then
		final = tonumber(final)
	end 

	return final,strLDEndCN
end


----------------------------计算Role属性----------------------------------------------------
function playerMsg:mathMainAtt(attID) --计算角色主属性
	local BOSSID = self:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	--cclog(tbMsg,"====mathMainAtt====111===",BOSSID,attID)
	local baseValue = tbMsg["mainAtt"..attID] 
	local zizhi = self:getZizhi()
	local level = self:getRoleAttValue(RoleAttMsg.level,true)
	
	local value = baseValue + math.floor(baseValue*zizhi*(level-1)/20)
	--cclog(value,"======mathMainAtt==222===",baseValue,zizhi,level)
	return value
end
function playerMsg:mathBaseAttMsg()
	local BOSSID = self:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbplayerMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	for key=1,6 do		
		local value = self:mathMainAtt(key)
		self:addRoleAttValue(key,value)
		cclog("===mathBaseAttMsg=============",key,value)
	end 
	local value = tbplayerMsg.attckNum
	self:addRoleAttValue(22,value)
	local value = tbplayerMsg.speed
	self:addRoleAttValue(17,value)
	
	local tbMsg =  g_cfgMsg:getCfgMsg("att_D")
	for key,v in ipairs(tbMsg)do
		if v.isMath == 1 and v.baseValue > 0 then
			self:addRoleAttValue(key,v.baseValue)
		end 
	end 
	
	self:addRoleAttValue(16,10)
	self:addRoleAttValue(18,70)
	
	local level = self:getRoleAttValue(RoleAttMsg.level,true)
	--  --计算回血和回魔
	self:addRoleAttValue(RoleAttMsg.addHpOne,level)
	--回魔在下面技能那
	--仇恨
	local zizhi = self:getZizhi(userID)
--	cclog("==mathBaseAttMsg====22=====",zizhi)
	if zizhi <= 0 then
		zizhi = 0
	end 
	local chouhen = (40 + zizhi ) *level
	--cclog("==mathBaseAttMsg===33===",chouhen,level)
	self:addRoleAttValue(RoleAttMsg.chouhen,chouhen)
end 


function playerMsg:getZizhi(userID)
	local jinhua = self:getRoleAttValue(RoleAttMsg.jinhua,true)
	
	local BOSSID = self:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local bianyi = self:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSIDBianyi) or 0
	local tbMsg = g_cfgMsg:getCfgMsg("role_D",BOSSID)
	local addzz =   self:getRoleAttValue(RoleAttMsg.zizhi)  or 0
	local baseZz = tbMsg.nSort
	if bianyi then
		baseZz = tbMsg.nSortMax
	end 
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	local Zizhi = baseZz + jinhua* tbGameConst.addzizhi + addzz
	
	return Zizhi
end 

function playerMsg:mathRoleEquAttMsgOne(Info)
	--主属性
	local name,yanse,tbEquMsg = g_getNameConTrol:getAllMsg(Info.cfgID)
	for i=1,2 do 
		local attLev = Info.mainAttLev[i]
		local attID = tbEquMsg["attID"..i]
		local ration = g_mathConTrol:mathEquMaintAttRation(attLev,Info.cfgID,i,Info.yanse)
		local value = g_mathConTrol:mathEquMaintAtt(Info.zbLev,Info.cfgID,attID,ration)
		self:addRoleAttValue(attID,value)
	end
	--副属性
	if  Info.QHAttLev then
		for i=1,7 do
			local attID = Info.QHAttID[i] or 0
			--cclog(attID,"=====attID=====")
			if  attID > 0 then
				local QHAttLev = Info.QHAttLev[i] or 0
				local ration = g_mathConTrol:mathEquCecAttRaton(QHAttLev,Info.cfgID)
				local value = g_mathConTrol:mathEquCecAtt(Info.zbLev,Info.cfgID,attID,ration)
				--cclog("======addRoleAttValue=====",attID,value)
				self:addRoleAttValue(attID,value)
			end 
		end 
	end 
	---符文
	if  Info.runeMsg then
		for i=1,6 do
			local FWID = Info.runeMsg[i] or 0
			--cclog(FWID,"=====FWID=========",Info.runeMsg,i)
			if FWID > 0   then
				local name,yanse,tbMsg,baseName = g_getNameConTrol:getAllMsg(FWID)
				local attID = tbMsg.attID
				local value =  self:mathFWValue(FWID)
				--cclog(value,attID,"===222==FWID=========",FWID)
				self:addRoleAttValue(attID,value)
			end 
		end 
	end
end



local tianfuTbMsg = { 
	-- tianfuInfo
}

function playerMsg:getTianfuTbMsg(tianfuID)
	if tianfuID  then
		local tbsmg = tianfuTbMsg[tianfuID] 
		return tbsmg
	end 
	return tianfuTbMsg
end

function playerMsg:setTianfuTbMsg(info)  
	tianfuTbMsg[info.id] = info
end
function playerMsg:setTianfuTbMsgAll(info)   
	if not info then
		return
	end 
	tianfuTbMsg = info
end

--==========================
function playerMsg:getTianfuOpenValue(tfID)

	local info = self:getTianfuTbMsg() or {}
	local value = 0
	for id,v in pairs(info)do
		local cfgID = v.cfgID
		if cfgID ==  tfID and (v.lev or 0)  > 0 then
			local tfValue =  g_tianfuMsg:getValuetianfu(cfgID,v.lev)  
			value = value + tfValue
		end 
	end 
	return value
end 

local tbjfMsg = 0

function playerMsg:getjfMsg(userID)
	
	return tbjfMsg
end

function playerMsg:setjfMsg(val)  
	tbjfMsg = tonumber( val )
	
end

function playerMsg:getVipValue(nType) 
	local count = 0
	local jifen = self:getjfMsg()
	local lev = g_viplevMsg:mathRoleVIPlev(jifen)
	cclog(jifen,lev,"======getVipValue===00=====",nType)
	for index = 1,lev do
		local cfgMsg =  g_cfgMsg:getCfgMsg("VIPLev_D",index)
		if cfgMsg.nTypeID == nType then
			count = count + cfgMsg.value1
			cclog(count,cfgMsg.value1,"======getVipValue====11====",nType)
		end 
	end 
	cclog(count,"======getVipValue====222===",nType)
	return count
end 


function playerMsg:mathFWValue(fwID) ---获取符文属性
	local tbMsg = g_cfgMsg:getCfgMsg("rune_D", fwID)
	local value = tbMsg.value
	local addVa = self:getTianfuOpenValue(49) 
	local addVip = self:getVipValue(25) or 0
	local value = math.floor(value *(1+ addVip/ 100 + addVa/100))
	local addVa = value - tbMsg.value 
	return value,addVa
end 


---=============================================
local EuqTbMsg = {}

function playerMsg:getEuqTbMsg(euqID)
	if euqID  then
		local tbsmg = EuqTbMsg[euqID] 
		return tbsmg
	end 
	return EuqTbMsg
end

function playerMsg:setEuqTbMsg(info)  

	EuqTbMsg[info.id] = info
end
function playerMsg:setEuqTbMsgAll(info)   
	if not info then
		return
	end 
	EuqTbMsg = info
end

function playerMsg:mathRoleEquAttMsg()
	self.tbTaozMsg = {}
	self.tbTaozMsgSkill = {}
	self.tbTaozMsgOpen = {}
	for index=1,9 do
		local zbID = self:getTbZbID(index) or 0
		if zbID > 0 then
			local zbInfo = self:getEuqTbMsg(zbID)
			if zbInfo  then
				self:mathRoleEquAttMsgOne(zbInfo)
				--local value1 = self:getRoleAttValue(5)
				local nType = g_getTypeByCfgID(zbInfo.cfgID)
				if nType == g_cfgType.equT then
					local  tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D",zbInfo.cfgID)
					if not self.tbTaozMsg[tbMsg.nTaozhuangType] then
						self.tbTaozMsg[tbMsg.nTaozhuangType] = 0
					end 
					self.tbTaozMsg[tbMsg.nTaozhuangType] = self.tbTaozMsg[tbMsg.nTaozhuangType] + 1
				
					self.tbTaozMsgSkill[tbMsg.nTaozhuangType] = tbMsg.taoSkill
				end 
			end 
			
		end
	end 
	--套装
	for nType,num in pairs(self.tbTaozMsg)do
		local taoSkill = self.tbTaozMsgSkill[nType] 
		local  tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiSkill_D",taoSkill)
		for i=1,3 do
			local open_num = tbMsg["open_num"..i] or 0
			if open_num > 0 and num >= open_num then
				self.tbTaozMsgOpen[nType] = i
				local value = tbMsg["value"..i]
				self:addRoleAttValue(tbMsg.attID,value)
				
				local value1 = self:getRoleAttValue(5,isNumber,isFloor,true)
				
				local attMsgD =  g_cfgMsg:getCfgMsg("att_D",attID)
				if attMsgD.isCwu and attMsgD.isCwu >= 1 then
					self:addTbPetAddAttMsg(attMsgD.isCwu,value)
				end 
			end 	
		end 
		
	end 
end 

function playerMsg:getTFMaxlev() 
	local zslevel = self:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	local value = tbGameConst.baseSkillMaxLev + zslevel*tbGameConst.skillMaxLev
	
	return value
end
function playerMsg:mathRoleSkillAttMsgOne(indexD,skillID,lev)
	local lev = self:getroleSkillTbMsgLev(indexD) 
	if lev <= 0  then
		return
	end 
	--cclog(lev,"======mathRoleSkillAttMsgOne=======")
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",skillID)
	if  tbMsg.costMp > 0  then
		local val =  tbMsg.costMpAdd*0.1*lev
		self:addRoleAttValue(RoleAttMsg.addMpOne,val)
	end 
	if tbMsg.attID <= 0  then
		return
	end 
	local maxLev = self:getTFMaxlev() 
	if lev > maxLev then
		lev = maxLev
	end 
	
	local  tbAttMsg = g_roleSkillMsg:getSkillValue(skillID,lev) 
	self:addRoleAttValue(tbMsg.attID,tbAttMsg[1])
	--cclog(lev,"======mathRoleSkillAttMsgOne==2222=====",tbAttMsg)
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D",tbMsg.attID)
	if attMsgD.isCwu and attMsgD.isCwu >= 1 then
		self:addTbPetAddAttMsg(attMsgD.isCwu,tbAttMsg[1])
	end 
	
end 
function playerMsg:mathRoleSkillAttMsg()
	local BOSSID = self:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	for i=1,tbGameConst.SkillMaxNum do
		local skillID = tbMsg["skill"..i]
		self:mathRoleSkillAttMsgOne(i,skillID)
	end 
end

function playerMsg:mathRoleTianfuAttMsg()
	local tianfuTbMsg = self:getTianfuTbMsg()
	for i,info in pairs(tianfuTbMsg)do
		local lev = info.lev or 0
		if  lev > 0 then
			local tbMsg =  g_cfgMsg:getCfgMsg("tianfu_D",info.cfgID)
			if tbMsg.attID > 0  then
				if lev > tbMsg.maxLev then
					lev = tbMsg.maxLev
				end 
				local value = g_tianfuMsg:getValuetianfu(info.cfgID,lev)   
				self:addRoleAttValue(tbMsg.attID,value)
				local attMsgD =  g_cfgMsg:getCfgMsg("att_D",tbMsg.attID)
				if attMsgD.isCwu and attMsgD.isCwu >= 1 then
					self:addTbPetAddAttMsg(attMsgD.isCwu,value)
				end 
			end 
		end 
	end 
end 

function playerMsg:mathRoleMainAttChangeMsg()
	
	local value1 = self:getRoleAttValue(1) -- 1点力量 = 2点物理攻击 + 0.5点物理防御
	local addVa = self:getTianfuOpenValue(30) 
	local value = byBigInt(value1,2+addVa)
	self:addRoleAttValue(11,value)
	local value = byBigInt(value1,0.5)
	self:addRoleAttValue(12,value)
	--cclog(value1,"======mathRoleMainAttChangeMsg====22===",value)
	--======================================
	local value1 = self:getRoleAttValue(2) --1点敏捷 = 0.1%躲闪 + 0.1%暴击
	
	local value = byBigInt(value1,0.1)
	self:addRoleAttValue(19,value)
	self:addRoleAttValue(20,value)
	self:addRoleAttValue(18,value)
	--cclog(value1,"======mathRoleMainAttChangeMsg===33===",value)
	local value1 = self:getRoleAttValue(3) --1点智慧 = 2点魔法攻击 + 1点法力
	local addVa = self:getTianfuOpenValue(33) 
	local value = byBigInt(value1,2 + addVa)
	self:addRoleAttValue(13,value)
	local value = byBigInt(value1,1)
	self:addRoleAttValue(16,value)
	--cclog(value1,"======mathRoleMainAttChangeMsg===444===",value)
	local value1 = self:getRoleAttValue(4) --1点体质 = 4点血量 + 1点物理/魔法防御
	local addVa = self:getTianfuOpenValue(26) 
	local value = byBigInt(value1,4+addVa)
	self:addRoleAttValue(15,value)

	local addVa = self:getTianfuOpenValue(27) 
	local value = byBigInt(value1,1+addVa)
	self:addRoleAttValue(14,value)
	self:addRoleAttValue(12,value)
	--cclog(value1,"======mathRoleMainAttChangeMsg===55==",value)
	local value1 = self:getRoleAttValue(5) --1点幸运 = 0.1额外材料获取 + 0.1额外金币获取
	local value = byBigInt(value1,0.1)
	self:addRoleAttValue(48,value)
	--self:addRoleAttValue(47,value)
	--cclog(value1,"======mathRoleMainAttChangeMsg===66==",value)
	local value1 = self:getRoleAttValue(6) --1点血脉 = 0.1统帅 + 0.1点攻速
	local value = byBigInt(value1,0.1)
	self:addRoleAttValue(33,value)

	self:addRoleAttValue(17,value)
	--cclog(value1,"======mathRoleMainAttChangeMsg====777==",value)
end 

function playerMsg:cleanRoleBaseAttMsg()
	local attMsgD =  g_cfgMsg:getCfgMsg("att_D")
	for attID,v in pairs(attMsgD)do
		if v.isDD == 2 then
			self:cleanRoleAttValue(attID)
		end 
	end 
end 

function playerMsg:getTbDalitMsg()
	local val = self:getOther(otherDBMsgID.daliyExp) or 0
	return val
end


function playerMsg:reloadDalitLevAddAtt()
	local DalitExp = self:getTbDalitMsg()
	local lev ,expOne,lastExp , tbAtt = g_dalitInfoMsg:mathDalitLev(DalitExp)  
	cclog(DalitExp,lev,"=====reloadDalitLevAddAtt===11========")
	
	for attID,value in ipairs(tbAtt)do
		local addVip = self:getVipValue(13)
		value = math.floor(value + addVip)
		self:addRoleAttValue(attID,value)
		cclog(lev,value,"=====reloadDalitLevAddAtt===222======",addVip)
	end 
	cclog(DalitExp,lev,"=====reloadDalitLevAddAtt===22========")
	
end
function playerMsg:reloadRoleBaseAttMsg()
	self:cleanRoleBaseAttMsg()
	--重置宠物光环
	self:cleanTbPetAddAttMsg()
	self:mathBaseAttMsg() --基础属性
	---计算装备  增加属性
	self:mathRoleEquAttMsg()
	---角色技能  增加属性
	self:mathRoleSkillAttMsg()
	---角色天赋  增加属性
	self:mathRoleTianfuAttMsg()
	---每日任务增加属性
	self:reloadDalitLevAddAtt()
	---计算主属性变换
	self:mathRoleMainAttChangeMsg()
	
end

---====================================================
---=====================================================
local tbPetAddAttMsg = {}
 --全体增加
function playerMsg:getTbPetAddAttMsg(attID)
	if not attID then
		return tbPetAddAttMsg
	end 
	return tbPetAddAttMsg[attID]
end 
function playerMsg:addTbPetAddAttMsg(attID,value)
	if not tbPetAddAttMsg[attID] then
		tbPetAddAttMsg[attID] = 0
	end 	
	tbPetAddAttMsg[attID]  = tbPetAddAttMsg[attID] + value
end 
function playerMsg:cleanTbPetAddAttMsg()
	 tbPetAddAttMsg = {}
end 
--全体增加
function playerMsg:mathTbPetAddAttMsg(tbValue)
	for attID,v in ipairs(tbPetAddAttMsg)do
		if not tbValue[attID] then
			tbValue[attID] = 0
		end 
		tbValue[attID] = tbValue[attID] + v
	end 
	return tbValue
end 


local petTbMsg = {}
function playerMsg:getpetTbMsg(petID)
	if petID  then
		local tbsmg = petTbMsg[petID] 
		return tbsmg
	end 
	return petTbMsg
end

function playerMsg:setpetTbMsg(info)  

	petTbMsg[info.id] = info
end

function playerMsg:setpetTbMsgAll(info)   
	if not info then
		return
	end 
	petTbMsg = info
end


local tbTujianMsg = {}
function playerMsg:getTbTujianMsg(ID)
	if ID then
		return tbTujianMsg[ID]
	end
	return tbTujianMsg
end
function playerMsg:setTbTujianMsg(info)
	tbTujianMsg[info.id] = info
end
function playerMsg:setTbTujianMsgAll(info)
	tbTujianMsg = info
end
function playerMsg:getpetSkillTbMsgLev(cfgID)
	local cfgID = math.floor(cfgID/10)*10 +1
	local info = self:getTbTujianMsg(cfgID) or {}
	local lev = info.lev or 1
	local nExp = info.nExp or 1
	--cclog(cfgID,"===getpetSkillTbMsgLev======",lev,nExp)
	return lev,nExp
end

 --技能单个属性增加 
function playerMsg:mathSkillAddAttMsg(PetID,tbValue)
	local info = self:getpetTbMsg(PetID)
	--技能增加
	if not info.skillMsg then
		info.skillMsg = {}
	end 
	local tbSkillValue = tbValue or {}
	for i=1,6 do
		local skillMsg = info.skillMsg[i] or {}
		local skillID = skillMsg.value1 or 0
		if skillID > 0  then
			if  skillID < 87000101  then
				skillID = 87000101
				info.skillMsg[i].value1 = 87000101
				self:setpetTbMsg(info)
			end 
			local tbMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillID)
			local attID = tbMsg.attID1
			local attID2 = tbMsg.attID2
			if  attID > 0   then
				local skillIDLev =  g_bagMsg:getpetSkillTbMsgLev(skillID)  
				local tb_number = g_mathConTrol:mathPetSkillValue(skillIDLev,skillID)
				if not tbSkillValue[attID]  then
					tbSkillValue[attID]  = 0
				end 
				tbSkillValue[attID] = addBigInt(tbSkillValue[attID], tb_number[1])
				if attID2 > 0 then
					if not tbSkillValue[attID2]  then
						tbSkillValue[attID2]  = 0
					end 
					tbSkillValue[attID2] = addBigInt(tbSkillValue[attID2], tb_number[2])
				end 
			end 
		end 
	end 
	return tbSkillValue
end
function playerMsg:mathPetAttHurt(index) ---计算宠物属性伤害
	local tbAttID = {64,65,66,67}
	local value = self:getTbPetAddAttMsg(tbAttID[index])
	return value
end 


---==============================================

function playerMsg:getPetAttValue(tbValue,curAttID)
	local proID = curAttID*1000+3
	local addValue = "0"
	local pct = "0"
	for attID,v in pairs(tbValue)do
		if curAttID == attID then
			addValue = addBigInt(addValue, v)
		elseif  proID == attID then
			pct = addBigInt(pct, v)
		end 
	end 
	return  addValue ,pct
end 

function playerMsg:mathPetBaseAtt(lev,index,zizhi,PetID,isFloor) ---计算基础属性
	local attIDRation = {22,30,18,20,80}
	local info = self:getpetTbMsg(PetID)
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",info.cfgID) 
	local baseValue = cfgMsg["baseValue"..index]
	local baseValue = math.floor( baseValue + lev*zizhi/attIDRation[index]*baseValue)
	--技能属性
	local tbattID = {11,12,15,17,43}

	---获取技能  增加
	local tbValue  = self:mathSkillAddAttMsg(PetID)
	---全体增加  增加
	local tbValue = self:mathTbPetAddAttMsg(tbValue)
	
	local curID = tbattID[index]
	
	local addValue ,pct  =  self:getPetAttValue(tbValue,curID)
	--lyu
	local tbLyattID = {4,8,1,3,9}
	local lyvalue = self:mathZhongzhuValueAtt(cfgMsg.zhongzhu,tbLyattID[index])
	pct = pct + lyvalue
	
	pct = tostring(1 + tonumber(pct)/100)
	local  final1 = addBigInt(baseValue, addValue)
	local final,strLDEndCN =  byBigInt(final1, pct,isFloor) ;
	
	--统帅
	local addValue =  self:getRoleAttValue(33,true) 
	local tbRation = {0.5,0.2,1.5,0.3,0}
	--cclog("======getRoleAttValue====",addValue,tbRation[index],index)
	local addValue =  byBigInt(addValue, tbRation[index],true) 
	
	final = addBigInt(final, addValue)
	if isNumber then
		final = tonumber(final)
	end 

	return final,strLDEndCN,addValue
end 

function playerMsg:mathPetAttCe(info,index,Level) ---计算基础属性2
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",info.cfgID) 
	local tbAttValue =  info.attValue or {}
	local attValue = tbAttValue[index] or 0
	local addLevValue = 0
	local value
	if index == 4 then
		value = self:getTbPetAddAttMsg(54) or  0
		local lyvalue = self:mathZhongzhuValueAtt(cfgMsg.zhongzhu,10)
		value = attValue + value + lyvalue

	else
		local addValue =  self:getRoleAttValue(33,true) 
		local lev = Level or info.Level
		addLevValue = cfgMsg["addAttCe"..index] * lev
		value = cfgMsg["TextAttCe"..index]  + addLevValue
		
		local tbLyattID = {5,100,7}
		local lyvalue = self:mathZhongzhuValueAtt(cfgMsg.zhongzhu,tbLyattID[index])
		
		value = (value + addValue*0.3)*(1+ lyvalue/100)
	end 
	
	local addVip = self:getVipValue(24)
	value = math.floor(value * (1+addVip/100))
	
	local tbattID = {19,18,20,22}

	---获取技能  增加
	local tbValue  = self:mathSkillAddAttMsg(info.id)

	local curID = tbattID[index]
	---全体增加  增加
	local tbValue = self:mathTbPetAddAttMsg(tbValue)
	
	local addValue ,pct  =  self:getPetAttValue(tbValue,curID)
	pct = tostring(1 + tonumber(pct)/100)
	local  final1 = addBigInt(value, addValue)
	
	local final,strLDEndCN =  byBigInt(final1, pct) ;
	
	if isNumber then
		final = tonumber(final)
	end 
	
	return final,strLDEndCN
end 

--=============================================================================
local tbInteger = {}
function playerMsg:setTbInteger(tbValue)
	tbInteger = tbValue
end

function playerMsg:setTbIntegerByID(id,tbValue)
	tbInteger[id] = tbValue
end

function playerMsg:getTbInteger(id)
	if tbInteger[id] then
		return tbInteger[id].value
	end 
	return  
end

function playerMsg:getPetZZ(petID)  
	local info = self:getpetTbMsg(petID)
	if not info then
		return
	end 
	local zzValue = info.zhizi
	local addzz = self:getTbPetAddAttMsg(62) or  0
	local  starLev = info.starLev or 0
	
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",info.cfgID)
	local lyvalue = self:mathZhongzhuValueAtt(cfgMsg.zhongzhu,2)
	
	zzValue = zzValue + addzz + starLev*0.3 + lyvalue
	return zzValue
end 

local roleSkillTbMsg = { 
	-- roleSkillInfo
}

function playerMsg:getroleSkillTbMsg(ID)
	if ID  then
		local tbsmg = roleSkillTbMsg[ID] 
		return tbsmg
	end 
	return roleSkillTbMsg
end
	
	
function playerMsg:getroleSkillTbMsgLev(indexD)
	local info = self:getroleSkillTbMsg(indexD) or {}
	local lev = info.lev or 0
	local addVa =  self:getTianfuOpenValue(28)
	lev = lev + addVa
	return lev
end

function playerMsg:setroleSkillTbMsg(info)  
	roleSkillTbMsg[info.id] = info
end
function playerMsg:setroleSkillTbMsgAll(info)   
	if not info then
		return
	end 
	roleSkillTbMsg = info
end

local other = {}
function playerMsg:setOther(tbValue)
	other = tbValue
end
function playerMsg:setOtherByID(id,value)
	other[id] = {id = id, value =value }
end
function playerMsg:getOther(id)
	if other[id] then
		if not other[id] then
			return
		end 
		return other[id].value
	end 
	return 
end


---------------发送获取UserID 数据---------------------------------------------------------
function playerMsg:sendGetUserIDMsg(userID,dyID)
	g_svSendMsgControl:request_getInitMsg(1,userID)
	g_svSendMsgControl:request_getRoleMsg(1000,userID)
	g_svSendMsgControl:request_getPetMsg(1000,userID)
	
	g_svSendMsgControl:request_getEquMsg(1000,userID)
	g_svSendMsgControl:request_getTianfuMsg(1000,userID)
	g_svSendMsgControl:request_lyuInfo(1000,userID)
	
	g_svSendMsgControl:request_getRoleSkillMsg(1000,userID)
	self.toUserID = userID
	self.dyID = dyID
	local function callback() --开始战斗
		self:reloadRoleBaseAttMsg()
		g_WndMgr:showWnd("B_FbBatPk")
	end 

	g_svSendMsgControl:request_geTujianMsg(1000,userID,nil,callback)

end 


---------------获取UserID 数据------保存---------------------------------------------------
 
function playerMsg:saveGetUserIDMsg1(response)
	
	local tbResValue = response.tbResValue
	local thOtherMsg = response.thOtherMsg
	local tbInteger = response.tbInteger
	local userID = response.userID
	for i,info in pairs(tbResValue)do
		cclog(g_resCfgId.jifen,"=====saveGetUserIDMsg1========",i,info )
		if i == g_resCfgId.jifen then	
			self:setjfMsg(info.number)
		end 
	end 
	if response.thOtherMsg then  
		self:setOther(response.thOtherMsg)
	end 
	self.nickname = response.szerror
	if response.tbInteger then  
		self:setTbInteger(response.tbInteger)
	end 
	cclog(otherDBMsgID.daliyExp,"====saveGetUserIDMsg1=======",self.nickname)
end 

function playerMsg:saveGetUserIDMsg2(response)
	local userID = response.status
	local RoleAttInfo = response.RoleAttInfo 
	local BaseInfo = response.BaseInfo 
	for i,info in pairs(RoleAttInfo)do
		self:setRoleTbMsgOne(info)
	end 
	self:setRoleBaseInfoTbMsg(BaseInfo)
	local tbSkillID = response.tbSkillID 
	local tbZbID = response.tbZbID 
	self:setTbZbIDAll(tbZbID)  
	self:setTbSkillIDAll(tbSkillID)  
end

function playerMsg:saveGetUserIDMsg3(response)
	local userID = response.status
	local tbPetInfo = response.tbPetInfo 
	cclog("====saveGetUserIDMsg3=======",tbPetInfo)
	self:setpetTbMsgAll(tbPetInfo)   
end 

function playerMsg:saveGetUserIDMsg4(response)
	local userID = response.status
	local tbEquInfo = response.tbEquInfo 
	self:setEuqTbMsgAll(tbEquInfo)   
end 
function playerMsg:saveGetUserIDMsg5(response)
	local userID = response.status
	local tianfuInfo = response.tianfuInfo 
	self:setTianfuTbMsgAll(tianfuInfo)   
end 

function playerMsg:saveGetUserIDMsg6(response)
	local userID = response.status
	local roleSkillInfo = response.roleSkillInfo 
	roleSkillTbMsg = {}
	self:setroleSkillTbMsgAll(roleSkillInfo) 
end 

function playerMsg:saveGetUserIDMsg7(response)
	local userID = response.status
	local tujianInfo = response.tujianInfo 
	self:setTbTujianMsgAll(tujianInfo)
	---开始战斗
end 


---============================================
local lyInfoTbMsg = {}
function playerMsg:getlyTbMsg(ID)
	if ID  then
		local tbsmg = lyInfoTbMsg[ID] 
		return tbsmg
	end 
	return lyInfoTbMsg
end

function playerMsg:setlyTbMsg(info)  
	lyInfoTbMsg[info.id] = info
end

function playerMsg:setlyTbMsgAll(info)   
	if not info then
		return
	end 
	lyInfoTbMsg = info
end


--============================================================
function playerMsg:mathExpAndlev(ID)  
	local info =  lyInfoTbMsg[ID] or {}
	local nExp = info.nExp or 0
	if nExp <= 0 then
		return 0,0,1030
	end 
	local cfgMsg =  g_cfgMsg:getCfgMsg("lingyuLev_D") 
	local lev = 0
	local maxExp = 117120
	for i,v in ipairs(cfgMsg)do
		if nExp >= v.getExp then
			nExp = nExp - v.getExp
			lev = i
		else
			maxExp = v.getExp
			break
		end 
	end 
	if lev > 48 then
		lev = 48
	end 
	cclog(lev,nExp,maxExp,"==222====mathExpAndlev===")
	return lev,nExp,maxExp
end 

function playerMsg:mathAttValue(cfgID,lev,yanse) 
	local cfgMsg =  g_cfgMsg:getCfgMsg("lingyu_D",cfgID) 
	if yanse < 1 then
		yanse = 1
	end 
	local Value = cfgMsg.baseValue + (cfgMsg.addValue + (cfgMsg.addValue2*yanse-1) ) * lev 
	return Value
end 

function playerMsg:mathZhongzhuValue2(cIndex) 
	local qhValye = self:mathQiheValue(cIndex) 
	local yanse  = self:mathZhongzhuYanse(qhValye) 
	local value = self:mathZhongzhuValue(cIndex,yanse) 
	return value
end 

function playerMsg:mathZhongzhuValue(cfgID,yanse) 
	local cfgMsg =  g_cfgMsg:getCfgMsg("lingyuLev_D",cfgID) 
	local Value = cfgMsg.baseValue + cfgMsg.addValue * yanse
	return Value
end 

function playerMsg:mathZhongzhuYanse(qhValye) 
	local tbMsg = {20,40,60,80,100,120}
	local yanse = 0
	for i,v in ipairs(tbMsg)do
		if qhValye < v then
		else
			yanse = i
		end 
	end 
	return yanse
end 

function playerMsg:mathQiheValue(cIndex) 
	local value = 0
	for index=1,8 do
		local ID = cIndex*100 + index
		local info =  lyInfoTbMsg[ID] or {}
		local yanse = info.yanse or 0
		if yanse > 0   then	
			local cfgMsg =  g_cfgMsg:getCfgMsg("lingyuLev_D",yanse) 
			value = value + cfgMsg.addValue
		end 
	end 
	return value
end 

----计算属性
function playerMsg:mathZhongzhuValueAtt(zzhuType,attCfgID)
	local value = 0
	for index=1,8 do
		local ID = zzhuType*100 + index
		local info =  lyInfoTbMsg[ID] or {}
		local yanse = info.yanse or 0
		if yanse > 0   then	
			local  cfgID = info.cfgID 
			if attCfgID == cfgID then
				local lev = self:mathExpAndlev(ID)  
				local  addValue = self:mathAttValue(cfgID,lev,yanse) 
				value = value + addValue
			end 
		end 
	end 
	return value
end 


function playerMsg:ctor()
	
end

g_playerMsg =  playerMsg:create()