------------------
-- 文件名:	TujianMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	制作数据
-- 应  用:  
-------------------
local TujianMsg = class("TujianMsg")

local tbTujianMsg = {}
function TujianMsg:getTbTujianMsg(ID)
	if ID then
		return tbTujianMsg[ID]
	end
	return tbTujianMsg
end
function TujianMsg:setTbTujianMsg(info)
	tbTujianMsg[info.id] = info
end
function TujianMsg:setTbTujianMsgAll(info)
	tbTujianMsg = info
end
----=====================

function TujianMsg:mathTaoNum(taoCfgID)
	local baseIndex = math.floor(taoCfgID/100)*100
	local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D",baseIndex + 1)
	local num = tbMsg.num
	local maxCount = num*7
	local count = 0
	for i=1,num do
		local cfgID = baseIndex + i
		local info =  self:getTbTujianMsg(cfgID) or {}
		if info.yanse and info.yanse > 0 then
			count =  count  +  info.yanse
		end 
	end 
	return count,maxCount
end
function TujianMsg:mathRoleTjPro(maxNum)
	local pro = math.floor( self.tbProCountMsg[1]*1000 /maxNum )/100
	return pro
end 
function TujianMsg:mathRoleSkillTjPro(maxNum)
	local pro = math.floor( self.tbProCountMsg[2]*1000 /maxNum )/100
	cclog(pro,"======mathEquTaoPro=22====",self.tbProCountMsg,maxNum)
	return pro
end 
function TujianMsg:mathPetTjPro(maxNum)
	local pro = math.floor( self.tbProCountMsg[3]*1000 /maxNum )/100
	cclog(pro,"======mathEquTaoPro=33====",self.tbProCountMsg,maxNum)
	return pro
end 
function TujianMsg:mathPetSkillPro(maxNum)
	local pro = math.floor( self.tbProCountMsg[4]*1000 /maxNum )/100
	cclog(pro,"======mathEquTaoPro=444===",self.tbProCountMsg,maxNum)
	return pro
end 
function TujianMsg:mathEquPro(maxNum)
	local pro = math.floor( self.tbProCountMsg[5]*1000 /maxNum )/100
	cclog(pro,"======mathEquTaoPro=22=====",self.tbProCountMsg,maxNum)
	return pro
end 

function TujianMsg:mathEquTaoPro()
	local maxNum = 0
	
	local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D")
	local tbCountMsg = {}
	for i,v in pairs(tbMsg)do
		if not tbCountMsg[v.nTaozhuangType] and v.openType ~= -1 then
			 tbCountMsg[v.nTaozhuangType] = v.num
			--cclog("===mathEquTaoPro=====",v.num,v.nTaozhuangType)
			 maxNum = maxNum + v.num
		end 
	end 

	local maxCount = maxNum*7
	local pro = math.floor( self.tbProCountMsg[6]*1000 /maxCount)/100
	--cclog(pro,"======mathEquTaoPro======",self.tbProCountMsg,maxCount,maxNum)
	
	return pro
end 

function TujianMsg:mathAllpro()
	self.tbProCountMsg = {0,0,0,0,0,0,0}
	for cfgID,info in pairs(tbTujianMsg)do
		if  cfgID >= 90000001 and cfgID <=  90000901 then
			self.tbProCountMsg[1] = self.tbProCountMsg[1] + info.yanse
		elseif  cfgID >= 95000001 and cfgID <=  95002020 then
			self.tbProCountMsg[2] = self.tbProCountMsg[2] + info.yanse
		elseif  cfgID >= 86000001 and cfgID <=  86001001 then	
			self.tbProCountMsg[3] = self.tbProCountMsg[3] + info.yanse
		elseif  cfgID >= 87000001 and cfgID <=  87019187 then	
			--cclog("========info=======",info)
			self.tbProCountMsg[4] = self.tbProCountMsg[4] + info.yanse
		elseif  cfgID >= 60100001 and cfgID <=  60901040 then		
			self.tbProCountMsg[5] = self.tbProCountMsg[5] + info.yanse
		elseif  cfgID >= 61100001 and cfgID <=  61193009 then		
			self.tbProCountMsg[6] = self.tbProCountMsg[6] + info.yanse	
		end
	end 
	cclog("======tbTujianMsg=========",self.tbProCountMsg)
end



function TujianMsg:ctor()
	self.tbProCountMsg = {0,0,0,0,0,0,0}
end

g_TujianMsg =  TujianMsg:create()