------------------
-- 文件名:	tianfuMsg.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	制作数据
-- 应  用:  
-------------------
local tianfuMsg = class("tianfuMsg")

local tianfuTbMsg = { 
	-- tianfuInfo
}

function tianfuMsg:getTianfuTbMsg(tianfuID)
	if tianfuID  then
		local tbsmg = tianfuTbMsg[tianfuID] 
		return tbsmg
	end 
	return tianfuTbMsg
end

function tianfuMsg:setTianfuTbMsg(info)  
	tianfuTbMsg[info.id] = info
end
function tianfuMsg:setTianfuTbMsgAll(info)   
	if not info then
		return
	end 
	tianfuTbMsg = info
end

function tianfuMsg:reloadTianfuTbMsgAll(info)   
	for  i,v in pairs(tianfuTbMsg)do
		v.lev = 0
	end 
end
---===========================================

---========================================
function tianfuMsg:getValuetianfu(cfgID,lev)   
	local cfgMsg =  g_cfgMsg:getCfgMsg("tianfu_D",cfgID)
	local baseValue = cfgMsg.value1
	local value1 = baseValue + (lev-1)*cfgMsg.add1
	return value1
end

function tianfuMsg:getNeedTimetianfu(id)   
	local info = self:getTianfuTbMsg(id)
	
	local cfgMsg =  g_cfgMsg:getCfgMsg("tianfu_D",info.cfgID)
	local baseTime = cfgMsg.nTime
	local index = math.floor((id-1)/4)
	local needTime = baseTime + baseTime * index*30 + baseTime*(info.lev)*5
	
	--cclog(needTime,"====getNeedTimetianfu=========",baseTime,index ,info.lev)
	return needTime
end

function tianfuMsg:getTFFreeNum()   
	local count = 0
	for i, info in pairs(tianfuTbMsg)do
		count = count + info.lev
	end 
	local curTianfuID = g_baseMsg:getOther(otherDBMsgID.curTianfuID) or  0
	if curTianfuID > 0  then
		count = count + 1
	end 

	local PointFreeNum = self:getTFPointFreeNum() 
	cclog(PointFreeNum,"====getTFFreeNum===",count,curTianfuID)
	
	return (PointFreeNum - count)
end
--当前天赋点
function tianfuMsg:getTFPointFreeNum() 
	local level = g_roleMsg:getRoleAttValue(RoleAttMsg.level,true)
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	local  addVip = g_viplevMsg:getVipValue(4)
	local value = tbGameConst.initTianfuNum + math.floor(level/20) 
	local maxvalue = self:getTFMaxFreeNum() 
	if value > maxvalue then
		value = maxvalue
	end 
	value = value + addVip
	cclog(value,"=====getTFPointFreeNum=====",zslevel,level,addVip,value,maxvalue)
	return value
end 

function tianfuMsg:getTFMaxFreeNum() 
	
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	local  addVip = g_viplevMsg:getVipValue(3)
	local value = tbGameConst.baseTianfuNum + zslevel*tbGameConst.addTianfuNum 
	
	return value
end

function tianfuMsg:ctor()

end

g_tianfuMsg =  tianfuMsg:create()