
local B_FbBatPk = class("B_FbBatPk")

function B_FbBatPk:initWnd()
	
	local function funcEndCallBack(btn,tag) 
		local tbQDMsg = {}
		tbQDMsg.dec =  "是否退出战斗"
		tbQDMsg.text1 = "确定"
		tbQDMsg.text2 = "取消"
		local function callBack()
			g_batContorl.gameStatus = gameStatus.batIng
			self:close()
		end 
		tbQDMsg.qdFunc =  callBack
		g_quedingItem:openWnd(tbQDMsg) 
	end
	g_SetBtnOne(self.rootLayout, "closeBtnD",2, funcEndCallBack)	
	
end 


function B_FbBatPk:getBossName(BOSSID,jinhua)
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	local iconname = tbMsg.icon
	local baseName = "【"..tbMsg.name.."】"
	
	local name,yanse
	if jinhua and jinhua > 0  then
		local tbJHMsg =  g_cfgMsg:getCfgMsg("roleJinJieLev_D",jinhua)
		local jjName = tbJHMsg.name
		yanse = tbJHMsg.nType
		name = jjName..baseName 
	else
		name = baseName
		yanse = 1
	end 
	if yanse > 7  then
		yanse = 7
	end 
	local colorID = G_tb_TextColor[yanse]
	cclog("========name,colorID,yanse====",name,colorID,yanse)
	return name,colorID,yanse,iconname
end 
function B_FbBatPk:setFbMsgPanleMyRole(nType)
	local nType = nType or 1
	local  roleItem =  self.rootLayout:getChild("roleItem"..nType) 
	
	local  textLev =  roleItem:getChild("textLev") 
	local  roleName =  roleItem:getChild("roleName")
	local  bossIcon =  roleItem:getChild("bossIcon")
	local c1 =  roleItem:getController("c1") --控制器
	local BOSSID,jinhua 
	if nType == 1 then
		BOSSID = g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
		jinhua = g_roleMsg:getRoleAttValue(RoleAttMsg.jinhua,true)
	elseif  nType == 2 then
		BOSSID = g_playerMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSID) or 90000001
		jinhua = g_playerMsg:getRoleAttValue(RoleAttMsg.jinhua,true)
	end 
	local name,colorID,yanse,iconname = self:getBossName(BOSSID,jinhua)
	roleName:setText(name)
	cc.g_setTextColor(roleName,colorID,true)
	c1:setSelectedIndex(yanse-1)
	bossIcon:setIcon(g_iconConTrol:getBossIcon(iconname))

	self:setFbMsgPanleRoleMp(nType)
	self:setFbMsgPanleRoleHp(nType)
end 
function B_FbBatPk:setFbMsgPanleRoleMp(nType)
	local nType = nType or 1
	local  roleItem =  self.rootLayout:getChild("roleItem"..nType) 
	local  mpBar = roleItem:getChild("mpBar") 
	local info = g_batTbMsgPK:getBatInfo(nil,nType)
	cclog(nType,"======setFbMsgPanleRoleMp=======",info)
	mpBar:setMax(info.maxMp)
	mpBar:setValue(info.mp)
end 
function B_FbBatPk:setFbMsgPanleRoleHp(nType)
	local nType = nType or 1
	
	local  roleItem =  self.rootLayout:getChild("roleItem"..nType) 
	local  hpBar = roleItem:getChild("hpBar") 
	local  titleD = hpBar:getChild("titleD") 
	local info = g_batTbMsgPK:getBatInfo(nil,nType) 	
	cclog(nType,"====22==setFbMsgPanleRoleMp=======",info)
	local pro =  porBigInt(info.hp, info.maxHp,true) 
	hpBar:setMax(100)
	hpBar:setValue(pro)
	titleD:setText(info.hp)
end 


function B_FbBatPk:setFbMsgPanlePetHp(index)
	local  cuItem =  self.rootLayout:getChild("petItem"..index) 
	local info = g_batTbMsgPK:getBatInfo(index) 	
	local  hpBar =  cuItem:getChild("hpBar") 
	local pro =  porBigInt(info.hp, info.maxHp,true) 
	hpBar:setValue(pro)
	return hpBar
end 
function B_FbBatPk:setFbMsgPanleCW(index)
	
	local  cuItem =  self.rootLayout:getChild("petItem"..index) 
	local info =  g_batTbMsgPK:getBatInfo(index) or {}
	cclog(info,"=======setFbMsgPanleCW==22===",index)
	
	if not info.index   then
		cuItem:setVisible(false)
		return
	end 
	cuItem:setVisible(true)
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",info.cfgID) 
	local  title =  cuItem:getChild("title") 
	title:setText(cfgMsg.name)
	cuItem:setIcon(g_iconConTrol:getPetYanseIcon(info.yanse))
	--local colorID = G_tb_TextColor[info.yanse]
	--cc.g_setTextColor(title,colorID,true)
	local  iconBg = cuItem:getChild("iconBg") 
	iconBg:setIcon(g_iconConTrol:getPetYanseBgIcon(info.yanse))
	

	local  starText = cuItem:getChild("starText") 
	starText:setText(G_tb_starText[(info.starLev or 0)])
end 

function B_FbBatPk:showMpStatusText(index,Cindex,txte)
	local nType = g_batContorlPK:getNtype(index)
	local  roleItem =  self.rootLayout:getChild("roleItem"..nType) 
	local c2 =  roleItem:getController("c2") --控制器
	if not Cindex then
		Cindex = 0
	end 
	c2:setSelectedIndex(Cindex)
		
	local  MPTextStatus = roleItem:getChild("MPTextStatus") 
	if not txte then
		txte = "魔法不足"
	end 
	cclog("===showMpStatusText=====",txte)
	MPTextStatus:setText(txte)
	return 
end 

function B_FbBatPk:closeWnd()
   g_batContorl.gameStatus = gameStatus.batIng
end 

function B_FbBatPk:openWnd(index,noGuid)
	--战斗
	g_batWndContorlPK:initItemPool()	
	self:showMpStatusText(1)
	self:showMpStatusText(2)
	self.countResD = "0"
	g_batContorlPK:initGameMsg()

end 

	
return B_FbBatPk
