
local B_Role = class("B_Role")


---=======================================================================
function B_Role:setRoleID()
	local  Test_playerID =  self.rootLayout:getChild("Test_playerID")  
	Test_playerID:setText("ID:"..g_GameDataMgr.userid)
	
	local  Test_playerName =  self.rootLayout:getChild("Test_playerName")  
	Test_playerName:setText(g_GameDataMgr.nickname)

end

function B_Role:initWnd()
	local tbMsg = {"LvUpPanle","jinhuaPanle","zhuanshengPanle","SkillPanle","tujianPanle","tuanfuPanle","tongjiPanle",[8] = "ComponentAttDec"}
	local c1 =  self.rootLayout:getController("c1") --控制器
	local function funcEndCallBack(btn,tag) 
		cclog("======initWnd======",tag)
		
		if tag <= 3 then
			
			c1:setSelectedIndex(1)
			g_panleMgr:showWndPanle(tbMsg[tag])
		elseif tag == 4 then
			g_WndMgr:showWnd("SkillPanle")
		elseif tag == 5 then	
			g_WndMgr:showWnd("tujianPanle")
		elseif tag == 6 then
			g_WndMgr:showWnd("tuanfuPanle")
		elseif tag == 8 then	
			c1:setSelectedIndex(1)
			g_panleMgr:showWndPanle(tbMsg[tag])
		else
			c1:setSelectedIndex(2)
		end 
	end 

	g_SetBtnOne(self.rootLayout, "btnsj",1, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnjh",2, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnzs",3, funcEndCallBack)
	g_SetBtnOne(self.rootLayout, "btnjn",4, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btntj",5, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btntf",6, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btntongji",7, funcEndCallBack)
	
	g_SetBtnOne(self.rootLayout, "btnAtt",8, funcEndCallBack)
	self:setRoleID()
	self:registerAllAttItem()	
end 

function B_Role:setLevBar()
	local  levBar =  self.rootLayout:getChild("levBar")  
	---local nExp = g_roleMsg:getRoleAttValue(RoleAttMsg.exp)
	local level = g_roleMsg:getRoleAttValue(RoleAttMsg.level)
	local MaxLev =  g_roleAttConTrol:getMaxLev()
	cclog(level,"====MaxLev===",MaxLev)
	levBar:setValue(level)
	levBar:setMax(MaxLev)
	--local  n44 =  self.rootLayout:getChild("n44")  
	--n44:setText(level)
end 
function B_Role:setJHBar()
	local  jhBar =  self.rootLayout:getChild("jhBar")  
	local jinhua = g_roleMsg:getRoleAttValue(RoleAttMsg.jinhua,true)
	local MaxJinHua =  g_roleAttConTrol:getRoleMaxJinHua()
	jhBar:setValue(jinhua)
	jhBar:setMax(MaxJinHua)
	--local  n46 =  self.rootLayout:getChild("n46")  
	--n46:setText(level)
end 
function B_Role:setZSBar()
	local  zsBar =  self.rootLayout:getChild("zsBar")  
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	zsBar:setValue(zslevel)
	zsBar:setMax(g_MAXZhuanShenglev)
	--local  n45 =  self.rootLayout:getChild("n45")  
	--n45:setText(level)
end 

function B_Role:showAnnima(Ntype)
	local movieName ,pos,scale
	if Ntype ==  1 then
		movieName = "MovieClip3"
		pos = {-150,200}
		scale = 2
	elseif  Ntype ==  2 then
		movieName = "MovieClip4"
		pos = {70,230}
		scale = 1.3
	elseif  Ntype ==  3 then
		movieName = "MovieClip5"
		pos = {60,100}
		scale = 1.5
	end 
	
	local  movieClip = fgui.UIPackage:createObject("z_effct",movieName)
	
	movieClip:setPosition(pos[1],pos[2])
	movieClip:setScale(scale,scale)
	self.rootLayout:addChild(movieClip)
	
	local function Moviecallback()
		movieClip:removeFromParent()
   end
	movieClip:setPlaySettings(0,-1,1,-1,Moviecallback)
end 

function B_Role:setZBPanle(Index)
	local  euqItem =  self.rootLayout:getChild("euqItem"..Index) 
	local zbID = g_roleMsg:getTbZbID(Index) or 0
	local c1 =  euqItem:getController("c1") --控制器
	if zbID > 0 then
		c1:setSelectedIndex(0)
		g_zbContorl:setZbItem1(zbID,euqItem)
	else
		c1:setSelectedIndex(1)
	end 
	
	local function funcEndCallBack(btn,tag) 
		g_WndMgr:showWnd("B_Bag",0,Index,1)
	end
	g_SetBtnOne(nil, nil,8, funcEndCallBack,euqItem)
	
end 
function B_Role:setZBPanleAll()
	for i=1,9 do
		self:setZBPanle(i)
	end 
end 
function B_Role:setFubenPanle()
	--local  fubenText =  self.rootLayout:getChild("fubenText") 
	--local strName = g_roleAttConTrol:getFubenName()
	--fubenText:setText(strName)
end 
function B_Role:setBossPanle()
	local  rolePanle =  self.rootLayout:getChild("rolePanle") 
	local  bossIcon =  rolePanle:getChild("bossIcon") 
	local  zzText =  rolePanle:getChild("zzText") 
	local  zzByText =  rolePanle:getChild("zzByText") 
	local  roleName =  rolePanle:getChild("roleName") 

	zzText:setText("资质："..g_roleAttConTrol:getZizhi())

	local name,colorID,iconname,yanse = g_roleAttConTrol:getBossName()
	roleName:setText(name)
	cc.g_setTextColor(roleName,colorID,true)
	
	bossIcon:setIcon(g_iconConTrol:getBossIcon(iconname))
	
	local c1 =  rolePanle:getController("c1") --控制器
	c1:setSelectedIndex(yanse-1)
	
	local bianyi =  g_roleMsg:getRoleBaseInfoTbMsg(tbRoleBaseID.BOSSIDBianyi) or 0
	cclog(bianyi,"=====getRoleBaseInfoTbMsg========")
	if bianyi == 1 then
		zzByText:setVisible(true)
	else
		zzByText:setVisible(false)
	end 
end 


function B_Role:setListItemEquTaoItem(obj,nType,num)
	local cfgID = 61100001 + (nType - 1)*100
	local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D",cfgID)
	local name = tbMsg.nameT2..num
	local index = math.floor(num/3)
	local c1 =  obj:getController("c1") --控制器
	c1:setSelectedIndex(index)
	obj:setText(name)
end

function B_Role:reloadListEuqTaoList(reload)
	local  equTaoList =  self.rootLayout:getChild("equTaoList") 
	local tbMsg = {}
	for nType,v in pairs(g_roleMsg.tbTaozMsg)do
		tbMsg[#tbMsg + 1] =  {nType,v}
	end 

	equTaoList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local nType = tbMsg[indexD][1]
			local num = tbMsg[indexD][2]
			obj:setCustomData(nType)
			self:setListItemEquTaoItem(obj,nType,num)
		end)
	equTaoList:setVirtual()--回调
	equTaoList:setNumItems(#tbMsg);
end 

function B_Role:reloadWnd()
	---cclog("==reloadWnd===111=",debug.traceback())
	self:setLevBar()
	self:setJHBar()
	self:setZSBar()
	self:setBossPanle()
	self:setFubenPanle()
	self:setZBPanleAll() 
	self:registerAllAttItem()	
	self:reloadListEuqTaoList()
end 

function B_Role:registerAllAttItem()	
	local chidren = self.rootLayout:getChildren()
	for i =1, #chidren do	
		local curChild = chidren[i] 
		local customData = curChild:getCustomData() 
		
		if type(customData)== "string" and tonumber(customData) < 1000 then
			customData = tonumber(customData)
			
			g_roleAttConTrol:registerAttLisener(customData,"B_Role",curChild)	
		end 
	end 
end

function B_Role:openWnd()
	self:reloadWnd()
	g_newGuide:isGuideContorlWnd("B_Role")
	local c1 =  self.rootLayout:getController("c1") --控制器
	c1:setSelectedIndex(0)
end 

	
return B_Role
