
local B_mShuoChang = class("B_mShuoChang")

function B_mShuoChang:initWnd()
	
	local function callBack()
		local ID = self:getID(self.touchIndex)
		local info = g_lyInfoMsg:getTbMsg(ID) 
		cclog("==DDD======callBack==========",ID)
		
		if not info or info.isJihuo == 0 then
			g_svSendMsgControl:request_lyuInfo(1,ID)
		else
			g_svSendMsgControl:request_lyuInfo(3,ID)
			self:showAnima(index)
		end 
	end 
	
	local function funcEndCallBack(btn,tag) 
		local ID = self:getID(self.touchIndex)
		if tag == 1 then
			local info = g_lyInfoMsg:getTbMsg(ID) 
			local str  = "更换需要花费500钻石"

			if not self.queding then
				local tbQDMsg = {}
				tbQDMsg.dec =  str
				tbQDMsg.text1 = "确定"
				tbQDMsg.text2 = "取消"
				
				tbQDMsg.qdFunc =  callBack
				g_quedingItem:openWnd(tbQDMsg)
				self.queding = 1
			else
				callBack()
			end 
		elseif tag == 2 then
			g_svSendMsgControl:request_lyuInfo(2,ID)
			self:showAnima2(index)
		end 
	end 
	g_SetBtnOne(self.rootLayout, "btngh",1, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnxj",2, funcEndCallBack)
	
	
	
	local function funcEndCallBack(btn,tag) 
		self:reload(tag)
		local t0 = self.rootLayout:getTransition("t0")
		t0:play()
	end 
	for i=1,5 do
		g_SetBtn(self.rootLayout, "btnType"..i,i, funcEndCallBack)
	end 
end 

function B_mShuoChang:setQiHeBar()
	local c1 =  self.rootLayout:getController("c1") --控制器
	local cIndex = c1:getSelectedIndex()
	local qhValye = g_lyInfoMsg:mathQiheValue(cIndex) 
	local textQihe =  self.rootLayout:getChild("textQihe") 
	local qiheBar =  self.rootLayout:getChild("qiheBar") 
	
	textQihe:setVar("value",tostring(qhValye)) 
	textQihe:flushVars()
	cclog(qhValye,"====qhValye================")
	qiheBar:setValue(qhValye)
end 

function B_mShuoChang:showDecPanle(index)
	local index = index or self.touchIndex
	local c1 =  self.rootLayout:getController("c1") --控制器
	local cIndex = c1:getSelectedIndex()
	local ID = self:getID(index)
	local info = g_lyInfoMsg:getTbMsg(ID) or {}

	if index ~= 0 then
		local c3 =  self.rootLayout:getController("c3") --控制器
		if info.isJihuo and info.isJihuo == 1 or index == 1 then
			 c3:setSelectedIndex(0) 
		else
			 c3:setSelectedIndex(1)
			 return
		end 
	end 

	local textTitle =  self.rootLayout:getChild("textTitle") 
	local textAdd =  self.rootLayout:getChild("textAdd") 
	local textDec =  self.rootLayout:getChild("textDec") 
	local decIcon =  self.rootLayout:getChild("decIcon") 
	local cfgID = info.cfgID
	local name 
	local yanse = info.yanse
	local lev,nExp,maxExp =  g_lyInfoMsg:mathExpAndlev(ID)
	local pro = math.floor(nExp*100/maxExp)
	local starText =  self.rootLayout:getChild("starText") 
	local c4 =  self.rootLayout:getController("c4") --控制器
	if index == 0 then
		decIcon:setVisible(false)
		starText:setVisible(false)
		cfgID = cIndex + 1
		local cfgDecMsg =  g_cfgMsg:getCfgMsg("lingyuLev_D",cfgID) 
		textAdd:setText("")
		name = cfgDecMsg.name2
		local qhValye = g_lyInfoMsg:mathQiheValue(cIndex) 
		yanse  = g_lyInfoMsg:mathZhongzhuYanse(qhValye) 
		local value = g_lyInfoMsg:mathZhongzhuValue(cfgID,yanse) 
		local tb_Str = {"x"}
		local tb_number = {value}
		local dec = cc.g_inalienContentByTbNumber(cfgDecMsg.zhongzuSkill,tb_Str,tb_number)  
		
		cclog(dec,"===DD=showDecPanle=",cfgID)
		textDec:setText(dec)
		c4:setSelectedIndex(1)		
	else
		local cfgMsg =  g_cfgMsg:getCfgMsg("lingyu_D",cfgID) 
		name = cfgMsg.name
		local iconPath = g_iconConTrol:getLyuIcon(cfgMsg.icon)
		decIcon:setVisible(true)
		decIcon:setIcon(iconPath)
		textAdd:setText("")	
		
		local tb_Str = {"x"}
		local value = g_lyInfoMsg:mathAttValue(cfgID,lev,yanse) 
		local tb_number = {value}
		local dec = cc.g_inalienContentByTbNumber(cfgMsg.dec,tb_Str,tb_number)  
		textDec:setText(dec)
		
		starText:setVisible(true)
		starText:setText(G_tb_starText2[lev]) 	
		name = name..pro.."%"
		self:setCoseCl(index)
		self:setBtnText(index)
		c4:setSelectedIndex(0)		
	end 
	textTitle:setText(name)	
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(textTitle,colorID,true)

	
end 

function B_mShuoChang:setCoseCl(index)
	local textCl =  self.rootLayout:getChild("textCl") 
	local  goodsID,num = g_lyInfoMsg:mathCLValue(index) 
	cclog(goodsID,num,"=========setCoseCl======",index)
	local name,yanse = g_getNameConTrol:getAllMsg(goodsID)
	
	textCl:setText(name..":"..num)
end 

function B_mShuoChang:setBtnText(index)
	local btngh =  self.rootLayout:getChild("btngh") 
	local ID,cIndex = self:getID(index)
	local info = g_lyInfoMsg:getTbMsg(ID)
	if info and info.isJihuo == 1 or index == 1 then
		btngh:setText("更换")
	else
		btngh:setText("激活")
	end 
	
end 

function B_mShuoChang:touchItem(index)
	if self.touchIndex then
		local item =  self.rootLayout:getChild("item"..self.touchIndex) 
		local c2 =  item:getController("c2") --控制器
		c2:setSelectedIndex(0)
	end
	self.touchIndex = index
	local item =  self.rootLayout:getChild("item"..index) 
	local c2 =  item:getController("c2") --控制器
	c2:setSelectedIndex(1)
	self:showDecPanle(index)
end 


function B_mShuoChang:showAnima(index)
	local index = index or self.touchIndex
	local ID,cIndex = self:getID(index)
	local item =  self.rootLayout:getChild("item"..index) 
	
	local Panel_ = item:displayObject()
	local pos = cc.p(50,50)
	local ArmatureEndA = g_gArmature:showArmatureByNums("FateSellAnimation",nil,Panel_,nil,nil,pos,1.5,endCallBcak)
	g_gameMusic:playEffect(73)
end 
function B_mShuoChang:showAnima2(index)
	local index = index or self.touchIndex
	local ID,cIndex = self:getID(index)
	local item =  self.rootLayout:getChild("item"..index) 
	local pos = cc.p(50,60)
	local  ArmatureEndA = g_gArmature:showArmature("FuncShowExplode",item,nil,nil,pos)
	ArmatureEndA:setScale(1)
end


function B_mShuoChang:getID(index)
	local c1 =  self.rootLayout:getController("c1") --控制器
	local cIndex = c1:getSelectedIndex()
	cclog(cIndex,"====getID====")
	local ID = cIndex*100 + index
	return ID ,cIndex
end  

function B_mShuoChang:setItem(index)
	if index == 0 then
		self:setItem0()
		return
	end 
	local ID,cIndex = self:getID(index)
	local item =  self.rootLayout:getChild("item"..index) 
	local info = g_lyInfoMsg:getTbMsg(ID)
	local c1 =  item:getController("c1") --控制器
	
	local function funcEndCallBack(btn,tag) 
		if info and info.isJihuo == 1 or index == 1 then
			self:touchItem(index)	
		else
			local tbQDMsg = {}
			tbQDMsg.dec =  "是否花费5000转生丹开启"
			tbQDMsg.text1 = "确定"
			tbQDMsg.text2 = "取消"
			local function callBack()
				----开启
				g_svSendMsgControl:request_lyuInfo(1,ID)
				self:showAnima2(index)
			end 
			tbQDMsg.qdFunc =  callBack
			g_quedingItem:openWnd(tbQDMsg) 	
		end 
		
	end 
	g_SetBtnOne(nil,nil,1, funcEndCallBack,item)

	if info and info.isJihuo == 1 or index == 1 then
		 c1:setSelectedIndex(0) 
	else
		 c1:setSelectedIndex(1)
		 item:setText("未激活") 
		 return
	end 
	
	
	local starText =  item:getChild("starText") 

	local title =  item:getChild("title") 
	local expBar =  item:getChild("expBar") 
	local yanse = info.yanse	
	local lev,nExp,maxExp =  g_lyInfoMsg:mathExpAndlev(ID)
	local cfgID = info.cfgID
	local cfgMsg =  g_cfgMsg:getCfgMsg("lingyu_D",cfgID) 
	local name = cfgMsg.name
	local iconPath = g_iconConTrol:getLyuIcon(cfgMsg.icon)

	local pro = math.floor(nExp*100/maxExp)
	starText:setText(G_tb_starText2[lev]) 	
	expBar:setValue(pro)

	title:setText(name..pro.."%")
	item:setIcon(iconPath) 	
	local iconBg =  item:getChild("iconBg") 
	local iconPath = g_iconConTrol:getLyuYanseIcon(yanse)
	iconBg:setIcon(iconPath) 	
end 
function B_mShuoChang:setItem0()
	local ID,cIndex = self:getID(0)
	local item =  self.rootLayout:getChild("item0") 
	---local info = g_lyInfoMsg:getTbMsg(ID)
	local c1 =  item:getController("c1") --控制器
	
	local function funcEndCallBack(btn,tag) 
		self:touchItem(0)
	end 
	g_SetBtnOne(nil,nil,1, funcEndCallBack,item)

	local title =  item:getChild("title") 

	local qhValye = g_lyInfoMsg:mathQiheValue(cIndex) 
	local yanse  = g_lyInfoMsg:mathZhongzhuYanse(qhValye)

	c1:setSelectedIndex(yanse)	
	
	local cfgID = cIndex + 1
	local cfgDecMsg =  g_cfgMsg:getCfgMsg("lingyuLev_D",cfgID) 
	name = cfgDecMsg.name2
	item:setText(name)
		cclog(qhValye,yanse,"=====setItem0=========",cIndex,name,cfgDecMsg)
end 

function B_mShuoChang:reload(tag)
	for index=0,8 do
		self:setItem(index)
	end 
	self:touchItem(1)
	self:setQiHeBar()
	---self.rootLayout:setVisible(true)
end 

function B_mShuoChang:openWnd()

	self:reload()
end 

	
return B_mShuoChang

