
local Item_HeroSuoPian = class("Item_HeroSuoPian", function() 
     local node = fgui.Window:create()  --原生对象（userdata)
     return node
end)


function Item_HeroSuoPian:initWnd()
	
	
	cclog('Item_HeroSuoPian:initWnd')
	local c1 = self.rootLayout:getController("c1") --控制器
	c1:setSelectedIndex(1)

end 

function Item_HeroSuoPian:closeWnd()
	cclog('Item_HeroSuoPian:closeWnd')
	if #self.tableMsg > 1  then
		table.remove(self.tableMsg,1)
		g_WndMgr:showWnd("HeroSuoPian",self.tableMsg)
	end 
end

function Item_HeroSuoPian:levUp()
	local c1 = self.rootLayout:getController("c1") --控制器
	c1:setSelectedIndex(0)
	local dongH = self.rootLayout:getTransition("t0")
	
	local function funcEndCallBack()
		g_action:ts_hszz_antion("英雄颜色提升",nil,-1)
	end 
	dongH:play(funcEndCallBack);
end

function Item_HeroSuoPian:setIcon1()
	local roleIcon1 = self.rootLayout:getChild("roleIcon1")
	g_gNodeConTrol:setHeroItem(roleIcon1,self.cfgID,self.yanse)
	
	local tbattMsg = g_heroMsg:mathAtt(self.cfgID,self.yanse)
	local attDps = self.rootLayout:getChild("attDps1")
	local attDef = self.rootLayout:getChild("attDef1")
	local attHp = self.rootLayout:getChild("attHp1")
	attDps:setText(tbattMsg[g_AttributeType.dps])
	attDef:setText(tbattMsg[g_AttributeType.def])
	attHp:setText(tbattMsg[g_AttributeType.hp])
	
	local cfgMsg =  g_cfgMsg:getCfgMsg("role_D",self.cfgID) 
	local iconPath = cfgMsg.packag
	--local  movieClip = fgui.UIPackage:createObject(iconPath,"heroAnima")
	local  movieClip, cfgAnimaMsg = g_gNodeConTrol:getShowPlayerMovieClip(self.cfgID)
	if self.movieClip  then
		local FrameBG = self.movieClip:displayObject()
		FrameBG:removeFromParent(true) 
	end 
	local heroTest = self.rootLayout:getChild("heroTest")
	heroTest:addChild(movieClip)
	movieClip:setScale(1.1,1.1)
	movieClip:setPosition(cfgAnimaMsg.pos2X ,cfgAnimaMsg.pos2Y-20)
	self.movieClip = movieClip
	local nameText = self.rootLayout:getChild("nameText")
	nameText:setText(cfgMsg.name)
	local function callbcak2()
	end
	
	local  frame =cfgAnimaMsg.frameZL
	local tbFrame= cc.g_inalienContentByCfgMsg(frame,1,"_")
	movieClip:setPlaySettings(tbFrame[1],tbFrame[2],0,-1,callbcak2)
end 
function Item_HeroSuoPian:setIcon2()
	local roleIcon2 = self.rootLayout:getChild("roleIcon2")
	g_gNodeConTrol:setHeroItem(roleIcon2,self.cfgID,self.yanse+1)
	
	local tbattMsg = g_heroMsg:mathAtt(self.cfgID,self.yanse+1)
	local attDps = self.rootLayout:getChild("attDps2")
	local attDef = self.rootLayout:getChild("attDef2")
	local attHp = self.rootLayout:getChild("attHp2")
	attDps:setText(tbattMsg[g_AttributeType.dps])
	attDef:setText(tbattMsg[g_AttributeType.def])
	attHp:setText(tbattMsg[g_AttributeType.hp])
end 

function Item_HeroSuoPian:openWnd(tableMsg)
	self.tableMsg = tableMsg
	self.cfgID = tableMsg[1][1]
	local addNumber =tableMsg[1][2] or 1
	local cfgMsg =  g_cfgMsg:getCfgMsg("role_D",self.cfgID) 
	local packag = cfgMsg.packag
	fgui.UIPackage:addPackage("hero/"..packag)
	
	
	local heroSuiPian = self.rootLayout:getChild("heroSuiPian")
	local heroSuiPianText = self.rootLayout:getChild("heroSuiPianText")
	self.yanse,curNum,needNum = g_heroMsg:mathHeroYanSe(self.cfgID)
	
	if yanse == 7   then
		curNum = 100
		needNum = 100
	end 
	
	heroSuiPian:setValue(curNum)
	heroSuiPian:setMax(needNum)
	
	cclog(self.yanse,curNum,needNum,"====Item_HeroSuoPian=====",curPer)
	 self:setIcon1()
	 if yanse == 7   then
		heroSuiPianText:setText("英雄已升至最高")
		return 
	end 
	local function scheduFun()
		self:setIcon2()
		--升阶
		self:levUp()
	end 
	if curNum+1 == needNum then
		scheduFun()
	else
		
	end 
	heroSuiPian:tweenValue(curNum+1,1.5)
	local dongH = self.rootLayout:getTransition("t1")
	
	local function funcEndCallBack()
		
	end 
	dongH:play(funcEndCallBack);
	
end

return Item_HeroSuoPian