
local A_story = class("A_story")

local tbWndMsg = {  "A_main" ,"A_main", "A_story", "app.views.panle.A_story"}

function A_story:closeWnd(bRemove)
	cclog('A_story:closeWnd')
	if  self.rootLayout  then	
		self.rootLayout:removeFromParent()
		self.rootLayout = nil
	end 
end


function A_story:initWnd(parent)
	local  szPacakgePath = tbWndMsg[1]
	local  szPacakge = tbWndMsg[2]
	local szWndName = tbWndMsg[3]
	fgui.UIPackage:addPackage(szPacakgePath)
	local _view = fgui.UIPackage:createObject(szPacakge, szWndName)
	self.rootLayout = _view	
	local parent =  g_GameDataMgr.rootObj
	cclog(parent,"====initWnd==========")
	parent:addChild(_view);
	_view:setSize(g_visibleSize.width,g_visibleSize.height);
	
	
end

function A_story:getNewName()
	local tbMsg = {19,707,2,1238,42}
	local nameText = ""
	for i=1,5 do
		local strKey = math.random(1,tbMsg[i])
		local tbCfgMsg = g_cfgMsg:getCfgMsg("setName_D",strKey)
		local str = tbCfgMsg["fwqName"..i]
		nameText = nameText..str
	
	end 
	return nameText
end 

function A_story:setNamePanle()

	local nameStr = self:getNewName()
	local textName = self.rootLayout:getChild("textName")
	textName:setText(nameStr)
	
end 

function A_story:setPanle()
	local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",self.cfgID)
	
	local title = self.rootLayout:getChild("title")
	local testDec = self.rootLayout:getChild("testDec")
	
	local c1 = self.rootLayout:getController("c1") --控制器
	local c2 = self.rootLayout:getController("c2") --控制器
	
	
	local function endCallBack()
		--cclog(cfgID,"==11===cfgID========")
		if self.cfgID == 103 then
			c2:setSelectedIndex(1)
			self:setNamePanle()
		else
			c1:setSelectedIndex(1)
		end 
	end 
	title:setText(tbCfgMsg.name1)
	local  strText = tbCfgMsg.des
	cclog("======setPanle=======")
	testDec:setText(strText)
	local nLabel = testDec:displayObject()
	nLabel:setOpacity(0)  --透明度
	
	local function CallBack()
		g_action:ActionScaleAndFadeIn(nLabel,1,endCallBack,2,nDelayTime)
	end
	local title = title:displayObject()
	title:setOpacity(0)  --透明度
	g_action:ActionScaleAndFadeIn(title,1,CallBack,1,nDelayTime)

	---showTextActionFGUI(testDec,strText,0.05,endCallBack)
end 


function A_story:setBtn(cfgID)
	local function funcEndCallBack(btn,tag) 
		
		local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",self.cfgID)
		local nextKey =  tbCfgMsg.nextKey
		cclog("=======funcEndCallBack======",self.cfgID,tbCfgMsg.wndType )
		if nextKey and nextKey > 0 and  self.cfgID <= 103  then
			g_svSendMsgControl:request_newGuide(tbCfgMsg.nType,1)
			g_newGuideMsg:setTbGuideOfstatus(tbCfgMsg.nType,1)
			self:openWnd(nextKey)
			
		else 
			---开启新手引导
			g_svSendMsgControl:request_newGuide(tbCfgMsg.nType,1)
			g_newGuideMsg:setTbGuideOfstatus(tbCfgMsg.nType,1)
			g_newGuide:isGuideContorlWnd("B_FbBat")
			self:closeWnd() 
			g_gameMusic:setBCanPlayEffect(true)
		end 
		
	end 
	g_SetBtnOne(self.rootLayout, "gbIcom",7, funcEndCallBack)
	

	local function CallBack(btn,tag) 
		cclog("")
		if tag == 1 then
			
			local textName = self.rootLayout:getChild("textName")
			local str = textName:getText()
			g_svSendMsgControl:request_setName(nil,str,funcEndCallBack)
		elseif  tag == 2 then 
			self:setNamePanle()
		end 
	end 
	g_SetBtnOne(self.rootLayout, "btnQD",1, CallBack)
	g_SetBtnOne(self.rootLayout, "btn2",2, CallBack)
end 

function A_story:openWnd(cfgID)
	cclog('A_story:openWnd',cfgID)
	g_gameMusic:setBCanPlayEffect(false)
	self.cfgID = cfgID
	if not  self.rootLayout then
		self:initWnd(parent)
	end 
	local c1 = self.rootLayout:getController("c1") --控制器
	local c2 = self.rootLayout:getController("c2") --控制器
	c1:setSelectedIndex(0)
	c2:setSelectedIndex(0)
	self.rootLayout:setVisible(true)
	self:setPanle(cfgID)
	self:setBtn(cfgID)
	self:setNamePanle()
end

function A_story:ctor()
end

g_A_story =  A_story:create()