
local B_BagSelect = class("B_BagSelect")

local tbWndMsg = {  "B_Bag" ,"B_Bag", "B_BagSelect", "app.views.panle.B_BagSelect"}

function B_BagSelect:closeWnd()
	cclog('B_BagSelect:closeWnd')
	if self.Selefuc then
		self.Selefuc()
	end 
	if not self.rootLayout  then
		return
	end 
	self.rootLayout:removeFromParent()
	self.rootLayout = nil
	self.curSelect = nil
end

function B_BagSelect:initWnd()
	local  szPacakgePath = tbWndMsg[1]
	local  szPacakge = tbWndMsg[2]
	local szWndName = tbWndMsg[3]
	fgui.UIPackage:addPackage(szPacakgePath)
	local _view = fgui.UIPackage:createObject(szPacakge, szWndName)
	self.rootLayout = _view	
	g_GameDataMgr.rootObj:addChild(_view);
	_view:setPosition(0, 0)

	local function funcEndCallBack(btn,tag) 
		
		self:closeWnd()
	end 
	g_SetBtnOne(self.rootLayout,"closeBtn" ,2, funcEndCallBack)
	self:initBtn()
end

---======================================================================



function B_BagSelect:initCheckBtn()
	local c4 =  self.rootLayout:getController("c4") --控制器
	local bagEquType = cc.UserDefault:getInstance():getIntegerForKey("bagEquType",1)
	c4:setSelectedIndex(bagEquType-1)
	for i=1,3 do
		local  checkBtn =  self.rootLayout:getChild("checkBtn"..i) 
		if bagEquType == i then
			self.curChecBtn = checkBtn
		end 
		local function funcEndCallBack(btn,tag) 
			cc.UserDefault:getInstance():setIntegerForKey("bagEquType",tag)
			c4:setSelectedIndex(tag-1)
			
			self.curChecBtn = btn
			self:reloadListEuq(true)
		end
		g_SetBtn(self.rootLayout,"checkBtn"..i,i, funcEndCallBack)
	end 
end 



function B_BagSelect:initBtn()
	self.selectMsg = {}
	local c3 =  self.rootLayout:getController("c3") --控制器
	self:initCheckBtn()
	
	local function funcEndCallBack(btn,tag) 
		
		if tag <100  then
			--c1:setSelectedIndex(1)
			self:touchBtn(0)
		else
			self:touchBtn(tag)
		end 
	end 
	for i=0,9 do
		g_SetBtn(self.rootLayout, "btnEuq"..i,i, funcEndCallBack)	
	end 
	g_SetBtn(self.rootLayout, "btn0",0, funcEndCallBack)
	g_SetBtn(self.rootLayout, "btn100",100, funcEndCallBack)	
	g_SetBtn(self.rootLayout, "btn101",101, funcEndCallBack)
	g_SetBtn(self.rootLayout, "btn102",102, funcEndCallBack)

	local  checkBtnAll =  self.rootLayout:getChild("checkBtnAll") 


	local function funcEndCallBack(btn,tag) 
		local bagBuyBum = g_baseMsg:getOther(otherDBMsgID.bagBuyBum) or  0
		local cost =  tbGameConst.BagBuyZs + bagBuyBum*tbGameConst.BagBuyZs
		
		local tbQDMsg = {}
		tbQDMsg.dec =  "是否花费"..cost.."钻石扩展背包,容量+5"
		tbQDMsg.text1 = "确定"
		tbQDMsg.text2 = "取消"
		local function callBack()
			g_svSendMsgControl:request_getBagMsg(11)
		end 
		tbQDMsg.qdFunc =  callBack
		g_quedingItem:openWnd(tbQDMsg) 
		
	end
	g_SetBtn(self.rootLayout, "btnAdd",1, funcEndCallBack)	
end 

function B_BagSelect:setBagNum()
	local maxBagNum = g_bagMsg:getMaxBagNum()
	local num = g_bagMsg:getcurBagEquNum()
	local  txextBagNum =  self.rootLayout:getChild("txextBagNum") 
	txextBagNum:setText("背包："..num.."/"..maxBagNum)

end 

function B_BagSelect:selectAll()
	local  checkBtnAll =  self.rootLayout:getChild("checkBtnAll") 
	local selectSta = checkBtnAll:getText()
	if selectSta == "1" then
		for i,ID in pairs(self.EuqBgTbMsg)do
			local info = g_zbMsg:getEuqTbMsg(ID)
			if (not info.isClock or info.isClock == 0 ) and (not info.inRole or  info.inRole  == 0 ) then
				self.selectMsg[ID] = ID
			end 
		end 
	else
		self.selectMsg = {}
	end 
end 

function B_BagSelect:showCheckBtn()
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	local  bagListEuq =  euqPanle:getChild("bagListEuq") 
	local chidren = bagListEuq:getChildren()
	local c6 =  self.rootLayout:getController("c6") --控制器
	local index = c6:getSelectedIndex()

	for i =1, #chidren do
		local curChild = chidren[i] 
		local ID = curChild:getCustomData()
		local info = g_zbMsg:getEuqTbMsg(ID)
		if info then
			local inRole = info.inRole
			local c3 =  curChild:getController("c3") --控制器
			if index == 1 then
				if  (inRole and inRole > 0) or (info.isClock and  info.isClock > 0) then
					c3:setSelectedIndex(0)
				else
					c3:setSelectedIndex(1)
					local  checkBtn1 = curChild:getChild("checkBtn1") 
						
					if not  self.selectMsg[ID] or self.selectMsg[ID] <= 0  then
						checkBtn1:setText(0)
					else
						checkBtn1:setText(1)
					end 
				end 
			else
				c3:setSelectedIndex(0)
			end 
		else	
			c3:setSelectedIndex(0)
		end 
		
	end
end 

function B_BagSelect:sortListTb1()
	local bagEquType = cc.UserDefault:getInstance():getIntegerForKey("bagEquType",1)
	local function comps(a,b)
		local info1 = g_zbMsg:getEuqTbMsg(a)
		local info2 = g_zbMsg:getEuqTbMsg(b)
		if bagEquType == 2 then
			local yanse1 = info1.yanse
			local yanse2 = info2.yanse
			if yanse1 == yanse2 then
				local pinfen1 = info1.pinfen or  g_mathConTrol:mathEquPoint(info1.id)
				local pinfen2 = info2.pinfen or  g_mathConTrol:mathEquPoint(info2.id)
				if pinfen1 == pinfen2 then
					local runeNum1 = info1.runeNum
					local runeNum2 = info2.runeNum
					if runeNum1 == runeNum2 then
						local cfgID1 = info1.cfgID
						local cfgID2 = info2.cfgID
						if cfgID1 == cfgID2 then
							return info1.id > info2.id 
						else
							return cfgID1 > cfgID2
						end 
					else
						return runeNum1 > runeNum2
					end 
				else
					return pinfen1 > pinfen2
				end 
				
			else
				return yanse1 > yanse2
			end 
		elseif  bagEquType == 3 then
			local runeNum1 = info1.runeNum
			local runeNum2 = info2.runeNum
			if runeNum1 == runeNum2 then
				local yanse1 = info1.yanse
				local yanse2 = info2.yanse
				if yanse1 == yanse2 then
					local pinfen1 = info1.pinfen or  g_mathConTrol:mathEquPoint(info1.id)
					local pinfen2 = info2.pinfen or  g_mathConTrol:mathEquPoint(info2.id)
					if pinfen1 == pinfen2 then
						local cfgID1 = info1.cfgID
						local cfgID2 = info2.cfgID
						if cfgID1 == cfgID2 then
							return info1.id > info2.id 
						else
							return cfgID1 > cfgID2
						end 
					else
						return pinfen1 > pinfen2
					end 
				else
					return yanse1 > yanse2
				end 
				
			else
				return runeNum1 > runeNum2
			end 
		elseif  bagEquType == 1 then
			local pinfen1 = info1.pinfen or  g_mathConTrol:mathEquPoint(info1.id)
			local pinfen2 = info2.pinfen or  g_mathConTrol:mathEquPoint(info2.id)
			if pinfen1 == pinfen2 then
				local yanse1 = info1.yanse
				local yanse2 = info2.yanse
				if yanse1 == yanse2 then
					local zbLev1 = info1.zbLev
					local zbLev2 = info2.zbLev
					if zbLev1 == zbLev2 then
						local cfgID1 = info1.cfgID
						local cfgID2 = info2.cfgID
						if cfgID1 == cfgID2 then
							return info1.id > info2.id 
						else
							return cfgID1 > cfgID2
						end 
					else
						return zbLev1 > zbLev2
					end 
				else
					return yanse1 > yanse2
				end 
			else
				return pinfen1 > pinfen2
			end 
		end 
		return a.numberKey < b.numberKey
	end
	table.sort(self.EuqBgTbMsg, comps)
end 
function B_BagSelect:sortListTb2()
	local function comps(a,b)
		return a > b 
	end 
	table.sort(self.BgTbMsg, comps)
end 	

function B_BagSelect:showEquDecPanle(zbID,reload)
	if reload then
		zbID = self.curTouchEuqID
	end 
	--local panle = g_panleMgr:showWndPanle("equDecItem",zbID)
	
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	local  equDecItem =  euqPanle:getChild("equDecItem") 
	if not  zbID  then
		return
	end 
	local info = g_zbMsg:getEuqTbMsg(zbID)
	if  info then
		g_gNodeConTrol:setEquDecItem(equDecItem,info)
		equDecItem:setVisible(true)
		
		local c4 =  equDecItem:getController("c4") --控制器
		c4:setSelectedIndex(1)
		local function funcEndCallBack(btn,tag) 
			g_selectMsg:setSelectID(zbID)
			self:closeWnd()
		end 
		g_SetBtnOne(equDecItem, "btnSele",i, funcEndCallBack)
	else
		equDecItem:setVisible(false)
	end 
	
end 

function B_BagSelect:getEquListItem(zbID)
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	if self.curHzbID == zbID then
		panle =  euqPanle:getChild("myEquItem") 
	else
		local  bagListEuq =  euqPanle:getChild("bagListEuq") 
		panle = getChildById(bagListEuq, self.curTouchEuqID)
	end 
	return  panle
end 

function B_BagSelect:touchEquItem(obj,zbID)
	if self.curTouchEuqID then
		local  euqPanle =  self.rootLayout:getChild("euqPanle") 
		local panle = self:getEquListItem(self.curTouchEuqID)
		
		if panle then
			local c1 =  panle:getController("c1") --控制器
			c1:setSelectedIndex(0)
		end 
	end 
	if not obj then
		local  euqPanle =  self.rootLayout:getChild("euqPanle") 
		local  bagListEuq =  euqPanle:getChild("bagListEuq") 
		obj = getChildById(bagListEuq, zbID)
	end 
	local c1 =  obj:getController("c1") --控制器
	c1:setSelectedIndex(1)
	self.curTouchEuqID = zbID
	self:showEquDecPanle(zbID)
end 

function B_BagSelect:setListItemEqu(obj,zbID)
	if not obj then
		obj = self:getEquListItem(zbID)
	end 
	if not obj then
		
		return
	end 
	local  textEquName =  obj:getChild("textEquName") 
	local  textEquT =  obj:getChild("textEquT") 
	local  textEquKLev =  obj:getChild("textEquKLev") 
	
	local info = g_zbMsg:getEuqTbMsg(zbID)
	local c1 =  obj:getController("c1") --控制器
	local c2 =  obj:getController("c2") --控制器
	

	if not info then
		c2:setSelectedIndex(1)
		c1:setSelectedIndex(0)
		return
	end 
	c2:setSelectedIndex(0)
	local name,yanse,tbEquMsg = g_getNameConTrol:getAllMsg(info.cfgID)
	textEquName:setText(name)
	local colorID = G_tb_TextColor[info.yanse]
	
	cc.g_setTextColor(textEquName,colorID,true)
	textEquKLev:setText("Lv."..info.zbLev)
	
	local  textEquT =  obj:getChild("textEquT") 
	if tbEquMsg.nameT2 then
		textEquT:setText(tbEquMsg.nameT2)
	else	
		textEquT:setText("")
	end 

	for i=1,2 do
		local  euqAtt =  obj:getChild("euqAtt"..i) 
		local lev = info.mainAttLev[i] or 0
		if lev <= 0 then
			euqAtt:setVisible(false)
		else
			euqAtt:setVisible(true)
			euqAtt:setIcon(g_iconConTrol:getABCDIcon(lev))
		end 
	end 
	local  conClock =  obj:getChild("conClock") 
	if info.isClock and info.isClock == 1 then
		conClock:setVisible(true)
	else
		conClock:setVisible(false)
	end 
	local textEquPinfen =  obj:getChild("textEquPinfen") 
	if not info.pinfen then
		info.pinfen = g_mathConTrol:mathEquPoint(info.id)
		g_zbMsg:setEuqTbMsg(info)  
	end 

	textEquPinfen:setText("评分："..info.pinfen)
	if not info.runeMsg then
		info.runeMsg = {}
	end 
	
	for i=1,7 do
		local  stItem =  obj:getChild("stItem"..i) 
		
		if stItem  then
			if  i > info.runeNum  then
				stItem:setVisible(false)
			else
				stItem:setVisible(true)
				local FWID = info.runeMsg[i] or 0
				
				if FWID > 0 then
					local name,yanse,tbMsg,baseName = g_getNameConTrol:getAllMsg(FWID)
					stItem:setIcon(g_iconConTrol:getFWYanseIcon(yanse))
				else
					stItem:setIcon(g_iconConTrol:getFWYanseIcon(0))
				end 
			end 
		end 
	end 
	
	local c2 =  obj:getController("c2") --控制器
	if not zbID or zbID <= 0 then
		c2:setSelectedIndex(1)
		c1:setSelectedIndex(0)
		return
	end 
	c2:setSelectedIndex(0)
	local function funcEndCallBack(btn,tag) 
		self:touchEquItem(obj,zbID)
	end 
	g_SetBtnOne(nil,nil,cfgID, funcEndCallBack,obj)
	
	
	cclog(zbID,"==setListItemEqu===11=",self.curTouchEuqID,info.inRole)
	if  zbID ==  self.curTouchEuqID then	
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
 
	local  checkBtn1 = obj:getChild("checkBtn1") 
	local function funcEndCallBack(btn,tag) 
		local index = tonumber(btn:getText())
		index = (index+1)%2
		btn:setText(index)
		if  index == 1 then
			self.selectMsg[zbID] = zbID
		else
			self.selectMsg[zbID] = nil
		end 
	end 
	g_SetBtnOne(nil,nil,1,funcEndCallBack,checkBtn1)	
	if not  self.selectMsg[zbID] or self.selectMsg[zbID] <= 0  then
		checkBtn1:setText(0)
	else
		checkBtn1:setText(1)
	end 

	local  textLevQH =  obj:getChild("textLevQH") 
	if  info.QHLev and info.QHLev > 0 then
		textLevQH:setText("A"..info.QHLev)
	else
		textLevQH:setText("")
	end 
	
end


function B_BagSelect:setListItemEquTaoItem(obj,nType,num)
	local cfgID = 61100001 + (nType - 1)*100
	local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D",cfgID)
	local name = tbMsg.nameT2..num
	local index = math.floor(num/3)
	local c1 =  obj:getController("c1") --控制器
	c1:setSelectedIndex(index)
	obj:setText(name)
end

function B_BagSelect:reloadListEuqTaoList(reload)
	local  equTaoList =  self.rootLayout:getChild("equTaoList") 
	local tbMsg = {}
	for nType,v in pairs(g_roleMsg.tbTaozMsg)do
		
		tbMsg[#tbMsg + 1] =  {nType,v}
	end 

	equTaoList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local nType = tbMsg[indexD][1]
			local num = tbMsg[indexD][2]
			obj:setCustomData(nType)
			self:setListItemEquTaoItem(obj,nType,num)
		end)
	equTaoList:setVirtual()--回调
	equTaoList:setNumItems(#tbMsg);
end 

function B_BagSelect:reloadListEuq(reload)
	local c3 =  self.rootLayout:getController("c3") --控制器
	self.EuqBgTbMsg = {}
	local euqTbMsg = g_bagMsg:getBagEuqTbMsg()
	
	local nTypeIndex = c3:getSelectedIndex() 
	
	--cclog(euqTbMsg,"=====reloadListEuq=====")
	for ID,v in pairs(euqTbMsg)do
		local info = g_zbMsg:getEuqTbMsg(ID)
		if info then
			local name,yanse,cfgEquMsg =  g_getNameConTrol:getAllMsg(info.cfgID) 
			local nType = cfgEquMsg.nType
			if nTypeIndex == 0 or  nType == nTypeIndex then
				self.EuqBgTbMsg[#self.EuqBgTbMsg+1] = ID
			end 
		end 
		
	end 
	self:sortListTb1()
	--cclog("====reloadListEuq=====",self.EuqBgTbMsg)
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	local  bagListEuq =  euqPanle:getChild("bagListEuq") 
	bagListEuq:itemRenderer(function(index, obj)
			local indexD = index + 1
			local zbID = self.EuqBgTbMsg[indexD]
			obj:setCustomData(zbID)
			self:setListItemEqu(obj,zbID)
		end)
	bagListEuq:setVirtual()--回调
	bagListEuq:setNumItems(#self.EuqBgTbMsg);
	
	local  title =  euqPanle:getChild("title") 
	local nameB = g_tb_zhuangbeiType_cn[nTypeIndex]
	
	if nTypeIndex > 0 then
		title:setText(nameB.."背包("..#self.EuqBgTbMsg..")")
		self.curHzbID = g_roleMsg:getTbZbID(nTypeIndex) 
		self:setMyEquItem()
	else
		title:setText("背包("..#self.EuqBgTbMsg..")")
		for i=1,9 do
			self.curHzbID = g_roleMsg:getTbZbID(i) 
			if self.curHzbID > 0  then
				break 
			end 
		end 
		self:setMyEquItem()
	end 
	self.curTouchEuqType = nTypeIndex
	self:reloadListEuqTaoList()
	self:setBagNum()
end 


function B_BagSelect:setMyEquItem()
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	local panle =  euqPanle:getChild("myEquItem") 
	
	if not self.curHzbID or self.curHzbID == 0 then
		panle:setVisible(false)
		return
	else
		panle:setVisible(true)
	end 
	self:setListItemEqu(panle,self.curHzbID)
	return panle
end 

---=======================================================


function B_BagSelect:initCheckBtnPet()
	local c6 =  self.rootLayout:getController("c6") --控制器
	local sortType = cc.UserDefault:getInstance():getIntegerForKey("sortType",1)
	c6:setSelectedIndex(sortType-1)
	for i=1,3 do
		local  checkBtn =  self.rootLayout:getChild("checkBtn"..i) 
		if sortType == i then
			self.curChecBtn = checkBtn
		end 
		local function funcEndCallBack(btn,tag) 
			c6:setSelectedIndex(tag-1)
			self.curChecBtn = btn
			self:reloadPatList(tag)
			cc.UserDefault:getInstance():setIntegerForKey("bagEquType",tag)
			
		end
		g_SetBtn(self.rootLayout,"checkBtncw"..i,i, funcEndCallBack)
		if i == 1 then
			self.curChecBtn = checkBtn
		end 
	end 	
end 

function B_BagSelect:setPetNumText()
	local  petNumText =  self.rootLayout:getChild("petNumText") 
	local maxNum = g_mathConTrol:mathMaxPetNum()
	petNumText:setText("拥有："..#self.petTbMsg.."/"..maxNum)
end 


function B_BagSelect:setListItem(obj,petID,notouch)
	local info = g_petMsg:getpetTbMsg(petID)
	if not obj then
		local  petList =  self.rootLayout:getChild("petList") 
		obj = getChildById(petList,petID)
	end 
	if not obj then
		return
	end 
	local  title =  obj:getChild("title") 
	local  icon =  obj:getChild("icon") 
	icon:setIcon(g_iconConTrol:getPetYanseIcon(info.yanse))
	local cfgID = info.cfgID
	local cfgMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID) 
	title:setText(cfgMsg.name)
	
	local  barExp =  obj:getChild("barExp")
	local maxExp = g_mathConTrol:mathPetMaxExp((info.starLev or 0) +1)
	barExp:setValue(info.nExp or 0)
	barExp:setMax(maxExp)
	
	local  iconBg = obj:getChild("iconBg") 
	obj:setIcon(g_iconConTrol:getPetYanseIcon(info.yanse))
	iconBg:setIcon(g_iconConTrol:getPetYanseBgIcon(info.yanse))
	local  textZZ =  obj:getChild("textZZ") 
	local  textLev =  obj:getChild("textLev") 
	local  skillText =  obj:getChild("skillText") 
	
	local colorID = G_tb_TextColor[info.yanse]

	cc.g_setTextColor(textZZ,colorID,true)
	cc.g_setTextColor(textLev,colorID,true)
	cc.g_setTextColor(skillText,colorID,true)
	textZZ:setText("资质："..g_petMsg:getPetZZ(info.id))
	textLev:setText("等级："..info.Level)

	local  starText =  obj:getChild("starText")
	starText:setText(G_tb_starText[(info.starLev or 0)])

	local count  = 0
	for i=1,info.skillNum do
		if  info.skillMsg[i] and  info.skillMsg[i].id > 0 then
			count = count+1
		end 
	end 
	
	skillText:setText("技能：("..count.."/"..info.skillNum..")")

	local function funcEndCallBack(btn,tag) 
		self:touchPetItem(obj,petID)
	end 
	if not notouch then
		g_SetBtnOne(obj,"touchItem",1,funcEndCallBack)	
	end 
	
	local c1 =  obj:getController("c1") --控制器
	if petID == self.cutTouchID  then
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
	
	local iconClock =  obj:getChild("iconClock")
	
	if info.isClock and  info.isClock > 0 then
		iconClock:setVisible(true)
	else
		iconClock:setVisible(false)
	end 

	local index = c1:getSelectedIndex()
	local  isBatIndexText =  obj:getChild("isBatIndexText") 
	local isBat = info.batIndex
	if isBat and isBat > 0 then
		isBatIndexText:setVisible(true)
	else
		isBatIndexText:setVisible(false)
	end 
	local c1 =  self.rootLayout:getController("c1") --控制器
	local index = c1:getSelectedIndex()
	local c2 =  obj:getController("c2") --控制器
	if index ==  1 then
		if (isBat and isBat > 0) or (info.isClock and  info.isClock > 0)  then
			c2:setSelectedIndex(0)
		else
			c2:setSelectedIndex(1)
			local  checkBtn1 = obj:getChild("checkBtn1") 
			if not  self.selectPetMsg[petID] or self.selectPetMsg[petID] <= 0  then
				checkBtn1:setText(0)
			else
				checkBtn1:setText(1)
			end 
			
		end 
	else
		c2:setSelectedIndex(0)
	end 

end
	
function B_BagSelect:setPetDecPanl()
	local info = g_petMsg:getpetTbMsg(self.cutTouchID)
	local  petName =  self.rootLayout:getChild("petName") 
	local  textLev =  self.rootLayout:getChild("textLev")
	local  textZZ =  self.rootLayout:getChild("textZZ")
	
	if not info then
		self:touchPetItem()
		return
	end 
	local cfgID = info.cfgID
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)

	petName:setText(name)
	local colorID = G_tb_TextColor[info.yanse]
	cc.g_setTextColor(petName,colorID,true)
	cc.g_setTextColor(textLev,colorID,true)
	cc.g_setTextColor(textZZ,colorID,true)

	textZZ:setText("资质："..g_petMsg:getPetZZ(info.id))
	textLev:setText("等级："..info.Level)
	local  barExp =  self.rootLayout:getChild("barExp")
	local maxExp = g_mathConTrol:mathPetMaxExp((info.starLev or 0) +1)
	barExp:setValue(info.nExp or 0)
	barExp:setMax(maxExp)

	local  starText =  self.rootLayout:getChild("starText")
	starText:setText(G_tb_starText[(info.starLev or 0)])
	local zhizi = g_petMsg:getPetZZ(info.id)
	for i=1,4 do
		local TextAtt =  self.rootLayout:getChild("TextAtt"..i)
		
		local value = g_mathConTrol:mathPetBaseAtt(info.Level,i,zhizi,info.id) 
	
		TextAtt:setVar("value",tostring(value)) 
		TextAtt:flushVars()
		
		local TextAttCe =  self.rootLayout:getChild("TextAttCe"..i)
		local value = g_mathConTrol:mathPetAttCe(info,i) 
		TextAttCe:setVar("value",tostring(value)) 
		TextAttCe:flushVars()
	end 
	
	
	local count = 0
	for i=1,6 do
		local TextSkill =  self.rootLayout:getChild("TextSkill"..i)
		local skillMsg = info.skillMsg[i] or {}
		local skillID = skillMsg.value1 or 0
		
		local skillIDLev = g_bagMsg:getpetSkillTbMsgLev(skillID)  
		if i > info.skillNum then
			TextSkill:setVisible(false)
		elseif skillID <= 0 then
			cc.g_setTextColor(TextSkill,1,true)
			TextSkill:setText("无")
		else
			local cfgSkillMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillID) 
			TextSkill:setVisible(true)
			local colorID = G_tb_TextColor[cfgSkillMsg.lev]
			cc.g_setTextColor(TextSkill,colorID,true)
			TextSkill:setText(cfgSkillMsg.name.." Lv"..skillIDLev)
			count = count + 1
		end 
	end
	local skillNum =  self.rootLayout:getChild("skillNum")
	skillNum:setVar("value1",tostring(count)) 
	skillNum:setVar("value2",tostring(info.skillNum)) 
	skillNum:flushVars()
	local TextChouhen =  self.rootLayout:getChild("TextChouhen")
	local chouhen = g_mathConTrol:mathPetBaseAtt(info.Level,5,zhizi,info.id) 
	TextChouhen:setText("仇恨值:"..chouhen)
	
	local btnBat =  self.rootLayout:getChild("btnBat")
	local c5 =  self.rootLayout:getController("c5") --控制器
	if info.batIndex and  info.batIndex > 0 then
		c5:setSelectedIndex(1)
	else
		c5:setSelectedIndex(0)
	end 	
	
	local iconClock =  self.rootLayout:getChild("iconClock")
	local  btnClock =  self.rootLayout:getChild("btnClock") 
	if info.isClock and  info.isClock > 0 then
		iconClock:setVisible(true)
	else
		iconClock:setVisible(false)
	end 
	
	local function funcEndCallBack(btn,tag) 
		---cclog("======btncwSele==========",self.cutTouchID)
		g_selectMsg:setSelectID(self.cutTouchID)
		self:closeWnd()
	end 
	---cclog("===btncwSele=======")
	g_SetBtnOne(self.rootLayout, "btncwSeleD",i, funcEndCallBack)	
end 	

function B_BagSelect:touchPetItem(obj,petID)
	if self.cutTouchID then
		local  petList =  self.rootLayout:getChild("petList") 
		local item  = getChildById(petList,self.cutTouchID)
		if item then
			local c1 =  item:getController("c1") --控制器
			c1:setSelectedIndex(0)
		end 
	end
	local c6 =  self.rootLayout:getController("c6") --控制器
	if not petID then
		c6:setSelectedIndex(1)
		return
	else
		c6:setSelectedIndex(0)
	end 
	self.cutTouchID = petID
	if not obj then
		local  petList =  self.rootLayout:getChild("petList") 
		obj = getChildById(petList,petID)
	end 
	local c1 =  obj:getController("c1") --控制器
	c1:setSelectedIndex(1)
	self:setPetDecPanl()

end 

function B_BagSelect:reloadPatList(sortType,reload)
	local sortType = sortType or cc.UserDefault:getInstance():getIntegerForKey("sortType",petSortType.yans)
	
	
	self.petSrot = sortType
	self.petTbMsg =  g_petMsg:getSortPetMsg(sortType) 
	local  petList =  self.rootLayout:getChild("petList") 
	self.first = nil
	petList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local petID = self.petTbMsg[indexD]
			if not self.first then
				self.first = petID
			end 
			obj:setCustomData(petID)
			self:setListItem(obj,petID)
		end)
	petList:setVirtual()--回调
	petList:setNumItems(#self.petTbMsg);
	self:initCheckBtnPet()
end 


function B_BagSelect:touchBtn(tag)
	local c2 =  self.rootLayout:getController("c2") --控制器
	cclog("====touchBtn===",tag)
	self.touchTag = tag
	if tag == 0 then --装备
		c2:setSelectedIndex(0)
		self:reloadListEuq()
	elseif tag == 101 then --cw
		c2:setSelectedIndex(1)
		self:reloadPatList(sortType)
	end 
	
end

function B_BagSelect:setSeleFuc(fuc)
	self.Selefuc = fuc
end 

function B_BagSelect:openWnd(index1,euqType)
	self:initWnd()
	local index  = index1 or 0
	
	local  euqPanle =  self.rootLayout:getChild("euqPanle") 
	local  equDecItem =  euqPanle:getChild("equDecItem") 
	equDecItem:setVisible(false)
	
	local c3 =  self.rootLayout:getController("c3") --控制器
	
	if euqType  then
		self:touchBtn(0)
		c3:setSelectedIndex(euqType-1)
	else
		self:touchBtn(index)
	end 
	
end 

function B_BagSelect:ctor()
end

g_B_BagSelect =  B_BagSelect:create()