
local ComponentShaoDang = class("ComponentShaoDang")

local tbWndMsg = {  "a_mainSence" ,"a_mainSence", "ComponentShaoDang", "app.views.panle.ComponentShaoDang"}

function ComponentShaoDang:closeWnd()
	cclog('ComponentShaoDang:closeWnd')
	
	if not self.rootLayout  then
		return
	end 
	local rootLayout = self.rootLayout:displayObject()
	rootLayout:removeFromParent()
	self.rootLayout = nil
	local FrameBG = self.FrameBG:displayObject()
	FrameBG:removeFromParent()
	self.FrameBG = nil
	
end


function ComponentShaoDang:setFrame()
	local frame =  {  "d_node" ,"d_node", "ComFrame", "app.views.item.ComFrame"} 
	local  szPacakgePath =frame[1]
	local  szPacakge = frame[2]
	local szWndName = frame[3]
	
	local FrameBG= fgui.UIPackage:createObject(szPacakge, szWndName)
	g_GameDataMgr.rootObj:addChild(FrameBG);
	---FrameBG:setChildrenRenderOrder(G_FrameLocalZOrder)
	self.FrameBG = FrameBG
	local FrameBG1 =FrameBG:displayObject()
	FrameBG1:setLocalZOrder(G_tishiLocalZOrder-5)
	--FrameBG1:setOpacity(50)  --透明度
	local function funcEndCallBack(btn,tag) 
		self:closeWnd()
	end 
	g_SetBtnOne(nil,nil ,2, funcEndCallBack,FrameBG)
end 

function ComponentShaoDang:initWnd()
	self:setFrame()
	local  szPacakgePath = tbWndMsg[1]
	local  szPacakge = tbWndMsg[2]
	local szWndName = tbWndMsg[3]
	fgui.UIPackage:addPackage(szPacakgePath)
	local _view = fgui.UIPackage:createObject(szPacakge, szWndName)
	self.rootLayout = _view	
	g_GameDataMgr.rootObj:addChild(_view);
	_view:setPosition(50, 116)
	local _view =_view:displayObject()
	_view:setLocalZOrder(G_tishiLocalZOrder+4)
	local function funcEndCallBack(btn,tag) 
		self:closeWnd()
	end 
	g_SetBtnOne(self.rootLayout,"colseBtn" ,2, funcEndCallBack)
end

function ComponentShaoDang:isSelect(DheroID)	
	local free,index
	for i=1,2 do
		local heroID = self.selectHero[i]
		if heroID == DheroID  and  DheroID  then
			index = i
		elseif not heroID then
			free = i
			break
		end 
	end 
	return free,index
end

function ComponentShaoDang:touchHero(heroID)	
	local obj = self:getHeroListItem(heroID)	
	if not obj then	
		return
	end 
	local c2 = obj:getController("c2") --控制器
	local free,index = self:isSelect(heroID)	 
	if index then
		 self.selectHero[index] = nil
		 c2:setSelectedIndex(0)
		 self:setTSHeroItem(index)
	elseif  free  then
		--判断体力
		local info = g_baozangMsg:getbaozangMsg(self.bzID)
		local needTiliValue = info.needTiliValue  
		local roleInfo = g_heroMsg:getHeroMsg(heroID) or {}
		local bzTli = roleInfo.bzTli or  100
		if bzTli < needTiliValue then
			 local cfgMsg =  g_cfgMsg:getCfgMsg("role_D",heroID) 
			g_action:ts_hszz_antion(cfgMsg.name.."体力不足")	
			return
		end 
		self.selectHero[free] = heroID
		c2:setSelectedIndex(1)
		self:setTSHeroItem(free)
	else	
		g_action:ts_hszz_antion("探索未知已满")	
		return
	end 
end

function ComponentShaoDang:getHeroListItem(heroID)	
	local heroList = self.rootLayout:getChild("heroList")
	local chidren = heroList:getChildren()
	local obj
	for i =1, #chidren do
		local curChild = chidren[i] 
		local heroCfgID = curChild:getCustomData()
		if heroCfgID == heroID  then
			obj = curChild
			break
		end 
	end
	return obj
end
---是否在宝藏中
function ComponentShaoDang:isTansuoINg(heroID)		
	local tbinfo = g_baozangMsg:getbaozangMsg()
	for i,info in pairs(tbinfo)do
		local tbheroID = info.heroID or {}
		---cclog("==isTansuoINg=====",info)
		for h,heroIDDD  in pairs(tbheroID)do
			if  heroIDDD == heroID then
				return  i
			end 
		end 
	end 
	return 0
end

function ComponentShaoDang:setHeroListItem(obj,heroID)	
	 if not  obj then
		obj = self:getHeroListItem(heroID)	
	 end 
	 if not obj  then
		return
	 end 
	local heroHead= obj:getChild("heroHead")
    local cfgMsg =  g_cfgMsg:getCfgMsg("role_D",heroID) 
	local icoPath = g_iconConTrol:getHeroIcon(cfgMsg.heroHead)
	heroHead:setIcon(icoPath)
	local tiliBar= obj:getChild("tiliBar")
	local addtili= obj:getChild("addtili")
	local roleInfo = g_heroMsg:getHeroMsg(heroID) or {}
	local bzTli = roleInfo.bzTli or  100
	local status = roleInfo.status or 0
	
	tiliBar:setMax(100)
	tiliBar:setValue(bzTli)
--	local  batIndex = g_baseBatMsg:isBat(heroID)
	local info = g_heroMsg:getHeroMsg(heroID) or {}
	local jihuo = info.bJihuo or 0
	local c1 = obj:getController("c1") --控制器
	local c1D = heroHead:getController("c1") --控制器
	---是否在宝藏中
	local status =  self:isTansuoINg(heroID)		
	
	if  status  > 0  then
		c1:setSelectedIndex(2)
		c1D:setSelectedIndex(2)
	elseif   jihuo and jihuo <= 0 then
		c1:setSelectedIndex(3)
		c1D:setSelectedIndex(2)
	else
		c1:setSelectedIndex(0)
		c1D:setSelectedIndex(0)
		local function funcEndCallBack(btn,tag) 	
			
			---体力是否满
			local roleInfo = g_heroMsg:getHeroMsg(heroID) or {}
			local bzTli = roleInfo.bzTli or  100
			if bzTli >= 100 then
				g_action:ts_hszz_antion("该英雄体力已满")	
				return
			end 
			local cost = 30
			local tbQDMsg = {}
			tbQDMsg.dec =  "是否花费30钻石恢复该英雄体力"
			tbQDMsg.text1 = "确定"
			tbQDMsg.text2 = "取消"
			local function callBack()
				--判断钻石
				
				local status = g_baseConTrol:resEnough(g_resCfgId.diamond,cost,notSend)
				if not status  then
					return 
				end 
				g_svSendMsgControl:request_getHeroMsg(14,heroID)
			end 
			tbQDMsg.qdFunc =  callBack
			g_quedingItem:openWnd(tbQDMsg) 
			
		end 
		g_SetBtnOne(nil,nil,2, funcEndCallBack,addtili)
		
		local function funcEndCallBack(btn,tag) 	
			self:touchHero(heroID)
		end
		g_SetBtnOne(obj,"heroHead",2, funcEndCallBack)
	end
end 


function ComponentShaoDang:setYWGoodsList()
	local ywItemList = self.rootLayout:getChild("ywItemList")
	local info = g_baozangMsg:getbaozangMsg(self.bzID)
	local dropGoods2 = info.dropGoods2
	ywItemList:removeChildren()
	for i,info in pairs(dropGoods2)do
		local item = ywItemList:addItemFromPool()
		local cfgID = info.id
		local numD =  info.addNumber
		g_gNodeConTrol:setGoodsItem(cfgID, item,numD)	
	end 
end

function ComponentShaoDang:setTsTime()
	local tsTime = self.rootLayout:getChild("tsTime")
	local n89 = self.rootLayout:getChild("n89")
	local pic = tsTime:displayObject()
	local info = g_baozangMsg:getbaozangMsg(self.bzID)
	local  nStarTime = info.nStarTime
	local strMsg = {".","..","...","....",}
	local count = 1
	
	local needTime = info.needTIme
	if not needTime then
		local cfgMsg =  g_cfgMsg:getCfgMsg("baozang_D",info.levPJ)
		needTime = cfgMsg.needTime*3600
	end 
	
	local function callBack()
		local curTIme =  g_getCursvTime()
		local nTime = curTIme - nStarTime
		cclog(nTime,"======nStarTime===",curTIme,nStarTime)
		
		local nTime =  needTime - nTime
		local str=  cc.getStrTimeByS(nTime)
		tsTime:setText(str)
		count = count%4+1
		n89:setText("正在探索中"..strMsg[count])
		if  nTime <= 0  then
			g_svSendMsgControl:request_BZContorl(7,self.bzID)
			g_scheduleTime:stopScheduleForever(pic)
		end 
	end 
	callBack()
	g_scheduleTime:scheduleForever(pic,1,callBack)
	
	
	local function setShijian(nRandom,index)
		
		local timeStr= cc.getStrTimeByS4(nRandom)
		local str = "("..timeStr.."前)"
		local nRandom = math.random(101,118)
		local tbCfg = g_cfgMsg:getCfgMsg("cnStr_D",nRandom) 
		str = str..tbCfg.des
		local shijianDec1 = self.rootLayout:getChild("shijianDec"..index)
		shijianDec1:setText(str)
		cc.UserDefault:getInstance():setStringForKey("tsShiTimeStr"..index, str)
		
	end 
	local tsShiTime = cc.UserDefault:getInstance():getIntegerForKey("tsShiTime",0 )
	local curTIme =  g_getCursvTime()
	local nTime = curTIme - tsShiTime
	if nTime > 15*60 then
		local nTime =  15*60 
		cc.UserDefault:getInstance():setIntegerForKey("tsShiTime",curTIme)
		local nRandom = math.random(1,nTime/2)
		setShijian(nRandom,1)
		local nRandom = math.random(nTime/2,nTime)
		setShijian(nRandom,2)
	else
		local str1 = cc.UserDefault:getInstance():getStringForKey("tsShiTimeStr1", "")
		local str2 = cc.UserDefault:getInstance():getStringForKey("tsShiTimeStr2", "")
		local shijianDec1 = self.rootLayout:getChild("shijianDec1")
		shijianDec1:setText(str1)
		local shijianDec2 = self.rootLayout:getChild("shijianDec2")
		shijianDec2:setText(str2)
	end 
end 

function ComponentShaoDang:setBtn()
	local function funcEndCallBack(btn,tag) 	
		 local free,index =  self:isSelect()	
		 if free and free  > 0 then
			g_action:ts_hszz_antion("需要派出2个英雄")	
			return
		 end 
		g_svSendMsgControl:request_BZContorl(2,self.bzID,self.selectHero)
	end
	g_SetBtnOne(self.rootLayout,"btnGotoD",2, funcEndCallBack)
	
	local function funcEndCallBack(btn,tag) 	
		
		local info = g_baozangMsg:getbaozangMsg(self.bzID)
		local  nStarTime = info.nStarTime
		local curTIme =  g_getCursvTime()
		local nTime = curTIme - nStarTime
		local needTime = info.needTIme
		local nTime =  needTime - nTime
		local  cost = g_baseConTrol:mathNeedZsByTime(nTime)
		local tbQDMsg = {}
		tbQDMsg.dec =  "是否花费"..cost.."钻石立刻完成探索"
		tbQDMsg.text1 = "确定"
		tbQDMsg.text2 = "取消"
		local function callBack()
			--判断钻石
			local status = g_baseConTrol:resEnough(g_resCfgId.diamond,cost,notSend)
			if not status  then
				return 
			end 
			g_svSendMsgControl:request_BZContorl(4,self.bzID)
		end 
		tbQDMsg.qdFunc =  callBack
		g_quedingItem:openWnd(tbQDMsg) 
	end
	g_SetBtnOne(self.rootLayout,"btnGoto1",2, funcEndCallBack)
	
	
	local function funcEndCallBack(btn,tag) 
		g_svSendMsgControl:request_BZContorl(5,self.bzID)
	end
	g_SetBtnOne(self.rootLayout,"btnGet",2, funcEndCallBack)

	local function adsFunc()
		self:setTsTime()
		self:setBtn()
		g_action:ts_hszz_antion("宝藏时间减少")
	end
	
	local function funcEndCallBack(btn,tag) 
		setADSFunc(g_tbAdsReward.adsHDNum,adsFunc)
		g_API_playAds(g_tbAdsReward.adsHDNum,self.bzID)
	end
	g_SetBtnOne(self.rootLayout,"btnAds",2, funcEndCallBack)
	
	local hdInfo = g_HDMsg:getTbHDMsg()
	local cfgID = hdInfo.hdCfgID or 0
	local a_mainSence = g_WndMgr:getWnd("MainScene")
	local c4 = self.rootLayout:getController("c4") --控制器	
	
	local asdtime = self.rootLayout:getChild("asdtime")
	local adsHDTime = g_baseMsg:getOther(otherDBMsgID.adsHDTime) or  0
	local adsHDNum = g_baseMsg:getOther(otherDBMsgID.adsHDNum) or  0
	local pic = asdtime:displayObject()
	local function callBack()
		local adsHDTime = g_baseMsg:getOther(otherDBMsgID.adsHDTime) or  0
		
		local curTIme =  g_getCursvTime()
		local nTime = curTIme - adsHDTime
		nTime = 300 - nTime
		if nTime > 0   then
			local str=  cc.getStrTimeByS(nTime)
			asdtime:setText("冷却："..str)
		else
			asdtime:setText("播放视频广告("..adsHDNum..")")
			g_scheduleTime:stopScheduleForever(pic)
			c4:setSelectedIndex(1)
		end 
		if a_mainSence.hdStatu ~= 1 then
			c4:setSelectedIndex(3)
		end 
	end 
	---cclog("====funcEndCallBack===DDD==",cfgID)
	if cfgID == 1 then
		cclog(a_mainSence.hdStatu,"====funcEndCallBack==1111==",adsHDTime)
		if a_mainSence.hdStatu ~= 1 then
			c4:setSelectedIndex(3)
		else
			c4:setSelectedIndex(1)
			if adsHDTime >= 0 then
				local curTIme =  g_getCursvTime()
				local nTime = curTIme - adsHDTime
				if nTime <= 300  then
					g_scheduleTime:scheduleForever(pic,1,callBack)
					callBack()
					c4:setSelectedIndex(2)
				else
					asdtime:setText("播放视频广告("..adsHDNum..")")
					c4:setSelectedIndex(1)
				end  
			end 
		end 
	else
		local Daily_adsBaozhangNum = g_taskConTrol:getTaskFinishNum(g_TaskStatisticsType.Daily_adsBaozhangNum) or 0
		local num = 5
		local asdtimeD = self.rootLayout:getChild("asdtimeD")
		num = num - Daily_adsBaozhangNum
		asdtimeD:setText("今日次数："..num)
		if num <= 0   then
			c4:setSelectedIndex(3)
			return
		else
			c4:setSelectedIndex(4)
		end 
		local function funcEndCallBack(btn,tag) 
			setADSFunc(g_tbAdsReward.adsHDNumBZ,adsFunc)
			g_API_playAds(g_tbAdsReward.adsHDNumBZ,self.bzID)
		end
		g_SetBtnOne(self.rootLayout,"btnAds",2, funcEndCallBack)
	end 
end

function ComponentShaoDang:setHeroList(init)
	if  init or not self.heroMsg then
		local cfgMsg =  g_cfgMsg:getCfgMsg("role_D") 
		self.heroMsg = {}
		for i,v in pairs(cfgMsg)do
			self.heroMsg[#self.heroMsg+1] = v
		end 
		local function comps(a,b)
			return a.key < b.key
		end
		table.sort(self.heroMsg , comps)
		
	end 
	local heroList = self.rootLayout:getChild("heroList")
	heroList:itemRenderer(function(index, obj)
		index = index + 1
		local heroID = self.heroMsg[index].key
		obj:setCustomData(heroID)
		self:setHeroListItem(obj,heroID)	
	end)
	heroList:setVirtual()--回调
    heroList:setNumItems(#self.heroMsg);
end 	


function ComponentShaoDang:setName()
	local sdName = self.rootLayout:getChild("sdName")
	local saodanLev = self.rootLayout:getChild("saodanLev")
	local resText = self.rootLayout:getChild("resText")
	local needMsg = self.rootLayout:getChild("needMsg")
	local needTimeText = self.rootLayout:getChild("needTime")
	local info = g_baozangMsg:getbaozangMsg(self.bzID)
	local mapID = info.mapID
	local tbMsg =  g_cfgMsg:getCfgMsg("baozangName_D",mapID)
	sdName:setText(tbMsg.name)
	local levPJ = info.levPJ
	saodanLev:setText(levPJ)
	local needTiliValue = info.needTiliValue
	needMsg:setVar("value",tostring(needTiliValue)) 
	needMsg:flushVars()
	
	local needTime = info.needTIme

	if not needTime then
		local cfgMsg =  g_cfgMsg:getCfgMsg("baozang_D",levPJ)
		needTime = cfgMsg.needTime*3600
	end 
	
	local  str = cc.getStrTimeByS4(needTime)
	--cclog("====needTime======",needTime)
	 needTimeText:setText(str)
	
	local cfgMsg =  g_cfgMsg:getCfgMsg("baozang_D", levPJ)
	local cost = cfgMsg.levUpZs
	resText:setText(cost)
	
	--设置物品
	local dropEqu = {}
	for i,info in pairs(info.dropEqu)do
		dropEqu[#dropEqu+1] = info
	end 
	local function comps(a,b)
		return a.id < b.id
	end
	table.sort(dropEqu , comps)
	
	local item1 = self.rootLayout:getChild("item1")
	local info1 = dropEqu[1]
	g_gNodeConTrol:setWorldEqu(item1,1,nil,info1)
	local item2 = self.rootLayout:getChild("item2")
	local info2 = dropEqu[2]
	g_gNodeConTrol:setWorldEqu(item2,1,nil,info2)
	local c3 = self.rootLayout:getController("c3") --控制器
	local equDecPanle = self.rootLayout:getChild("equDecPanle")
	local function callback()	
		c3:setSelectedIndex(0)
	end 
	local function funcEndCallBack(btn,tag) 	
		if self.touchEqu and self.touchEqu  == tag then
			c3:setSelectedIndex(0)
			self.touchEqu = nil
			return
		elseif self.touchEqu and self.touchEqu  ~= tag then
			c3:setSelectedIndex(tag)
		else 
			c3:setSelectedIndex(tag)
		end 
		self.touchEqu = tag
		local info2 = dropEqu[tag]
		g_gNodeConTrol:setWorldEuqDecPanle(equDecPanle,info2.id,nil,callback,nil,nil,info2)
		local c1 = equDecPanle:getController("c1") --控制器
		c1:setSelectedIndex(4)
	end
	g_SetBtnOne(nil,nil,1, funcEndCallBack,item1)
	g_SetBtnOne(nil,nil,2, funcEndCallBack,item2)
	
	local item3 = self.rootLayout:getChild("item3")

	for i,info in pairs(info.dropGoods)do
		local cfgID = info.id
		local numD =  info.addNumber
		g_gNodeConTrol:setGoodsItem(cfgID, item3,numD)	
	end 
	
	local function funcEndCallBack(btn,tag) 	
		 
			local status = g_baseConTrol:resEnough(g_resCfgId.diamond,cost,notSend)
			if not status  then
				return 
			end 
			if levPJ >= 7  then
				g_action:ts_hszz_antion("已是最高级")
				return
			end 
			--判断是否升级过
			local info = g_baozangMsg:getbaozangMsg(self.bzID)
			local addlevPJ = info.addlevPJ or 0
			if addlevPJ > 0  then
				g_action:ts_hszz_antion("本次探索已升级过")
				return
			end 
			g_svSendMsgControl:request_BZContorl(3,self.bzID,self.selectHero)
	end
	g_SetBtnOne(self.rootLayout,"btnLev",2, funcEndCallBack)
	local btnLev = self.rootLayout:getChild("btnLev")
	if levPJ >= 7  then
		btnLev:setVisible(false)
	end 
	
end

---nType 0
function ComponentShaoDang:setTSHeroItem(index)
	local heroItem = self.rootLayout:getChild("heroItem"..index)
	local info = g_baozangMsg:getbaozangMsg(self.bzID)
	local nStarTime = info.nStarTime
	local c3 = heroItem:getController("c3") --控制器
	
	if nStarTime == -1  then
		local heroID = self.selectHero[index]
		if not heroID then
			c3:setSelectedIndex(1)
		else
			c3:setSelectedIndex(2)
			self:setHeroListItem(heroItem,heroID)
		end 
	else
		local tbhero = info.heroID
		local heroID = tbhero[index]
		self:setHeroListItem(heroItem,heroID)
		c3:setSelectedIndex(2)
	end
end

function ComponentShaoDang:startRe(bzID)
	local info = g_baozangMsg:getbaozangMsg(bzID)
	local nType = nType or 0
	if not  self.rootLayout then
		return 
	end 
	local c1 = self.rootLayout:getController("c1") --控制器
	local c2 = self.rootLayout:getController("c2") --控制器
	local  nStarTime = info.nStarTime
	if nStarTime == -1  then
		c1:setSelectedIndex(0)
		c2:setSelectedIndex(0)
		self:setHeroList(true)
	elseif nStarTime == 0  then
		c1:setSelectedIndex(1)
		c2:setSelectedIndex(0)
		self:setYWGoodsList()
	elseif nStarTime > 0  then
		c1:setSelectedIndex(0)
		c2:setSelectedIndex(1)
		self:setTsTime()
		self:setHeroList()
	end
	self:setTSHeroItem(1)
	self:setTSHeroItem(2)
end

function ComponentShaoDang:openWnd(bzID)
	cclog('ComponentShaoDang:')
	fgui.UIPackage:addPackage("b_mapSence")
	self.bzID = bzID
	self.selectHero = {}
	if not self.rootLayout  then
		self:initWnd()
		self:setBtn()
	end 
	self:setName()
	self:setTSHeroItem(1)
	self:setTSHeroItem(2)
	local info = g_baozangMsg:getbaozangMsg(bzID)
	local nType = nType or 0
	local c1 = self.rootLayout:getController("c1") --控制器
	local c2 = self.rootLayout:getController("c2") --控制器
	local  nStarTime = info.nStarTime
	if nStarTime == -1  then
		c1:setSelectedIndex(0)
		c2:setSelectedIndex(0)
		self:setHeroList(true)
	elseif nStarTime == 0  then
		c1:setSelectedIndex(1)
		c2:setSelectedIndex(0)
		self:setYWGoodsList()
	
	elseif nStarTime > 0  then
		c1:setSelectedIndex(0)
		c2:setSelectedIndex(1)
		self:setTsTime()
		self:setHeroList()
	end
---	local n93 = self.rootLayout:getChild("n93")
	--local value1, value2  = g_baseConTrol:isOpenVipLev(18)
	--if value1  > 0  then
		---n93:setVisible(true)
	--end 
end

function ComponentShaoDang:ctor()

end

g_ComponentShaoDang =  ComponentShaoDang:create()