local connectItem = class("connectItem")

function connectItem:setText(dec)
	local text = self.rootLayout:getChild("text")
	if  dec then
		text:setText(dec)
	end 
end

function connectItem:initWnd()
	cclog('connectItem:initWnd')
end 

function connectItem:closeWnd()
	cclog('connectItem:closeWnd')
end

function connectItem:proText(nTimeStr)
	local proText = self.rootLayout:getChild("proText")
	proText:setText(nTimeStr.."%")
end 

function connectItem:openWnd(dec,nTime)
	local nTime = nTime or 5 
	local count = 0
	local text = self.rootLayout:getChild("text")
	local n9 = self.rootLayout:getChild("n9")
	--text:setVisible(false)
	--n9:setVisible(false)
	self:setText(dec)
	
	local pic = self.rootLayout:displayObject()
	local function callBack()
		count = count + 1
		
		cclog(count,"===connectItem====",nTime)
		if count == nTime  then
			g_scheduleTime:stopScheduleForever(pic)
			self:close()
		end
	end

	g_scheduleTime:scheduleForever(pic,1,callBack)
end

return connectItem