
local newGuideWnd = class("newGuideWnd")

local tbWndMsg = {  "A_main" ,"A_main", "new_guide", "app.views.panle.newGuideWnd"}


function newGuideWnd:closeWnd(bRemove)
	---cclog('newGuideWnd:closeWnd',debug.traceback()) --堆栈
	self.tbMsg  = nil
	--if self.rootLayout and self.rootLayout:isVisible() then
	--	self.rootLayout:setVisible(false)
	--end 
	if  self.rootLayout  then	
		self.rootLayout:removeFromParent()
		self.rootLayout = nil
	end 
end

function newGuideWnd:setWndParent(parent)
	cclog('newGuideWnd:setWndParent')
	local parent =   parent or g_WndMgr:getCurWnd().rootLayout
	self.rootLayout:retain()
	self.rootLayout:removeFromParent()
	g_GameDataMgr.rootObj:addChild(self.rootLayout);
	self.rootLayout:release()
	local rootLayout =self.rootLayout:displayObject()
	rootLayout:setLocalZOrder(G_tishiLocalZOrder+4)
end


function newGuideWnd:initWnd(parent)
	local  szPacakgePath = tbWndMsg[1]
	local  szPacakge = tbWndMsg[2]
	local szWndName = tbWndMsg[3]
	fgui.UIPackage:addPackage(szPacakgePath)
	local _view = fgui.UIPackage:createObject(szPacakge, szWndName)
	self.rootLayout = _view	
	local parent = parent or g_GameDataMgr.rootObj
	parent:addChild(_view);
	_view:setSize(g_visibleSize.width,g_visibleSize.height);
	local _view =_view:displayObject()
	_view:setLocalZOrder(G_tishiLocalZOrder+4)
	
	self.touch = self.rootLayout:getChild("touch")
	local rootLayout = self.rootLayout:displayObject()
	local touch = self.touch:displayObject()
	touch:setLocalZOrder(100)
	local atPos = cc.p(-100,-100)
	self.touchAmami = g_gArmature:showArmatureByNums("OnTouchGuide","OnTouchGuide",rootLayout,nil,-1)
	self.touchAmami:setLocalZOrder(1)
	self:initBtn()
end


function newGuideWnd:finishNewGuide()
	--跳过新手引导
		cclog("====跳过新手引导===")
		
		local key = self.tbMsg.GuideID
		local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",key)
		local nType = tbCfgMsg.nType
		if nType <= 6  then
			for i=1,6 do
				g_newGuideMsg:setTbGuideOfstatus(i,1)
				g_svSendMsgControl:request_newGuide(i,1)
			end 
		else	
			g_svSendMsgControl:request_newGuide(nType,1)
			g_newGuideMsg:setTbGuideOfstatus(nType,1)
			---g_newGuideMsg:setTbGuide(nType,1)
		end 
		self:closeWnd(true)
end 
function newGuideWnd:initBtn()
	local function funcEndCallBack(btn,tag) 
		self:finishNewGuide()
	end 
	
	g_SetBtnOne(self.rootLayout, "n19" ,1, funcEndCallBack,nil,true)	
	local function funcEndCallBack(btn,tag) 
		if self.tbMsg.func then
			self.tbMsg.func()
		else
			self:closeWnd()
		end 
	end 
	local panle = self.rootLayout:getChild("panle")
	local guide_talkPanle= self.rootLayout:getChildInGroup(panle,"guide_talkPanle")
	g_SetBtnOne(nil, nil ,1, funcEndCallBack,guide_talkPanle,true)
	
end 


function newGuideWnd:showTalkPanle(tbMsg)
	local panle = self.rootLayout:getChild("panle")
	local dec= self.rootLayout:getChildInGroup(panle,"dec") --高级组
	local guide = self.rootLayout:getController("guide") --控制器 
	local key = tbMsg.GuideID
	local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",key)
	local nType = tbCfgMsg.wndType
	
	local panle = self.rootLayout:getChild("panle")
	if tbMsg.talk and  tbMsg.talk ~= "" then
		guide:setSelectedIndex(1)
		showTextActionFGUI(dec,tbMsg.talk,0.05)
		if tbMsg.icon then
			local icon= self.rootLayout:getChildInGroup(panle,"icon")	
			local path = g_iconConTrol:getcGuideIcon(tbMsg.icon)
			icon:setIcon(path)
		end 
	else
		guide:setSelectedIndex(nType)
	end 
end

function newGuideWnd:showTouchPanle(tbMsg)
	local touch = self.rootLayout:getChild("touch")
	local key = tbMsg.GuideID
	local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",key)
	local nType = tbCfgMsg.wndType
	if nType == 0  or nType == 3  then
		local size = tbMsg.size  or {120,120}
		local pos  = self.tbMsg.pos
		self.touchAmami:setVisible(true)
		cclog(size,"==size==",tbMsg,pos)
		touch:setSize(size[1],size[2])
		touch:setPosition(pos.x,1440-pos.y)
		self:showTouchAction()
	else
		self.touchAmami:setVisible(false)
	end 
	
end

function newGuideWnd:showTouchAction(tbMsg)
	if self.atPos then
		self.touchAmami:setPosition(self.atPos.x, self.atPos.y)
	end 
	cclog("======self.tbMsg.pos==0=",self.tbMsg.pos)
	local actionMove1 = cc.MoveTo:create(0.5,self.tbMsg.pos)
	local function endCallback()
		self.touch:setVisible(true)
		
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionSequence = cc.Sequence:create(actionMove1,actionEnd)
	actionSequence:setTag(1009)
	self.atPos  = self.tbMsg.pos
	self.touchAmami:stopActionByTag(1009)
	self.touchAmami:runAction(actionSequence)
end

---tbMsg = {talk,name,icon,pos,size,func,nType,GuideID}
function newGuideWnd:openWnd(tbMsg,init)
	cclog('newGuideWnd:openWnd')
	self:closeWnd()
	local curWndID =  g_WndMgr:getTopWndID()	
	local parent = g_GameDataMgr.rootObj
	self:initWnd()
	
	local rootLayout =self.rootLayout:displayObject()
	rootLayout:setLocalZOrder(G_tishiLocalZOrder+4)
	self.tbMsg = tbMsg
	
	local key = tbMsg.GuideID
	local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",key)

	if tbMsg.GuideID then
		local key = tbMsg.GuideID
		local tbCfgMsg = g_cfgMsg:getCfgMsg("new_tip_D",key)
		
		if not tbMsg.talk and tbCfgMsg.des ~= "" then
			tbMsg.talk  = tbCfgMsg.des
		end 
		if not tbMsg.icon and tbCfgMsg.icon ~= ""  then
			tbMsg.icon  = tbCfgMsg.icon
		end 
		
		local itemSize ,touchitem
		if not tbMsg.pos and tbCfgMsg.posX  then
			cclog(tbCfgMsg,"=====新手引导==1111=====new1=11==",tbCfgMsg.item)
			if tbCfgMsg.item and tbCfgMsg.item ~= ""  then
				local itemTable= cc.g_inalienContentByCfgMsg(tbCfgMsg.item,2,"|")
				local rootLayout = g_WndMgr:getCurWnd().rootLayout
				local parent  = rootLayout
				local parent1
				local childCount = 1
				local lastType
				for i,itemName in ipairs(itemTable)do
					cclog("=====新手引导==1111=====new1===",itemName,lastType)
					if not parent then
						cclog("=====parent====",itemName)
						---self:finishNewGuide()
						return 
					end
					
					if itemName =="child" then
						local tbChildID = cc.g_inalienContentByCfgMsg(tbMsg.icon ,1,"_")  or {}
						local items = parent:getChildren()
						--cclog("========")
						local index = tbChildID[childCount] or 1
						local item =items[index]
						parent = item
						childCount = childCount + 1
					elseif itemName =="root" then
						parent = g_GameDataMgr.rootObj 
					elseif itemName =="panleWnd" then
						local wndCloss = g_panleMgr:getPannelwd(g_panleMgr.panleID)
						parent = wndCloss.rootLayout
					elseif itemName =="custom" then
						lastType = 1
						---cclog("==custom====")
					elseif lastType == 1 then
						parent = getChildById(parent,itemName)
						---cclog(parent,"==lastType===222=",parent,itemName)
						lastType = 0
					elseif self.isWnd  then	
						self.isWnd =  nil
						local wnd =  g_WndMgr:getWnd(itemName)
						parent = wnd.rootLayout
						
					else
						local item = parent:getChild(itemName)
						parent = item
					end 
					
				end 
				if not parent then
					self:finishNewGuide()
					return 
				end
				local  parent1 = parent:displayObject()
				local nSize = parent1:getContentSize()
				local nScale = parent1:getScale()
				nSize.width= nSize.width *nScale
				nSize.height= nSize.height *nScale
				itemSize =nSize
				local toPos =  getWorildPos(parent1)
				
				local Pivot =  parent:getPivot()
				local posX = toPos.x
				local posY = toPos.y
				cclog(toPos,"=====新手引导==3333===new1===",toPos,nSize,nScale,Pivot)
				if Pivot.x == 0  then
					posX = toPos.x + nSize.width/2
				end 
				if Pivot.y == 0  then
					posY = toPos.y -nSize.height/2
				end 
				tbMsg.pos  = cc.p( posX,posY )
			elseif tbCfgMsg.posX == -1  then	 --查找相同的
				
			elseif tbCfgMsg.posX == -2 then	 --	
				 
			elseif tbCfgMsg.posX == -3  then	 --查找相同的
				
			elseif tbCfgMsg.posX == -4 then	 --	
				
			elseif tbCfgMsg.posX == -5 then	 --	
				
			elseif tbCfgMsg.posX == -6 then	 --	
				 --g_indexGaui6 =g_batContorl2:getItemOne(g_indexGaui5)
				 --local batScene = g_WndMgr:getWnd("batScene")
				-- touchitem =  batScene:getItemByIndex(g_indexGaui6)
			else
				tbMsg.pos  = cc.p(tbCfgMsg.posX,710-tbCfgMsg.posY)
			end 
		end 
		if touchitem then
			local parent = touchitem
			local  parent1 = parent:displayObject()
			local nSize = parent1:getContentSize()
			local nScale = parent1:getScale()
			nSize.width= nSize.width *nScale
			nSize.height= nSize.height *nScale
			itemSize =nSize
			local toPos =  getWorildPos(parent1)
			
			local Pivot =  parent:getPivot()
			local posX = toPos.x
			local posY = toPos.y
			cclog(toPos,"=====新手引导==3333===new1===",toPos,nSize,nScale,Pivot)
			if Pivot.x == 0  then
				posX = toPos.x + nSize.width/2
			end 
			if Pivot.y == 0  then
				posY = toPos.y -nSize.height/2
			end 
			tbMsg.pos  = cc.p( posX,posY )
		end 
		if not tbMsg.size  and   itemSize  then
			if itemSize then
				tbMsg.size  = {itemSize.width,itemSize.height}
			elseif tbCfgMsg.width   then
				tbMsg.size  = {tbCfgMsg.width,tbCfgMsg.heigh}
			end 
		end 
	end 
	self:showTalkPanle(tbMsg)
	self:showTouchPanle(tbMsg)
	self.rootLayout:setVisible(true)
end

function newGuideWnd:ctor()
end

g_newGuideWnd =  newGuideWnd:create()