
local skillLevUpPanle = class("skillLevUpPanle")

--吞噬结束
function skillLevUpPanle:endAnima(addExp)	
	local expText= self.rootLayout:getChild("expText" )
	local iconItem= self.rootLayout:getChild("iconItem"..self.touchSkillIndex)
	local pos2 = cc.p(30,40)
	local ArmatureEndA = g_gArmature:showArmature("FuncShowExplode",iconItem,nil,nil,pos2)
	
	expText:setText("+"..addExp)
	local t0 = self.rootLayout:getTransition("t"..self.touchSkillIndex)
	t0:play()
	
	self:setSkillIcon()
	self:reloadBagList()
	local MainScene = g_WndMgr:getWnd("MainScene")
	 MainScene:setHeroHeadItem(1)	
	 MainScene:setHeroHeadItem(2)	
	 g_gameMusic:playEffect(44)
end
---=========================================
function skillLevUpPanle:setHeroSkillListItem(obj,index)	
	local c1 = obj:getController("c1") --控制器
	local c2 = obj:getController("c2") --控制器
	local skillItem= obj:getChild("skillItem")
	
	local tbMsg = self.SkillBag[index]
	if not tbMsg then
		c1:setSelectedIndex(0)
		c2:setSelectedIndex(2)
		return 
	end 
	c1:setSelectedIndex(1)
	
	local cfgID = tbMsg.cfgID
	local yase = tbMsg.yanse
	cclog("===setHeroSkillListItem===",cfgID,yase)
	
	c2:setSelectedIndex(1)
	g_gNodeConTrol:setHeroSkill(skillItem,cfgID,yase,true)
	
	local checkBtn= obj:getChild("checkBtn2")
	
	if self.tbSkillCfgID[tbMsg.id] then
		checkBtn:setText(1)
	else
		checkBtn:setText(0)
	end 
	local function funcEndCallBack(btn,tag) 
		if self.tbSkillCfgID[tbMsg.id] then
			checkBtn:setText(0)
			self.tbSkillCfgID[tbMsg.id] = nil
		else
			checkBtn:setText(1)
			self.tbSkillCfgID[tbMsg.id] =  {id= tbMsg.id , value = 1}
		end
	end 
	g_SetBtnOne(obj, "checkBtn2",1, funcEndCallBack)	
	
end

function skillLevUpPanle:selAllItem()
	for i,v in pairs(self.SkillBag)do
		self.tbSkillCfgID[v.id] = {id= v.id , value = 1}
	end 
	local bagList= self.rootLayout:getChild("bagList")
	local chidren = bagList:getChildren()
	cclog("=====selAllItem==")
	for i =1, #chidren do
		local curChild = chidren[i] 
		local checkBtn= curChild:getChild("checkBtn2")
		checkBtn:setText(1)
	end
end

function skillLevUpPanle:delAllItem()
	self.tbSkillCfgID = {}
	local bagList= self.rootLayout:getChild("bagList")
	local chidren = bagList:getChildren()
	cclog("=====delAllItem==")
	for i =1, #chidren do
		local curChild = chidren[i] 
		local checkBtn= curChild:getChild("checkBtn2")
		checkBtn:setText(0)
	end
end

function skillLevUpPanle:reloadBagList(showYanse)
	local bagList= self.rootLayout:getChild("bagList")
	local maxvalue = g_goodsMsg:mathMaxSkillBagNum()
	local tbSkillBagMsg = g_skillBagMsg:getskillBagMsg() or {}
	local showYanse = showYanse or  self.showYanse
	self.SkillBag = {}
	self.tbSkillCfgID = {}
	local selAll= self.rootLayout:getChild("selAll")
	selAll:setText(0)
	local count = 0
	
 	for id,v in pairs(tbSkillBagMsg)do
		local yanse = v.yanse
		if yanse > 10 then
			yanse = 1
		end 
		for i,n in ipairs(showYanse)do
			if n == yanse  then
				self.SkillBag[#self.SkillBag+1] = v
				count = count+ 1
			end 
		end 
	end 
	local function comps(a,b)
		if a.yanse == b.yanse   then
			if a.cfgID == b.cfgID then
				return a.id < b.id
			else
				return a.cfgID < b.cfgID
			end 
		else
			return a.yanse > b.yanse
		end 	
	end
	table.sort(self.SkillBag, comps)

	bagList:itemRenderer(function(index, obj)
		index = index + 1
		--local cfgID = self.SkillBag[index] or 0
		obj:setCustomData(index)
		self:setHeroSkillListItem(obj,index)	
	end)
	bagList:setVirtual()--回调
    bagList:setNumItems(maxvalue);
	
	local numText= self.rootLayout:getChild("numText")
	local str = string.format("(%d/%d)",count,maxvalue)
	numText:setText(str)
	bagList:scrollToView(0,true,true)
end

function skillLevUpPanle:initYansCheckbtn()
	local yansBtn0= self.rootLayout:getChild("yansBtn0")
	local yansBtn2= self.rootLayout:getChild("yansBtn2")
	local yansBtn3= self.rootLayout:getChild("yansBtn3")
	local yansBtn4= self.rootLayout:getChild("yansBtn4")
	local yansBtn5= self.rootLayout:getChild("yansBtn5")
	local c1 =  self.rootLayout:getController("c1") --控制器
	self.showYanse = {1,2,3,4,5}
	self:reloadBagList()
	local function funcEndCallBack(btn,tag) 
		local textStr = tonumber(btn:getText())
		local textStr2 = (textStr+1)%2
		btn:setText(textStr2)
		if tag == 0 then
			---cclog(textStr,"=====setSelectedIndex====",textStr2)
			c1:setSelectedIndex(textStr)
			if textStr2 == 1 then
				self.showYanse = {1,2,3,4,5}
				yansBtn2:setText(1)
				yansBtn3:setText(1)
				yansBtn4:setText(1)
				yansBtn5:setText(1)
			end 
		else 
			if textStr2 == 1 then
				self.showYanse[tag]  = tag
				if tag == 2 then 
					self.showYanse[1]  = 1
				end 
			else 
				self.showYanse[tag]  = 0
				if tag == 2 then 
					self.showYanse[1]  = 0
				end 
			end 
		end 
		self:reloadBagList()
	end 
	g_SetBtnOne(nil, nil,0, funcEndCallBack,yansBtn0)	
	g_SetBtnOne(nil, nil,2, funcEndCallBack,yansBtn2)	
	g_SetBtnOne(nil, nil,3, funcEndCallBack,yansBtn3)	
	g_SetBtnOne(nil, nil,4, funcEndCallBack,yansBtn4)	
	g_SetBtnOne(nil, nil,5, funcEndCallBack,yansBtn5)	
end 

function skillLevUpPanle:setSkillLevItem(skillID,item,noBar)
	self.lev = g_gNodeConTrol:setSkillItem_Lev(skillID,item,self.batIndex, self.skillIndex,nil,noBar)
	
	return  self.lev
end

function skillLevUpPanle:setSkillIcon(index)
	local index = index or self.touchSkillIndex
	local iconItem= self.rootLayout:getChild("iconItem"..index)
	local skillIcon= iconItem:getChild("skillIcon")
	local skillLev= iconItem:getChild("skillLev")
	local bar= iconItem:getChild("bar")
	local lev,nExp,baseLev = g_baseBatMsg:getbaseBatMsgSkillMsg(batIndex,index)
	skillLev:setText(lev)
	local cfgMsg =  g_cfgMsg:getCfgMsg("skillLev_D",baseLev+1) 
	local maxExp = cfgMsg.getExp
	bar:setMax(maxExp)
	bar:setValue(nExp)
	
	skillIcon:setIcon("")
	----skillIcon:setVisible(false)
end

function skillLevUpPanle:touchSkillIndexFuc(tag)
	self.touchSkillIndex = tag
	local c2 =  self.rootLayout:getController("c2") --控制器
	c2:setSelectedIndex(tag-1)
	local title= self.rootLayout:getChild("title" )
	--text的模板 
	title:setVar("index",tostring(tag)) 
	title:flushVars()
end


function skillLevUpPanle:initWnd()
	local function funcEndCallBack(btn,tag) 
		local MainScene = g_WndMgr:getWnd("MainScene")
		 MainScene:closeHeroDec()
	end 
	g_SetBtnOne(self.rootLayout, "clockBtn",1, funcEndCallBack)	
	
	local function funcEndCallBack(btn,tag) 
		---g_action:ts_hszz_antion("吞噬技能")
		local count = getTbCount(self.tbSkillCfgID)
		if count <=0 then
			--return
		end 
		local index = cc.UserDefault:getInstance():getIntegerForKey("stSkillBook",0)
		local tbSkillBook
		if index == 1 then
			tbSkillBook = {}
			for i=1,3 do
				local str = "yansSkillBook"..i
				local index = cc.UserDefault:getInstance():getIntegerForKey(str,0)
				cclog("===str====",str,index)
				
				tbSkillBook[i] = index
			end 
		end 
		g_svSendMsgControl:request_batIndex(3,self.batIndex,self.touchSkillIndex,self.tbSkillCfgID,tbSkillBook)
	end 
	g_SetBtnOne(self.rootLayout, "btnTS",1, funcEndCallBack)	
	
	local selAll= self.rootLayout:getChild("selAll")
	local function funcEndCallBack(btn,tag) 
		local text = tonumber(selAll:getText())
		cclog(text,"===funcEndCallBack==")
		if text ==  1 then
			self:delAllItem()
			selAll:setText(0)
		else
			self:selAllItem()
			selAll:setText(1)
		end 
	end 
	g_SetBtnOne(self.rootLayout, "selAll",1, funcEndCallBack)	
	
	local expText= self.rootLayout:getChild("expText" )
	expText:setText("")
	
	
	
	local function funcEndCallBack(btn,tag) 
		self:touchSkillIndexFuc(tag)
	end
	for index=1,4 do
		g_SetBtnOne(self.rootLayout,"iconItem"..index,index, funcEndCallBack)	
	end
end


function skillLevUpPanle:setTSSkillBook()
	local function funcEndCallBack(btn,tag) 
		local str = "yansSkillBook"..tag
		local index = cc.UserDefault:getInstance():getIntegerForKey(str,0)
		index = (index+1)%2
		btn:setText(index)
		cc.UserDefault:getInstance():setIntegerForKey(str,index)
		cclog(str,"===funcEndCallBack==",tag,index)
	end
	for index=1,3 do
		local str = "yansSkillBook"..index
		local yansSkillBook = self.rootLayout:getChild(str)
		local indexD = cc.UserDefault:getInstance():getIntegerForKey(str,0)
		yansSkillBook:setText(indexD)
		g_SetBtnOne(self.rootLayout,str,index, funcEndCallBack)	
	end
	
	local index = cc.UserDefault:getInstance():getIntegerForKey("stSkillBook",0)
	local yansSkillBook= self.rootLayout:getChild("yansSkillBook" )
	yansSkillBook:setText(index)
	
	local function funcEndCallBack(btn,tag) 
		local index = cc.UserDefault:getInstance():getIntegerForKey("stSkillBook",0)
		index = (index+1)%2
		yansSkillBook:setText(index)
		cc.UserDefault:getInstance():setIntegerForKey("stSkillBook",index)
	end
	g_SetBtnOne(self.rootLayout,"yansSkillBook",0, funcEndCallBack)	
end


function skillLevUpPanle:reloadWnd()
	self:initYansCheckbtn()
end

function skillLevUpPanle:openWnd(panle,skillID,batIndex,skillIndex)
	self.rootLayout = panle
	self.tbSkillCfgID = {}
	self.skillID = skillID or 0
	self.batIndex = batIndex or 0
	self.skillIndex = skillIndex or 0
	self:initWnd()
	self:setTSSkillBook()
	for i=1,4 do
		self:setSkillIcon(i)
	end 
	 self:touchSkillIndexFuc(1)
	if not g_skillBagMsg.svMsg then
		local function callback()
			g_skillBagMsg.svMsg  = 1
			self:reloadWnd()
		end 
		g_svSendMsgControl:request_skillBag(nil,nil,nil,callback)
		return
	end 

	
	self:reloadWnd()
end 

function skillLevUpPanle:ctor()
	
end

g_skillLevUpPanle =  skillLevUpPanle:create()