
local rankPanle = class("rankPanle")

function rankPanle:initWnd()

	local function funcEndCallBack(btn,tag) 
		cclog("======initWnd======",tag)
		if tag == 1 then
			
		elseif tag == 2 then
			
		
		
		end 
	end 

	--g_SetBtnOne(self.rootLayout, "btn1",1, funcEndCallBack)	
	--g_SetBtnOne(self.rootLayout, "btn3",3, funcEndCallBack)	

end 

function rankPanle:getBossName(BOSSID,jinhua)
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",BOSSID)
	local iconname = tbMsg.icon
	local baseName = "【"..tbMsg.name.."】"
	
	local name,yanse
	if jinhua and jinhua > 0  then
		local tbJHMsg =  g_cfgMsg:getCfgMsg("roleJinJieLev_D",jinhua)
		local jjName = tbJHMsg.name
		yanse = tbJHMsg.nType
		name = jjName..baseName 
	else
		name = baseName
		yanse = 1
	end 
	if yanse > 7  then
		yanse = 7
	end 
	local colorID = G_tb_TextColor[yanse]
	return name,colorID,yanse
end 

function rankPanle:setListItem(obj,playerID,indexD)	

	local info = g_rankMsg:getTbUserMsg(playerID)
	if not indexD then
		indexD = self.rankMy or info.rank or 201
	end 
	local nickName = info.nickName
	local lev = info.roleLev
	local zslevel = info.zuanshilev
	local maxMap = info.maxMap or {}
	local maxLev = maxMap[1] or 0
	local bossID = info.bossID
	local Bianyi = info.Bianyi or 0
	local jinhuaLev = info.jinhuaLev
	
	local textRank = obj:getChild("textRank")
	local textBossID = obj:getChild("textBossID")
	local textLev = obj:getChild("textLev")
	local textZs = obj:getChild("textZs")
	local textMapLev = obj:getChild("textMapLev")
	local textName = obj:getChild("textName")

	textRank:setText(indexD)
	if indexD > 200  then
		textRank:setText("未进榜")
	end 
	textName:setText(nickName)
	
	local name,colorID = self:getBossName(bossID,jinhuaLev)
	textBossID:setText(name)
	cc.g_setTextColor(textBossID,colorID,true)
	local c1 =  obj:getController("c1") --控制器
	if Bianyi == 1 then
		c1:setSelectedIndex(0)
	else
		c1:setSelectedIndex(1)
	end

	textLev:setVar("value",tostring(lev)) 
	textLev:flushVars()
	
	textZs:setVar("value",tostring(zslevel)) 
	textZs:flushVars()
	
	textMapLev:setVar("value",tostring(maxLev)) 
	textMapLev:flushVars()
	if g_GameDataMgr.userid == playerID then
		self.rankMy = indexD
	end 
end

function rankPanle:setList()
	local tbRank = g_rankMsg:getRankMsg()
	self.tbSmg = {}
	for i, v in pairs(tbRank)do
		local  id = v.value
	
		local info = g_rankMsg:getTbUserMsg(id)
		
		if info then
			self.tbSmg[#self.tbSmg+1] = id
		end 
	end 
	cclog("====setList=======",self.tbSmg)
	local function comps(a,b)
		local infoA = g_rankMsg:getTbUserMsg(a)
		local infoB = g_rankMsg:getTbUserMsg(b)
		if infoA.maxMap[1] ==  infoB.maxMap[1] then
			if infoA.zslevel ==  infoB.zslevel then
				if infoA.jinhuaLev ==  infoB.jinhuaLev then
					if infoA.maxMapIDTime ==  infoB.maxMapIDTime then
						return infoA.id < infoB.id
					else
						return  infoA.maxMapIDTime  >  infoB.maxMapIDTime
					end
				else
					return  infoA.jinhuaLev  >  infoB.jinhuaLev
				end
			else
				return  infoA.zslevel  >  infoB.zslevel
			end 
			
		else
			return  infoA.maxMap[1]  >  infoB.maxMap[1]
		end 
		
	end
	table.sort(self.tbSmg,comps)
	
	local rankList = self.rootLayout:getChild("rankList")
	rankList:itemRenderer(function(index, obj)
		local indexD = index + 1
		local cfgiD = self.tbSmg[indexD]
		--obj:setCustomData(cfgiD)
		self:setListItem(obj,cfgiD,indexD)	
	end)
	rankList:setVirtual()--回调
    rankList:setNumItems(#self.tbSmg);
	self.rootLayout:setVisible(true)
end 

function rankPanle:setMyItem()
	local myItem = self.rootLayout:getChild("myItem")
	self:setListItem(myItem,g_GameDataMgr.userid)	
	
end 
function rankPanle:openWnd()
	
	local sttsus = g_rankMsg:getSendTime()
	if sttsus == true then
		self:setList()
		self:setMyItem()
	end 
	self.rootLayout:setVisible(sttsus)
end 

	
return rankPanle
