
local tuanfuPanle = class("tuanfuPanle")

function tuanfuPanle:initWnd()

	local function funcEndCallBack(btn,tag) 
		cclog("======initWnd======",tag)
		if tag == 1 then
			g_WndMgr:showWnd("tuanfuPanleTujian")
			g_svSendMsgControl:request_getTianfuMsg(5,10,55)
		elseif tag == 2 then
			
			local tbQDMsg = {}
			tbQDMsg.dec =  "是否花费"..tbGameConst.tfReloadZs.."钻石重置天赋点"
			tbQDMsg.text1 = "确定"
			tbQDMsg.text2 = "取消"
			local function callBack()
				--判断钻石
				local status = g_baseConTrol:resEnough(g_resCfgId.diamond,tbGameConst.tfReloadZs)
				if not status  then
					return 
				end 
				g_svSendMsgControl:request_getTianfuMsg(2)
			end 
			tbQDMsg.qdFunc =  callBack
			g_quedingItem:openWnd(tbQDMsg) 	
			
		elseif tag == 3 then
			local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}
			local maxMapLev = fubenMaxLev[1] or 1
			local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
			if zslevel < 0  then
				g_action:ts_hszz_antion("转生后开启")
				return
			end 
			local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
			local freeNum =  self:getTFTreeReloadNum()
			if freeNum <= 0 and zslevel < 10  then
				g_action:ts_hszz_antion("改命次数已用完，每次转生获得10次")
				return
			end 
			--判断钻石
			local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
			local costzs = zslevel*500
			if costzs > 3000 then
				costzs = 3000
			end 
			local tbQDMsg = {} 
			tbQDMsg.dec =  "是否消耗"..costzs.."钻石重置天赋树"
			tbQDMsg.text1 = "确定"
			tbQDMsg.text2 = "取消"
			local function callBack()
				local status = g_baseConTrol:resEnough(g_resCfgId.diamond,costzs)
				if not status  then
					return 
				end 
				g_svSendMsgControl:request_getTianfuMsg(4)
			end 
			tbQDMsg.qdFunc =  callBack
			g_quedingItem:openWnd(tbQDMsg) 	
			
		end 
	end 
	g_SetBtnOne(self.rootLayout, "btnTj",1, funcEndCallBack)	
	
	g_SetBtnOne(self.rootLayout, "btnYW",2, funcEndCallBack)
	
	g_SetBtnOne(self.rootLayout, "btnTm",3, funcEndCallBack)
end 

function tuanfuPanle:getTFTreeReloadNum()
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	local maxNum = (zslevel+1)*10
	local tianfReloadNum =  g_baseMsg:getOther(otherDBMsgID.tianfReloadNum) or 0
	local freeNum = maxNum - tianfReloadNum
	return freeNum
end 

function tuanfuPanle:setReloadTFNum()
	local textReload = self.rootLayout:getChild("textReload")
	local freeNum =  self:getTFTreeReloadNum()
	textReload:setText("("..freeNum..")")
end 

function tuanfuPanle:setFreeTFNum()
	local textFreeNum = self.rootLayout:getChild("textFreeNum")
	local maxNum = g_tianfuMsg:getTFMaxFreeNum() 
	local nNum = g_tianfuMsg:getTFFreeNum()   
	textFreeNum:setText("空闲天赋点："..nNum.."/"..maxNum)
end 

function tuanfuPanle:showDecPanle()
	local textName = self.rootLayout:getChild("textName")
	local textLev = self.rootLayout:getChild("textLev")
	--local textTime = self.rootLayout:getChild("textTime")
	local textDec = self.rootLayout:getChild("textDec")
	
	local info = g_tianfuMsg:getTianfuTbMsg(self.touchItemID)
	local cfgMsg =  g_cfgMsg:getCfgMsg("tianfu_D",info.cfgID)
	textName:setText(cfgMsg.name)
	textLev:setText(info.lev.."|"..cfgMsg.maxLev)
	local value = g_tianfuMsg:getValuetianfu(info.cfgID,info.lev)   
	
	local tb_Str = {"x"}
	local tb_number = {value}
	local nameStr = cc.g_inalienContentByTbNumber(cfgMsg.dec,tb_Str,tb_number)  
	textDec:setText(nameStr)
	local curTianfuID =   0
	local c1 =  self.rootLayout:getController("c1") --控制器
	
	--textTime:setCustomData(self.touchItemID)
	--self.textTimeDecItem = textTime
	
	if curTianfuID == self.touchItemID then
		local str,lastTime = self:getItemTimeStr()  
		--textTime:setText("升级时间："..str)
		c1:setSelectedIndex(0)
		local cost = g_baseConTrol:mathNeedZsByTime(lastTime)
		local textNeedZs = self.rootLayout:getChild("textNeedZs")
		textNeedZs:setText(cost)
		
		
		local function funcEndCallBack(btn,tag) 
			--判断钻石
			local status = g_baseConTrol:resEnough(g_resCfgId.diamond,cost)
			if not status  then
				return 
			end 
			
			local tbQDMsg = {}
			tbQDMsg.dec =  "是否花费"..cost.."钻石立刻完成升级"
			tbQDMsg.text1 = "确定"
			tbQDMsg.text2 = "取消"
			local function callBack()
				g_svSendMsgControl:request_getTianfuMsg(3,self.touchItemID)
			end 
			tbQDMsg.qdFunc =  callBack
			g_quedingItem:openWnd(tbQDMsg) 	
		end 
		g_SetBtnOne(self.rootLayout, "btnZS",1, funcEndCallBack)
	else
		local needTime = g_tianfuMsg:getNeedTimetianfu(self.touchItemID) 
		local str = cc.getStrTimeByS(needTime)
		---cclog(needTime,"=====needTime=====",str)
		--textTime:setText("升级时间："..str)
		c1:setSelectedIndex(1)
	end 
	
	local function funcEndCallBack(btn,tag)
		self:showListItemEff()
		g_gameMusic:playEffect(73)
		--local curTianfuID = g_baseMsg:getOther(otherDBMsgID.curTianfuID) or  0
		--if curTianfuID > 0 then
			--g_action:ts_hszz_antion("有天赋正在升级中")
			--return	
		--end 
		--需要前面一层至少3点
		local cengIndex =  math.floor((self.touchItemID-1)/4) + 1
		--前一层点数
		if cengIndex > 1 then
			local count = 0
			for i=1,4 do
				local id = (cengIndex-2)*4 + i
				local infoD = g_tianfuMsg:getTianfuTbMsg(id)
				count = count + infoD.lev
			end
			if count < 6 then
				g_action:ts_hszz_antion("需要"..(cengIndex-1).."层至少6点天赋")
				return
			end 
		end 

		g_svSendMsgControl:request_getTianfuMsg(1,self.touchItemID)
	end 
	g_SetBtnOne(self.rootLayout, "btnXl",1, funcEndCallBack)

end 

function tuanfuPanle:showListItemEff(ID)
	local tfList = self.rootLayout:getChild("tfList")
	local id = ID or self.touchItemID
	local tfList = self.rootLayout:getChild("tfList")
	local index1 = math.floor((id-1)/4) + 1
	local panle = getChildById(tfList, index1)
	if panle then
		local index2 = (id-1)%4 + 1
		local item = panle:getChild("item"..index2)
		if item then
			local pos = cc.p(36,36)
			local  ArmatureEndA = g_gArmature:showArmature("FuncShowExplode",item,nil,nil,pos)
			ArmatureEndA:setScale(0.7)
		end 
	end 

end
--获取倒计时时间
function tuanfuPanle:getItemTimeStr(nType)
	local curTianfuIDStarTime = g_baseMsg:getOther(otherDBMsgID.curTianfuIDStarTime) or  0
	local curTianfuID = g_baseMsg:getOther(otherDBMsgID.curTianfuID) or  0
	local info = g_tianfuMsg:getTianfuTbMsg(curTianfuID)
	local cfgMsg =  g_cfgMsg:getCfgMsg("tianfu_D",info.cfgID)
	local baseTime = cfgMsg.nTime

	local needTime =  g_tianfuMsg:getNeedTimetianfu(curTianfuID)   
	local nTime = g_getCursvTime() - curTianfuIDStarTime
	local lastTime = needTime - nTime 
	local str = ""
	if lastTime > 0  then
		if nType  then
			str = cc.getStrTimeByS(lastTime,1,2)
		else
			str = cc.getStrTimeByS(lastTime,1)
		end 
		
	else
		return str,0
	end 
	return str,lastTime
end 

function tuanfuPanle:scheduleForever()

	if self.scheduleForeverStatus  then
		cclog("======self.scheduleForeverStatus======",self.scheduleForeverStatus)
		return
	end 
	local  itemObj = self.rootLayout:displayObject()
	--local textTime = self.rootLayout:getChild("textTime")
	local function CallBack() 
		local curTianfuID = g_baseMsg:getOther(otherDBMsgID.curTianfuID) or  0
		
		if curTianfuID <= 0  then
			g_scheduleTime:stopScheduleForever(itemObj)
			self.scheduleForeverStatus = nil
			return
		end 
		local str,lastTime = self:getItemTimeStr()
		if lastTime <= 0 then
			g_scheduleTime:stopScheduleForever(itemObj)
			self.scheduleForeverStatus = nil
			g_svSendMsgControl:request_getTianfuMsg(3)
			return
		end 
		

		if self.textTimeItem  then
			local id = self.textTimeItem:getCustomData()
			if id == curTianfuID then
				str = cc.getStrTimeByS(lastTime)
				self.textTimeItem:setText(str)
			end 
		end 
		if self.textTimeDecItem  then
			local id = self.textTimeDecItem:getCustomData()
			if id == curTianfuID then
				self.textTimeDecItem:setText("倒计时："..str)
			end 
		end 
	
	end
	local curTianfuID = g_baseMsg:getOther(otherDBMsgID.curTianfuID) or  0
	if curTianfuID > 0  then
		--self.scheduleForeverStatus = true
		--g_scheduleTime:scheduleForever(itemObj,1,CallBack)
	end 
	
end


function tuanfuPanle:touchListItem(obj,ID)
	if self.touchItemID then
		local tfList = self.rootLayout:getChild("tfList")
		local index1 = math.floor((self.touchItemID-1)/4) + 1
		local panle = getChildById(tfList, index1)
		cclog(self.touchItemID,"====touchListItem======",index1,panle)

		if panle then
			local index2 = (self.touchItemID-1)%4 + 1
			cclog(self.touchItemID,"====touchListItem====222==",index2)
			local item = panle:getChild("item"..index2)
			local c2 =  item:getController("c2") --控制器
			c2:setSelectedIndex(0)
		end 
	end 
	
	local c2 =  obj:getController("c2") --控制器
	c2:setSelectedIndex(1)
	self.touchItemID = ID
	self:showDecPanle()
	cclog(self.touchItemID,"====touchListItem=DD=",ID)
end 


function tuanfuPanle:setListItemOne(obj,id)
	local info = g_tianfuMsg:getTianfuTbMsg(id)
	if not obj then
		local tfList = self.rootLayout:getChild("tfList")
		local index1 = math.floor((id-1)/4) + 1 
		local panle = getChildById(tfList, index1)
		--cclog(panle,index1,"=======setListItemOne==1232====",id)
		if panle then
			obj = panle:getChild("item"..id)
		end 
	end 
	if not obj then
		return  0
	end 
	local cfgMsg =  g_cfgMsg:getCfgMsg("tianfu_D",info.cfgID)
	--local textLev = obj:getChild("textLev")
	obj:setText(cfgMsg.name)
	--textLev:setText(" ")
	local iconPath = g_iconConTrol:getTianfuYanseBgIcon(info.lev+1)
	obj:setIcon(iconPath)
	
	
	local c1 =  obj:getController("c1") --控制器
	if info.needID and info.needID > 0 then
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
	local curTianfuID =  0
	--local textTime = obj:getChild("textTime")
	--textTime:setCustomData(id)
	if curTianfuID == id then
		--local str = self:getItemTimeStr(true)
		--textTime:setText(str)
		--textTime:setVisible(true)
		--self.textTimeItem = textTime
	else
		--textTime:setVisible(false)
	end 
	
	local function funcEndCallBack(btn,tag) 
		self:touchListItem(obj,id)
	end 
	g_SetBtnOne(nil,nil,1, funcEndCallBack,obj)	
	
	if not  self.touchItemID and id == 1 then
		self:touchListItem(obj,id)
	end 
	local c2 =  obj:getController("c2") --控制器
	
	if  self.touchItemID and id == self.touchItemID then
		c2:setSelectedIndex(1)
	else
		c2:setSelectedIndex(0)
	end 
	local title = obj:getChild("title")
	local cengIndex =  math.floor((id-1)/4) + 1
	--cclog( self.tableMsg[cengIndex-1],"======cengIndex========")
	if  self.tableMsg[cengIndex-1] and self.tableMsg[cengIndex-1] <= 0  then
		title:setText("未知")
		cc.g_setTextColor(title,1,true)  
		self.tableItemMsg[id] = 0
	else	
		---cclog(self.tableMsg[id],self.tableMsg[cengIndex-1],"===self.tableMsg[id]=====",id,cengIndex)
		if self.tableItemMsg[id] and self.tableItemMsg[id] == 0 then
			self:showListItemEff(id)
			self.tableItemMsg[id] = nil
		end 
		if info.lev == 0 then
			cc.g_setTextColor(title,1,true)
		else
			local colorID = G_tb_TextColor[yanse]
			cc.g_setTextColor(title,colorID,true)
		end  
	end 
	
	return info.lev 
end 


function tuanfuPanle:setListItem(obj,index)
	local count = 0
	for i=1,4 do
		local id = (index-1)*4 + i
		local info = g_tianfuMsg:getTianfuTbMsg(id)
		count = count + info.lev 
	end 
	local textLev = obj:getChild("textLev")
	local title = obj:getChild("title")
	local number = 0
	title:setText("("..count..")")
	textLev:setText("第"..index.."层")
	self.tableMsg[index] = count
	for i=1,4 do
		local item = obj:getChild("item"..i)
		local id = (index-1)*4 + i
		item:setCustomData(id)
		local number = self:setListItemOne(item,id)
		count = count + number
	end 
end 


function tuanfuPanle:reloadListShow()
	local tfList = self.rootLayout:getChild("tfList")
	
	local chidren = tfList:getChildren()
	for i =1, #chidren do
		local curChild = chidren[i] 
		local index = curChild:getCustomData()
		self:setListItem(curChild,index)
	end 
end
function tuanfuPanle:reloadList()
	local tfList = self.rootLayout:getChild("tfList")
	local tianfuTbMsg = g_tianfuMsg:getTianfuTbMsg()
	self.tableMsg = {}
	self.tableItemMsg = {}
	tfList:itemRenderer(function(index, obj)
			local indexD = index + 1
			obj:setCustomData(indexD)
			self:setListItem(obj,indexD)
		end)
	tfList:setVirtual()--回调
	local  num = math.floor((#tianfuTbMsg-1)/4)
	--cclog("=====reloadList=========",num)
	tfList:setNumItems(num);
end 


function tuanfuPanle:openWnd()
	self:reloadList()
	self:setFreeTFNum()
	self:setReloadTFNum()
	self:scheduleForever()
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	local c2 =  self.rootLayout:getController("c2") --控制器
	if zslevel > 0  then
		c2:setSelectedIndex(1)
	end 
end 

	
return tuanfuPanle
