
local tuanfuPanleTujian = class("tuanfuPanleTujian")

function tuanfuPanleTujian:initWnd()

	local function funcEndCallBack(btn,tag) 
		cclog("======initWnd======",tag)
		self.curTouchType = tag
		self:reloadList(init)
	end 
	for i=1,5 do
		g_SetBtn(self.rootLayout, "btn"..i,i, funcEndCallBack)
	end 
	
end 

function tuanfuPanleTujian:setListItem(obj,cfgID)
	local title = obj:getChild("title")
	local textDec = obj:getChild("textDec")
	local textNum = obj:getChild("textNum")
	local cfgMsg =  g_cfgMsg:getCfgMsg("tianfu_D",cfgID)
	
	title:setText(cfgID.."."..cfgMsg.name)
	textDec:setText(cfgMsg.dec)
	textNum:setText(cfgMsg.number.."个")
end 

function tuanfuPanleTujian:sortTbMsg()
	local cfgMsg =  g_cfgMsg:getCfgMsg("tianfu_D")
	self.tbTjmsg = {}
	for i,v in ipairs(cfgMsg)do
		if not self.tbTjmsg[v.tjType] then
			self.tbTjmsg[v.tjType] = {}
		end 
		local count = #self.tbTjmsg[v.tjType] + 1
		self.tbTjmsg[v.tjType][count] = v
	end 
	
end

function tuanfuPanleTujian:reloadList(init)
	local tjList = self.rootLayout:getChild("tjList")
	if init then
		self:sortTbMsg()
	end 

	tjList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local cfgID = self.tbTjmsg[self.curTouchType][indexD].key
			obj:setCustomData(cfgID)
			self:setListItem(obj,cfgID)
		end)
	tjList:setVirtual()--回调
	tjList:setNumItems(#self.tbTjmsg[self.curTouchType]);
end 


function tuanfuPanleTujian:openWnd()
	self.curTouchType = 1
	 self:reloadList(true)
	local sdPanle = self.rootLayout:getChild("sdPanle")
	self:setListItem(sdPanle,1)
end 

	
return tuanfuPanleTujian
