
local tujianPanle = class("tujianPanle")

function tujianPanle:initWnd()
	local function funcEndCallBack(btn,tag) 
		--cclog("====funcEndCallBack===",tag)
		if tag == self.curTag  then
			return
		end 
		handler(self, self["initlList"..tag])()
	end 
	for i=1,6 do
		g_SetBtn(self.rootLayout, "btn"..i,i, funcEndCallBack)	
	end 
	
	local function funcEndCallBack(btn,tag) 
		self:initlList5()
	end 
	for i=1,9 do
		g_SetBtn(self.rootLayout, "btnEuq"..i,i, funcEndCallBack)	
	end 	
end 

function tujianPanle:setListItemTaoItem(obj,cfgID)
	local  title =  obj:getChild("title") 
	local  textCz =  obj:getChild("textCz") 
	local c1 =  obj:getController("c1") --控制器
	
	local info =  g_TujianMsg:getTbTujianMsg(cfgID) or {}
	local c2 =  obj:getController("c2") --控制器
	--cclog(info.yanse,"====info.yanse======")
	if info.yanse and info.yanse > 0 then
		c2:setSelectedIndex(1)
		local colorID = G_tb_TextColor[info.yanse]
		cc.g_setTextColor(title,colorID,true)
	else
		c2:setSelectedIndex(0)
	end 
	local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D",cfgID)
	title:setText(tbMsg.name)
	local pjunValue1 = math.floor((tbMsg.addRationMin1 +  tbMsg.addRationMax1)*10/2)/10
	local pjunValue2 = math.floor((tbMsg.addRationMin2 +  tbMsg.addRationMax2)*10/2)/10
	--text的模板 
	textCz:setVar("value1",tostring(pjunValue1)) 
	textCz:setVar("value2",tostring(pjunValue2)) 
	textCz:flushVars()
	
	c1:setSelectedIndex(tbMsg.openType)
	
end 

function tujianPanle:showTaoDec(cfgID)
	local c2 =  self.rootLayout:getController("c2") --控制器
	c2:setSelectedIndex(2)
	local  decTaoPanle =  self.rootLayout:getChild("decTaoPanle") 
	local  title =  decTaoPanle:getChild("title") 
	local  textDec =  decTaoPanle:getChild("textDec") 
	local  textNum =  decTaoPanle:getChild("textNum") 

	local count,maxCount =  g_TujianMsg:mathTaoNum(cfgID)
	local pro = math.floor( count*1000/maxCount)/100
	textNum:setText("收集（"..pro.."%）")

	local listTaoEqu =  self.rootLayout:getChild("listTaoEqu") 
	
	local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D",cfgID)
	title:setText(tbMsg.nameT2)
	local tbMsgSkill =  g_cfgMsg:getCfgMsg("zhuangbeiSkill_D",tbMsg.taoSkill)
	
	textDec:setText(tbMsgSkill.decText1)
	self.tbEquTao = {}
	local tbMsgD =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D")
	for i,v in pairs(tbMsgD)do
		if v.nTaozhuangType == tbMsg.nTaozhuangType and v.openType ~= -1 then
			self.tbEquTao[#self.tbEquTao+1] = i
		end 
	end 
	listTaoEqu:itemRenderer(function(index, obj)
			local indexD = index+1
			local cfgID =	self.tbEquTao[indexD]
			obj:setCustomData(cfgID)
			self:setListItemTaoItem(obj,cfgID)
		end)
	listTaoEqu:setVirtual()--回调
	listTaoEqu:setNumItems(#self.tbEquTao);
	
end 
function tujianPanle:setListItem6(obj,cfgID)
	local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D",cfgID)
	local tbMsgSkill =  g_cfgMsg:getCfgMsg("zhuangbeiSkill_D",tbMsg.taoSkill)
	local  title =  obj:getChild("title") 
	local  textDec =  obj:getChild("textDec") 
	local  textNum =  obj:getChild("textNum") 
	title:setText("【"..tbMsg.nameT2.."】")
	textDec:setText(tbMsgSkill.decText1)
	
	local count,maxCount =  g_TujianMsg:mathTaoNum(cfgID)
	local pro = math.floor( count*1000/maxCount)/100
	textNum:setText("收集（"..pro.."%）")
	
	local function funcEndCallBack(btn,tag) 
		self:showTaoDec(cfgID)
	end 
	g_SetBtnOne(nil, nil,indexD, funcEndCallBack,obj)	
end 

function tujianPanle:initlList6()
	if self.initlist6 then
		return
	end 
	self.list6 = true
	if not self.taoSkillMsg then
		self.taoSkillMsg = {}
		local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbeiTao_D")
		for key,v in pairs(tbMsg)do
			if not self.taoSkillMsg[v.nTaozhuangType] and  v.openType ~= -1 and key ~= 0 then
				self.taoSkillMsg[v.nTaozhuangType] = key
			end 
		end 
		local function comps(a,b)
			return a < b
		end
		table.sort(self.taoSkillMsg, comps)
	end 

	local  list6 =  self.rootLayout:getChild("list6") 
	list6:itemRenderer(function(index, obj)
			local indexD = index + 1
			local cfgID = self.taoSkillMsg[indexD]
			obj:setCustomData(cfgID)
			self:setListItem6(obj,cfgID)
		end)
	list6:setVirtual()--回调
	list6:setNumItems(#self.taoSkillMsg);
	
	self:textPro(#self.taoSkillMsg)
end 
---=====================================================================

function tujianPanle:setListItem5(obj,cfgID)
	
	local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbei_D",cfgID)
	
	
	local  textCz =  obj:getChild("textCz") 
	local  title =  obj:getChild("title") 
	local  textAtt =  obj:getChild("textAtt") 
	
	title:setText(tbMsg.name)
	local pjunValue1 = math.floor((tbMsg.addRationMin1 +  tbMsg.addRationMax1)*10/2)/10
	local pjunValue2 = math.floor((tbMsg.addRationMin2 +  tbMsg.addRationMax2)*10/2)/10
	--text的模板 
	textCz:setVar("value1",tostring(pjunValue1)) 
	textCz:setVar("value2",tostring(pjunValue2)) 
	textCz:flushVars()

	textAtt:setText(tbMsg.attIDName1.."|"..tbMsg.attIDName2)
	
	local c1 =  obj:getController("c1") --控制器
	local info = g_TujianMsg:getTbTujianMsg(cfgID) or {}

	if not info.yanse or info.yanse <= 0 then
		c1:setSelectedIndex(0)
	else
		c1:setSelectedIndex(1)
		local colorID = G_tb_TextColor[info.yanse]
		cc.g_setTextColor(title,colorID,true)
	end 

end 

function tujianPanle:initlList5()
	
	self.initlist5 = true
	local c3 =  self.rootLayout:getController("c3") --控制器
	local index =  c3:getSelectedIndex()
	local tbMsg =  g_cfgMsg:getCfgMsg("zhuangbei_D")
	self.EquTbMsg = {}
	--cclog(index,"=====index===========",self.curZbType)
	if index ~= self.curZbType then 
		for key,v in pairs(tbMsg)do
			--cclog(v.nType, index,"===v.nType == index======",v.openType)
			if v.nType == (index+1) and  v.openType ~= -1 then
				self.EquTbMsg[#self.EquTbMsg+1] =  key
			end 
		end 
		local function comps(a,b)
			return a < b
		end
		table.sort(self.EquTbMsg, comps)
		self.curZbType = index
	else
		return
	end 
	
	local  list5 =  self.rootLayout:getChild("list5") 
	--cclog("=======self.EquTbMsg========",self.EquTbMsg)
	list5:itemRenderer(function(index, obj)
			local indexD = index +1
			local cfgID = self.EquTbMsg[indexD]
		
			obj:setCustomData(cfgID)
			self:setListItem5(obj,cfgID)
		end)
	list5:setVirtual()--回调
	list5:setNumItems(#self.EquTbMsg);
	self:textPro(#self.EquTbMsg*7)
end 


---=====================================================================

function tujianPanle:setListItem4(obj,indexD)
	local cfgID = 87000000 + indexD *100 + 1
	local info = g_TujianMsg:getTbTujianMsg(cfgID) or {}
	--cclog("===setListItem4======",cfgID)
	local tbMsg =  g_cfgMsg:getCfgMsg("petSkill_D",cfgID)
	
	local  textDec =  obj:getChild("textDec") 
	local  title =  obj:getChild("title") 
	local tb_Str = {"x","y","z"}
	local lev = g_bagMsg:getpetSkillTbMsgLev(cfgID) or 1
	local yanse = info.yanse	 or 1
	local cfgID1 = 87000000 + indexD *100 + yanse
	
	local tb_number = g_mathConTrol:mathPetSkillValue(lev,cfgID1)
	local dec = cc.g_inalienContentByTbNumber(tbMsg.dec,tb_Str,tb_number)  
	title:setText(tbMsg.name.."：")
	textDec:setText(dec)
	local colorID = G_tb_TextColor[info.yanse]
	cc.g_setTextColor(title,colorID,true)
	cc.g_setTextColor(textDec,colorID,true)

	for i=1,7 do
		local  textYanse =  obj:getChild("textYanse"..i) 
		local cfgID1 = 87000000 + indexD *100 + i
		local tb_number = g_mathConTrol:mathPetSkillValue(lev+1,cfgID1)
		local str = ""
		for i,v in ipairs(tb_number)do
			if v ~= 0 then
				if i == 1  then
					str = v
				else
					str = str.."|"..v	
				end 
			end 
		end 
		textYanse:setVar("value",str) 
		textYanse:flushVars()
	end 
	local c1 =  obj:getController("c1") --控制器
	
	if not info.yanse or info.yanse <= 0 then
		c1:setSelectedIndex(0)
	else
		c1:setSelectedIndex(1)
		cc.g_setTextColor(title,G_tb_TextColor[yanse],true)
	
	end 
	local lev = info.lev or 1

	local nExp = info.nExp or 0
	
	
	local  levText =  obj:getChild("levText") 
	levText:setText("Lv."..lev)
	local  barExp =  obj:getChild("barExp") 
	local needValue = g_mathConTrol:mathPetSkillNeedSLD(lev)
	---cclog(nExp,lev,"======setMax========")
	barExp:setMax(needValue)
	barExp:setValue(nExp)
end 

function tujianPanle:initlList4()
	if self.initlist4 then
		return
	end 
	self.initlist4 = true
	local  list4 =  self.rootLayout:getChild("list4") 

	list4:itemRenderer(function(index, obj)
			local indexD = index + 1
			obj:setCustomData(indexD)
			self:setListItem4(obj,indexD)
		end)
	list4:setVirtual()--回调
	list4:setNumItems(tbGameConst.petSkillType);
	self:textPro(tbGameConst.petSkillType*7)
end 


---=====================================================================

function tujianPanle:showPetDec(cfgID)
	local obj = self.rootLayout
	local  textZZ =  obj:getChild("textZZ") 
	local  iconBg =  obj:getChild("iconBg") 
	local  title =  obj:getChild("title") 
	local  icon =  obj:getChild("icon") 
	
	local tbMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID)
	title:setText(tbMsg.name)
	icon:setIcon(g_iconConTrol:getPetYanseIcon(1))
	iconBg:setIcon(g_iconConTrol:getPetYanseBgIcon(1))
	local zz = math.floor(tbMsg.nSortmin +tbMsg.nSortmax )/2
	textZZ:setText("资质："..zz)
	local  textTsValue =  obj:getChild("textTsValue") 
	local  n409 =  obj:getChild("n409")
	
	local  textZz =  obj:getChild("textZz") 
	textZz:setText("【"..G_tb_ZZType[tbMsg.zhongzhu].."】")
	
	local  textskill =  obj:getChild("textskill") 
	local skillcfgID = tbMsg.skill1
	
	local cfgMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillcfgID) 
	
	textskill:setText("【"..cfgMsg.name.."】")
	local colorID = G_tb_TextColor[cfgMsg.lev]
	cc.g_setTextColor(textskill,colorID,true)	
	
	local petDrop =  self.rootLayout:getController("petDrop") --控制器
	if tbMsg.openType == 0  then
		textTsValue:setText("统帅值达到"..tbMsg.open)
		textTsValue:setVisible(true)
		n409:setVisible(true)
		petDrop:setSelectedIndex(0)
	else
		textTsValue:setVisible(false)
		n409:setVisible(false)
		if tbMsg.openType == -1 then
			petDrop:setSelectedIndex(4)
		else
			petDrop:setSelectedIndex(tbMsg.openType)
		end 
	end 
	
	for i=1,5 do
		local  attText1 =  obj:getChild("attText"..i) 
		local baseValue = tbMsg["baseValue"..i]
		attText1:setVar("value",tostring(baseValue)) 
		attText1:flushVars()
		if i <= 3  then
			local  attTextC =  obj:getChild("attTextC"..i) 
			local addAttCe1 = tbMsg["addAttCe"..i]
			attTextC:setVar("value",tostring(addAttCe1)) 
			attTextC:flushVars()
		end 
	end 
	local  attTextC4 =  obj:getChild("attTextC4") 
	local addAttCe1 = tbMsg["TextAttCe4"]
	attTextC4:setVar("value",tostring(addAttCe1)) 
	attTextC4:flushVars()
end 

function tujianPanle:setListItem3(obj,indexD)
	local cfgID = 86000000 + indexD
	local tbMsg =  g_cfgMsg:getCfgMsg("pet_D",cfgID)
	
	local  textZZ =  obj:getChild("textZZ") 
	local  iconBg =  obj:getChild("iconBg") 
	local  title =  obj:getChild("title") 
	local  icon =  obj:getChild("icon") 
	local  textname =  obj:getChild("textname") 
	
	title:setText(tbMsg.name)
	icon:setIcon(g_iconConTrol:getPetYanseIcon(1))
	iconBg:setIcon(g_iconConTrol:getPetYanseBgIcon(1))
	local zz = math.floor(tbMsg.nSortmin +tbMsg.nSortmax )/2
	textZZ:setText("资质："..zz)
	textname:setText(tbMsg.name)
	
	local function funcEndCallBack(btn,tag) 
		local c2 =  self.rootLayout:getController("c2") --控制器
		c2:setSelectedIndex(1)
		self:showPetDec(cfgID)
	end 
	g_SetBtnOne(nil, nil,indexD, funcEndCallBack,obj)	
	
	local c1 =  obj:getController("c1") --控制器
	local info = g_TujianMsg:getTbTujianMsg(cfgID) or {}
	if not info.yanse or info.yanse <= 0 then
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
end 

function tujianPanle:initlList3()
	if self.initlist3 then
		return
	end 
	self.initlist3 = true
	local  list3 =  self.rootLayout:getChild("list3") 

	list3:itemRenderer(function(index, obj)
			local indexD = index + 1
			obj:setCustomData(indexD)
			self:setListItem3(obj,indexD)
		end)
	list3:setVirtual()--回调
	list3:setNumItems(149);
	
	self:textPro(149*7)
end 


---=====================================================================

function tujianPanle:setListRoleSkillItem(obj,indexD)
	local cfgID 
	if indexD <= 8 then
		cfgID = 95000000+indexD
	elseif indexD <= 36 then
		cfgID = 95000100+indexD-8
	else
		cfgID = 95001000+indexD-36
	end 
	cclog(cfgID,"=======setListRoleSkillItem=============",indexD)
	local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",cfgID)
	local  textName =  obj:getChild("textName") 
	local  textDec =  obj:getChild("textDec") 
	local  testRole =  obj:getChild("testRole") 
	textName:setText(tbMsg.name..":")
	textDec:setText(tbMsg.dec)
	testRole:setText(tbMsg.hero)
	
	local c1 =  obj:getController("c1") --控制器
	local info = g_TujianMsg:getTbTujianMsg(cfgID) or {}
	if info.yanse and info.yanse > 1 then
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
end 

function tujianPanle:initlList2()
	cclog("=======initlList2=====",self.initlist2)
	if self.initlist2 then
		return
	end 
	self.initlist2 = true
	local  list2 =  self.rootLayout:getChild("list2") 

	list2:itemRenderer(function(index, obj)
			local indexD = index + 1
			obj:setCustomData(indexD)
			self:setListRoleSkillItem(obj,indexD)
		end)
	list2:setVirtual()--回调
	list2:setNumItems(41);
	self:textPro(41)
end 


---=====================================================================

function tujianPanle:setListRoleItem(obj,cfgID)
	
	local tbMsg =  g_cfgMsg:getCfgMsg("role_D",cfgID)
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	local info = g_TujianMsg:getTbTujianMsg(cfgID) or {}
	
	cclog(cfgID,"===tujianPanle===",tbMsg)
	
	local  textOpen =  obj:getChild("textOpen") 
	local  textOpenIcon =  obj:getChild("textOpenIcon") 
	local c1 =  obj:getController("c1") --控制器
	if  tbMsg.openType == 0  then
		if  zslevel < tbMsg.openTypeValue  then
			textOpen:setText(tbMsg.openTypeValue.."转后激活")
			c1:setSelectedIndex(0)
		else
			if info.yanse and info.yanse > 1 then
				c1:setSelectedIndex(2)
			else
				c1:setSelectedIndex(1)
			end 
		end 
	elseif info.yanse and info.yanse > 1 then
		c1:setSelectedIndex(2)
	elseif  tbMsg.openType == -1  then
		c1:setSelectedIndex(3)
	else
		c1:setSelectedIndex(1)
	end 

	local  bossIcon =  obj:getChild("bossIcon") 
	local  textZZ =  obj:getChild("textZZ") 
	local  TextType =  obj:getChild("TextType") 
	local  textName =  obj:getChild("textName") 
	local  textZZBY =  obj:getChild("textZZBY") 
	textName:setText("【"..tbMsg.name.."】")
	bossIcon:setIcon(g_iconConTrol:getBossIcon(tbMsg.icon))
	textZZBY:setText("(变异资质)"..tbMsg.nSortMax) 
	textZZ:setText("基础资质："..tbMsg.nSort) 
	---TextType:setText(tbMsg.nType)
	
	for i=1,6 do
		local  textAtt =  obj:getChild("textAtt"..i) 
		local value = tbMsg["mainAtt"..i]
		textAtt:setText(G_tb_HeroAtt[i]..":"..value)
	end 
	local c2 =  obj:getController("c2") --控制器
	---cclog("===tbMsg.nTypeIndex====",tbMsg.nTypeIndex)
	c2:setSelectedIndex(tbMsg.nTypeIndex-1)
	local str = ""
	for i=1,tbGameConst.SkillMaxNum do
		local skillID = tbMsg["skill"..i] 
		local tbMsg =  g_cfgMsg:getCfgMsg("roleSkill_D",skillID)
		local name = "["..tbMsg.name.."]"
		str = str..name.."  "
	end 
	local  textSkill =  obj:getChild("textSkill") 
	textSkill:setText(str)
	
	
end 

function tujianPanle:textPro(maxNum)
	local  textPro =  self.rootLayout:getChild("textPro") 
	local c1 =  self.rootLayout:getController("c1") --控制器
	local index = c1:getSelectedIndex()
	local pro = 0
	if index == 0 then
		pro = g_TujianMsg:mathRoleTjPro(maxNum)
	elseif index == 1 then 
		pro = g_TujianMsg:mathRoleSkillTjPro(maxNum)
	elseif index == 2 then 
		pro = g_TujianMsg:mathPetTjPro(maxNum)
	elseif index == 3 then 
		pro = g_TujianMsg:mathPetSkillPro(maxNum)
	elseif index == 4 then 
		pro = g_TujianMsg:mathEquPro(maxNum)
	elseif index == 5 then 
		pro = g_TujianMsg:mathEquTaoPro(maxNum)	

	end 
	textPro:setText("收集:("..pro.."%)")
end 


function tujianPanle:initlList1()
	local  list1 =  self.rootLayout:getChild("list1") 

	if not self.RoleMsg then
		self.RoleMsg = {}
		local tbMsg =  g_cfgMsg:getCfgMsg("role_D")
		for key,v in pairs(tbMsg)do
			if v.openType ~= -1   then
				self.RoleMsg[#self.RoleMsg + 1] = key
			end 
		end 
		local function comps(a,b)
			return a < b
		end
		table.sort(self.RoleMsg, comps)
	end 
 
	list1:itemRenderer(function(index, obj)
		local indexD = index + 1
		local cfgID = self.RoleMsg[indexD]
	
		obj:setCustomData(cfgID)
		self:setListRoleItem(obj,cfgID)
	end)
	list1:setVirtual()--回调
	list1:setNumItems(#self.RoleMsg);
	self:textPro(#self.RoleMsg)
end 



function tujianPanle:openWnd()
	--if not g_TujianMsg.init  then
		
		--g_TujianMsg.init = true
	--end 
	
	g_TujianMsg:mathAllpro()
	self:initlList1()
end 

	
return tujianPanle
