
local ComponentCJpanle = class("ComponentCJpanle")

function ComponentCJpanle:initWnd()

	local function funcEndCallBack(btn,tag) 
		if tag == 1 then
			g_svSendMsgControl:request_getChengjiuMsg(1)
		elseif tag == 2 then

		end 
	end 

	g_SetBtnOne(self.rootLayout, "btnMain3",1, funcEndCallBack)	
	--g_SetBtnOne(self.rootLayout, "btn3",3, funcEndCallBack)	

end 


function ComponentCJpanle:setListItem(obj,cfgID)
	local info = g_dalitInfoMsg:getchengjiuTbMsg(cfgID)
	local cfgMsg =  g_cfgMsg:getCfgMsg("achievement_D",info.cfgID) 
	local dec = cfgMsg.des
	
	local status 
	local c1 =  obj:getController("c1") --控制器
	local count = info.count or 0
	
	if cfgMsg.type == 1 then
		local level = g_roleMsg:getRoleAttValue(RoleAttMsg.level,true)
		count = level
	end 
	
	if count >= info.maxCount then
		c1:setSelectedIndex(1)
		
	else
		c1:setSelectedIndex(0)
		status = 0
	end 
	
	dec = dec.."(当前："..count..")"
	obj:setText(dec)

	return status

end

function ComponentCJpanle:setList()
	local  cjList =  self.rootLayout:getChild("cjList")  
	
	local tbMsg = g_dalitInfoMsg:getchengjiuTbMsg()
	self.cjMsg  = {}
	
	for i,info in pairs(tbMsg)do
		self.cjMsg[#self.cjMsg+1] = info
	end 
	
	local function comps(a,b)
		return a.cfgID > b.cfgID
	end
	table.sort(self.cjMsg,comps)
	local status 
	cjList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local cfgID = self.cjMsg[indexD].cfgID
			obj:setCustomData(cfgID)
			local resurl = self:setListItem(obj,cfgID)
			
			if resurl == 0 then
				status = resurl
			end 
			cclog(resurl,status,"====setListItem===")
		end)
	cjList:setVirtual()--回调
	cjList:setNumItems(#self.cjMsg);
	
	
	cclog(resurl,status,"===22=setListItem===")
	self:isReward(status)
end 

function ComponentCJpanle:isRewardPanle()
	local chengjiuLev = g_baseMsg:getOther(otherDBMsgID.chengjiuLev) or  1
	local cfgMsg =  g_cfgMsg:getCfgMsg("achievementReward_D",chengjiuLev) 
	
	for i=1,4 do
		local v = cfgMsg[i]
		local  textReward =  self.rootLayout:getChild("textReward"..i)  
		local  cfgID = v.dropID
		local ntype =  g_getTypeByCfgID(cfgID)
		if  g_cfgType.equ == ntype or g_cfgType.equT == ntype  then
			textReward:setText(i..".【"..v.des.."】")
		else
			textReward:setText(i..".【"..v.des.."】x"..v.value2)	
		end 
		
		if v.yanse > 0 then
			--local colorID = G_tb_TextColor[v.yanse]
			--cc.g_setTextColor(textReward,25,true)
		else
			--local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)
			--local colorID = G_tb_TextColor[yanse]
			--cc.g_setTextColor(textReward,25,true)
		end 
	end 
end 

function ComponentCJpanle:isReward(statsu)
	local tbMsg = g_dalitInfoMsg:getchengjiuTbMsg()
	
	local c1 =  self.rootLayout:getController("c1") --控制器
	if statsu then
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
end

function ComponentCJpanle:setTitle()
	local chengjiuLev = g_baseMsg:getOther(otherDBMsgID.chengjiuLev) or  1
	local  n202 =  self.rootLayout:getChild("n202")  
	n202:setText("成就第"..chengjiuLev.."章节：")
end 


function ComponentCJpanle:closeWnd()

end 

function ComponentCJpanle:openWnd()
	self:initWnd()
	self:setList()
	self:isRewardPanle()
	self:setTitle()
end 

	
return ComponentCJpanle
