
local ComponentLilian = class("ComponentLilian")

function ComponentLilian:initWnd()

	local function funcEndCallBack(btn,tag) 
		cclog("======initWnd======",tag)
		if tag == 1 then
			
		elseif tag == 2 then

		end 
	end 

	--g_SetBtnOne(self.rootLayout, "btn1",1, funcEndCallBack)	
	--g_SetBtnOne(self.rootLayout, "btn3",3, funcEndCallBack)	

end 


function ComponentLilian:reloadListItem(indexD)
	local  lilianList =  self.rootLayout:getChild("lilianList")  
	local obj = getChildById(lilianList, indexD)
	if  obj then
		self:setListItem(obj,indexD)	
	end 
end 

function ComponentLilian:setListItem(obj,indexD)	
	
	local info =  g_dalitInfoMsg:getdalitInfoTbMsg(indexD)
	local cfgID = info.cfgID
	local cfgMsg =  g_cfgMsg:getCfgMsg("lilian_D",cfgID) 
	local maxValue = info.maxCount
	local count = info.count
	
	if cfgID == 10 or cfgID == 15  or cfgID == 16   then
		maxValue = 1
		
	end 
	
	local str = "("..count.."/"..maxValue..")"
	if cfgID == 10 or cfgID == 15  or cfgID == 16    then
		str = str..G_tb_HeroColor[info.maxCount]
	elseif cfgID == 9 then 
		str = maxValue
	end 
	
	local tb_Str = {"x"}
	local tb_number = {str}
	local dec = cc.g_inalienContentByTbNumber(cfgMsg.value1,tb_Str,tb_number)  
			
	obj:setText(indexD.."."..dec)
	local c1 =  obj:getController("c1") --控制器
	--cclog(info.status,"=====info.status=======")
	if  info.status == 1 then
		c1:setSelectedIndex(2)
	else
		if count >= maxValue then
			c1:setSelectedIndex(0)
			local function funcEndCallBack(btn,tag) 		
				g_svSendMsgControl:request_geDaliyMsg(1,indexD)
				g_taskConTrol:addTaskFinishNum(g_TaskStatisticsType.Daily_lilianAdsNum,-1)
			end 
			g_SetBtnOne(obj, "btnMain3",3, funcEndCallBack)	
		else
			c1:setSelectedIndex(1)	
		end 
	end 
	
	local  textReWard =  obj:getChild("textReWard")  
	
	local cfgMsg =  g_cfgMsg:getCfgMsg("lilianReward_D",info.reward) 
	----cclog(cfgMsg.value3,"=====info.reward=====",info.reward)
	local name,yanse,tbEquMsg = g_getNameConTrol:getAllMsg(cfgMsg.value3)
	
	textReWard:setText(name.."x"..cfgMsg.value4)
	
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(textReWard,colorID,true)
	
	local function callBack()
		g_svSendMsgControl:request_geDaliyMsg(10,indexD)
		g_taskConTrol:addTaskFinishNum(g_TaskStatisticsType.Daily_lilianAdsNum,1)
	end 
	local function callBack1()
		setADSFunc(g_tbAdsReward.lilianDel,callBack)
		g_API_playAds(g_tbAdsReward.lilianDel)
	end 
	
	local function callBack2()
		setADSFunc(g_tbAdsReward.lilianAdsDel,callBack)
		g_API_playAds(g_tbAdsReward.lilianAdsDel,value,true)
	end 
	
	local iLoginClickTime = nil
	local function funcEndCallBack(btn,tag) 		
		if CheckLoginClick() then
			return
		end
		local Daily_lilianAdsNum =  g_taskConTrol:getTaskFinishNum(g_TaskStatisticsType.Daily_lilianAdsNum) or 0
		local number = g_taskConTrol:getAchivementFinishNum(g_TaskStatisticsType.Achivement_AdsBuy,3) or 0
		--cclog(Daily_lilianAdsNum,"=======Daily_lilianAdsNum======",number  )
		if Daily_lilianAdsNum >= 50 and number  > 0  then
			local Daily_lilianAdsNum =  g_taskConTrol:getTaskFinishNum(g_TaskStatisticsType.Daily_lilianAdsNum) or 0
			local tbQDMsg = {}
			tbQDMsg.dec =  "每天更换任务上限50次，需要播放一次广告后可50次清0。是否清0，本次广告不可跳过"
			tbQDMsg.text1 = "确定"
			tbQDMsg.text2 = "取消"
			tbQDMsg.qdFunc =  callBack2
			g_quedingItem:openWnd(tbQDMsg) 
			return
		end 
		callBack1()
	end 
	g_SetBtnOne(obj, "btnDel",1, funcEndCallBack)	
end

function ComponentLilian:setList()
	local  lilianList =  self.rootLayout:getChild("lilianList")  
	local  dalitInfoTbMsg = g_dalitInfoMsg:getdalitInfoTbMsg()
	
	self.dalitTbMsg = {}
	
	for id,v in pairs(dalitInfoTbMsg)do
		self.dalitTbMsg[#self.dalitTbMsg + 1 ] = id
	end 
	
	local function comps(a,b)
		local infoA = g_dalitInfoMsg:getdalitInfoTbMsg(a)
		local infoB = g_dalitInfoMsg:getdalitInfoTbMsg(b)
		local status1 = infoA.status or 0
		local status2 = infoB.status or 0
		if   status1 == status2 then
			if  infoA.cfgID ==  infoB.cfgID then
				return infoA.id <  infoB.id
			else
			
				return infoA.cfgID <  infoB.cfgID
			end 
		else
			return status2  < status2
			 
		end 	
	end 
	
	table.sort(self.dalitTbMsg,comps)
	
	
	lilianList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local id = self.dalitTbMsg[indexD]
			obj:setCustomData(id)
			self:setListItem(obj,id)	
		end)
	
	lilianList:setVirtual()--回调
	lilianList:setNumItems(#self.dalitTbMsg);

end 


function ComponentLilian:setPanleDec()	
	local  lilianLev =  self.rootLayout:getChild("lilianLev")  
	local  ReAttNext =  self.rootLayout:getChild("ReAttNext")  
	local  barExp =  self.rootLayout:getChild("barExp")  
	
	local lev ,expOne,lastExp,tbAtt = g_dalitInfoMsg:mathDalitLev()   
	local maxLev  = g_dalitInfoMsg:mathDalitMaxLev() 
	if lev >  maxLev then
		lev = maxLev
	end 
	lilianLev:setText("每日任务："..lev.."/"..maxLev.."级")
	cclog("====setPanleDec=======",lev ,expOne,lastExp,tbAtt)
	barExp:setMax(expOne)
	barExp:setValue(lastExp)
	local cfgMsg =  g_cfgMsg:getCfgMsg("lilianLev_D") 
	if  lev >= #cfgMsg then
		ReAttNext:setText("已满级")
	else
		local cfgMsg =  g_cfgMsg:getCfgMsg("lilianLev_D",lev+1) 
		local nextAttID = cfgMsg.name
		local nextAttIDValue = cfgMsg.value
		ReAttNext:setText("下一级奖励："..nextAttID.."+"..nextAttIDValue)
	end 
	
	
	self:setPanleDec2(tbAtt)
end 

function ComponentLilian:setPanleDec2(tbAtt)
	for i=1,6 do
		local  ReAtt1 =  self.rootLayout:getChild("ReAtt"..i) 
		local value = tbAtt[i] or 0
		--local addVip = g_viplevMsg:getVipValue(13)
		---value = math.floor(value + addVip)
		local cfgMsg =  g_cfgMsg:getCfgMsg("att_D",i) 
		ReAtt1:setText(cfgMsg.name..":"..value)
	end 
end 

function ComponentLilian:openWnd()

	self:initWnd()
	self:setPanleDec()	
	self:setList()
	g_gNodeConTrol:setMaoPaoMsg(G_MaoPaoMsgType.loginReward,0)
end 

	
return ComponentLilian
