
local ComponentShop = class("ComponentShop")

function ComponentShop:getMaxNum()	
	local addVip =   g_viplevMsg:getVipValue(5)
	local num = tbGameConst.reloadShopNum + addVip
	return num
end 

function ComponentShop:initWnd()

	local function funcEndCallBack(btn,tag) 
		cclog("======initWnd======",tag)
		if tag == 1 then
			--判断次数
			local  num =  g_taskConTrol:getTaskFinishNum(g_TaskStatisticsType.Daily_reloadShopNum) or 0
			local maxNum = self:getMaxNum()
			if  num >= maxNum then
				g_action:ts_hszz_antion("今日刷新次数已满"..maxNum.."次")
				return
			end 
			--判断钻石
			local status = g_baseConTrol:resEnough(g_resCfgId.diamond,tbGameConst.reloadShop)
			if not status  then
				return 
			end 
			g_svSendMsgControl:request_getShopMsg(2)
		elseif tag == 2 then
		
			self:buyListItemEff(self.touchIndex)
			local shopInfo = g_ShopMsg:getShopTbMsg(self.touchIndex)
			if shopInfo.sellStatus == 1 then
				g_action:ts_hszz_antion("已购买")
				return
			end 
			local cfgMsg =  g_cfgMsg:getCfgMsg("shop_D",shopInfo.cfgID) 
			if cfgMsg.value2 == 1 or shopInfo.CostType == 2 then
				setADSFunc(g_tbAdsReward.shopFree,handler(self, self.reloadIndexItem))
				g_API_playAds(g_tbAdsReward.shopFree,self.touchIndex)
				----g_svSendMsgControl:request_getShopMsg(1,self.touchIndex)
			else
				g_svSendMsgControl:request_getShopMsg(1,self.touchIndex)
			end 
			
		end 
	end 

	g_SetBtnOne(self.rootLayout, "btnMain3",1, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnBuy",2, funcEndCallBack)

end 

function ComponentShop:buyListItemEff(index)
	local  shopList =  self.rootLayout:getChild("shopList")  
	local objD = getChildById(shopList, index)
	if objD then
		local parent = objD:displayObject()
		local pos = cc.p(60,70)
		local ArmatureEndA = g_gArmature:showArmatureByNums("texiao28","texiao28",parent,nil,nil,pos)
		ArmatureEndA:setScale(2)
	end 
end



function ComponentShop:showDecPanle()
	local  textName =  self.rootLayout:getChild("textName")  
	local  textDec =  self.rootLayout:getChild("textDec")  	
	local shopInfo = g_ShopMsg:getShopTbMsg(self.touchIndex)
	
	local cfgMsg =  g_cfgMsg:getCfgMsg("shop_D",shopInfo.cfgID) 
	local  goodsID = cfgMsg.value4
	
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(goodsID)

	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(textName,colorID,true)
	
	textName:setText(name.."x"..cfgMsg.value6)

	textDec:setText(tbMsg.dec)
	cc.g_setTextColor(textDec,colorID,true)
	
	local  textRes2 =  self.rootLayout:getChild("textRes2")  	
	local c2 =  self.rootLayout:getController("c2") --控制器
	c2:setSelectedIndex(shopInfo.CostType)
	
	if shopInfo.CostType == 2 then
		textRes2:setText("免费")
	elseif shopInfo.CostType == 1 then
		local res = g_mathConTrol:mathShopCoin(cfgMsg.value10) --
		local resStr = getBigIntByStr2(res)
		textRes2:setText(resStr)
		cclog(shopInfo,"==222=setText====",cfgMsg,res)
	elseif shopInfo.CostType == 0 then
		local resStr = getBigIntByStr2(cfgMsg.value11)
		textRes2:setText(resStr)
		cclog(shopInfo,"=DDD=setText====",cfgMsg,res)
	end 
	local c1 =  self.rootLayout:getController("c1") --控制器		
	c1:setSelectedIndex(shopInfo.sellStatus)
	
end 

function ComponentShop:setTouchItem(obj,indexD)	
	if self.touchIndex then
		local  shopList =  self.rootLayout:getChild("shopList")  
		local objD = getChildById(shopList, self.touchIndex)
		if objD then
			local c1 =  objD:getController("c1") --控制器
			c1:setSelectedIndex(0)
		end 
	end 
	
	self.touchIndex = indexD
	if not obj then
		local  shopList =  self.rootLayout:getChild("shopList")  
		obj = getChildById(shopList, indexD)
	end 
	if obj then
		local c1 =  obj:getController("c1") --控制器
		c1:setSelectedIndex(1)
		self:showDecPanle()	
	end 
end


function ComponentShop:setListItem(obj,indexD)	
	local shopInfo = g_ShopMsg:getShopTbMsg(indexD)
	if not obj then
		local  shopList =  self.rootLayout:getChild("shopList")  
		obj = getChildById(shopList, indexD)
	end 
	local  title =  obj:getChild("title")  
	local  textRes =  obj:getChild("textRes")  
	
	local cfgID = shopInfo.cfgID
	local cfgMsg =  g_cfgMsg:getCfgMsg("shop_D",cfgID) 
	local  goodsID = cfgMsg.value4
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(goodsID)
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(title,colorID,true)
	title:setText(name.."x"..cfgMsg.value6) 
	
	local c2 =  obj:getController("c2") --控制器
	c2:setSelectedIndex(shopInfo.CostType)
	
	
	if shopInfo.CostType == 2 then
		textRes:setText("免费")
	elseif shopInfo.CostType == 1 then
		local res = g_mathConTrol:mathShopCoin(cfgMsg.value10) --
		local resStr = getBigIntByStr2(res)
		cclog(resStr,"==111setText====",res,cfgMsg.value10)
		textRes:setText(resStr)
	elseif shopInfo.CostType == 0 then
		local resStr = getBigIntByStr2(cfgMsg.value11)
		cclog(resStr,"==00=setText====",cfgMsg.value11)
		textRes:setText(resStr)
	end 
	cclog(shopInfo,"===1==setText====",cfgMsg)
	
	local function funcEndCallBack(btn,tag)
		self:setTouchItem(obj,indexD)	
	end 
	g_SetBtnOne(nil,nil,1, funcEndCallBack,obj)	
	
	local c1 =  obj:getController("c1") --控制器
	if indexD == self.touchIndex  then
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
			
	local c3 =  obj:getController("c3") --控制器		
	c3:setSelectedIndex(shopInfo.sellStatus)
end 

function ComponentShop:reloadIndexItem()
	self:showDecPanle()
	self:setListItem(nil,self.touchIndex)	
end 

function ComponentShop:setList()

	local tbShopInfo = g_ShopMsg:getShopTbMsg()
	
	local  shopList =  self.rootLayout:getChild("shopList")  
	shopList:itemRenderer(function(index, obj)
			local indexD = index + 1
			obj:setCustomData(indexD)
			self:setListItem(obj,indexD)	
		end)
	shopList:setVirtual()--回调
	shopList:setNumItems(#tbShopInfo);

end 


function ComponentShop:openWnd()
	local info = g_ShopMsg:getShopTbMsg(1)
	
	if not info then
		self.rootLayout:setVisible(false)
		g_svSendMsgControl:request_getShopMsg(0)
		return
	end 
	self:initWnd()
	self:setTouchItem(nil,1)	
	self.rootLayout:setVisible(true)
	self:setList()
end 

	
return ComponentShop
