
local ComponentTL = class("ComponentTL")

function ComponentTL:initWnd()
	local info = g_petMsg:getpetTbMsg(self.petID)
	local  petName =  self.rootLayout:getChild("petName") 
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(info.cfgID)
	petName:setText(name)
	local colorID = G_tb_TextColor[info.yanse]
	cc.g_setTextColor(petName,colorID,true)
end 

function ComponentTL:mathCostLJs(petID)
	if not petID then
		petID = self.petID
	end 	
	local info = g_petMsg:getpetTbMsg(petID)
	local maxLev = 0
	for i=1,6 do
		local skillMsg = info.skillMsg[i] or {}
		local skillID = skillMsg.value1 or 0
		if skillID > 0 then
			local cfgSkillMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillID) 
			if maxLev < cfgSkillMsg.lev then
				maxLev = cfgSkillMsg.lev
			end 			
		end 
	end 
	if maxLev == 0 then
		return 0
	end 
	local cost = tbGameConst.needNumTL + (maxLev-1)*tbGameConst.needNumTLRation
	return cost
end 
function ComponentTL:setTextPanle()
	local info = g_petMsg:getpetTbMsg(self.petID)
	local count = 0
	local onlyOne 
	for i=1,6 do
		local TextSkill =  self.rootLayout:getChild("TextSkill"..i)
		local skillMsg = info.skillMsg[i] or {}
		local skillID = skillMsg.value1 or 0
		local skillIDLev = g_bagMsg:getpetSkillTbMsgLev(skillID)  
		
		if i > info.skillNum then
			TextSkill:setVisible(false)
		elseif skillID <= 0 then
			cc.g_setTextColor(TextSkill,1,true)
			TextSkill:setText("无")
		else
			local cfgSkillMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillID) 
			TextSkill:setVisible(true)
			local colorID = G_tb_TextColor[cfgSkillMsg.lev]
			cc.g_setTextColor(TextSkill,colorID,true)
			TextSkill:setText(cfgSkillMsg.name.." Lv"..skillIDLev)
			
			count = count + 1
			onlyOne = i
		end 
	end
	
	local skillNum =  self.rootLayout:getChild("skillNum")
	skillNum:setVar("value1",tostring(count)) 
	skillNum:setVar("value2",tostring(info.skillNum)) 
	skillNum:flushVars()

	local textRes =  self.rootLayout:getChild("textRes")
	local costCl = self:mathCostLJs()
	local btnSkill =  self.rootLayout:getChild("btnSkill")
	if costCl <= 0 then
		textRes:setVisible(false)
		btnSkill:setVisible(false)
		return
	end 
	
	textRes:setText("炼金石："..costCl)
	local function funcEndCallBack(btn,tag) 
		local numGoods = g_bagMsg:getGoodsTbMsg(12003010)
		if numGoods < costCl then
			g_action:ts_hszz_antion("材料不足")
			return
		end 
		
		--if onlyOne == 1 then
			--g_action:ts_hszz_antion("宠物第一个原生技能无法提炼")
			--return
		--end 
		g_svSendMsgControl:request_getPetMsg(4,self.petID)
	end 

	g_SetBtnOne(self.rootLayout, "btnSkill",1, funcEndCallBack)	
	
	--local btnSkill =  self.rootLayout:getChild("btnSkill")
	--local n141 =  self.rootLayout:getChild("n141")
	--if info.tlValue and info.tlValue == 1 then
		--btnSkill:setVisible(false)
	--else
	--	btnSkill:setVisible(true)
--	end 
end

function ComponentTL:closeWnd()
	local B_Pet = g_WndMgr:getWnd("B_Pet")
	local c2 =  B_Pet.rootLayout:getController("c2") --控制器
	cclog("===closeWnd======ComponentTL=====")
	c2:setSelectedIndex(0)
end 

function ComponentTL:openWnd(petID)
	self.petID = petID
	self:initWnd()
	self:setTextPanle()
end 

	
return ComponentTL
