
local Componentchongzhu = class("Componentchongzhu")

function Componentchongzhu:initWnd()
	local count = 1
	local function funcEndCallBack(btn,tag) 
		if tag == 1 then
			count = count + 1
			
			--判断物品
			local goodsID = 12003008 
			local num =  self:mathNeedNum()
			local  value = g_bagMsg:getGoodsTbMsg(goodsID) or 0
			if value < num then
				g_action:ts_hszz_antion("重铸草不足",22)
				return 
			end 
			g_svSendMsgControl:request_getBaozangMsg(101)
		elseif tag == 2 then
			--判断钻石
			local status = g_baseConTrol:resEnough(g_resCfgId.diamond,tbGameConst.chongzhuZs)
			if not status  then
				return 
			end 
			g_svSendMsgControl:request_getBaozangMsg(102)
		end 
		
	end 
	
	g_SetBtnOne(self.rootLayout, "btncz",1, funcEndCallBack)
	g_SetBtnOne(self.rootLayout, "btnReload",2, funcEndCallBack)
	
	local function funcEndCallBack(btn,tag) 
		g_WndMgr:showWnd("tujianPanle")
	end 
	g_SetBtnOne(self.rootLayout, "btnTj",1, funcEndCallBack)
	
end 

function Componentchongzhu:setListItem(index)
	local iconItem= self.rootLayout:getChild("item"..index)
	local info = g_congzhuInfoMsg:getBzInfoTbMsg(index)
	local cfgID = info.cfgID
	local tbCfgMsg = g_cfgMsg:getCfgMsg("role_D",cfgID)
	
	local roleName= iconItem:getChild("roleName")
	local bossIcon= iconItem:getChild("bossIcon")
	local zzText= iconItem:getChild("zzText")
	roleName:setText("【"..tbCfgMsg.name.."】")
	bossIcon:setIcon(g_iconConTrol:getBossIcon(tbCfgMsg.icon))
	
	local  bianyi = info.bianyi 
	local c2 =  iconItem:getController("c2") --控制器
	if bianyi and  bianyi == 1 then
		zzText:setText("[变异]资质："..tbCfgMsg.nSortMax)
		c2:setSelectedIndex(1)
	else
		zzText:setText("资质："..tbCfgMsg.nSort)
		c2:setSelectedIndex(0)
	end 

end 

function Componentchongzhu:setList()
	for index=1,9 do
		self:setListItem(index)
	end 
end 

function Componentchongzhu:showAnima(index,cfgID)
	if not index then
		local tbInfo = g_congzhuInfoMsg:getBzInfoTbMsg()
		for i,info in pairs(tbInfo)do
			if info.cfgID == cfgID then
				index = i
			end 
		end 
	end 
	if not index then
		return
	end 
	if self.curinde then
		local iconItem= self.rootLayout:getChild("item"..self.curinde)
		local c1 =  iconItem:getController("c1") --控制器
		c1:setSelectedIndex(0)
	end 
	local iconItem= self.rootLayout:getChild("item"..index)
	local pos2 = cc.p(150,150)
	local ArmatureEndA = g_gArmature:showArmature("FuncShowExplode",iconItem,nil,nil,pos2)
	ArmatureEndA:setScale(2)
	local c1 =  iconItem:getController("c1") --控制器
	c1:setSelectedIndex(1)
	g_gameMusic:playEffect(44)
	self.curinde = index
	local tbCfgMsg = g_cfgMsg:getCfgMsg("role_D",cfgID)
	g_action:ts_hszz_antion("获得"..tbCfgMsg.name)
end 


function Componentchongzhu:mathNeedNum()
	local zslevel = g_roleMsg:getRoleAttValue(RoleAttMsg.zhuansheng ,true) or 0
	local cost = tbGameConst.chongzhu +  zslevel*200
	return cost
end 
function Componentchongzhu:openWnd(visible)
	if not g_congzhuInfoMsg.init and not visible then
		g_svSendMsgControl:request_getBaozangMsg(100)
		self.rootLayout:setVisible(false)
		g_congzhuInfoMsg.init = true
		return 	
	end 
	self.rootLayout:setVisible(true)
	self:initWnd()
	self:setList()
	local num =  self:mathNeedNum()
	local  needResText =  self.rootLayout:getChild("needResText") 
	needResText:setText("重铸草："..num)
end 

	
return Componentchongzhu
