
local Componenttoushi = class("Componenttoushi")

function Componenttoushi:initWnd()

	local function funcEndCallBack(btn,tag) 
		cclog("======initWnd======",tag)
		if tag == 1 then
			self:touchShowBag(tag)
			
		elseif tag == 2 then
			self:touchShowBag(tag)
		end 
	end 

	g_SetBtnOne(self.rootLayout, "touch1",1, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "touch2",2, funcEndCallBack)	
	
end 

function Componenttoushi:selectBagClose()
	local c1 = self.rootLayout:getController("c1") --控制器
	local nType = c1:getSelectedIndex()
	local id = g_selectMsg:getSelectID()
	cclog(nType,"=====selectBagClose=======")
	if nType == 0  then
		g_selectMsg:setTbSelecMsg2(GSelectTag.equ,self.curTag,id)
		self:setZbItemOne(self.curTag)
	else
		g_selectMsg:setTbSelecMsg2(GSelectTag.cw,self.curTag,id)
		self:setCwItemOne(self.curTag)
	end 
end 

function Componenttoushi:touchShowBag(tag)
	local c1 = self.rootLayout:getController("c1") --控制器
	local nType = c1:getSelectedIndex()
	self.curTag = tag
	local function callback()
		self:selectBagClose()
	end 
	if nType == 0  then
		g_B_BagSelect:openWnd(0)
		g_B_BagSelect:setSeleFuc(callback)
	else
		g_B_BagSelect:openWnd(101)
		g_B_BagSelect:setSeleFuc(callback)
	end 
end  

function Componenttoushi:setZbItemOne(tag,noset)
	local  zbItem =  self.rootLayout:getChild("zbItem"..tag) 
	local ID = g_selectMsg:getTbSelecMsg2(GSelectTag.equ,tag)
	local c1 = self.rootLayout:getController("c"..(tag+1)) --控制器
	c1:setSelectedIndex(0)
	if not ID then
		zbItem:setVisible(false)
		return
	end 
	g_gNodeConTrol:setListItemEqu(zbItem,ID)
	zbItem:setVisible(true)
	if not noset then
		local index = (tag%2)+1
		local petID2 = g_selectMsg:getTbSelecMsg2(GSelectTag.equ,index)
		if petID2 and petID2 > 0 then
			self:setTextlev()
		end 
	end 
	
	
end 
function Componenttoushi:setCwItemOne(tag,noset)
	local  cwItem =  self.rootLayout:getChild("cwItem"..tag) 
	local petID = g_selectMsg:getTbSelecMsg2(GSelectTag.cw,tag)
	
	local c1 = self.rootLayout:getController("c"..(tag+1)) --控制器
	if not petID then
		c1:setSelectedIndex(0)
		cwItem:setVisible(false)
		return
	end 
	g_gNodeConTrol:setListItemCw(cwItem,petID)
	cwItem:setVisible(true)
	c1:setSelectedIndex(1)
	if not noset then
		local index = (tag%2)+1
		local petID2 = g_selectMsg:getTbSelecMsg2(GSelectTag.cw,index)
		if petID2 and petID2 > 0 then
			self:setTextlev()
		end 
	end 
	
end 

function Componenttoushi:mathEquLevUp()
	
	local zbID1 = g_selectMsg:getTbSelecMsg2(GSelectTag.equ,1)
	local info1 = g_zbMsg:getEuqTbMsg(zbID1)
	
	local zbID2 = g_selectMsg:getTbSelecMsg2(GSelectTag.equ,2)
	local info2 = g_zbMsg:getEuqTbMsg(zbID2)
	local yanse = info2.yanse
	local c4 = self.rootLayout:getController("c4") --控制器
	if  info1.zbLev  >= info2.zbLev then
		 c4:setSelectedIndex(1)
		 return
	else
		 c4:setSelectedIndex(0)
	end 
	local rarion = tbGameConst.jichengRation[yanse]
	local lev = math.ceil(info2.zbLev*rarion)
	return lev,info1.zbLev
end 

function Componenttoushi:mathWcLevUp()
	local petID1 = g_selectMsg:getTbSelecMsg2(GSelectTag.cw,1)
	local info1 = g_petMsg:getpetTbMsg(petID1)
	
	local petID2 = g_selectMsg:getTbSelecMsg2(GSelectTag.cw,2)
	local info2 = g_petMsg:getpetTbMsg(petID2)
	local yanse = info2.yanse
	local c4 = self.rootLayout:getController("c4") --控制器
	if  info1.Level  >= info2.Level then
		 c4:setSelectedIndex(1)
		 return
	else
		 c4:setSelectedIndex(0)
	end 
	local rarion = tbGameConst.jichengRation[yanse]
	local lev = math.ceil(info2.Level*rarion)
	return lev,info1.Level
end 


function Componenttoushi:mathCoseCl(lev,oldLev)
	local offLev = lev - oldLev
	if offLev < 0  then
		return
	end 
	local index = math.ceil( offLev/100)
	if index > 20  then
		index = 20
	end 
	cclog(offLev,"======mathCoseCl=========",lev ,oldLev)
	local costMsg = tbGameConst.jichengCL[index]
	
	return costMsg
end  

function Componenttoushi:setTextlev()
	local c1 = self.rootLayout:getController("c1") --控制器
	local nType = c1:getSelectedIndex()
	--计算升级
	local  textlev =  self.rootLayout:getChild("textlev") 
	local  textRes =  self.rootLayout:getChild("textRes") 
	local  textNum =  self.rootLayout:getChild("textNum") 
	
	local lev,oldLev
	if nType == 0  then
		lev,oldLev = self:mathEquLevUp()
	else
		lev,oldLev = self:mathWcLevUp()
	end
	
	if not lev then
		return
	end 
	textlev:setText("等级："..lev.."级")
	--计算消耗材料
	cclog("=======mathCoseCl=====",lev,oldLev)
	if lev <=  oldLev then
		g_action:ts_hszz_antion("装备顺序错误")
		return
	end 
	local costMsg = self:mathCoseCl(lev,oldLev)
	
	local goodsID = costMsg[1]
	local num = costMsg[2]
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(goodsID)
	textRes:setText(name)
	textNum:setText("x"..num)
	local  colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(textRes,colorID,true)
	
	--判断材料
	local numGoods = g_bagMsg:getGoodsTbMsg(goodsID)
	if numGoods < num then
		cc.g_setTextColor(textNum,21,true)
	else
		cc.g_setTextColor(textNum,2,true)
	end 
	
	local function funcEndCallBack(btn,tag) 
		local numGoods = g_bagMsg:getGoodsTbMsg(goodsID)
		
		if numGoods < num then
			g_action:ts_hszz_antion(name.."不足")
			return
		end 
		local c1 = self.rootLayout:getController("c1") --控制器
		local nType = c1:getSelectedIndex()
		local value1,value2
		if nType == 0  then
			nType = 1000
			value1 = g_selectMsg:getTbSelecMsg2(GSelectTag.equ,1)
			value2 = g_selectMsg:getTbSelecMsg2(GSelectTag.equ,2)
		else
			nType = 1001
			value1 = g_selectMsg:getTbSelecMsg2(GSelectTag.cw,1)
			value2 = g_selectMsg:getTbSelecMsg2(GSelectTag.cw,2)
		end 
		g_svSendMsgControl:request_getBaozangMsg(nType,value1,value2)
	end
	g_SetBtnOne(self.rootLayout, "btnts",3, funcEndCallBack)	
end 

function Componenttoushi:reloadWnd()
	local c1 = self.rootLayout:getController("c1") --控制器
	local nType = c1:getSelectedIndex()
	if nType == 0  then
		self:setZbItem()
	else
		self:setCwItem()
	end 
	self:setTextlev()
end 

function Componenttoushi:showAnima()	
	local c1 = self.rootLayout:getController("c1") --控制器
	local nType = c1:getSelectedIndex()
	if nType == 0 then
		patItem =  self.rootLayout:getChild("zbItem1") 
	else
		patItem =  self.rootLayout:getChild("cwItem1")
	end 
	local Panel_ = patItem:displayObject()
	--cclog("==showAnima=====")
	local pos = cc.p(100,40)
	local ArmatureEndA = g_gArmature:showArmatureByNums("FateSellAnimation",nil,Panel_,nil,nil,pos,1.5,endCallBcak)
	g_gameMusic:playEffect(73)
end 

function Componenttoushi:reloadWnd(nType)
	self:showAnima()
	if nType == 1 then
		self:setZbItemOne(1)
		self:setZbItemOne(2)
	else
		self:setCwItemOne(1,true)
		self:setCwItemOne(2,true)
	end 
	local  textlev =  self.rootLayout:getChild("textlev") 
	textlev:setText("")
	g_action:ts_hszz_antion("传承完毕")
	g_selectMsg:cleanTbMsg()
end 


function Componenttoushi:closeWnd()

end 

function Componenttoushi:openWnd(petID)
	self:initWnd()
	
	g_selectMsg:cleanTbMsg()
	for i=1,2 do
		local  zbItem =  self.rootLayout:getChild("zbItem"..i) 
		local  cwItem =  self.rootLayout:getChild("cwItem"..i) 
		zbItem:setVisible(false)
		cwItem:setVisible(false)
	end 

	
	local  textlev =  self.rootLayout:getChild("textlev") 
	textlev:setText("")
	
end 

	
return Componenttoushi
