
local petSkillPanle = class("petSkillPanle")
	
function petSkillPanle:initWnd()
	local function callBack() 
		g_svSendMsgControl:request_getPetMsg(9,self.petID,self.selfIndex)
		
	end
	local function funcEndCallBack(btn,tag) 
		if tag == 1 then
			local c1 =  self.rootLayout:getController("c1") --控制器
			local index = c1:getSelectedIndex()
			if  index == 0 then
				g_svSendMsgControl:request_getPetMsg(8,self.petID,self.showCfgID)
				
			else
				local tbQDMsg = {}
				tbQDMsg.dec =  "遗忘后技能将会消失，是否需要遗忘"
				tbQDMsg.text1 = "确定"
				tbQDMsg.text2 = "取消"
				tbQDMsg.qdFunc =  callBack
				g_quedingItem:openWnd(tbQDMsg) 
			end 
		elseif  tag == 2 then 
			g_svSendMsgControl:request_getPetMsg(11,self.showCfgID)
			
		end 
	end 
	g_SetBtnOne(self.rootLayout, "btn",1, funcEndCallBack)	
	g_SetBtnOne(self.rootLayout, "btnTs",2, funcEndCallBack)	
	
	local function funcEndCallBack(btn,tag) 
		g_svSendMsgControl:request_getPetMsg(11,self.showCfgID)
	end
	g_SetBtnOne(self.rootLayout, "btnSell",1, funcEndCallBack)	

	self:setPetPanle()
end 
---========================================================

function petSkillPanle:showAnima0()
	local  patItem =  self.rootLayout:getChild("barExp") 
	local Panel_ = patItem:displayObject()
	local pos = cc.p(50,20)
	local ArmatureEndA = g_gArmature:showArmatureByNums("FateSellAnimation",nil,Panel_,nil,nil,pos,1,endCallBcak)
	g_gameMusic:playEffect(73)
end

function petSkillPanle:showAnima1(index)
	local  patItem =  self.rootLayout:getChild("TextSkill"..index) 
	local Panel_ = patItem:displayObject()
	local pos = cc.p(36,20)
	local ArmatureEndA = g_gArmature:showArmatureByNums("FateSellAnimation",nil,Panel_,nil,nil,pos,1,endCallBcak)
	g_gameMusic:playEffect(73)
end 
function petSkillPanle:showAnima2(index)
	local  patItem =  self.rootLayout:getChild("TextSkill"..index) 
	
	local pos = cc.p(36,20)
	local  ArmatureEndA = g_gArmature:showArmature("FuncShowExplode",patItem,nil,nil,pos)
	ArmatureEndA:setScale(0.7)
end 

function petSkillPanle:setSkllBar(cfgID)
	local lev,nExpD = g_bagMsg:getpetSkillTbMsgLev(cfgID)  
	local  barExp =  self.rootLayout:getChild("barExp") 
	local needValue = g_mathConTrol:mathPetSkillNeedSLD(lev)
	--cclog( lev,nExpD,"====setSkllBar=====",cfgID,g_bagMsg:getpetSkillTbMsgLev(cfgID))
	barExp:setMax(needValue)
	barExp:setValue(nExpD)
	
end 

function petSkillPanle:setDecPanle(cfgID,index)
	
	local  skillDecPanle =  self.rootLayout:getChild("skillDecPanle") 
	local c2 =  self.rootLayout:getController("c2") --控制器
	local c4 =  self.rootLayout:getController("c4") --控制器
	
	local textGoodsName = self.rootLayout:getChild("textGoodsName") 
	local textDec = self.rootLayout:getChild("textDec")
	
	if cfgID <= 0 then
		c2:setSelectedIndex(1)
		textDec:setText("无技能")	
		return
	end 
	
	c2:setSelectedIndex(0)
	local name,yanse,tbEquMsg = g_getNameConTrol:getAllMsg(cfgID)
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(textGoodsName,colorID,true)
	local lev = g_bagMsg:getpetSkillTbMsgLev(cfgID)
	textGoodsName:setText(name.."Lv."..lev)
	local textDec = self.rootLayout:getChild("textDec")

	local tb_Str = {"x","y","z"}
	local tb_number = g_mathConTrol:mathPetSkillValue(lev,cfgID)
	local dec = cc.g_inalienContentByTbNumber(tbEquMsg.dec,tb_Str,tb_number)  
	textDec:setText(dec)	

	local c1 =  self.rootLayout:getController("c1") --控制器
	--cclog(index,"=========setSelectedIndex=======")
	if index then
		c1:setSelectedIndex(1)
		self.selfIndex = index
	else
		c1:setSelectedIndex(0)
		self.showCfgID = cfgID
		local textNum = self.rootLayout:getChild("textNum")
		local value = g_bagMsg:getpetSkillTbMsg(cfgID)
		textNum:setText("数量："..value)
	end 
	self:setSkllBar(cfgID)
end 

function petSkillPanle:touchGoodsItem(obj,cfgID)
	local  bagList =  self.rootLayout:getChild("bagList") 
	if self.curTouchGoodsID then
		local panle = getChildById(bagList, self.curTouchGoodsID)
		if panle then
			local c1 =  panle:getController("c1") --控制器
			c1:setSelectedIndex(0)
		end 
	end 
	if not obj then
		obj = getChildById(bagList, cfgID)
	end 
	local c1 =  obj:getController("c1") --控制器
	c1:setSelectedIndex(1)
	self.curTouchGoodsID = cfgID
	self:setDecPanle(cfgID)
	
	local c3 =  self.rootLayout:getController("c3") --控制器
	c3:setSelectedIndex(0)

end 

function petSkillPanle:setListItemPet(obj,cfgID)
	--cclog("========setListItemPet=======",cfgID)
	local  textNum =  obj:getChild("textNum") 
	local value = g_bagMsg:getpetSkillTbMsg(cfgID)
	textNum:setText("数量："..value)

	local  title =  obj:getChild("title") 
	local name,yanse,tbMsg = g_getNameConTrol:getAllMsg(cfgID)
	title:setText(name)
	local colorID = G_tb_TextColor[yanse]
	cc.g_setTextColor(title,colorID,true)
	
	local function funcEndCallBack(btn,tag) 
		self:touchGoodsItem(obj,cfgID)
		self:setDecPanle(cfgID)
	end 
	g_SetBtnOne(nil,nil,cfgID, funcEndCallBack,obj)
	
	local c1 =  obj:getController("c1") --控制器
	if  cfgID ==  self.curTouchGoodsID then	
		c1:setSelectedIndex(1)
	else
		c1:setSelectedIndex(0)
	end 
end

function petSkillPanle:sortListTb2()
	local function comps(a,b)
		return a > b 
	end 
	table.sort(self.BgTbMsg, comps)
end 	
function petSkillPanle:reloadList()
	self.BgTbMsg = {}

	local TbMsg = g_bagMsg:getpetSkillTbMsg()
	for cfgID,Num in pairs(TbMsg)do
		self.BgTbMsg[#self.BgTbMsg+1] = cfgID
	end
	self:sortListTb2()
	local  bagList =  self.rootLayout:getChild("bagList") 
	bagList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local cfgID = self.BgTbMsg[indexD]
			obj:setCustomData(cfgID)
			self:setListItemPet(obj,cfgID)		
		end)
	bagList:setVirtual()--回调
	bagList:setNumItems(#self.BgTbMsg);
	
end 

---==================================================
function petSkillPanle:setPetPanle()
	local  petPanle =  self.rootLayout:getChild("petPanle") 
	local B_Pet = g_WndMgr:getWnd("B_Pet")
	B_Pet:setListItem(petPanle,self.petID,true)
end 

function petSkillPanle:setTextPanle(index)
	local info = g_petMsg:getpetTbMsg(self.petID)
	local count = 0
	for i=1,6 do
		local TextSkill =  self.rootLayout:getChild("TextSkill"..i)
		local title =  TextSkill:getChild("title")
		local skillMsg = info.skillMsg[i] or {}
		local skillID = skillMsg.value1 or 0 
		local skillIDLev = g_bagMsg:getpetSkillTbMsgLev(skillID)  
		if i > info.skillNum then
			TextSkill:setVisible(false)
		elseif skillID <= 0 then
			cc.g_setTextColor(TextSkill,1,true)
			TextSkill:setText("无")
		else
			local cfgSkillMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillID) 
			TextSkill:setVisible(true)
			local colorID = G_tb_TextColor[cfgSkillMsg.lev]
			cc.g_setTextColor(title,colorID,true)
			TextSkill:setText(cfgSkillMsg.name.." Lv"..skillIDLev)
			count = count + 1
		end 
		
		local c3 =  self.rootLayout:getController("c3") --控制器
		local function funcEndCallBack(btn,tag) 
			self:touchIndex(skillID,i)
		end 
		g_SetBtnOne(nil,nil,1, funcEndCallBack,TextSkill)	
		if index and index == i  then
			self:touchIndex(skillID,i)
		end 
	end
	local skillNum =  self.rootLayout:getChild("skillNum")
	skillNum:setVar("value1",tostring(count)) 
	skillNum:setVar("value2",tostring(info.skillNum)) 
	skillNum:flushVars()
end



function petSkillPanle:touchIndex(skillID,index)
	local c3 =  self.rootLayout:getController("c3") --控制器
	c3:setSelectedIndex(index)
	self:setDecPanle(skillID,index)
end 

function petSkillPanle:closeWnd()
	
end 

function petSkillPanle:openWnd(petID)
	
	if petID then
		self.petID = petID
	end 
	self:initWnd()
	self:setTextPanle(1)
	self:reloadList()
	--self:setSkillIndexItemAll()
end 

	
return petSkillPanle
