
g_LoginType = {
    loginTypeNone = 0, 			-- 无效的登录方式
    loginTypeQQAuth = 1,		-- QQ授权登录
    loginTypeQQToken = 2,		-- QQ快速登录
    loginTypeWeiXinAuth = 3,	-- 微信授权登录
    loginTypeWeiXinToken = 4,	-- 微信快速登录
    loginTypeVisitor = 5,		-- 游客登录
    loginTypeGM = 6,			-- GM登录
	loginTypeQQAndroid = 10,		-- AndroidQQ授权登录
}


g_resCfgId = {
    diamond = 11000001,   -- 钻石  
    coin = 11000002,      -- 金币
	energy = 11000003,      -- 体力
	nExp = 11000004,    -- 经验
	jifen = 11000005,
	xueshi = 11000006, ---学识
	shuijin = 11000007, ---水晶
	
	va1 = 101,
	va2 = 102,
	vaLev = 103,
	vazs = 104,
	vaJh = 105,
}

-- 玩家初始化时的掉落id
g_InitResDropId = 20000000
----初始开启英雄 
g_baseOpenHero = 90000002
maxHeroLev = 200
g_MAXMAPID = 110  
g_MAXEquQH = 12 ---最大强化等级
g_MAXSYMAPID = 600  
g_MAXZhuanShenglev = 10 ---最大转生等级  
g_MAXDalitlev = 500 ---最大任务等级  
g_MaxMapLev = {3000,3000,3000,3000,3000,3000,3000,3000}   --最大副本

g_cfgType = {}
g_cfgType.res = 1  --资源
g_cfgType.goods = 2   --物品/道具
g_cfgType.hero =  3  --英雄
g_cfgType.touxiang =  5  --头像皮肤
g_cfgType.enemy =  7  --enemy
g_cfgType.mingwen =  8  -- 铭文
g_cfgType.equ =  9  -- 
g_cfgType.equT =  6  --套装
g_cfgType.petSkill =  10  -- 宠物技能
g_cfgType.pet =  11  -- 宠物
--获取类型
function g_getTypeByCfgID(cfgID)
	
	if cfgID >= 1001 and cfgID <= 4106 then
		return  g_cfgType.touxiang 
	end 

	local nType =math.floor( cfgID/1000000) 
	--cclog(nType,"====g_getTypeByCfgID======",cfgID)
	if nType == 12 or  nType == 13 or nType == 14 or nType == 15 then
		return g_cfgType.goods
	elseif   nType == 11 then
		return g_cfgType.res
	elseif   nType == 81 then
		return g_cfgType.mingwen
	elseif   nType == 180 then	
		return g_cfgType.enemy	
	elseif   nType == 60 then	
		return g_cfgType.equ
	elseif   nType == 61 then	
		return g_cfgType.equT		
	elseif  nType == 90 then 	
		return g_cfgType.hero
	elseif  nType == 86 then 	
		return g_cfgType.pet
	elseif  nType == 87 then 	
		return g_cfgType.petSkill		
	end
end


--充值
g_PayType = {
	["ShopCity_6"] = "bossZS6",
	--["ShopCity_12"] = "ShopCity_12",
	["ShopCity_30"] = "bossZS30",
	--["ShopCity_45"] = "ShopCity_45",
	["ShopCity_68"] = "bossZS68",
	--["ShopCity_98"] = "ShopCity_98",
	["ShopCity_128"] = "bossZS128",
	--["ShopCity_288"] = "ShopCity_288",
	["ShopCity_328"] = "bossZS328",
	["ShopCity_648"] = "bossZS648",
}


g_TaskType = {["Daily"] = 1, ["Achivement"] = 2, ["Level"] = 3, ["FirstReward"] = 4}


local TaskType = {}
TaskType.Daily_Login = 1
TaskType.Daily_CostTili = 2  --已统计
TaskType.Daily_zsAdsNum = 3  --每日广告
TaskType.Daily_tiliNum = 4  --每日体力
TaskType.Daily_reoladShopNum = 5  --商店刷新次数
TaskType.Daily_buyTl = 6  --购买体力次数
TaskType.Daily_reloadShopNum = 7  --刷新商店次数
TaskType.Daily_shopFreeNum = 8  -- 商店免费的次数

---------每日任务
for key=1, 23 do  ---  7到29
	TaskType["Daily_renwu"..key] = key+6
end 
TaskType.Daily_renwu20D = 50  --特殊任务20
TaskType.Daily_renwu21D = 51  --特殊任务21
TaskType.Daily_renwu22D = 52  --特殊任务22
TaskType.Daily_renwu23D = 53  --特殊任务23
TaskType.Daily_rwFinishNum = 54  -- 
TaskType.Daily_getFinishNum = 55  --  每日任务奖励领取

TaskType.Daily_adsBaozhangNum = 63 --  每日宝藏广告次数
TaskType.Daily_adsXingLianNum = 64 --  每日星链广告次数
TaskType.Daily_dianzanRankNums = 65 --  每日点赞次数
TaskType.Daily_tlADs = 66 --  每日体力广告
TaskType.Daily_ReloadNum = 67  --  
TaskType.Daily_qianDaoBuNum = 68  --   签到补签次数

TaskType.Daily_baozangDoubleNum = 69  --   宝藏双倍次数
TaskType.Daily_DaoyuGetNum = 70  -- 岛屿抢夺次数 
TaskType.Daily_DaoyuGetAdsNum = 71  -- 广告恢复岛屿抢夺次数 
TaskType.Daily_lilianAdsNum = 72  -- 广告历练次数 
--===============
TaskType.Daily_mathlev = 500  --多个的时候
TaskType.Daily_killBoss = 501  --击杀boss

TaskType.Daily_CzhiReward = 504--  每日免费钻石广告和钻石宠物领取
TaskType.Daily_DaoyuReward = 505--  岛屿奖励


--TaskType.Daily_junxuGet2 = 4200  --军需是否领取
--成就任务
TaskType.Achivement_bat = 1			--累计战斗胜利1
TaskType.Achivement_LoginDate = 2   --累计登陆天数
TaskType.Achivement_adsNums = 3   --累计广告
TaskType.Achivement_fenxNum = 4   --分享
TaskType.Achivement_QQNum = 5   --QQ群
TaskType.Achivement_skillBoss = 6   --累计击杀副本boss
TaskType.Achivement_7DayLogin = 7  --七天登录
TaskType.Achivement_7DayLoginReward = 8  --七天登录奖励
TaskType.Achivement_adsRewar = 9  --广告领取
TaskType.Achivement_playerLev = 10  --玩家等级
TaskType.Achivement_playerExp = 11  --玩家当前经验
TaskType.Achivement_batReward = 12  --玩家过关奖励
TaskType.Achivement_logType = 13 --玩家登陆类型 安卓 或者ios
TaskType.Achivement_qiandao = 14  --签到

--TaskType.Lilian = 100   --历练  Lilian*100+lev 1000
TaskType.Achivement_mathlev = 1000  --多个的时候

TaskType.Achivement_VIPBuy = 1100 ---- vip购买

TaskType.Achivement_jijinGet  = 1102 ---- 基金领取
TaskType.Achivement_levRewad  = 1103 ---- 等级礼包领取
TaskType.Achivement_levZSRewad  = 1104 ---- 等级礼包zs领取

TaskType.Achivement_ADSTime = 1105 ---- 免费广告时间
TaskType.Achivement_newPlayer = 1106 ---- 新手邮件发送
TaskType.Achivement_VipGet = 1107 ---- vip领取
TaskType.Achivement_AdsBuy = 1108 ----去广告充值

g_TaskStatisticsType = TaskType

--枚举
otherDBMsgID = {}
otherDBMsgID.playerStatus = 1 ---玩家状态  0 正常  -1 封号 ，99 异常，监督
otherDBMsgID.createTime = 2 --创建时间
otherDBMsgID.onlineTime = 3 --在线时间
otherDBMsgID.lastTlTime = 4 --上一次体力获得时间
otherDBMsgID.adsZSTime = 5  --钻石领取时间
otherDBMsgID.qqQunZs = 6 -- 加qq群钻石
otherDBMsgID.goodZs = 7 -- 加钻石 点赞
otherDBMsgID.fxZs = 8 -- 加分享钻石


otherDBMsgID.mapType = 14 --副本类型  困难/ 简单
otherDBMsgID.batReward = 15 --副本类型 奖励

otherDBMsgID.shopReload = 17 -- 刷新时间
otherDBMsgID.curMap = 18 -- 当前副本
otherDBMsgID.newPlayer = 19 -- 新玩家
otherDBMsgID.reloadTIl = 20 -- 每日刷新体力

otherDBMsgID.playerCost = 24 --玩家悬赏
otherDBMsgID.headID = 25 --头像iD
otherDBMsgID.headKuangID = 26 --头像KuangiD
otherDBMsgID.maxRank = 27 --最高排名
otherDBMsgID.loginTime = 28  -- 
otherDBMsgID.BuyJijinTime = 29  --  购买时间
otherDBMsgID.BuyLevReward = 30  --  等级礼包

otherDBMsgID.bagBuyBum = 32  --  装备背包购买次数

otherDBMsgID.date7GatTime = 34 --七天登录第七天的领取时间
otherDBMsgID.loginDate = 35  -- 登陆天数
otherDBMsgID.buyMaxOffTimeNum= 36  -- 挂机离线上限次数
otherDBMsgID.leaveGameTime= 37  -- 离线时间

otherDBMsgID.yuekaNum= 42  --月卡可领取次数
otherDBMsgID.yuekaGetTimes= 43  --月卡领取时间
otherDBMsgID.dataCzTime= 44  --连续购买时间
otherDBMsgID.dataCzNum= 45  --连续购买天数
otherDBMsgID.newMainRW= 46  --新主线任务
otherDBMsgID.maxMapIDTime = 47 --通关最远副本时间
otherDBMsgID.batMaxMapID = 48 --已打过副本

otherDBMsgID.curTianfuID = 51  --当前升级天赋ID
otherDBMsgID.curTianfuIDStarTime = 52 --当前升级天赋时间
otherDBMsgID.curRoleSkilGWlLev = 53 --当前技能领悟等级
otherDBMsgID.lastGetXSTime = 54 --上次领取学识时间

otherDBMsgID.yuekaTXZNum= 59  --月卡可领取次数
otherDBMsgID.yuekaTXZGetTimes= 60  --月卡领取时间


----==============================================
otherDBMsgID.petMaxBuy = 61  --宠物栏购买
otherDBMsgID.petSkillSLD = 62  --熟练度
otherDBMsgID.killNumindex1 = 63  --战斗每分钟击杀个数 计数
otherDBMsgID.killNumindex2 = 64  --战斗每分钟击杀个数 计数
otherDBMsgID.killNumindex3 = 65  --战斗每分钟击杀个数 计数
otherDBMsgID.BatDropTime = 66  --战斗上一次掉落装备时间
otherDBMsgID.BatDropTime2 = 67  --战斗上一次掉落装备时间2
otherDBMsgID.daliyExp = 68  -- 每日任务经验
otherDBMsgID.chengjiuLev = 69  -- 成就第几章
otherDBMsgID.addCoinXY = 70  -- 幸运+金币掉落
otherDBMsgID.addCLXY = 71 -- 幸运 + 材料掉落
otherDBMsgID.xinshouLib = 72 -- 新手礼包
otherDBMsgID.GuideID= 73 --
otherDBMsgID.tongshuai = 74  -- 统帅

otherDBMsgID.daoyuStarTime = 75  -- 岛屿上次时间
otherDBMsgID.daoyuEndTime = 76  -- 岛屿上次结束时间
otherDBMsgID.daoyukey = 77  -- 岛屿上次
otherDBMsgID.daoyuRation = 78  -- 岛屿上次
otherDBMsgID.tianfReloadNum = 79  -- 天赋重置
otherDBMsgID.isYifu = 80  -- 岛主还是依附
otherDBMsgID.isYifuNum = 81  -- 岛主还是依附数量
otherDBMsgID.baokuKillValue1 = 82 --宝库击杀
---1000+ 仅服务器需要
--	[2001] = 1 --装备唯一ID 序号
otherDBMsgID.dhm1 = 3000 --兑换码  3000 - 3100
otherDBMsgID.dhm2 = 3002
otherDBMsgID.dhm1111 = 3003
otherDBMsgID.dhm1112 = 3004
otherDBMsgID.dhm1113 = 3005
otherDBMsgID.dhm1114 = 3006
otherDBMsgID.dhm1115 = 3007
otherDBMsgID.dhm1116 = 3008
otherDBMsgID.dhm1117 = 3009

----==================================================
otherStrDBMsgID = {}
otherStrDBMsgID.baokuValue1 = 1000 --宝库保存
otherStrDBMsgID.baokuValue2 = 1001 --宝库保存
otherStrDBMsgID.baokuValue3 = 1002 --宝库保存

--====================================
bgMusicID = 26
batMusicID = 27

g_tbInteger = {}
g_tbInteger.changeEquFlash = 1

g_tbAdsReward = {}
g_tbAdsReward.zsAds = 1
g_tbAdsReward.LoginNum = 2
g_tbAdsReward.LoginNumBU = 3
g_tbAdsReward.chongzhiAds = 4
g_tbAdsReward.shopFree = 5
g_tbAdsReward.bzDouble = 6
g_tbAdsReward.lilianDel = 7
g_tbAdsReward.QianDuoNum = 8
g_tbAdsReward.lilianAdsDel = 9
g_gameMsgID = {}
g_gameMsgID.dataTime = 1

---=======tb_playerDBName[102]================
tbIntegerKEy = {}
tbIntegerKEy.BatPetMsg = 1   ----出战的宠物ID
tbIntegerKEy.fubenMaxLev = 2   ----fuben 数据  副本最远进度
tbIntegerKEy.fubenCurLev = 3   ----fuben 数据  副本进度
tbIntegerKEy.petSkillIndexLev = 4   ----宠物技能等级

tbIntegerKEy.batGetResTme = 5  --战斗领取时间 
tbIntegerKEy.baokulev = 6  --战斗宝库等级
tbIntegerKEy.killNumValue1 = 7  --战斗每分钟击杀个数
tbIntegerKEy.killNumValue2 = 8  --战斗每分钟击杀个数
tbIntegerKEy.killNumValue3 = 9  --战斗每分钟击杀个数
tbIntegerKEy.baokuValue = 10  --宝库库存
tbIntegerKEy.equFj = 11  --装备自动分解
tbIntegerKEy.cwFj = 12  --宠物自动分解
---=======================
tbGameConst = {}
tbGameConst.addJinjie = 10 -- 每次转生增加进阶上限 

tbGameConst.chongzhuZs = 500 ---重铸刷新钻石
tbGameConst.chongzhu = 500 ---重铸材料
tbGameConst.addMaxLev = 30 ---每次进化增加等级上限 
tbGameConst.addzizhi = 0.3 ---每次进化增加资质
tbGameConst.baseMaxJinjie = 20 ---初始进化上限 

tbGameConst.initTianfuNum = 5 ---初始天赋点
tbGameConst.baseTianfuNum = 50 ---基础天赋点  
tbGameConst.addTianfuNum = 3 ---每次转生提高天赋点
tbGameConst.maxTianfuIndex = 10 ---天赋最多10层  目前
tbGameConst.tfReloadZs = 1000 ---重置天赋需要金币
tbGameConst.skillMaxLev = 200 ---每次转生提高技能上限
tbGameConst.dalitMaxLev = 50 ---每次转生提高任务等级上限

tbGameConst.baseSkillMaxLev = 2000 ---基础技能上限
tbGameConst.SkillMaxNum = 6 --- 技能个数上限
tbGameConst.SkillOpenLev = {0,1,2,3,5,7,9,12,15} --- 技能开启等级
tbGameConst.SkillLevCostXS = {1,2,3,4,5,7,9,11,13} --- 技能消耗学识系数
tbGameConst.MaxXSTimeOff = 3900 --- 最大学识累计离线时间
tbGameConst.ganwuSpeed = 3 --- 感悟初始速度
tbGameConst.needNumTL = 500 --- 提炼需要炼金石基础
tbGameConst.needNumTLRation = 150 --- 提炼需要炼金石系数 
tbGameConst.maxPetStarLev = 36 --- 宠物满星
tbGameConst.petSkillIndexlev = 500 --- 宠物技能级
tbGameConst.petSkillType = 20 --- 宠物技能种类
tbGameConst.mapOpenNeed = {0,3,6} --- 50人本 100人本开启条件
tbGameConst.mapOpenNeed = {0,3,6} --- 计算宝库最大量基本
tbGameConst.maxBaokuLev = 450 --- 计算宝库最大
tbGameConst.maxBatGround = 50 --- 每分钟出现波数上限
tbGameConst.batEnemyNum = {20,50,100} --- 副本每波出几个怪
tbGameConst.reloadShop = 200 --- 刷新商店钻石
tbGameConst.reloadShopNum = 10 --- 刷新商店 
tbGameConst.ShopFreeNum = 10 --- 商店每天最多免费
tbGameConst.BagBuyNum = 40 --- 背包购买
tbGameConst.BagBuyaddNum = 5 --- 每次增加
tbGameConst.BagBuyZs = 100 --- 消耗钻石
tbGameConst.BagBaseNum = 30

tbGameConst.basePetNum = 10 ---基础宠物栏
tbGameConst.petBagBuyNum = 30 --- 背包购买
tbGameConst.petBagBuyaddNum = 3 --- 每次增加
tbGameConst.petBagBuyZs = 100 --- 消耗钻石
tbGameConst.maxOffTime = 3600*3 ---最大离线
tbGameConst.bzShuangNum = 2 ---最大双倍次数
tbGameConst.maxVip = 72 ---最大Vip

tbGameConst.daoyumaxNumTT = 1000 ---岛屿最大跳过卷20
tbGameConst.daoyumaxNumDj = 20 ---岛屿最大代金卷20
tbGameConst.maxDQNum = 10 ---岛屿抢夺次数10

tbGameConst.jichengRation = {0.6,0.65,0.7,0.75,0.8,0.85,0.9} --- 继承系数
tbGameConst.jichengCL = {
 [1] = {12001001,1},
 [2] = {12001001,2},
 [3] = {12001001,3},
 [4] = {12001001,4},
 [5] = {12001002,1},
 [6] = {12001002,2},
 [7] = {12001002,3},
 [8] = {12001002,4},
 [9] = {12001003,1},
 [10] = {12001003,2},
 [11] = {12001003,3},
 [12] = {12001003,4},
 [13] = {12001004,1},
 [14] = {12001004,2},
 [15] = {12001004,3},
 [16] = {12001004,4},
 [17] = {12001005,1},
 [18] = {12001005,2},
 [19] = {12001005,3},
 [20] = {12001005,4},
} --- 继承材料

tbRoleBaseID = {}
tbRoleBaseID.BOSSID = 100
tbRoleBaseID.BOSSIDBianyi = 101
tbRoleBaseID.NewEquID = 10
tbRoleBaseID.NewPetID = 11
