return [[
.req_login {
	type 0 : integer #0表示微信 1表示游客 2 android
	devicetoken 1 : string  #设备id
	openid 2 : string
	accesstoken 3 : string #其他数据
	sex 4: integer
	nickname 5: string
	svID 6: integer
}

.res_login {
	ok 0 : boolean
	type 1 : integer
	userid 2 : integer
	desc 3: string
	sex 4: integer
	nickname 5: string
	headimgurl 6: string
	newplayer 7: boolean
	bindwechat 8 : boolean
	gm 9 : boolean
	devicetoken 10 : string
	create_time 11 : string
	svID 12: integer
}

#-------服务器出错
.response_error{
		status 0 : integer
		szerror 1 : string
		errorTiShi 2 : integer
		errorTiShiNumber 3 : string
	}

#-------获取服务器时间  
.request_time {
		nType 0 : integer
		nValue 1: integer
		nValue2 2: integer
	}
.response_time{
		status 0 : integer
		szerror 1 : string
		nValue 2: integer
		playerStatus 3: integer
		playerCreatorTime 4: string
		playerLogInTime 5: string
		gVersion 6: integer
		nType 7 : integer
	}



#绑定微信
.request_bindWeChat {
	type 0 : integer #1表示ios微信 2 android
	openid 1 : string
	devicetoken 2 : string  #设备id
	accesstoken 3 : string
}


.response_bindWeChat {
	ok 0 : boolean
	desc 1 : string
	sex 2: integer
	nickname 3: string
	headimgurl 4: string
}

.nty_kickoff {
	errortype 0 : integer #1表示在其他地方登陆
	desc 1 : string #具体原因
}



##------登入数据发送
.request_getInitMsg {
		nType 0 : integer
		userID 1 : integer
	}
.response_getInitMsg {
		status 0 : integer
		szerror 1 : string
		nTime 2 : integer
		tbResValue 3 : *resinfo(id)
		thOtherMsg 4 : *intTable(id)
		tbInteger 5 : *tbInteger(id) 
		thOtherStrMsg 6 : *intTable_Str(id)
		userID 7 : integer
	}
	
	
.dataLogin{	
	devicetoken 0 : string
	userid 1 : integer
	loginstatus 2 : integer
	login_time 3 : integer
	create_time 4 : integer
	sex 5 : integer
	nickname 6 : string
	headimgurl 7 : string
	createTimeStr 8 : string
	loginTimeStr 9 : string
	mainLev 10 : integer
	gameTime 11 : integer
	jifen 12 : integer
}
	

##------掉落资源
.response_dropResMsg {
		status 0 : integer
		szerror 1 : string
		tbResValue 3 : *resinfo(id)
		noTishi 4 : integer
	}	


#-----支付	
.response_getApiCallBack {
	status 0 : integer	
	szerror 1 : string
	productID 3: string	
}
	
##------命名
.request_setName {
		nType 0 : integer
		name 1 : string
	}
.response_setName {
		status 0 : integer
		szerror 1 : string
		nType 2 : integer
		name 3 : string
	}		
	

##--视频广告 
.request_videoAD {
	nType 0 : integer
	status 1 : integer
	resultType 2 : integer
	value 3 : integer
}
.response_videoAD {
	status 0 : integer
	szerror 1 : string
	value 2: integer   ##时间
	resultType 3 : integer
}


]]

