return [[
.NtyPlayerInfo {
	id 0 : integer 
	name 1 : string  
	playerbaseinfo 2 : binary
}
##----资源
.request_getResMsg {
		nType 0 : integer
		id 1 : integer
	}
.response_getResMsg {
		status 0 : integer
		szerror 1 : string
		nType 2 : integer
		tbResInfo 3 : *resinfo(id)
	}	

##--任务 id = id*100 + Type
.commonTaskInfo {
	id 0: integer
	reward 1: boolean
}


##任务统计
.taskStatisticsInfo {
	id 0: integer
	num 1: integer
	itime 2: integer
	value 3: *integer
}

.taskStatisticsBlob {
    taskStatisticsInfo 0: *taskStatisticsInfo(id)
}

.taskBlob {
    dailyTaskRefreshTime 0: integer
    dailyTaskInfo 1: *commonTaskInfo(id)
    achivementTaskInfo 2: *commonTaskInfo(id)
    levelTaskInfo 3: *commonTaskInfo(id)	
}


##请求任务列表
.request_taskInfo {
	itype 0: integer
	renwuID 1: integer
	taskid 2: integer
}
.response_taskInfo {
	itype 0: integer
	taskBlob 1: taskBlob
	taskStatisticsInfo 2: taskStatisticsBlob
	str  3: string
}

.request_taskReward {
	taskid 0: integer
	itype 1: integer
}
.response_taskReward {
	status 0 : integer
	szerror 1 : string
	taskid 2: integer
	itype 3: integer
}

.countData {
	id 0 : string
	maxMap 1 : string
	batMapNum 2 : string
	skillBuy 3 : string
	startTime 4 : string
	czhiValue 5 : string
	batMapLostNum 6 : string
	batMapWinNum 7 : string
	bzNums 8 : string
	zbQHNums 9 : string
	zbHCNums 10 : string
}
##--发送信息 
.request_msgString {
	nType 0 : integer
	dec 1 : string
	value1 2 : integer
	value2 3 : integer
	sting1 4 : *string
	sting2 5 : string
}
.response_msgString {
	status 0 : integer
	szerror 1 : string
	otherInfo 2: otherInfo
	value 3 : integer
	countData  4 : countData
	tbInteger 5 : tbInteger
	otherStrInfo 6: intTable_Str
}


.request_cmdMsg {
	cmd 0:  string
	value1 1:  integer
	value2 2:  integer
	value3 3:  *integer
	sting1 4:  *string
}
.response_cmdMsg {
	status 0 : integer
	cmd 1:  string
	value1 2:  integer
	value2 3:  string
	value3 4:  *integer
	dltbInfo 5 : *dltbInfo
	cztbInfo 6 : *cztbInfo
}	



##--邮件 nType 1 领取/以读  0 ：登录界面获取邮件信息  -1 登陆获取新邮件数量

#邮件  status  0  可领取/未读   1 已领取/已读  
.mailInfo {
    id 0: integer
	cfgID 1:integer
	nTime 2:integer	
	goodsID 3:integer
	goodsMsg 4:*integer
	status 5:integer	
	strDec 6:*string	
	
}
.mailBlob {
    mailInfo 0: *mailInfo(id)
}

#全服邮件领取记录
.mailAllBlob {
    mailInfo 0: *intTable(id)
}
#全服邮件---系统
.sv_mailAllBlob {
    mailInfo 0: *mailInfo(id)
}


##--邮件 nType 1 领取/以读  0 ：登录界面获取邮件信息  -1 登陆获取新邮件数量
.request_mail {
	nType 0 : integer
	mailID 1: integer
}
.response_mial{
	status 0 : integer
	szerror 1 : string
	tbMailInfo 2: *mailInfo(id)
	count  3 : integer
}

.dltbInfo {
	id 0 : integer
	ntime 1 : string #注册时间
	ntime2 2 : string #登陆时间
	jifen 3 : integer
	nickName 4 : string
	maxMapID 5: integer
}
.cztbInfo {
	id 0 : integer
	ntime 1 : string
	czID 2 : integer
	jifen 3 : integer
	nickName 4 : string
	maxMapID 5: integer
}


##--账号表
.PlayerAllSvIDInfo {
    id 0: integer
	svID 1:integer
	openID 2:string
	useID 3:integer
}
.PlayerAllSvIDBlob {
    PlayerAllSvIDInfo 0: *PlayerAllSvIDInfo(id)
}

##----Role
.RoleBlob {
	RoleInfo 2 : *intTable_Str(id)
}
##----Role
.RoleBaseBlob {
	tbSkillID 1 : *intTable2(id)
	BaseInfo 2 : *intTable(id) 
	tbZbID 3 : *integer
}
.request_getRoleMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
	}
.response_getRoleMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		RoleAttInfo 3 : *intTable_Str(id)	
		BaseInfo 4 : *intTable(id)
		tbSkillID 5 : *intTable2(id) 
		tbZbID 6 : *integer
	}	

##----equ
.equInfo {
	id 0 : integer
	cfgID 1 : integer
	QHAttID 2 : *integer
	QHAttLev 3 : *integer
	QHLev 4 : integer
	FMID 5 : integer
	runeMsg 6 : *integer
	runeNum 7 : integer
	isClock 8 : integer
	inRole 9 : integer
	zbLev 10 : integer
	yanse 11 : integer
	mainAttLev 12 : *integer
	goodsUse 13 : integer
	delTime 14: integer
}
.equInfoBlob {
	equInfo 2 : *equInfo(id)
}
.request_getEquMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
		tbClientMsg 3 : *integer
	}
.response_getEquMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		tbEquInfo 3 : *equInfo(id)
		value 4 : integer
		tbEquMsg 5 : *integer
	}



.request_getBagMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
	}
.response_getBagMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		tbGoodsInfo 3 : *goodsinfo(id)
		tbRuneInfo 4 : *goodsinfo(id)
		euqInfos 5 :  *otherInfo(id)
		tbPetSkillInfo 6 : *goodsinfo(id)
	}	


.response_getGoodsMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		tbGoodsInfo 3 : *goodsinfo(id)
		tbRuneInfo 4 : *goodsinfo(id)
		euqInfos 5 :  *otherInfo(id)
		noTis 6: integer
		tbPetSkillInfo 7 :  *goodsinfo(id)
	}	


#新手引导数据 
#是否已经掉落过物品 dropKey =*iD  --新手引导ID 已经掉落过
.newGuideInfo {
    id 0: integer
	status 1:integer	
	dropKey 2 :*integer	 
}
.newGuideBlob {
    newGuideInfo 0: *newGuideInfo(id)
}
	
##--新手引导
.request_newGuide {
	id 0 : integer
	nType 1 : integer
	value 2 : integer
}
.response_newGuide {
	status 0 : integer
	szerror 1 : string
	newGuideInfo 2: *newGuideInfo(id)
}
	
	
##----pet
.petInfo {
	id 0 : integer
	cfgID 1 : integer
	attValue 2 : *integer
	yanse 3 : integer
	Level 4 : integer
	nExp 5 : integer
	isClock 6 : integer
	skillMsg 7 :  *intTable3(id) 
	batIndex 8 : integer
	zhizi 9 :integer
	skillNum 10 :integer
	zcdValue 11 :integer 
	delTime 12: integer
	starLev  13: integer
}
.petInfoBlob {
	petInfo 2 : *petInfo(id)
}
.request_getPetMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
		tbClientMsg 3 : *integer
	}
.response_getPetMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		tbPetInfo 3 : *petInfo(id)
		tbDelMsg  4 : *integer
		value 5 : integer
		tujianInfo 6 : tujianInfo
		value2 7 : integer
	}
	
##----tianfu
.tianfuInfo {
	id 0 : integer
	cfgID 1 : integer
	lev 2 : integer
	needID 3 : integer 
}
.tianfuInfoBlob {
	tianfuInfo 1 : *tianfuInfo(id)
}
.request_getTianfuMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
	}
.response_getTianfuMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		tianfuInfo 3 : *tianfuInfo(id)
		value 4 : integer
	}
	
##----roleSkill
.roleSkillInfo {
	id 0 : integer
	lev 1 : integer
}	
.roleSkillBlob {
	roleSkillInfo 1 : *roleSkillInfo(id)
}
.request_getRoleSkillMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
	}
.response_getRoleSkillMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		roleSkillInfo 3 : *roleSkillInfo(id)
		value 4 : integer
	}
	
##----tujian
.tujianInfo {
	id 0 : integer
	lev 1 : integer
	yanse 2 : integer
	nExp 3 : integer
}	
.tujianInfoBlob {
	tujianInfo 1 : *tujianInfo(id)
}
	
.request_geTujianMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
	}
.response_geTujianMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		tujianInfo 3 : *tujianInfo(id)
		value 4 : integer
	}	
#战斗
.request_geBatMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
		valueStr 3 : string
		valueStr4 4 : string
	}
.response_geBatMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		value 3 : integer
		strValue 4 : string
	}
	
	
##----每日任务
.daliyInfo {
	id 0 : integer
	cfgID 1 : integer
	maxCount 2 : integer
	reward 3 : integer
	count 4 : integer
	status 5 : integer
}	
.daliyInfoBlob {
	daliyInfo 1 : *daliyInfo(id)
}
	
.request_geDaliyMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
	}
.response_geDaliyMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		daliyInfo 3 : *daliyInfo(id)
		value 4 : integer
	}	

##----成就
.chengjiuInfo {
	id 0 : integer
	cfgID 1 : integer
	maxCount 2 : integer
	reward 3 : integer
	count 4 : integer
	status 5 : integer
}	
.chengjiuBlob {
	chengjiuInfo 1 : *chengjiuInfo(id)
}
	
.request_getChengjiuMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
	}
.response_getChengjiuMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		chengjiuInfo 3 : *chengjiuInfo(id)
		value 4 : integer
	}
	
##----商店
.shopInfo {
	id 0 : integer
	cfgID 1 : integer
	CostType 2 : integer
	sellStatus 3 : integer
	
}	
.shopBlob {
	shopInfo 1 : *shopInfo(id)
}	
	
.request_getShopMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
	}
.response_getShopMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		shopInfo 3 : *shopInfo(id)
		value 4 : integer
	}

##----签到
.qdaoInfo {
	id 0 : integer
	status 1 : integer
	
}	
.qdaoBlob {
	qdaoInfo 1 : *qdaoInfo(id)
}	
	
.request_getqianDaoMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
	}
.response_getqianDaoMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		qdaoInfo 3 : *qdaoInfo(id)
		value 4 : integer
	}	

##----宝藏
.baozInfo {
	id 0 : integer
	nameCfgID 1 : integer
	status 2 : integer
	startTime 3 : integer
	goodsID 4 : integer 
	number 5 : integer 
	yanse 6 : integer 
}	
.baozInfoBlob {
	baozInfo 1 : *baozInfo(id)
}	
	
##----重铸
.congzhuInfo {
	id 0 : integer
	cfgID 1 : integer
	bianyi 2 : integer
}	
.congzhuInfoBlob {
	congzhuInfo 1 : *congzhuInfo(id)
}	
	
.request_getBaozangMsg {
		nType 0 : integer
		id 1 : integer
		value 2 : integer
	}
.response_getBaozangMsg {
		status 0 : integer
		szerror 1 : string
		nType 2: integer
		baozInfo 3 : *baozInfo(id)
		value 4 : integer
		congzhuInfo 5 : *congzhuInfo(id)
	}
	

##请求Rank列表

.tbUserMsg {
	id 0: integer
	maxMap 1: *integer
	roleLev 2: integer
	nickName 3: string
	bossID 4: integer
	jinhuaLev 5:integer
	zuanshilev	6:integer
	maxMapIDTime 7: integer
	
	tbEquInfo 8 : *equInfo(id)
	tbPetInfo 9 : *petInfo(id)
	Bianyi 10:integer
	rank 11:integer
}

.request_rankInfo {
	id 0: integer
	nType 1: integer
	value1 2: integer
	value2 3: integer
	value3 4: integer
}

.response_rankInfo {
	status 0 : integer
	szerror 1 : string
	nType 2 : integer
	tbRank 3: *intTable(id)
	tbUserMsg 4:  *tbUserMsg(id)
	myRank  5: integer
	tbEquInfo  6: *equInfo(id)
	tbPetInfo 7 : *petInfo(id)
	userID 8: integer
	otherValue 9: *intTable(id)
	
}
	
##----
.daoyuInfo {
	id 0 :integer
	cfgID 1 : integer
	userID 2 : integer
	nTime 3 : integer
	count 4 : integer
	tbMsg 5 : *intTable(id)
	dyMaxLev 6 : integer
	resStatus 7 : integer
	userNickName 8 : string
	userLev 9 : integer
	status 10 : integer
	resMaxTimeRation 11 : integer
	countResTime 12 : integer
	tbUserMsg 13:  tbUserMsg
	fwqID 14: integer
	tbYifu 15: *intTable(id)
}	
.daoyuInfoBlob {
	daoyuInfo 0 : *daoyuInfo(id)
}	

##----记录
.daoyuOldInfo {
	id 0 : integer
	nType 1: integer
	tbUserMsg 2:  *tbUserMsg
	nTime 3 : integer
	result 4 : integer
	lostres 5 : integer
}
.daoyuOldInfoBlob {
	daoyuOldInfo 1 : *daoyuOldInfo(id)
}

.request_daoyuInfo {
	id 0: integer
	nType 1: integer
	value1 2: integer
	value2 3: integer
	value3 4: integer
}

.response_daoyuInfo {
	status 0 : integer
	szerror 1 : string
	nType 2 : integer
	daoyuInfo 3 : *daoyuInfo(id)
	value 4 : integer 
	value1 5 : integer 
	
	daoyuOldInfo 6 : *daoyuOldInfo(id)

}	
	

##----记录
.lyuInfo {
	id 0 : integer
	cfgID 1: integer
	lev 2: integer
	isJihuo 3 : integer
	yanse 4 : integer
	nExp 5: integer
}

.lyuInfoBlob {
	lyuInfo 1 : *lyuInfo(id)
}

.request_lyuInfo {
	id 0: integer
	nType 1: integer
	value1 2: integer

}

.response_lyuInfo {
	status 0 : integer
	szerror 1 : string
	nType 2 : integer
	lyuInfo 3 : *lyuInfo(id)

}		
]]

